
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse         base_yyparse
#define yylex           base_yylex
#define yyerror         base_yyerror
#define yylval          base_yylval
#define yychar          base_yychar
#define yydebug         base_yydebug
#define yynerrs         base_yynerrs
#define yylloc          base_yylloc

/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 1 "gram.y"


/*#define YYDEBUG 1*/
/*-------------------------------------------------------------------------
 *
 * gram.y
 *	  POSTGRESQL BISON rules/actions
 *
 * Portions Copyright (c) 1996-2010, PostgreSQL Global Development Group
 * Portions Copyright (c) 1994, Regents of the University of California
 *
 *
 * IDENTIFICATION
 *	  $PostgreSQL: pgsql/src/backend/parser/gram.y,v 2.713.2.1 2010/08/18 18:35:30 tgl Exp $
 *
 * HISTORY
 *	  AUTHOR			DATE			MAJOR EVENT
 *	  Andrew Yu			Sept, 1994		POSTQUEL to SQL conversion
 *	  Andrew Yu			Oct, 1994		lispy code conversion
 *
 * NOTES
 *	  CAPITALS are used to represent terminal symbols.
 *	  non-capitals are used to represent non-terminals.
 *	  SQL92-specific syntax is separated from plain SQL/Postgres syntax
 *	  to help isolate the non-extensible portions of the parser.
 *
 *	  In general, nothing in this file should initiate database accesses
 *	  nor depend on changeable state (such as SET variables).  If you do
 *	  database accesses, your code will fail when we have aborted the
 *	  current transaction and are just parsing commands to find the next
 *	  ROLLBACK or COMMIT.  If you make use of SET variables, then you
 *	  will do the wrong thing in multi-query strings like this:
 *			SET SQL_inheritance TO off; SELECT * FROM foo;
 *	  because the entire string is parsed by gram.y before the SET gets
 *	  executed.  Anything that depends on the database or changeable state
 *	  should be handled during parse analysis so that it happens at the
 *	  right time not the wrong time.  The handling of SQL_inheritance is
 *	  a good example.
 *
 * WARNINGS
 *	  If you use a list, make sure the datum is a node so that the printing
 *	  routines work.
 *
 *	  Sometimes we assign constants to makeStrings. Make sure we don't free
 *	  those.
 *
 *-------------------------------------------------------------------------
 */
#include "postgres.h"

#include <ctype.h>
#include <limits.h>

#include "catalog/index.h"
#include "catalog/namespace.h"
#include "catalog/pg_trigger.h"
#include "commands/defrem.h"
#include "nodes/makefuncs.h"
#include "nodes/nodeFuncs.h"
#include "parser/gramparse.h"
#include "parser/parser.h"
#include "storage/lmgr.h"
#include "utils/date.h"
#include "utils/datetime.h"
#include "utils/numeric.h"
#include "utils/xml.h"


/* Location tracking support --- simpler than bison's default */
#define YYLLOC_DEFAULT(Current, Rhs, N) \
	do { \
		if (N) \
			(Current) = (Rhs)[1]; \
		else \
			(Current) = (Rhs)[0]; \
	} while (0)

/*
 * Bison doesn't allocate anything that needs to live across parser calls,
 * so we can easily have it use palloc instead of malloc.  This prevents
 * memory leaks if we error out during parsing.  Note this only works with
 * bison >= 2.0.  However, in bison 1.875 the default is to use alloca()
 * if possible, so there's not really much problem anyhow, at least if
 * you're building with gcc.
 */
#define YYMALLOC palloc
#define YYFREE   pfree

/* Private struct for the result of privilege_target production */
typedef struct PrivTarget
{
	GrantTargetType targtype;
	GrantObjectType objtype;
	List	   *objs;
} PrivTarget;


#define parser_yyerror(msg)  scanner_yyerror(msg, yyscanner)
#define parser_errposition(pos)  scanner_errposition(pos, yyscanner)

static void base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner,
						 const char *msg);
static Node *makeColumnRef(char *colname, List *indirection,
						   int location, core_yyscan_t yyscanner);
static Node *makeTypeCast(Node *arg, TypeName *typename, int location);
static Node *makeStringConst(char *str, int location);
static Node *makeStringConstCast(char *str, int location, TypeName *typename);
static Node *makeIntConst(int val, int location);
static Node *makeFloatConst(char *str, int location);
static Node *makeBitStringConst(char *str, int location);
static Node *makeNullAConst(int location);
static Node *makeAConst(Value *v, int location);
static Node *makeBoolAConst(bool state, int location);
static FuncCall *makeOverlaps(List *largs, List *rargs,
							  int location, core_yyscan_t yyscanner);
static void check_qualified_name(List *names, core_yyscan_t yyscanner);
static List *check_func_name(List *names, core_yyscan_t yyscanner);
static List *check_indirection(List *indirection, core_yyscan_t yyscanner);
static List *extractArgTypes(List *parameters);
static SelectStmt *findLeftmostSelect(SelectStmt *node);
static void insertSelectOptions(SelectStmt *stmt,
								List *sortClause, List *lockingClause,
								Node *limitOffset, Node *limitCount,
								WithClause *withClause,
								core_yyscan_t yyscanner);
static Node *makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg);
static Node *doNegate(Node *n, int location);
static void doNegateFloat(Value *v);
static Node *makeAArrayExpr(List *elements, int location);
static Node *makeXmlExpr(XmlExprOp op, char *name, List *named_args,
						 List *args, int location);
static List *mergeTableFuncParameters(List *func_args, List *columns);
static TypeName *TableFuncTypeName(List *columns);



/* Line 189 of yacc.c  */
#line 218 "gram.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     IDENT = 258,
     FCONST = 259,
     SCONST = 260,
     BCONST = 261,
     XCONST = 262,
     Op = 263,
     ICONST = 264,
     PARAM = 265,
     TYPECAST = 266,
     DOT_DOT = 267,
     COLON_EQUALS = 268,
     ABORT_P = 269,
     ABSOLUTE_P = 270,
     ACCESS = 271,
     ACTION = 272,
     ADD_P = 273,
     ADMIN = 274,
     AFTER = 275,
     AGGREGATE = 276,
     ALL = 277,
     ALSO = 278,
     ALTER = 279,
     ALWAYS = 280,
     ANALYSE = 281,
     ANALYZE = 282,
     AND = 283,
     ANY = 284,
     ARRAY = 285,
     AS = 286,
     ASC = 287,
     ASSERTION = 288,
     ASSIGNMENT = 289,
     ASYMMETRIC = 290,
     AT = 291,
     AUTHORIZATION = 292,
     BACKWARD = 293,
     BEFORE = 294,
     BEGIN_P = 295,
     BETWEEN = 296,
     BIGINT = 297,
     BINARY = 298,
     BIT = 299,
     BOOLEAN_P = 300,
     BOTH = 301,
     BY = 302,
     CACHE = 303,
     CALLED = 304,
     CASCADE = 305,
     CASCADED = 306,
     CASE = 307,
     CAST = 308,
     CATALOG_P = 309,
     CHAIN = 310,
     CHAR_P = 311,
     CHARACTER = 312,
     CHARACTERISTICS = 313,
     CHECK = 314,
     CHECKPOINT = 315,
     CLASS = 316,
     CLOSE = 317,
     CLUSTER = 318,
     COALESCE = 319,
     COLLATE = 320,
     COLUMN = 321,
     COMMENT = 322,
     COMMENTS = 323,
     COMMIT = 324,
     COMMITTED = 325,
     CONCURRENTLY = 326,
     CONFIGURATION = 327,
     CONNECTION = 328,
     CONSTRAINT = 329,
     CONSTRAINTS = 330,
     CONTENT_P = 331,
     CONTINUE_P = 332,
     CONVERSION_P = 333,
     COPY = 334,
     COST = 335,
     CREATE = 336,
     CREATEDB = 337,
     CREATEROLE = 338,
     CREATEUSER = 339,
     CROSS = 340,
     CSV = 341,
     CURRENT_P = 342,
     CURRENT_CATALOG = 343,
     CURRENT_DATE = 344,
     CURRENT_ROLE = 345,
     CURRENT_SCHEMA = 346,
     CURRENT_TIME = 347,
     CURRENT_TIMESTAMP = 348,
     CURRENT_USER = 349,
     CURSOR = 350,
     CYCLE = 351,
     DATA_P = 352,
     DATABASE = 353,
     DAY_P = 354,
     DEALLOCATE = 355,
     DEC = 356,
     DECIMAL_P = 357,
     DECLARE = 358,
     DEFAULT = 359,
     DEFAULTS = 360,
     DEFERRABLE = 361,
     DEFERRED = 362,
     DEFINER = 363,
     DELETE_P = 364,
     DELIMITER = 365,
     DELIMITERS = 366,
     DESC = 367,
     DICTIONARY = 368,
     DISABLE_P = 369,
     DISCARD = 370,
     DISTINCT = 371,
     DO = 372,
     DOCUMENT_P = 373,
     DOMAIN_P = 374,
     DOUBLE_P = 375,
     DROP = 376,
     EACH = 377,
     ELSE = 378,
     ENABLE_P = 379,
     ENCODING = 380,
     ENCRYPTED = 381,
     END_P = 382,
     ENUM_P = 383,
     ESCAPE = 384,
     EXCEPT = 385,
     EXCLUDE = 386,
     EXCLUDING = 387,
     EXCLUSIVE = 388,
     EXECUTE = 389,
     EXISTS = 390,
     EXPLAIN = 391,
     EXTERNAL = 392,
     EXTRACT = 393,
     FALSE_P = 394,
     FAMILY = 395,
     FETCH = 396,
     FIRST_P = 397,
     FLOAT_P = 398,
     FOLLOWING = 399,
     FOR = 400,
     FORCE = 401,
     FOREIGN = 402,
     FORWARD = 403,
     FREEZE = 404,
     FROM = 405,
     FULL = 406,
     FUNCTION = 407,
     FUNCTIONS = 408,
     GLOBAL = 409,
     GRANT = 410,
     GRANTED = 411,
     GREATEST = 412,
     GROUP_P = 413,
     HANDLER = 414,
     HAVING = 415,
     HEADER_P = 416,
     HOLD = 417,
     HOUR_P = 418,
     IDENTITY_P = 419,
     IF_P = 420,
     ILIKE = 421,
     IMMEDIATE = 422,
     IMMUTABLE = 423,
     IMPLICIT_P = 424,
     IN_P = 425,
     INCLUDING = 426,
     INCREMENT = 427,
     INDEX = 428,
     INDEXES = 429,
     INHERIT = 430,
     INHERITS = 431,
     INITIALLY = 432,
     INLINE_P = 433,
     INNER_P = 434,
     INOUT = 435,
     INPUT_P = 436,
     INSENSITIVE = 437,
     INSERT = 438,
     INSTEAD = 439,
     INT_P = 440,
     INTEGER = 441,
     INTERSECT = 442,
     INTERVAL = 443,
     INTO = 444,
     INVOKER = 445,
     IS = 446,
     ISNULL = 447,
     ISOLATION = 448,
     JOIN = 449,
     KEY = 450,
     LANGUAGE = 451,
     LARGE_P = 452,
     LAST_P = 453,
     LC_COLLATE_P = 454,
     LC_CTYPE_P = 455,
     LEADING = 456,
     LEAST = 457,
     LEFT = 458,
     LEVEL = 459,
     LIKE = 460,
     LIMIT = 461,
     LISTEN = 462,
     LOAD = 463,
     LOCAL = 464,
     LOCALTIME = 465,
     LOCALTIMESTAMP = 466,
     LOCATION = 467,
     LOCK_P = 468,
     LOGIN_P = 469,
     MAPPING = 470,
     MATCH = 471,
     MAXVALUE = 472,
     MINUTE_P = 473,
     MINVALUE = 474,
     MODE = 475,
     MONTH_P = 476,
     MOVE = 477,
     NAME_P = 478,
     NAMES = 479,
     NATIONAL = 480,
     NATURAL = 481,
     NCHAR = 482,
     NEXT = 483,
     NO = 484,
     NOCREATEDB = 485,
     NOCREATEROLE = 486,
     NOCREATEUSER = 487,
     NOINHERIT = 488,
     NOLOGIN_P = 489,
     NONE = 490,
     NOSUPERUSER = 491,
     NOT = 492,
     NOTHING = 493,
     NOTIFY = 494,
     NOTNULL = 495,
     NOWAIT = 496,
     NULL_P = 497,
     NULLIF = 498,
     NULLS_P = 499,
     NUMERIC = 500,
     OBJECT_P = 501,
     OF = 502,
     OFF = 503,
     OFFSET = 504,
     OIDS = 505,
     ON = 506,
     ONLY = 507,
     OPERATOR = 508,
     OPTION = 509,
     OPTIONS = 510,
     OR = 511,
     ORDER = 512,
     OUT_P = 513,
     OUTER_P = 514,
     OVER = 515,
     OVERLAPS = 516,
     OVERLAY = 517,
     OWNED = 518,
     OWNER = 519,
     PARSER = 520,
     PARTIAL = 521,
     PARTITION = 522,
     PASSWORD = 523,
     PLACING = 524,
     PLANS = 525,
     POSITION = 526,
     PRECEDING = 527,
     PRECISION = 528,
     PRESERVE = 529,
     PREPARE = 530,
     PREPARED = 531,
     PRIMARY = 532,
     PRIOR = 533,
     PRIVILEGES = 534,
     PROCEDURAL = 535,
     PROCEDURE = 536,
     QUOTE = 537,
     RANGE = 538,
     READ = 539,
     REAL = 540,
     REASSIGN = 541,
     RECHECK = 542,
     RECURSIVE = 543,
     REFERENCES = 544,
     REINDEX = 545,
     RELATIVE_P = 546,
     RELEASE = 547,
     RENAME = 548,
     REPEATABLE = 549,
     REPLACE = 550,
     REPLICA = 551,
     RESET = 552,
     RESTART = 553,
     RESTRICT = 554,
     RETURNING = 555,
     RETURNS = 556,
     REVOKE = 557,
     RIGHT = 558,
     ROLE = 559,
     ROLLBACK = 560,
     ROW = 561,
     ROWS = 562,
     RULE = 563,
     SAVEPOINT = 564,
     SCHEMA = 565,
     SCROLL = 566,
     SEARCH = 567,
     SECOND_P = 568,
     SECURITY = 569,
     SELECT = 570,
     SEQUENCE = 571,
     SEQUENCES = 572,
     SERIALIZABLE = 573,
     SERVER = 574,
     SESSION = 575,
     SESSION_USER = 576,
     SET = 577,
     SETOF = 578,
     SHARE = 579,
     SHOW = 580,
     SIMILAR = 581,
     SIMPLE = 582,
     SMALLINT = 583,
     SOME = 584,
     STABLE = 585,
     STANDALONE_P = 586,
     START = 587,
     STATEMENT = 588,
     STATISTICS = 589,
     STDIN = 590,
     STDOUT = 591,
     STORAGE = 592,
     STRICT_P = 593,
     STRIP_P = 594,
     SUBSTRING = 595,
     SUPERUSER_P = 596,
     SYMMETRIC = 597,
     SYSID = 598,
     SYSTEM_P = 599,
     TABLE = 600,
     TABLES = 601,
     TABLESPACE = 602,
     TEMP = 603,
     TEMPLATE = 604,
     TEMPORARY = 605,
     TEXT_P = 606,
     THEN = 607,
     TIME = 608,
     TIMESTAMP = 609,
     TO = 610,
     TRAILING = 611,
     TRANSACTION = 612,
     TREAT = 613,
     TRIGGER = 614,
     TRIM = 615,
     TRUE_P = 616,
     TRUNCATE = 617,
     TRUSTED = 618,
     TYPE_P = 619,
     UNBOUNDED = 620,
     UNCOMMITTED = 621,
     UNENCRYPTED = 622,
     UNION = 623,
     UNIQUE = 624,
     UNKNOWN = 625,
     UNLISTEN = 626,
     UNTIL = 627,
     UPDATE = 628,
     USER = 629,
     USING = 630,
     VACUUM = 631,
     VALID = 632,
     VALIDATOR = 633,
     VALUE_P = 634,
     VALUES = 635,
     VARCHAR = 636,
     VARIADIC = 637,
     VARYING = 638,
     VERBOSE = 639,
     VERSION_P = 640,
     VIEW = 641,
     VOLATILE = 642,
     WHEN = 643,
     WHERE = 644,
     WHITESPACE_P = 645,
     WINDOW = 646,
     WITH = 647,
     WITHOUT = 648,
     WORK = 649,
     WRAPPER = 650,
     WRITE = 651,
     XML_P = 652,
     XMLATTRIBUTES = 653,
     XMLCONCAT = 654,
     XMLELEMENT = 655,
     XMLFOREST = 656,
     XMLPARSE = 657,
     XMLPI = 658,
     XMLROOT = 659,
     XMLSERIALIZE = 660,
     YEAR_P = 661,
     YES_P = 662,
     ZONE = 663,
     NULLS_FIRST = 664,
     NULLS_LAST = 665,
     WITH_TIME = 666,
     POSTFIXOP = 667,
     UMINUS = 668
   };
#endif



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 146 "gram.y"

	core_YYSTYPE		core_yystype;
	/* these fields must match core_YYSTYPE: */
	int					ival;
	char				*str;
	const char			*keyword;

	char				chr;
	bool				boolean;
	JoinType			jtype;
	DropBehavior		dbehavior;
	OnCommitAction		oncommit;
	List				*list;
	Node				*node;
	Value				*value;
	ObjectType			objtype;
	TypeName			*typnam;
	FunctionParameter   *fun_param;
	FunctionParameterMode fun_param_mode;
	FuncWithArgs		*funwithargs;
	DefElem				*defelt;
	SortBy				*sortby;
	WindowDef			*windef;
	JoinExpr			*jexpr;
	IndexElem			*ielem;
	Alias				*alias;
	RangeVar			*range;
	IntoClause			*into;
	WithClause			*with;
	A_Indices			*aind;
	ResTarget			*target;
	struct PrivTarget	*privtarget;
	AccessPriv			*accesspriv;
	InsertStmt			*istmt;
	VariableSetStmt		*vsetstmt;



/* Line 214 of yacc.c  */
#line 706 "gram.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 731 "gram.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  683
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   63815

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  431
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  515
/* YYNRULES -- Number of rules.  */
#define YYNRULES  2087
/* YYNRULES -- Number of states.  */
#define YYNSTATES  3837

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   668

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint16 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   420,     2,     2,
     425,   426,   418,   416,   429,   417,   427,   419,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   430,   428,
     413,   412,   414,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   423,     2,   424,   421,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   415,   422
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     9,    11,    13,    15,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    73,    75,    77,    79,
      81,    83,    85,    87,    89,    91,    93,    95,    97,    99,
     101,   103,   105,   107,   109,   111,   113,   115,   117,   119,
     121,   123,   125,   127,   129,   131,   133,   135,   137,   139,
     141,   143,   145,   147,   149,   151,   153,   155,   157,   159,
     161,   163,   165,   167,   169,   171,   173,   175,   177,   179,
     181,   183,   185,   187,   189,   191,   193,   195,   197,   199,
     201,   203,   205,   207,   209,   211,   213,   215,   216,   222,
     224,   225,   228,   229,   232,   233,   236,   239,   243,   247,
     249,   251,   253,   255,   257,   259,   261,   263,   265,   267,
     269,   271,   275,   279,   282,   284,   287,   290,   293,   297,
     301,   307,   313,   314,   318,   324,   330,   335,   339,   345,
     349,   355,   361,   368,   370,   372,   376,   382,   389,   394,
     396,   397,   400,   401,   403,   405,   407,   409,   411,   413,
     416,   420,   424,   428,   432,   436,   440,   444,   448,   451,
     457,   460,   463,   466,   469,   473,   477,   481,   483,   487,
     489,   493,   495,   497,   500,   503,   506,   508,   510,   512,
     514,   516,   518,   520,   524,   531,   533,   535,   537,   539,
     541,   542,   544,   546,   549,   553,   558,   562,   565,   568,
     570,   573,   577,   582,   586,   589,   594,   596,   598,   600,
     602,   604,   607,   610,   613,   616,   621,   626,   631,   636,
     638,   642,   645,   649,   654,   661,   668,   675,   681,   687,
     694,   701,   706,   714,   717,   724,   729,   733,   737,   741,
     745,   749,   754,   759,   763,   767,   771,   775,   779,   783,
     788,   793,   797,   800,   804,   808,   812,   815,   818,   822,
     825,   827,   829,   830,   833,   834,   838,   841,   842,   844,
     848,   852,   854,   860,   864,   867,   870,   881,   888,   890,
     892,   894,   896,   898,   900,   904,   907,   908,   910,   912,
     916,   920,   922,   924,   928,   932,   936,   940,   945,   947,
     948,   951,   952,   956,   957,   959,   960,   962,   966,   969,
     971,   973,   975,   979,   980,   982,   986,   988,  1000,  1011,
    1013,  1015,  1018,  1021,  1024,  1027,  1028,  1030,  1031,  1035,
    1036,  1038,  1042,  1044,  1048,  1050,  1052,  1054,  1056,  1058,
    1062,  1067,  1070,  1071,  1075,  1077,  1079,  1082,  1084,  1088,
    1093,  1098,  1101,  1107,  1109,  1112,  1115,  1118,  1122,  1126,
    1130,  1131,  1133,  1135,  1137,  1139,  1141,  1143,  1147,  1149,
    1155,  1163,  1172,  1182,  1194,  1198,  1199,  1201,  1205,  1207,
    1210,  1213,  1216,  1217,  1219,  1223,  1227,  1234,  1239,  1240,
    1242,  1244,  1247,  1250,  1251,  1255,  1259,  1262,  1264,  1266,
    1269,  1272,  1277,  1278,  1281,  1284,  1287,  1288,  1292,  1297,
    1302,  1303,  1306,  1307,  1312,  1313,  1321,  1327,  1331,  1332,
    1334,  1338,  1340,  1343,  1347,  1348,  1354,  1359,  1361,  1362,
    1364,  1367,  1370,  1372,  1375,  1379,  1382,  1385,  1388,  1391,
    1395,  1399,  1401,  1405,  1407,  1408,  1410,  1413,  1415,  1417,
    1421,  1428,  1439,  1441,  1442,  1444,  1447,  1450,  1451,  1454,
    1457,  1459,  1460,  1466,  1474,  1476,  1477,  1484,  1487,  1488,
    1492,  1498,  1506,  1513,  1522,  1530,  1537,  1544,  1549,  1550,
    1552,  1556,  1561,  1563,  1567,  1569,  1572,  1575,  1578,  1581,
    1583,  1585,  1596,  1599,  1600,  1603,  1606,  1608,  1609,  1614,
    1621,  1627,  1632,  1637,  1646,  1648,  1650,  1652,  1660,  1670,
    1679,  1695,  1716,  1718,  1720,  1722,  1726,  1728,  1730,  1732,
    1736,  1738,  1742,  1743,  1745,  1746,  1748,  1750,  1755,  1756,
    1758,  1762,  1763,  1765,  1767,  1769,  1771,  1773,  1775,  1778,
    1779,  1781,  1784,  1786,  1789,  1790,  1793,  1795,  1798,  1801,
    1808,  1817,  1826,  1831,  1837,  1842,  1847,  1852,  1856,  1864,
    1873,  1880,  1887,  1894,  1901,  1905,  1907,  1911,  1915,  1917,
    1919,  1921,  1923,  1925,  1927,  1931,  1935,  1939,  1941,  1945,
    1949,  1951,  1952,  1954,  1958,  1972,  1974,  1978,  1983,  1989,
    1994,  2002,  2005,  2007,  2008,  2011,  2012,  2014,  2015,  2022,
    2031,  2040,  2042,  2046,  2052,  2058,  2066,  2076,  2084,  2094,
    2100,  2107,  2114,  2119,  2121,  2123,  2125,  2127,  2129,  2131,
    2133,  2135,  2139,  2143,  2147,  2151,  2153,  2157,  2159,  2162,
    2165,  2169,  2175,  2178,  2181,  2182,  2189,  2197,  2205,  2213,
    2222,  2231,  2238,  2247,  2257,  2267,  2275,  2286,  2294,  2303,
    2312,  2321,  2330,  2332,  2334,  2336,  2338,  2340,  2342,  2344,
    2346,  2348,  2350,  2352,  2354,  2356,  2358,  2361,  2364,  2366,
    2369,  2373,  2377,  2381,  2385,  2390,  2395,  2399,  2403,  2407,
    2412,  2417,  2421,  2426,  2431,  2433,  2435,  2437,  2438,  2446,
    2454,  2465,  2467,  2469,  2472,  2477,  2483,  2485,  2489,  2492,
    2495,  2498,  2501,  2503,  2506,  2509,  2514,  2518,  2521,  2524,
    2527,  2531,  2534,  2537,  2543,  2549,  2555,  2557,  2561,  2563,
    2566,  2570,  2571,  2573,  2577,  2580,  2587,  2594,  2604,  2608,
    2609,  2613,  2614,  2620,  2623,  2624,  2628,  2632,  2636,  2644,
    2652,  2663,  2665,  2667,  2669,  2684,  2686,  2687,  2689,  2690,
    2692,  2693,  2696,  2697,  2699,  2703,  2708,  2713,  2720,  2722,
    2725,  2726,  2728,  2730,  2731,  2733,  2735,  2736,  2746,  2759,
    2767,  2770,  2771,  2775,  2778,  2780,  2784,  2788,  2791,  2793,
    2797,  2801,  2805,  2808,  2811,  2813,  2815,  2817,  2819,  2822,
    2824,  2826,  2828,  2830,  2835,  2841,  2843,  2847,  2851,  2853,
    2856,  2861,  2867,  2869,  2871,  2873,  2875,  2879,  2883,  2886,
    2889,  2892,  2895,  2897,  2900,  2903,  2905,  2907,  2909,  2913,
    2916,  2917,  2920,  2922,  2926,  2932,  2934,  2937,  2939,  2940,
    2946,  2954,  2960,  2968,  2974,  2982,  2986,  2992,  2998,  3004,
    3006,  3010,  3013,  3015,  3018,  3020,  3023,  3035,  3046,  3057,
    3060,  3063,  3064,  3074,  3077,  3078,  3083,  3088,  3093,  3095,
    3097,  3099,  3100,  3108,  3115,  3122,  3129,  3136,  3144,  3154,
    3164,  3171,  3178,  3185,  3192,  3199,  3208,  3217,  3224,  3231,
    3238,  3244,  3250,  3259,  3268,  3277,  3286,  3293,  3295,  3296,
    3299,  3300,  3308,  3315,  3322,  3329,  3336,  3343,  3350,  3358,
    3365,  3372,  3379,  3386,  3394,  3402,  3410,  3420,  3430,  3437,
    3444,  3451,  3460,  3469,  3478,  3485,  3499,  3501,  3503,  3507,
    3511,  3513,  3515,  3517,  3519,  3521,  3523,  3525,  3526,  3528,
    3530,  3532,  3534,  3536,  3538,  3539,  3546,  3555,  3559,  3562,
    3563,  3566,  3569,  3572,  3575,  3579,  3583,  3586,  3589,  3592,
    3595,  3599,  3602,  3608,  3613,  3617,  3621,  3625,  3627,  3629,
    3630,  3634,  3637,  3640,  3642,  3646,  3649,  3651,  3652,  3661,
    3672,  3676,  3681,  3686,  3687,  3690,  3696,  3699,  3700,  3704,
    3708,  3712,  3716,  3720,  3724,  3728,  3732,  3736,  3740,  3744,
    3748,  3752,  3757,  3761,  3765,  3767,  3768,  3774,  3781,  3786,
    3789,  3790,  3795,  3799,  3805,  3812,  3817,  3824,  3831,  3837,
    3845,  3847,  3848,  3855,  3867,  3879,  3891,  3905,  3915,  3927,
    3938,  3943,  3946,  3952,  3955,  3956,  3961,  3967,  3973,  3978,
    3985,  3987,  3991,  3993,  3995,  3997,  3999,  4002,  4007,  4009,
    4011,  4013,  4014,  4016,  4017,  4019,  4020,  4024,  4025,  4028,
    4033,  4037,  4043,  4045,  4047,  4049,  4051,  4053,  4055,  4057,
    4059,  4063,  4066,  4068,  4070,  4072,  4074,  4076,  4077,  4083,
    4087,  4088,  4090,  4092,  4094,  4096,  4100,  4109,  4113,  4114,
    4117,  4121,  4124,  4128,  4134,  4136,  4141,  4144,  4146,  4150,
    4153,  4156,  4157,  4164,  4167,  4168,  4174,  4178,  4179,  4182,
    4185,  4188,  4192,  4194,  4198,  4200,  4203,  4205,  4206,  4214,
    4216,  4220,  4222,  4224,  4228,  4234,  4237,  4239,  4243,  4251,
    4253,  4254,  4258,  4261,  4264,  4267,  4268,  4271,  4274,  4276,
    4278,  4282,  4286,  4288,  4291,  4296,  4301,  4304,  4308,  4314,
    4320,  4322,  4324,  4334,  4336,  4339,  4344,  4349,  4354,  4357,
    4361,  4363,  4367,  4372,  4375,  4376,  4380,  4384,  4389,  4394,
    4399,  4404,  4407,  4409,  4411,  4412,  4414,  4416,  4417,  4419,
    4425,  4427,  4428,  4430,  4431,  4435,  4437,  4441,  4446,  4450,
    4453,  4456,  4458,  4460,  4462,  4463,  4466,  4471,  4477,  4480,
    4484,  4486,  4488,  4490,  4492,  4496,  4497,  4499,  4501,  4503,
    4505,  4507,  4511,  4512,  4515,  4516,  4518,  4522,  4524,  4525,
    4527,  4530,  4535,  4540,  4543,  4544,  4547,  4551,  4554,  4555,
    4557,  4561,  4563,  4566,  4568,  4571,  4577,  4584,  4590,  4592,
    4595,  4597,  4602,  4606,  4611,  4617,  4622,  4628,  4633,  4639,
    4642,  4647,  4649,  4652,  4655,  4658,  4660,  4662,  4663,  4668,
    4671,  4673,  4676,  4679,  4684,  4686,  4690,  4692,  4695,  4699,
    4701,  4704,  4705,  4708,  4713,  4714,  4716,  4720,  4723,  4726,
    4730,  4736,  4743,  4746,  4750,  4754,  4759,  4760,  4762,  4764,
    4766,  4768,  4770,  4773,  4779,  4781,  4783,  4785,  4787,  4790,
    4794,  4798,  4799,  4801,  4803,  4805,  4807,  4809,  4812,  4815,
    4818,  4821,  4824,  4826,  4830,  4831,  4833,  4835,  4837,  4839,
    4845,  4848,  4850,  4852,  4854,  4856,  4862,  4865,  4868,  4871,
    4873,  4877,  4881,  4884,  4886,  4887,  4891,  4892,  4898,  4901,
    4907,  4910,  4912,  4915,  4919,  4920,  4922,  4924,  4926,  4928,
    4930,  4932,  4936,  4940,  4944,  4948,  4952,  4956,  4960,  4961,
    4963,  4968,  4970,  4974,  4980,  4983,  4986,  4990,  4994,  4998,
    5002,  5006,  5010,  5014,  5018,  5022,  5026,  5029,  5032,  5036,
    5040,  5043,  5047,  5053,  5058,  5065,  5069,  5075,  5080,  5087,
    5092,  5099,  5105,  5113,  5117,  5120,  5125,  5128,  5132,  5136,
    5141,  5145,  5150,  5154,  5159,  5165,  5172,  5179,  5187,  5194,
    5202,  5209,  5217,  5221,  5226,  5231,  5238,  5241,  5245,  5250,
    5252,  5256,  5259,  5262,  5266,  5270,  5274,  5278,  5282,  5286,
    5290,  5294,  5298,  5302,  5305,  5308,  5314,  5321,  5328,  5336,
    5340,  5345,  5347,  5349,  5352,  5357,  5359,  5361,  5363,  5366,
    5369,  5372,  5375,  5377,  5382,  5388,  5395,  5404,  5411,  5419,
    5427,  5433,  5435,  5437,  5442,  5444,  5449,  5451,  5456,  5458,
    5463,  5465,  5467,  5469,  5471,  5473,  5475,  5482,  5487,  5492,
    5497,  5502,  5509,  5515,  5521,  5527,  5532,  5539,  5544,  5549,
    5554,  5559,  5565,  5573,  5581,  5591,  5596,  5603,  5609,  5617,
    5625,  5633,  5636,  5640,  5644,  5648,  5653,  5654,  5659,  5661,
    5665,  5669,  5671,  5673,  5675,  5678,  5681,  5682,  5685,  5686,
    5688,  5692,  5696,  5699,  5702,  5703,  5710,  5712,  5713,  5717,
    5718,  5721,  5724,  5725,  5727,  5732,  5735,  5738,  5741,  5744,
    5747,  5752,  5756,  5762,  5764,  5766,  5768,  5770,  5772,  5774,
    5776,  5778,  5780,  5782,  5784,  5786,  5788,  5790,  5792,  5797,
    5799,  5804,  5806,  5811,  5813,  5816,  5818,  5821,  5823,  5827,
    5829,  5833,  5835,  5839,  5841,  5845,  5849,  5853,  5856,  5858,
    5862,  5866,  5867,  5869,  5871,  5873,  5875,  5877,  5879,  5881,
    5883,  5888,  5892,  5895,  5899,  5900,  5904,  5908,  5911,  5914,
    5916,  5917,  5920,  5923,  5927,  5930,  5932,  5934,  5938,  5944,
    5946,  5949,  5954,  5957,  5958,  5960,  5961,  5963,  5966,  5969,
    5972,  5976,  5982,  5984,  5987,  5988,  5991,  5993,  5994,  5996,
    5998,  6000,  6004,  6008,  6010,  6014,  6018,  6021,  6023,  6025,
    6027,  6031,  6033,  6036,  6038,  6042,  6044,  6046,  6048,  6050,
    6052,  6054,  6056,  6059,  6061,  6063,  6065,  6067,  6069,  6072,
    6078,  6081,  6085,  6092,  6094,  6096,  6098,  6100,  6102,  6104,
    6106,  6109,  6112,  6114,  6116,  6118,  6120,  6122,  6124,  6126,
    6128,  6130,  6132,  6134,  6136,  6138,  6140,  6142,  6144,  6146,
    6148,  6150,  6152,  6154,  6156,  6158,  6160,  6162,  6164,  6166,
    6168,  6170,  6172,  6174,  6176,  6178,  6180,  6182,  6184,  6186,
    6188,  6190,  6192,  6194,  6196,  6198,  6200,  6202,  6204,  6206,
    6208,  6210,  6212,  6214,  6216,  6218,  6220,  6222,  6224,  6226,
    6228,  6230,  6232,  6234,  6236,  6238,  6240,  6242,  6244,  6246,
    6248,  6250,  6252,  6254,  6256,  6258,  6260,  6262,  6264,  6266,
    6268,  6270,  6272,  6274,  6276,  6278,  6280,  6282,  6284,  6286,
    6288,  6290,  6292,  6294,  6296,  6298,  6300,  6302,  6304,  6306,
    6308,  6310,  6312,  6314,  6316,  6318,  6320,  6322,  6324,  6326,
    6328,  6330,  6332,  6334,  6336,  6338,  6340,  6342,  6344,  6346,
    6348,  6350,  6352,  6354,  6356,  6358,  6360,  6362,  6364,  6366,
    6368,  6370,  6372,  6374,  6376,  6378,  6380,  6382,  6384,  6386,
    6388,  6390,  6392,  6394,  6396,  6398,  6400,  6402,  6404,  6406,
    6408,  6410,  6412,  6414,  6416,  6418,  6420,  6422,  6424,  6426,
    6428,  6430,  6432,  6434,  6436,  6438,  6440,  6442,  6444,  6446,
    6448,  6450,  6452,  6454,  6456,  6458,  6460,  6462,  6464,  6466,
    6468,  6470,  6472,  6474,  6476,  6478,  6480,  6482,  6484,  6486,
    6488,  6490,  6492,  6494,  6496,  6498,  6500,  6502,  6504,  6506,
    6508,  6510,  6512,  6514,  6516,  6518,  6520,  6522,  6524,  6526,
    6528,  6530,  6532,  6534,  6536,  6538,  6540,  6542,  6544,  6546,
    6548,  6550,  6552,  6554,  6556,  6558,  6560,  6562,  6564,  6566,
    6568,  6570,  6572,  6574,  6576,  6578,  6580,  6582,  6584,  6586,
    6588,  6590,  6592,  6594,  6596,  6598,  6600,  6602,  6604,  6606,
    6608,  6610,  6612,  6614,  6616,  6618,  6620,  6622,  6624,  6626,
    6628,  6630,  6632,  6634,  6636,  6638,  6640,  6642,  6644,  6646,
    6648,  6650,  6652,  6654,  6656,  6658,  6660,  6662,  6664,  6666,
    6668,  6670,  6672,  6674,  6676,  6678,  6680,  6682,  6684,  6686,
    6688,  6690,  6692,  6694,  6696,  6698,  6700,  6702,  6704,  6706,
    6708,  6710,  6712,  6714,  6716,  6718,  6720,  6722,  6724,  6726,
    6728,  6730,  6732,  6734,  6736,  6738,  6740,  6742,  6744,  6746,
    6748,  6750,  6752,  6754,  6756,  6758,  6760,  6762,  6764,  6766,
    6768,  6770,  6772,  6774,  6776,  6778,  6780,  6782,  6784,  6786,
    6788,  6790,  6792,  6794,  6796,  6798,  6800,  6802,  6804,  6806,
    6808,  6810,  6812,  6814,  6816,  6818,  6820,  6822,  6824,  6826,
    6828,  6830,  6832,  6834,  6836,  6838,  6840,  6842,  6844,  6846,
    6848,  6850,  6852,  6854,  6856,  6858,  6860,  6862,  6864,  6866,
    6868,  6870,  6872,  6874,  6876,  6878,  6880,  6882,  6884,  6886,
    6888,  6890,  6892,  6894,  6896,  6898,  6900,  6902,  6904,  6906,
    6908,  6910,  6912,  6914,  6916,  6918,  6920,  6922
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     432,     0,    -1,   433,    -1,   433,   428,   434,    -1,   434,
      -1,   734,    -1,   735,    -1,   653,    -1,   740,    -1,   563,
      -1,   577,    -1,   687,    -1,   450,    -1,   708,    -1,   709,
      -1,   543,    -1,   475,    -1,   444,    -1,   442,    -1,   743,
      -1,   742,    -1,   581,    -1,   446,    -1,   445,    -1,   750,
      -1,   473,    -1,   485,    -1,   745,    -1,   631,    -1,   470,
      -1,   486,    -1,   536,    -1,   597,    -1,   698,    -1,   744,
      -1,   739,    -1,   561,    -1,   572,    -1,   668,    -1,   449,
      -1,   610,    -1,   616,    -1,   617,    -1,   550,    -1,   453,
      -1,   542,    -1,   501,    -1,   558,    -1,   582,    -1,   435,
      -1,   441,    -1,   578,    -1,   730,    -1,   767,    -1,   786,
      -1,   599,    -1,   773,    -1,   474,    -1,   695,    -1,   598,
      -1,   700,    -1,   562,    -1,   576,    -1,   452,    -1,   620,
      -1,   621,    -1,   622,    -1,   556,    -1,   717,    -1,   624,
      -1,   560,    -1,   596,    -1,   447,    -1,   448,    -1,   580,
      -1,   738,    -1,   765,    -1,   756,    -1,   634,    -1,   638,
      -1,   649,    -1,   658,    -1,   768,    -1,   720,    -1,   729,
      -1,   775,    -1,   718,    -1,   762,    -1,   623,    -1,   702,
      -1,   691,    -1,   690,    -1,   692,    -1,   705,    -1,   639,
      -1,   650,    -1,   710,    -1,   790,    -1,   722,    -1,   629,
      -1,   721,    -1,   779,    -1,   747,    -1,   467,    -1,   457,
      -1,   469,    -1,   727,    -1,    -1,    81,   304,   937,   436,
     437,    -1,   392,    -1,    -1,   437,   440,    -1,    -1,   438,
     439,    -1,    -1,   268,   936,    -1,   268,   242,    -1,   126,
     268,   936,    -1,   367,   268,   936,    -1,   341,    -1,   236,
      -1,   175,    -1,   233,    -1,    82,    -1,   230,    -1,    83,
      -1,   231,    -1,    84,    -1,   232,    -1,   214,    -1,   234,
      -1,    73,   206,   938,    -1,   377,   372,   936,    -1,   374,
     926,    -1,   439,    -1,   343,   935,    -1,    19,   926,    -1,
     304,   926,    -1,   170,   304,   926,    -1,   170,   158,   926,
      -1,    81,   374,   937,   436,   437,    -1,    24,   304,   937,
     436,   438,    -1,    -1,   170,    98,   928,    -1,    24,   304,
     937,   443,   468,    -1,    24,   374,   937,   436,   438,    -1,
      24,   374,   937,   468,    -1,   121,   304,   926,    -1,   121,
     304,   165,   135,   926,    -1,   121,   374,   926,    -1,   121,
     374,   165,   135,   926,    -1,    81,   158,   937,   436,   437,
      -1,    24,   158,   937,   451,   374,   926,    -1,    18,    -1,
     121,    -1,   121,   158,   926,    -1,   121,   158,   165,   135,
     926,    -1,    81,   310,   454,    37,   937,   455,    -1,    81,
     310,   939,   455,    -1,   939,    -1,    -1,   455,   456,    -1,
      -1,   501,    -1,   658,    -1,   542,    -1,   582,    -1,   638,
      -1,   727,    -1,   322,   458,    -1,   322,   209,   458,    -1,
     322,   320,   458,    -1,   459,   355,   460,    -1,   459,   412,
     460,    -1,   459,   355,   104,    -1,   459,   412,   104,    -1,
     459,   150,    87,    -1,   353,   408,   464,    -1,   357,   725,
      -1,   320,    58,    31,   357,   725,    -1,    54,   936,    -1,
     310,   936,    -1,   224,   465,    -1,   304,   466,    -1,   320,
      37,   466,    -1,   320,    37,   104,    -1,   397,   254,   874,
      -1,   939,    -1,   459,   427,   939,    -1,   461,    -1,   460,
     429,   461,    -1,   463,    -1,   548,    -1,   284,   366,    -1,
     284,    70,    -1,   294,   284,    -1,   318,    -1,   361,    -1,
     139,    -1,   251,    -1,   466,    -1,   936,    -1,     3,    -1,
     861,   936,   863,    -1,   861,   425,   935,   426,   936,   863,
      -1,   548,    -1,   104,    -1,   209,    -1,   936,    -1,   104,
      -1,    -1,   939,    -1,   936,    -1,   297,   459,    -1,   297,
     353,   408,    -1,   297,   357,   193,   204,    -1,   297,   320,
      37,    -1,   297,    22,    -1,   322,   458,    -1,   467,    -1,
     325,   459,    -1,   325,   353,   408,    -1,   325,   357,   193,
     204,    -1,   325,   320,    37,    -1,   325,    22,    -1,   322,
      75,   471,   472,    -1,    22,    -1,   924,    -1,   107,    -1,
     167,    -1,    60,    -1,   115,    22,    -1,   115,   348,    -1,
     115,   350,    -1,   115,   270,    -1,    24,   345,   833,   476,
      -1,    24,   173,   925,   476,    -1,    24,   316,   925,   476,
      -1,    24,   386,   925,   476,    -1,   477,    -1,   476,   429,
     477,    -1,    18,   509,    -1,    18,    66,   509,    -1,    24,
     706,   939,   478,    -1,    24,   706,   939,   121,   237,   242,
      -1,    24,   706,   939,   322,   237,   242,    -1,    24,   706,
     939,   322,   334,   938,    -1,    24,   706,   939,   322,   481,
      -1,    24,   706,   939,   297,   481,    -1,    24,   706,   939,
     322,   337,   939,    -1,   121,   706,   165,   135,   939,   479,
      -1,   121,   706,   939,   479,    -1,    24,   706,   939,   707,
     364,   841,   480,    -1,    18,   518,    -1,   121,    74,   165,
     135,   927,   479,    -1,   121,    74,   927,   479,    -1,   322,
     392,   250,    -1,   322,   393,   250,    -1,    63,   251,   927,
      -1,   322,   393,    63,    -1,   124,   359,   927,    -1,   124,
      25,   359,   927,    -1,   124,   296,   359,   927,    -1,   124,
     359,    22,    -1,   124,   359,   374,    -1,   114,   359,   927,
      -1,   114,   359,    22,    -1,   114,   359,   374,    -1,   124,
     308,   927,    -1,   124,    25,   308,   927,    -1,   124,   296,
     308,   927,    -1,   114,   308,   927,    -1,   175,   925,    -1,
     229,   175,   925,    -1,   264,   355,   937,    -1,   322,   347,
     927,    -1,   322,   481,    -1,   297,   481,    -1,   322,   104,
     865,    -1,   121,   104,    -1,    50,    -1,   299,    -1,    -1,
     375,   865,    -1,    -1,   425,   483,   426,    -1,   392,   481,
      -1,    -1,   484,    -1,   483,   429,   484,    -1,   941,   412,
     603,    -1,   941,    -1,   941,   427,   941,   412,   603,    -1,
     941,   427,   941,    -1,    62,   787,    -1,    62,    22,    -1,
      79,   492,   925,   520,   493,   487,   488,   494,   436,   489,
      -1,    79,   791,   355,   488,   436,   489,    -1,   150,    -1,
     355,    -1,   936,    -1,   335,    -1,   336,    -1,   490,    -1,
     425,   496,   426,    -1,   490,   491,    -1,    -1,    43,    -1,
     250,    -1,   110,   741,   936,    -1,   242,   741,   936,    -1,
      86,    -1,   161,    -1,   282,   741,   936,    -1,   129,   741,
     936,    -1,   146,   282,   521,    -1,   146,   282,   418,    -1,
     146,   237,   242,   521,    -1,    43,    -1,    -1,   392,   250,
      -1,    -1,   495,   111,   936,    -1,    -1,   375,    -1,    -1,
     497,    -1,   496,   429,   497,    -1,   941,   498,    -1,   463,
      -1,   548,    -1,   418,    -1,   425,   499,   426,    -1,    -1,
     500,    -1,   499,   429,   500,    -1,   463,    -1,    81,   502,
     345,   925,   425,   503,   426,   531,   532,   533,   534,    -1,
      81,   502,   345,   925,   247,   627,   504,   532,   533,   534,
      -1,   350,    -1,   348,    -1,   209,   350,    -1,   209,   348,
      -1,   154,   350,    -1,   154,   348,    -1,    -1,   505,    -1,
      -1,   425,   506,   426,    -1,    -1,   507,    -1,   505,   429,
     507,    -1,   508,    -1,   506,   429,   508,    -1,   509,    -1,
     515,    -1,   518,    -1,   510,    -1,   518,    -1,   939,   841,
     511,    -1,   939,   392,   255,   511,    -1,   511,   512,    -1,
      -1,    74,   927,   513,    -1,   513,    -1,   514,    -1,   237,
     242,    -1,   242,    -1,   369,   684,   535,    -1,   277,   195,
     684,   535,    -1,    59,   425,   865,   426,    -1,   104,   866,
      -1,   289,   925,   520,   523,   527,    -1,   106,    -1,   237,
     106,    -1,   177,   107,    -1,   177,   167,    -1,   205,   925,
     516,    -1,   516,   171,   517,    -1,   516,   132,   517,    -1,
      -1,   105,    -1,    75,    -1,   174,    -1,   337,    -1,    68,
      -1,    22,    -1,    74,   927,   519,    -1,   519,    -1,    59,
     425,   865,   426,   593,    -1,   369,   425,   521,   426,   684,
     535,   593,    -1,   277,   195,   425,   521,   426,   684,   535,
     593,    -1,   131,   662,   425,   524,   426,   684,   535,   526,
     593,    -1,   147,   195,   425,   521,   426,   289,   925,   520,
     523,   527,   593,    -1,   425,   521,   426,    -1,    -1,   522,
      -1,   521,   429,   522,    -1,   939,    -1,   216,   151,    -1,
     216,   266,    -1,   216,   327,    -1,    -1,   525,    -1,   524,
     429,   525,    -1,   664,   392,   694,    -1,   664,   392,   253,
     425,   694,   426,    -1,   389,   425,   865,   426,    -1,    -1,
     528,    -1,   529,    -1,   528,   529,    -1,   529,   528,    -1,
      -1,   251,   373,   530,    -1,   251,   109,   530,    -1,   229,
      17,    -1,   299,    -1,    50,    -1,   322,   242,    -1,   322,
     104,    -1,   176,   425,   924,   426,    -1,    -1,   392,   481,
      -1,   392,   250,    -1,   393,   250,    -1,    -1,   251,    69,
     121,    -1,   251,    69,   109,   307,    -1,   251,    69,   274,
     307,    -1,    -1,   347,   927,    -1,    -1,   375,   173,   347,
     927,    -1,    -1,    81,   502,   345,   537,    31,   790,   541,
      -1,   925,   538,   532,   533,   534,    -1,   425,   539,   426,
      -1,    -1,   540,    -1,   539,   429,   540,    -1,   939,    -1,
     392,    97,    -1,   392,   229,    97,    -1,    -1,    81,   502,
     316,   925,   544,    -1,    24,   316,   925,   545,    -1,   545,
      -1,    -1,   546,    -1,   545,   546,    -1,    48,   548,    -1,
      96,    -1,   229,    96,    -1,   172,   547,   548,    -1,   217,
     548,    -1,   219,   548,    -1,   229,   217,    -1,   229,   219,
      -1,   263,    47,   627,    -1,   332,   436,   548,    -1,   298,
      -1,   298,   436,   548,    -1,    47,    -1,    -1,     4,    -1,
     417,     4,    -1,   938,    -1,   548,    -1,   549,   429,   548,
      -1,    81,   669,   551,   557,   196,   466,    -1,    81,   669,
     551,   557,   196,   466,   159,   552,   553,   555,    -1,   363,
      -1,    -1,   927,    -1,   927,   628,    -1,   178,   552,    -1,
      -1,   378,   552,    -1,   229,   378,    -1,   554,    -1,    -1,
     121,   557,   196,   466,   479,    -1,   121,   557,   196,   165,
     135,   466,   479,    -1,   280,    -1,    -1,    81,   347,   927,
     559,   212,   936,    -1,   264,   927,    -1,    -1,   121,   347,
     927,    -1,   121,   347,   165,   135,   927,    -1,    81,   147,
      97,   395,   927,   555,   564,    -1,   121,   147,    97,   395,
     927,   479,    -1,   121,   147,    97,   395,   165,   135,   927,
     479,    -1,    24,   147,    97,   395,   927,   554,   566,    -1,
      24,   147,    97,   395,   927,   554,    -1,    24,   147,    97,
     395,   927,   566,    -1,   255,   425,   565,   426,    -1,    -1,
     569,    -1,   565,   429,   569,    -1,   255,   425,   567,   426,
      -1,   568,    -1,   567,   429,   568,    -1,   569,    -1,   322,
     569,    -1,    18,   569,    -1,   121,   570,    -1,   570,   571,
      -1,   941,    -1,   936,    -1,    81,   319,   927,   573,   575,
     147,    97,   395,   927,   564,    -1,   364,   936,    -1,    -1,
     385,   936,    -1,   385,   242,    -1,   574,    -1,    -1,   121,
     319,   927,   479,    -1,   121,   319,   165,   135,   927,   479,
      -1,    24,   319,   927,   574,   566,    -1,    24,   319,   927,
     574,    -1,    24,   319,   927,   566,    -1,    81,   374,   215,
     145,   579,   319,   927,   564,    -1,    94,    -1,   374,    -1,
     937,    -1,   121,   374,   215,   145,   579,   319,   927,    -1,
     121,   374,   215,   165,   135,   145,   579,   319,   927,    -1,
      24,   374,   215,   145,   579,   319,   927,   566,    -1,    81,
     359,   927,   583,   584,   251,   925,   586,   589,   134,   281,
     933,   425,   590,   426,    -1,    81,    74,   359,   927,    20,
     584,   251,   925,   592,   593,   145,   122,   306,   589,   134,
     281,   933,   425,   590,   426,    -1,    39,    -1,    20,    -1,
     585,    -1,   584,   256,   585,    -1,   183,    -1,   109,    -1,
     373,    -1,   373,   247,   521,    -1,   362,    -1,   145,   587,
     588,    -1,    -1,   122,    -1,    -1,   306,    -1,   333,    -1,
     388,   425,   865,   426,    -1,    -1,   591,    -1,   590,   429,
     591,    -1,    -1,   935,    -1,     4,    -1,   936,    -1,     6,
      -1,     7,    -1,   939,    -1,   150,   925,    -1,    -1,   594,
      -1,   594,   595,    -1,   595,    -1,   595,   594,    -1,    -1,
     237,   106,    -1,   106,    -1,   177,   167,    -1,   177,   107,
      -1,   121,   359,   927,   251,   925,   479,    -1,   121,   359,
     165,   135,   927,   251,   925,   479,    -1,    81,    33,   927,
      59,   425,   865,   426,   593,    -1,   121,    33,   927,   479,
      -1,    81,    21,   933,   604,   600,    -1,    81,    21,   933,
     605,    -1,    81,   253,   694,   600,    -1,    81,   364,   627,
     600,    -1,    81,   364,   627,    -1,    81,   364,   627,    31,
     425,   839,   426,    -1,    81,   364,   627,    31,   128,   425,
     608,   426,    -1,    81,   351,   312,   265,   627,   600,    -1,
      81,   351,   312,   113,   627,   600,    -1,    81,   351,   312,
     349,   627,   600,    -1,    81,   351,   312,    72,   627,   600,
      -1,   425,   601,   426,    -1,   602,    -1,   601,   429,   602,
      -1,   941,   412,   603,    -1,   941,    -1,   678,    -1,   945,
      -1,   891,    -1,   548,    -1,   936,    -1,   425,   896,   426,
      -1,   425,   418,   426,    -1,   425,   606,   426,    -1,   607,
      -1,   606,   429,   607,    -1,     3,   412,   603,    -1,   609,
      -1,    -1,   936,    -1,   609,   429,   936,    -1,    81,   253,
      61,   627,   613,   145,   364,   841,   375,   929,   614,    31,
     611,    -1,   612,    -1,   611,   429,   612,    -1,   253,   935,
     694,   615,    -1,   253,   935,   694,   693,   615,    -1,   152,
     935,   933,   670,    -1,   152,   935,   425,   896,   426,   933,
     670,    -1,   337,   841,    -1,   104,    -1,    -1,   140,   627,
      -1,    -1,   287,    -1,    -1,    81,   253,   140,   627,   375,
     929,    -1,    24,   253,   140,   627,   375,   929,    18,   611,
      -1,    24,   253,   140,   627,   375,   929,   121,   618,    -1,
     619,    -1,   618,   429,   619,    -1,   253,   935,   425,   896,
     426,    -1,   152,   935,   425,   896,   426,    -1,   121,   253,
      61,   627,   375,   929,   479,    -1,   121,   253,    61,   165,
     135,   627,   375,   929,   479,    -1,   121,   253,   140,   627,
     375,   929,   479,    -1,   121,   253,   140,   165,   135,   627,
     375,   929,   479,    -1,   121,   263,    47,   926,   479,    -1,
     286,   263,    47,   926,   355,   927,    -1,   121,   625,   165,
     135,   626,   479,    -1,   121,   625,   626,   479,    -1,   345,
      -1,   316,    -1,   386,    -1,   173,    -1,   364,    -1,   119,
      -1,    78,    -1,   310,    -1,   351,   312,   265,    -1,   351,
     312,   113,    -1,   351,   312,   349,    -1,   351,   312,    72,
      -1,   627,    -1,   626,   429,   627,    -1,   939,    -1,   939,
     628,    -1,   427,   930,    -1,   628,   427,   930,    -1,   362,
     800,   834,   630,   479,    -1,    77,   164,    -1,   298,   164,
      -1,    -1,    67,   251,   632,   627,   191,   633,    -1,    67,
     251,    21,   933,   604,   191,   633,    -1,    67,   251,   152,
     933,   670,   191,   633,    -1,    67,   251,   253,   694,   693,
     191,   633,    -1,    67,   251,    74,   927,   251,   627,   191,
     633,    -1,    67,   251,   308,   927,   251,   627,   191,   633,
      -1,    67,   251,   308,   927,   191,   633,    -1,    67,   251,
     359,   927,   251,   627,   191,   633,    -1,    67,   251,   253,
      61,   627,   375,   929,   191,   633,    -1,    67,   251,   253,
     140,   627,   375,   929,   191,   633,    -1,    67,   251,   197,
     246,   548,   191,   633,    -1,    67,   251,    53,   425,   841,
      31,   841,   426,   191,   633,    -1,    67,   251,   557,   196,
     627,   191,   633,    -1,    67,   251,   351,   312,   265,   627,
     191,   633,    -1,    67,   251,   351,   312,   113,   627,   191,
     633,    -1,    67,   251,   351,   312,   349,   627,   191,   633,
      -1,    67,   251,   351,   312,    72,   627,   191,   633,    -1,
      66,    -1,    98,    -1,   310,    -1,   173,    -1,   316,    -1,
     345,    -1,   119,    -1,   364,    -1,   386,    -1,    78,    -1,
     347,    -1,   304,    -1,   936,    -1,   242,    -1,   141,   635,
      -1,   222,   635,    -1,   787,    -1,   636,   787,    -1,   228,
     637,   787,    -1,   278,   637,   787,    -1,   142,   637,   787,
      -1,   198,   637,   787,    -1,    15,   938,   637,   787,    -1,
     291,   938,   637,   787,    -1,   938,   637,   787,    -1,    22,
     637,   787,    -1,   148,   637,   787,    -1,   148,   938,   637,
     787,    -1,   148,    22,   637,   787,    -1,    38,   637,   787,
      -1,    38,   938,   637,   787,    -1,    38,    22,   637,   787,
      -1,   150,    -1,   170,    -1,   636,    -1,    -1,   155,   640,
     251,   643,   355,   644,   646,    -1,   302,   640,   251,   643,
     150,   644,   479,    -1,   302,   155,   254,   145,   640,   251,
     643,   150,   644,   479,    -1,   641,    -1,    22,    -1,    22,
     279,    -1,    22,   425,   521,   426,    -1,    22,   279,   425,
     521,   426,    -1,   642,    -1,   641,   429,   642,    -1,   315,
     520,    -1,   289,   520,    -1,    81,   520,    -1,   939,   520,
      -1,   924,    -1,   345,   924,    -1,   316,   924,    -1,   147,
      97,   395,   926,    -1,   147,   319,   926,    -1,   152,   647,
      -1,    98,   926,    -1,   196,   926,    -1,   197,   246,   549,
      -1,   310,   926,    -1,   347,   926,    -1,    22,   346,   170,
     310,   926,    -1,    22,   317,   170,   310,   926,    -1,    22,
     153,   170,   310,   926,    -1,   645,    -1,   644,   429,   645,
      -1,   937,    -1,   158,   937,    -1,   392,   155,   254,    -1,
      -1,   648,    -1,   647,   429,   648,    -1,   933,   670,    -1,
     155,   641,   355,   926,   651,   652,    -1,   302,   641,   150,
     926,   652,   479,    -1,   302,    19,   254,   145,   641,   150,
     926,   652,   479,    -1,   392,    19,   254,    -1,    -1,   156,
      47,   937,    -1,    -1,    24,   104,   279,   654,   656,    -1,
     654,   655,    -1,    -1,   170,   310,   926,    -1,   145,   304,
     926,    -1,   145,   374,   926,    -1,   155,   640,   251,   657,
     355,   644,   646,    -1,   302,   640,   251,   657,   150,   644,
     479,    -1,   302,   155,   254,   145,   640,   251,   657,   150,
     644,   479,    -1,   346,    -1,   153,    -1,   317,    -1,    81,
     659,   173,   660,   661,   251,   925,   662,   425,   663,   426,
     482,   534,   837,    -1,   369,    -1,    -1,    71,    -1,    -1,
     931,    -1,    -1,   375,   929,    -1,    -1,   664,    -1,   663,
     429,   664,    -1,   939,   665,   666,   667,    -1,   868,   665,
     666,   667,    -1,   425,   865,   426,   665,   666,   667,    -1,
     627,    -1,   375,   627,    -1,    -1,    32,    -1,   112,    -1,
      -1,   409,    -1,   410,    -1,    -1,    81,   669,   152,   933,
     672,   301,   677,   680,   684,    -1,    81,   669,   152,   933,
     672,   301,   345,   425,   686,   426,   680,   684,    -1,    81,
     669,   152,   933,   672,   680,   684,    -1,   256,   295,    -1,
      -1,   425,   671,   426,    -1,   425,   426,    -1,   674,    -1,
     671,   429,   674,    -1,   425,   673,   426,    -1,   425,   426,
      -1,   679,    -1,   673,   429,   679,    -1,   675,   676,   678,
      -1,   676,   675,   678,    -1,   676,   678,    -1,   675,   678,
      -1,   678,    -1,   170,    -1,   258,    -1,   180,    -1,   170,
     258,    -1,   382,    -1,   940,    -1,   678,    -1,   841,    -1,
     940,   628,   420,   364,    -1,   323,   940,   628,   420,   364,
      -1,   674,    -1,   674,   104,   865,    -1,   674,   412,   865,
      -1,   682,    -1,   680,   682,    -1,    49,   251,   242,   181,
      -1,   301,   242,   251,   242,   181,    -1,   338,    -1,   168,
      -1,   330,    -1,   387,    -1,   137,   314,   108,    -1,   137,
     314,   190,    -1,   314,   108,    -1,   314,   190,    -1,    80,
     548,    -1,   307,   548,    -1,   468,    -1,    31,   683,    -1,
     196,   466,    -1,   391,    -1,   681,    -1,   936,    -1,   936,
     429,   936,    -1,   392,   600,    -1,    -1,   676,   678,    -1,
     685,    -1,   686,   429,   685,    -1,    24,   152,   648,   688,
     689,    -1,   681,    -1,   688,   681,    -1,   299,    -1,    -1,
     121,   152,   933,   670,   479,    -1,   121,   152,   165,   135,
     933,   670,   479,    -1,   121,    21,   933,   604,   479,    -1,
     121,    21,   165,   135,   933,   604,   479,    -1,   121,   253,
     694,   693,   479,    -1,   121,   253,   165,   135,   694,   693,
     479,    -1,   425,   841,   426,    -1,   425,   841,   429,   841,
     426,    -1,   425,   235,   429,   841,   426,    -1,   425,   841,
     429,   235,   426,    -1,   888,    -1,   939,   427,   694,    -1,
     117,   696,    -1,   697,    -1,   696,   697,    -1,   936,    -1,
     196,   466,    -1,    81,    53,   425,   841,    31,   841,   426,
     392,   152,   648,   699,    -1,    81,    53,   425,   841,    31,
     841,   426,   393,   152,   699,    -1,    81,    53,   425,   841,
      31,   841,   426,   392,   180,   699,    -1,    31,   169,    -1,
      31,    34,    -1,    -1,   121,    53,   701,   425,   841,    31,
     841,   426,   479,    -1,   165,   135,    -1,    -1,   290,   703,
     925,   704,    -1,   290,   344,   927,   704,    -1,   290,    98,
     927,   704,    -1,   173,    -1,   345,    -1,   146,    -1,    -1,
      24,    21,   933,   604,   293,   355,   927,    -1,    24,    78,
     627,   293,   355,   927,    -1,    24,    98,   928,   293,   355,
     928,    -1,    24,   152,   648,   293,   355,   927,    -1,    24,
     158,   937,   293,   355,   937,    -1,    24,   557,   196,   927,
     293,   355,   927,    -1,    24,   253,    61,   627,   375,   929,
     293,   355,   927,    -1,    24,   253,   140,   627,   375,   929,
     293,   355,   927,    -1,    24,   310,   927,   293,   355,   927,
      -1,    24,   345,   833,   293,   355,   927,    -1,    24,   316,
     925,   293,   355,   927,    -1,    24,   386,   925,   293,   355,
     927,    -1,    24,   173,   925,   293,   355,   927,    -1,    24,
     345,   833,   293,   706,   927,   355,   927,    -1,    24,   359,
     927,   251,   925,   293,   355,   927,    -1,    24,   304,   937,
     293,   355,   937,    -1,    24,   374,   937,   293,   355,   937,
      -1,    24,   347,   927,   293,   355,   927,    -1,    24,   347,
     927,   322,   481,    -1,    24,   347,   927,   297,   481,    -1,
      24,   351,   312,   265,   627,   293,   355,   927,    -1,    24,
     351,   312,   113,   627,   293,   355,   927,    -1,    24,   351,
     312,   349,   627,   293,   355,   927,    -1,    24,   351,   312,
      72,   627,   293,   355,   927,    -1,    24,   364,   627,   293,
     355,   927,    -1,    66,    -1,    -1,   322,    97,    -1,    -1,
      24,    21,   933,   604,   322,   310,   927,    -1,    24,   119,
     627,   322,   310,   927,    -1,    24,   152,   648,   322,   310,
     927,    -1,    24,   345,   833,   322,   310,   927,    -1,    24,
     316,   925,   322,   310,   927,    -1,    24,   386,   925,   322,
     310,   927,    -1,    24,   364,   627,   322,   310,   927,    -1,
      24,    21,   933,   604,   264,   355,   937,    -1,    24,    78,
     627,   264,   355,   937,    -1,    24,    98,   928,   264,   355,
     937,    -1,    24,   119,   627,   264,   355,   937,    -1,    24,
     152,   648,   264,   355,   937,    -1,    24,   557,   196,   927,
     264,   355,   937,    -1,    24,   197,   246,   548,   264,   355,
     937,    -1,    24,   253,   694,   693,   264,   355,   937,    -1,
      24,   253,    61,   627,   375,   929,   264,   355,   937,    -1,
      24,   253,   140,   627,   375,   929,   264,   355,   937,    -1,
      24,   310,   927,   264,   355,   937,    -1,    24,   364,   627,
     264,   355,   937,    -1,    24,   347,   927,   264,   355,   937,
      -1,    24,   351,   312,   113,   627,   264,   355,   937,    -1,
      24,   351,   312,    72,   627,   264,   355,   937,    -1,    24,
     147,    97,   395,   927,   264,   355,   937,    -1,    24,   319,
     927,   264,   355,   937,    -1,    81,   669,   308,   927,    31,
     251,   715,   355,   925,   837,   117,   716,   711,    -1,   238,
      -1,   713,    -1,   425,   712,   426,    -1,   712,   428,   714,
      -1,   714,    -1,   790,    -1,   768,    -1,   779,    -1,   773,
      -1,   718,    -1,   713,    -1,    -1,   315,    -1,   373,    -1,
     109,    -1,   183,    -1,   184,    -1,    23,    -1,    -1,   121,
     308,   927,   251,   925,   479,    -1,   121,   308,   165,   135,
     927,   251,   925,   479,    -1,   239,   939,   719,    -1,   429,
     936,    -1,    -1,   207,   939,    -1,   371,   939,    -1,   371,
     418,    -1,    14,   723,    -1,    40,   723,   726,    -1,   332,
     357,   726,    -1,    69,   723,    -1,   127,   723,    -1,   305,
     723,    -1,   309,   939,    -1,   292,   309,   939,    -1,   292,
     939,    -1,   305,   723,   355,   309,   939,    -1,   305,   723,
     355,   939,    -1,   275,   357,   936,    -1,    69,   276,   936,
      -1,   305,   276,   936,    -1,   394,    -1,   357,    -1,    -1,
     193,   204,   462,    -1,   284,   252,    -1,   284,   396,    -1,
     724,    -1,   725,   429,   724,    -1,   725,   724,    -1,   725,
      -1,    -1,    81,   502,   386,   925,   520,    31,   790,   728,
      -1,    81,   256,   295,   502,   386,   925,   520,    31,   790,
     728,    -1,   392,    59,   254,    -1,   392,    51,    59,   254,
      -1,   392,   209,    59,   254,    -1,    -1,   208,   932,    -1,
      81,    98,   928,   436,   731,    -1,   731,   732,    -1,    -1,
     347,   733,   927,    -1,   347,   733,   104,    -1,   212,   733,
     936,    -1,   212,   733,   104,    -1,   349,   733,   927,    -1,
     349,   733,   104,    -1,   125,   733,   936,    -1,   125,   733,
     935,    -1,   125,   733,   104,    -1,   199,   733,   936,    -1,
     199,   733,   104,    -1,   200,   733,   936,    -1,   200,   733,
     104,    -1,    73,   206,   733,   938,    -1,   264,   733,   927,
      -1,   264,   733,   104,    -1,   412,    -1,    -1,    24,    98,
     928,   436,   736,    -1,    24,    98,   928,   322,   347,   927,
      -1,    24,    98,   928,   468,    -1,   736,   737,    -1,    -1,
      73,   206,   733,   938,    -1,   121,    98,   928,    -1,   121,
      98,   165,   135,   928,    -1,    81,   119,   627,   741,   841,
     511,    -1,    24,   119,   627,   478,    -1,    24,   119,   627,
     121,   237,   242,    -1,    24,   119,   627,   322,   237,   242,
      -1,    24,   119,   627,    18,   518,    -1,    24,   119,   627,
     121,    74,   927,   479,    -1,    31,    -1,    -1,    24,   351,
     312,   113,   627,   600,    -1,    24,   351,   312,    72,   627,
      18,   215,   145,   926,   392,   626,    -1,    24,   351,   312,
      72,   627,    24,   215,   145,   926,   392,   626,    -1,    24,
     351,   312,    72,   627,    24,   215,   295,   627,   392,   627,
      -1,    24,   351,   312,    72,   627,    24,   215,   145,   926,
     295,   627,   392,   627,    -1,    24,   351,   312,    72,   627,
     121,   215,   145,   926,    -1,    24,   351,   312,    72,   627,
     121,   215,   165,   135,   145,   926,    -1,    81,   613,    78,
     627,   145,   936,   355,   936,   150,   627,    -1,    63,   752,
     925,   746,    -1,    63,   752,    -1,    63,   752,   931,   251,
     925,    -1,   375,   931,    -1,    -1,   376,   753,   754,   752,
      -1,   376,   753,   754,   752,   925,    -1,   376,   753,   754,
     752,   750,    -1,   376,   425,   748,   426,    -1,   376,   425,
     748,   426,   925,   755,    -1,   749,    -1,   748,   429,   749,
      -1,   751,    -1,   384,    -1,   149,    -1,   151,    -1,   751,
     752,    -1,   751,   752,   925,   755,    -1,    27,    -1,    26,
      -1,   384,    -1,    -1,   151,    -1,    -1,   149,    -1,    -1,
     425,   926,   426,    -1,    -1,   136,   757,    -1,   136,   751,
     752,   757,    -1,   136,   384,   757,    -1,   136,   425,   758,
     426,   757,    -1,   790,    -1,   768,    -1,   779,    -1,   773,
      -1,   786,    -1,   536,    -1,   765,    -1,   759,    -1,   758,
     429,   759,    -1,   760,   761,    -1,   939,    -1,   751,    -1,
     384,    -1,   463,    -1,   548,    -1,    -1,   275,   927,   763,
      31,   764,    -1,   425,   896,   426,    -1,    -1,   790,    -1,
     768,    -1,   779,    -1,   773,    -1,   134,   927,   766,    -1,
      81,   502,   345,   537,    31,   134,   927,   766,    -1,   425,
     893,   426,    -1,    -1,   100,   927,    -1,   100,   275,   927,
      -1,   100,    22,    -1,   100,   275,    22,    -1,   183,   189,
     925,   769,   772,    -1,   790,    -1,   425,   770,   426,   790,
      -1,   104,   380,    -1,   771,    -1,   770,   429,   771,    -1,
     939,   917,    -1,   300,   922,    -1,    -1,   109,   150,   835,
     774,   838,   772,    -1,   375,   826,    -1,    -1,   213,   800,
     834,   776,   778,    -1,   170,   777,   220,    -1,    -1,    16,
     324,    -1,   306,   324,    -1,   306,   133,    -1,   324,   373,
     133,    -1,   324,    -1,   324,   306,   133,    -1,   133,    -1,
      16,   133,    -1,   241,    -1,    -1,   373,   835,   322,   780,
     825,   838,   772,    -1,   781,    -1,   780,   429,   781,    -1,
     782,    -1,   783,    -1,   784,   412,   919,    -1,   425,   785,
     426,   412,   921,    -1,   939,   917,    -1,   784,    -1,   785,
     429,   784,    -1,   103,   787,   788,    95,   789,   145,   790,
      -1,   927,    -1,    -1,   788,   229,   311,    -1,   788,   311,
      -1,   788,    43,    -1,   788,   182,    -1,    -1,   392,   162,
      -1,   393,   162,    -1,   792,    -1,   791,    -1,   425,   792,
     426,    -1,   425,   791,   426,    -1,   794,    -1,   793,   804,
      -1,   793,   803,   819,   808,    -1,   793,   803,   807,   820,
      -1,   795,   793,    -1,   795,   793,   804,    -1,   795,   793,
     803,   819,   808,    -1,   795,   793,   803,   807,   820,    -1,
     794,    -1,   791,    -1,   315,   802,   922,   798,   825,   837,
     817,   818,   876,    -1,   824,    -1,   345,   833,    -1,   793,
     368,   801,   793,    -1,   793,   187,   801,   793,    -1,   793,
     130,   801,   793,    -1,   392,   796,    -1,   392,   288,   796,
      -1,   797,    -1,   796,   429,   797,    -1,   927,   755,    31,
     791,    -1,   189,   799,    -1,    -1,   350,   800,   925,    -1,
     348,   800,   925,    -1,   209,   350,   800,   925,    -1,   209,
     348,   800,   925,    -1,   154,   350,   800,   925,    -1,   154,
     348,   800,   925,    -1,   345,   925,    -1,   925,    -1,   345,
      -1,    -1,    22,    -1,   116,    -1,    -1,   116,    -1,   116,
     251,   425,   893,   426,    -1,    22,    -1,    -1,   804,    -1,
      -1,   257,    47,   805,    -1,   806,    -1,   805,   429,   806,
      -1,   865,   375,   891,   667,    -1,   865,   666,   667,    -1,
     809,   810,    -1,   810,   809,    -1,   809,    -1,   810,    -1,
     807,    -1,    -1,   206,   811,    -1,   206,   811,   429,   812,
      -1,   141,   816,   813,   815,   252,    -1,   249,   812,    -1,
     249,   814,   815,    -1,   865,    -1,    22,    -1,   865,    -1,
     938,    -1,   425,   865,   426,    -1,    -1,   867,    -1,   306,
      -1,   307,    -1,   142,    -1,   228,    -1,   158,    47,   893,
      -1,    -1,   160,   865,    -1,    -1,   821,    -1,   145,   284,
     252,    -1,   819,    -1,    -1,   822,    -1,   821,   822,    -1,
     145,   373,   823,   778,    -1,   145,   324,   823,   778,    -1,
     247,   924,    -1,    -1,   380,   921,    -1,   824,   429,   921,
      -1,   150,   826,    -1,    -1,   827,    -1,   826,   429,   827,
      -1,   833,    -1,   833,   829,    -1,   836,    -1,   836,   829,
      -1,   836,    31,   425,   839,   426,    -1,   836,    31,   939,
     425,   839,   426,    -1,   836,   939,   425,   839,   426,    -1,
     791,    -1,   791,   829,    -1,   828,    -1,   425,   828,   426,
     829,    -1,   425,   828,   426,    -1,   827,    85,   194,   827,
      -1,   827,   830,   194,   827,   832,    -1,   827,   194,   827,
     832,    -1,   827,   226,   830,   194,   827,    -1,   827,   226,
     194,   827,    -1,    31,   939,   425,   926,   426,    -1,    31,
     939,    -1,   939,   425,   926,   426,    -1,   939,    -1,   151,
     831,    -1,   203,   831,    -1,   303,   831,    -1,   179,    -1,
     259,    -1,    -1,   375,   425,   926,   426,    -1,   251,   865,
      -1,   925,    -1,   925,   418,    -1,   252,   925,    -1,   252,
     425,   925,   426,    -1,   833,    -1,   834,   429,   833,    -1,
     833,    -1,   833,   939,    -1,   833,    31,   939,    -1,   868,
      -1,   389,   865,    -1,    -1,   389,   865,    -1,   389,    87,
     247,   927,    -1,    -1,   840,    -1,   839,   429,   840,    -1,
     939,   841,    -1,   843,   842,    -1,   323,   843,   842,    -1,
     843,    30,   423,   935,   424,    -1,   323,   843,    30,   423,
     935,   424,    -1,   843,    30,    -1,   323,   843,    30,    -1,
     842,   423,   424,    -1,   842,   423,   935,   424,    -1,    -1,
     845,    -1,   847,    -1,   849,    -1,   853,    -1,   860,    -1,
     861,   863,    -1,   861,   425,   935,   426,   863,    -1,   847,
      -1,   850,    -1,   854,    -1,   860,    -1,   940,   846,    -1,
     940,   628,   846,    -1,   425,   893,   426,    -1,    -1,   185,
      -1,   186,    -1,   328,    -1,    42,    -1,   285,    -1,   143,
     848,    -1,   120,   273,    -1,   102,   846,    -1,   101,   846,
      -1,   245,   846,    -1,    45,    -1,   425,   935,   426,    -1,
      -1,   851,    -1,   852,    -1,   851,    -1,   852,    -1,    44,
     858,   425,   893,   426,    -1,    44,   858,    -1,   855,    -1,
     856,    -1,   855,    -1,   856,    -1,   857,   425,   935,   426,
     859,    -1,   857,   859,    -1,    57,   858,    -1,    56,   858,
      -1,   381,    -1,   225,    57,   858,    -1,   225,    56,   858,
      -1,   227,   858,    -1,   383,    -1,    -1,    57,   322,   939,
      -1,    -1,   354,   425,   935,   426,   862,    -1,   354,   862,
      -1,   353,   425,   935,   426,   862,    -1,   353,   862,    -1,
     188,    -1,   411,   408,    -1,   393,   353,   408,    -1,    -1,
     406,    -1,   221,    -1,    99,    -1,   163,    -1,   218,    -1,
     864,    -1,   406,   355,   221,    -1,    99,   355,   163,    -1,
      99,   355,   218,    -1,    99,   355,   864,    -1,   163,   355,
     218,    -1,   163,   355,   864,    -1,   218,   355,   864,    -1,
      -1,   313,    -1,   313,   425,   935,   426,    -1,   867,    -1,
     865,    11,   841,    -1,   865,    36,   353,   408,   865,    -1,
     416,   865,    -1,   417,   865,    -1,   865,   416,   865,    -1,
     865,   417,   865,    -1,   865,   418,   865,    -1,   865,   419,
     865,    -1,   865,   420,   865,    -1,   865,   421,   865,    -1,
     865,   413,   865,    -1,   865,   414,   865,    -1,   865,   412,
     865,    -1,   865,   890,   865,    -1,   890,   865,    -1,   865,
     890,    -1,   865,    28,   865,    -1,   865,   256,   865,    -1,
     237,   865,    -1,   865,   205,   865,    -1,   865,   205,   865,
     129,   865,    -1,   865,   237,   205,   865,    -1,   865,   237,
     205,   865,   129,   865,    -1,   865,   166,   865,    -1,   865,
     166,   865,   129,   865,    -1,   865,   237,   166,   865,    -1,
     865,   237,   166,   865,   129,   865,    -1,   865,   326,   355,
     865,    -1,   865,   326,   355,   865,   129,   865,    -1,   865,
     237,   326,   355,   865,    -1,   865,   237,   326,   355,   865,
     129,   865,    -1,   865,   191,   242,    -1,   865,   192,    -1,
     865,   191,   237,   242,    -1,   865,   240,    -1,   886,   261,
     886,    -1,   865,   191,   361,    -1,   865,   191,   237,   361,
      -1,   865,   191,   139,    -1,   865,   191,   237,   139,    -1,
     865,   191,   370,    -1,   865,   191,   237,   370,    -1,   865,
     191,   116,   150,   865,    -1,   865,   191,   237,   116,   150,
     865,    -1,   865,   191,   247,   425,   896,   426,    -1,   865,
     191,   237,   247,   425,   896,   426,    -1,   865,    41,   918,
     866,    28,   866,    -1,   865,   237,    41,   918,   866,    28,
     866,    -1,   865,    41,   342,   866,    28,   866,    -1,   865,
     237,    41,   342,   866,    28,   866,    -1,   865,   170,   908,
      -1,   865,   237,   170,   908,    -1,   865,   892,   887,   791,
      -1,   865,   892,   887,   425,   865,   426,    -1,   369,   791,
      -1,   865,   191,   118,    -1,   865,   191,   237,   118,    -1,
     867,    -1,   866,    11,   841,    -1,   416,   866,    -1,   417,
     866,    -1,   866,   416,   866,    -1,   866,   417,   866,    -1,
     866,   418,   866,    -1,   866,   419,   866,    -1,   866,   420,
     866,    -1,   866,   421,   866,    -1,   866,   413,   866,    -1,
     866,   414,   866,    -1,   866,   412,   866,    -1,   866,   890,
     866,    -1,   890,   866,    -1,   866,   890,    -1,   866,   191,
     116,   150,   866,    -1,   866,   191,   237,   116,   150,   866,
      -1,   866,   191,   247,   425,   896,   426,    -1,   866,   191,
     237,   247,   425,   896,   426,    -1,   866,   191,   118,    -1,
     866,   191,   237,   118,    -1,   914,    -1,   934,    -1,    10,
     917,    -1,   425,   865,   426,   917,    -1,   909,    -1,   868,
      -1,   791,    -1,   791,   916,    -1,   135,   791,    -1,    30,
     791,    -1,    30,   897,    -1,   886,    -1,   933,   425,   426,
     879,    -1,   933,   425,   894,   426,   879,    -1,   933,   425,
     382,   895,   426,   879,    -1,   933,   425,   894,   429,   382,
     895,   426,   879,    -1,   933,   425,   894,   804,   426,   879,
      -1,   933,   425,    22,   894,   803,   426,   879,    -1,   933,
     425,   116,   894,   803,   426,   879,    -1,   933,   425,   418,
     426,   879,    -1,    89,    -1,    92,    -1,    92,   425,   935,
     426,    -1,    93,    -1,    93,   425,   935,   426,    -1,   210,
      -1,   210,   425,   935,   426,    -1,   211,    -1,   211,   425,
     935,   426,    -1,    90,    -1,    94,    -1,   321,    -1,   374,
      -1,    88,    -1,    91,    -1,    53,   425,   865,    31,   841,
     426,    -1,   138,   425,   899,   426,    -1,   262,   425,   901,
     426,    -1,   271,   425,   903,   426,    -1,   340,   425,   904,
     426,    -1,   358,   425,   865,    31,   841,   426,    -1,   360,
     425,    46,   907,   426,    -1,   360,   425,   201,   907,   426,
      -1,   360,   425,   356,   907,   426,    -1,   360,   425,   907,
     426,    -1,   243,   425,   865,   429,   865,   426,    -1,    64,
     425,   893,   426,    -1,   157,   425,   893,   426,    -1,   202,
     425,   893,   426,    -1,   399,   425,   893,   426,    -1,   400,
     425,   223,   941,   426,    -1,   400,   425,   223,   941,   429,
     871,   426,    -1,   400,   425,   223,   941,   429,   893,   426,
      -1,   400,   425,   223,   941,   429,   871,   429,   893,   426,
      -1,   401,   425,   872,   426,    -1,   402,   425,   874,   865,
     875,   426,    -1,   403,   425,   223,   941,   426,    -1,   403,
     425,   223,   941,   429,   865,   426,    -1,   404,   425,   865,
     429,   869,   870,   426,    -1,   405,   425,   874,   865,    31,
     843,   426,    -1,   385,   865,    -1,   385,   229,   379,    -1,
     429,   331,   407,    -1,   429,   331,   229,    -1,   429,   331,
     229,   379,    -1,    -1,   398,   425,   872,   426,    -1,   873,
      -1,   872,   429,   873,    -1,   865,    31,   941,    -1,   865,
      -1,   118,    -1,    76,    -1,   274,   390,    -1,   339,   390,
      -1,    -1,   391,   877,    -1,    -1,   878,    -1,   877,   429,
     878,    -1,   939,    31,   880,    -1,   260,   880,    -1,   260,
     939,    -1,    -1,   425,   881,   882,   803,   883,   426,    -1,
     939,    -1,    -1,   267,    47,   893,    -1,    -1,   283,   884,
      -1,   307,   884,    -1,    -1,   885,    -1,    41,   885,    28,
     885,    -1,   365,   272,    -1,   365,   144,    -1,    87,   306,
      -1,   865,   272,    -1,   865,   144,    -1,   306,   425,   893,
     426,    -1,   306,   425,   426,    -1,   425,   893,   429,   865,
     426,    -1,    29,    -1,   329,    -1,    22,    -1,     8,    -1,
     889,    -1,   416,    -1,   417,    -1,   418,    -1,   419,    -1,
     420,    -1,   421,    -1,   413,    -1,   414,    -1,   412,    -1,
       8,    -1,   253,   425,   694,   426,    -1,   888,    -1,   253,
     425,   694,   426,    -1,   888,    -1,   253,   425,   694,   426,
      -1,   205,    -1,   237,   205,    -1,   166,    -1,   237,   166,
      -1,   865,    -1,   893,   429,   865,    -1,   895,    -1,   894,
     429,   895,    -1,   865,    -1,   676,    13,   865,    -1,   841,
      -1,   896,   429,   841,    -1,   423,   893,   424,    -1,   423,
     898,   424,    -1,   423,   424,    -1,   897,    -1,   898,   429,
     897,    -1,   900,   150,   865,    -1,    -1,     3,    -1,   406,
      -1,   221,    -1,    99,    -1,   163,    -1,   218,    -1,   313,
      -1,   936,    -1,   865,   902,   905,   906,    -1,   865,   902,
     905,    -1,   269,   865,    -1,   866,   170,   866,    -1,    -1,
     865,   905,   906,    -1,   865,   906,   905,    -1,   865,   905,
      -1,   865,   906,    -1,   893,    -1,    -1,   150,   865,    -1,
     145,   865,    -1,   865,   150,   893,    -1,   150,   893,    -1,
     893,    -1,   791,    -1,   425,   893,   426,    -1,    52,   913,
     910,   912,   127,    -1,   911,    -1,   910,   911,    -1,   388,
     865,   352,   865,    -1,   123,   865,    -1,    -1,   865,    -1,
      -1,   939,    -1,   939,   916,    -1,   427,   930,    -1,   427,
     418,    -1,   423,   865,   424,    -1,   423,   865,   430,   865,
     424,    -1,   915,    -1,   916,   915,    -1,    -1,   917,   915,
      -1,    35,    -1,    -1,   865,    -1,   104,    -1,   919,    -1,
     920,   429,   919,    -1,   425,   920,   426,    -1,   923,    -1,
     922,   429,   923,    -1,   865,    31,   941,    -1,   865,     3,
      -1,   865,    -1,   418,    -1,   925,    -1,   924,   429,   925,
      -1,   939,    -1,   939,   916,    -1,   927,    -1,   926,   429,
     927,    -1,   939,    -1,   939,    -1,   939,    -1,   941,    -1,
     939,    -1,   936,    -1,   940,    -1,   939,   916,    -1,   935,
      -1,     4,    -1,   936,    -1,     6,    -1,     7,    -1,   933,
     936,    -1,   933,   425,   894,   426,   936,    -1,   844,   936,
      -1,   861,   936,   863,    -1,   861,   425,   935,   426,   936,
     863,    -1,   361,    -1,   139,    -1,   242,    -1,     9,    -1,
       5,    -1,   939,    -1,   935,    -1,   416,   935,    -1,   417,
     935,    -1,     3,    -1,   942,    -1,   943,    -1,     3,    -1,
     942,    -1,   944,    -1,     3,    -1,   942,    -1,   943,    -1,
     944,    -1,   945,    -1,    14,    -1,    15,    -1,    16,    -1,
      17,    -1,    18,    -1,    19,    -1,    20,    -1,    21,    -1,
      23,    -1,    24,    -1,    25,    -1,    33,    -1,    34,    -1,
      36,    -1,    38,    -1,    39,    -1,    40,    -1,    47,    -1,
      48,    -1,    49,    -1,    50,    -1,    51,    -1,    54,    -1,
      55,    -1,    58,    -1,    60,    -1,    61,    -1,    62,    -1,
      63,    -1,    67,    -1,    68,    -1,    69,    -1,    70,    -1,
      72,    -1,    73,    -1,    75,    -1,    76,    -1,    77,    -1,
      78,    -1,    79,    -1,    80,    -1,    82,    -1,    83,    -1,
      84,    -1,    86,    -1,    87,    -1,    95,    -1,    96,    -1,
      97,    -1,    98,    -1,    99,    -1,   100,    -1,   103,    -1,
     105,    -1,   107,    -1,   108,    -1,   109,    -1,   110,    -1,
     111,    -1,   113,    -1,   114,    -1,   115,    -1,   118,    -1,
     119,    -1,   120,    -1,   121,    -1,   122,    -1,   124,    -1,
     125,    -1,   126,    -1,   128,    -1,   129,    -1,   131,    -1,
     132,    -1,   133,    -1,   134,    -1,   136,    -1,   137,    -1,
     140,    -1,   142,    -1,   144,    -1,   146,    -1,   148,    -1,
     152,    -1,   153,    -1,   154,    -1,   156,    -1,   159,    -1,
     161,    -1,   162,    -1,   163,    -1,   164,    -1,   165,    -1,
     167,    -1,   168,    -1,   169,    -1,   171,    -1,   172,    -1,
     173,    -1,   174,    -1,   175,    -1,   176,    -1,   178,    -1,
     181,    -1,   182,    -1,   183,    -1,   184,    -1,   190,    -1,
     193,    -1,   195,    -1,   196,    -1,   197,    -1,   198,    -1,
     199,    -1,   200,    -1,   204,    -1,   207,    -1,   208,    -1,
     209,    -1,   212,    -1,   213,    -1,   214,    -1,   215,    -1,
     216,    -1,   217,    -1,   218,    -1,   219,    -1,   220,    -1,
     221,    -1,   222,    -1,   223,    -1,   224,    -1,   228,    -1,
     229,    -1,   230,    -1,   231,    -1,   232,    -1,   233,    -1,
     234,    -1,   236,    -1,   238,    -1,   239,    -1,   241,    -1,
     244,    -1,   246,    -1,   247,    -1,   248,    -1,   250,    -1,
     253,    -1,   254,    -1,   255,    -1,   263,    -1,   264,    -1,
     265,    -1,   266,    -1,   267,    -1,   268,    -1,   270,    -1,
     272,    -1,   275,    -1,   276,    -1,   274,    -1,   278,    -1,
     279,    -1,   280,    -1,   281,    -1,   282,    -1,   283,    -1,
     284,    -1,   286,    -1,   287,    -1,   288,    -1,   290,    -1,
     291,    -1,   292,    -1,   293,    -1,   294,    -1,   295,    -1,
     296,    -1,   297,    -1,   298,    -1,   299,    -1,   301,    -1,
     302,    -1,   304,    -1,   305,    -1,   307,    -1,   308,    -1,
     309,    -1,   310,    -1,   311,    -1,   312,    -1,   313,    -1,
     314,    -1,   316,    -1,   317,    -1,   318,    -1,   319,    -1,
     320,    -1,   322,    -1,   324,    -1,   325,    -1,   327,    -1,
     330,    -1,   331,    -1,   332,    -1,   333,    -1,   334,    -1,
     335,    -1,   336,    -1,   337,    -1,   338,    -1,   339,    -1,
     341,    -1,   343,    -1,   344,    -1,   346,    -1,   347,    -1,
     348,    -1,   349,    -1,   350,    -1,   351,    -1,   357,    -1,
     359,    -1,   362,    -1,   363,    -1,   364,    -1,   365,    -1,
     366,    -1,   367,    -1,   370,    -1,   371,    -1,   372,    -1,
     373,    -1,   376,    -1,   377,    -1,   378,    -1,   379,    -1,
     383,    -1,   385,    -1,   386,    -1,   387,    -1,   390,    -1,
     393,    -1,   394,    -1,   395,    -1,   396,    -1,   397,    -1,
     406,    -1,   407,    -1,   408,    -1,    41,    -1,    42,    -1,
      44,    -1,    45,    -1,    56,    -1,    57,    -1,    64,    -1,
     101,    -1,   102,    -1,   135,    -1,   138,    -1,   143,    -1,
     157,    -1,   180,    -1,   185,    -1,   186,    -1,   188,    -1,
     202,    -1,   225,    -1,   227,    -1,   235,    -1,   243,    -1,
     245,    -1,   258,    -1,   262,    -1,   271,    -1,   273,    -1,
     285,    -1,   306,    -1,   323,    -1,   328,    -1,   340,    -1,
     353,    -1,   354,    -1,   358,    -1,   360,    -1,   380,    -1,
     381,    -1,   398,    -1,   399,    -1,   400,    -1,   401,    -1,
     402,    -1,   403,    -1,   404,    -1,   405,    -1,    37,    -1,
      43,    -1,    71,    -1,    85,    -1,    91,    -1,   149,    -1,
     151,    -1,   166,    -1,   179,    -1,   191,    -1,   192,    -1,
     194,    -1,   203,    -1,   205,    -1,   226,    -1,   240,    -1,
     259,    -1,   260,    -1,   261,    -1,   303,    -1,   326,    -1,
     384,    -1,    22,    -1,    26,    -1,    27,    -1,    28,    -1,
      29,    -1,    30,    -1,    31,    -1,    32,    -1,    35,    -1,
      46,    -1,    52,    -1,    53,    -1,    59,    -1,    65,    -1,
      66,    -1,    74,    -1,    81,    -1,    88,    -1,    89,    -1,
      90,    -1,    92,    -1,    93,    -1,    94,    -1,   104,    -1,
     106,    -1,   112,    -1,   116,    -1,   117,    -1,   123,    -1,
     127,    -1,   130,    -1,   139,    -1,   141,    -1,   145,    -1,
     147,    -1,   150,    -1,   155,    -1,   158,    -1,   160,    -1,
     170,    -1,   177,    -1,   187,    -1,   189,    -1,   201,    -1,
     206,    -1,   210,    -1,   211,    -1,   237,    -1,   242,    -1,
     249,    -1,   251,    -1,   252,    -1,   256,    -1,   257,    -1,
     269,    -1,   277,    -1,   289,    -1,   300,    -1,   315,    -1,
     321,    -1,   329,    -1,   342,    -1,   345,    -1,   352,    -1,
     355,    -1,   356,    -1,   361,    -1,   368,    -1,   369,    -1,
     374,    -1,   375,    -1,   382,    -1,   388,    -1,   389,    -1,
     391,    -1,   392,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   623,   623,   630,   637,   647,   648,   649,   650,   651,
     652,   653,   654,   655,   656,   657,   658,   659,   660,   661,
     662,   663,   664,   665,   666,   667,   668,   669,   670,   671,
     672,   673,   674,   675,   676,   677,   678,   679,   680,   681,
     682,   683,   684,   685,   686,   687,   688,   689,   690,   691,
     692,   693,   694,   695,   696,   697,   698,   699,   700,   701,
     702,   703,   704,   705,   706,   707,   708,   709,   710,   711,
     712,   713,   714,   715,   716,   717,   718,   719,   720,   721,
     722,   723,   724,   725,   726,   727,   728,   729,   730,   731,
     732,   733,   734,   735,   736,   737,   738,   739,   740,   741,
     742,   743,   744,   745,   746,   747,   748,   750,   760,   771,
     772,   781,   782,   786,   787,   791,   796,   800,   805,   810,
     814,   818,   822,   826,   830,   834,   838,   842,   847,   851,
     855,   859,   863,   868,   875,   877,   881,   885,   889,   893,
     907,   925,   936,   937,   941,   959,   971,   992,   999,  1018,
    1025,  1042,  1060,  1071,  1072,  1084,  1091,  1108,  1120,  1132,
    1133,  1137,  1138,  1146,  1147,  1148,  1149,  1150,  1151,  1165,
    1171,  1177,  1186,  1194,  1202,  1209,  1216,  1224,  1235,  1243,
    1251,  1259,  1267,  1278,  1286,  1294,  1301,  1311,  1312,  1319,
    1320,  1323,  1325,  1329,  1330,  1331,  1332,  1336,  1337,  1338,
    1344,  1356,  1360,  1364,  1379,  1402,  1403,  1404,  1408,  1409,
    1410,  1414,  1415,  1419,  1426,  1433,  1440,  1447,  1457,  1458,
    1463,  1469,  1475,  1481,  1487,  1497,  1507,  1508,  1512,  1513,
    1521,  1536,  1542,  1548,  1554,  1572,  1580,  1588,  1596,  1607,
    1608,  1613,  1621,  1629,  1638,  1646,  1654,  1663,  1672,  1681,
    1690,  1700,  1713,  1723,  1731,  1741,  1751,  1758,  1765,  1773,
    1781,  1789,  1797,  1805,  1812,  1819,  1827,  1834,  1841,  1849,
    1857,  1865,  1873,  1881,  1889,  1897,  1905,  1913,  1923,  1924,
    1928,  1929,  1930,  1934,  1935,  1939,  1942,  1943,  1947,  1948,
    1953,  1957,  1961,  1966,  1981,  1987,  2014,  2036,  2050,  2051,
    2060,  2061,  2062,  2065,  2066,  2071,  2072,  2076,  2080,  2084,
    2088,  2092,  2096,  2100,  2104,  2108,  2112,  2116,  2125,  2129,
    2133,  2137,  2141,  2145,  2149,  2150,  2155,  2159,  2166,  2173,
    2174,  2175,  2176,  2177,  2181,  2185,  2193,  2204,  2218,  2242,
    2243,  2244,  2245,  2246,  2247,  2248,  2252,  2253,  2257,  2258,
    2262,  2266,  2273,  2277,  2284,  2285,  2286,  2290,  2291,  2294,
    2305,  2316,  2317,  2321,  2329,  2330,  2349,  2356,  2363,  2373,
    2383,  2392,  2401,  2430,  2437,  2444,  2451,  2470,  2480,  2481,
    2482,  2486,  2487,  2488,  2489,  2490,  2491,  2500,  2508,  2512,
    2526,  2539,  2552,  2568,  2588,  2589,  2593,  2594,  2597,  2603,
    2607,  2615,  2620,  2626,  2627,  2631,  2636,  2643,  2644,  2654,
    2656,  2658,  2660,  2663,  2666,  2669,  2673,  2674,  2675,  2676,
    2677,  2680,  2681,  2686,  2687,  2688,  2689,  2692,  2693,  2694,
    2695,  2698,  2699,  2702,  2703,  2713,  2738,  2750,  2751,  2755,
    2756,  2760,  2776,  2777,  2778,  2791,  2803,  2812,  2813,  2816,
    2817,  2820,  2824,  2828,  2832,  2836,  2840,  2844,  2848,  2852,
    2856,  2860,  2864,  2870,  2871,  2875,  2876,  2881,  2884,  2885,
    2897,  2909,  2924,  2925,  2933,  2934,  2938,  2939,  2943,  2944,
    2948,  2949,  2953,  2961,  2972,  2973,  2983,  2993,  2994,  3007,
    3014,  3030,  3047,  3055,  3072,  3081,  3089,  3100,  3101,  3105,
    3109,  3117,  3121,  3125,  3132,  3136,  3141,  3146,  3153,  3160,
    3165,  3175,  3189,  3190,  3195,  3196,  3200,  3201,  3211,  3219,
    3236,  3245,  3253,  3269,  3281,  3282,  3283,  3293,  3301,  3318,
    3337,  3357,  3381,  3382,  3386,  3388,  3410,  3412,  3414,  3416,
    3418,  3423,  3428,  3438,  3439,  3443,  3444,  3448,  3449,  3453,
    3454,  3455,  3459,  3465,  3466,  3467,  3468,  3469,  3473,  3474,
    3478,  3480,  3489,  3496,  3506,  3510,  3511,  3515,  3516,  3521,
    3531,  3553,  3572,  3595,  3605,  3616,  3626,  3636,  3647,  3683,
    3690,  3699,  3708,  3717,  3728,  3731,  3732,  3735,  3739,  3746,
    3747,  3748,  3749,  3750,  3753,  3754,  3757,  3760,  3761,  3769,
    3776,  3777,  3780,  3782,  3799,  3814,  3815,  3819,  3828,  3837,
    3846,  3856,  3865,  3866,  3869,  3870,  3873,  3887,  3892,  3902,
    3911,  3923,  3924,  3928,  3936,  3948,  3957,  3969,  3978,  3999,
    4009,  4027,  4036,  4048,  4049,  4050,  4051,  4052,  4053,  4054,
    4055,  4056,  4057,  4058,  4059,  4063,  4064,  4067,  4068,  4071,
    4073,  4086,  4097,  4098,  4099,  4124,  4133,  4142,  4151,  4160,
    4169,  4178,  4188,  4197,  4206,  4215,  4224,  4233,  4242,  4250,
    4258,  4266,  4277,  4278,  4279,  4280,  4281,  4282,  4283,  4284,
    4285,  4286,  4287,  4288,  4292,  4293,  4303,  4309,  4317,  4325,
    4333,  4341,  4349,  4357,  4365,  4373,  4381,  4389,  4397,  4405,
    4413,  4421,  4429,  4437,  4447,  4448,  4451,  4452,  4462,  4478,
    4492,  4518,  4520,  4522,  4524,  4531,  4540,  4541,  4544,  4551,
    4558,  4565,  4579,  4587,  4595,  4603,  4611,  4619,  4627,  4635,
    4643,  4651,  4659,  4667,  4675,  4683,  4695,  4696,  4699,  4709,
    4723,  4724,  4728,  4729,  4734,  4750,  4763,  4773,  4785,  4786,
    4789,  4790,  4800,  4810,  4811,  4815,  4819,  4823,  4834,  4847,
    4861,  4878,  4879,  4880,  4892,  4911,  4912,  4916,  4917,  4921,
    4922,  4926,  4927,  4930,  4931,  4939,  4949,  4959,  4971,  4972,
    4973,  4976,  4977,  4978,  4981,  4982,  4983,  4999,  5011,  5024,
    5039,  5040,  5043,  5044,  5048,  5049,  5057,  5058,  5062,  5063,
    5078,  5087,  5096,  5105,  5114,  5126,  5127,  5128,  5129,  5130,
    5136,  5140,  5155,  5156,  5162,  5172,  5176,  5181,  5191,  5192,
    5199,  5203,  5207,  5211,  5215,  5219,  5223,  5227,  5231,  5235,
    5239,  5243,  5247,  5255,  5259,  5263,  5267,  5273,  5274,  5281,
    5282,  5285,  5297,  5301,  5316,  5327,  5328,  5333,  5334,  5349,
    5359,  5372,  5382,  5395,  5405,  5418,  5426,  5428,  5430,  5435,
    5437,  5450,  5459,  5460,  5464,  5468,  5480,  5491,  5502,  5515,
    5516,  5517,  5521,  5532,  5533,  5547,  5555,  5565,  5578,  5579,
    5582,  5583,  5593,  5602,  5610,  5618,  5627,  5635,  5643,  5652,
    5661,  5669,  5678,  5687,  5696,  5705,  5714,  5723,  5731,  5739,
    5747,  5756,  5765,  5773,  5781,  5789,  5797,  5807,  5808,  5811,
    5812,  5822,  5831,  5839,  5848,  5856,  5864,  5872,  5888,  5897,
    5905,  5913,  5921,  5930,  5938,  5946,  5955,  5964,  5973,  5981,
    5989,  5997,  6005,  6013,  6021,  6038,  6055,  6056,  6057,  6062,
    6068,  6077,  6078,  6079,  6080,  6081,  6085,  6086,  6089,  6090,
    6091,  6092,  6096,  6097,  6098,  6103,  6113,  6134,  6144,  6145,
    6148,  6157,  6163,  6182,  6189,  6196,  6203,  6210,  6217,  6224,
    6232,  6240,  6248,  6256,  6264,  6271,  6278,  6287,  6288,  6289,
    6293,  6296,  6299,  6306,  6308,  6310,  6315,  6317,  6329,  6340,
    6354,  6360,  6366,  6372,  6382,  6398,  6408,  6409,  6413,  6417,
    6421,  6425,  6429,  6433,  6437,  6441,  6445,  6449,  6453,  6457,
    6461,  6465,  6469,  6473,  6483,  6484,  6495,  6502,  6513,  6524,
    6525,  6529,  6543,  6550,  6567,  6579,  6588,  6596,  6604,  6613,
    6624,  6625,  6636,  6646,  6656,  6666,  6676,  6686,  6694,  6715,
    6738,  6746,  6755,  6766,  6767,  6779,  6793,  6807,  6819,  6831,
    6848,  6849,  6853,  6854,  6855,  6856,  6860,  6872,  6887,  6888,
    6892,  6893,  6896,  6897,  6900,  6901,  6905,  6906,  6919,  6926,
    6936,  6943,  6953,  6954,  6955,  6956,  6957,  6958,  6959,  6963,
    6967,  6974,  6981,  6982,  6983,  6987,  6988,  6989,  6999,  7009,
    7010,  7014,  7015,  7016,  7017,  7027,  7035,  7052,  7053,  7063,
    7069,  7075,  7081,  7097,  7106,  7112,  7118,  7127,  7129,  7134,
    7145,  7146,  7157,  7170,  7171,  7182,  7193,  7194,  7197,  7198,
    7199,  7200,  7201,  7202,  7203,  7204,  7207,  7208,  7219,  7236,
    7237,  7241,  7242,  7246,  7254,  7282,  7293,  7294,  7304,  7315,
    7318,  7319,  7320,  7321,  7322,  7325,  7326,  7327,  7375,  7376,
    7380,  7381,  7395,  7396,  7403,  7411,  7419,  7427,  7435,  7443,
    7454,  7455,  7482,  7497,  7498,  7517,  7521,  7525,  7540,  7547,
    7557,  7558,  7561,  7573,  7583,  7591,  7596,  7601,  7606,  7611,
    7616,  7621,  7626,  7633,  7634,  7637,  7638,  7639,  7646,  7647,
    7648,  7649,  7653,  7654,  7658,  7662,  7663,  7666,  7675,  7688,
    7689,  7690,  7691,  7695,  7696,  7700,  7702,  7712,  7717,  7720,
    7725,  7726,  7734,  7744,  7745,  7746,  7754,  7758,  7759,  7762,
    7763,  7768,  7769,  7773,  7774,  7778,  7779,  7783,  7784,  7788,
    7789,  7793,  7801,  7812,  7813,  7818,  7824,  7842,  7843,  7847,
    7848,  7858,  7862,  7867,  7874,  7882,  7889,  7899,  7909,  7937,
    7944,  7948,  7974,  7978,  7990,  8003,  8017,  8028,  8043,  8049,
    8054,  8060,  8067,  8068,  8069,  8070,  8074,  8075,  8087,  8088,
    8093,  8100,  8107,  8114,  8125,  8126,  8139,  8143,  8150,  8160,
    8165,  8166,  8171,  8172,  8180,  8185,  8189,  8195,  8216,  8221,
    8228,  8233,  8239,  8244,  8253,  8255,  8258,  8262,  8263,  8264,
    8265,  8266,  8267,  8272,  8302,  8303,  8304,  8305,  8316,  8322,
    8330,  8331,  8337,  8342,  8347,  8352,  8357,  8362,  8367,  8372,
    8378,  8384,  8390,  8397,  8419,  8428,  8432,  8440,  8444,  8452,
    8464,  8485,  8489,  8495,  8499,  8512,  8531,  8554,  8556,  8558,
    8560,  8562,  8564,  8569,  8570,  8574,  8575,  8582,  8591,  8599,
    8608,  8619,  8627,  8628,  8629,  8633,  8635,  8637,  8639,  8641,
    8643,  8645,  8650,  8655,  8661,  8669,  8674,  8681,  8688,  8692,
    8696,  8726,  8727,  8729,  8751,  8753,  8755,  8757,  8759,  8761,
    8763,  8765,  8767,  8769,  8771,  8774,  8776,  8778,  8781,  8783,
    8785,  8788,  8790,  8803,  8805,  8818,  8820,  8833,  8835,  8849,
    8862,  8875,  8888,  8911,  8918,  8925,  8932,  8939,  8943,  8950,
    8957,  8964,  8971,  8978,  8985,  8989,  8997,  9001,  9011,  9018,
    9025,  9038,  9051,  9070,  9091,  9101,  9108,  9124,  9129,  9147,
    9149,  9151,  9153,  9155,  9157,  9159,  9161,  9163,  9165,  9167,
    9169,  9171,  9173,  9175,  9177,  9179,  9183,  9188,  9192,  9196,
    9201,  9218,  9219,  9220,  9235,  9247,  9249,  9251,  9261,  9284,
    9294,  9304,  9312,  9330,  9343,  9356,  9369,  9382,  9395,  9412,
    9425,  9448,  9469,  9479,  9492,  9509,  9522,  9532,  9545,  9555,
    9568,  9581,  9594,  9607,  9620,  9633,  9646,  9648,  9661,  9679,
    9693,  9709,  9731,  9747,  9760,  9773,  9786,  9790,  9797,  9805,
    9813,  9817,  9821,  9825,  9829,  9833,  9837,  9846,  9850,  9854,
    9859,  9873,  9875,  9879,  9881,  9883,  9886,  9889,  9892,  9893,
    9896,  9904,  9914,  9915,  9918,  9919,  9920,  9927,  9928,  9932,
    9933,  9938,  9946,  9948,  9962,  9965,  9992,  9993,  9996,  9997,
   10008, 10026, 10033, 10042, 10059, 10104, 10112, 10120, 10128, 10136,
   10157, 10158, 10159, 10162, 10163, 10164, 10167, 10168, 10171, 10172,
   10173, 10174, 10175, 10176, 10177, 10178, 10179, 10182, 10184, 10189,
   10191, 10196, 10198, 10200, 10202, 10204, 10206, 10218, 10222, 10229,
   10233, 10239, 10243, 10254, 10255, 10258, 10262, 10266, 10272, 10273,
   10278, 10282, 10289, 10290, 10291, 10292, 10293, 10294, 10295, 10296,
   10306, 10310, 10317, 10324, 10325, 10341, 10345, 10350, 10354, 10369,
   10374, 10378, 10381, 10384, 10385, 10386, 10389, 10396, 10406, 10420,
   10421, 10425, 10436, 10437, 10440, 10441, 10444, 10448, 10455, 10459,
   10463, 10470, 10480, 10481, 10485, 10486, 10489, 10490, 10501, 10502,
   10511, 10512, 10520, 10531, 10532, 10535, 10551, 10559, 10567, 10589,
   10590, 10601, 10609, 10637, 10639, 10644, 10647, 10650, 10652, 10654,
   10656, 10666, 10668, 10679, 10683, 10687, 10691, 10695, 10704, 10711,
   10736, 10740, 10746, 10763, 10767, 10771, 10777, 10778, 10779, 10781,
   10782, 10783, 10799, 10800, 10801, 10806, 10807, 10808, 10814, 10815,
   10816, 10817, 10818, 10838, 10839, 10840, 10841, 10842, 10843, 10844,
   10845, 10846, 10847, 10848, 10849, 10850, 10851, 10852, 10853, 10854,
   10855, 10856, 10857, 10858, 10859, 10860, 10861, 10862, 10863, 10864,
   10865, 10866, 10867, 10868, 10869, 10870, 10871, 10872, 10873, 10874,
   10875, 10876, 10877, 10878, 10879, 10880, 10881, 10882, 10883, 10884,
   10885, 10886, 10887, 10888, 10889, 10890, 10891, 10892, 10893, 10894,
   10895, 10896, 10897, 10898, 10899, 10900, 10901, 10902, 10903, 10904,
   10905, 10906, 10907, 10908, 10909, 10910, 10911, 10912, 10913, 10914,
   10915, 10916, 10917, 10918, 10919, 10920, 10921, 10922, 10923, 10924,
   10925, 10926, 10927, 10928, 10929, 10930, 10931, 10932, 10933, 10934,
   10935, 10936, 10937, 10938, 10939, 10940, 10941, 10942, 10943, 10944,
   10945, 10946, 10947, 10948, 10949, 10950, 10951, 10952, 10953, 10954,
   10955, 10956, 10957, 10958, 10959, 10960, 10961, 10962, 10963, 10964,
   10965, 10966, 10967, 10968, 10969, 10970, 10971, 10972, 10973, 10974,
   10975, 10976, 10977, 10978, 10979, 10980, 10981, 10982, 10983, 10984,
   10985, 10986, 10987, 10988, 10989, 10990, 10991, 10992, 10993, 10994,
   10995, 10996, 10997, 10998, 10999, 11000, 11001, 11002, 11003, 11004,
   11005, 11006, 11007, 11008, 11009, 11010, 11011, 11012, 11013, 11014,
   11015, 11016, 11017, 11018, 11019, 11020, 11021, 11022, 11023, 11024,
   11025, 11026, 11027, 11028, 11029, 11030, 11031, 11032, 11033, 11034,
   11035, 11036, 11037, 11038, 11039, 11040, 11041, 11042, 11043, 11044,
   11045, 11046, 11047, 11048, 11049, 11050, 11051, 11052, 11053, 11054,
   11055, 11056, 11057, 11058, 11059, 11060, 11061, 11062, 11063, 11064,
   11065, 11066, 11067, 11068, 11069, 11070, 11071, 11072, 11073, 11074,
   11075, 11076, 11077, 11078, 11079, 11080, 11081, 11082, 11083, 11084,
   11085, 11086, 11087, 11088, 11102, 11103, 11104, 11105, 11106, 11107,
   11108, 11109, 11110, 11111, 11112, 11113, 11114, 11115, 11116, 11117,
   11118, 11119, 11120, 11121, 11122, 11123, 11124, 11125, 11126, 11127,
   11128, 11129, 11130, 11131, 11132, 11133, 11134, 11135, 11136, 11137,
   11138, 11139, 11140, 11141, 11142, 11143, 11144, 11145, 11146, 11147,
   11161, 11162, 11163, 11164, 11165, 11166, 11167, 11168, 11169, 11170,
   11171, 11172, 11173, 11174, 11175, 11176, 11177, 11178, 11179, 11180,
   11181, 11182, 11192, 11193, 11194, 11195, 11196, 11197, 11198, 11199,
   11200, 11201, 11202, 11203, 11204, 11205, 11206, 11207, 11208, 11209,
   11210, 11211, 11212, 11213, 11214, 11215, 11216, 11217, 11218, 11219,
   11220, 11221, 11222, 11223, 11224, 11225, 11226, 11227, 11228, 11229,
   11230, 11231, 11232, 11233, 11234, 11235, 11236, 11237, 11238, 11239,
   11240, 11241, 11242, 11243, 11244, 11245, 11246, 11247, 11248, 11249,
   11250, 11251, 11252, 11253, 11254, 11255, 11256, 11257, 11258, 11259,
   11260, 11261, 11262, 11263, 11264, 11265, 11266, 11267
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "IDENT", "FCONST", "SCONST", "BCONST",
  "XCONST", "Op", "ICONST", "PARAM", "TYPECAST", "DOT_DOT", "COLON_EQUALS",
  "ABORT_P", "ABSOLUTE_P", "ACCESS", "ACTION", "ADD_P", "ADMIN", "AFTER",
  "AGGREGATE", "ALL", "ALSO", "ALTER", "ALWAYS", "ANALYSE", "ANALYZE",
  "AND", "ANY", "ARRAY", "AS", "ASC", "ASSERTION", "ASSIGNMENT",
  "ASYMMETRIC", "AT", "AUTHORIZATION", "BACKWARD", "BEFORE", "BEGIN_P",
  "BETWEEN", "BIGINT", "BINARY", "BIT", "BOOLEAN_P", "BOTH", "BY", "CACHE",
  "CALLED", "CASCADE", "CASCADED", "CASE", "CAST", "CATALOG_P", "CHAIN",
  "CHAR_P", "CHARACTER", "CHARACTERISTICS", "CHECK", "CHECKPOINT", "CLASS",
  "CLOSE", "CLUSTER", "COALESCE", "COLLATE", "COLUMN", "COMMENT",
  "COMMENTS", "COMMIT", "COMMITTED", "CONCURRENTLY", "CONFIGURATION",
  "CONNECTION", "CONSTRAINT", "CONSTRAINTS", "CONTENT_P", "CONTINUE_P",
  "CONVERSION_P", "COPY", "COST", "CREATE", "CREATEDB", "CREATEROLE",
  "CREATEUSER", "CROSS", "CSV", "CURRENT_P", "CURRENT_CATALOG",
  "CURRENT_DATE", "CURRENT_ROLE", "CURRENT_SCHEMA", "CURRENT_TIME",
  "CURRENT_TIMESTAMP", "CURRENT_USER", "CURSOR", "CYCLE", "DATA_P",
  "DATABASE", "DAY_P", "DEALLOCATE", "DEC", "DECIMAL_P", "DECLARE",
  "DEFAULT", "DEFAULTS", "DEFERRABLE", "DEFERRED", "DEFINER", "DELETE_P",
  "DELIMITER", "DELIMITERS", "DESC", "DICTIONARY", "DISABLE_P", "DISCARD",
  "DISTINCT", "DO", "DOCUMENT_P", "DOMAIN_P", "DOUBLE_P", "DROP", "EACH",
  "ELSE", "ENABLE_P", "ENCODING", "ENCRYPTED", "END_P", "ENUM_P", "ESCAPE",
  "EXCEPT", "EXCLUDE", "EXCLUDING", "EXCLUSIVE", "EXECUTE", "EXISTS",
  "EXPLAIN", "EXTERNAL", "EXTRACT", "FALSE_P", "FAMILY", "FETCH",
  "FIRST_P", "FLOAT_P", "FOLLOWING", "FOR", "FORCE", "FOREIGN", "FORWARD",
  "FREEZE", "FROM", "FULL", "FUNCTION", "FUNCTIONS", "GLOBAL", "GRANT",
  "GRANTED", "GREATEST", "GROUP_P", "HANDLER", "HAVING", "HEADER_P",
  "HOLD", "HOUR_P", "IDENTITY_P", "IF_P", "ILIKE", "IMMEDIATE",
  "IMMUTABLE", "IMPLICIT_P", "IN_P", "INCLUDING", "INCREMENT", "INDEX",
  "INDEXES", "INHERIT", "INHERITS", "INITIALLY", "INLINE_P", "INNER_P",
  "INOUT", "INPUT_P", "INSENSITIVE", "INSERT", "INSTEAD", "INT_P",
  "INTEGER", "INTERSECT", "INTERVAL", "INTO", "INVOKER", "IS", "ISNULL",
  "ISOLATION", "JOIN", "KEY", "LANGUAGE", "LARGE_P", "LAST_P",
  "LC_COLLATE_P", "LC_CTYPE_P", "LEADING", "LEAST", "LEFT", "LEVEL",
  "LIKE", "LIMIT", "LISTEN", "LOAD", "LOCAL", "LOCALTIME",
  "LOCALTIMESTAMP", "LOCATION", "LOCK_P", "LOGIN_P", "MAPPING", "MATCH",
  "MAXVALUE", "MINUTE_P", "MINVALUE", "MODE", "MONTH_P", "MOVE", "NAME_P",
  "NAMES", "NATIONAL", "NATURAL", "NCHAR", "NEXT", "NO", "NOCREATEDB",
  "NOCREATEROLE", "NOCREATEUSER", "NOINHERIT", "NOLOGIN_P", "NONE",
  "NOSUPERUSER", "NOT", "NOTHING", "NOTIFY", "NOTNULL", "NOWAIT", "NULL_P",
  "NULLIF", "NULLS_P", "NUMERIC", "OBJECT_P", "OF", "OFF", "OFFSET",
  "OIDS", "ON", "ONLY", "OPERATOR", "OPTION", "OPTIONS", "OR", "ORDER",
  "OUT_P", "OUTER_P", "OVER", "OVERLAPS", "OVERLAY", "OWNED", "OWNER",
  "PARSER", "PARTIAL", "PARTITION", "PASSWORD", "PLACING", "PLANS",
  "POSITION", "PRECEDING", "PRECISION", "PRESERVE", "PREPARE", "PREPARED",
  "PRIMARY", "PRIOR", "PRIVILEGES", "PROCEDURAL", "PROCEDURE", "QUOTE",
  "RANGE", "READ", "REAL", "REASSIGN", "RECHECK", "RECURSIVE",
  "REFERENCES", "REINDEX", "RELATIVE_P", "RELEASE", "RENAME", "REPEATABLE",
  "REPLACE", "REPLICA", "RESET", "RESTART", "RESTRICT", "RETURNING",
  "RETURNS", "REVOKE", "RIGHT", "ROLE", "ROLLBACK", "ROW", "ROWS", "RULE",
  "SAVEPOINT", "SCHEMA", "SCROLL", "SEARCH", "SECOND_P", "SECURITY",
  "SELECT", "SEQUENCE", "SEQUENCES", "SERIALIZABLE", "SERVER", "SESSION",
  "SESSION_USER", "SET", "SETOF", "SHARE", "SHOW", "SIMILAR", "SIMPLE",
  "SMALLINT", "SOME", "STABLE", "STANDALONE_P", "START", "STATEMENT",
  "STATISTICS", "STDIN", "STDOUT", "STORAGE", "STRICT_P", "STRIP_P",
  "SUBSTRING", "SUPERUSER_P", "SYMMETRIC", "SYSID", "SYSTEM_P", "TABLE",
  "TABLES", "TABLESPACE", "TEMP", "TEMPLATE", "TEMPORARY", "TEXT_P",
  "THEN", "TIME", "TIMESTAMP", "TO", "TRAILING", "TRANSACTION", "TREAT",
  "TRIGGER", "TRIM", "TRUE_P", "TRUNCATE", "TRUSTED", "TYPE_P",
  "UNBOUNDED", "UNCOMMITTED", "UNENCRYPTED", "UNION", "UNIQUE", "UNKNOWN",
  "UNLISTEN", "UNTIL", "UPDATE", "USER", "USING", "VACUUM", "VALID",
  "VALIDATOR", "VALUE_P", "VALUES", "VARCHAR", "VARIADIC", "VARYING",
  "VERBOSE", "VERSION_P", "VIEW", "VOLATILE", "WHEN", "WHERE",
  "WHITESPACE_P", "WINDOW", "WITH", "WITHOUT", "WORK", "WRAPPER", "WRITE",
  "XML_P", "XMLATTRIBUTES", "XMLCONCAT", "XMLELEMENT", "XMLFOREST",
  "XMLPARSE", "XMLPI", "XMLROOT", "XMLSERIALIZE", "YEAR_P", "YES_P",
  "ZONE", "NULLS_FIRST", "NULLS_LAST", "WITH_TIME", "'='", "'<'", "'>'",
  "POSTFIXOP", "'+'", "'-'", "'*'", "'/'", "'%'", "'^'", "UMINUS", "'['",
  "']'", "'('", "')'", "'.'", "';'", "','", "':'", "$accept", "stmtblock",
  "stmtmulti", "stmt", "CreateRoleStmt", "opt_with", "OptRoleList",
  "AlterOptRoleList", "AlterOptRoleElem", "CreateOptRoleElem",
  "CreateUserStmt", "AlterRoleStmt", "opt_in_database", "AlterRoleSetStmt",
  "AlterUserStmt", "AlterUserSetStmt", "DropRoleStmt", "DropUserStmt",
  "CreateGroupStmt", "AlterGroupStmt", "add_drop", "DropGroupStmt",
  "CreateSchemaStmt", "OptSchemaName", "OptSchemaEltList", "schema_stmt",
  "VariableSetStmt", "set_rest", "var_name", "var_list", "var_value",
  "iso_level", "opt_boolean_or_string", "zone_value", "opt_encoding",
  "ColId_or_Sconst", "VariableResetStmt", "SetResetClause",
  "VariableShowStmt", "ConstraintsSetStmt", "constraints_set_list",
  "constraints_set_mode", "CheckPointStmt", "DiscardStmt",
  "AlterTableStmt", "alter_table_cmds", "alter_table_cmd",
  "alter_column_default", "opt_drop_behavior", "alter_using", "reloptions",
  "opt_reloptions", "reloption_list", "reloption_elem", "ClosePortalStmt",
  "CopyStmt", "copy_from", "copy_file_name", "copy_options",
  "copy_opt_list", "copy_opt_item", "opt_binary", "opt_oids",
  "copy_delimiter", "opt_using", "copy_generic_opt_list",
  "copy_generic_opt_elem", "copy_generic_opt_arg",
  "copy_generic_opt_arg_list", "copy_generic_opt_arg_list_item",
  "CreateStmt", "OptTemp", "OptTableElementList",
  "OptTypedTableElementList", "TableElementList", "TypedTableElementList",
  "TableElement", "TypedTableElement", "columnDef", "columnOptions",
  "ColQualList", "ColConstraint", "ColConstraintElem", "ConstraintAttr",
  "TableLikeClause", "TableLikeOptionList", "TableLikeOption",
  "TableConstraint", "ConstraintElem", "opt_column_list", "columnList",
  "columnElem", "key_match", "ExclusionConstraintList",
  "ExclusionConstraintElem", "ExclusionWhereClause", "key_actions",
  "key_update", "key_delete", "key_action", "OptInherit", "OptWith",
  "OnCommitOption", "OptTableSpace", "OptConsTableSpace", "CreateAsStmt",
  "create_as_target", "OptCreateAs", "CreateAsList", "CreateAsElement",
  "opt_with_data", "CreateSeqStmt", "AlterSeqStmt", "OptSeqOptList",
  "SeqOptList", "SeqOptElem", "opt_by", "NumericOnly", "NumericOnly_list",
  "CreatePLangStmt", "opt_trusted", "handler_name", "opt_inline_handler",
  "validator_clause", "opt_validator", "DropPLangStmt", "opt_procedural",
  "CreateTableSpaceStmt", "OptTableSpaceOwner", "DropTableSpaceStmt",
  "CreateFdwStmt", "DropFdwStmt", "AlterFdwStmt", "create_generic_options",
  "generic_option_list", "alter_generic_options",
  "alter_generic_option_list", "alter_generic_option_elem",
  "generic_option_elem", "generic_option_name", "generic_option_arg",
  "CreateForeignServerStmt", "opt_type", "foreign_server_version",
  "opt_foreign_server_version", "DropForeignServerStmt",
  "AlterForeignServerStmt", "CreateUserMappingStmt", "auth_ident",
  "DropUserMappingStmt", "AlterUserMappingStmt", "CreateTrigStmt",
  "TriggerActionTime", "TriggerEvents", "TriggerOneEvent",
  "TriggerForSpec", "TriggerForOpt", "TriggerForType", "TriggerWhen",
  "TriggerFuncArgs", "TriggerFuncArg", "OptConstrFromTable",
  "ConstraintAttributeSpec", "ConstraintDeferrabilitySpec",
  "ConstraintTimeSpec", "DropTrigStmt", "CreateAssertStmt",
  "DropAssertStmt", "DefineStmt", "definition", "def_list", "def_elem",
  "def_arg", "aggr_args", "old_aggr_definition", "old_aggr_list",
  "old_aggr_elem", "opt_enum_val_list", "enum_val_list",
  "CreateOpClassStmt", "opclass_item_list", "opclass_item", "opt_default",
  "opt_opfamily", "opt_recheck", "CreateOpFamilyStmt", "AlterOpFamilyStmt",
  "opclass_drop_list", "opclass_drop", "DropOpClassStmt",
  "DropOpFamilyStmt", "DropOwnedStmt", "ReassignOwnedStmt", "DropStmt",
  "drop_type", "any_name_list", "any_name", "attrs", "TruncateStmt",
  "opt_restart_seqs", "CommentStmt", "comment_type", "comment_text",
  "FetchStmt", "fetch_args", "from_in", "opt_from_in", "GrantStmt",
  "RevokeStmt", "privileges", "privilege_list", "privilege",
  "privilege_target", "grantee_list", "grantee", "opt_grant_grant_option",
  "function_with_argtypes_list", "function_with_argtypes", "GrantRoleStmt",
  "RevokeRoleStmt", "opt_grant_admin_option", "opt_granted_by",
  "AlterDefaultPrivilegesStmt", "DefACLOptionList", "DefACLOption",
  "DefACLAction", "defacl_privilege_target", "IndexStmt", "opt_unique",
  "opt_concurrently", "opt_index_name", "access_method_clause",
  "index_params", "index_elem", "opt_class", "opt_asc_desc",
  "opt_nulls_order", "CreateFunctionStmt", "opt_or_replace", "func_args",
  "func_args_list", "func_args_with_defaults",
  "func_args_with_defaults_list", "func_arg", "arg_class", "param_name",
  "func_return", "func_type", "func_arg_with_default",
  "createfunc_opt_list", "common_func_opt_item", "createfunc_opt_item",
  "func_as", "opt_definition", "table_func_column",
  "table_func_column_list", "AlterFunctionStmt", "alterfunc_opt_list",
  "opt_restrict", "RemoveFuncStmt", "RemoveAggrStmt", "RemoveOperStmt",
  "oper_argtypes", "any_operator", "DoStmt", "dostmt_opt_list",
  "dostmt_opt_item", "CreateCastStmt", "cast_context", "DropCastStmt",
  "opt_if_exists", "ReindexStmt", "reindex_type", "opt_force",
  "RenameStmt", "opt_column", "opt_set_data", "AlterObjectSchemaStmt",
  "AlterOwnerStmt", "RuleStmt", "RuleActionList", "RuleActionMulti",
  "RuleActionStmt", "RuleActionStmtOrEmpty", "event", "opt_instead",
  "DropRuleStmt", "NotifyStmt", "notify_payload", "ListenStmt",
  "UnlistenStmt", "TransactionStmt", "opt_transaction",
  "transaction_mode_item", "transaction_mode_list",
  "transaction_mode_list_or_empty", "ViewStmt", "opt_check_option",
  "LoadStmt", "CreatedbStmt", "createdb_opt_list", "createdb_opt_item",
  "opt_equal", "AlterDatabaseStmt", "AlterDatabaseSetStmt",
  "alterdb_opt_list", "alterdb_opt_item", "DropdbStmt", "CreateDomainStmt",
  "AlterDomainStmt", "opt_as", "AlterTSDictionaryStmt",
  "AlterTSConfigurationStmt", "CreateConversionStmt", "ClusterStmt",
  "cluster_index_specification", "VacuumStmt", "vacuum_option_list",
  "vacuum_option_elem", "AnalyzeStmt", "analyze_keyword", "opt_verbose",
  "opt_full", "opt_freeze", "opt_name_list", "ExplainStmt",
  "ExplainableStmt", "explain_option_list", "explain_option_elem",
  "explain_option_name", "explain_option_arg", "PrepareStmt",
  "prep_type_clause", "PreparableStmt", "ExecuteStmt",
  "execute_param_clause", "DeallocateStmt", "InsertStmt", "insert_rest",
  "insert_column_list", "insert_column_item", "returning_clause",
  "DeleteStmt", "using_clause", "LockStmt", "opt_lock", "lock_type",
  "opt_nowait", "UpdateStmt", "set_clause_list", "set_clause",
  "single_set_clause", "multiple_set_clause", "set_target",
  "set_target_list", "DeclareCursorStmt", "cursor_name", "cursor_options",
  "opt_hold", "SelectStmt", "select_with_parens", "select_no_parens",
  "select_clause", "simple_select", "with_clause", "cte_list",
  "common_table_expr", "into_clause", "OptTempTableName", "opt_table",
  "opt_all", "opt_distinct", "opt_sort_clause", "sort_clause",
  "sortby_list", "sortby", "select_limit", "opt_select_limit",
  "limit_clause", "offset_clause", "select_limit_value",
  "select_offset_value", "opt_select_fetch_first_value",
  "select_offset_value2", "row_or_rows", "first_or_next", "group_clause",
  "having_clause", "for_locking_clause", "opt_for_locking_clause",
  "for_locking_items", "for_locking_item", "locked_rels_list",
  "values_clause", "from_clause", "from_list", "table_ref", "joined_table",
  "alias_clause", "join_type", "join_outer", "join_qual", "relation_expr",
  "relation_expr_list", "relation_expr_opt_alias", "func_table",
  "where_clause", "where_or_current_clause", "TableFuncElementList",
  "TableFuncElement", "Typename", "opt_array_bounds", "SimpleTypename",
  "ConstTypename", "GenericType", "opt_type_modifiers", "Numeric",
  "opt_float", "Bit", "ConstBit", "BitWithLength", "BitWithoutLength",
  "Character", "ConstCharacter", "CharacterWithLength",
  "CharacterWithoutLength", "character", "opt_varying", "opt_charset",
  "ConstDatetime", "ConstInterval", "opt_timezone", "opt_interval",
  "interval_second", "a_expr", "b_expr", "c_expr", "func_expr",
  "xml_root_version", "opt_xml_root_standalone", "xml_attributes",
  "xml_attribute_list", "xml_attribute_el", "document_or_content",
  "xml_whitespace_option", "window_clause", "window_definition_list",
  "window_definition", "over_clause", "window_specification",
  "opt_existing_window_name", "opt_partition_clause", "opt_frame_clause",
  "frame_extent", "frame_bound", "row", "sub_type", "all_Op", "MathOp",
  "qual_Op", "qual_all_Op", "subquery_Op", "expr_list", "func_arg_list",
  "func_arg_expr", "type_list", "array_expr", "array_expr_list",
  "extract_list", "extract_arg", "overlay_list", "overlay_placing",
  "position_list", "substr_list", "substr_from", "substr_for", "trim_list",
  "in_expr", "case_expr", "when_clause_list", "when_clause",
  "case_default", "case_arg", "columnref", "indirection_el", "indirection",
  "opt_indirection", "opt_asymmetric", "ctext_expr", "ctext_expr_list",
  "ctext_row", "target_list", "target_el", "qualified_name_list",
  "qualified_name", "name_list", "name", "database_name", "access_method",
  "attr_name", "index_name", "file_name", "func_name", "AexprConst",
  "Iconst", "Sconst", "RoleId", "SignedIconst", "ColId",
  "type_function_name", "ColLabel", "unreserved_keyword",
  "col_name_keyword", "type_func_name_keyword", "reserved_keyword", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,   368,   369,   370,   371,   372,   373,   374,
     375,   376,   377,   378,   379,   380,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
     415,   416,   417,   418,   419,   420,   421,   422,   423,   424,
     425,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   436,   437,   438,   439,   440,   441,   442,   443,   444,
     445,   446,   447,   448,   449,   450,   451,   452,   453,   454,
     455,   456,   457,   458,   459,   460,   461,   462,   463,   464,
     465,   466,   467,   468,   469,   470,   471,   472,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,   489,   490,   491,   492,   493,   494,
     495,   496,   497,   498,   499,   500,   501,   502,   503,   504,
     505,   506,   507,   508,   509,   510,   511,   512,   513,   514,
     515,   516,   517,   518,   519,   520,   521,   522,   523,   524,
     525,   526,   527,   528,   529,   530,   531,   532,   533,   534,
     535,   536,   537,   538,   539,   540,   541,   542,   543,   544,
     545,   546,   547,   548,   549,   550,   551,   552,   553,   554,
     555,   556,   557,   558,   559,   560,   561,   562,   563,   564,
     565,   566,   567,   568,   569,   570,   571,   572,   573,   574,
     575,   576,   577,   578,   579,   580,   581,   582,   583,   584,
     585,   586,   587,   588,   589,   590,   591,   592,   593,   594,
     595,   596,   597,   598,   599,   600,   601,   602,   603,   604,
     605,   606,   607,   608,   609,   610,   611,   612,   613,   614,
     615,   616,   617,   618,   619,   620,   621,   622,   623,   624,
     625,   626,   627,   628,   629,   630,   631,   632,   633,   634,
     635,   636,   637,   638,   639,   640,   641,   642,   643,   644,
     645,   646,   647,   648,   649,   650,   651,   652,   653,   654,
     655,   656,   657,   658,   659,   660,   661,   662,   663,   664,
     665,   666,    61,    60,    62,   667,    43,    45,    42,    47,
      37,    94,   668,    91,    93,    40,    41,    46,    59,    44,
      58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   431,   432,   433,   433,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   435,   436,
     436,   437,   437,   438,   438,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   439,   439,   439,   439,   439,   439,
     439,   439,   439,   439,   440,   440,   440,   440,   440,   440,
     441,   442,   443,   443,   444,   445,   446,   447,   447,   448,
     448,   449,   450,   451,   451,   452,   452,   453,   453,   454,
     454,   455,   455,   456,   456,   456,   456,   456,   456,   457,
     457,   457,   458,   458,   458,   458,   458,   458,   458,   458,
     458,   458,   458,   458,   458,   458,   458,   459,   459,   460,
     460,   461,   461,   462,   462,   462,   462,   463,   463,   463,
     463,   464,   464,   464,   464,   464,   464,   464,   465,   465,
     465,   466,   466,   467,   467,   467,   467,   467,   468,   468,
     469,   469,   469,   469,   469,   470,   471,   471,   472,   472,
     473,   474,   474,   474,   474,   475,   475,   475,   475,   476,
     476,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   477,   477,
     477,   477,   477,   477,   477,   477,   477,   477,   478,   478,
     479,   479,   479,   480,   480,   481,   482,   482,   483,   483,
     484,   484,   484,   484,   485,   485,   486,   486,   487,   487,
     488,   488,   488,   489,   489,   490,   490,   491,   491,   491,
     491,   491,   491,   491,   491,   491,   491,   491,   492,   492,
     493,   493,   494,   494,   495,   495,   496,   496,   497,   498,
     498,   498,   498,   498,   499,   499,   500,   501,   501,   502,
     502,   502,   502,   502,   502,   502,   503,   503,   504,   504,
     505,   505,   506,   506,   507,   507,   507,   508,   508,   509,
     510,   511,   511,   512,   512,   512,   513,   513,   513,   513,
     513,   513,   513,   514,   514,   514,   514,   515,   516,   516,
     516,   517,   517,   517,   517,   517,   517,   518,   518,   519,
     519,   519,   519,   519,   520,   520,   521,   521,   522,   523,
     523,   523,   523,   524,   524,   525,   525,   526,   526,   527,
     527,   527,   527,   527,   528,   529,   530,   530,   530,   530,
     530,   531,   531,   532,   532,   532,   532,   533,   533,   533,
     533,   534,   534,   535,   535,   536,   537,   538,   538,   539,
     539,   540,   541,   541,   541,   542,   543,   544,   544,   545,
     545,   546,   546,   546,   546,   546,   546,   546,   546,   546,
     546,   546,   546,   547,   547,   548,   548,   548,   549,   549,
     550,   550,   551,   551,   552,   552,   553,   553,   554,   554,
     555,   555,   556,   556,   557,   557,   558,   559,   559,   560,
     560,   561,   562,   562,   563,   563,   563,   564,   564,   565,
     565,   566,   567,   567,   568,   568,   568,   568,   569,   570,
     571,   572,   573,   573,   574,   574,   575,   575,   576,   576,
     577,   577,   577,   578,   579,   579,   579,   580,   580,   581,
     582,   582,   583,   583,   584,   584,   585,   585,   585,   585,
     585,   586,   586,   587,   587,   588,   588,   589,   589,   590,
     590,   590,   591,   591,   591,   591,   591,   591,   592,   592,
     593,   593,   593,   593,   593,   594,   594,   595,   595,   596,
     596,   597,   598,   599,   599,   599,   599,   599,   599,   599,
     599,   599,   599,   599,   600,   601,   601,   602,   602,   603,
     603,   603,   603,   603,   604,   604,   605,   606,   606,   607,
     608,   608,   609,   609,   610,   611,   611,   612,   612,   612,
     612,   612,   613,   613,   614,   614,   615,   615,   616,   617,
     617,   618,   618,   619,   619,   620,   620,   621,   621,   622,
     623,   624,   624,   625,   625,   625,   625,   625,   625,   625,
     625,   625,   625,   625,   625,   626,   626,   627,   627,   628,
     628,   629,   630,   630,   630,   631,   631,   631,   631,   631,
     631,   631,   631,   631,   631,   631,   631,   631,   631,   631,
     631,   631,   632,   632,   632,   632,   632,   632,   632,   632,
     632,   632,   632,   632,   633,   633,   634,   634,   635,   635,
     635,   635,   635,   635,   635,   635,   635,   635,   635,   635,
     635,   635,   635,   635,   636,   636,   637,   637,   638,   639,
     639,   640,   640,   640,   640,   640,   641,   641,   642,   642,
     642,   642,   643,   643,   643,   643,   643,   643,   643,   643,
     643,   643,   643,   643,   643,   643,   644,   644,   645,   645,
     646,   646,   647,   647,   648,   649,   650,   650,   651,   651,
     652,   652,   653,   654,   654,   655,   655,   655,   656,   656,
     656,   657,   657,   657,   658,   659,   659,   660,   660,   661,
     661,   662,   662,   663,   663,   664,   664,   664,   665,   665,
     665,   666,   666,   666,   667,   667,   667,   668,   668,   668,
     669,   669,   670,   670,   671,   671,   672,   672,   673,   673,
     674,   674,   674,   674,   674,   675,   675,   675,   675,   675,
     676,   677,   678,   678,   678,   679,   679,   679,   680,   680,
     681,   681,   681,   681,   681,   681,   681,   681,   681,   681,
     681,   681,   681,   682,   682,   682,   682,   683,   683,   684,
     684,   685,   686,   686,   687,   688,   688,   689,   689,   690,
     690,   691,   691,   692,   692,   693,   693,   693,   693,   694,
     694,   695,   696,   696,   697,   697,   698,   698,   698,   699,
     699,   699,   700,   701,   701,   702,   702,   702,   703,   703,
     704,   704,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   705,   705,   705,
     705,   705,   705,   705,   705,   705,   705,   706,   706,   707,
     707,   708,   708,   708,   708,   708,   708,   708,   709,   709,
     709,   709,   709,   709,   709,   709,   709,   709,   709,   709,
     709,   709,   709,   709,   709,   710,   711,   711,   711,   712,
     712,   713,   713,   713,   713,   713,   714,   714,   715,   715,
     715,   715,   716,   716,   716,   717,   717,   718,   719,   719,
     720,   721,   721,   722,   722,   722,   722,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   722,   723,   723,   723,
     724,   724,   724,   725,   725,   725,   726,   726,   727,   727,
     728,   728,   728,   728,   729,   730,   731,   731,   732,   732,
     732,   732,   732,   732,   732,   732,   732,   732,   732,   732,
     732,   732,   732,   732,   733,   733,   734,   734,   735,   736,
     736,   737,   738,   738,   739,   740,   740,   740,   740,   740,
     741,   741,   742,   743,   743,   743,   743,   743,   743,   744,
     745,   745,   745,   746,   746,   747,   747,   747,   747,   747,
     748,   748,   749,   749,   749,   749,   750,   750,   751,   751,
     752,   752,   753,   753,   754,   754,   755,   755,   756,   756,
     756,   756,   757,   757,   757,   757,   757,   757,   757,   758,
     758,   759,   760,   760,   760,   761,   761,   761,   762,   763,
     763,   764,   764,   764,   764,   765,   765,   766,   766,   767,
     767,   767,   767,   768,   769,   769,   769,   770,   770,   771,
     772,   772,   773,   774,   774,   775,   776,   776,   777,   777,
     777,   777,   777,   777,   777,   777,   778,   778,   779,   780,
     780,   781,   781,   782,   783,   784,   785,   785,   786,   787,
     788,   788,   788,   788,   788,   789,   789,   789,   790,   790,
     791,   791,   792,   792,   792,   792,   792,   792,   792,   792,
     793,   793,   794,   794,   794,   794,   794,   794,   795,   795,
     796,   796,   797,   798,   798,   799,   799,   799,   799,   799,
     799,   799,   799,   800,   800,   801,   801,   801,   802,   802,
     802,   802,   803,   803,   804,   805,   805,   806,   806,   807,
     807,   807,   807,   808,   808,   809,   809,   809,   810,   810,
     811,   811,   812,   813,   813,   813,   814,   815,   815,   816,
     816,   817,   817,   818,   818,   819,   819,   820,   820,   821,
     821,   822,   822,   823,   823,   824,   824,   825,   825,   826,
     826,   827,   827,   827,   827,   827,   827,   827,   827,   827,
     827,   827,   828,   828,   828,   828,   828,   828,   829,   829,
     829,   829,   830,   830,   830,   830,   831,   831,   832,   832,
     833,   833,   833,   833,   834,   834,   835,   835,   835,   836,
     837,   837,   838,   838,   838,   839,   839,   840,   841,   841,
     841,   841,   841,   841,   842,   842,   842,   843,   843,   843,
     843,   843,   843,   843,   844,   844,   844,   844,   845,   845,
     846,   846,   847,   847,   847,   847,   847,   847,   847,   847,
     847,   847,   847,   848,   848,   849,   849,   850,   850,   851,
     852,   853,   853,   854,   854,   855,   856,   857,   857,   857,
     857,   857,   857,   858,   858,   859,   859,   860,   860,   860,
     860,   861,   862,   862,   862,   863,   863,   863,   863,   863,
     863,   863,   863,   863,   863,   863,   863,   863,   863,   864,
     864,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,   865,   866,
     866,   866,   866,   866,   866,   866,   866,   866,   866,   866,
     866,   866,   866,   866,   866,   866,   866,   866,   866,   866,
     866,   867,   867,   867,   867,   867,   867,   867,   867,   867,
     867,   867,   867,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   868,   868,   868,   868,   868,   868,   868,   868,   868,
     868,   869,   869,   870,   870,   870,   870,   871,   872,   872,
     873,   873,   874,   874,   875,   875,   875,   876,   876,   877,
     877,   878,   879,   879,   879,   880,   881,   881,   882,   882,
     883,   883,   883,   884,   884,   885,   885,   885,   885,   885,
     886,   886,   886,   887,   887,   887,   888,   888,   889,   889,
     889,   889,   889,   889,   889,   889,   889,   890,   890,   891,
     891,   892,   892,   892,   892,   892,   892,   893,   893,   894,
     894,   895,   895,   896,   896,   897,   897,   897,   898,   898,
     899,   899,   900,   900,   900,   900,   900,   900,   900,   900,
     901,   901,   902,   903,   903,   904,   904,   904,   904,   904,
     904,   905,   906,   907,   907,   907,   908,   908,   909,   910,
     910,   911,   912,   912,   913,   913,   914,   914,   915,   915,
     915,   915,   916,   916,   917,   917,   918,   918,   919,   919,
     920,   920,   921,   922,   922,   923,   923,   923,   923,   924,
     924,   925,   925,   926,   926,   927,   928,   929,   930,   931,
     932,   933,   933,   934,   934,   934,   934,   934,   934,   934,
     934,   934,   934,   934,   934,   934,   935,   936,   937,   938,
     938,   938,   939,   939,   939,   940,   940,   940,   941,   941,
     941,   941,   941,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   942,   942,   942,   942,   942,   942,
     942,   942,   942,   942,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   943,   943,   943,   943,   943,   943,
     943,   943,   943,   943,   943,   943,   943,   943,   943,   943,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   944,   944,   944,   944,   944,   944,   944,   944,
     944,   944,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945,   945,   945,
     945,   945,   945,   945,   945,   945,   945,   945
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     5,     1,
       0,     2,     0,     2,     0,     2,     2,     3,     3,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     2,     1,     2,     2,     2,     3,     3,
       5,     5,     0,     3,     5,     5,     4,     3,     5,     3,
       5,     5,     6,     1,     1,     3,     5,     6,     4,     1,
       0,     2,     0,     1,     1,     1,     1,     1,     1,     2,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     5,
       2,     2,     2,     2,     3,     3,     3,     1,     3,     1,
       3,     1,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     3,     6,     1,     1,     1,     1,     1,
       0,     1,     1,     2,     3,     4,     3,     2,     2,     1,
       2,     3,     4,     3,     2,     4,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     4,     4,     4,     4,     1,
       3,     2,     3,     4,     6,     6,     6,     5,     5,     6,
       6,     4,     7,     2,     6,     4,     3,     3,     3,     3,
       3,     4,     4,     3,     3,     3,     3,     3,     3,     4,
       4,     3,     2,     3,     3,     3,     2,     2,     3,     2,
       1,     1,     0,     2,     0,     3,     2,     0,     1,     3,
       3,     1,     5,     3,     2,     2,    10,     6,     1,     1,
       1,     1,     1,     1,     3,     2,     0,     1,     1,     3,
       3,     1,     1,     3,     3,     3,     3,     4,     1,     0,
       2,     0,     3,     0,     1,     0,     1,     3,     2,     1,
       1,     1,     3,     0,     1,     3,     1,    11,    10,     1,
       1,     2,     2,     2,     2,     0,     1,     0,     3,     0,
       1,     3,     1,     3,     1,     1,     1,     1,     1,     3,
       4,     2,     0,     3,     1,     1,     2,     1,     3,     4,
       4,     2,     5,     1,     2,     2,     2,     3,     3,     3,
       0,     1,     1,     1,     1,     1,     1,     3,     1,     5,
       7,     8,     9,    11,     3,     0,     1,     3,     1,     2,
       2,     2,     0,     1,     3,     3,     6,     4,     0,     1,
       1,     2,     2,     0,     3,     3,     2,     1,     1,     2,
       2,     4,     0,     2,     2,     2,     0,     3,     4,     4,
       0,     2,     0,     4,     0,     7,     5,     3,     0,     1,
       3,     1,     2,     3,     0,     5,     4,     1,     0,     1,
       2,     2,     1,     2,     3,     2,     2,     2,     2,     3,
       3,     1,     3,     1,     0,     1,     2,     1,     1,     3,
       6,    10,     1,     0,     1,     2,     2,     0,     2,     2,
       1,     0,     5,     7,     1,     0,     6,     2,     0,     3,
       5,     7,     6,     8,     7,     6,     6,     4,     0,     1,
       3,     4,     1,     3,     1,     2,     2,     2,     2,     1,
       1,    10,     2,     0,     2,     2,     1,     0,     4,     6,
       5,     4,     4,     8,     1,     1,     1,     7,     9,     8,
      15,    20,     1,     1,     1,     3,     1,     1,     1,     3,
       1,     3,     0,     1,     0,     1,     1,     4,     0,     1,
       3,     0,     1,     1,     1,     1,     1,     1,     2,     0,
       1,     2,     1,     2,     0,     2,     1,     2,     2,     6,
       8,     8,     4,     5,     4,     4,     4,     3,     7,     8,
       6,     6,     6,     6,     3,     1,     3,     3,     1,     1,
       1,     1,     1,     1,     3,     3,     3,     1,     3,     3,
       1,     0,     1,     3,    13,     1,     3,     4,     5,     4,
       7,     2,     1,     0,     2,     0,     1,     0,     6,     8,
       8,     1,     3,     5,     5,     7,     9,     7,     9,     5,
       6,     6,     4,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     1,     3,     1,     2,     2,
       3,     5,     2,     2,     0,     6,     7,     7,     7,     8,
       8,     6,     8,     9,     9,     7,    10,     7,     8,     8,
       8,     8,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     2,     1,     2,
       3,     3,     3,     3,     4,     4,     3,     3,     3,     4,
       4,     3,     4,     4,     1,     1,     1,     0,     7,     7,
      10,     1,     1,     2,     4,     5,     1,     3,     2,     2,
       2,     2,     1,     2,     2,     4,     3,     2,     2,     2,
       3,     2,     2,     5,     5,     5,     1,     3,     1,     2,
       3,     0,     1,     3,     2,     6,     6,     9,     3,     0,
       3,     0,     5,     2,     0,     3,     3,     3,     7,     7,
      10,     1,     1,     1,    14,     1,     0,     1,     0,     1,
       0,     2,     0,     1,     3,     4,     4,     6,     1,     2,
       0,     1,     1,     0,     1,     1,     0,     9,    12,     7,
       2,     0,     3,     2,     1,     3,     3,     2,     1,     3,
       3,     3,     2,     2,     1,     1,     1,     1,     2,     1,
       1,     1,     1,     4,     5,     1,     3,     3,     1,     2,
       4,     5,     1,     1,     1,     1,     3,     3,     2,     2,
       2,     2,     1,     2,     2,     1,     1,     1,     3,     2,
       0,     2,     1,     3,     5,     1,     2,     1,     0,     5,
       7,     5,     7,     5,     7,     3,     5,     5,     5,     1,
       3,     2,     1,     2,     1,     2,    11,    10,    10,     2,
       2,     0,     9,     2,     0,     4,     4,     4,     1,     1,
       1,     0,     7,     6,     6,     6,     6,     7,     9,     9,
       6,     6,     6,     6,     6,     8,     8,     6,     6,     6,
       5,     5,     8,     8,     8,     8,     6,     1,     0,     2,
       0,     7,     6,     6,     6,     6,     6,     6,     7,     6,
       6,     6,     6,     7,     7,     7,     9,     9,     6,     6,
       6,     8,     8,     8,     6,    13,     1,     1,     3,     3,
       1,     1,     1,     1,     1,     1,     1,     0,     1,     1,
       1,     1,     1,     1,     0,     6,     8,     3,     2,     0,
       2,     2,     2,     2,     3,     3,     2,     2,     2,     2,
       3,     2,     5,     4,     3,     3,     3,     1,     1,     0,
       3,     2,     2,     1,     3,     2,     1,     0,     8,    10,
       3,     4,     4,     0,     2,     5,     2,     0,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     4,     3,     3,     1,     0,     5,     6,     4,     2,
       0,     4,     3,     5,     6,     4,     6,     6,     5,     7,
       1,     0,     6,    11,    11,    11,    13,     9,    11,    10,
       4,     2,     5,     2,     0,     4,     5,     5,     4,     6,
       1,     3,     1,     1,     1,     1,     2,     4,     1,     1,
       1,     0,     1,     0,     1,     0,     3,     0,     2,     4,
       3,     5,     1,     1,     1,     1,     1,     1,     1,     1,
       3,     2,     1,     1,     1,     1,     1,     0,     5,     3,
       0,     1,     1,     1,     1,     3,     8,     3,     0,     2,
       3,     2,     3,     5,     1,     4,     2,     1,     3,     2,
       2,     0,     6,     2,     0,     5,     3,     0,     2,     2,
       2,     3,     1,     3,     1,     2,     1,     0,     7,     1,
       3,     1,     1,     3,     5,     2,     1,     3,     7,     1,
       0,     3,     2,     2,     2,     0,     2,     2,     1,     1,
       3,     3,     1,     2,     4,     4,     2,     3,     5,     5,
       1,     1,     9,     1,     2,     4,     4,     4,     2,     3,
       1,     3,     4,     2,     0,     3,     3,     4,     4,     4,
       4,     2,     1,     1,     0,     1,     1,     0,     1,     5,
       1,     0,     1,     0,     3,     1,     3,     4,     3,     2,
       2,     1,     1,     1,     0,     2,     4,     5,     2,     3,
       1,     1,     1,     1,     3,     0,     1,     1,     1,     1,
       1,     3,     0,     2,     0,     1,     3,     1,     0,     1,
       2,     4,     4,     2,     0,     2,     3,     2,     0,     1,
       3,     1,     2,     1,     2,     5,     6,     5,     1,     2,
       1,     4,     3,     4,     5,     4,     5,     4,     5,     2,
       4,     1,     2,     2,     2,     1,     1,     0,     4,     2,
       1,     2,     2,     4,     1,     3,     1,     2,     3,     1,
       2,     0,     2,     4,     0,     1,     3,     2,     2,     3,
       5,     6,     2,     3,     3,     4,     0,     1,     1,     1,
       1,     1,     2,     5,     1,     1,     1,     1,     2,     3,
       3,     0,     1,     1,     1,     1,     1,     2,     2,     2,
       2,     2,     1,     3,     0,     1,     1,     1,     1,     5,
       2,     1,     1,     1,     1,     5,     2,     2,     2,     1,
       3,     3,     2,     1,     0,     3,     0,     5,     2,     5,
       2,     1,     2,     3,     0,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     3,     0,     1,
       4,     1,     3,     5,     2,     2,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     2,     3,     3,
       2,     3,     5,     4,     6,     3,     5,     4,     6,     4,
       6,     5,     7,     3,     2,     4,     2,     3,     3,     4,
       3,     4,     3,     4,     5,     6,     6,     7,     6,     7,
       6,     7,     3,     4,     4,     6,     2,     3,     4,     1,
       3,     2,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     2,     2,     5,     6,     6,     7,     3,
       4,     1,     1,     2,     4,     1,     1,     1,     2,     2,
       2,     2,     1,     4,     5,     6,     8,     6,     7,     7,
       5,     1,     1,     4,     1,     4,     1,     4,     1,     4,
       1,     1,     1,     1,     1,     1,     6,     4,     4,     4,
       4,     6,     5,     5,     5,     4,     6,     4,     4,     4,
       4,     5,     7,     7,     9,     4,     6,     5,     7,     7,
       7,     2,     3,     3,     3,     4,     0,     4,     1,     3,
       3,     1,     1,     1,     2,     2,     0,     2,     0,     1,
       3,     3,     2,     2,     0,     6,     1,     0,     3,     0,
       2,     2,     0,     1,     4,     2,     2,     2,     2,     2,
       4,     3,     5,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     4,     1,
       4,     1,     4,     1,     2,     1,     2,     1,     3,     1,
       3,     1,     3,     1,     3,     3,     3,     2,     1,     3,
       3,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       4,     3,     2,     3,     0,     3,     3,     2,     2,     1,
       0,     2,     2,     3,     2,     1,     1,     3,     5,     1,
       2,     4,     2,     0,     1,     0,     1,     2,     2,     2,
       3,     5,     1,     2,     0,     2,     1,     0,     1,     1,
       1,     3,     3,     1,     3,     3,     2,     1,     1,     1,
       3,     1,     2,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     1,     1,     1,     2,     5,
       2,     3,     6,     1,     1,     1,     1,     1,     1,     1,
       2,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
     107,   979,   485,  1059,  1058,   979,   230,     0,  1061,     0,
     979,   319,   791,     0,     0,     0,     0,     0,   485,   979,
       0,     0,     0,     0,     0,     0,     0,  1184,     0,     0,
       0,     0,     0,     0,     0,     0,   979,     0,  1191,     0,
       0,     0,     0,  1184,     0,     0,  1063,     0,     0,     0,
       0,     2,     4,    49,    50,    18,    17,    23,    22,    72,
      73,    39,    12,    63,    44,   104,   103,   105,    29,    25,
      57,    16,    26,    30,    46,    31,    45,    15,    43,    67,
      47,    70,    36,    61,     9,    37,    62,    10,    51,    74,
      21,    48,    71,    32,    59,    55,    40,    41,    42,    64,
      65,    66,    88,    69,    99,    28,    78,    79,    94,    80,
      95,     7,    81,    38,    11,    91,    90,    92,    58,    33,
      60,    89,    93,    13,    14,    96,    68,    86,    83,   100,
      98,   106,    84,    52,     5,     6,    75,    35,     8,    20,
      19,    34,    27,   102,    24,  1061,    77,    87,    76,    53,
      82,    56,    85,   101,    54,    97,  1161,  1148,  1193,  1160,
       0,  1163,   978,   977,   963,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   484,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   987,
    1682,  1693,  1694,  1695,  1696,  1697,  1698,  1699,  1700,   295,
    1701,  1702,  1703,  1704,  1705,  1706,  1707,  1708,  1709,  1944,
    1945,  1946,  1947,  1710,  1711,  1712,  1713,  1714,  1715,  1716,
    1948,  1949,  1717,  1718,  1719,  1720,  1721,  1950,  1722,  1723,
    1724,  1725,  1726,  1727,  1728,  1729,  1730,  1731,  1732,  1733,
    1734,  1735,  1736,  1737,  1738,  1739,  1740,  1741,  1742,  1743,
    1744,  1951,  1952,  1745,  1746,  1747,  1748,  1749,  1750,  1751,
    1752,  1753,  1754,  1755,  1756,  1757,  1758,  1759,  1760,  1761,
    1762,  1763,  1764,  1765,  1766,  1767,  1768,  1953,  1769,  1770,
    1954,  1771,  1772,  1955,  1773,  1774,  1775,  1776,  1777,  1778,
    1779,  1956,  1780,  1781,  1782,  1783,  1784,  1785,  1786,  1787,
    1788,  1789,  1790,  1791,  1792,  1793,  1794,  1795,  1957,  1796,
    1797,  1798,  1799,  1958,  1959,  1960,  1800,  1801,  1802,  1803,
    1804,  1805,  1806,  1807,  1961,  1808,  1809,  1810,  1811,  1812,
    1813,  1814,  1815,  1816,  1817,  1818,  1819,  1820,  1821,  1822,
    1823,  1824,  1962,  1963,  1825,  1826,  1827,  1828,  1829,  1830,
    1831,  1964,  1832,  1833,  1834,  1835,  1965,  1836,  1966,  1837,
    1838,  1839,  1840,  1841,  1842,  1843,  1967,  1968,  1844,  1845,
    1846,  1847,  1848,  1849,  1850,  1969,  1851,  1970,  1854,  1852,
    1853,  1855,  1856,  1857,  1858,  1859,  1860,  1861,  1971,  1862,
    1863,  1864,  1865,  1866,  1867,  1868,  1869,  1870,  1871,  1872,
    1873,  1874,  1875,  1876,  1877,  1878,  1972,  1879,  1880,  1881,
    1882,  1883,  1884,  1885,  1886,  1887,  1888,  1889,  1890,  1891,
    1892,  1973,  1893,  1894,  1895,  1974,  1896,  1897,  1898,  1899,
    1900,  1901,  1902,  1903,  1904,  1905,  1975,  1906,  1907,  1908,
    1909,  1910,  1911,  1912,  1913,  1914,  1976,  1977,  1915,  1978,
    1916,  1979,  1917,  1918,  1919,  1920,  1921,  1922,  1923,  1924,
    1925,  1926,  1927,  1928,  1929,  1930,  1980,  1981,  1931,  1932,
    1933,  1934,  1935,  1936,  1937,  1938,  1939,  1940,  1982,  1983,
    1984,  1985,  1986,  1987,  1988,  1989,  1941,  1942,  1943,   294,
    1139,  1655,  1683,  1684,  1060,  1041,   485,     0,   966,   318,
       0,     0,     0,     0,     0,     0,     0,   612,     0,     0,
       0,     0,     0,     0,     0,     0,   160,     0,     0,   340,
     339,     0,     0,     0,   765,     0,     0,     0,     0,   473,
    1101,  1852,  1099,  1140,     0,   231,   234,   232,   233,  1677,
       0,   861,   862,   864,     0,     0,   874,   639,     0,   638,
       0,     0,     0,   636,     0,     0,     0,     0,   640,   634,
       0,   633,     0,     0,     0,   637,     0,   635,     0,     0,
     967,  1098,   345,     0,     0,  1077,  1061,  1068,  1078,  1073,
    1075,  1074,  1076,  1072,  1676,  1694,   707,   707,   707,   707,
     704,   705,   707,   707,   707,  1866,     0,     0,   686,     0,
     688,  1679,   707,   712,   395,   395,   395,     0,   711,   716,
     395,     0,   960,   994,  1660,  1183,     0,   687,   959,  1915,
    1090,     0,     0,   878,     0,   879,     0,  1881,   971,   217,
    1891,  1976,  1915,   213,   187,  1698,     0,     0,   711,     0,
     968,   969,  1190,  1188,     0,  1715,  1728,  1811,   210,  1877,
    1882,  1891,  1976,  1915,  1940,   169,     0,   224,  1891,  1976,
    1915,   220,   987,     0,  1164,  1270,  1651,     0,   962,   961,
    1276,     0,  1062,     0,  1065,     0,  1235,  1864,  1168,  1170,
    1067,  1161,     0,     1,   107,  1056,  1187,  1187,     0,  1187,
       0,  1153,  1161,  1156,  1160,     0,  1682,  1990,  1991,  1992,
    1993,  1994,  1995,  1996,  1997,  1998,  1999,  2000,  2001,  2002,
    2003,  2004,  2005,  2006,  2007,  2008,  2009,  2010,  2011,     0,
       0,  1661,  1683,  1687,     0,   647,   110,  1656,   754,     0,
       0,     0,     0,     0,  1678,     0,     0,  1556,  1719,  1771,
    1566,  1564,  1565,  1558,  1559,  1560,  1561,  1562,  1563,     0,
     859,  1557,     0,   110,     0,     0,     0,     0,     0,     0,
       0,     0,  1815,   110,     0,     0,     0,     0,   983,   986,
     964,  1044,     0,  1651,     0,     0,   672,     0,   681,   673,
     678,     0,   675,     0,     0,   683,     0,   674,   676,   677,
     682,     0,     0,   679,   680,     0,     0,   975,   395,     0,
       0,     0,     0,     0,   110,  1031,     0,   344,   343,   110,
     342,   341,  1719,  1771,     0,   790,   110,     0,   162,   513,
     488,     0,     0,   577,  1815,   110,     0,     0,     0,     0,
     768,     0,     0,   472,   485,  1102,  1100,     0,  1114,   865,
     212,   211,   863,  1785,     0,   282,     0,     0,  1785,  1022,
       0,  1785,     0,  1785,   155,  1653,  1719,  1771,  1785,     0,
       0,  1785,   147,  1785,     0,  1785,   282,  1785,   489,     0,
    1785,     0,  1785,  1815,   149,     0,  1785,   282,   645,     0,
    1095,     0,  1070,  1980,  1084,  1083,     0,  1079,  1087,  1082,
       0,   707,   706,     0,   707,     0,   707,     0,   707,     0,
     707,     0,     0,     0,   707,  1680,  1681,   689,     0,   713,
       0,     0,   720,   719,   718,     0,     0,     0,   721,     0,
    1274,  1117,     0,   957,   974,     0,     0,     0,   881,   881,
     881,   970,   216,   214,     0,     0,     0,     0,     0,     0,
     976,     0,     0,  1664,  1666,  1667,  1567,  1634,     0,  1945,
    1946,  1947,  1625,     0,  1948,  1949,  1950,  1484,  1471,  1480,
    1485,  1472,  1474,  1481,  1951,  1952,  1757,  1953,  1954,  1674,
    1955,  1956,  1958,  1959,  1960,  1961,  1476,  1478,  1962,  1963,
       0,  1675,  1965,  1966,  1841,  1968,  1969,  1971,  1972,  1482,
    1974,  1975,  1976,  1977,  1978,  1979,  1673,     0,  1483,  1981,
    1983,  1984,  1985,  1986,  1987,  1988,  1989,     0,     0,  1648,
       0,  1457,     0,  1304,  1305,  1327,  1328,  1306,  1333,  1334,
    1346,  1307,     0,  1647,  1371,  1456,  1462,     0,  1455,  1451,
    1174,  1643,     0,  1452,  1663,  1665,  1626,   180,   226,     0,
     227,  1649,  1891,   170,   209,   182,   208,   183,   181,     0,
    1717,   171,     0,   178,     0,     0,     0,     0,   223,   221,
       0,   965,     0,  1272,  1271,     0,     0,  1632,  1652,   654,
       0,  1277,     0,  1054,  1055,  1053,     0,  1050,  1052,  1064,
    1061,  1639,  1638,  1640,     0,  1169,     0,     0,     0,  1151,
    1150,     3,  1067,  1185,  1186,     0,     0,     0,     0,     0,
       0,     0,     0,  1228,  1201,  1202,  1204,  1225,  1229,     0,
    1157,  1236,     0,     0,  1662,     0,     0,     0,   648,     0,
       0,     0,   109,  1020,   219,  1018,     0,     0,     0,     0,
       0,  1025,     0,     0,     0,     0,   823,     0,     0,     0,
       0,     0,     0,   824,   822,   825,   832,   845,   848,     0,
     744,   153,   154,     0,     0,     0,   908,     0,     0,   908,
       0,     0,     0,     0,     0,     0,     0,   236,   239,   465,
       0,     0,   467,     0,     0,     0,     0,     0,     0,     0,
     114,     0,     0,     0,     0,   452,   464,     0,     0,     0,
       0,     0,   461,     0,   110,   237,   446,   449,     0,     0,
       0,   522,   521,   908,     0,   235,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   114,   146,     0,     0,   238,     0,     0,   981,   982,
       0,   985,     0,  1040,     0,     0,     0,     0,     0,     0,
    1719,  1771,     0,     0,     0,     0,     0,     0,   321,   301,
     302,   110,   300,     0,     0,   574,     0,  1685,  1315,  1344,
    1322,  1344,  1344,  1311,  1311,  1324,  1312,  1313,  1351,     0,
    1344,  1311,  1316,     0,  1314,  1354,  1354,  1339,     0,  1296,
    1297,  1298,  1299,  1325,  1326,  1300,  1331,  1332,  1301,  1368,
    1311,  1686,     0,   997,  1030,     0,     0,   112,   613,     0,
       0,   575,     0,   112,     0,   158,     0,   517,     0,     0,
       0,     0,     0,     0,   533,   532,     0,     0,   576,     0,
     112,   448,     0,   438,   395,     0,   767,   770,     0,     0,
       0,  1143,  1145,  1144,     0,  1142,     0,  1284,     0,   282,
     280,   281,   572,   873,     0,     0,     0,     0,   282,     0,
       0,  1785,     0,  1785,     0,     0,   282,   282,     0,     0,
       0,     0,   518,     0,   644,   642,   641,   643,     0,     0,
       0,     0,     0,  1785,   282,     0,     0,   632,  1577,     0,
       0,     0,     0,   198,   199,   197,  1085,   200,  1086,  1081,
    1069,     0,   697,     0,   701,     0,   692,     0,   698,     0,
     693,   690,   691,     0,   696,     0,     0,   396,   398,     0,
       0,  1742,     0,  1776,  1803,  1804,  1882,  1887,     0,  1910,
       0,   722,   749,   717,     0,     0,  1111,  1104,     0,     0,
    1127,   958,  1583,     0,     0,     0,   880,   877,   876,   875,
     215,   188,     0,     0,     0,   751,  1881,   973,     0,  1453,
       0,  1460,  1461,  1343,  1330,  1624,     0,     0,  1338,  1337,
       0,     0,     0,     0,  1320,  1319,  1318,  1459,  1591,     0,
    1317,     0,     0,     0,     0,  1344,  1344,  1342,  1390,     0,
    1321,     0,     0,  1604,     0,  1610,     0,     0,     0,  1350,
       0,  1348,     0,     0,  1426,     0,     0,     0,     0,     0,
       0,     0,  1374,  1375,  1457,  1577,     0,  1458,  1670,     0,
       0,  1336,     0,  1368,  1646,  1567,     0,     0,     0,     0,
    1637,  1575,     0,     0,  1404,  1573,     0,  1406,     0,     0,
       0,  1566,  1564,  1565,  1558,  1559,  1560,  1561,  1562,  1563,
    1571,  1387,     0,     0,  1386,     0,     0,  1238,     0,  1668,
    1627,   228,   229,   225,     0,     0,   185,   184,     0,   202,
     206,   207,   177,   205,     0,   201,  1523,  1522,   186,   176,
     174,   172,   189,   191,   192,   175,   173,   222,     0,     0,
    1688,  2012,  2013,  2014,  2015,  2016,  2017,  2018,  2019,  2020,
    2021,  2022,  2023,  2024,  2025,  2026,  2027,  2028,  2029,  2030,
    2031,  2032,  2033,  2034,  2035,  2036,  2037,  2038,  2039,  2040,
    2041,  2042,  2043,  2044,  2045,  2046,  2047,  2048,  2049,  2050,
    2051,  2052,  2053,  2054,  2055,  2056,  2057,  2058,  2059,  2060,
    2061,  2062,  2063,  2064,  2065,  2066,  2067,  2068,  2069,  2070,
    2071,  2072,  2073,  2074,  2075,  2076,  2077,  2078,  2079,  2080,
    2081,  2082,  2083,  2084,  2085,  2086,  2087,  1629,  1628,  1658,
    1689,  1690,  1691,  1692,  1633,     0,     0,   282,  1278,     0,
    1238,  1129,  1131,  1132,     0,  1634,  1048,     0,  1045,  1642,
       0,  1171,     0,     0,  1057,  1167,  1166,  1194,  1195,   783,
    1165,  1219,  1220,  1215,     0,  1234,  1234,  1211,  1205,  1210,
    1208,     0,  1212,  1371,  1227,  1155,  1199,  1200,  1203,  1154,
       0,  1230,  1228,  1204,     0,     0,     0,     0,     0,     0,
       0,   649,     0,     0,     0,  1910,   218,  1016,     0,     0,
       0,     0,   753,   752,     0,     0,   772,     0,     0,     0,
    1028,   388,     0,   279,     0,     0,     0,     0,     0,     0,
       0,   830,     0,     0,     0,     0,   831,   828,   829,  1882,
     847,   846,   844,   805,   807,   806,     0,   809,   793,     0,
     794,     0,     0,   804,   812,   810,     0,     0,     0,  1765,
     241,   253,     0,   907,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   272,     0,     0,     0,     0,   277,
       0,     0,     0,   276,     0,   466,     0,     0,     0,     0,
       0,     0,   860,     0,     0,   141,   144,     0,     0,   451,
     463,     0,   455,   456,   453,   457,   458,     0,     0,     0,
       0,     0,     0,   450,     0,     0,   515,   514,   520,     0,
       0,     0,     0,     0,   901,   900,     0,     0,     0,     0,
       0,     0,     0,     0,   524,   525,     0,   526,     0,   145,
       0,     0,     0,     0,     0,     0,   196,   980,   984,  1043,
    1659,  1042,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   306,  1685,     0,   597,   573,     0,  1296,     0,  1292,
    1288,  1357,  1358,  1359,  1356,  1369,  1355,     0,  1302,  1360,
    1311,  1308,     0,   995,   362,   481,   151,     0,     0,     0,
     585,   588,     0,   108,   162,   345,     0,   161,   163,   165,
     166,   167,   164,   168,   512,   516,     0,   487,     0,     0,
       0,     0,     0,   537,   536,   540,   538,     0,   534,     0,
       0,     0,   140,   445,   447,     0,     0,   347,   426,     0,
       0,     0,   769,     0,     0,     0,     0,     0,     0,     0,
    1141,     0,  1248,  1113,  1239,  1250,  1241,  1243,  1279,     0,
    1651,     0,  1111,     0,   851,     0,  1023,  1785,   282,     0,
     849,   156,  1654,     0,     0,     0,     0,     0,   853,   629,
     148,     0,   282,   282,   490,     0,   282,   150,     0,     0,
       0,   482,   282,   646,  1097,     0,   438,  1071,  1080,   694,
     703,   702,   700,   699,   695,     0,   714,     0,   394,     0,
       0,     0,   728,     0,     0,   727,   742,   729,     0,   731,
     724,   723,   732,     0,     0,   751,  1106,     0,  1107,  1634,
       0,  1103,     0,  1124,     0,  1122,     0,  1275,  1126,  1115,
    1089,     0,  1088,  1092,  1094,  1093,  1091,     0,     0,     0,
     711,     0,     0,   282,   972,     0,  1635,  1587,     0,  1588,
       0,     0,     0,  1623,  1619,     0,     0,     0,     0,     0,
    1592,  1595,  1596,  1597,  1594,  1598,  1593,     0,     0,  1599,
       0,     0,     0,     0,     0,  1341,  1340,     0,     0,     0,
       0,     0,     0,     0,  1429,  1462,     0,     0,  1551,     0,
    1577,  1609,     0,     0,  1352,     0,     0,     0,     0,     0,
       0,     0,  1577,  1615,     0,     0,     0,  1521,     0,  1518,
       0,     0,     0,     0,  1634,     0,     0,     0,     0,  1671,
    1372,  1388,  1645,     0,  1636,     0,     0,  1395,     0,  1616,
    1422,     0,  1427,  1410,     0,  1403,     0,  1408,  1412,  1391,
    1637,  1576,     0,  1574,     0,     0,  1389,     0,  1384,  1382,
    1383,  1376,  1377,  1378,  1379,  1380,  1381,  1385,  1555,  1553,
    1554,     0,     0,     0,  1407,  1778,  1811,     0,  1184,  1184,
    1173,  1182,  1644,     0,  1281,     0,     0,     0,     0,  1534,
       0,  1581,     0,  1579,  1661,  1650,     0,     0,  1368,     0,
    1273,  1630,     0,   652,   653,   651,  1136,     0,     0,  1284,
       0,  1135,  1067,  1051,  1047,  1046,  1641,  1066,  1172,     0,
     781,   782,     0,   786,     0,     0,  1213,  1226,     0,  1127,
    1127,     0,  1217,  1218,  1209,  1159,  1158,   595,   594,     0,
       0,     0,   919,   883,   650,   920,   884,  1017,     0,  1019,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   282,  1026,   921,   278,  1027,   912,     0,
       0,     0,   495,   496,     0,   826,   827,   922,   885,     0,
     913,   808,  1311,   792,     0,     0,   803,     0,   802,  1311,
    1311,   886,   152,   242,   362,   910,   258,   271,   266,   267,
     265,  1785,   282,  1785,   282,     0,     0,     0,     0,   268,
     263,   264,   260,   273,   274,   894,     0,   288,   291,   275,
     256,   259,   257,   240,     0,     0,  1657,     0,     0,   855,
       0,     0,   143,   897,     0,   123,   125,   127,     0,   121,
     129,   124,   126,   128,   122,   130,   120,     0,   119,     0,
       0,     0,   113,   928,   890,   454,   459,   892,   462,   915,
     460,  1697,  1758,  1892,     0,   502,   504,     0,   509,   934,
     891,     0,   914,   930,   899,     0,     0,     0,     0,     0,
       0,     0,  1032,     0,     0,     0,   929,   906,   917,     0,
     898,   893,   916,     0,     0,   194,   193,   195,     0,     0,
       0,     0,     0,     0,     0,     0,   685,   661,   684,     0,
       0,     0,     0,     0,     0,     0,   655,   320,   298,   299,
       0,     0,   297,   303,     0,   596,     0,     0,  1293,  1289,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1309,
       0,     0,  1015,  1015,  1015,  1015,  1015,  1015,  1015,   996,
    1024,   480,   498,     0,     0,     0,     0,   134,   111,     0,
     618,   584,     0,     0,   395,   157,     0,     0,     0,   486,
     583,   581,   580,   582,     0,     0,     0,   601,     0,  1285,
       0,     0,     0,   444,   349,     0,     0,   346,   350,   354,
     355,   356,     0,   439,   441,     0,     0,   430,     0,     0,
       0,   797,     0,   815,   798,     0,     0,     0,   835,   840,
     836,   818,     0,   470,  1146,  1147,     0,  1161,     0,  1250,
       0,  1249,  1261,     0,     0,  1267,  1265,     0,  1267,     0,
    1267,     0,  1242,     0,  1244,  1261,     0,  1652,  1738,  1282,
    1112,   282,     0,     0,   492,   282,     0,   282,     0,   282,
     282,     0,   955,   519,     0,   569,     0,     0,   282,   631,
    1578,     0,   715,   397,     0,     0,     0,     0,   726,     0,
     468,   730,     0,   741,   736,   738,     0,   745,     0,     0,
    1109,  1110,  1125,  1118,  1120,  1119,     0,     0,  1116,  1584,
     630,     0,     0,   282,     0,   746,  1189,  1585,  1586,     0,
       0,     0,     0,  1620,     0,     0,  1497,  1473,  1475,  1310,
    1487,     0,  1323,  1498,  1499,  1477,  1479,     0,  1568,     0,
       0,  1488,  1431,  1432,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1444,  1443,  1489,
    1550,     0,     0,  1607,  1608,  1490,  1353,  1354,  1354,     0,
       0,  1614,     0,     0,     0,  1495,  1500,     0,     0,  1505,
       0,  1526,     0,     0,     0,  1454,  1578,  1345,  1346,     0,
       0,     0,     0,     0,     0,     0,     0,  1428,  1411,  1405,
       0,  1409,  1413,     0,     0,     0,     0,  1397,  1423,  1393,
       0,     0,  1399,     0,  1424,  1184,  1184,  1184,  1184,  1181,
       0,     0,  1237,     0,  1222,  1193,  1193,     0,  1534,     0,
    1463,     0,  1534,     0,     0,   179,     0,   203,   190,     0,
       0,     0,  1130,  1111,  1133,  1049,  1196,     0,  1569,   786,
     784,   785,  1198,     0,     0,  1233,  1232,  1231,  1206,   918,
     882,   911,  1015,   756,   757,     0,   755,     0,     0,     0,
     387,   771,     0,     0,     0,     0,  1029,   479,     0,   478,
     474,   494,   820,     0,  1311,   795,   800,   801,     0,   359,
       0,     0,     0,   243,     0,     0,   255,     0,   251,   269,
     261,   270,   262,   285,     0,     0,     0,   924,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   925,     0,     0,
     116,   115,     0,   133,     0,   506,   507,   505,   501,     0,
     508,   510,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   923,   887,   656,     0,     0,   657,
     665,     0,     0,   658,     0,     0,     0,     0,     0,     0,
     667,   323,     0,   326,   333,   307,   311,  1031,  1031,     0,
     312,  1031,   308,  1031,   305,  1841,  1558,  1559,   592,   599,
     589,   591,   593,   590,     0,   598,   564,     0,     0,     0,
    1294,     0,  1362,  1363,  1364,  1365,  1366,  1367,     0,  1361,
    1368,     0,  1015,  1014,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   373,     0,     0,   367,     0,     0,
     840,   361,   364,   365,     0,   491,   136,     0,     0,   137,
     135,     0,   586,   587,     0,   345,     0,     0,   539,   542,
     535,     0,   600,   602,   578,     0,  1287,   498,  1098,     0,
     435,     0,   426,   380,   422,     0,   437,     0,   424,   423,
     425,     0,   432,   993,     0,   772,   796,     0,     0,     0,
     833,   837,   834,     0,     0,   811,     0,   819,   789,   950,
     951,   948,   949,     0,     0,  1138,  1252,  1259,     0,  1240,
       0,  1266,  1262,     0,  1263,     0,     0,  1264,     0,     0,
    1259,     0,     0,     0,   852,     0,   282,   850,     0,   625,
       0,   627,   854,   282,   282,   527,     0,   483,   441,     0,
       0,     0,   725,   743,     0,   739,     0,     0,   708,   748,
    1105,  1108,  1123,  1121,   751,     0,   709,   750,  1589,  1329,
       0,  1622,  1618,     0,  1590,     0,  1602,  1601,  1430,  1603,
       0,  1449,     0,     0,  1441,  1439,  1440,  1433,  1434,  1435,
    1436,  1437,  1438,  1442,  1612,  1611,  1605,  1606,  1349,  1347,
       0,  1492,  1493,  1494,  1613,  1501,     0,  1520,  1519,     0,
       0,     0,  1507,     0,     0,  1516,     0,  1552,  1335,  1368,
    1373,     0,     0,  1396,  1617,  1414,     0,     0,     0,  1392,
       0,     0,     0,     0,  1401,  1568,     0,     0,     0,     0,
       0,     0,  1176,  1175,  1280,     0,  1224,     0,     0,  1192,
       0,  1534,  1470,  1537,  1532,  1533,  1582,  1464,  1669,     0,
    1580,  1534,     0,  1631,     0,  1137,  1128,     0,  1197,  1214,
    1207,     0,   762,   763,   761,     0,     0,     0,   564,     0,
       0,   403,     0,   780,   780,     0,     0,   840,   933,   475,
     821,     0,   813,     0,   248,   909,     0,     0,     0,   247,
       0,   282,   282,   289,   290,   293,     0,     0,     0,     0,
       0,   619,   605,     0,     0,   620,   621,     0,     0,   857,
     858,   856,   131,   117,   118,   132,   503,   895,     0,     0,
       0,     0,     0,   932,   905,   931,   903,   902,   904,   896,
     529,     0,   659,     0,     0,   660,   671,   669,   668,   670,
     662,   324,   110,     0,   304,     0,   331,     0,   329,   328,
     330,     0,     0,     0,     0,     0,     0,   566,     0,     0,
     571,   560,   562,     0,     0,     0,  1290,  1295,  1370,  1303,
     559,     0,  1006,  1005,  1004,  1008,  1007,  1010,  1009,  1001,
    1000,  1013,  1012,   999,   998,  1003,  1002,     0,     0,   371,
     375,   376,   374,   366,   840,   395,   434,     0,   139,   138,
       0,     0,     0,     0,   544,   548,   579,     0,  1286,   523,
    1096,   442,     0,     0,   352,   357,   358,     0,   430,   377,
       0,   426,   351,   440,     0,     0,   436,     0,   988,     0,
       0,   799,   816,   817,     0,     0,   840,   839,     0,   477,
    1251,     0,     0,  1253,     0,     0,  1255,  1257,     0,     0,
       0,     0,     0,  1655,  1534,  1283,   282,   493,   282,   282,
     956,   570,     0,   735,   734,   733,   469,     0,   737,   282,
       0,  1621,  1486,  1496,  1600,     0,     0,  1450,     0,     0,
    1491,  1982,     0,     0,  1524,  1525,  1506,     0,  1826,  1511,
       0,     0,     0,  1672,  1420,  1418,  1415,     0,  1416,     0,
       0,  1398,  1394,     0,  1400,  1425,  1180,  1179,  1178,  1177,
       0,     0,  1528,  1534,  1534,  1465,  1539,  1536,     0,  1467,
    1368,  1134,     0,  1021,     0,     0,     0,   389,     0,   840,
       0,     0,     0,   778,   783,   783,     0,   840,   434,   814,
     244,   245,   246,   249,   284,   254,   250,     0,   926,   888,
       0,     0,   611,     0,     0,     0,     0,   927,   889,     0,
       0,     0,  1037,     0,     0,   663,   664,   306,     0,   327,
     336,     0,   334,   309,   314,     0,   316,   315,   310,   313,
     568,   567,   565,   561,   563,  1291,     0,   871,   871,     0,
     564,  1011,     0,     0,   363,   434,   402,     0,   368,     0,
     499,     0,   993,   347,   498,   543,     0,     0,     0,   603,
     443,   348,     0,     0,   432,     0,     0,     0,   430,     0,
     427,     0,   431,     0,     0,     0,     0,     0,   838,     0,
     842,     0,   810,   787,  1281,     0,   481,     0,  1260,  1269,
       0,  1256,  1254,  1245,     0,  1247,   872,   626,   628,   528,
     740,   747,   282,  1445,     0,     0,     0,     0,  1502,     0,
    1503,  1508,  1512,     0,  1509,  1510,  1417,  1421,  1419,  1402,
    1221,  1223,     0,  1162,  1468,  1469,     0,  1193,  1534,   204,
    1570,   741,     0,   282,   780,   434,   404,  1841,   405,   779,
     786,   786,     0,   434,   564,     0,   252,   292,     0,     0,
     617,   606,     0,     0,   622,     0,     0,     0,     0,     0,
     666,   296,   322,   332,     0,   317,   871,     0,   868,   867,
     558,     0,   370,   369,     0,   413,     0,   497,     0,   615,
     989,   511,   545,   546,   541,     0,     0,   353,   362,   338,
     386,   385,   382,   381,   383,   384,   379,   378,     0,   432,
     428,   429,     0,   990,     0,  1039,     0,   773,   841,     0,
       0,     0,   476,   471,  1258,     0,  1246,   710,  1446,     0,
    1447,     0,     0,  1514,  1513,  1527,  1529,     0,     0,  1542,
    1466,   758,     0,   759,   783,   408,     0,   776,   775,   395,
     564,   390,   283,     0,   609,   616,   607,   617,     0,     0,
    1033,     0,  1034,  1035,  1038,   335,   866,   870,   869,     0,
     399,   400,   401,     0,   372,   409,   410,     0,   500,     0,
       0,     0,     0,   360,   421,   337,   991,   992,   287,     0,
     840,   843,   954,  1268,  1448,  1517,  1504,  1515,     0,     0,
    1538,     0,     0,     0,     0,   786,     0,   564,     0,   402,
     391,     0,   608,   624,   623,     0,     0,     0,     0,     0,
     411,     0,   412,   433,   614,     0,   547,     0,     0,   432,
     774,   788,   953,   952,     0,  1530,  1531,  1944,  1738,  1920,
       0,  1540,  1543,  1541,  1535,   282,   777,     0,   392,   406,
     413,     0,  1036,   548,   418,     0,   417,     0,   415,   414,
     604,   551,   286,  1281,   936,   947,   935,   937,   945,   942,
     944,   943,   941,     0,  1547,  1546,  1545,  1549,  1548,   760,
       0,   564,   610,     0,   416,   420,   419,   553,   555,   556,
       0,   549,   552,   554,   557,   764,     0,   946,   940,  1161,
    1148,     0,   407,   393,     0,   530,     0,   938,   947,  1544,
       0,   550,   939,     0,   551,     0,   531
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    50,    51,    52,    53,  1123,  1916,  1815,  2477,  2478,
      54,    55,  1181,    56,    57,    58,    59,    60,    61,    62,
    1154,    63,    64,   817,  1305,  1927,    65,  1726,   656,  1571,
    1572,  1867,  1573,  1562,  1045,  1387,  1124,  1146,    67,    68,
    1039,  1553,    69,    70,    71,  1167,  1168,  1131,  1342,  3576,
    1803,  3749,  2336,  2337,    72,    73,  2440,  1251,  2442,  2443,
    2874,   500,  1890,  3222,  3223,  2862,  2863,  3229,  3451,  3452,
      74,  1302,  2506,  2952,  2507,  3293,  2508,  3294,  2509,  3295,
    2470,  2921,  2922,  2923,  2510,  3299,  3626,  2511,  1741,   912,
    1406,  1407,  3605,  3150,  3151,  3727,  3694,  3695,  3696,  3778,
    3301,  2517,  2962,  3306,  3478,   575,  1322,  1958,  2512,  2513,
    2950,    76,    77,  1953,  1196,  1197,  1821,  2878,  2591,    78,
     834,  2779,  3516,  2471,  2472,    79,   188,    80,  1309,    81,
      82,    83,    84,  2925,  3479,  1201,  2384,  2385,  2386,  2387,
    2830,    85,  1307,  1202,  1936,    86,    87,    88,  1856,    89,
      90,    91,  1316,  1947,  1948,  3285,  3486,  3614,  3488,  3810,
    3811,  3470,  3240,  3241,  3242,    92,    93,    94,    95,  1301,
    1919,  1920,  2879,  1113,  1255,  1893,  1894,  2941,  2942,    96,
    3181,  3182,   527,  3700,  3676,    97,    98,  3185,  3186,    99,
     100,   101,   102,   103,   569,   877,   878,  2310,   104,  1667,
     105,   796,  2427,   106,   598,   892,   893,   107,   108,   607,
    2070,   609,  1420,  2593,  2594,  3028,  2035,   731,   109,   110,
    2045,  2073,   111,  1126,  1732,  1733,  3145,   112,   528,  1327,
    1961,  2279,  3636,  3152,  3414,  2243,  2752,   113,   529,  1150,
    1769,  1964,  2522,  2523,  1771,  2210,  2974,  1773,  2524,  2529,
    2530,  2531,  2970,  2978,  3510,  3511,   114,  1148,  1762,   115,
     116,   117,  1176,   749,   118,   541,   542,   119,  3598,   120,
     847,   121,   626,  1437,   122,  1784,  2794,   123,   124,   125,
    3786,  3816,  3817,  3818,  2983,  3754,   126,  3788,   923,   128,
     129,   130,   164,   768,   769,   770,   131,  3308,   132,   133,
    1913,  2469,  2904,   134,   135,  1727,  2269,   136,   137,   138,
    1295,   139,   140,   141,   142,  1233,   143,  1076,  1077,   144,
     145,   495,   674,  1080,  1088,   146,   577,   886,   887,   888,
    1389,   147,   926,  2062,   578,   880,   149,   579,  1426,  2047,
    2048,  2051,   580,  1337,   152,  1430,  2056,  2059,   581,  1670,
    1671,  1672,  1673,  1674,  2227,   582,   600,   837,  1969,   583,
    1011,   157,   158,   159,   160,   678,   679,  1547,  2200,   616,
    1095,   644,   690,  3119,  1687,  1688,  1708,  1709,  1104,  1105,
    1698,  1700,  2245,  1701,  2254,  1693,  3116,  3392,  1704,  1705,
    1107,  1108,  2249,   161,  2204,  1973,  1974,  1975,  2541,  2551,
    2992,  3326,  1976,   921,   671,  1977,  2724,  1982,  2498,  2499,
    1774,  1900,  1279,  1012,  1280,  1911,  1013,  1470,  1282,  1014,
    1015,  1016,  1285,  1017,  1018,  1019,  1020,  1454,  1511,  1021,
    1022,  1489,  1908,  1909,  1378,  2113,  1024,  1025,  3085,  3371,
    3362,  2138,  2139,  1568,  3081,  3553,  3655,  3656,  3127,  3124,
    3396,  3557,  3723,  3761,  3762,  1026,  2191,  1540,   751,  1027,
    2881,  1542,  2133,  2212,  2213,  1715,  1452,  2080,  2097,  2098,
    2110,  2640,  2117,  2122,  2663,  2664,  2134,  2160,  1028,  2083,
    2084,  2624,  1456,  1029,  1067,  1068,  1449,  2156,  1083,  1084,
     676,  1030,  1031,  1421,   665,  3322,   855,   726,  2345,  1658,
     772,   613,  1032,  1033,  1034,  1035,  2595,  1172,   491,   721,
    2388,   492,   493,   723,  1663
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -3255
static const int yypact[] =
{
   10997,   927,  8114, -3255, -3255,   927, -3255, 42372,   374,   477,
    1036,   138,  5379, 42778, 49680,   656,   419,   271,  9387,   927,
   49680,  2629, 33440, 38312,   686, 49680,  1007,   719, 33440, 49680,
   50086,   828,  1016, 50492, 43184, 36688,  1037, 49680,  1015, 50898,
   43590,   769, 43996,   719, 30618, 43996,   103,   705, 51304,  1187,
    1212,   801, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255,   374, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255,   168, -3255,   653,   203,
    1095,   866, -3255, -3255, -3255, 34658, 49680, 49680,  1061, 49680,
    1279, 34658, 49680, 49680,  1140, 27709, -3255, 49680, 49680, 49680,
   49680, 43996, 49680,  1172, 49680, 49680, 51710, 49680,  1272,   101,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, 49680,  3827,  1007, -3255, -3255,
   49680,  1136, 34658, 49680,  1093,  1236, 49680, -3255, 49680,  1449,
    1179, 49680,  1309, 28128,  1318, 49680, 49680, 49680, 49680, -3255,
   -3255,  1219, 49680, 49680, -3255, 52116,  1059,  1541,  1433,   625,
   -3255, 44402, -3255, -3255, 43996, -3255, -3255, -3255, -3255, -3255,
   44808,   271, -3255, -3255, 35064, 49680,  1464, -3255, 52522, -3255,
    1538, 35470, 52928, -3255, 28547,  1626, 53334, 53740, -3255, -3255,
   54146, -3255, 54552,  1375, 54958, -3255, 55364, -3255,  1445, 55770,
   -3255,  1267,   661,  1585, 24818, -3255,   374, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255,   291,  1424,   161,   165,   192,
   -3255, -3255,   189,   195,   204,   291,  1705,  1705, -3255, 49680,
   -3255, -3255,  1424,   514,  1293,  1293,  1293,  1473,   -54, -3255,
    1293, 49680, -3255, -3255, -3255, -3255, 43996, -3255,  1308,  1007,
    1324,  1694, 49680, -3255, 49680, -3255, 49680, 49680, -3255, -3255,
    1716,  1354,  1578,  1364, -3255,  1551,  1559,  1550,    47,  1007,
    1484, -3255, -3255,  1611, 16424,  1007, 45214, 56176,   216, 44808,
    1007, 45620,  1419,   101,  1590, -3255,   590, -3255,  1821,  1480,
    1679,  1364,   101, 25642, -3255,  1486,   527, 43996, -3255, -3255,
   56582,  1591, -3255,   173,  1789, 16847, -3255, 49680,  1520, -3255,
    1542,  1527,  1556, -3255, 10997, 49680,  1032,  1032,  1929,  1032,
    1174,  1237, -3255,  1868, -3255,   705,   200, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,  1561,
     527, -3255,   212, -3255,    80,  1581,  1040, -3255, -3255,   193,
    1619,  2139,  1617,   217, -3255,  2092,   279, -3255, 49680, 49680,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,  1635,
   -3255, -3255,  1599,  1177,    87,  4593,   959,  2126,  1218,   148,
    1752,  1250,  1916,  1208,  2987, 49680,  1861,    10, -3255,   615,
   -3255,  1710,  1818,   471, 34658,  1664, -3255, 49680, -3255, -3255,
   -3255, 34658, -3255,  1853, 28966, -3255, 49680, -3255, -3255, -3255,
   -3255,  1795, 49680, -3255, -3255,  1918, 49680, -3255,  1293,   188,
    1690,  2071, 62222, 49680,  1743,  2111,  1751, -3255, -3255,  1743,
   -3255, -3255, 49680, 49680,  1722,  1009,  1743,  2114,  2120,  1799,
    1901,   196,   313,   140,  2021,  1743, 49680, 49680, 49680, 49680,
    2096, 34658, 49680, -3255,  1889, -3255, -3255,   822,  1796, -3255,
   -3255, -3255, -3255,  2035,  1561,   210,  2040,  1748,  2041, -3255,
    1782,  2043,  1617,  2047,  1754, -3255, 56988, 57394,  2050,  1635,
   49680,  2051,  1754,  2052,  1939,  2058,   210,  2060, -3255,   726,
    2061,  1947,  2065,  1459,  1754, 46026,  2066,   206, -3255, 18539,
   -3255,  1857, -3255,   705, -3255, -3255,   879, -3255, 33034, -3255,
    1585,  1424, -3255, 49680,  1424, 49680,  1424, 49680,  1424, 49680,
    1424, 49680, 49680, 49680,  1424, -3255, -3255, -3255, 49680,  1779,
   49680, 49680, -3255, -3255, -3255, 39124, 49680, 39530, -3255,   569,
   -3255,   276,  1007, -3255, -3255, 62222,  2178, 49680,  2069,  2069,
    2069, -3255, -3255, -3255,  2007, 49680,  2067,  2072, 39124, 49680,
   -3255, 57800,  1797, -3255, -3255, -3255, -3255, -3255,  1304,  2219,
     144,  2220, 18539,  1802,   159,   159,  1803, -3255, -3255, -3255,
     213,  1805,  1806, -3255,   157,   157,  1959,  1812,  1813, -3255,
     191,  1814,  2239,  2240,   219,  1823,  1824,  1833,  1607,   159,
   18539, -3255,  1836,   157,  1837,  1838,  1839,  2241,  1840, -3255,
    2249,  1841,   234,   290,  1843,  1844, -3255,  1812, -3255,   175,
    1845,  1846,  1847,  1848,  1850,  1852,  1863, 18539, 18539, -3255,
   15578,   527,  1007, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
      93, -3255,   225,  3810, -3255, -3255,  2028, 18539, -3255, -3255,
     457, -3255,   226, -3255, -3255, -3255,   527, -3255, -3255,   714,
    1864, -3255,  1418, -3255, -3255, -3255, -3255, -3255, -3255, 40342,
    2261, -3255,   277,   615,  1165,  2210, 32222, 32628, -3255, -3255,
    2094, -3255, 49680, -3255, -3255, 18539, 30212, -3255,   527,    96,
   49680, -3255, 26054, -3255, -3255, -3255,   991, -3255, -3255, -3255,
     374, -3255,  9970, -3255,  1116,  1520, 49680, 49680,  2268, -3255,
   -3255, -3255,  1542, -3255, -3255,  1095,  1095, 18539,  1095,   636,
    1010, 17270, 18539,  2155,  2053,   177,   155,  2159, -3255,  1174,
    1237, -3255, 31430,  1295,   527,  1950,  1951, 33846,  1881,  1954,
    1955, 58206, -3255, -3255, -3255, -3255,  1029,   676,   837,  1956,
     130, -3255, 49680,  2063,   279,  1998, -3255,  1960,  1961,  2075,
     279,   224, 58612, -3255, -3255, -3255, -3255, -3255,  2353, 14365,
   -3255, -3255, -3255,  1963,  1945, 35876,  2254,  2073,    40,  1160,
     154, 49680,  2150,  1982,  1983,  1914,  1156,  1911, -3255, -3255,
     359,  2077, -3255,  1967,  1970, 61026,  2083, 29385,  2250,  1994,
   -3255,    15,  1995,  1997,   279, -3255,  2306,   279,   279,  1152,
    2307,  2002,   232,    -6,  1743,  1911,  2852, -3255,  1935,  2006,
     474, -3255,  2107,   156,   917,  1911,  2008,  2012,  1914,  1914,
   49680, 49680, 49680, 49680, 49680,  2024,  2025,  2076, 40748,  2026,
   56176, -3255, -3255,  2027,  1178,  1911,   774,  1104, -3255, -3255,
     101, -3255, 49680, -3255, 49680,  1561, 62222,  2125,  1617,   279,
   49680, 49680,  1635,  1112,   750,  2136, 49680,  2200,  2001, -3255,
   -3255,  1743, -3255, 31826,  1722, -3255,  1969, -3255, -3255,  2013,
   -3255,  2013,  2013,  1974,  1974,  1976, -3255, -3255, -3255,  1607,
    2013,  1974, -3255, 63012, -3255,  1173,  1180, -3255,  2364,  2374,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,    95,
    1478, -3255,  2385, -3255, -3255, 62222, 49680, -3255,  2302,  2032,
   33846, -3255,  2022, -3255, 49680,   236,  1007,  2030, 49680,  2198,
   49680, 49680, 49680, 49680, -3255, -3255,   717,    46, -3255, 40748,
   -3255,  2852,  2380,     5,  1293,  2272, -3255, 49680,  1996,  2391,
    2228, -3255,  1257, -3255,  2117, -3255, 23170,  2036, 34658,   210,
   -3255, -3255, -3255, -3255, 62222, 49680, 59018, 34658,   210, 49680,
   49680,  2294,  2055,  2304,  2068, 29385,   210,   382, 49680, 49680,
   49680, 49680, -3255, 49680, -3255, -3255, -3255, -3255, 49680, 49680,
   49680, 40748,  2310,  2312,   210, 49680, 49680, -3255,  9970,  1151,
   49680,  1585, 39936, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, 49680, -3255, 49680, -3255, 49680, -3255, 49680, -3255, 49680,
   -3255, -3255, -3255, 49680, -3255, 49680,  1243, -3255, -3255,  1255,
      90, 49680,   110, 34658, 49680,  2195, 49680, 49680, 49680, 49680,
    2087,  1864,   982, -3255,  2082, 25230,  2149, -3255,   174, 43996,
    2222, -3255, -3255,  1274,   690,   -19, -3255, -3255, -3255, -3255,
   -3255, -3255, 39530, 38312,  2316,   150, 49680, -3255, 18539,   527,
   16001, -3255, -3255, -3255,  2046,  9970,  2091, 18539, -3255, -3255,
   18539,  1705,  1705, 18539, -3255, -3255, -3255, -3255,  1203,  1705,
   -3255, 18539, 18539,  1705,  1705,  2013,  2013, -3255,  3699, 18539,
   -3255, 29385, 18539, 21077, 13537, 18539,  2122,  2074,  1705, -3255,
    1705, -3255, 18539, 15155, -3255, 18539,  2257, 18539,  1165,  2258,
   18539,  1165,  2473,  2473,  1200,  4098,  2056,   527, -3255,  2165,
    1705, -3255,  1705,   687, -3255,   162, 62222, 18539, 33846,  2138,
     205, 18539,  2070,   869, -3255, 18539,   222, -3255,  2080, 18539,
    2141, 18539, 18539, 18539, 18539, 18539, 18539, 18539, 18539, 18539,
   -3255, 21923,   243,   418,   933, 46432, 16424,  2343, 13113, -3255,
     141, -3255, -3255, -3255, 49680,  2261, -3255, -3255,  2140, -3255,
   -3255, -3255, -3255, -3255,   228, -3255, -3255, -3255, -3255, -3255,
   -3255,  2084, -3255, -3255, -3255, -3255,  2084, -3255,  2086,  1866,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255,  2334,  2336,   210, -3255, 49680,
      60, -3255, -3255, -3255,  2103, -3255, 49680,   173, 41154, -3255,
   16847, -3255,  1310,  1812, -3255,  2333, -3255,  2098, -3255,  6857,
    2333, -3255, -3255,   255,  2276,  2285,  2285, -3255,  2104,  9970,
   -3255,  1373,  9970,  1471, -3255, -3255, -3255, -3255, -3255, -3255,
      32, -3255,  2155,   155,  2108,  1316,  2180,  2183,  2229, 49680,
   49680, -3255, 33846, 49680, 49680, 49680, -3255,  2467,   695, 38312,
    2232, 37094, -3255, -3255,  2119, 49680,  2170,  2351,  2355,  2127,
   -3255, -3255, 49680, -3255,  2309, 49680, 18539,  2313, 49680,   961,
    2314, -3255,   832, 49680, 49680,  2303, -3255, -3255, -3255, 44808,
   -3255, -3255, -3255,  2299, -3255, -3255, 63012, -3255, -3255,  1317,
   -3255, 62617, 59424, -3255, -3255,   426, 49680, 49680, 49680,   -35,
   -3255, -3255, 62222, -3255, 49680, 49680, 49680, 41560, 59819, 60225,
     754,   856, 49680, 41966, -3255, 49680, 49680, 49680, 33846, -3255,
   49680,  2317,   245, -3255,  2678, -3255,  2205, 49680, 49680,  2142,
    1328,  2213, -3255, 49680, 49680,  2703, -3255, 49680, 49680, -3255,
   -3255,   279, -3255, -3255, -3255, -3255, -3255, 49680, 49680,   279,
   49680,   279,  1025, -3255, 34252, 49680, -3255, -3255, -3255, 49680,
   49680, 49680, 49680, 49680, -3255, -3255,   996,     6,  2280,  2281,
    2282, 49680, 49680, 49680, -3255, -3255,  2259, -3255, 49680,  2703,
   49680, 49680,  2214,  2221,   180,  2293, -3255, -3255, -3255, -3255,
   -3255, -3255,  2388,  2549, 49680,  2390,  2392,  2211,  2212,  2394,
     692, 49680, 49680, 49680, 49680, 49680, 49680,  2397,   692,  2339,
      98,  2167,  2181,  1329, -3255, -3255, 18539,  2560, 62222,  2171,
    2172,  2245,  2246,  2247, -3255,  2179,  2248,  1705, -3255, -3255,
    1570, -3255,   717,  1021, -3255,    22,  2586,  2451, 49680,  1330,
   -3255,  2194, 49680,  2586, -3255,  1327, 38312, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255,  2460, -3255,  1007,  1722,
    1722,  1722,  1722, -3255, -3255, -3255,  2361,  1133, -3255,  2185,
   49680,  2292,  2586, -3255,  2852,   762, 49680, 36282,  1394,  2583,
    1007,  2365, -3255, 14760,  3324,  2367, 44808,  2453,  2457,  2475,
   -3255, 22758, 46838,  2192,  1467, -3255, 46838, 47244, -3255,  2197,
     527, 18962,  2149,  1561, -3255,  2592, -3255,  2489,   210,  1617,
   -3255,  1754, -3255, 49680, 49680, 49680, 49680,  1635, -3255, -3255,
    1754,  2375,   210,   210, -3255,  2376,   210,  1754,  2318,  2480,
   44808, -3255,   206, -3255, -3255, 18539,  2203, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255,  1335, -3255, 49680, -3255,  2459,
    2461,  2463,  1754,  2243, 49680,  2215, -3255,  1754,   279,  1754,
    1864,  1864,  1754, 47650,  2620,  2484, -3255,  1337, -3255, -3255,
   16424, -3255,   145, -3255,   146,   770,  2422, -3255, -3255, -3255,
   -3255, 62222, -3255, -3255, -3255, -3255, -3255, 49680,   107,  2396,
    2216, 47650,  2596,   210, -3255,  1343, -3255, -3255,  1163, -3255,
    1201, 18539, 18539,    89, -3255,  7161,  1347,  2223,  2225,  1353,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255,  2227,  2498, -3255,
    2231,  1359,  1367,  2235,  2237, -3255, -3255,  2902,  2238,  7460,
    2252, 21077, 21077,  1144, -3255, -3255, 21077,  2253, -3255,  1369,
    3892,  2236,  2255,  2263, -3255,  2256,  2260,  7731, 17693, 18539,
   17693, 17693,  7762,  2236,  2262,  1371, 33846,  8845,  1386, -3255,
   18539, 33846,  3497, 18539, -3255, 18539, 49680,  2264,  2275, -3255,
   -3255,  3699, -3255,  2266, -3255, 21077, 21077,  3348, 15578, -3255,
   -3255,  2508, -3255, -3255,   655, -3255,  2251, -3255, -3255,  4360,
     220, 18539,  2070, 18539,  2311, 29385, 10001, 18539,  4800,  3006,
    3006,   292,   292,   231,   231,   231,  1392,   933, -3255, -3255,
   -3255,  2278,  1840, 18539, -3255,  1528,  1547, 49680,  1829,  3138,
   -3255, -3255, -3255, 23170,  2283, 18539, 18539, 18539,  2279,  2424,
    2672,  9970,   601, -3255,  2691, -3255,   101,  1705,   687, 33034,
   -3255, -3255, 18539, -3255, -3255, -3255, -3255,  1402, 26054,  2036,
   16847,   527,  1542, -3255, -3255, -3255, -3255, -3255, -3255, 18539,
   -3255, -3255,   415,  1410, 18539,  1373, -3255, -3255, 49680,  2222,
    2222, 18539, -3255, -3255, -3255, -3255, -3255, -3255, -3255, 49680,
   49680, 49680, -3255, -3255, -3255, -3255, -3255, -3255,  2509, -3255,
   49680, 49680,  2465, 49680,  2464,  2466, 18539,   388, 49680,  2295,
    2296,  2297, 49680,   210, -3255, -3255,  9970, -3255, -3255,  2341,
    2369, 49680,  2107, -3255,  2546, -3255, -3255, -3255, -3255,  2486,
   -3255, -3255,  1478, -3255, 59424, 62617, -3255, 62617, -3255,  1478,
    1240, -3255,  1754, -3255, -3255,   437, -3255, -3255, -3255, -3255,
   -3255,  2594,   210,  2595,   210, 49680, 49680, 49680, 49680, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255,  1409, -3255,   895, -3255,
   -3255, -3255, -3255, -3255, 49680,   953, -3255,   209, 62222, -3255,
   61421, 49680, -3255, -3255,  2525, -3255, -3255, -3255,  2469, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255,   713, -3255,  2476,
   49680,  2371, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, 33846, 33846, 33846,  1417, -3255, -3255,  1007, -3255, -3255,
   -3255,  2378, -3255, -3255, -3255,  2533,  2534,  2536,  2398,  2399,
    2400,  2402, -3255,  2405,  2407,  2409, -3255, -3255, -3255, 49680,
   -3255, -3255, -3255, 49680, 49680, -3255, -3255, -3255,   692, 62222,
    2574,   692,   692, 49680, 49680,   692, -3255, -3255, -3255,  2575,
    2577,  2580,  2581,  2587,  2588,   692, -3255, -3255, -3255, -3255,
     188, 33846, -3255,  1878, 27290, -3255,  2771,  4462,  2354,  2172,
    2356,  1705,   197,   624,   816,  2468,  1705,  2559,  2358, -3255,
    1380,  2582,  2377,  2377,  2377,  2377,  2377,  2377,  2377, -3255,
    2785, -3255,  2535, 49680,   117, 49680,  1705, -3255, -3255,  2427,
   -3255, -3255, 33846, 27290,  1293,   236,  2499,  1167,  2696, -3255,
   -3255, -3255, -3255, -3255, 49680, 49680,   717,  1007,  1434, -3255,
   62222, 49680, 49680,  2403,  2372, 49680,  2379,  2382, -3255, -3255,
   -3255, -3255,  1438, -3255, 62222,   497,  2548,  2552,  1187,  2452,
   49680, -3255,  1440,    78, -3255,  1007, 44808, 60631, -3255,  2445,
   -3255, -3255,   181,  2647, -3255, -3255,  1187, 13952,  1467,  2383,
   49680, -3255,  2401, 23170,  2614,  2564, -3255, 23170,  2564,   929,
    2564,  2630, -3255, 26466, -3255,  2408, 13113,  1094,  2578,  9970,
   -3255,   210, 62222, 49680, -3255,   210,  2455,   210,  2477,   210,
     210, 49680, -3255, -3255, 49680, -3255, 49680, 40748,   210, -3255,
    9970, 49680, -3255, -3255,  2517,  2518,  2541, 49680,  1754, 34658,
   -3255,  2428, 49680,  1069, -3255, -3255,  2602, -3255,  1187, 49680,
     527,  2431, -3255, -3255, -3255, -3255,  2728,  2729, -3255, -3255,
   -3255, 49680, 39124,   401, 49680, -3255, -3255, -3255, -3255,  2440,
    1456,  8149, 18539, -3255,  2738, 62222, -3255, -3255, -3255, -3255,
   -3255, 18539, -3255, -3255, -3255, -3255, -3255, 18539, -3255, 18539,
    2716, -3255,  2856,  2856, 62222, 21077,  1091,  1837, 21077, 21077,
   21077, 21077, 21077, 21077, 21077, 21077, 21077, 22346,   384, -3255,
   -3255, 18539, 18539,  2723,  2716, -3255, -3255,   979,   979, 62222,
    2443,  2236,  2444,  2446, 18539, -3255, -3255,  1458, 33846, -3255,
   18539,  6888,  1460,  2494,  8955,   527,  4567, -3255,  2825,  1007,
   18539,  1663,  1720, 18539,  1470, 18539,  2733, -3255, -3255, -3255,
    2462, -3255, -3255, 62222, 18539, 21077, 21077,  4680, -3255,  5196,
   18539,  2479,  6054, 15578, -3255,   719,   719,   719,   719, -3255,
   49680, 49680,  2192, 18539,  2730,   304,   304,  2482,  2424, 26878,
   -3255, 18539,   214, 18116,  2483,   615,  2485, -3255, -3255,  5788,
    2487, 49680, -3255,  2149, -3255, -3255, -3255,  2481, -3255,  1410,
   -3255, -3255, -3255,  4918,  2642,  1864, -3255, -3255, -3255, -3255,
   -3255, -3255,  2377,  1754,  1754,   118,  1754,  2756,   118,  5137,
   -3255, -3255, 23582, 49680, 49680,  1483, -3255, -3255, 49680, -3255,
    1581, -3255, -3255,  2721,  1270, -3255, -3255, -3255,  2550,  2785,
     753,  1914,   664, -3255,  2551, 49680, -3255, 49680, -3255, -3255,
   -3255, -3255, -3255, -3255, 33846, 27290, 33846, -3255,  2557,  2561,
     593,   158,  2563,  2566,  2493,  2496,  2497, -3255,   291,  1007,
   -3255, -3255,  1007,  1754,  1007, -3255, -3255, -3255, -3255, 34252,
   -3255, -3255, 49680,  2780,   121,  1475, 49680, 49680, 49680, 49680,
   49680, 49680, 49680,  2107, -3255, -3255, -3255,  2502,   692, -3255,
   -3255,  2740,  2741, -3255,   692,   692,   692,   692,   692,   692,
   -3255,   178,  1488, -3255, 24406, -3255, -3255,  2111,  2111,    97,
   -3255,  2111, -3255,  2111, -3255,  2481,  1705,   359, -3255, -3255,
   -3255, -3255, -3255, -3255,  2181, -3255,   755,  1705,  1533,  2516,
   -3255,  2521, -3255, -3255, -3255, -3255, -3255, -3255,  2515, -3255,
     687, 49680,  2377, -3255,  1311,   314,  1014,  1066, 48056, 48462,
   48868,  2522, 49680, 21077, -3255,  1150,   186, -3255,  2751, 49680,
    2562, -3255, -3255, -3255,  2524, -3255,  1754, 49680, 49680,  1754,
   -3255, 62222, -3255, -3255,  2921,   661, 49680,  2569,  2527,  2812,
   -3255,  2532,  2530, -3255, -3255, 49680, -3255,  2535,  1267,   831,
   -3255, 37500,  1394, -3255,  2789, 36282, -3255, 49680, -3255, -3255,
   -3255,  2892,  2619,  2576,  1007,  2170, -3255, 59424, 18539, 18539,
   -3255,  2540, -3255,  2553,  4967, -3255,  1722, -3255, -3255, -3255,
   -3255, -3255, -3255,  2618, 49680, -3255, 46838,  2554, 49680,  1467,
   23170, -3255, -3255,  1689, -3255, 23170,  2783, -3255, 23170, 49680,
    2558, 49680,   620, 49680, -3255,  2567,   210, -3255, 49680, -3255,
   49680, -3255, -3255,   210,   210, -3255,  2666, -3255, -3255, 49680,
   49680, 49680,  1754, -3255,   279, -3255,  2833, 47650, -3255, -3255,
   -3255, -3255, -3255, -3255,   150,  2844, -3255, -3255, -3255, -3255,
   18539,  9970, -3255,  2570,  9970,  5419,  9970,  2723, -3255,  2090,
    2847, -3255,   984,  2579,  2090,  2145,  2145,   344,   344,   233,
     233,   233,  2856,   384,  9970,  9970, -3255, -3255, -3255, -3255,
    2573, -3255, -3255, -3255,  2236, -3255, 19385, -3255, -3255,  2613,
    2616,  2584, -3255, 18539, 19808,  2589, 63012, -3255, -3255,   687,
    2473, 21077, 21077,  1405, -3255,   833, 18539, 62222,  1493,  1405,
    1952,  2038, 18539, 18539,  6411,   331, 18539,  5773, 49680, 49680,
   49680, 49680, -3255, -3255,  9970,  2960,  2848, 18539,  2590, -3255,
    2593,  2424, -3255, 61816, -3255, -3255,  9970, -3255, -3255, 18539,
   -3255,  2424,  1007, -3255,   705, -3255, -3255, 29385, -3255, -3255,
   -3255,   291, -3255, -3255, -3255,  2657, 38312,  2865,   755, 18539,
    1498, -3255,  2628, 49274, 12688,  1506,  1508,  2562, -3255,  1881,
   -3255,  2659, -3255,  2784, -3255, -3255,  2786,   291, 49680, -3255,
   62222,   210,   210, -3255, -3255,  2617, 49680, 49680,  1705,  1705,
   62222,  2603, -3255,  1705,  1705,  2605, -3255, 49680, 49680, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, 49680, 49680,
   49680, 49680,  2890, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255,  2840, -3255,   692,   692, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255,  1743,  2924, -3255, 33846, -3255, 38718, -3255, -3255,
   -3255,  1007,  1007,  2794, 31024,  1007,  1007, -3255,  1298,  2932,
   -3255,  2862,   185,  2621,   702,  2889, -3255, -3255, -3255, -3255,
    2893,   291, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, 18539,   670,  2090,
   -3255, -3255, -3255, -3255,  2562,  1293,  2671, 33846,  1754,  1754,
    2673,  1187,    38, 49680,  2927,  2663, -3255,  1007, -3255, -3255,
   -3255, -3255,  2955,  1510, -3255, -3255, -3255,  2661,  2552,   969,
    2631,  1394, -3255, -3255,   184, 49680, -3255,   872, -3255,  2905,
    2634, -3255,  9970,  9970,  1007, 63407,  2445, -3255, 49680,  2882,
   -3255, 49680,  1516, -3255, 18539,  2636, -3255, -3255, 23170,  1689,
    1540, 49680,  1552, 62222,  2424, -3255,   210, -3255,   210,   210,
   -3255, -3255, 49680,  1754,  1754,  1754, -3255,  2809, -3255,   210,
   47650,  9970, -3255, -3255, -3255, 21077,  2914, -3255,  2640, 62222,
   -3255,  2641,  1564,  1565, -3255, -3255, -3255,  5973,  2694,  9970,
    2744,  2650,  2656, -3255,  1076,  1076,   833,  1586, -3255, 21077,
   21077,  1405,  1405, 18539,  1405, -3255, -3255, -3255, -3255, -3255,
   18539, 18539,  2692,  2424,  2424, -3255,  2817, -3255,  2662, -3255,
     687, -3255,  2664, -3255, 47650,  2836, 47650, -3255,  6275,  2562,
   23582, 29804, 49680, -3255,   839,   839,  2800,  2562,  2671, -3255,
   -3255, -3255, -3255, -3255,  2717, -3255, -3255, 27290, -3255, -3255,
   23994, 29385, -3255,   593,  2670,  2675,   158, -3255, -3255,  1080,
     691,  2699,  1754,  2952,   692, -3255, -3255,  2167,  1007, -3255,
   -3255,  1592, -3255, -3255, -3255, 49680, -3255,  2527, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, 34658,  3071,  3071, 49680,
     755, -3255,  6313,  2861, -3255,  2671,  2888,  2933, -3255,  1593,
   -3255, 49680,  2576, 36282,  2535, -3255,   786,  2680,  2975, -3255,
   -3255, -3255, 37500,  2855,  2619,   704,   704, 49680,  2552,  2810,
   -3255,  2814, -3255,  3068,  2875,  3076, 49680, 23582, -3255, 62617,
   -3255,  1594, -3255, -3255,  2283, 49680,    22,  1601, -3255,  9970,
   49680, -3255, -3255, -3255,  1602, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255,   401,   777, 21077, 62222,  1608, 18539, -3255, 18539,
   -3255, -3255, -3255,    68, -3255, -3255, -3255,  1076,  1076,  1405,
    2236,  9970, 49680, -3255, -3255, -3255,  3089,  2883,  2424, -3255,
   -3255,  1069,   118,   401, 49274,  2671, -3255,  2718, -3255, -3255,
    1410,  1410, 49680,  2671,   755, 18539, -3255, -3255, 62222,  1617,
     538, -3255, 62222, 62222, -3255, 49680, 49680, 49680, 49680, 49680,
   -3255, -3255, -3255, -3255, 38718,  2527,  3071,   758, -3255, -3255,
   -3255,  2996, -3255, -3255,   619,  2894,  2797, -3255, 33846,  3007,
   -3255, -3255, -3255, -3255, -3255, 18539,  2867, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,  1612,  2619,
   -3255, -3255,  2897, -3255,  2898, -3255,  1614, -3255, -3255,  4967,
   63407,  3029, -3255, -3255, -3255,  1621, -3255, -3255,   777,  1627,
   -3255,  1633,  1641,  2774, -3255,  2731, -3255,  3130, 18539,   803,
   -3255, -3255,  3014, -3255,   839,  2776, 29385, -3255, -3255,  1293,
     755, -3255,  9970,  1661, -3255, -3255, -3255,  2881,  1665,  1682,
    2742,  2777,  2742, -3255,  1754, -3255, -3255, -3255, -3255,  3048,
   -3255, -3255, -3255,   164, -3255,  2923,  2926, 49680, -3255, 49680,
    3144,  6619, 34658,  2785, -3255, -3255, -3255, -3255,  2787, 23582,
    2445, -3255,   732, -3255, -3255, -3255, -3255, -3255, 49680,  2753,
    2236, 20231, 20231,  2754, 47650,  1410,  2757,   755,  2755,  2888,
   -3255, 34658, -3255, -3255, -3255, 49680,  2879,   490,   490,  3077,
   -3255,  2815, -3255, -3255, -3255,   593, -3255,  2762,  1914,  2619,
   -3255, -3255, -3255, -3255,  1209, -3255, -3255, 21500,  2884,   701,
    7093, -3255, -3255, -3255, -3255,   401, -3255, 18539, -3255, -3255,
    2894,  1617, -3255,  2663, -3255,  3172, -3255,   183, -3255, -3255,
    2603, 37906, -3255,  2283, -3255,  1834, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255,  3163, -3255, -3255, -3255, -3255, -3255, -3255,
    6739,   755, -3255,  3058, -3255, -3255, -3255, -3255, -3255, -3255,
    1683, -3255, -3255, -3255, -3255, -3255,  1576, -3255, -3255,  1667,
    1556, 20654, -3255, -3255,  2912, -3255, 37906, -3255,  1834, -3255,
   34658, -3255, -3255,  2778, 37906,  1697, -3255
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -3255, -3255, -3255,  2512, -3255,  -700,   -24,  1980, -1488, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255,  1278, -3255, -3255,   102,  1333,  2151,
     987, -3255,  -868, -3255, -3255,  -497,   129,  -575, -3255, -3255,
   -3255, -3255, -3255, -3255, -3255,   821,  1403,   894,  -465, -3255,
   -1136, -3255, -3255,   406, -3255, -3255, -3255,   773,  -233, -3255,
   -3255, -3255, -3255, -3255, -3255, -3255,   -10, -3255, -3255,  -377,
   -1222,    27, -3255, -3255, -3255, -3255,   265,  -271, -1018, -3255,
   -2262, -3255,   -44, -3255, -3255, -3255,  -267, -1095,   948,  -583,
    -883,  1204,  -499, -3255,  -178, -3255,  -537,  -462,  -460,  -502,
   -3255, -2780, -3039, -2792, -2523,   132, -3255, -3255, -3255,   280,
   -3255, -1204, -3255, -3255,  1917, -1065, -3255,  -680, -3255, -3255,
   -3255, -2837, -3255,  1490,  -274, -3255,    84, -3255, -3255, -3255,
   -3255, -3255, -3255, -2807, -3255, -1145, -3255,   414, -2284,   862,
   -3255, -3255, -3255,  1938, -3255, -3255, -3255, -3255, -1245, -3255,
   -3255, -1199, -3255,  1336,   756, -3255, -3255, -3255,  -524,  -581,
    -572, -3255, -3004,    14,    17, -3255, -3255, -3255, -3255,  -782,
   -3255,   778, -2361,  -721, -3255, -3255,   817, -3255, -3255, -3255,
    -483,  -169,  1968, -3255,  -412, -3255, -3255, -3255,  -167, -3255,
   -3255, -3255, -3255, -3255, -3255, -1344,   -75,  -688, -3255, -3255,
   -3255, -3255, -1679, -3255,  3242,  1451,  1050, -1197, -3255,   -16,
      45,  2357,  -904, -2004,   244,  -289, -3255, -1378, -3255, -3255,
   -3255, -1956, -3255, -3255, -3255, -3255, -2656, -1194, -3255, -3255,
   -3255,   308, -3255, -3254, -2908, -3177, -2628, -3255, -3255,  -845,
   -3255, -3255, -3255, -1061,  1504, -1116, -3255, -1717,   310, -2844,
    -533, -2454, -3255, -2775,  -355, -3255, -3255, -3255, -3255, -3255,
   -3255, -3255,  -844,  -507, -3255, -3255,  2745, -3255, -3194, -3255,
   -3255, -3255, -3255,  1122, -3255,   -98, -3255, -3255, -3255, -3255,
   -3255, -3255,  -467,  -539, -3255, -3255, -3255,   133, -3255, -3255,
   -3255, -3255,  1597,  -724,  -595,  2632, -1192,  -192, -3255, -3255,
   -3255, -3255, -2310, -3255, -3255, -3255, -3255, -3255, -3255, -3255,
   -1133, -3255, -3255, -3255, -3255, -3255, -3255, -3255,  1615,  1613,
      44,   -21, -3255, -3255, -1010, -3255,  -445, -3255,  1913, -3255,
   -3255, -3255, -3255, -3255,   134,   349, -3255,     2, -3255, -3255,
     700, -1855,     3, -3255, -3255, -3255, -3255,  -288,     4, -3255,
    1073, -3255, -3255, -1569, -3255,   136,    63, -3255, -3255,     1,
       0,   -40,   -67,   -43, -3255,  2625,  2217, -3255, -3255,   -18,
    1472, -3255,  -681,  -144, -3255,  1065,  -542,  1595,  2201,  2206,
   -3255,  1056, -3255, -3255,  1067, -3255, -3255, -3255,  -523,  1605,
   -3255,  2226,  1628, -3255,  1643,  1123, -1886,  1356, -1858,   780,
    -386,     7,    42,  2667,  2796, -3255, -3245,  1106, -2814,   397,
    -697,  1446, -1233, -3255, -3255,  -914,  7127, -3255, -3255, -3255,
    7435,  7545, -3255, -3255,  7573,  7815, -3255,  -777,   657,  8376,
      70,  -951, -1467,  -605,  6309, -1673,  -322, -1265, -3255, -3255,
   -3255,  -191,   667,   626, -3255, -3255, -3255,  -370, -2095,  -369,
   -3255, -3255, -3255,  -373, -2832, -1380, -3255,  -170, -3255,  9075,
    1109, -3255,  -781, -2030, -2111,  -889, -1372, -3255, -3255, -3255,
   -3255, -3255, -3255, -3255, -1211, -2497,  -429,  1181, -3255, -3255,
    1271, -3255, -3255, -3255, -1007,  -690, -1537,  1188, -1538, -3255,
    -669,  1307,  1815,  -633,   230,  -490,  5229,  -458, -1749,  -978,
    -930, -3255,  -155, -3255,    16,    -9,   -91,    -4,  2947,  6770,
   -1002,  6139,  -974,  -931, -2324
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1995
static const yytype_int16 yytable[] =
{
     156,   155,   150,   151,   153,   750,   814,  1348,   543,   682,
     719,   501,  1109,  1040,   691,  1356,   732,   614,   602,   637,
    1386,   156,   913,   914,   602,   667,  1111,   918,  1409,  1799,
    1114,  2012,  1740,  1772,  1444,  2036,  1433,  1118,   601,   526,
    1897,  1318,  1491,   839,   601,  1231,  2149,   859,   804,   681,
    1464,  1465,  2789,  1180,  2306,  2308,  1171,  1838,  1053,  2347,
    1781,  1664,   854,  1221,  1659,   576,   862,  2613,   608,  1480,
     489,  1978,  1844,  1845,  1951,  2977,   874,   533,  2079,  1254,
     638,   733,  1684,  1928,   664,  2538,   753,   670,  1770,  2597,
     849,   724,  1661,   693,   729,   763,  2727,  2825,  1379,  2827,
    2226,  1929,   568,  2115,  1293,  1278,  1930,  1664,  1931,  1297,
     761,  1932,  3147,  1933,  2730,  1659,  1303,   694,  2552,  2554,
    2883,  3138,  2933,  1339,   685,  1320,  2008,  2560,   882,    66,
    3316,  1833,    75,   127,   148,  1662,   154,  1780,  2231,  1721,
    3289,   655,  2236,  1661,  3407,  3276, -1662,  3319,  1103, -1344,
    1509,  1125,  1047,  2905,  2906,  2907,  2908,  2909,  2910,  2883,
     692, -1707, -1311,  2194, -1344, -1772,  3066,  1106, -1149,  2480,
     584,  1317,  3298,  1665,  1949,  2725,  2726,  1458,  1459,  1790,
   -1339,   499,  2968,   894, -1556,  3330,  1662,  3332,  1222, -1805,
    2052, -1556, -1775,   539,  1901, -1825, -1324,   939,  1147,     3,
       4,   584,  1477, -1152, -1855, -1685,   584,  2033,  1388,  2436,
    2203,  1127,  2622, -1685,   898,  1248, -1344, -1686, -1994,   539,
    1210,   539,  1783,   757, -1351, -1686, -1994,  2810,  1432,  1506,
     539,   539, -1339,   539,  1746,  1151,  -110,  3570,  3571, -1354,
    2154,  -110,  1516,  2029,  2644,  2567,  3415,  2569,  2438, -1149,
    2415,  2289,  1956,  3637,   672,  2154,  1340,  2611,  1902,  3494,
    1340,  1211,  1228,  2170,   584,  2188,  3199,  1519,  1310,  3641,
    2400,  3142,  2189,  3737,  3599,  2927,   539,  1242,  2602,  2604,
    1559,  1169,   539,  1169, -1152,  1956,   584,  3805,   584,  -325,
    2979,  3237,  3272,  3499,   766, -1354,  1099,  3653,  1921,  2401,
     584,   916,  1869,  1516,  1830,  3500,  2072,  2053,  2341,  1311,
    3183,   590,    34,  1903,  1128,   590,  1904,  1925,  1099,   539,
    1044,  1507,  1073, -1149,  1074,  1491,  1661,  2372,  1519,  1231,
    2811,   591,  1757,  1314,  3233,   591,  2067,  1220,  1152,   590,
    2278,  1800,   590,   750,  1115,   590,  1550,   800,  1786,  1464,
    1465,  1182,  1315, -1572,   590,  2644,  1695,  1480, -1152,   591,
   -1572,  1101,   591,  1805,  2980,   591, -1824,  1747,   584,  1662,
    1357,  2372,  1563,  1116,   591,   917,  1574,  1574,  1374,  3234,
    1183,  1560,  3418,  1101,   750,   767,  1801,  1802,  2171,   844,
    -772,  1926,  2172,  1875,  1666,  2644,   852,  1962,  1879,  1787,
    2291,  1362,  3686,   735,  1102,  1696,  1229,  2030,  1905,   755,
    1350,  3184,  1377,  1212,  1758,  1432,  3200,   764,  3255,  1798,
     809,  2928,  3239,   737,   816,  3806,  1422,  2173,  3273,  2034,
    1957,  1300,  1340,   805,   825,  3143,  2031,  1435,  2642,  2643,
    1748,   535,  2076,  2658,  3174,  1390,  1428,  1734,   823,  1445,
    1791,  1340,  3141,  2439,  1751,  3750, -1311,  1129,  3501,  3629,
    1756,  1312,  1792,  3483,  3144,  1268,  3601,   540, -1149,  2603,
    2605,  1950,  1895,  2812,  2729,  3654,   917,  2082,  1810,   539,
    2054,  2883,  2691,  2692,  1458,  1459,  1561,  3725,   797,  2228,
    2969, -1556,  1829,  1477,  1831,  2342,  2981,  1213,  2055,  3475,
    1664,  1906,  2813, -1152,  1819,  1341,  1868,  1822,  1823,  1341,
    1153,  1839,  2600,  1793,  1872,  1130,  2152,  3524,  1510,  1736,
    1907,  3498,  2025,  1249,  1250,  1429,  3002,  1453,   673,  2771,
   -1311,   840,   543,  1897,   682,  1737,   917,  3738,  3815,  1873,
    3774,  3513,  1453,  1664,  1661,  1313,  2416,  2155,  2174,  1110,
    3354,  1891,  1557,  3221,  2982,   890,  1432,  1075,  2790,  1876,
   -1149,   688,  2705,    49,  1065,  1300, -1662,  1712,  1066, -1344,
    3671, -1824,  2190,   156,   681,  2646,   670,   596,   597,  1350,
     795,   891,  1463,   896, -1344,   900,  1713,  1662,  2786, -1707,
    2787,   904,  3251, -1772, -1149, -1152, -1149,  1682,  1914,   881,
   -1339,   601,  1910,   601,  2293,   601,  1816,  2685,   596,   597,
     924,   601,   905,   906,   750,  1761,  1469, -1805,   885,  1235,
   -1775,  2890,  3130, -1825,  1122, -1685,  1238,  1486, -1824, -1152,
     940, -1152, -1855,  3122,  3565,  1376,  1037, -1686, -1994,  1046,
     840,  1048,  3573, -1824, -1351,  1487,  1545,  1985,  -110,  -110,
    1512,  1548,  1539,  2217,  2656,  2305,  3664,  2989,   920,  1488,
   -1572,  2993,   907,  1173,  1174,  1738,  3730,  2075,  2747,  2078,
    1812,   596,   597,  1424,  2851,  2852,  1328,  3611,  3642,  2086,
    2244,  1341,  2089,  1486,   156,   155,   150,   151,   153,   536,
    2101,  2102,  2744,   596,  1170,   596,  1170,   539,  2105,  2106,
    1341,  1487,  3619,  2119,  2121,  1429,  1978,   596,   597,   920,
    1536,  1537,  1538,  1539,  2135,  1490,  1836,  1078,   539,  3775,
    1659,  1247, -1659,  3768,  2192,   771,  3620,  2880,   496,  2911,
     798,  2115,  2115,  3117,  2791,  1734,  2115,  1298,  1299,  2846,
    1055,  1959,  2849,  2850,  2264,  3178,  2853,  2958,  1661,  1043,
    1735,  2737,   601,  1051,  1325,  3752,  2860,  1739,   494,  2792,
    2313,  3165,  2653,  2654,  2655,  2656,  2880,   537,  1746,   538,
    3690,  2696,  3621,  2697,  2913,  2115,  2115,   831,  1691,  3622,
    1703,  1352,  1354,   686,  2040,  2041,  1901,  2892,  2644,  3776,
    1252,  1662,  3687,   909,  2698,  3710,  2338,  3823,  1364,    15,
    2651,  2652,  2653,  2654,  2655,  2656,   534,  1736,   766,  3623,
    2975,  1350,  3777,    66,  1507,   510,    75,   127,   148,  2150,
     154,  1551,  1882,  1737,  1661,  3675,  1943,   740,   741,   742,
    3027,   743,   744,   745,   746,   747,   748,  3705, -1311,  1365,
     687,   919,  2893,  2193,  1516,  3795,  3179,  1772,  1997, -1311,
    1902,  1463, -1311,  1117,  3466, -1311,   930,  1743,   688,  1991,
    1661,  3237,  2977,  1883,  1692,  1331,   840,  1662,  2000,  1519,
     512,  2240,  1289,    24,  1984,   611,  1041,   688,  3624,   840,
    2007,  1552,  3467,  1990,    38,  3691,  1546,  1986,  3136,  1833,
     156,  1998,  1999,  1063,  1065,  3574,  2502,  2699,  1066,   767,
    1944,  3166,  2700,  1662,   601,  1903,  3662,  3473,  1904,  2011,
     688,  1742,  2917,  1431,    42,  1092,  3753,  1332,  1330,   156,
    1427,  2032,  1798,  3503,  2037,  3793,  2039,  3688,  3291,  2042,
    3180,  3504,  3238,   832,  2426,  3751,  2017,  1905,  1978,   910,
    2295,  1743,  3667,  3668,  1516,  1056,  3692,  2918,  1451,    47,
    1065,  2241,  3603,  1738,  1066,  2820,  1392,  3783,  1394,  2919,
    1396,    48,  1398,  1175,  1400,  1401,  1402,  1467, -1995,  1519,
     682,  1404,  3049,  3796,  2108,  3054,  3055,  3056,  3057,  3058,
    3059,  3060,  3061,  3062,  3063,  2161,  3586,  2162,   833,  3829,
    3163,  1366,  3239,  3480,  1425,  1289,  2459,  1494,  3167,  2270,
    1905,  3168,  1057,  1508,  1333,    38,  3130,   750,  2163,   519,
    1504,   520,   539,  1513,  2395,  1884,  2701,   935,  3398,   539,
    2396,   689,  2296,  1549, -1995,  2702,  3395,  2732,  1685,  1686,
    2733,  1690,  3100,  3101,  2895,    42,  3399,   642,  1862,  2920,
     840,  3625,  3665,  1565,  1230,  1739,  3334,   840,   840,  2733,
    3670,  1334,   694,   694,  1093,   694,  1321,  1323,  1324,  1678,
    3292,  1789,  2325,    45,   615,  2402,  3577,  1863,   601,  2271,
      47,   539,   601,   601,  1744,  1367,  2606,    38,  3349,  1945,
    2545,  3505,    48,  3587,   946,  2314,  3721,  2644,  2880,  1798,
    1946,   621,  3612,  1906,  2461,   692,   692,  3766,   692,  1885,
    3356,  3495,  3357,  2883,  3323,  1840,  2164,    42,  2546,  3327,
    3722,  2165,  3329,  2326,   622,    49,  2166,  2397,  3257,  3613,
    1350,  1824,  1564,  2995,  1523,  1524,   662,  1857,  3320,  1905,
     675,   643,  2548,  1335,  2677,  1846,  1847,  1848,  1849,  2682,
    3496,  2375,    47,  2607,  2565,  1041,  2462,  2781,  1094,  2378,
     601,  2380,   946,  2570,    48,  2644,   601,  2490,  2491,  2492,
    2493,  2114,  1661,   510,  2327,  1877,  1878,  1661,  1041,  3212,
    3259,  1887,  3135,  1527,  1728,  3215,  3216,  3217,  3218,  3219,
    3220,  1979,  1289,  1983,  1729,   750,   906,    49,  1772,   623,
    2289,  1837,  1989,  2651,  2652,  2653,  2654,  2655,  2656,  1730,
     601,  2450,  2225,   601,   601,  1662,  2090,  3050,   539,  3051,
    1662,  3023,   683,  1924,  1198,  2328,  1198,  2808,   512,  1289,
    2463,  2464,  2745,  1199,  2076,  2290,  1783,  1841,  1857,   684,
    2167,  3358,  2550,  2465,  1788,  1939,  1940,  1941,  1942,  2168,
    3269,  1566,  1825,  2785,  1826,  1289,  2809,  3038,  1824,  1534,
    1535,  1536,  1537,  1538,  1539,   601,  2977,  3270,   732,  3338,
    2398,  3339,  2561,  1928,  1800,  2115,  2266,  2646,  2115,  2115,
    2115,  2115,  2115,  2115,  2115,  2115,  2115,  2115,  1978,  1923,
    1857,  1929,  1978,  1567,   162,  2466,  1930,  2312,  1931,  2399,
    2557,  1932,  1578,  1933,  1694,   695,  1952,  1934,  3554,  3555,
    2620,  2013,  2091,  1880,  1119,  1381,  1289,  2805,  1382,  1801,
    1802,   750,   497,   639,  2645,  1099,   539,  3271,    15,  1100,
     584,   163,  2806,  1289,  3698,  2115,  2115,  1795,  3052,  2647,
   -1161,  1731,  3016,  1120,  1695,  2646,  1972,    34,  3053,  2291,
     728, -1161,  1798,  1289,  1200, -1161,  3532,  1178,  2671,  1534,
    1535,  1536,  1537,  1538,  1539,  2352,  3703,   519,  2590,   520,
     624,   625,  1121,  1881,  2609,  1289,  2092,   633,  2467,  1825,
    2468,  1826,  1486,   661,  2044,   826,   730,  2694, -1192,  2959,
    1101,   156, -1192,  1696,  2495,   682,   736, -1161,  1864,  2496,
    1487,  1794,    24,   162,   162,  -345,  2459,  2647,  1865,  2775,
    3561,   505,  3563,  1516,   827,  3460, -1161,  1661,  1661,  1661,
      38,  1350,  1506,  1515,  1289,  3252,  1516,  1676,  3374,  3375,
    1677,  2093,  1866,  1102,  2094,   681,   885,  2069,  1519,  3047,
     163,   163,  1122,  3249,   156,  2066,  2063,  2064,  2065,  2864,
      42,  1519,  3521, -1192,  1850,   828,  1520,  3784,    29, -1161,
    1662,  1662,  1662,  3067,  2019,  1049,  2020, -1161,  2021,  2099,
    2022,  3026,  2023,  3660,  1871,  3461,  2024,  1661,   765,  2533,
    1179,  2057,  3585,   599,  -142,    47,  1555,  2087,  2088,   599,
    1921,   510,  1206,   826,   759,  2100, -1192,  2068,  1861,  2103,
    2104,   799,  2651,  2652,  2653,  2654,  2655,  2656,  3027,  -142,
    -766,  1219,    38,  1800,  2125,    34,  2126,  3153,  1661,  1350,
    1662,  1207,  2936,  2578,  1215,  1208,  2095,  1065,   802, -1662,
      49,  1066,  2159,  2564,    38,  1800,  2147,   807,  2148,   808,
    1220,   821,    42,  2115,  3445,  3446,   512,  2572,  2573,  1574,
    1209,  2575,  1679,  1216,  2588,  1680,   806,  2579,  1801,  1802,
    1664,  1662,  2544,   828,    42,  2218,  2648,  2649,  2650,  1716,
    2651,  2652,  2653,  2654,  2655,  2656,  1486,    47, -1161,  1122,
    1801,  1802,  1217,  1486,   590,  1522,  1195,  2014,  1205,    48,
    2015,  1798,    45,  2486,  1487,  1225,  1289,  2617,  1717,    47,
    2002,  1487,  2015,  2076,   591,   803,  1523,  1524,  1488,  2006,
    1122,    48,   189,  1798,  1371,  1490,   830,   498,  2615,  2096,
    2016,  2938,    49,   815,  2784,  2755,   570,  1718,  2545,   829,
    3201,  2735,  3373,  1065,  1372,  2618,  1089,  1066,  2262,   846,
    2619,  2901,  2265,   640,  3785,   850,  2496,   895,   897,   899,
    3202,   875,   901,   902,   903,  1527,  2546,  1041,  1041,  1967,
    1968,  2814,   908,  2816,  2285,  3164,  3169,   810,  1528,   811,
    2788,  2547,  2297,  1475,  1476,  1463,   572,  1722,  2711,  2026,
    2548,   946,  2027,   860,  2644,   519,  3077,   520,  2076,  2252,
    2253,  2028,  3533,  2238,  2027,  2311,   522,   869,    14,  2246,
    3161,  3091,   879,  2549,    15,  1463,   524,  1722,  3210,  2670,
    2060,  2672,  2673,  2061,  1661,  2334,  3547,  3548,  3035,   601,
    2880,  2115,  2115,  2272,   584,  2275,  3068,  3069,   911,    20,
    3765,  1078,  2847,  2353,   915,  1978,  2373,  1450,   946,    49,
    1978,  2644,  3609,  1978,  3231,  3232,  2237,   922,  3235,  1350,
    3236,   927,  2258,  2303,  2389,  2061,  2304,  1662,  3092,   925,
    1048,  2393,  2376,   932,  2349,  2445,  2481,  2350,  2446,  2482,
    2406,  2582,   933,  2598,  2027,  3590,  2599,  2410,    24,  2616,
    2550,   934,  2015,  2626,  2544,  2201,  2015, -1216, -1216,  2629,
    2763,  2764,  2015,  2766,  2215,  2633,  2515,  2516,  2015,  2114,
    2114,   935,  3638,  2634,  2114,  2660,  2015,  2676,  2015,  2420,
    2015,   938,  2338,  2946,  3175,   936,  2429,  2430,  2431,  2432,
    2433,  2434,  2679,   937,  3098,  2680,  1979,  2314,  2776,  2750,
    2751,  1534,  1535,  1536,  1537,  1538,  1539,  1052,  2740, -1911,
    1661,  2741,  1661,  2114,  2114,  2803,  1289,   601,  2804,   941,
    2545,  1289,  1289,  2828,  1054,   601,  2829,   601,  2894,  2896,
    2897,  1772,  1289,  3372,  2646,  1661,  3296,  2796,  1058,  2798,
    2944,  3648,   942,  2945,  2956,  3005,  2966,  2957,  2546,  2967,
    2459,  2428,  1060,  1662,  1515,  1662,  2715,  1516,  2716,  2428,
    2823,  2504,  3039,  2547,  3075,  2015,  3082,  3076,  1059,  3083,
    3155,  3156,  2548,  3074,  1517,  2717,  3094,  2718,  1662,  2015,
      38,  2934,  1519,  1463,  1064,  1117,  2232,  1520,  2235,  3157,
   -1911,  2646,  2027,  1072,  3224,  2549,  2647,  3225,  2566,  3378,
    2568,  2865,  2061,  2458,  3409,  3244,  3245,  3410,  3043,  2489,
      42,   682,  3416,  3559,  3417,  2027,  3491,  2027,  1079,  3492,
    3324,  1391,  3518,    15,  1393,  1350,  1395,  3048,  1397,  1086,
    1399,  2519,  2487,  1089,  1403,   156,  2503,   840,    45, -1911,
     946,  2756,  2757,  2644,  2866,    47,  3523,  1087,  1289,  2945,
   -1911,  2537,  3070,  2647, -1911,  2115,  1097,    48,  3525, -1911,
    3379,  2945,  1090,  2926, -1911,  2929,  1112, -1911,  2867, -1911,
    3538,  3540,  2550,  3539,  2015,  1463,  3228,  1722,   686,  2115,
    2115,   840,  3827,  1214,  3828,   750,  1432,  2868,  1117, -1193,
      49,  1231,  3546, -1193,  1132,  2061, -1911,    24,  3593,  3607,
    3639,  3594,  3608,  3640,  2869,  2333,  1177,  3644,  3646,  2972,
    1350,  2945,  1521,  1289,  3650, -1911,  1522,  2061,  3704,  2870,
    3708,  1554,  1149,  3709,  3118,  3120,   946,  3713,  1979,  2644,
    1350,  1438,  1439,  3714,   601,   687,  2061,  1523,  1524,  3715,
    1175,  1218,  2680,  1978,  3325,  1227,  3380,  3716,  2734,  1234,
    2015,  1525,  2748,    29, -1193,  2648,  2649,  2650, -1911,  2651,
    2652,  2653,  2654,  2655,  2656,  1232, -1911,  3731,  3596,  1236,
    2061,  3733,  3159,  1089,  2061, -1149,  3004,  3022,   946,  1239,
    3007,  2644,  3009,  1526,  3011,  3012,  1527,  1244,  3734,  3825,
    1155,  2061,  3826,  3017,  1246,  1253,  1156, -1193,   682,  1528,
    2871,  3034,  1529,  3836,  2140,   688,  3826,  2143,  2872, -1911,
    1256,  1289,  2648,  2649,  2650,  1122,  2651,  2652,  2653,  2654,
    2655,  2656,  1294,  2646,  1155,  3153,  1296,  1300,  3036,    38,
    1156,  1304,  2484,   946,  2115,  1157,  2644,  -159,  1504,  1096,
    2873,  1098,  2994,  1306,  2997,  1308,  1319,  1326,  2759,   176,
    1338,  1336,  2159,  1344,   615,  1343,  1345,  1346,  1347,    42,
    2720,  2721,  1349,  1350,  3230,  1355,  1358,  1359,  1133,  1157,
    1360,  2714,  1530,  1361,  3317,  1363,  1368, -1911,  1369,  3509,
    1370,  1375,  1380,  1972,  1405,  2647,  1158,    45,  3377,  1434,
     840,  1440,  1442,  1159,    47,  1436,  1160,  1443, -1911,  1134,
   -1911, -1911,  1448,  2864, -1315, -1322,    48,  1457,  1460,  2646,
    1461,  1462,  1466,  2736,  3280,   601,   689,    49,  1468,  1471,
    1158,  3680,  3153,  3682, -1312, -1313, -1316,  1159,  1472,  1473,
    1160,  1661, -1911,  2807, -1314, -1911, -1911, -1911,  1474,    49,
    2817,  1479,  1481,  1482,  1483,  1484,  1485,  1161,  1492,  1493,
    1495,  1496,  1497,  1498,  2748,  1499,  1135,  1500,  1531,  1532,
    1533,  2646,  1534,  1535,  1536,  1537,  1538,  1539,  1501,  1543,
    2221,  2647,  1558,  1554,  1662,  3363,  2222,  1569,  1577,  1683,
    1100,  1161,  1102,  1661,  1710,  1719,  1720,  1136,  1722,  1723,
    1724,  1745,  1752,  2748,  1750,  1753,  1754,  1755,  1776,  1777,
    1783,  1162,  2844,  2114,  1785,  1795,  2114,  2114,  2114,  2114,
    2114,  2114,  2114,  2114,  2114,  2114,  2646,  1796,  1797,  1798,
    1804,  1806,  1807,  2647,  3346,  1808,  1662,  1811,  1813,  1814,
    1817,  3457,  1818,  1820,  1827,  1162,  1163,  1828,  2821,  3450,
    1834,  1835,  1198,  1842,  2648,  2649,  2650,  1843,  2651,  2652,
    2653,  2654,  2655,  2656,  1289,  1289,  1874,  1289,  2831,  1851,
    1852,  1858,  1860,  2114,  2114,  1164,  1853,  1886,  1979,  1165,
    1163,  1888,  1979,  1889,  1896,  1898,  1453,  3296,  2647,  1463,
    1432,  1469,  1133,  1137,  1899,  1912,   507,  1918,  1922,  2428,
    1938,  1955,  2428,  2428,  1166,  1200,  2428,  1960,  1289,  1203,
    1289,  1963,  1965,  1165,  1966,  1981,  2428,  2719,  1970,  1993,
    1994,  1252,  1138,  1134,   732,  2882,    34,  3278,  3279,  1995,
    1139,  2038,  2043,  1996,  3153,  2009,  1140,  2010,  1204,  2050,
    2648,  2649,  2650,  1141,  2651,  2652,  2653,  2654,  2655,  2656,
     601,  1142,  2046,  2058,  1114,  3401,  2071,  2889,  2891,  1143,
    3536,  2081,  2898,  3424,  2882,  2123,  2525,  1144,  1041,  2082,
    2136,  2141,  2124,  3432,  1516,  2145,  1857,  2146,  2943,  1289,
    1135,  2153,  2930,  2203,  1133,  2158,  2177,  2216,  2223,   601,
    2224,  3025,  2648,  2649,  2650,  2175,  2651,  2652,  2653,  2654,
    2655,  2656,  2220,  2219,  1289,  2230,  2971,   840,   156,  2963,
     687,  1136,  3447,  3037,  3509,  1134,  1145,  2239,  2247,  3343,
    3344,  3345,  2248,  2251,  2257,  2259,   156,  2985,  2260,  2261,
    2268,  3337,  2273,  1972,  2276,  2278,  2280,  1972,  3340,  3341,
    2281,  2284,  2282,  1289,  2299,  2287,  2294,  2301, -1995, -1995,
    2344,  2651,  2652,  2653,  2654,  2655,  2656,  2340,  2351,  2413,
    1289,  2348,  3595,  2403,  2404,  2405,  2414,  2417,  2409,  2418,
    2419,  2421,  1135,  2422,  1289,  2425,  2423,  2424,  2435,  2437,
    2448,  2114,  2441,  2444,  2451,  2452,  2479,  1289,   156,  3030,
    2453,  2454,  2455,  2457,  2456,  2473,  2483,  2488,  2494,  3550,
    2497,  2501,  3782,  1136,  2518,  2534,  2520,  1979,  2532,  2535,
    2536,  2543,  2556,  2562,  2563,  2577,  2571,  2574,  2581,  2584,
    3402,  2585,  1289,  2586,  1661,  2748,  2946,  2576,  2587,  2596,
    2072,  2526,  2608,  2614,  2589,   917,  3649,  2612,  2631,  2627,
      34,  2628,  1760,  2630,  1139,     3,     4,  2632,  2695,  2354,
    1140,  2635,  1432,  2636,  2638,  2015,  2710,  1141,  2355,  2356,
    2357,  2666,  2723,   682,  2690,  1220,  2703,  1662,  2641,  2659,
    3089,  2665,  2667,  1143,  2729,  2731,  2668,  3158,  2675,  3673,
    2688,  1144,  3476,  3678,  3679,  1289,  1155,  3108,  3109,  3110,
    3111,  2689,  1156,  2713,  -810,  2728,  3425,  3426,  3439,  3440,
     572,  3442,  2358,  1504,  1289,  2762,  2765,  2768,  2767,  2777,
    2772,  2773,  2774,  3128,  2778,  2939,  3450,  2782,  2783,  2795,
    2797,  2818,    14,  2832,  3674,  2953,  3677,  2819,    15,  1289,
    1145,  1157,    34,  2824,  2822,  3203,  1139,  3205,  2833,  2834,
    2965,  2835,  1140,  2836,  2837,  2838,  2474,  2839,  3652,  1141,
    2840,  2359,  2841,    20,  2842,  2848,  2854,  1220,  2855,  2114,
    2114,  2856,  2857,  1289,  2884,  1143,  2354,  2887,  2858,  2859,
    2899,  1905,  2888,  1144,  2900,  2355,  2356,  2357,  2902,  2903,
    2924,  2931,  1158,  2937,  2935,  2949,  2882,  2951,  2960,  1159,
    2360,  3013,  1160,  2961,  3014,  2954,  2984,  2964,  2990,  2986,
    3193,  2955,    24,  3194,  3192,  3195,  2361,  2362,  2363,  2364,
    2365,   601,  2366,  2991,  2998,  3003,  2988,  3019,  3020,  2358,
    3008,  3517,  1145,  3001,   601,  1979,  2528,  2976,  1432,  2428,
    1979,  3517,  1041,  1979,  2911,  2428,  2428,  2428,  2428,  2428,
    2428,  3021,  3010,  1161,  2367,   840,  3029,  3024,  2734,  2912,
    1546,  3032,  3033,  1450,  3628,  3042,  2662,  2644,  2661,  3071,
    3072,  3526,  3073,  3527,  3528,  1289,  3659,  3720,  2359,  3084,
     601,  1432,  1509,  3096,  3531,  1432,  1432,  3097,  3115,  2913,
    2475,  2914,   905,   906,  3140,  3254,  3256,  3258,  3260,  3134,
    1184,  3146,  3160,  3243,  3568,  3105,  3137,  1162,  3121,  3131,
    1515,  3132,  3176,  1516,  3162,  3170,  3177,  2360,  3187,  3189,
    3253,  3188,  3190,  3191,  3580,  3198,  3802,  2368,  3211,  2476,
    1517,  3213,  3214,  2361,  2362,  2363,  2364,  2365,  1519,  2366,
    3246,  3248,  1163,  1520,    38,  3247,  3274,  3267,  1185,  3277,
    3112,  3113,  3281,  2369,  2976,  3309,  2027,  3284,  3286,  3287,
    2370,  3304,  2915,  2371,  3283,  3300,  3305,   750,  3307,  3314,
     610,  2367,   612,  3318,    42,  1165,   618,  3328,  3315,  3321,
     628,   634,   610,  3331,   641,  3342,   634,   634,  3347,   666,
    1972,   669,   666,  3336,  3350,  1972,  3352,  3355,  1972,  3360,
    1166,  1289,    45,  3364,  3359,  1155,  3365,  3390,  3391,    47,
    3366,  1156,  3404,   573,  1515,  3406,  3393,  1516,  3370,  3394,
    3411,    48,  2916,  3419,  1186,  3443,  3420,  2917,  3421,  3427,
    3645,  3444,  3433,  2114,  3436,  3448,  3455,  1289,  3462,  3238,
     601,  3468,  1519,  3469,  2368,  3465,  3477,  1520,  3481,  3485,
    1157,  3487,  3490,  3493,   574,  3506,  3497,  2114,  2114,  3507,
    3515,  3520,  2918,  3530,  3534,  3535,  3537,  3647,  1521,  1187,
    2369,  1188,  1522,  3542,  2919,  3543,  3544,  2370,  3413,  3413,
    2371,  1832,  3545,  3552,  3556,  3428,  3729,  3562,  3558,  3572,
    3560,  3588,  3575,  1523,  1524,  3582,  3437,  3589,  3663,  3684,
    3583,  1158,  3597,  3273,  3604,  3615,  3606,  1525,  1159,  3616,
    3618,  1160,   720,   725,   727,  1190,   725,  3630,   720,   734,
     666,  3631,   752,  3400,   734,  3441,   666,  3632,   666,  3633,
    3405,  3250,   725,   734,   666,  3634,  3658,  3403, -1913,  1526,
     688,  3689,  1527,  3666,  3697,  3693,  3712,  3699,  3702,  3275,
    1192,  3706,  3707,  3717,  2920,  1528,  1289,   601,  1529,  3728,
    3718,  3719,  1161,  3422,  3724,  3726,  3282,  1289,  3675,  3735,
    3736,  1376,  1521,  1979,  3739,  3745,  1522,  3741,  3123,  3748,
    3764,  3769,  3767,   601,  1194,  3773,  3737,  3781,  3738,  3804,
    3794,  3821,  3824,  3830,  3430,  3431,  1091,  1523,  1524,  3434,
    3435,  1859,  2485,  3834,  2428,  2428,  2738,  2343,  1576,  2793,
    3173,  1525,  2114,  2861,  3591,  3449,  1162,  3685,   840, -1913,
    3302,  3617,  3453,  3454,  3474,  2770,  3458,  3459,  1530,  3627,
    3770,  2583,  3566,  3801,  3742,  3740,  3779,  3303,  1954,  2292,
    1289,   750,  3643,  3196,  2826,  1935,  1527,  3471,  2460,  3803,
    1289,  1163,  2940,  3835,  3831,  1979,  3464,  2748,  3463,  1528,
    2932,   750,  3780,  2885,  3581,  3732,  1917,   601, -1913,  3584,
     617,  3348,  3661,  3310,  1423,  3579,  2307,  3311,  3489, -1913,
    1223,   156,  3482, -1913,  1165,  3711,   842,  3787, -1913,  3832,
    3610,  2234,  2233, -1913,  1061,  2018, -1913,  3290, -1913,  3031,
    3799,  2742,  1085,  1681,  2746,  3508,  1707,  2758,  2256,  1224,
    1706,   732,  2754,  2229,  1531,  1532,  1533,  2255,  1534,  1535,
    1536,  1537,  1538,  1539,  2250, -1913,  2722,  2539,  1972,  2996,
     838,  2637,  1530,  1711,  1069,  2743,  3522,  3569,  3386,  3387,
    3388,  3389,  3288,  2449, -1913,  3088,  3651,  3078,  3755,  3763,
    3756,  2749,  1979,  2708,  2623,  2525,  1515,  2601,  2706,  1516,
       0,  2202,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1133,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1519,     0,     0, -1913,     0,  1520,
       0,     0,     0,     0,     0, -1913,     0,     0,     0,     0,
       0,     0,     0,  1289,  1134,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2882, -1995,
   -1995,     0,  1534,  1535,  1536,  1537,  1538,  1539,     0,  1289,
       0,  3635,     0,     0,     0,  2428,     0,     0, -1913,  3592,
       0,     0,   773,   601,     0,     0,     0,   666,     0,   720,
       0,     0,     0,   727,     0,   725,     0,     0,   734,     0,
     752,  1135,   734,   818,     0,     0,     0,     0,     0,     0,
     725,     0,   734,     0,     0,     0,     0,  2693,     0,     0,
       0,   666,     0,   615,     0,     0,     0,   841,     0,  3413,
       0,   720,  1136,     0,     0,   727,   750,  1289,   720,     0,
       0,   752,     0,     0,     0,  1515, -1913,     0,  1516,     0,
       0,  3681,     0,  3683, -1995,     0,   725,     0,  1522,     0,
    2526,   889,     0,     0,     0,  1517,     0, -1913,     0, -1913,
   -1913,     0,     0,  1519,     0,     0,     0,     0,  1520,  1523,
    1524,     0,     0,     0,     0,     0,     0,  3747,  3514,     0,
       0,     0,     0, -1995,  1979,     0,     0,     0,   666,     0,
       0, -1913,     0,   666, -1913, -1913, -1913,     0,     0,     0,
       0,     0,     0,   666,   931,     0,  3771,     0,     0,  1289,
       0,     0,     0,     0,     0,   840,     0,     0,  1527,     0,
       0,  1036,     0,   666,   634,     0,   841,     0,   634,     0,
       0,  1528,     0,     0,     0,  1289,     0,     0,     0,     0,
     666,     0,     0,     0,   666,     0,     0,  1071,     0,     0,
       0,    34,  1036,     0,  3744,  2527,     0,     0,     0,     0,
       0,  1140,   666,     0,     0,     0,     0,     0,  1141,     0,
       0,     0,     0,     0,     0,     0,  1220,     0,  1289,     0,
       0,     0,  1289,  1289,  1143,     0,     0,     0,     0,     0,
    3772,     0,  1144,  1521,     0,     0,     0,  1522,     0,     0,
       0,     0,     0,     0, -1995,  3833,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   725,   725,     0,  1523,  1524,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3600,
       0,     0,  1525,     0,     0,     0,     0,  1515,     0,     0,
    1516,  1145,     0,     0,     0,  2528,     0,     0,     0,     0,
       0,   720,     0,     0,     0,     0,     0,  1041,   720,     0,
       0,   752,     0,     0,  1526,  1519,     0,  1527,     0,     0,
    1520,     0,     0,   725,     0,  3820,     0,     0,     0,     0,
    1528,     0,     0,  1529,   156,  3792,  3789,  3790,  3791,   725,
     725,     0,     0,     0,  1534,  1535,  1536,  1537,  1538,  1539,
       0,     0,  3813,   666,   666,   666,   725,     0,   720,     0,
       0,     0,     0,     0,     0,  3819,  3792,  3789,  3790,  3791,
       0,     0,     0,     0,     0,     0,     0,  3812,     0,     0,
       0,     0,  3669,   725,   725,     0,     0,     0,     0,     0,
       0,     0,     0,  1514,     0,     0,     0,  3813,  1515,     0,
       0,  1516,   841,  1530,     0,  3813,  1036,     0,   156,  3792,
    3789,  3790,  3791,     0,     0,   841,     0,     0,  1517,     0,
       0,  1518,  3812,     0,     0,     0,  1519,     0,   774,     0,
    3812,  1520,     0,     0,     0,     0,     0,  1408,  1408,     0,
       0,     0,   666,     0,   610,  1521,     0,     0,     0,  1522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     775,     0,  1441,     0,     0,   666,     0,     0,  1447,     0,
    1523,  1524,     0,   776,     0,     0,     0,     0,     0,  1036,
    1515,   777,     0,  1516,  1525,   778,     0,     0,     0,  1531,
    1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,     0,
    1517,     0,     0,     0,     0,   779,  2683,  1036,  1519,     0,
       0,     0,     0,  1520,     0,     0,  1526,     0,     0,  1527,
       0,     0,     0,     0,     0,     0,   780,     0,     0,     0,
       0,     0,  1528,     0,  1036,  1036,     0,  1036,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1036,     0,  1521,     0,     0,   781,
    1522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   841,     0,     0,     0,
     782,  1523,  1524,   841,   841,     0,     0,     0,     0,   666,
       0,     0,  1036,     0,     0,  1525,     0,  1668,     0,  1675,
       0,     0,     0,     0,   783,  1530,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  2661,     0,     0,
       0,     0,  2662,     0,  1036,     0,     0,  1526,  1036,  1036,
    1527,     0,     0,     0,     0,     0,     0,     0,  1521,     0,
       0,     0,  1522,  1528,     0,     0,  1529,     0,   634,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     784,     0,     0,  1523,  1524,     0,     0,     0,     0,   634,
       0,     0,     0,     0,     0,     0,     0,  1525,     0,     0,
       0,     0,  1782,     0,     0,     0,  1515,   176,   666,  1516,
       0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,
    1539,     0,     0,     0,   752,     0,  1517,     0,     0,  1526,
       0,   785,  1527,     0,  1519,   786,  1530,   787,     0,  1520,
       0,     0,     0,   788,     0,  1528,     0,     0,  1529,     0,
       0,     0,     0,     0,     0,     0,     0,   725,   725,   725,
     725,   666,     0,     0,     0,   734,     0,   634,     0,     0,
       0,     0,   789,     0,   790,     0,     0,     0,   791,  1870,
       0,   666,     0,     0,     0,     0,   792,   725,   725,     0,
       0,   793,     0,   725,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   794,     0,     0,     0,     0,  1530,     0,
       0,     0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,
    1538,  1539,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   734,     0,     0,     0,     0,     0,   725,   725,   725,
     725,     0,     0,     0,  1521,     0,   734,     0,  1522,     0,
       0,     0,     0,     0,  1870,     0,     0,     0,     0,     0,
       0,     0,     0,  1980,     0,   720,     0,     0,     0,  1523,
    1524,     0,   727,     0,   720,     0,     0,     0,     0,     0,
       0,     0,   752,  1525,  1531,  1532,  1533,   666,  1534,  1535,
    1536,  1537,  1538,  1539,     0,     0,   666,     0,   734,     0,
       0,     0,   725,   725,     0,     0,     0,   666,     0,   889,
       0,     0,     0,     0,     0,  1526,     0,     0,  1527,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1528,  1408,     0,  1529,     0,     0,     0,     0,     0,
     720,     0,     0,     0,   666,   666,     0,     0,  1515,     0,
       0,  1516,  2049,     0,     0,     0,   666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   610,
     610,     0,     0,  2074,     0,  1036,  1519,  1036,     0,     0,
       0,  1520,     0,     0,  1036,     0,     0,  1036,     0,     0,
    1036,     0,     0,     0,     0,     0,     0,     0,  1036,  1036,
       0,     0,     0,     0,  1530,     0,  1036,     0,   752,  1036,
    1036,  1036,  1036,     0,     0,     0,     0,     0,     0,  1036,
    1036,     0,  1036,     0,  1036,     0,     0,  1036,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1036,     0,     0,     0,  1036,     0,
    1515,     0,  1036,  1516,     0,     0,  1036,     0,  1036,  1036,
    1036,  1036,  1036,  1036,  1036,  1036,  1036,     0,  1036,  2704,
    1517,     0,   666,  1036,     0,  1036,     0,     0,  1519,     0,
       0,   666,     0,  1520,     0,     0,     0,     0,     0,     0,
    1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,
       0,     0,     0,     0,  2144,     0, -1995,     0,     0,     0,
    1522,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1523,  1524,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0, -1995,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1515,     0,     0,  1516,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1517,     0,     0,     0,     0,
    1527,     0,     0,  1519,     0,     0,     0,     0,  1520,     0,
       0,  1155,     0,  1528,     0,     0,  1675,  1156,     0,     0,
       0,     0,     0,   666,     0,   666,     0,  1036,  1521,     0,
       0,     0,  1522,     0,     0,     0,     0,     0,     0,     0,
       0,  1184,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1523,  1524,     0,  1157,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   734,  1525,     0,     0,
     734,   727,     0,     0,     0,     0,   610,     0,   610,     0,
       0,     0,     0,     0,     0,     0, -1995,     0,  1515,  1185,
       0,  1516,   734,  1036,     0,     0,     0,     0,     0,  1526,
     734,     0,  1527,     0,     0,     0,     0,  1158,     0,     0,
       0,     0,     0,     0,  1159,  1528,  1519,  1160,  1529,     0,
       0,  1520,     0,   734,     0,  1782,     0,     0,     0,     0,
       0,  2315,     0,  1521,     0,     0,  2324,  1522,     0,     0,
       0,     0,   666,   734,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2346,  2346,     0,     0,  1523,  1524,
     727,   734,     0,     0,   734,  1186,     0,     0,  1161,     0,
       0,     0,  1525,     0,   725,     0,  1534,  1535,  1536,  1537,
    1538,  1539,   734,     0,     0,     0,     0,     0,  1530,   734,
       0,     0,     0,     0,     0,     0,     0,     0,   734,     0,
       0,     0,     0,     0,  1526,   734,     0,  1527,  1515,  3102,
    1187,  1516,  1188,     0,     0,     0,     0,     0,     0,     0,
    1528,   725,  1189,  1529,     0,     0,     0,     0,   725,   725,
     725,   725,   725,   725,     0,     0,  1519,     0,     0,     0,
       0,  1520,     0,  1036,     0,     0, -1995,     0,     0,     0,
    1522,     0,     0,     0,     0,     0,  1190,  1163,     0,     0,
       0,     0,     0,     0,     0,  2346,     0,     0,     0,   666,
       0,  1523,  1524,   610,  1531,  1532,  1533,     0,  1534,  1535,
    1536,  1537,  1538,  1539,     0, -1995,  1191,     0,  2886,     0,
    1165,  1192,     0,  1530,     0,     0,     0,  2500,     0,     0,
       0,     0,     0,   725,  2514,     0,     0,     0,     0,     0,
       0,     0,     0,   841,     0,  1193,     0,     0,  1980,  2542,
    1527,     0,     0,  2542,  2555,  1194,  1515,     0,  1036,  1516,
       0,     0,     0,  1528,     0,     0,     0,     0,     0,     0,
     725,  2346,   725,  2346,     0,     0,  1517,     0,     0,     0,
       0,     0,     0,     0,  1519,     0,     0,   841,     0,  1520,
       0,     0,  1036,     0,     0,     0,  1521,     0,     0,     0,
    1522,     0,     0,     0,  1408,     0,     0,     0,     0,  1531,
    1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,     0,
     734,  1523,  1524,  3087,     0,     0,     0,  1036,  2525,     0,
       0,     0,     0,     0,     0,  1525, -1995,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1133,     0,   734,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1036,  1036,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,  1134,     0,     0,
       0,     0,     0,  1528,     0,     0,     0,     0,  1036,  1036,
       0,     0,     0,  1036,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1036,  1036,  1036,  1036,     0,
       0,     0,     0,     0,  1521,     0,     0,  1036,  1522,     0,
    1036,     0,  1036,  2687,     0,     0,  1534,  1535,  1536,  1537,
    1538,  1539,  1036,  1036,  1135,  1036,     0,     0,     0,  1523,
    1524,     0,     0,     0,     0,     0,     0,     0,  1036,     0,
    1036,     0,   752,  1525,  1036,     0,  1530,     0,     0,     0,
       0,     0,     0,     0,     0,  1136,     0,     0,     0,     0,
    1036,     0,     0,     0,   666,  1515,     0,     0,  1516,     0,
    1980,     0,  1036,  1036,  1036,  1526,     0,     0,  1527,     0,
       0,     0,     0,  2526,     0,  1517,   841,     0,     0,  1036,
       0,  1528,     0,  1519,  1529,  1675,     0,  1036,  1520,     0,
       0,     0,     0,     0,     0,     0,  1036,     0,     0,     0,
       0,  1036,     0,     0,     0,   666,     0,     0,  1036,     0,
       0,     0,     0,     0,  1515,     0,   734,  1516,     0,     0,
       0,     0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,
    1538,  1539,     0,  1036,     0,  2346,     0,     0,     0,  1408,
       0,     0,  1519,     0,     0,     0,   490,  1520,     0,     0,
       0,     0,   532,   490,  1530,     0,     0,     0,     0,   571,
       0,   490,     0,     0,     0,     0,     0,   490,     0,   620,
       0,     0,     0,     0,    34,     0,     0,     0,  1139,     0,
       0,     0,     0,     0,  1140,     0,     0,   680,     0,     0,
       0,  1141,     0,     0,     0,     0,     0,     0,     0,  1220,
       0,   734,     0,     0,     0,     0,     0,  1143,   734,     0,
       0,     0,     0,  1521,     0,  1144,     0,  1522,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3103,     0,     0,  1523,  1524,
    1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,
       0,     0,  1525,     0,  3139,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1145,     0,     0,     0,  2528,     0,
     734,     0, -1995,     0,     0,     0,  1522,     0,     0,     0,
    2346,  2346,     0,     0,  1526,     0,     0,  1527,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1523,  1524,     0,
    1528,     0,     0,  1529,     0,     0,     0,     0,     0,     0,
     502, -1995,     0,     0,     0,     0,     0,   754,     0,   756,
       0,   758,   503,   760,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1515,     0,     0,
    1516,     0,   504,     0,     0,     0,  1527,     0,     0,     0,
       0,  1408,   666,     0,     0,     0,     0,  1517,     0,  1528,
       0,     0,   666,   505,     0,  1519,     0,  -613,     0,     0,
    1520,     0,     0,  1530,     0,     0,     0,   666,     0,     0,
       0,     0,     0,   841,     0,     0,     0,   506,     0,     0,
       0,     0,     0,   507,  2542,     0,     0,  2987,     0,     0,
    1980,     0,     0,     0,  1980,     0,     0,     0,   508,     0,
    3000,     0,     0,  1036,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   666,     0,
       0,   666, -1995,     0,   734,     0,   509,     0,  3018,     0,
       0,     0,     0,   510,     0,     0,   720,   511,     0,   734,
       0,     0,     0,     0,     0,     0,  2049,     0,     0,  1531,
    1532,  1533,  -766,  1534,  1535,  1536,  1537,  1538,  1539,   666,
       0,   734,     0,  3148,     0,     0,     0,     0,     0,  1036,
       0,     0,     0,     0,     0,     0,     0,     0,  1036,     0,
       0,     0,     0,     0,  1036,  1521,  1036,     0,   512,  1522,
       0,     0,  1036,     0,     0,  1036,  1036,  1036,  1036,  1036,
    1036,  1036,  1036,  1036,  1036,     0,     0,     0,  1036,  1036,
    1523,  1524,  1534,  1535,  1536,  1537,  1538,  1539,     0,     0,
       0,  1036,     0,     0,  1525,     0,     0,  1036,     0,     0,
       0,     0,   513,     0,     0,   514,     0,  1036,     0,     0,
    1036,     0,  1036,     0,     0,     0,     0,     0,     0,     0,
       0,  1036,  1036,  1036,     0,     0,  1526,  1036,     0,  1527,
    1036,     0,     0,     0,     0,     0,     0,   666,   666,     0,
    1036,     0,  1528,     0,     0,  1529,  3125,     0,  1036,     0,
    1036,     0,     0,   515,     0,     0,     0,     0,  1675,   516,
       0,     0,     0,     0,     0,  -345,     0,     0,   517,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3154,
    1408,  1408,     0,     0,  -345,   734,   518,   519,     0,   520,
     521,     0,   801,     0,     0,     0,     0,     0,   522,     0,
       0,     0,     0,   523,  3172,  1530,   819,   820,   524,     0,
       0,   822,     0,   525,     0,     0,     0,     0,     0,     0,
     836,     0,     0,     0,     0,  -345,     0,     0,     0,     0,
       0,     0,     0,     0,   845,     0,     0,     0,     0,     0,
       0,  1515,     0,   734,  1516,   734,   864,     0,     0,   866,
       0,   868,     0,   871,     0,     0,  1515,     0,     0,  1516,
       0,  1517,     0,     0,     0,     0,     0,     0,     0,  1519,
       0,   841,     0,     0,  1520,     0,  1517,     0,     0,     0,
       0,     0,     0,     0,  1519,     0,     0,     0,   490,  1520,
       0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,
    1539,     0,     0,     0,     0,  3353,     0,     0,   666,     0,
       0,   928,     0,   929,     0,     0,     0,     0,     0,     0,
    1036,     0,     0,     0,     0,     0,   666,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   666,     0,     0,     0,     0,     0,     0,
       0,     0,  2500,     0,     0,     0,     0,     0,  3297,     0,
       0,     0,  1782,     0,  3018,     0,   680,     0,     0,     0,
       0,     0,     0,     0,     0,  1036,  1036,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  2542,     0,     0,     0,  1980,     0,  1521,
       0,     0,  1980,  1522,     0,  1980,  2500,     0,  3333,     0,
       0,     0,     0,     0,  1521,  2346,     0,  2346,  1522,     0,
       0,     0,     0,     0,  1523,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,   734,     0,     0,     0,  1525,  1523,
    1524,  1515,     0,     0,  1516,     0,     0,  1036,     0,     0,
       0,     0,     0,  1525,  1226,     0,     0,     0,     0,     0,
       0,  1517,     0,     0,     0,     0,  1237,     0,     0,  1519,
    1526,     0,     0,  1527,  1520,  1243,     0,     0,     0,     0,
       0,  1245,     0,  1036,     0,  1526,  1528,     0,  1527,  1529,
    1036,  1036,  1292,     0,     0,     0,     0,     0,  1036,  1036,
       0,  1528,     0,  1036,  1529,     0,     0,     0,     0,  1036,
    1036,     0,     0,  1036,     0,   666,   666,   666,   666,     0,
       0,  1329,  1515,     0,  1036,  1516,     0,     0,     0,     0,
    3397,     0,     0,     0,     0,     0,  1036,     0,     0,     0,
       0,     0,     0,     0,   752,     0,     0,     0,     0,     0,
    1519,     0,     0,   610,     0,  1520,  1036,     0,     0,  1530,
     725,   725,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1530,  3423,     0,     0,     0,     0,
       0,     0,   490,   734,   490,     0,   490,     0,   490,     0,
     490,   490,   490,     0,   734,     0,     0,   490,     0,  1521,
       0,     0,     0,  1522,     0,     0,     0,   725,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1523,  1524,     0,     0,     0,     0,
       0,     0,     0,     0,   841,     0,     0,     0,  1525,     0,
       0,  1408,     0,  3106,     0,  1531,  1532,  1533,     0,  1534,
    1535,  1536,  1537,  1538,  1539,     0,     0,     0,     0,  3385,
    1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,
    1526,     0,  3133,  1527,  1036,     0,     0,     0,     0,     0,
   -1995,     0,     0,     0,  1522,     0,  1528,     0,     0,  1529,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1523,  1524,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0, -1995,
       0,     0,     0,     0,     0,   666,     0,     0,     0,     0,
       0,  1036,     0,     0,     0,  1980,     0,     0,  3333,     0,
       0,     0,     0,  1515,     0,     0,  1516,     0,     0,     0,
       0,     0,     0,     0,  1527,     0,     0,   734,     0,  1530,
       0,     0,  1036,  1517,   722,     0,     0,  1528,     0,     0,
     722,  1519,     0,     0,     0,   680,  1520,     0,     0,     0,
       0,  1515,     0,     0,  1516,     0,  1036,  1036,     0,     0,
    1036,     0,     0,     0,     0,     0,     0,  1036,  1036,     0,
       0,  1517,     0,     0,     0,     0,     0,     0,     0,  1519,
       0,   734,     0,   734,  1520,     0,     0,  3154,   752,   725,
       0,  1749,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   720,   752,     0,
   -1995,     0,     0,     0,     0,  1531,  1532,  1533,     0,  1534,
    1535,  1536,  1537,  1538,  1539,     0,     0,     0,     0,  3541,
       0,     0,  1408,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   720,     0,     0,   666,     0,     0,  1515,
       0,     0,  1516,     0,     0,     0,     0,     0,  2346,     0,
    1782,     0,     0,     0,     0,     0,     0,     0,     0,  3297,
       0,  1521,     0,     0,   666,  1522,     0,  1519,     0,     0,
       0,     0,  1520,   725,  3154,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1523,  1524,     0,     0,
    1534,  1535,  1536,  1537,  1538,  1539,     0,     0,     0,  1521,
    1525,  1036,     0,  1522,  1036,     0,  1036,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  3657,
       0,     0,     0,     0,  1523,  1524,     0,     0,     0,     0,
       0,   725,  1526,     0,     0,  1527,     0,     0,  1525,   666,
       0,     0,  1036,     0,     0,  1915,     0,     0,  1528,     0,
       0,  1529,   725,   725,   725,   725,     0,  1937,     0,     0,
    3383,   841,     0,     0,     0,     0,     0,     0,     0,     0,
    1526,     0,     0,  1527,     0,     0,     0,     0,     0,     0,
       0,     0,  1036,     0,     0,     0,  1528,     0,     0,  1529,
       0,     0,     0,     0,     0,  1988,     0, -1995,     0,  1992,
       0,  1522,     0,     0,     0,     0,     0,     0,  2001,     0,
    2003,     0,  2004,     0,     0,     0,     0,  2005,     0,     0,
       0,  1530,  1523,  1524,     0,  1036,     0,     0,     0,     0,
       0,     0,     0,   752,     0,     0, -1995,     0,     0,     0,
     490,     0,   490,     0,   490,     0,   490,  1515,   490,     0,
    1516,     0,   490,     0,     0,     0,     0,     0,     0,  1530,
       0,   722,     0,     0,     0,     0,   725,  1517,     0,   720,
       0,  1527,     0,     0,     0,  1519,  3154,     0,     0,     0,
    1520,     0,     0,     0,  1528,  3657,     0,     0,  1036,  1036,
       0,   734,     0,     0,     0,     0,     0,     0,   720,     0,
       0,     0,   725,   722,     0,     0,     0,  1531,  1532,  1533,
     722,  1534,  1535,  1536,  1537,  1538,  1539,     0,     0,     0,
       0,  3564,     0,     0,  1036,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1036,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1531,  1532,  1533,  3814,  1534,
    1535,  1536,  1537,  1538,  1539,     0,     0, -1995,     0,  3602,
       0,     0,     0,     0,     0,     0,     0,  1515,     0,     0,
    1516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1517,  1036,     0,
       0,     0,     0,  3814,     0,  1519,     0,   720,     0,     0,
    1520,  3814,     0,   722,     0,  1521,     0,     0,     0,  1522,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1523,  1524,     0,     0,   722,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1525,     0,     0,  1534,  1535,  1536,
    1537,  1538,  1539,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1526,     0,     0,  1527,
       0,     0,     0,     0,     0,  1515,     0,     0,  1516,     0,
       0,     0,  1528,     0,     0,  1529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1517,     0,     0,     0,  2240,
       0,     0,     0,  1519,     0,     0,  1515,     0,  1520,  1516,
       0,     0,     0,     0,     0,  1521,     0,     0,     0,  1522,
       0,     0,     0,   722,     0,     0,  1517,     0,     0,     0,
     722,     0,     0,     0,  1519,     0,     0,     0,     0,  1520,
    1523,  1524,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1291,     0,     0,  1525,  1530,     0,     0,     0,  2263,
       0,     0,     0,  1023,  2267,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2277,     0,     0,     0,     0,  2241,
     722,  2283,     0,     0,     0,     0,  1526,  2288,     0,  1527,
       0,     0,     0,  2298,  1082,     0,     0,     0,  2300,     0,
       0,     0,  1528,     0,     0,  1529,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2316,  2317,  2320,  2322,   722,     0,
       0,  2329,  2332,  1521,     0,     0,  2335,  1522,     0,  2339,
       0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,
    1539,     0,     0,     0,     0,  3746,     0,  2374,  1523,  1524,
       0,     0,     0,     0,  1521,     0,     0,  2377,  1522,  2379,
       0,     0,  1525,     0,  1291,  1530,     0,     0,  2390,  2391,
    2392,     0,  2394,     0,     0,     0,     0,     0,     0,  1523,
    1524,  2407,  2408,     0,     0,     0,     0,     0,     0,  2411,
    2412,   722,     0,  1525,  1526,     0,     0,  1527,     0,     0,
       0,  1515,     0,     0,  1516,     0,     0,     0,     0,     0,
    1528,     0,     0,  1529,     0,     0,     0,     0,     0,   722,
       0,  1517,     0,     0,     0,  1526,     0,     0,  1527,  1519,
       0,     0,     0,     0,  1520,     0,     0,     0,     0,     0,
       0,  1528,     0,     0,  1529,     0,   722,   722,     0,   722,
       0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,
    1539,     0,  3079,     0,     0,  3822,   722,     0,     0,  1515,
       0,     0,  1516,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1530,     0,     0,     0,     0,     0,  1517,
       0,     0,  2625,     0,     0,     0,     0,  1519,     0,     0,
       0,     0,  1520,     0,   722,  1660,     0,     0,     0,     0,
       0,     0,     0,     0,  1530,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3080,     0,     0,
       0,     0,  2242,     0,     0,     0,   722,  3797,     0,     0,
     722,   722,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1291,     0,     0,     0,     0,  1660,     0,     0,  1521,
       0,  1455,     0,  1522,     0,     0,     0,     0,     0,  1531,
    1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,     0,
       0,     0,     0,     0,  1523,  1524,     0,     0,  1291,  1478,
       0,     0,     0,     0,     0,     0,  2610,     0,  1525,     0,
    1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,  1539,
       0,     0,     0,     0,  1291,     0,  1502,  1503,     0,  1505,
       0,     0,     0,     0,     0,     0,     0,  1521,     0,     0,
    1526,  1522,     0,  1527,     0,     0,  1544,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1528,     0,     0,  1529,
       0,     0,  1523,  1524,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  3798,  1525,     0,     0,     0,
       0,     0,     0,     0,  1579,  1291,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1291,     0,     0,     0,     0,     0,  1526,     0,
       0,  1527,     0,     0,     0,     0,  1689,     0,     0,     0,
    1699,  1702,  1291,     0,  1528,     0,     0,  1529,     0,  1530,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1291,     0,     0,     0,     0,  1660,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1515,     0,
       0,  1516,     0,     0,     0,   722,     0,   722,     0,     0,
       0,     0,     0,  1291,     0,     0,   722,  1530,  1517,  2760,
    2761,     0,     0,     0,     0,     0,  1519,     0,     0,     0,
       0,  1520,     0,     0,     0,  1531,  1532,  1533,     0,  1534,
    1535,  1536,  1537,  1538,  1539,     0,     0,     0,     0,     0,
    2780,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   722,     0,  2799,  2800,  2801,  2802,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1290,  1531,  1532,  1533,     0,  1534,  1535,  1536,
    1537,  1538,  1539,     0,     0,     0,     0,   722,     0,   722,
       0,     0,     0,     0,     0,     0,   722,     0,     0,   722,
       0,     0,   722,     0,     0,     0,     0,     0,     0,     0,
     722,   722,     0,     0,     0,     0,     0,     0,   722,     0,
       0,   722,   722,   722,   722,     0,  1521,     0,     0,     0,
    1522,   722,   722,     0,   722,     0,   722,     0,  2843,   722,
       0,     0,     0,  2845,     0,     0,     0,     0,     0,     0,
       0,  1523,  1524,     0,     0,  1291,   722,  1660,     0,     0,
     722,     0,     0,     0,   722,  1525,     0,     0,   722,     0,
     722,   722,   722,   722,   722,   722,   722,   722,   722,     0,
     722,     0,     0,     0,     0,   722,     0,   722,     0,     0,
       0,     0,     0,     0,     0,  1290,     0,  1526,     0,     0,
    1527,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1528,     0,     0,  1529,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  2639,
    2947,  2948,     0,     0,     0,     0,     0,     0,     0,  1515,
       0,     0,  1516,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1517,
       0,     0,  2669,     0,     0,     0,  2085,  1519,     0,     0,
    1515,     0,  1520,  1516,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1530,     0,  2107,     0,
    1517,  2109,  3006,     0,  2120,     0,     0,     0,  1519,     0,
       0,  2127,  2132,  1520,     0,  3015,  2137,     0,     0,  2142,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   722,
       0,     0,     0,     0,     0,     0,  2151,     0,     0,     0,
    2157,     0,     0,     0,  2169,     0,     0,     0,  2176,     0,
    2178,  2179,  2180,  2181,  2182,  2183,  2184,  2185,  2186,     0,
    2187,     0,     0,     0,     0,  1023,     0,  2211,     0,     0,
       0,  1660,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,
    1538,  1539,  1290,     0,     0,   722,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1521,     0,     0,
       0,  1522,     0,     0,     0,  1291,     0,     0,     0,     0,
    1291,  1291,  2674,     0,     0,     0,     0,     0,     0,  1775,
       0,  1291,  1523,  1524,     0,     0,     0,     0,  1521,  1281,
       0,     0,  1522,     0,     0,     0,  1525,  1660,     0,     0,
       0,     0,     0,     0,     0,  1290,     0,     0,     0,     0,
       0,     0,     0,  1523,  1524,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1525,  1526,     0,
       0,  1527,     0,  1660,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1528,     0,     0,  1529,     0,  1082,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1526,
       0,     0,  1527,     0,     0,     0,  1290,     0,     0,     0,
       0,     0,     0,     0,     0,  1528,     0,     0,  1529,     0,
       0,     0,     0,  1290,  3171,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   722,     0,  1291,     0,     0,
       0,     0,     0,  1290,     0,     0,     0,     0,     0,     0,
       0,     0,  1281,     0,     0,  2286,     0,  1530,     0,     0,
       0,  3197,     0,     0,     0,  1290,  3204,     0,  3206,  3207,
    3208,  3209,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1530,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1291,     0,     0,     0,     0,     0,     0,     0,
     722,     0,     0,     0,  1290,     0,     0,     0,     0,     0,
     722,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   165,     0,  3262,  3264,  3266,
       0,  3268,     0,  1531,  1532,  1533,     0,  1534,  1535,  1536,
    1537,  1538,  1539,     0,   722,     0,     0,  1515,     0,     0,
    1516,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1531,  1532,  1533,  1517,  1534,  1535,
    1536,  1537,  1538,  1539,     0,  1519,     0,     0,     0,   722,
    1520,     0,   166,     0,     0,     0,     0,     0,     0,     0,
    1291,     0,     0,     0,     0,  2447,     0,     0,     0,     0,
       0,     0,   167,  2780,     0,     0,     0,     0,   168,     0,
     722,   722,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3335,   169,     0,     0,     0,  1283,     0,  1281,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     722,   722,     0,     0,     0,   722,     0,     0,     0,     0,
       0,   170,     0,     0,     0,     0,   171,   722,   722,   722,
     722,     0,   172,     0,     0,  1660,  1281,     0,     0,   722,
    1660,     0,   722,     0,   722,     0,  1290,   173,     0,     0,
    2559,     0,     0,     0,   722,   722,     0,   722,     0,     0,
       0,     0,  1281,     0,     0,     0,     0,     0,     0,     0,
     722,   174,   722,     0,     0,  1521,   722,     0,  2214,  1522,
       0,     0,     0,     0,  2580,     0,     0,     0,     0,     0,
       0,     0,   722,     0,     0,     0,     0,     0,     0,     0,
    1523,  1524,   722,     0,   722,   722,   722,  1284,     0,     0,
       0,     0,     0,     0,  1525,     0,     0,     0,     0,  1023,
    1283,   722,     0,  1281,     0,     0,     0,   175,     0,   722,
       0,     0,     0,     0,     0,  1286,     0,     0,   722,     0,
    1281,     0,     0,   722,     0,     0,  1526,     0,     0,  1527,
     722,  2621,     0,     0,   176,     0,     0,     0,     0,     0,
    1281,     0,  1528,     0,     0,  1529,  3429,     0,     0,     0,
       0,     0,     0,     0,     0,   722,     0,  3438,   177,     0,
       0,     0,  1281,     0,   178,     0,     0,     0,     0,     0,
     179,     0,     0,   180,     0,     0,     0,  2132,     0,  2132,
    2132,     0,     0,  1291,  1291,     0,  1291,     0,     0,  2681,
       0,     0,  2684,     0,  2686,     0,     0,     0,     0,   181,
       0,   182,     0,     0,     0,   183,     0,     0,     0,     0,
    1284,  1281,     0,   184,     0,  1530,     0,     0,   185,     0,
    2707,     0,  2709,     0,     0,     0,  2712,  1291,   186,  1291,
       0,     0,     0,     0,     0,     0,     0,     0,  1286,     0,
     187,  3040,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3484,     0,  2211,  2211,  2211,     0,     0,     0,
    1660,  1660,  1660,     0,     0,     0,     0,     0,     0,     0,
       0,  2739,     0,     0,  3502,     0,  2302,     0,     0,  1082,
       0,  1775,  2309,     0,     0,     0,     0,  1283,  1689,     0,
       0,     0,  1290,  2753,     0,     0,     0,     0,  1291,     0,
    1702,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,  1538,
    1539,  3529,     0,     0,     0,     0,     0,     0,     0,     0,
    1660,     0,     0,  1291,  1283,  2769,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,     0,     0,     0,     0,     0,  1287,     0,     0,
       0,  1660,  1291,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1291,
       0,     0,     0,  1281,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1291,     0,     0,     0,  1284,     0,     0,
       0,     0,     0,     0,     0,     0,  1291,     0,  1290,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   722,     0,     0,  1286,   722,     0,  1283,     0,
       0,     0,     0,     0,  1284,   722,     0,     0,     0,     0,
       0,  1291,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1284,     0,  1286,     0,     0,     0,     0,     0,   722,     0,
    1283,     0,     0,  1775,     0,     0,     0,     0,     0,     0,
    1287,     0,     0,     0,  2780,     0,     0,     0,  1286,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   722,     0,     0,  1291,     0,     0,     0,     0,     0,
     722,     0,     0,     0,     0,     0,   722,     0,   722,  1283,
       0,  1284,     0,  1291,   722,     0,     0,   722,   722,   722,
     722,   722,   722,   722,   722,   722,   722,     0,  1284,     0,
     722,   722,     0,     0,     0,     0,     0,     0,  1291,  1286,
       0,     0,     0,   722,     0,     0,     0,  1660,  1284,   722,
       0,     0,     0,     0,     0,     0,  1286,     0,     0,   722,
       0,  1290,   722,     0,   722,     0,     0,     0,     0,     0,
    1284,     0,  1291,   722,   722,   722,  1286,     0,     0,   722,
       0,     0,   722,  1515,     0,     0,  1516,     0,     0,     0,
       0,     0,   722,     0,     0,  2211,     0,     0,  1286,     0,
     722,     0,   722,  1517,     0,     0,  2678,     0,     0,     0,
       0,  1519,     0,     0,     0,     0,  1520,     0,     0,  1284,
       0,     0,     0,  1281,     0,     0,     0,     0,  1281,  1281,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1281,
       0,   722,     0,     0,     0,     0,     0,  1286,     0,     0,
       0,     0,     0,     0,     0,     0,  3743,  1287,     0,     0,
       0,  3041,     0,     0,     0,     0,     0,     0,     0,     0,
    3044,     0,     0,  1660,  1291,  1660,  3045,     0,  3046,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1515,  1287,     0,  1516,     0,  1660,     0,
    3064,  3065,     0,     0,     0,  2214,  2214,  2214,     0,     0,
       0,     0,     0,  1517,     0,     0,  3086,     0,     0,  2137,
    1287,  1519,     0,     0,     0,     0,  1520,     0,     0,  3090,
       0,     0,  3093,     0,  3095,     0,     0,     0,     0,     0,
       0,  1521,     0,  3099,     0,  1522,     0,     0,     0,  3104,
       0,     0,  3107,     0,     0,  1281,     0,     0,     0,     0,
       0,     0,  3114,     0,     0,     0,  1523,  1524,     0,     0,
    3126,     0,  2211,     0,     0,     0,     0,     0,     0,     0,
    1525,  1287,   722,     0,     0,     0,     0,     0,     0,     0,
       0,  1284,     0,     0,     0,     0,     0,     0,  1287,     0,
    1291,     0,     0,     0,  1775,  2309,     0,  2309,     0,     0,
       0,     0,  1526,     0,     0,  1527,     0,     0,  1287,  1286,
    1281,     0,     0,     0,     0,     0,     0,     0,  1528,     0,
       0,  1529,     0,     0,     0,     0,  1291,   722,   722,     0,
    1287,     0,     0,     0,     0,     0,     0,     0,  1290,     0,
    1290,  1521,     0,     0,     0,  1522,     0,     0,     0,   722,
       0,     0,     0,     0,   722,     0,     0,   722,     0,     0,
       0,     0,     0,     0,     0,     0,  1523,  1524,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1287,
    1525,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1530,     0,     0,     0,     0,     0,     0,  1288,   722,
       0,     0,     0,     0,     0,     0,     0,     0,  1281,  1290,
       0,     0,  1526,     0,     0,  1527,     0,     0,     0,     0,
       0,  1283,     0,     0,     0,     0,  1283,  1283,  1528,     0,
       0,  1529,     0,     0,  2309,   722,     0,  1283,     0,     0,
       0,     0,   722,   722,     0,  1291,     0,     0,     0,     0,
     722,   722,     0,     0,     0,   722,  1291,     0,     0,     0,
       0,   722,   722,     0,     0,   722,     0,     0,     0,     0,
       0,     0,     0,  2309,     0,     0,   722,  1531,  1532,  1533,
       0,  1534,  1535,  1536,  1537,  1538,  1539,     0,   722,     0,
    1290,     0,     0,     0,     0,     0,     0,  3312,  3313,     0,
       0,  1530,     0,     0,  1290,     0,     0,     0,   722,     0,
       0,     0,     0,     0,     0,     0,     0,  2309,     0,     0,
       0,  1288,     0,     0,     0,     0,     0,     0,     0,  1291,
       0,  1284,     0,     0,     0,     0,  1284,  1284,     0,  1291,
       0,     0,     0,     0,     0,     0,  2214,  1284,     0,     0,
       0,  1287,  1290,  1283,     0,     0,     0,     0,     0,  1286,
       0,     0,     0,     0,  1286,  1286,     0,     0,     0,  3351,
       0,     0,     0,     0,     0,  1286,     0,     0,     0,     0,
       0,     0,     0,     0,  1660,     0,     0,  1531,  1532,  1533,
       0,  1534,  1535,  1536,  1537,  1538,  1539,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  3367,  3369,     0,  1290,     0,     0,  1283,     0,
       0,     0,     0,     0,     0,  3376,   722,     0,   544,     0,
       0,  3381,  3382,     0,  1290,  3384,  1660,     0,     0,     0,
     545,     0,     0,     0,     0,     0,  2211,     0,     0,     0,
       0,  1281,  1281,     0,  1281,     0,     0,     0,  2211,  1290,
     546,     0,     0,  1284,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1291,     0,     0,     0,  3408,     0,
       0,     0,     0,   722,     0,   547,     0,   722,     0,     0,
       0,  1286,  1291,  1290,     0,  1281,     0,  1281,     0,     0,
       0,     0,     0,     0,     0,   548,     0,     0,  1288,     0,
       0,     0,     0,     0,   722,     0,  1283,     0,  1291,     0,
       0,     0,     0,  2214,     0,     0,   549,     0,  1284,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   722,   722,
       0,     0,   722,     0,     0,  1288,     0,     0,     0,   722,
     722,     0,     0,     0,   550,     0,  1286,     0,     0,   551,
       0,     0,     0,     0,     0,   552,  1281,     0,     0,   722,
       0,  1288,     0,     0,     0,     0,     0,     0,     0,     0,
     553,     0,     0,     0,     0,     0,  1291,     0,     0,   722,
       0,  1281,     0,     0,     0,  2309,  3472,     0,     0,     0,
       0,  1287,     0,     0,     0,     0,  1287,  1287,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1287,     0,     0,
       0,     0,     0,     0,     0,   722,  1284,     0,     0,     0,
    1281,     0,  1288,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1281,     0,  1288,
       0,     0,     0,  3519,  1286,     0,     0,     0,     0,     0,
     554,  1281,     0,     0,     0,     0,   722,     0,  1291,  1288,
     555,     0,     0,     0,  1281,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   176,     0,     0,
       0,  1288,     0,   722,  1291,     0,   722,     0,   722,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1281,
       0,   556,  3549,     0,     0,   557,     0,   558,     0,     0,
    3551,  1290,     0,   559,     0,     0,   560,     0,     0,     0,
       0,     0,     0,  1287,   722,     0,     0,  1291,     0,     0,
    1288,  1291,  1291,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   561,     0,   562,     0,     0,  1775,   563,  1283,
    1283,     0,  1283,     0,     0,     0,   564,  1660,     0,     0,
       0,   565,  1281,     0,   722,     0,     0,     0,     0,     0,
       0,   566,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1281,     0,   567,     0,     0,     0,     0,  1287,  1291,
       0,     0,     0,  1283,     0,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1281,   722,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1281,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   722,     0,     0,     0,     0,  2137,     0,   722,  1284,
    1284,     0,  1284,     0,  1283,     0,  1290,     0,     0,     0,
     722,   722,     0,     0,     0,     0,     0,  1290,     0,     0,
     722,     0,     0,     0,     0,     0,  1287,  1286,  1286,  1283,
    1286,     0,     0,     0,  3672,     0,     0,  2214,     0,     0,
       0,     0,  1288,  1284,     0,  1284,   722,     0,     0,  2214,
       0,     0,     0,     0,     0,     0,   722,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1283,     0,
       0,  1286,     0,  1286,  3701,     0,     0,     0,     0,     0,
       0,     0,  1281,     0,     0,  1283,     0,     0,     0,     0,
    1290,     0,     0,     0,     0,     0,     0,     0,     0,  1283,
    1290,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     722,     0,  1283,     0,  1284,     0,     0,     0,     0,   722,
       0,     0,     0,     0,     0,     0,     0,     0,  1515,     0,
       0,  1516,     0,     0,     0,     0,     0,     0,     0,  1284,
       0,     0,  1286,     0,     0,     0,     0,  1283,  1517,     0,
       0,     0,     0,     0,     0,     0,  1519,     0,     0,  1515,
       0,  1520,  1516,     0,     0,     0,     0,  1286,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1284,  1517,
    3760,  3760,     0,     0,     0,     0,     0,  1519,     0,     0,
       0,     0,  1520,     0,     0,  1284,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1286,     0,  1281,  1284,
    1283,     0,     0,     0,     0,     0,  3760,     0,     0,     0,
       0,     0,  1284,  1286,     0,     0,  3800,     0,     0,  1283,
       0,     0,     0,     0,     0,  3512,     0,  1286,     0,     0,
       0,     0,     0,     0,  1281,     0,     0,     0,  1541,     0,
    1286,     0,     0,  1290,  1283,     0,     0,  1284,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1287,
    1287,     0,  1287,     0,     0,     0,     0,     0,     0,  1290,
    3760,     0,     0,     0,     0,  1286,  1521,     0,  1283,     0,
    1522,     0,  1288,     0,     0,     0,     0,  1288,  1288,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,  1288,     0,
       0,  1523,  1524,  1287,     0,  1287,     0,  1521,     0,     0,
    1284,  1522,     0,     0,     0,  1525,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1284,
       0,     0,  1523,  1524,     0,     0,     0,  2309,  1286,     0,
       0,     0,     0,     0,     0,     0,  1525,  1526,     0,     0,
    1527,     0,     0,  1281,  1284,     0,     0,  1286,     0,     0,
       0,     0,     0,  1528,  1281,     0,  1529,     0,     0,     0,
       0,     0,     0,     0,  1287,     0,     0,     0,  1526,     0,
    1283,  1527,  1286,     0,     0,     0,     0,     0,  1284,     0,
       0,     0,     0,     0,  1528,     0,     0,     0,     0,  1287,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1288,     0,  1286,     0,     0,  2309,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1530,  1281,  1287,     0,
       0,     0,     0,     0,     0,  1290,     0,  1281,     0,     0,
       0,     0,     0,     0,     0,  1287,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1530,     0,  1287,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1288,
       0,     0,  1287,     0,     0,     0,     0,     0,  1290,     0,
    1284,     0,  1290,  1290,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1283,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1287,  1286,     0,
       0,     0,  1531,  1532,  1533,     0,  1534,  1535,  1536,  1537,
    1538,  1539,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
    3512,     0,     0,  1531,  1532,  1533,     0,  1534,  1535,  1536,
    1537,  1538,  1539,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1288,     0,     0,
    1287,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1541,     0,     0,     0,     0,     0,  1287,
    1281,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1284,     0,     0,     0,
       0,     0,     0,     0,  1287,     0,  1281,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1286,     0,     0,     0,     0,     0,
       0,     0,  1284,     0,     0,     0,     0,     0,  1287,     0,
       0,  1283,     0,     0,     0,     0,     0,     0,     0,     0,
    1541,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
    1286,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1541,  1281,     0,     0,     0,  2116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,  1541,     0,
    1541,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1283,     0,     0,     0,  1541,
    1287,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1284,     0,     0,     0,     0,  1281,     0,     0,     0,
       0,     0,  1284,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,  1286,
       0,     0,  1281,     0,     0,     0,     0,     0,     0,     0,
    1286,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1288,  1288,     0,  1288,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1281,     0,     0,     0,  1281,
    1281,     0,     0,     0,     0,  1284,     0,     0,     0,     0,
       0,     0,     0,     0,  1288,  1284,  1288,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1286,     0,     0,  1287,     0,     0,     0,
       0,     0,     0,  1286,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,  1283,     0,
       0,     0,     0,     0,  1541,     0,     0,  1541,     0,     0,
       0,     0,  1287,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1283,  1288,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1288,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1288,
       0,     0,  1283,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1288,     0,  1284,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1288,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1287,     0,  1288,  1284,     0,  1286,     0,     0,     0,
       0,     0,  1287,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1286,     0,     0,     0,     0,     0,  1288,     0,
       0,     0,     0,     0,  1283,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    1283,     0,  1284,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1287,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1287,     0,     0,     0,     0,
    1286,  1288,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     1,     0,  1283,     0,     0,     0,  1283,  1283,     0,
    1288,     2,     0,     3,     4,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     5,     0,     0,
       0,     0,     0,     0,     0,  1288,     0,     0,     0,     0,
       0,     0,     0,     0,  1284,     0,     0,     6,     0,     7,
       8,     0,     0,     0,     9,     0,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    11,     0,    12,  1288,
    1284,     0,  1286,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    13,     0,     0,
      14,     0,     0,     0,     0,     0,    15,     0,  1286,     0,
       0,     0,    16,     0,    17,     0,     0,     0,    18,     0,
       0,     0,     0,  1284,    19,     0,     0,  1284,  1284,     0,
       0,    20,     0,    21,     0,     0,     0,     0,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1287,     0,
       0,  1286,    23,     0,     0,  1286,  1286,     0,     0,     0,
    1541,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1287,     0,     0,     0,     0,     0,
      24,  1288,  1541,     0,  1541,     0,  2116,  2116,  2657,     0,
       0,  2116,     0,     0,     0,  1541,     0,     0,     0,     0,
       0,     0,  1541,     0,    25,    26,     0,  1541,     0,     0,
      27,     0,  1541,     0,     0,     0,     0,  1541,     0,    28,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,     0,
    2116,  2116,  1541,     0,     0,     0,    29,     0,     0,     0,
       0,     0,  1287,     0,  1541,     0,     0,     0,     0,     0,
       0,  1541,     0,  1541,  1541,  1541,  1541,  1541,  1541,  1541,
    1541,  1541,  1541,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    30,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    31,     0,     0,  1541,    32,     0,    33,
       0,     0,     0,     0,    34,     0,     0,     0,     0,    35,
       0,     0,    36,     0,     0,     0,    37,  1288,     0,     0,
       0,     0,    38,     0,     0,     0,     0,     0,     0,    39,
       0,     0,    40,     0,  1287,     0,     0,     0,     0,    41,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    42,  1288,     0,     0,     0,     0,     0,     0,
    1287,     0,     0,     0,     0,     0,     0,     0,     0,    43,
       0,  1541,     0,     0,     0,     0,     0,     0,    44,     0,
      45,     0,     0,    46,     0,     0,     0,    47,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    48,
       0,     0,     0,  1287,     0,     0,     0,  1287,  1287,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    49,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1288,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1288,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1541,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1288,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1288,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1541,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1288,
       0,     0,     0,     0,     0,     0,     0,  2657,  2657,     0,
    2116,     0,     0,  2116,  2116,  2116,  2116,  2116,  2116,  2116,
    2116,  2116,  2116,  2657,     0,  1288,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,  1541,
       0,  1541,     0,     0,     0,     0,  2657,  2657,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
    2116,  2116,  1541,     0,  1541,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1288,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1541,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1288,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1288,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1288,     0,     0,     0,  1288,  1288,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2116,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,  1541,
    1541,  1541,     0,     0,  2657,     0,     0,     0,     0,  2657,
    2657,  2657,  2657,  2657,  2657,  2657,  2657,  2657,  2657,  1541,
    1541,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1541,  2116,  2116,  1541,     0,
    1541,     0,     0,     0,  1541,  2657,  2657,     0,     0,  1541,
       0,     0,  1541,     0,     0,     0,     0,     0,     0,  1541,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1541,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  2657,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,  1541,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,  1541,     0,     0,     0,
    2116,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1541,     0,  1541,     0,     0,     0,     0,  2657,
    2657,  1541,     0,     0,  2116,  2116,  1541,  1541,     0,  1541,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1541,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,  1541,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  2657,  2116,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  2657,  2657,  1541,     0,  1541,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,  2657,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,  1541,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,  1541,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,  1541,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,  1541,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,  3412,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  1065,     0,     0,     0,  1066,   696,   943,   539,   944,
     945,   946,   584,   947,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,  2205,   200,   201,   202,     0,
       0,     0,     0,   948,     0,     0,   203,   204,     0,   205,
     697,   206,   207,   208,   209,   949,   698,   950,   951,     0,
     213,   214,   215,   216,   217,   952,   953,   218,   219,   954,
     955,   222,     0,   223,   224,   225,   226,   956,     0,     0,
     228,   229,   230,   231,   699,   232,   233,     0,   234,   235,
     236,   237,   238,   239,     0,   240,   241,   242,   700,   243,
     244,   957,   958,   959,   960,   961,   962,   963,   245,   246,
     247,   248,   249,   250,   964,   965,   253,     0,   254,     0,
     255,   256,   257,   258,   259,     0,   260,   261,   262,  2206,
       0,   263,   264,   966,   266,   267,     0,   268,   269,   270,
       0,   271,   272,     0,   273,   274,   275,   276,   967,   278,
     279,   968,   969,   281,     0,   282,   970,   284,     0,   285,
       0,   286,   702,     0,   703,   287,   288,   289,     0,   290,
     971,     0,   292,     0,   293,   294,   295,   296,   297,   704,
     298,   299,   300,     0,   301,   302,   303,   304,   305,   306,
       0,   307,   705,   308,   309,   310,   311,   312,   972,   973,
       0,   974,     0,   316,   706,   707,   317,   708,   318,   319,
     320,   321,   322,   323,     0,   975,   709,   325,   710,     0,
     326,   327,   328,   976,   977,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   978,   711,
     979,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     980,   353,   354,   712,   355,   981,   982,   357,   983,   359,
     360,   361,     0,   362,     0,     0,   984,   364,   365,     0,
       0,   366,   713,   714,   715,   985,   368,   369,   370,   371,
     372,   373,     0,   374,   986,   376,   377,   378,   379,   380,
       0,   381,   382,   383,   384,   385,   386,   387,   987,   389,
     390,   391,     0,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   716,   404,   405,   988,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   989,   420,   421,   422,   423,   717,
     424,   990,     0,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   991,   437,     0,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   992,   993,     0,     0,
     448,   994,   450,   995,   996,   452,   453,   454,   455,   456,
     457,     0,   997,   458,   459,   460,   461,   998,     0,   462,
     463,   464,   465,   466,   999,  2207,   468,   718,   469,   470,
     471,     0,     0,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,
     487,   488,     0,     0,     0,     0,     0,     0,     0,  1007,
    1008,  2208,     0,     0,     0,     0,     0,     0,  1010,  2209,
     696,   943,   539,   944,   945,   946,   584,   947,     0,     0,
       0,   191,   192,   193,   194,   195,   196,   197,   198,     0,
     200,   201,   202,     0,     0,     0,     0,   948,     0,     0,
     203,   204,     0,   205,   697,   206,   207,   208,   209,   949,
     698,   950,   951,     0,   213,   214,   215,   216,   217,   952,
     953,   218,   219,   954,   955,   222,     0,   223,   224,   225,
     226,   956,     0,     0,   228,   229,   230,   231,   699,   232,
     233,     0,   234,   235,   236,   237,   238,   239,     0,   240,
     241,   242,   700,   243,   244,   957,   958,   959,   960,   961,
     962,   963,   245,   246,   247,   248,   249,   250,   964,   965,
     253,     0,   254,     0,   255,   256,   257,   258,   259,     0,
     260,   261,   262,     0,     0,   263,   264,   966,   266,   267,
       0,   268,   269,   270,     0,   271,   272,     0,   273,   274,
     275,   276,   967,   278,   279,   968,   969,   281,     0,   282,
     970,   284,     0,   285,     0,   286,   702,     0,   703,   287,
     288,   289,     0,   290,   971,     0,   292,     0,   293,   294,
     295,   296,   297,   704,   298,   299,   300,     0,   301,   302,
     303,   304,   305,   306,     0,   307,   705,   308,   309,   310,
     311,   312,   972,   973,     0,   974,     0,   316,   706,   707,
     317,   708,   318,   319,   320,   321,   322,   323,     0,   975,
     709,   325,   710,     0,   326,   327,   328,   976,   977,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   978,   711,   979,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   980,   353,   354,   712,   355,   981,
     982,   357,   983,   359,   360,   361,     0,   362,     0,     0,
     984,   364,   365,     0,     0,   366,   713,   714,   715,   985,
     368,   369,   370,   371,   372,   373,     0,   374,   986,   376,
     377,   378,   379,   380,     0,   381,   382,   383,   384,   385,
     386,   387,   987,   389,   390,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     716,   404,   405,   988,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   989,   420,
     421,   422,   423,   717,   424,   990,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   991,   437,     0,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     992,   993,     0,     0,   448,   994,   450,   995,   996,   452,
     453,   454,   455,   456,   457,     0,   997,   458,   459,   460,
     461,   998,     0,   462,   463,   464,   465,   466,   999,     0,
     468,   718,   469,   470,   471,     0,     0,   472,     0,     0,
     473,   474,   475,   476,   477,   478,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,   486,   487,   488,     0,     0,     0,     0,
       0,     0,     0,  1007,  1008,   190,     0,     0,     0,     0,
       0,     0,  1010,  2118,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,  2540,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242, -1248,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0, -1248,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307, -1248,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317, -1248,   318,   319,   320,
     321,   322,   323,     0,   324, -1248,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342, -1248,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403, -1248,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,     0,     0,     0,     0,  1257,     0,
       0,     0,     0,     0,     0,     0,     0,     0,  1089,   191,
     192,   193,   194,   195,   196,   197,   198,     0,   200,   201,
     202,     0,     0,     0,     0,     0,     0,     0,   203,   204,
       0,   205,   697,   206,   207,   208,     0,  1258,   698,  1259,
    1260,     0,   213,   214,   215,   216,   217,     0,     0,   218,
     219,  1261,  1262,   222,     0,   223,   224,   225,   226,     0,
       0,     0,   228,   229,   230,   231,   699,   232,   233,     0,
     234,   235,   236,   237,   238,   239,     0,   240,   241,   242,
     700,   243,   244,     0,     0,     0,   701,     0,     0,     0,
     245,   246,   247,   248,   249,   250,  1263,  1264,   253,     0,
     254,     0,   255,   256,   257,   258,   259,     0,   260,   261,
     262,     0,     0,   263,   264,   966,   266,   267,     0,   268,
     269,   270,     0,   271,   272,     0,   273,   274,   275,   276,
       0,   278,   279,     0,     0,   281,     0,   282,  1265,   284,
       0,   285,     0,   286,   702,     0,   703,   287,   288,   289,
       0,   290,     0,     0,   292,     0,   293,   294,   295,   296,
     297,   704,   298,   299,   300,  1763,   301,   302,   303,   304,
     305,   306,     0,   307,   705,  1764,   309,   310,   311,   312,
    1266,  1267,     0,  1268,     0,   316,   706,   707,   317,   708,
     318,   319,   320,   321,   322,   323,     0,     0,   709,   325,
     710,     0,   326,   327,   328,     0,     0,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
    1269,   711,  1270,   344,   345,   346,   347,   348,   349,   350,
       0,   352,     0,   353,   354,   712,   355,     0,     0,   357,
    1271,   359,   360,   361,     0,   362,     0,     0,   363,   364,
     365,     0,     0,  1765,   713,   714,   715,     0,   368,   369,
     370,   371,   372,   373,     0,   374,     0,   376,     0,   378,
     379,   380,     0,   381,   382,   383,   384,   385,   386,   387,
    1272,   389,   390,   391,     0,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   716,   404,
     405,     0,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,     0,   420,  1766,   422,
     423,   717,   424,  1274,     0,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,     0,   437,     0,   438,   439,
       0,   440,   441,   442,   443,   444,   445,     0,  1275,  1276,
       0,     0,   448,     0,   450,     0,     0,   452,   453,   454,
     455,   456,   457,     0,     0,   458,   459,   460,   461,     0,
       0,   462,   463,   464,   465,     0,  1277,  1767,   468,   718,
     469,   470,   471,     0,     0,   472,     0,     0,   473,   474,
     475,   476,   477,  1257,     0,     0,     0,     0,     0,     0,
       0,   486,   487,   488,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,  1768,     0,   203,   204,     0,   205,   697,   206,   207,
     208,     0,  1258,   698,  1259,  1260,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,  1261,  1262,   222,     0,
     223,   224,   225,   226,     0,     0,     0,   228,   229,   230,
     231,   699,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,   700,   243,   244,     0,     0,
       0,   701,     0,     0,     0,   245,   246,   247,   248,   249,
     250,  1263,  1264,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     966,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,     0,   278,   279,     0,     0,
     281,     0,   282,  1265,   284,     0,   285,     0,   286,   702,
       0,   703,   287,   288,   289,     0,   290,     0,     0,   292,
       0,   293,   294,   295,   296,   297,   704,   298,   299,   300,
    1763,   301,   302,   303,   304,   305,   306,     0,   307,   705,
    1764,   309,   310,   311,   312,  1266,  1267,     0,  1268,     0,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,     0,     0,   709,   325,   710,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,  1269,   711,  1270,   344,   345,
     346,   347,   348,   349,   350,     0,   352,     0,   353,   354,
     712,   355,     0,     0,   357,  1271,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,  1765,   713,
     714,   715,     0,   368,   369,   370,   371,   372,   373,     0,
     374,     0,   376,     0,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,  1272,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   716,   404,   405,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,  1766,   422,   423,   717,   424,  1274,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,  1275,  1276,     0,     0,   448,     0,   450,
       0,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
       0,  1277,  1767,   468,   718,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   696,   943,
     539,   944,   945,   946,   584,   947,   486,   487,   488,   191,
     192,   193,   194,   195,   196,   197,   198,     0,   200,   201,
     202,     0,     0,     0,     0,   948,  2521,     0,   203,   204,
       0,   205,   697,   206,   207,   208,   209,   949,   698,   950,
     951,  2128,   213,   214,   215,   216,   217,   952,   953,   218,
     219,   954,   955,   222,     0,   223,   224,   225,   226,   956,
       0,     0,   228,   229,   230,   231,   699,   232,   233,     0,
     234,   235,   236,   237,   238,   239,     0,   240,   241,   242,
     700,   243,   244,   957,   958,   959,   960,   961,   962,   963,
     245,   246,   247,   248,   249,   250,   964,   965,   253,     0,
     254,     0,   255,   256,   257,   258,   259,     0,   260,   261,
     262,     0,     0,   263,   264,   966,   266,   267,     0,   268,
     269,   270,     0,   271,   272,     0,   273,   274,   275,   276,
     967,   278,   279,   968,   969,   281,     0,   282,   970,   284,
       0,   285,     0,   286,   702,  2129,   703,   287,   288,   289,
       0,   290,   971,     0,   292,     0,   293,   294,   295,   296,
     297,   704,   298,   299,   300,     0,   301,   302,   303,   304,
     305,   306,     0,   307,   705,   308,   309,   310,   311,   312,
     972,   973,     0,   974,     0,   316,   706,   707,   317,   708,
     318,   319,   320,   321,   322,   323,  2130,   975,   709,   325,
     710,     0,   326,   327,   328,   976,   977,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     978,   711,   979,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   980,   353,   354,   712,   355,   981,   982,   357,
     983,   359,   360,   361,     0,   362,     0,     0,   984,   364,
     365,     0,     0,   366,   713,   714,   715,   985,   368,   369,
     370,   371,   372,   373,     0,   374,   986,   376,   377,   378,
     379,   380,     0,   381,   382,   383,   384,   385,   386,   387,
     987,   389,   390,   391,     0,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   716,   404,
     405,   988,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   989,   420,   421,   422,
     423,   717,   424,   990,     0,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   991,   437,     0,   438,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   992,   993,
       0,  2131,   448,   994,   450,   995,   996,   452,   453,   454,
     455,   456,   457,     0,   997,   458,   459,   460,   461,   998,
       0,   462,   463,   464,   465,   466,   999,     0,   468,   718,
     469,   470,   471,     0,     0,   472,     0,     0,   473,   474,
     475,   476,   477,   478,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,   486,   487,   488,     0,     0,     0,     0,     0,     0,
       0,  1007,  1008,     0,     0,     0,     0,     0,     0,     0,
    1010,   696,   943,   539,   944,   945,   946,   584,   947,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,   948,     0,
       0,   203,   204,     0,   205,   697,   206,   207,   208,   209,
     949,   698,   950,   951,     0,   213,   214,   215,   216,   217,
     952,   953,   218,   219,   954,   955,   222,     0,   223,   224,
     225,   226,   956,     0,     0,   228,   229,   230,   231,   699,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,   700,   243,   244,   957,   958,   959,   960,
     961,   962,   963,   245,   246,   247,   248,   249,   250,   964,
     965,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   966,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   967,   278,   279,   968,   969,   281,     0,
     282,   970,   284,     0,   285,     0,   286,   702,     0,   703,
     287,   288,   289,     0,   290,   971,     0,   292,     0,   293,
     294,   295,   296,   297,   704,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,   705,   308,   309,
     310,   311,   312,   972,   973,     0,   974,     0,   316,   706,
     707,   317,   708,   318,   319,   320,   321,   322,   323,     0,
     975,   709,   325,   710,     0,   326,   327,   328,   976,   977,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   978,   711,   979,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   980,   353,   354,   712,   355,
     981,   982,   357,   983,   359,   360,   361,     0,   362,     0,
       0,   984,   364,   365,     0,     0,   366,   713,   714,   715,
     985,   368,   369,   370,   371,   372,   373,     0,   374,   986,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   987,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   716,   404,   405,   988,   407,   408,   409,   410,   411,
     412,   413,   414,    38,   415,   416,   417,   418,   419,   989,
     420,   421,   422,   423,   717,   424,   990,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   991,   437,
       0,   438,   439,    42,   440,   441,   442,   443,   444,   445,
       0,   992,   993,     0,     0,   448,   994,   450,   995,   996,
     452,   453,   454,   455,   456,   457,     0,   997,   458,   459,
     460,   461,   998,     0,   462,   463,   464,   465,   883,   999,
       0,   468,   718,   469,   470,   471,     0,     0,   472,     0,
      48,   473,   474,   475,   476,   477,   478,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,   486,   487,   488,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,  1010,   696,   943,   539,   944,   945,   946,
     584,   947,     0,     0,     0,   191,   192,   193,   194,   195,
     196,   197,   198,     0,   200,   201,   202,     0,     0,     0,
       0,   948,     0,     0,   203,   204,     0,   205,   697,   206,
     207,   208,   209,   949,   698,   950,   951,     0,   213,   214,
     215,   216,   217,   952,   953,   218,   219,   954,   955,   222,
       0,   223,   224,   225,   226,   956,     0,     0,   228,   229,
     230,   231,   699,   232,   233,     0,   234,   235,   236,   237,
     238,   239,     0,   240,   241,   242,   700,   243,   244,   957,
     958,   959,   960,   961,   962,   963,   245,   246,   247,   248,
     249,   250,   964,   965,   253,     0,   254,     0,   255,   256,
     257,   258,   259,     0,   260,   261,   262,     0,     0,   263,
     264,   966,   266,   267,     0,   268,   269,   270,     0,   271,
     272,     0,   273,   274,   275,   276,   967,   278,   279,   968,
     969,   281,     0,   282,   970,   284,     0,   285,     0,   286,
     702,     0,   703,   287,   288,   289,     0,   290,   971,     0,
     292,     0,   293,   294,   295,   296,   297,   704,   298,   299,
     300,     0,   301,   302,   303,   304,   305,   306,     0,   307,
     705,   308,   309,   310,   311,   312,   972,   973,     0,   974,
       0,   316,   706,   707,   317,   708,   318,   319,   320,   321,
     322,   323,     0,   975,   709,   325,   710,     0,   326,   327,
     328,   976,   977,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   978,   711,   979,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   980,   353,
     354,   712,   355,   981,   982,   357,   983,   359,   360,   361,
       0,   362,     0,     0,   984,   364,   365,     0,     0,   366,
     713,   714,   715,   985,   368,   369,   370,   371,   372,   373,
       0,   374,   986,   376,   377,   378,   379,   380,     0,   381,
     382,   383,   384,   385,   386,   387,   987,   389,   390,   391,
       0,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   716,   404,   405,   988,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   989,   420,   421,   422,   423,   717,   424,   990,
       0,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   991,   437,     0,   438,   439,     0,   440,   441,   442,
     443,   444,   445,     0,   992,   993,     0,     0,   448,   994,
     450,   995,   996,   452,   453,   454,   455,   456,   457,     0,
     997,   458,   459,   460,   461,   998,     0,   462,   463,   464,
     465,   466,   999,     0,   468,   718,   469,   470,   471,     0,
       0,   472,     0,     0,   473,   474,   475,   476,   477,   478,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,   487,   488,
       0,     0,     0,     0,     0,     0,     0,  1007,  1008,     0,
       0,     0,     0,     0,  1450,  2077,  1010,   696,   943,   539,
     944,   945,   946,   584,   947,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,   948,     0,     0,   203,   204,     0,
     205,   697,   206,   207,   208,   209,   949,   698,   950,   951,
       0,   213,   214,   215,   216,   217,   952,   953,   218,   219,
     954,   955,   222,     0,   223,   224,   225,   226,   956,     0,
       0,   228,   229,   230,   231,   699,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,   700,
     243,   244,   957,   958,   959,   960,   961,   962,   963,   245,
     246,   247,   248,   249,   250,   964,   965,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   966,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   967,
     278,   279,   968,   969,   281,     0,   282,   970,   284,     0,
     285,     0,   286,   702,     0,   703,   287,   288,   289,     0,
     290,   971,     0,   292,     0,   293,   294,   295,   296,   297,
     704,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,   705,   308,   309,   310,   311,   312,   972,
     973,     0,   974,     0,   316,   706,   707,   317,   708,   318,
     319,   320,   321,   322,   323,     0,   975,   709,   325,   710,
       0,   326,   327,   328,   976,   977,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   978,
     711,   979,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   980,   353,   354,   712,   355,   981,   982,   357,   983,
     359,   360,   361,     0,   362,     0,     0,   984,   364,   365,
       0,     0,   366,   713,   714,   715,   985,   368,   369,   370,
     371,   372,   373,     0,   374,   986,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   987,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   716,   404,   405,
     988,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   989,   420,   421,   422,   423,
     717,   424,   990,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   991,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   992,   993,     0,
       0,   448,   994,   450,   995,   996,   452,   453,   454,   455,
     456,   457,     0,   997,   458,   459,   460,   461,   998,     0,
     462,   463,   464,   465,   466,   999,     0,   468,   718,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
     486,   487,   488,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,  1009,     0,     0,     0,     0,     0,     0,  1010,
     696,   943,   539,   944,   945,   946,   584,   947,     0,     0,
       0,   191,   192,   193,   194,   195,   196,   197,   198,     0,
     200,   201,   202,     0,     0,     0,     0,   948,     0,     0,
     203,   204,     0,   205,   697,   206,   207,   208,   209,   949,
     698,   950,   951,     0,   213,   214,   215,   216,   217,   952,
     953,   218,   219,   954,   955,   222,     0,   223,   224,   225,
     226,   956,     0,     0,   228,   229,   230,   231,   699,   232,
     233,     0,   234,   235,   236,   237,   238,   239,     0,   240,
     241,   242,   700,   243,   244,   957,   958,   959,   960,   961,
     962,   963,   245,   246,   247,   248,   249,   250,   964,   965,
     253,  1081,   254,     0,   255,   256,   257,   258,   259,     0,
     260,   261,   262,     0,     0,   263,   264,   966,   266,   267,
       0,   268,   269,   270,     0,   271,   272,     0,   273,   274,
     275,   276,   967,   278,   279,   968,   969,   281,     0,   282,
     970,   284,     0,   285,     0,   286,   702,     0,   703,   287,
     288,   289,     0,   290,   971,     0,   292,     0,   293,   294,
     295,   296,   297,   704,   298,   299,   300,     0,   301,   302,
     303,   304,   305,   306,     0,   307,   705,   308,   309,   310,
     311,   312,   972,   973,     0,   974,     0,   316,   706,   707,
     317,   708,   318,   319,   320,   321,   322,   323,     0,   975,
     709,   325,   710,     0,   326,   327,   328,   976,   977,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   978,   711,   979,   344,   345,   346,   347,   348,
     349,   350,   351,   352,   980,   353,   354,   712,   355,   981,
     982,   357,   983,   359,   360,   361,     0,   362,     0,     0,
     984,   364,   365,     0,     0,   366,   713,   714,   715,   985,
     368,   369,   370,   371,   372,   373,     0,   374,   986,   376,
     377,   378,   379,   380,     0,   381,   382,   383,   384,   385,
     386,   387,   987,   389,   390,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     716,   404,   405,   988,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   989,   420,
     421,   422,   423,   717,   424,   990,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   991,   437,     0,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     992,   993,     0,     0,   448,   994,   450,   995,   996,   452,
     453,   454,   455,   456,   457,     0,   997,   458,   459,   460,
     461,   998,     0,   462,   463,   464,   465,   466,   999,     0,
     468,   718,   469,   470,   471,     0,     0,   472,     0,     0,
     473,   474,   475,   476,   477,   478,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,   486,   487,   488,     0,     0,     0,     0,
       0,     0,     0,  1007,  1008,     0,     0,     0,     0,     0,
       0,     0,  1010,   696,   943,   539,   944,   945,   946,   584,
     947,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,  1697,   200,   201,   202,     0,     0,     0,     0,
     948,     0,     0,   203,   204,     0,   205,   697,   206,   207,
     208,   209,   949,   698,   950,   951,     0,   213,   214,   215,
     216,   217,   952,   953,   218,   219,   954,   955,   222,     0,
     223,   224,   225,   226,   956,     0,     0,   228,   229,   230,
     231,   699,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,   700,   243,   244,   957,   958,
     959,   960,   961,   962,   963,   245,   246,   247,   248,   249,
     250,   964,   965,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     966,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   967,   278,   279,   968,   969,
     281,     0,   282,   970,   284,     0,   285,     0,   286,   702,
       0,   703,   287,   288,   289,     0,   290,   971,     0,   292,
       0,   293,   294,   295,   296,   297,   704,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,   705,
     308,   309,   310,   311,   312,   972,   973,     0,   974,     0,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,     0,   975,   709,   325,   710,     0,   326,   327,   328,
     976,   977,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   978,   711,   979,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   980,   353,   354,
     712,   355,   981,   982,   357,   983,   359,   360,   361,     0,
     362,     0,     0,   984,   364,   365,     0,     0,   366,   713,
     714,   715,   985,   368,   369,   370,   371,   372,   373,     0,
     374,   986,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   987,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   716,   404,   405,   988,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   989,   420,   421,   422,   423,   717,   424,   990,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     991,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   992,   993,     0,     0,   448,   994,   450,
     995,   996,   452,   453,   454,   455,   456,   457,     0,   997,
     458,   459,   460,   461,   998,     0,   462,   463,   464,   465,
     466,   999,     0,   468,   718,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,   486,   487,   488,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,  1010,   696,   943,   539,   944,
     945,   946,   584,   947,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,     0,   200,   201,   202,     0,
       0,     0,     0,   948,     0,     0,   203,   204,     0,   205,
     697,   206,   207,   208,   209,   949,   698,   950,   951,     0,
     213,   214,   215,   216,   217,   952,   953,   218,   219,   954,
     955,   222,     0,   223,   224,   225,   226,   956,     0,     0,
     228,   229,   230,   231,   699,   232,   233,     0,   234,   235,
     236,   237,   238,   239,     0,   240,   241,   242,   700,   243,
     244,   957,   958,   959,   960,   961,   962,   963,   245,   246,
     247,   248,   249,   250,   964,   965,   253,     0,   254,     0,
     255,   256,   257,   258,   259,     0,   260,   261,   262,     0,
       0,   263,   264,   966,   266,   267,     0,   268,   269,   270,
       0,   271,   272,     0,   273,   274,   275,   276,   967,   278,
     279,   968,   969,   281,     0,   282,   970,   284,     0,   285,
       0,   286,   702,  2129,   703,   287,   288,   289,     0,   290,
     971,     0,   292,     0,   293,   294,   295,   296,   297,   704,
     298,   299,   300,     0,   301,   302,   303,   304,   305,   306,
       0,   307,   705,   308,   309,   310,   311,   312,   972,   973,
       0,   974,     0,   316,   706,   707,   317,   708,   318,   319,
     320,   321,   322,   323,     0,   975,   709,   325,   710,     0,
     326,   327,   328,   976,   977,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   978,   711,
     979,   344,   345,   346,   347,   348,   349,   350,   351,   352,
     980,   353,   354,   712,   355,   981,   982,   357,   983,   359,
     360,   361,     0,   362,     0,     0,   984,   364,   365,     0,
       0,   366,   713,   714,   715,   985,   368,   369,   370,   371,
     372,   373,     0,   374,   986,   376,   377,   378,   379,   380,
       0,   381,   382,   383,   384,   385,   386,   387,   987,   389,
     390,   391,     0,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   716,   404,   405,   988,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   989,   420,   421,   422,   423,   717,
     424,   990,     0,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   991,   437,     0,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   992,   993,     0,     0,
     448,   994,   450,   995,   996,   452,   453,   454,   455,   456,
     457,     0,   997,   458,   459,   460,   461,   998,     0,   462,
     463,   464,   465,   466,   999,     0,   468,   718,   469,   470,
     471,     0,     0,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,
     487,   488,     0,     0,     0,     0,     0,     0,     0,  1007,
    1008,     0,     0,     0,     0,     0,     0,     0,  1010,   696,
     943,   539,   944,   945,   946,   584,   947,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,   948,     0,     0,   203,
     204,     0,   205,   697,   206,   207,   208,   209,   949,   698,
     950,   951,     0,   213,   214,   215,   216,   217,   952,   953,
     218,   219,   954,   955,   222,     0,   223,   224,   225,   226,
     956,     0,     0,   228,   229,   230,   231,   699,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,   700,   243,   244,   957,   958,   959,   960,   961,   962,
     963,   245,   246,   247,   248,   249,   250,   964,   965,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   966,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   967,   278,   279,   968,   969,   281,     0,   282,   970,
     284,     0,   285,     0,   286,   702,     0,   703,   287,   288,
     289,     0,   290,   971,     0,   292,     0,   293,   294,   295,
     296,   297,   704,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,   705,   308,   309,   310,   311,
     312,   972,   973,     0,   974,     0,   316,   706,   707,   317,
     708,   318,   319,   320,   321,   322,   323,     0,   975,   709,
     325,   710,     0,   326,   327,   328,   976,   977,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   978,   711,   979,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   980,   353,   354,   712,   355,   981,   982,
     357,   983,   359,   360,   361,     0,   362,     0,     0,   984,
     364,   365,     0,     0,   366,   713,   714,   715,   985,   368,
     369,   370,   371,   372,   373,     0,   374,   986,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   987,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   716,
     404,   405,   988,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   989,   420,   421,
     422,   423,   717,   424,   990,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   991,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   992,
     993,     0,     0,   448,   994,   450,   995,   996,   452,   453,
     454,   455,   456,   457,     0,   997,   458,   459,   460,   461,
     998,     0,   462,   463,   464,   465,   466,   999,  3129,   468,
     718,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   486,   487,   488,     0,     0,     0,     0,     0,
       0,     0,  1007,  1008,     0,     0,     0,     0,     0,     0,
       0,  1010,   696,   943,   539,   944,   945,   946,   584,   947,
       0,     0,     0,   191,   192,   193,   194,   195,   196,   197,
     198,     0,   200,   201,   202,     0,     0,     0,     0,   948,
       0,     0,   203,   204,     0,   205,   697,   206,   207,   208,
     209,   949,   698,   950,   951,     0,   213,   214,   215,   216,
     217,   952,   953,   218,   219,   954,   955,   222,     0,   223,
     224,   225,   226,   956,     0,     0,   228,   229,   230,   231,
     699,   232,   233,     0,   234,   235,   236,   237,   238,   239,
       0,   240,   241,   242,   700,   243,   244,   957,   958,   959,
     960,   961,   962,   963,   245,   246,   247,   248,   249,   250,
     964,   965,   253,     0,   254,     0,   255,   256,   257,   258,
     259,     0,   260,   261,   262,     0,     0,   263,   264,   966,
     266,   267,     0,   268,   269,   270,     0,   271,   272,     0,
     273,   274,   275,   276,   967,   278,   279,   968,   969,   281,
       0,   282,   970,   284,     0,   285,     0,   286,   702,     0,
     703,   287,   288,   289,     0,   290,   971,     0,   292,     0,
     293,   294,   295,   296,   297,   704,   298,   299,   300,     0,
     301,   302,   303,   304,   305,   306,     0,   307,   705,   308,
     309,   310,   311,   312,   972,   973,     0,   974,     0,   316,
     706,   707,   317,   708,   318,   319,   320,   321,   322,   323,
       0,   975,   709,   325,   710,     0,   326,   327,   328,   976,
     977,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   978,   711,   979,   344,   345,   346,
     347,   348,   349,   350,   351,   352,   980,   353,   354,   712,
     355,   981,   982,   357,   983,   359,   360,   361,     0,   362,
       0,     0,   984,   364,   365,     0,     0,   366,   713,   714,
     715,   985,   368,   369,   370,   371,   372,   373,     0,   374,
     986,   376,   377,   378,   379,   380,     0,   381,   382,   383,
     384,   385,   386,   387,   987,   389,   390,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,   716,   404,   405,   988,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
     989,   420,   421,   422,   423,   717,   424,   990,     0,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   991,
     437,     0,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   992,   993,     0,     0,   448,   994,   450,   995,
     996,   452,   453,   454,   455,   456,   457,     0,   997,   458,
     459,   460,   461,   998,     0,   462,   463,   464,   465,   466,
     999,     0,   468,   718,   469,   470,   471,     0,     0,   472,
       0,     0,   473,   474,   475,   476,   477,   478,  1000,  1001,
    1002,  1003,  1004,  1005,  1006,   486,   487,   488,     0,     0,
       0,     0,     0,     0,     0,  1007,  1008,     0,     0,     0,
       0,     0,     0,     0,  1010,   696,   943,   539,   944,   945,
     946,   584,   947,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,   948,     0,     0,   203,   204,     0,   205,   697,
     206,   207,   208,   209,   949,   698,   950,   951,     0,   213,
     214,   215,   216,   217,   952,   953,   218,   219,   954,   955,
     222,     0,   223,   224,   225,   226,   956,     0,     0,   228,
     229,   230,   231,   699,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,   700,   243,  2558,
     957,   958,   959,   960,   961,   962,   963,   245,   246,   247,
     248,   249,   250,   964,   965,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   966,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   967,   278,   279,
     968,   969,   281,     0,   282,   970,   284,     0,   285,     0,
     286,   702,     0,   703,   287,   288,   289,     0,   290,   971,
       0,   292,     0,   293,   294,   295,   296,   297,   704,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,   705,   308,   309,   310,   311,   312,   972,   973,     0,
     974,     0,   316,   706,   707,   317,   708,   318,   319,   320,
     321,   322,   323,     0,   975,   709,   325,   710,     0,   326,
     327,   328,   976,   977,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   978,   711,   979,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   980,
     353,   354,   712,   355,   981,   982,   357,   983,   359,   360,
     361,     0,   362,     0,     0,   984,   364,   365,     0,     0,
     366,   713,   714,   715,   985,   368,   369,   370,   371,   372,
     373,     0,   374,   986,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   987,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   716,   404,   405,   988,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   989,   420,   421,   422,   423,   717,   424,
     990,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   991,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   992,   993,     0,     0,   448,
     994,   450,   995,   996,   452,   453,   454,   455,   456,   457,
       0,   997,   458,   459,   460,   461,   998,     0,   462,   463,
     464,   465,   466,   999,     0,   468,   718,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,   487,
     488,     0,     0,     0,     0,     0,     0,     0,  1007,  1008,
       0,     0,     0,     0,     0,     0,     0,  1010,   696,   943,
     539,   944,   945,   946,   584,   947,     0,     0,     0,   191,
     192,   193,   194,   195,   196,   197,   198,     0,   200,   201,
     202,     0,     0,     0,     0,   948,     0,     0,   203,   204,
       0,   205,   697,   206,   207,   208,   209,   949,   698,   950,
     951,     0,   213,   214,   215,   216,   217,   952,   953,   218,
     219,   954,   955,   222,     0,   223,   224,   225,   226,   956,
       0,     0,   228,   229,   230,   231,   699,   232,   233,     0,
     234,   235,   236,   237,   238,   239,     0,   240,   241,   242,
     700,   243,   244,   957,   958,   959,   960,   961,   962,   963,
     245,   246,   247,   248,   249,   250,   964,   965,   253,     0,
     254,     0,   255,   256,   257,   258,   259,     0,   260,   261,
     262,     0,     0,   263,   264,   966,   266,   267,     0,   268,
     269,   270,     0,   271,   272,     0,   273,   274,   275,   276,
     967,   278,   279,   968,   969,   281,     0,   282,   970,   284,
       0,   285,     0,   286,   702,     0,   703,   287,   288,   289,
       0,   290,   971,     0,   292,     0,   293,   294,   295,   296,
     297,   704,   298,   299,   300,     0,   301,   302,   303,   304,
     305,   306,     0,   307,   705,   308,   309,   310,   311,   312,
     972,   973,     0,   974,     0,   316,   706,   707,   317,   708,
     318,   319,   320,   321,   322,   323,     0,   975,   709,   325,
     710,     0,   326,   327,   328,   976,   977,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     978,   711,   979,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   980,   353,   354,   712,   355,   981,   982,   357,
     983,   359,   360,   361,     0,   362,     0,     0,   984,   364,
     365,     0,     0,   366,   713,   714,   715,   985,   368,   369,
     370,   371,   372,   373,     0,   374,   986,   376,   377,   378,
     379,   380,     0,   381,   382,   383,   384,   385,   386,   387,
     987,   389,   390,   391,     0,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,   716,   404,
     405,   988,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,   989,   420,   421,   422,
     423,   717,   424,   990,     0,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   991,   437,     0,   438,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   992,   993,
       0,     0,   448,   994,   450,   995,   996,   452,   453,   454,
     455,   456,   457,     0,   997,   458,   459,   460,   461,   998,
       0,   462,   463,   464,   465,   466,   999,     0,   468,   718,
     469,   470,   471,     0,     0,   472,     0,     0,   473,   474,
     475,   476,   477,  3361,  1000,  1001,  1002,  1003,  1004,  1005,
    1006,   486,   487,   488,     0,     0,     0,     0,     0,     0,
       0,  1007,  1008,     0,     0,     0,     0,     0,     0,     0,
    1010,   696,   943,   539,   944,   945,   946,   584,   947,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,   948,     0,
       0,   203,   204,     0,   205,   697,   206,   207,   208,   209,
     949,   698,   950,   951,     0,   213,   214,   215,   216,   217,
     952,   953,   218,   219,   954,   955,   222,     0,   223,   224,
     225,   226,   956,     0,     0,   228,   229,   230,   231,   699,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,   700,   243,   244,   957,   958,   959,   960,
     961,   962,   963,   245,   246,   247,   248,   249,   250,   964,
     965,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   966,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   967,   278,   279,   968,   969,   281,     0,
     282,   970,   284,     0,   285,     0,   286,   702,     0,   703,
     287,   288,   289,     0,   290,   971,     0,   292,     0,   293,
     294,   295,   296,   297,   704,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,   705,   308,   309,
     310,   311,   312,   972,   973,     0,   974,     0,   316,   706,
     707,   317,   708,   318,   319,   320,   321,   322,   323,     0,
     975,   709,   325,   710,     0,   326,   327,   328,   976,   977,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   978,   711,   979,   344,  3368,   346,   347,
     348,   349,   350,   351,   352,   980,   353,   354,   712,   355,
     981,   982,   357,   983,   359,   360,   361,     0,   362,     0,
       0,   984,   364,   365,     0,     0,   366,   713,   714,   715,
     985,   368,   369,   370,   371,   372,   373,     0,   374,   986,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   987,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   716,   404,   405,   988,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,   989,
     420,   421,   422,   423,   717,   424,   990,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   991,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   992,   993,     0,     0,   448,   994,   450,   995,   996,
     452,   453,   454,   455,   456,   457,     0,   997,   458,   459,
     460,   461,   998,     0,   462,   463,   464,   465,   466,   999,
       0,   468,   718,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,   486,   487,   488,     0,     0,     0,
       0,     0,     0,     0,  1007,  1008,     0,     0,     0,     0,
       0,     0,     0,  1010,   696,   943,   539,   944,   945,   946,
     584,   947,     0,     0,     0,   191,   192,   193,   194,   195,
     196,   197,   198,     0,   200,   201,   202,     0,     0,     0,
       0,   948,     0,     0,   203,   204,     0,   205,   697,   206,
     207,   208,  3757,   949,   698,   950,   951,     0,   213,   214,
     215,   216,   217,   952,   953,   218,   219,   954,   955,   222,
       0,   223,   224,   225,   226,   956,     0,     0,   228,   229,
     230,   231,   699,   232,   233,     0,   234,   235,   236,   237,
     238,   239,     0,   240,   241,   242,   700,   243,  3758,   957,
     958,   959,   960,   961,   962,   963,   245,   246,   247,   248,
     249,   250,   964,   965,   253,     0,   254,     0,   255,   256,
     257,   258,   259,     0,   260,   261,   262,     0,     0,   263,
     264,   966,   266,   267,     0,   268,   269,   270,     0,   271,
     272,     0,   273,   274,   275,   276,   967,   278,   279,   968,
     969,   281,     0,   282,   970,   284,     0,   285,     0,   286,
     702,     0,   703,   287,   288,   289,     0,   290,   971,     0,
     292,     0,   293,   294,   295,   296,   297,   704,   298,   299,
     300,     0,   301,   302,   303,   304,   305,   306,     0,   307,
     705,   308,   309,   310,   311,   312,   972,   973,     0,   974,
       0,   316,   706,   707,   317,   708,   318,   319,   320,   321,
     322,   323,     0,   975,   709,   325,   710,     0,   326,   327,
     328,   976,   977,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   978,   711,   979,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   980,   353,
     354,   712,   355,   981,   982,   357,   983,   359,   360,   361,
       0,   362,     0,     0,   984,   364,   365,     0,     0,   366,
     713,   714,   715,   985,   368,   369,   370,   371,   372,   373,
       0,   374,   986,   376,   377,   378,   379,   380,     0,   381,
     382,   383,   384,   385,   386,   387,   987,   389,   390,   391,
       0,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   716,   404,   405,   988,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,   989,   420,   421,   422,   423,   717,   424,   990,
       0,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,   991,   437,     0,   438,   439,     0,   440,   441,   442,
     443,   444,   445,     0,   992,   993,     0,     0,   448,   994,
     450,   995,   996,   452,   453,   454,  3759,   456,   457,     0,
     997,   458,   459,   460,   461,   998,     0,   462,   463,   464,
     465,   466,   999,     0,   468,   718,   469,   470,   471,     0,
       0,   472,     0,     0,   473,   474,   475,   476,   477,   478,
    1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,   487,   488,
       0,     0,     0,     0,     0,     0,     0,  1007,  1008,     0,
       0,     0,     0,     0,     0,     0,  1010,   696,   943,   539,
     944,   945,   946,   584,   947,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,   948,     0,     0,   203,   204,     0,
     205,   697,   206,   207,   208,   209,   949,   698,   950,   951,
       0,   213,   214,   215,   216,   217,   952,   953,   218,   219,
     954,   955,   222,     0,   223,   224,   225,   226,   956,     0,
       0,   228,   229,   230,   231,   699,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,   700,
     243,  3758,   957,   958,   959,   960,   961,   962,   963,   245,
     246,   247,   248,   249,   250,   964,   965,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   966,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   967,
     278,   279,   968,   969,   281,     0,   282,   970,   284,     0,
     285,     0,   286,   702,     0,   703,   287,   288,   289,     0,
     290,   971,     0,   292,     0,   293,   294,   295,   296,   297,
     704,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,   705,   308,   309,   310,   311,   312,   972,
     973,     0,   974,     0,   316,   706,   707,   317,   708,   318,
     319,   320,   321,   322,   323,     0,   975,   709,   325,   710,
       0,   326,   327,   328,   976,   977,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   978,
     711,   979,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   980,   353,   354,   712,   355,   981,   982,   357,   983,
     359,   360,   361,     0,   362,     0,     0,   984,   364,   365,
       0,     0,   366,   713,   714,   715,   985,   368,   369,   370,
     371,   372,   373,     0,   374,   986,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   987,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   716,   404,   405,
     988,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,   989,   420,   421,   422,   423,
     717,   424,   990,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   991,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   992,   993,     0,
       0,   448,   994,   450,   995,   996,   452,   453,   454,  3759,
     456,   457,     0,   997,   458,   459,   460,   461,   998,     0,
     462,   463,   464,   465,   466,   999,     0,   468,   718,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,
     486,   487,   488,     0,     0,     0,     0,     0,     0,     0,
    1007,  1008,     0,     0,     0,     0,     0,     0,     0,  1010,
     696,   943,   539,   944,   945,   946,   584,   947,     0,     0,
       0,   191,   192,   193,   194,   195,   196,   197,   198,     0,
     200,   201,   202,     0,     0,     0,     0,   948,     0,     0,
     203,   204,     0,   205,   697,   206,   207,   208,   209,   949,
     698,   950,   951,     0,   213,   214,   215,   216,   217,   952,
     953,   218,   219,   954,   955,   222,     0,   223,   224,   225,
     226,   956,     0,     0,   228,   229,   230,   231,   699,   232,
     233,     0,   234,   235,   236,   237,   238,   239,     0,   240,
     241,   242,   700,   243,   244,   957,   958,   959,   960,   961,
     962,   963,   245,   246,   247,   248,   249,   250,   964,   965,
     253,     0,   254,     0,   255,   256,   257,   258,   259,     0,
     260,   261,   262,     0,     0,   263,   264,   966,   266,   267,
       0,   268,   269,   270,     0,   271,   272,     0,   273,   274,
     275,   276,   967,   278,   279,   968,   969,   281,     0,   282,
     970,   284,     0,   285,     0,   286,   702,     0,   703,   287,
     288,   289,     0,   290,   971,     0,   292,     0,   293,   294,
     295,   296,   297,   704,   298,   299,   300,     0,   301,   302,
     303,   304,   305,   306,     0,   307,   705,   308,   309,   310,
     311,   312,   972,   973,     0,   974,     0,   316,   706,   707,
     317,   708,   318,   319,   320,   321,   322,   323,     0,   975,
     709,   325,   710,     0,   326,   327,   328,   976,   977,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   978,   711,   979,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,   712,   355,   981,
     982,   357,   983,   359,   360,   361,     0,   362,     0,     0,
     984,   364,   365,     0,     0,   366,   713,   714,   715,   985,
     368,   369,   370,   371,   372,   373,     0,   374,   986,   376,
     377,   378,   379,   380,     0,   381,   382,   383,   384,   385,
     386,   387,   987,   389,   390,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     716,   404,   405,   988,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,   989,   420,
     421,   422,   423,   717,   424,   990,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   991,   437,     0,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     992,   993,     0,     0,   448,   994,   450,   995,   996,   452,
     453,   454,   455,   456,   457,     0,     0,   458,   459,   460,
     461,   998,     0,   462,   463,   464,   465,   466,   999,     0,
     468,   718,   469,   470,   471,     0,     0,   472,     0,     0,
     473,   474,   475,   476,   477,   478,  1000,  1001,  1002,  1003,
    1004,  1005,  1006,   486,   487,   488,     0,     0,     0,     0,
       0,     0,     0,  2111,  2112,     0,     0,     0,     0,     0,
       0,     0,  1010,   696,   943,   539,   944,   945,   946,   584,
     947,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
     948,     0,     0,   203,   204,     0,   205,   697,   206,   207,
     208, -1995,   949,   698,   950,   951,     0,   213,   214,   215,
     216,   217,   952,   953,   218,   219,   954,   955,   222,     0,
     223,   224,   225,   226,   956,     0,     0,   228,   229,   230,
     231,   699,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,   700,   243,  3758,   957,   958,
     959,   960,   961,   962,   963,   245,   246,   247,   248,   249,
     250,   964,   965,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     966,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   967,   278,   279,   968,   969,
     281,     0,   282,   970,   284,     0,   285,     0,   286,   702,
       0,   703,   287,   288,   289,     0,   290,   971,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,   705,
     308,   309,   310,   311,   312,   972,   973,     0,   974,     0,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,     0,   975,   709,   325,     0,     0,   326,   327,   328,
     976,   977,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   978,   711,   979,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     712,   355,   981,   982,   357,   983,   359,   360,   361,     0,
     362,     0,     0,   984,   364,   365,     0,     0,   366,   713,
     714,   715,   985,   368,   369,   370,   371,   372,   373,     0,
     374,   986,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   987,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   716,   404,   405,   988,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   989,   420,   421,   422,   423,     0,   424,   990,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     991,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   992,   993,     0,     0,   448,   994,   450,
     995,   996,   452,   453,   454,  3759,   456,   457,     0,   997,
     458,   459,   460,   461,   998,     0,   462,   463,   464,   465,
     466,   999,     0,   468,   718,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,   486,   487,   488,     0,
       0,     0,     0,     0,     0,     0,  1007,  1008,     0,     0,
       0,     0,     0,     0,     0,  1010,   696,   943,   539,   944,
     945,   946,   584,   947,     0,     0,     0,   191,   192,   193,
     194,   195,   196,   197,   198,     0,   200,   201,   202,     0,
       0,     0,     0,   948,     0,     0,   203,   204,     0,   205,
     697,   206,   207,   208,     0,   949,   698,   950,   951,     0,
     213,   214,   215,   216,   217,   952,   953,   218,   219,   954,
     955,   222,     0,   223,   224,   225,   226,   956,     0,     0,
     228,   229,   230,   231,   699,   232,   233,     0,   234,   235,
     236,   237,   238,   239,     0,   240,   241,   242,   700,   243,
     244,   957,   958,   959,   960,   961,   962,   963,   245,   246,
     247,   248,   249,   250,   964,   965,   253,     0,   254,     0,
     255,   256,   257,   258,   259,     0,   260,   261,   262,     0,
       0,   263,   264,   966,   266,   267,     0,   268,   269,   270,
       0,   271,     0,     0,   273,   274,   275,   276,   967,   278,
     279,   968,   969,   281,     0,   282,   970,   284,     0,   285,
       0,   286,   702,     0,   703,   287,   288,   289,     0,   290,
     971,     0,   292,     0,   293,   294,   295,   296,   297,     0,
     298,   299,   300,     0,   301,   302,   303,   304,   305,   306,
       0,   307,   705,   308,   309,   310,   311,   312,   972,   973,
       0,   974,     0,   316,   706,   707,   317,   708,   318,   319,
     320,   321,   322,   323,     0,   975,   709,   325,     0,     0,
     326,   327,   328,   976,   977,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   978,   711,
     979,   344,   345,   346,   347,   348,   349,   350,   351,   352,
       0,   353,   354,   712,   355,   981,   982,   357,   983,   359,
     360,   361,     0,   362,     0,     0,   984,   364,   365,     0,
       0,   366,   713,   714,   715,   985,   368,   369,   370,   371,
     372,   373,     0,   374,   986,   376,   377,   378,   379,   380,
       0,   381,   382,   383,   384,   385,   386,   387,   987,   389,
     390,   391,     0,   392,   393,   394,   395,   396,   397,   398,
     399,   400,   401,     0,   402,   403,   716,   404,   405,   988,
     407,   408,   409,   410,   411,   412,   413,   414,     0,   415,
     416,   417,   418,   419,   989,   420,   421,   422,   423,     0,
     424,   990,     0,   426,   427,   428,   429,   430,   431,   432,
     433,   434,   435,   991,   437,     0,   438,   439,     0,   440,
     441,   442,   443,   444,   445,     0,   992,   993,     0,     0,
     448,   994,   450,   995,   996,   452,   453,   454,   455,   456,
     457,     0,   997,   458,   459,   460,   461,   998,     0,   462,
     463,   464,   465,   466,   999,     0,   468,   718,   469,   470,
     471,     0,     0,   472,     0,     0,   473,   474,   475,   476,
     477,   478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,
     487,   488,     0,     0,     0,     0,     0,     0,     0,  1007,
    1008,     0,     0,     0,     0,     0,     0,     0,  1010,   696,
     943,   539,   944,   945,   946,   584,   947,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,   948,     0,     0,   203,
     204,     0,   205,   697,   206,   207,   208,     0,   949,   698,
     950,   951,     0,   213,   214,   215,   216,   217,   952,   953,
     218,   219,   954,   955,   222,     0,   223,   224,   225,   226,
     956,     0,     0,   228,   229,   230,   231,   699,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,   700,   243,   244,   957,   958,   959,   960,   961,   962,
     963,   245,   246,   247,   248,   249,   250,   964,   965,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   966,   266,   267,     0,
     268,   269,   270,     0,   271,     0,     0,   273,   274,   275,
     276,   967,   278,   279,   968,   969,   281,     0,   282,   970,
     284,     0,   285,     0,   286,   702,     0,   703,   287,   288,
     289,     0,   290,   971,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,   705,   308,   309,   310,   311,
     312,   972,   973,     0,   974,     0,   316,   706,   707,   317,
     708,   318,   319,   320,   321,   322,   323,     0,   975,   709,
     325,     0,     0,   326,   327,   328,   976,   977,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   978,   711,   979,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,   712,   355,   981,   982,
     357,   983,   359,   360,   361,     0,   362,     0,     0,   984,
     364,   365,     0,     0,   366,   713,   714,   715,   985,   368,
     369,   370,   371,   372,   373,     0,   374,   986,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   987,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   716,
     404,   405,   988,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,   989,   420,   421,
     422,   423,     0,   424,   990,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   991,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   992,
     993,     0,     0,   448,   994,   450,   995,   996,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
     998,     0,   462,   463,   464,   465,   466,   999,     0,   468,
     718,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,  1000,  1001,  1002,  1003,  1004,
    1005,  1006,   486,   487,   488,     0,     0,     0,     0,     0,
       0,   696,  2111,  2112,     0,     0,     0,     0,     0,     0,
       0,  1010,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,   697,   206,   207,   208,   209,
     210,   698,   211,   212,     0,   213,   214,   215,   216,   217,
       0,   953,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   956,     0,     0,   228,   229,   230,   231,   699,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,   700,   243,   244,   957,   958,   959,   960,
     961,   962,   963,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   968,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,   702,     0,   703,
     287,   288,   289,     0,   290,   971,     0,   292,     0,   293,
     294,   295,   296,   297,   704,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,   705,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   706,
     707,   317,   708,   318,   319,   320,   321,   322,   323,     0,
     975,   709,   325,   710,     0,   326,   327,   328,   976,   977,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   711,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   712,   355,
       0,   982,   357,   358,   359,   360,   361,     0,   362,     0,
     663,   363,   364,   365,     0,     0,   366,   713,   714,   715,
     985,   368,   369,   370,   371,   372,   373,     0,   374,   986,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   716,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    38,   415,   416,   417,   418,   419,   989,
     420,   421,   422,   423,   717,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   991,   437,
       0,   438,   439,    42,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   994,   450,   995,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,   998,     0,   462,   463,   464,   465,   883,   467,
       0,   468,   718,   469,   470,   471,     0,     0,   472,     0,
      48,   473,   474,   475,   476,   477,   478,  1000,  1001,  1002,
    1003,  1004,  1005,  1006,   486,   487,   488,     0,     0,     0,
       0,     0,     0,   696,     0,     0,     0,     0,     0,     0,
       0,     0,     0,  1971,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,   697,   206,   207,
     208,   209,   210,   698,   211,   212,     0,   213,   214,   215,
     216,   217,     0,   953,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   956,     0,     0,   228,   229,   230,
     231,   699,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,   700,   243,   244,   957,   958,
     959,   960,   961,   962,   963,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   968,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,   702,
       0,   703,   287,   288,   289,     0,   290,   971,     0,   292,
       0,   293,   294,   295,   296,   297,   704,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,   705,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,     0,   975,   709,   325,   710,     0,   326,   327,   328,
     976,   977,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   711,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     712,   355,     0,   982,   357,   358,   359,   360,   361,     0,
     362,     0,   663,   363,   364,   365,     0,     0,   366,   713,
     714,   715,   985,   368,   369,   370,   371,   372,   373,     0,
     374,   986,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   716,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,   989,   420,   421,   422,   423,   717,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     991,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   994,   450,
     995,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,   998,     0,   462,   463,   464,   465,
     466,   467,     0,   468,   718,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,  1000,
    1001,  1002,  1003,  1004,  1005,  1006,   486,   487,   488,     0,
       0,     0,     0,     0,     0,   696,     0,     0,     0,     0,
       0,     0,     0,     0,     0,  1971,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,   697,
     206,   207,   208,   209,   210,   698,   211,   212,     0,   213,
     214,   215,   216,   217,     0,   953,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   956,     0,     0,   228,
     229,   230,   231,   699,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,   700,   243,   244,
     957,   958,   959,   960,   961,   962,   963,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     968,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,   702,     0,   703,   287,   288,   289,     0,   290,   971,
       0,   292,     0,   293,   294,   295,   296,   297,   704,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,   705,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,   706,   707,   317,   708,   318,   319,   320,
     321,   322,   323,     0,   975,   709,   325,   710,     0,   326,
     327,   328,   976,   977,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   711,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,   712,   355,     0,   982,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,   713,   714,   715,   985,   368,   369,   370,   371,   372,
     373,     0,   374,   986,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   716,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,   989,   420,   421,   422,   423,   717,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   991,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     994,   450,   995,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,   998,     0,   462,   463,
     464,   465,   466,   467,     0,   468,   718,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,  1000,  1001,  1002,  1003,  1004,  1005,  1006,   486,   487,
     488,     0,     0,     0,     0,     0,     0,   696,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  3149,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,   697,   206,   207,   208,   209,   210,   698,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   699,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,   700,
     243,   244,     0,     0,     0,   701,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,   702,     0,   703,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
     704,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,   705,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   706,   707,   317,   708,   318,
     319,   320,   321,   322,   323,     0,   324,   709,   325,   710,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     711,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   712,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,   713,   714,   715,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   716,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     717,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,   718,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,     0,     0,     0,     0,     0,     0,   190,
    1169,   539,     0,     0,     0,   584,     0,     0,     0,  3578,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,  1383,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,  1384,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,  1385,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,     0,     0,     0,     0,     0,
       0,   190,   596,  1170,  3226,     0,     0,     0,     0,     0,
       0,  3227,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     3,     4,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,    38,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,    42,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   883,   467,
       0,   468,   884,   469,   470,   471,     0,     0,   472,     0,
      48,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,     0,     0,     0,
       0,     0,     0,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    49,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,    38,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,    42,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     883,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,    48,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,     0,
       0,     0,     0,     0,     0,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    49,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,     0,     0,     0,     0,     0,     0,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1062,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,     0,     0,     0,     0,     0,     0,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,  1669,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,     0,     0,     0,     0,     0,
       0,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,  2999,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,     0,     0,     0,
       0,     0,     0,  1257,  1169,   539,     0,     0,   737,   584,
       0,     0,     0,  3123,   191,   192,   193,   194,   195,   196,
     197,   198,  1581,   200,   201,   202,  1582,  1583,  1584,  1585,
    1586,  1587,  1588,   203,   204,  1589,   205,   697,   206,   207,
     208,     0,  1258,   698,  1259,  1260,  1590,   213,   214,   215,
     216,   217,  1591,  1592,   218,   219,  1261,  1262,   222,  1593,
     223,   224,   225,   226,     0,  1594,  1595,   228,   229,   230,
     231,   699,   232,   233,  1596,   234,   235,   236,   237,   238,
     239,  1597,   240,   241,   242,   700,   243,   244,  1598,  1599,
    1600,   701,  1601,  1602,  1603,   245,   246,   247,   248,   249,
     250,  1263,  1264,   253,  1604,   254,  1605,   255,   256,   257,
     258,   259,  1606,   260,   261,   262,  1607,  1608,   263,   264,
     966,   266,   267,  1609,   268,   269,   270,  1610,   271,   272,
    1611,   273,   274,   275,   276,     0,   278,   279,     0,  1612,
     281,  1613,   282,  1265,   284,  1614,   285,  1615,   286,   702,
    1616,   703,   287,   288,   289,  1617,   290,     0,  1618,   292,
    1619,   293,   294,   295,   296,   297,   704,   298,   299,   300,
    1620,   301,   302,   303,   304,   305,   306,  1621,   307,   705,
       0,   309,   310,   311,   312,  1266,  1267,  1622,  1268,  1623,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,  1624,     0,   709,   325,   710,  1625,   326,   327,   328,
    1626,  1627,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,  1269,   711,  1270,   344,   345,
     346,   347,   348,   349,   350,     0,   352,  1628,   353,   354,
     712,   355,  1629,     0,   357,  1271,   359,   360,   361,  1630,
     362,  1631,  1632,  2875,   364,   365,  1633,  1634,     0,   713,
     714,   715,     0,   368,   369,   370,   371,   372,   373,  1635,
     374,     0,   376,     0,   378,   379,   380,  1636,   381,   382,
     383,   384,   385,   386,   387,  1272,   389,   390,   391,  1637,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
    1638,   402,   403,   716,   404,   405,     0,   407,   408,   409,
     410,   411,   412,   413,   414,  1639,   415,   416,   417,   418,
     419,  1640,   420,  1766,   422,   423,   717,   424,  1274,  1641,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,  1642,   438,   439,  1643,   440,   441,   442,   443,
     444,   445,  1644,  1275,  1276,  1645,  1646,   448,     0,   450,
       0,  1647,   452,   453,   454,   455,   456,   457,  1648,  1649,
     458,   459,   460,   461,  1650,  1651,   462,   463,   464,   465,
       0,  1277,  1652,   468,   718,   469,   470,   471,  1653,  1654,
     472,  1655,  1656,   473,   474,   475,   476,   477,     0,     0,
       0,     0,     0,     0,     0,     0,   486,   487,   488,     0,
       0,     0,   740,   741,   742,     0,  2876,  2877,   745,   746,
     747,   748,   190,     0,     0,     0,     0,   737,     0,     0,
       0,     0,     0,   191,   192,   193,   194,   195,   196,   197,
     198,     0,   200,   201,   202,     0,     0,     0,     0,     0,
       0,     0,   203,   204,     0,   205,     0,   206,   207,   208,
     209,   210,     0,   211,   212,     0,   213,   214,   215,   216,
     217,     0,     0,   218,   219,   220,   221,   222,     0,   223,
     738,   225,   226,   227,     0,     0,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,   239,
       0,   240,   241,   242,     0,   243,   244,     0,     0,     0,
       0,     0,     0,     0,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,   254,     0,   255,   256,   257,   258,
     259,     0,   260,   261,   262,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,     0,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   739,
       0,   282,   283,   284,     0,   285,     0,   286,     0,     0,
       0,   287,   288,   289,     0,   290,   291,     0,   292,     0,
     293,   294,   295,   296,   297,     0,   298,   299,   300,     0,
     301,   302,   303,   304,   305,   306,     0,   307,     0,   308,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
       0,     0,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,   327,   328,     0,
       0,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,     0,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
       0,     0,   363,   364,   365,     0,     0,   366,     0,     0,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,     0,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,     0,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,     0,   424,   425,     0,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,   451,
       0,   452,   453,   454,   455,   456,   457,     0,     0,   458,
     459,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,     0,   468,     0,   469,   470,   471,     0,     0,   472,
       0,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,     0,     0,
       0,   740,   741,   742,     0,   743,   744,   745,   746,   747,
     748,   190,     0,     0,     0,     0,   737,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   812,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   813,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,     0,     0,     0,
     740,   741,   742,     0,   743,   744,   745,   746,   747,   748,
     190,     0,     0,     0,     0,   737,     0,     0,     0,     0,
       0,   191,   192,   193,   194,   195,   196,   197,   198,     0,
     200,   201,   202,     0,     0,     0,     0,     0,     0,     0,
     203,   204,     0,   205,     0,   206,   207,   208,   209,   210,
       0,   211,   212,     0,   213,   214,   215,   216,   217,     0,
       0,   218,   219,   220,   221,   222,     0,   223,   856,   225,
     226,   227,     0,     0,   228,   229,   230,   231,     0,   232,
     233,     0,   234,   235,   236,   237,   238,   239,     0,   240,
     241,   242,     0,   243,   244,     0,     0,     0,     0,     0,
       0,     0,   245,   246,   247,   248,   249,   250,   251,   252,
     253,     0,   254,     0,   255,   256,   257,   258,   259,     0,
     260,   261,   262,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,     0,   273,   274,
     275,   276,   277,   278,   279,   280,     0,   857,     0,   282,
     283,   284,     0,   285,     0,   286,     0,     0,     0,   287,
     288,   289,     0,   290,   291,     0,   292,     0,   293,   294,
     295,   296,   858,     0,   298,   299,   300,     0,   301,   302,
     303,   304,   305,   306,     0,   307,     0,   308,   309,   310,
     311,   312,   313,   314,     0,   315,     0,   316,     0,     0,
     317,     0,   318,   319,   320,   321,   322,   323,     0,   324,
       0,   325,     0,     0,   326,   327,   328,     0,     0,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,   342,     0,   343,   344,   345,   346,   347,   348,
     349,   350,   351,   352,     0,   353,   354,     0,   355,     0,
     356,   357,   358,   359,   360,   361,     0,   362,     0,     0,
     363,   364,   365,     0,     0,   366,     0,     0,     0,   367,
     368,   369,   370,   371,   372,   373,     0,   374,   375,   376,
     377,   378,   379,   380,     0,   381,   382,   383,   384,   385,
     386,   387,   388,   389,   390,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
       0,   404,   405,   406,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,     0,   420,
     421,   422,   423,     0,   424,   425,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,   436,   437,     0,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
     446,   447,     0,     0,   448,   449,   450,   451,     0,   452,
     453,   454,   455,   456,   457,     0,     0,   458,   459,   460,
     461,     0,     0,   462,   463,   464,   465,   466,   467,     0,
     468,     0,   469,   470,   471,     0,     0,   472,     0,     0,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,   488,     0,     0,     0,   740,
     741,   742,     0,   743,   744,   745,   746,   747,   748,   190,
       0,     0,     0,     0,   737,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,  1240,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,  1241,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,     0,     0,     0,   740,   741,
     742,     0,   743,   744,   745,   746,   747,   748,   190,     0,
       0,     0,     0,   737,     0,     0,     0,     0,     0,   191,
     192,   193,   194,   195,   196,   197,   198,     0,   200,   201,
     202,     0,     0,     0,     0,     0,     0,     0,   203,   204,
       0,   205,     0,   206,   207,   208,   209,   210,     0,   211,
     212,     0,   213,   214,   215,   216,   217,     0,     0,   218,
     219,   220,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,   239,     0,   240,   241,   242,
       0,   243,   244,     0,     0,     0,     0,     0,     0,     0,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
     254,     0,   255,   256,   257,   258,   259,     0,   260,   261,
     262,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,     0,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
       0,   285,     0,   286,     0,     0,     0,   287,   288,   289,
       0,   290,   291,     0,   292,     0,   293,   294,   295,   296,
     297,     0,   298,   299,   300,     0,   301,   302,   303,   304,
     305,   306,     0,   307,     0,   308,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,     0,     0,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,   327,   328,     0,     0,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,     0,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,     0,     0,   363,   364,
     365,     0,     0,   366,     0,     0,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,     0,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,     0,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,     0,   424,   425,     0,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   438,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,   451,     0,   452,   453,   454,
     455,   456,   457,     0,     0,   458,   459,   460,   461,     0,
       0,   462,   463,   464,   465,   466,   467,     0,   468,     0,
     469,   470,   471,     0,     0,   472,     0,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,     0,     0,     0,   740,   741,   742,
       0,   743,   744,   745,   746,   747,   748,   190,     0,     0,
       0,     0,   737,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,  3567,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,     0,     0,  1580,   740,   741,   742,     0,
     743,   744,   745,   746,   747,   748,   191,   192,   193,   194,
     195,   196,   197,   198,  1581,   200,   201,   202,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,   203,   204,  1589,   205,   697,
     206,   207,   208,   209,   210,   698,   211,   212,  1590,   213,
     214,   215,   216,   217,  1591,  1592,   218,   219,   220,   221,
     222,  1593,   223,   224,   225,   226,   227,  1594,  1595,   228,
     229,   230,   231,   699,   232,   233,  1596,   234,   235,   236,
     237,   238,   239,  1597,   240,   241,   242,   700,   243,   244,
    1598,  1599,  1600,   701,  1601,  1602,  1603,   245,   246,   247,
     248,   249,   250,   251,   252,   253,  1604,   254,  1605,   255,
     256,   257,   258,   259,  1606,   260,   261,   262,  1607,  1608,
     263,   264,   265,   266,   267,  1609,   268,   269,   270,  1610,
     271,   272,  1611,   273,   274,   275,   276,   277,   278,   279,
     280,  1612,   281,  1613,   282,   283,   284,  1614,   285,  1615,
     286,   702,  1616,   703,   287,   288,   289,  1617,   290,   291,
    1618,   292,  1619,   293,   294,   295,   296,   297,   704,   298,
     299,   300,  1620,   301,   302,   303,   304,   305,   306,  1621,
     307,   705,   308,   309,   310,   311,   312,   313,   314,  1622,
     315,  1623,   316,   706,   707,   317,   708,   318,   319,   320,
     321,   322,   323,  1624,   324,   709,   325,   710,  1625,   326,
     327,   328,  1626,  1627,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   711,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,  1628,
     353,   354,   712,   355,  1629,   356,   357,   358,   359,   360,
     361,  1630,   362,  1631,  1632,   363,   364,   365,  1633,  1634,
     366,   713,   714,   715,   367,   368,   369,   370,   371,   372,
     373,  1635,   374,   375,   376,   377,   378,   379,   380,  1636,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,  1637,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,  1638,   402,   403,   716,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,  1639,   415,   416,
     417,   418,   419,  1640,   420,   421,   422,   423,   717,   424,
     425,  1641,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1642,   438,   439,  1643,   440,   441,
     442,   443,   444,   445,  1644,   446,   447,  1645,  1646,   448,
     449,   450,   451,  1647,   452,   453,   454,   455,   456,   457,
    1648,  1649,   458,   459,   460,   461,  1650,  1651,   462,   463,
     464,   465,   466,   467,  1652,   468,   718,   469,   470,   471,
    1653,  1654,   472,  1655,  1656,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
    1657,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,   668,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,  1257,     0,     0,     0,     0,     0,     0,
       0,     0,  3456,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,   697,   206,   207,
     208,     0,  1258,   698,  1259,  1260,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,  1261,  1262,   222,     0,
     223,   224,   225,   226,     0,     0,     0,   228,   229,   230,
     231,   699,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,   700,   243,   244,     0,     0,
       0,   701,     0,     0,     0,   245,   246,   247,   248,   249,
     250,  1263,  1264,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     966,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,     0,   278,   279,     0,     0,
     281,     0,   282,  1265,   284,     0,   285,     0,   286,   702,
       0,   703,   287,   288,   289,     0,   290,     0,     0,   292,
       0,   293,   294,   295,   296,   297,   704,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,   705,
       0,   309,   310,   311,   312,  1266,  1267,     0,  1268,     0,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,     0,     0,   709,   325,   710,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,  1269,   711,  1270,   344,   345,
     346,   347,   348,   349,   350,     0,   352,     0,   353,   354,
     712,   355,     0,     0,   357,  1271,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,     0,   713,
     714,   715,     0,   368,   369,   370,   371,   372,   373,     0,
     374,     0,   376,     0,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,  1272,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   716,   404,   405,     0,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,  1273,   422,   423,   717,   424,  1274,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
       0,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,  1275,  1276,     0,     0,   448,     0,   450,
       0,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
       0,  1277,     0,   468,   718,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,     0,  1892,
       0,     0,     0,     0,     0,     0,   486,   487,   488,     0,
     191,   192,   193,   194,   195,   196,   197,   198,  1714,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,   697,   206,   207,   208,     0,  1258,   698,
    1259,  1260,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,  1261,  1262,   222,     0,   223,   224,   225,   226,
       0,     0,     0,   228,   229,   230,   231,   699,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,   700,   243,   244,     0,     0,     0,   701,     0,     0,
       0,   245,   246,   247,   248,   249,   250,  1263,  1264,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   966,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,     0,   278,   279,     0,     0,   281,     0,   282,  1265,
     284,     0,   285,     0,   286,   702,     0,   703,   287,   288,
     289,     0,   290,     0,     0,   292,     0,   293,   294,   295,
     296,   297,   704,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,   705,     0,   309,   310,   311,
     312,  1266,  1267,     0,  1268,     0,   316,   706,   707,   317,
     708,   318,   319,   320,   321,   322,   323,     0,     0,   709,
     325,   710,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,  1269,   711,  1270,   344,   345,   346,   347,   348,   349,
     350,     0,   352,     0,   353,   354,   712,   355,     0,     0,
     357,  1271,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,     0,   713,   714,   715,     0,   368,
     369,   370,   371,   372,   373,     0,   374,     0,   376,     0,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,  1272,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   716,
     404,   405,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,  1273,
     422,   423,   717,   424,  1274,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,  1275,
    1276,     0,     0,   448,     0,   450,     0,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,     0,  1277,     0,   468,
     718,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,     0,   190,  1169,   539,     0,     0,
       0,   584,   486,   487,   488,     0,   191,   192,   193,   194,
     195,   196,   197,   198,  1714,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,  1570,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,  1383,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,  1384,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,  1385,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,  1169,   539,     0,     0,     0,   584,   596,  1170,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,  1575,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,  1383,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,  1384,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,  1385,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,  1169,   539,
       0,     0,     0,   584,   596,  1170,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,  1383,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,  1384,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,  1385,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,   584,
     596,  1170,     0,     0,   191,   585,   193,   194,   195,   196,
     197,   198,   586,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   587,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   588,   283,   284,     0,   285,     0,   589,     0,
     590,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
     591,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   592,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   593,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   594,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   595,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,  1580,
       0,     0,     0,     0,     0,     0,   596,   597,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,  1581,   200,
     201,   202,  1582,  1583,  1584,  1585,  1586,  1587,  1588,   203,
     204,  1589,   205,   697,   206,   207,   208,   209,   210,   698,
     211,   212,  1590,   213,   214,   215,   216,   217,  1591,  1592,
     218,   219,   220,   221,   222,  1593,   223,   224,   225,   226,
     227,  1594,  1595,   228,   229,   230,   231,   699,   232,   233,
    1596,   234,   235,   236,   237,   238,   239,  1597,   240,   241,
     242,   700,   243,   244,  1598,  1599,  1600,   701,  1601,  1602,
    1603,   245,   246,   247,   248,   249,   250,   251,   252,   253,
    1604,   254,  1605,   255,   256,   257,   258,   259,  1606,   260,
     261,   262,  1607,  1608,   263,   264,   265,   266,   267,  1609,
     268,   269,   270,  1610,   271,   272,  1611,   273,   274,   275,
     276,   277,   278,   279,   280,  1612,   281,  1613,   282,   283,
     284,  1614,   285,  1615,   286,   702,  1616,   703,   287,   288,
     289,  1617,   290,   291,  1618,   292,  1619,   293,   294,   295,
     296,   297,   704,   298,   299,   300,  1620,   301,   302,   303,
     304,   305,   306,  1621,   307,   705,   308,   309,   310,   311,
     312,   313,   314,  1622,   315,  1623,   316,   706,   707,   317,
     708,   318,   319,   320,   321,   322,   323,  1624,   324,   709,
     325,   710,  1625,   326,   327,   328,  1626,  1627,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   711,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,  1628,   353,   354,   712,   355,  1629,   356,
     357,   358,   359,   360,   361,  1630,   362,  1631,  1632,   363,
     364,   365,  1633,  1634,   366,   713,   714,   715,   367,   368,
     369,   370,   371,   372,   373,  1635,   374,   375,   376,   377,
     378,   379,   380,  1636,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,  1637,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,  1638,   402,   403,   716,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,  1639,   415,   416,   417,   418,   419,  1640,   420,   421,
     422,   423,   717,   424,   425,  1641,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,  1642,   438,
     439,  1643,   440,   441,   442,   443,   444,   445,  1644,   446,
     447,  1645,  1646,   448,   449,   450,   451,  1647,   452,   453,
     454,   455,   456,   457,  1648,  1649,   458,   459,   460,   461,
    1650,  1651,   462,   463,   464,   465,   466,   467,  1652,   468,
     718,   469,   470,   471,  1653,  1654,   472,  1655,  1656,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1580,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
    2381,   196,   197,   198,  1581,   200,   201,   202,  1582,  1583,
    1584,  1585,  1586,  1587,  1588,   203,   204,  1589,   205,   697,
     206,   207,   208,   209,   210,   698,   211,   212,  1590,   213,
     214,   215,   216,   217,  1591,  1592,   218,   219,   220,   221,
     222,  1593,   223,   224,   225,   226,   227,  1594,  1595,   228,
     229,   230,   231,   699,   232,   233,  1596,   234,   235,   236,
     237,   238,   239,  1597,   240,   241,   242,   700,   243,   244,
    1598,  1599,  1600,   701,  1601,  1602,  1603,   245,   246,   247,
     248,   249,   250,   251,   252,   253,  1604,   254,  1605,   255,
     256,   257,   258,   259,  1606,   260,   261,   262,  1607,  1608,
     263,   264,   265,  2382,   267,  1609,   268,   269,   270,  1610,
     271,   272,  1611,   273,   274,   275,   276,   277,   278,   279,
     280,  1612,   281,  1613,   282,   283,   284,  1614,   285,  1615,
     286,   702,  1616,   703,   287,   288,   289,  1617,   290,   291,
    1618,   292,  1619,   293,   294,   295,   296,   297,   704,   298,
     299,   300,  1620,   301,   302,   303,   304,   305,   306,  1621,
     307,   705,   308,   309,   310,   311,   312,   313,   314,  1622,
     315,  1623,   316,   706,   707,   317,   708,   318,   319,   320,
     321,   322,   323,  1624,   324,   709,   325,   710,  1625,   326,
     327,   328,  1626,  1627,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   711,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,  1628,
     353,   354,   712,   355,  1629,   356,   357,   358,   359,   360,
     361,  1630,   362,  1631,  1632,   363,   364,   365,  1633,  1634,
     366,   713,   714,   715,   367,   368,   369,   370,   371,   372,
     373,  1635,   374,   375,   376,   377,   378,   379,   380,  1636,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,  1637,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,  1638,   402,   403,   716,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,  1639,   415,   416,
     417,   418,   419,  1640,  2383,   421,   422,   423,   717,   424,
     425,  1641,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,  1642,   438,   439,  1643,   440,   441,
     442,   443,   444,   445,  1644,   446,   447,  1645,  1646,   448,
     449,   450,   451,  1647,   452,   453,   454,   455,   456,   457,
    1648,  1649,   458,   459,   460,   461,  1650,  1651,   462,   463,
     464,   465,   466,   467,  1652,   468,   718,   469,   470,   471,
    1653,  1654,   472,  1655,  1656,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   696,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,   697,   206,   207,   208,   209,
     210,   698,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,   699,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,   700,   243,   244,     0,     0,     0,   701,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,   702,     0,   703,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,   704,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,   705,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,   706,
     707,   317,   708,   318,   319,   320,   321,   322,   323,     0,
     324,   709,   325,   710,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,   711,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,   712,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,   713,   714,   715,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,   716,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,   717,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,   718,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   696,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,   697,   206,   207,   208,   209,   210,   698,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,   699,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,   700,
     243,   244,     0,     0,     0,   701,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,   702,     0,   703,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   843,
     704,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,   705,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,   706,   707,   317,   708,   318,
     319,   320,   321,   322,   323,     0,   324,   709,   325,   710,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
     711,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,   712,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,   713,   714,   715,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   716,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
     717,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,   718,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   696,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,   697,   206,   207,
     208,   209,   210,   698,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,   699,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,   700,   243,   244,     0,     0,
       0,   701,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,   702,
       0,   703,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   851,   704,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,   705,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,   706,   707,   317,   708,   318,   319,   320,   321,   322,
     323,     0,   324,   709,   325,   710,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,   711,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
     712,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,   713,
     714,   715,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,   716,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,   717,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,   718,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,  1734,   223,   224,   225,   226,
     227,     0,  1778,   228,   229,   230,   231,     0,   232,   233,
    1735,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,  1779,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,  1737,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,  1738,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,  1739,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,  1734,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,  1735,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,  1779,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,  1737,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,  2505,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,  1738,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,  1739,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   635,   197,   198,
     603,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,   604,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,   636,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,   605,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,   606,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   603,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,   604,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,  2274,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,   605,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,   606,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,  1734,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,  1735,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,  1779,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,  1737,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,  1738,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,  1739,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
    3807,   539,  3808,  3809,     0,   584,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   603,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,   604,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,   605,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,   606,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,   539,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,  1383,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,  1384,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,  1385,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,  1410,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,  1411,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,  1412,   286,     0,     0,     0,  1413,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
    1414,  1415,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,  1416,   411,   412,   413,   414,     0,
    1417,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,  1418,
     440,  1419,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,   604,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,   605,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,   606,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     3,     4,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
     884,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,   539,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,  1556,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,  1854,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,  1855,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       3,     4,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,  2318,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,  2319,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,  2330,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
    2331,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
     530,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   531,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,   629,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   630,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   631,   447,     0,
       0,   632,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,   657,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     658,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   659,   447,     0,     0,   660,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,   663,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,   835,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,   539,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,  1038,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,  1049,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   645,   219,   220,   221,  1050,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   648,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   649,   405,   406,   407,   408,   409,
     650,   411,   412,   413,   414,     0,   415,   416,   417,   418,
    1042,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   652,   447,     0,     0,   653,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   654,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,   539,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,  1373,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,  2195,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,  2196,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,  2197,   440,   441,
    2198,   443,  2199,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,  2540,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,  2553,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,  2592,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
    3261,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,  3263,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,  3265,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,  3412,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   619,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   627,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   645,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   646,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   297,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   647,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   648,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   649,   405,   406,   407,   408,   409,   650,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   651,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   652,   447,     0,     0,   653,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   654,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   297,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   677,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   762,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   824,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   848,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   853,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   861,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   863,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   865,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   867,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,   870,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,   872,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   873,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   876,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,   409,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     645,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     648,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     649,   405,   406,   407,   408,   409,   650,   411,   412,   413,
     414,     0,   415,   416,   417,   418,  1042,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   652,
     447,     0,     0,   653,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   654,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,  1070,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   404,   405,   406,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,     0,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   446,   447,     0,     0,   448,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,  1351,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,   190,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,     0,   206,   207,   208,   209,   210,     0,   211,   212,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
     220,   221,   222,     0,   223,   224,   225,   226,   227,     0,
       0,   228,   229,   230,   231,     0,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,     0,
     243,   244,     0,     0,     0,     0,     0,     0,     0,   245,
     246,   247,   248,   249,   250,   251,   252,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   265,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,   277,
     278,   279,   280,     0,   281,     0,   282,   283,   284,     0,
     285,     0,   286,     0,     0,     0,   287,   288,   289,     0,
     290,   291,     0,   292,     0,   293,   294,   295,   296,  1353,
       0,   298,   299,   300,     0,   301,   302,   303,   304,   305,
     306,     0,   307,     0,   308,   309,   310,   311,   312,   313,
     314,     0,   315,     0,   316,     0,     0,   317,     0,   318,
     319,   320,   321,   322,   323,     0,   324,     0,   325,     0,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,   342,
       0,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,     0,   353,   354,     0,   355,     0,   356,   357,   358,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,   366,     0,     0,     0,   367,   368,   369,   370,
     371,   372,   373,     0,   374,   375,   376,   377,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,   388,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,     0,   404,   405,
     406,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,   421,   422,   423,
       0,   424,   425,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,   436,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,   446,   447,     0,
       0,   448,   449,   450,   451,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,   466,   467,     0,   468,     0,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   478,   479,   480,   481,   482,   483,   484,   485,
     486,   487,   488,   190,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   191,   192,   193,   194,   195,   196,
     197,   198,     0,   200,   201,   202,     0,     0,     0,     0,
       0,     0,     0,   203,   204,     0,   205,     0,   206,   207,
     208,   209,   210,     0,   211,   212,     0,   213,   214,   215,
     216,   217,     0,     0,   218,   219,   220,   221,   222,     0,
     223,   224,   225,   226,   227,     0,     0,   228,   229,   230,
     231,     0,   232,   233,     0,   234,   235,   236,   237,   238,
     239,     0,   240,   241,   242,     0,   243,   244,     0,     0,
       0,     0,     0,     0,     0,   245,   246,   247,   248,   249,
     250,   251,   252,   253,     0,   254,     0,   255,   256,   257,
     258,   259,     0,   260,   261,   262,     0,     0,   263,   264,
     265,   266,   267,     0,   268,   269,   270,     0,   271,   272,
       0,   273,   274,   275,   276,   277,   278,   279,   280,     0,
     281,     0,   282,   283,   284,     0,   285,     0,   286,     0,
       0,     0,   287,   288,   289,     0,   290,   291,     0,   292,
       0,   293,   294,   295,   296,   297,     0,   298,   299,   300,
       0,   301,   302,   303,   304,   305,   306,     0,   307,     0,
     308,   309,   310,   311,   312,   313,   314,     0,   315,     0,
     316,     0,     0,   317,     0,   318,   319,   320,   321,   322,
     323,     0,   324,     0,   325,     0,     0,   326,   327,   328,
       0,     0,   329,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,   342,     0,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,     0,   353,   354,
       0,   355,     0,   356,   357,   358,   359,   360,   361,     0,
     362,     0,     0,   363,   364,   365,     0,     0,   366,     0,
       0,     0,   367,   368,   369,   370,   371,   372,   373,     0,
     374,   375,   376,   377,   378,   379,   380,     0,   381,   382,
     383,   384,   385,   386,   387,   388,   389,   390,   391,     0,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
       0,   402,   403,     0,   404,   405,   406,   407,   408,  1446,
     410,   411,   412,   413,   414,     0,   415,   416,   417,   418,
     419,     0,   420,   421,   422,   423,     0,   424,   425,     0,
     426,   427,   428,   429,   430,   431,   432,   433,   434,   435,
     436,   437,     0,   438,   439,     0,   440,   441,   442,   443,
     444,   445,     0,   446,   447,     0,     0,   448,   449,   450,
     451,     0,   452,   453,   454,   455,   456,   457,     0,     0,
     458,   459,   460,   461,     0,     0,   462,   463,   464,   465,
     466,   467,     0,   468,     0,   469,   470,   471,     0,     0,
     472,     0,     0,   473,   474,   475,   476,   477,   478,   479,
     480,   481,   482,   483,   484,   485,   486,   487,   488,   190,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     645,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     648,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,   372,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     649,   405,   406,   407,   408,   409,   650,   411,   412,   413,
     414,     0,   415,   416,   417,   418,  1042,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,  1725,   442,   443,   444,   445,     0,   652,
     447,     0,     0,   653,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   654,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,   190,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,     0,
     206,   207,   208,   209,   210,     0,   211,   212,     0,   213,
     214,   215,   216,   217,     0,     0,   645,   219,   220,   221,
     222,     0,   223,   224,   225,   226,   227,     0,     0,   228,
     229,   230,   231,     0,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,     0,   243,   244,
       0,     0,     0,     0,     0,     0,     0,   245,   246,   247,
     248,   249,   250,   251,   252,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   265,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,   277,   278,   279,
     280,     0,   281,     0,   282,   283,   284,     0,   285,     0,
     286,     0,     0,     0,   287,   288,   289,     0,   290,   291,
       0,   292,     0,   293,   294,   295,   296,   297,     0,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,     0,   308,   309,   310,   311,   312,   313,   314,     0,
     315,     0,   316,     0,     0,   317,     0,   318,   319,   320,
     321,   322,   323,     0,   324,     0,   325,     0,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   648,   342,     0,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,     0,
     353,   354,     0,   355,     0,   356,   357,   358,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
     366,     0,     0,     0,   367,   368,   369,   370,   371,   372,
     373,     0,   374,   375,   376,   377,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,   388,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,     0,   649,   405,   406,   407,
     408,   409,  1759,   411,   412,   413,   414,     0,   415,   416,
     417,   418,  1042,     0,   420,   421,   422,   423,     0,   424,
     425,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,   436,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,   652,   447,     0,     0,   653,
     449,   450,   451,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,   466,   467,     0,   468,     0,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   654,
     478,   479,   480,   481,   482,   483,   484,   485,   486,   487,
     488,   190,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   191,   192,   193,   194,   195,   196,   197,   198,
       0,   200,   201,   202,     0,     0,     0,     0,     0,     0,
       0,   203,   204,     0,   205,     0,   206,   207,   208,   209,
     210,     0,   211,   212,     0,   213,   214,   215,   216,   217,
       0,     0,   218,   219,   220,   221,   222,     0,   223,   224,
     225,   226,   227,     0,     0,   228,   229,   230,   231,     0,
     232,   233,     0,   234,   235,   236,   237,   238,   239,     0,
     240,   241,   242,     0,   243,   244,     0,     0,     0,     0,
       0,     0,     0,   245,   246,   247,   248,   249,   250,   251,
     252,   253,     0,   254,     0,   255,   256,   257,   258,   259,
       0,   260,   261,   262,     0,     0,   263,   264,   265,   266,
     267,     0,   268,   269,   270,     0,   271,   272,     0,   273,
     274,   275,   276,   277,   278,   279,   280,     0,   281,     0,
     282,   283,   284,     0,   285,     0,   286,     0,     0,     0,
     287,   288,   289,     0,   290,   291,     0,   292,     0,   293,
     294,   295,   296,  1987,     0,   298,   299,   300,     0,   301,
     302,   303,   304,   305,   306,     0,   307,     0,   308,   309,
     310,   311,   312,   313,   314,     0,   315,     0,   316,     0,
       0,   317,     0,   318,   319,   320,   321,   322,   323,     0,
     324,     0,   325,     0,     0,   326,   327,   328,     0,     0,
     329,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,   342,     0,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,     0,   353,   354,     0,   355,
       0,   356,   357,   358,   359,   360,   361,     0,   362,     0,
       0,   363,   364,   365,     0,     0,   366,     0,     0,     0,
     367,   368,   369,   370,   371,   372,   373,     0,   374,   375,
     376,   377,   378,   379,   380,     0,   381,   382,   383,   384,
     385,   386,   387,   388,   389,   390,   391,     0,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,     0,   402,
     403,     0,   404,   405,   406,   407,   408,   409,   410,   411,
     412,   413,   414,     0,   415,   416,   417,   418,   419,     0,
     420,   421,   422,   423,     0,   424,   425,     0,   426,   427,
     428,   429,   430,   431,   432,   433,   434,   435,   436,   437,
       0,   438,   439,     0,   440,   441,   442,   443,   444,   445,
       0,   446,   447,     0,     0,   448,   449,   450,   451,     0,
     452,   453,   454,   455,   456,   457,     0,     0,   458,   459,
     460,   461,     0,     0,   462,   463,   464,   465,   466,   467,
       0,   468,     0,   469,   470,   471,     0,     0,   472,     0,
       0,   473,   474,   475,   476,   477,   478,   479,   480,   481,
     482,   483,   484,   485,   486,   487,   488,  1257,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   191,   192,
     193,   194,   195,   196,   197,   198,     0,   200,   201,   202,
       0,     0,     0,     0,     0,     0,     0,   203,   204,     0,
     205,   697,   206,   207,   208,     0,  1258,   698,  1259,  1260,
       0,   213,   214,   215,   216,   217,     0,     0,   218,   219,
    1261,  1262,   222,     0,   223,   224,   225,   226,     0,     0,
       0,   228,   229,   230,   231,   699,   232,   233,     0,   234,
     235,   236,   237,   238,   239,     0,   240,   241,   242,   700,
     243,   244,     0,     0,     0,   701,     0,     0,     0,   245,
     246,   247,   248,   249,   250,  1263,  1264,   253,     0,   254,
       0,   255,   256,   257,   258,   259,     0,   260,   261,   262,
       0,     0,   263,   264,   966,   266,   267,     0,   268,   269,
     270,     0,   271,   272,     0,   273,   274,   275,   276,     0,
     278,   279,     0,     0,   281,     0,   282,  1265,   284,     0,
     285,     0,   286,   702,     0,   703,   287,   288,   289,     0,
     290,     0,     0,   292,     0,   293,   294,   295,   296,   297,
     704,   298,   299,   300,  1763,   301,   302,   303,   304,   305,
     306,     0,   307,   705,  1764,   309,   310,   311,   312,  1266,
    1267,     0,  1268,     0,   316,   706,   707,   317,   708,   318,
     319,   320,   321,   322,   323,     0,     0,   709,   325,   710,
       0,   326,   327,   328,     0,     0,   329,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,  1269,
     711,  1270,   344,   345,   346,   347,   348,   349,   350,     0,
     352,     0,   353,   354,   712,   355,     0,     0,   357,  1271,
     359,   360,   361,     0,   362,     0,     0,   363,   364,   365,
       0,     0,  1765,   713,   714,   715,     0,   368,   369,   370,
     371,   372,   373,     0,   374,     0,   376,     0,   378,   379,
     380,     0,   381,   382,   383,   384,   385,   386,   387,  1272,
     389,   390,   391,     0,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,     0,   402,   403,   716,   404,   405,
       0,   407,   408,   409,   410,   411,   412,   413,   414,     0,
     415,   416,   417,   418,   419,     0,   420,  1766,   422,   423,
     717,   424,  1274,     0,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   435,     0,   437,     0,   438,   439,     0,
     440,   441,   442,   443,   444,   445,     0,  1275,  1276,     0,
       0,   448,     0,   450,     0,     0,   452,   453,   454,   455,
     456,   457,     0,     0,   458,   459,   460,   461,     0,     0,
     462,   463,   464,   465,     0,  1277,  1767,   468,   718,   469,
     470,   471,     0,     0,   472,     0,     0,   473,   474,   475,
     476,   477,   190,     0,     0,     0,     0,     0,     0,     0,
     486,   487,   488,   191,   192,   193,   194,   195,   196,   197,
     198,     0,   200,   201,   202,     0,     0,     0,     0,     0,
       0,     0,   203,   204,     0,   205,     0,   206,   207,   208,
     209,   210,     0,   211,   212,     0,   213,   214,   215,   216,
     217,     0,     0,   218,   219,   220,   221,   222,     0,   223,
     224,   225,   226,   227,     0,     0,   228,   229,   230,   231,
       0,   232,   233,     0,   234,   235,   236,   237,   238,   239,
       0,   240,   241,   242,     0,   243,   244,     0,     0,     0,
       0,     0,     0,     0,   245,   246,   247,   248,   249,   250,
     251,   252,   253,     0,   254,     0,   255,   256,   257,   258,
     259,     0,   260,   261,   262,     0,     0,   263,   264,   265,
     266,   267,     0,   268,   269,   270,     0,   271,   272,     0,
     273,   274,   275,   276,   277,   278,   279,   280,     0,   281,
       0,   282,   283,   284,     0,   285,     0,   286,     0,     0,
       0,   287,   288,   289,     0,   290,   291,     0,   292,     0,
     293,   294,   295,   296,  2321,     0,   298,   299,   300,     0,
     301,   302,   303,   304,   305,   306,     0,   307,     0,   308,
     309,   310,   311,   312,   313,   314,     0,   315,     0,   316,
       0,     0,   317,     0,   318,   319,   320,   321,   322,   323,
       0,   324,     0,   325,     0,     0,   326,   327,   328,     0,
       0,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,     0,   343,   344,   345,   346,
     347,   348,   349,   350,   351,   352,     0,   353,   354,     0,
     355,     0,   356,   357,   358,   359,   360,   361,     0,   362,
       0,     0,   363,   364,   365,     0,     0,   366,     0,     0,
       0,   367,   368,   369,   370,   371,   372,   373,     0,   374,
     375,   376,   377,   378,   379,   380,     0,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,     0,   392,
     393,   394,   395,   396,   397,   398,   399,   400,   401,     0,
     402,   403,     0,   404,   405,   406,   407,   408,   409,   410,
     411,   412,   413,   414,     0,   415,   416,   417,   418,   419,
       0,   420,   421,   422,   423,     0,   424,   425,     0,   426,
     427,   428,   429,   430,   431,   432,   433,   434,   435,   436,
     437,     0,   438,   439,     0,   440,   441,   442,   443,   444,
     445,     0,   446,   447,     0,     0,   448,   449,   450,   451,
       0,   452,   453,   454,   455,   456,   457,     0,     0,   458,
     459,   460,   461,     0,     0,   462,   463,   464,   465,   466,
     467,     0,   468,     0,   469,   470,   471,     0,     0,   472,
       0,     0,   473,   474,   475,   476,   477,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   190,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   191,
     192,   193,   194,   195,   196,   197,   198,     0,   200,   201,
     202,     0,     0,     0,     0,     0,     0,     0,   203,   204,
       0,   205,     0,   206,   207,   208,   209,   210,     0,   211,
     212,     0,   213,   214,   215,   216,   217,     0,     0,   218,
     219,   220,   221,   222,     0,   223,   224,   225,   226,   227,
       0,     0,   228,   229,   230,   231,     0,   232,   233,     0,
     234,   235,   236,   237,   238,   239,     0,   240,   241,   242,
       0,   243,   244,     0,     0,     0,     0,     0,     0,     0,
     245,   246,   247,   248,   249,   250,   251,   252,   253,     0,
     254,     0,   255,   256,   257,   258,   259,     0,   260,   261,
     262,     0,     0,   263,   264,   265,   266,   267,     0,   268,
     269,   270,     0,   271,   272,     0,   273,   274,   275,   276,
     277,   278,   279,   280,     0,   281,     0,   282,   283,   284,
       0,   285,     0,   286,     0,     0,     0,   287,   288,   289,
       0,   290,   291,     0,   292,     0,   293,   294,   295,   296,
    2323,     0,   298,   299,   300,     0,   301,   302,   303,   304,
     305,   306,     0,   307,     0,   308,   309,   310,   311,   312,
     313,   314,     0,   315,     0,   316,     0,     0,   317,     0,
     318,   319,   320,   321,   322,   323,     0,   324,     0,   325,
       0,     0,   326,   327,   328,     0,     0,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,     0,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,     0,   353,   354,     0,   355,     0,   356,   357,
     358,   359,   360,   361,     0,   362,     0,     0,   363,   364,
     365,     0,     0,   366,     0,     0,     0,   367,   368,   369,
     370,   371,   372,   373,     0,   374,   375,   376,   377,   378,
     379,   380,     0,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,     0,   392,   393,   394,   395,   396,
     397,   398,   399,   400,   401,     0,   402,   403,     0,   404,
     405,   406,   407,   408,   409,   410,   411,   412,   413,   414,
       0,   415,   416,   417,   418,   419,     0,   420,   421,   422,
     423,     0,   424,   425,     0,   426,   427,   428,   429,   430,
     431,   432,   433,   434,   435,   436,   437,     0,   438,   439,
       0,   440,   441,   442,   443,   444,   445,     0,   446,   447,
       0,     0,   448,   449,   450,   451,     0,   452,   453,   454,
     455,   456,   457,     0,     0,   458,   459,   460,   461,     0,
       0,   462,   463,   464,   465,   466,   467,     0,   468,     0,
     469,   470,   471,     0,     0,   472,     0,     0,   473,   474,
     475,   476,   477,   478,   479,   480,   481,   482,   483,   484,
     485,   486,   487,   488,  1257,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   191,   192,   193,   194,   195,
     196,   197,   198,     0,   200,   201,   202,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,   205,   697,   206,
     207,   208,     0,  1258,   698,  1259,  1260,     0,   213,   214,
     215,   216,   217,     0,     0,   218,   219,  1261,  1262,   222,
       0,   223,   224,   225,   226,     0,     0,     0,   228,   229,
     230,   231,   699,   232,   233,     0,   234,   235,   236,   237,
     238,   239,     0,   240,   241,   242,   700,   243,   244,     0,
       0,     0,   701,     0,     0,     0,   245,   246,   247,   248,
     249,   250,  1263,  1264,   253,     0,   254,     0,   255,   256,
     257,   258,   259,     0,   260,   261,   262,     0,     0,   263,
     264,   966,   266,   267,     0,   268,   269,   270,     0,   271,
     272,     0,   273,   274,   275,   276,     0,   278,   279,     0,
       0,   281,     0,   282,  1265,   284,     0,   285,     0,   286,
     702,     0,   703,   287,   288,   289,     0,   290,     0,     0,
     292,     0,   293,   294,   295,   296,   297,   704,   298,   299,
     300,     0,   301,   302,   303,   304,   305,   306,     0,   307,
     705,     0,   309,   310,   311,   312,  1266,  1267,     0,  1268,
       0,   316,   706,   707,   317,   708,   318,   319,   320,   321,
     322,   323,     0,     0,   709,   325,   710,     0,   326,   327,
     328,     0,     0,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,  1269,   711,  1270,   344,
     345,   346,   347,   348,   349,   350,     0,   352,     0,   353,
     354,   712,   355,  1755,     0,   357,  1271,   359,   360,   361,
       0,   362,     0,     0,   363,   364,   365,     0,     0,     0,
     713,   714,   715,     0,   368,   369,   370,   371,   372,   373,
       0,   374,     0,   376,     0,   378,   379,   380,     0,   381,
     382,   383,   384,   385,   386,   387,  1272,   389,   390,   391,
       0,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   716,   404,   405,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,     0,   420,  1766,   422,   423,   717,   424,  1274,
       0,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,     0,   438,   439,  2973,   440,   441,   442,
     443,   444,   445,     0,  1275,  1276,     0,     0,   448,     0,
     450,     0,     0,   452,   453,   454,   455,   456,   457,     0,
       0,   458,   459,   460,   461,     0,     0,   462,   463,   464,
     465,     0,  1277,     0,   468,   718,   469,   470,   471,     0,
       0,   472,     0,     0,   473,   474,   475,   476,   477,  1257,
       0,     0,     0,     0,     0,     0,     0,   486,   487,   488,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,   697,   206,   207,   208,     0,  1258,   698,
    1259,  1260,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,  1261,  1262,   222,     0,   223,   224,   225,   226,
       0,     0,     0,   228,   229,   230,   231,   699,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,   700,   243,   244,     0,     0,     0,   701,     0,     0,
       0,   245,   246,   247,   248,   249,   250,  1263,  1264,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   966,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,     0,   278,   279,     0,     0,   281,     0,   282,  1265,
     284,     0,   285,     0,   286,   702,     0,   703,   287,   288,
     289,     0,   290,     0,     0,   292,     0,   293,   294,   295,
     296,   297,   704,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,   705,     0,   309,   310,   311,
     312,  1266,  1267,     0,  1268,     0,   316,   706,   707,   317,
     708,   318,   319,   320,   321,   322,   323,     0,     0,   709,
     325,   710,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,  1269,   711,  1270,   344,   345,   346,   347,   348,   349,
     350,  1809,   352,     0,   353,   354,   712,   355,     0,     0,
     357,  1271,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,     0,   713,   714,   715,     0,   368,
     369,   370,   371,   372,   373,     0,   374,     0,   376,     0,
     378,   379,   380,     0,   381,   382,   383,   384,   385,   386,
     387,  1272,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,   716,
     404,   405,     0,   407,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,  1273,
     422,   423,   717,   424,  1274,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,     0,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,  1275,
    1276,     0,     0,   448,     0,   450,     0,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,     0,  1277,     0,   468,
     718,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,  1257,     0,     0,     0,     0,     0,
       0,     0,   486,   487,   488,   191,   192,   193,   194,   195,
     196,   197,   198,     0,   200,   201,   202,     0,     0,     0,
       0,     0,     0,     0,   203,   204,     0,   205,   697,   206,
     207,   208,     0,  1258,   698,  1259,  1260,     0,   213,   214,
     215,   216,   217,     0,     0,   218,   219,  1261,  1262,   222,
       0,   223,   224,   225,   226,     0,     0,     0,   228,   229,
     230,   231,   699,   232,   233,     0,   234,   235,   236,   237,
     238,   239,     0,   240,   241,   242,   700,   243,   244,     0,
       0,     0,   701,     0,     0,     0,   245,   246,   247,   248,
     249,   250,  1263,  1264,   253,     0,   254,     0,   255,   256,
     257,   258,   259,     0,   260,   261,   262,     0,     0,   263,
     264,   966,   266,   267,     0,   268,   269,   270,     0,   271,
     272,     0,   273,   274,   275,   276,     0,   278,   279,     0,
       0,   281,     0,   282,  1265,   284,     0,   285,     0,   286,
     702,     0,   703,   287,   288,   289,     0,   290,     0,     0,
     292,     0,   293,   294,   295,   296,   297,   704,   298,   299,
     300,     0,   301,   302,   303,   304,   305,   306,     0,   307,
     705,     0,   309,   310,   311,   312,  1266,  1267,     0,  1268,
       0,   316,   706,   707,   317,   708,   318,   319,   320,   321,
     322,   323,     0,     0,   709,   325,   710,     0,   326,   327,
     328,     0,     0,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,  1269,   711,  1270,   344,
     345,   346,   347,   348,   349,   350,  2815,   352,     0,   353,
     354,   712,   355,     0,     0,   357,  1271,   359,   360,   361,
       0,   362,     0,     0,   363,   364,   365,     0,     0,     0,
     713,   714,   715,     0,   368,   369,   370,   371,   372,   373,
       0,   374,     0,   376,     0,   378,   379,   380,     0,   381,
     382,   383,   384,   385,   386,   387,  1272,   389,   390,   391,
       0,   392,   393,   394,   395,   396,   397,   398,   399,   400,
     401,     0,   402,   403,   716,   404,   405,     0,   407,   408,
     409,   410,   411,   412,   413,   414,     0,   415,   416,   417,
     418,   419,     0,   420,  1273,   422,   423,   717,   424,  1274,
       0,   426,   427,   428,   429,   430,   431,   432,   433,   434,
     435,     0,   437,     0,   438,   439,     0,   440,   441,   442,
     443,   444,   445,     0,  1275,  1276,     0,     0,   448,     0,
     450,     0,     0,   452,   453,   454,   455,   456,   457,     0,
       0,   458,   459,   460,   461,     0,     0,   462,   463,   464,
     465,     0,  1277,     0,   468,   718,   469,   470,   471,     0,
       0,   472,     0,     0,   473,   474,   475,   476,   477,   190,
       0,     0,     0,     0,     0,     0,     0,   486,   487,   488,
     191,   192,   193,   194,   195,   196,   197,   198,     0,   200,
     201,   202,     0,     0,     0,     0,     0,     0,     0,   203,
     204,     0,   205,     0,   206,   207,   208,   209,   210,     0,
     211,   212,     0,   213,   214,   215,   216,   217,     0,     0,
     218,   219,   220,   221,   222,     0,   223,   224,   225,   226,
     227,     0,     0,   228,   229,   230,   231,     0,   232,   233,
       0,   234,   235,   236,   237,   238,   239,     0,   240,   241,
     242,     0,   243,   244,     0,     0,     0,     0,     0,     0,
       0,   245,   246,   247,   248,   249,   250,   251,   252,   253,
       0,   254,     0,   255,   256,   257,   258,   259,     0,   260,
     261,   262,     0,     0,   263,   264,   265,   266,   267,     0,
     268,   269,   270,     0,   271,   272,     0,   273,   274,   275,
     276,   277,   278,   279,   280,     0,   281,     0,   282,   283,
     284,     0,   285,     0,   286,     0,     0,     0,   287,   288,
     289,     0,   290,   291,     0,   292,     0,   293,   294,   295,
     296,   297,     0,   298,   299,   300,     0,   301,   302,   303,
     304,   305,   306,     0,   307,     0,   308,   309,   310,   311,
     312,   313,   314,     0,   315,     0,   316,     0,     0,   317,
       0,   318,   319,   320,   321,   322,   323,     0,   324,     0,
     325,     0,     0,   326,   327,   328,     0,     0,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,     0,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,     0,   353,   354,     0,   355,     0,   356,
     357,   358,   359,   360,   361,     0,   362,     0,     0,   363,
     364,   365,     0,     0,   366,     0,     0,     0,   367,   368,
     369,   370,   371,     0,   373,     0,   374,   375,   376,   377,
     378,   379,   380,     0,   381,   382,   383,   384,   385,     0,
     387,   388,   389,   390,   391,     0,   392,   393,   394,   395,
     396,   397,   398,   399,   400,   401,     0,   402,   403,     0,
     404,   405,   406,     0,   408,   409,   410,   411,   412,   413,
     414,     0,   415,   416,   417,   418,   419,     0,   420,   421,
     422,   423,     0,   424,   425,     0,   426,   427,   428,   429,
     430,   431,   432,   433,   434,   435,   436,   437,     0,   438,
     439,     0,   440,   441,   442,   443,   444,   445,     0,   446,
     447,     0,     0,   448,   449,   450,   451,     0,   452,   453,
     454,   455,   456,   457,     0,     0,   458,   459,   460,   461,
       0,     0,   462,   463,   464,   465,   466,   467,     0,   468,
       0,   469,   470,   471,     0,     0,   472,     0,     0,   473,
     474,   475,   476,   477,   478,   479,   480,   481,   482,   483,
     484,   485,   486,   487,   488,  1257,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,   697,
     206,   207,   208,     0,  1258,   698,  1259,  1260,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,  1261,  1262,
     222,     0,   223,   224,   225,   226,     0,     0,     0,   228,
     229,   230,   231,   699,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,   700,   243,   244,
       0,     0,     0,   701,     0,     0,     0,   245,   246,   247,
     248,   249,   250,  1263,  1264,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   966,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,     0,   278,   279,
       0,     0,   281,     0,   282,  1265,   284,     0,   285,     0,
     286,   702,     0,   703,   287,   288,   289,     0,   290,     0,
       0,   292,     0,   293,   294,   295,   296,   297,   704,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,   705,     0,   309,   310,   311,   312,  1266,  1267,     0,
    1268,     0,   316,   706,   707,   317,   708,   318,   319,   320,
     321,   322,   323,     0,     0,   709,   325,   710,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,  1269,   711,  1270,
     344,   345,   346,   347,   348,   349,   350,     0,   352,     0,
     353,   354,   712,   355,     0,     0,   357,  1271,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
       0,   713,   714,   715,     0,   368,   369,   370,   371,   372,
     373,     0,   374,     0,   376,     0,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,  1272,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   716,   404,   405,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,  1273,   422,   423,   717,   424,
    1274,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,  1275,  1276,     0,     0,   448,
       0,   450,     0,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,     0,  1277,     0,   468,   718,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
    1257,     0,     0,     0,     0,     0,     0,     0,   486,   487,
     488,   191,   192,   193,   194,   195,   196,   197,   198,     0,
     200,   201,   202,     0,     0,     0,     0,     0,     0,     0,
     203,   204,     0,   205,   697,   206,   207,   208,     0,  1258,
     698,  1259,  1260,     0,   213,   214,   215,   216,   217,     0,
       0,   218,   219,  1261,  1262,   222,     0,   223,   224,   225,
     226,     0,     0,     0,   228,   229,   230,   231,   699,   232,
     233,     0,   234,   235,   236,   237,   238,   239,     0,   240,
     241,   242,   700,   243,   244,     0,     0,     0,   701,     0,
       0,     0,   245,   246,   247,   248,   249,   250,  1263,  1264,
     253,     0,   254,     0,   255,   256,   257,   258,   259,     0,
     260,   261,   262,     0,     0,   263,   264,   966,   266,   267,
       0,   268,   269,   270,     0,   271,   272,     0,   273,   274,
     275,   276,     0,   278,   279,     0,     0,   281,     0,   282,
    1265,   284,     0,   285,     0,   286,   702,     0,   703,   287,
     288,   289,     0,   290,     0,     0,   292,     0,   293,   294,
     295,   296,   297,   704,   298,   299,   300,     0,   301,   302,
     303,   304,   305,   306,     0,   307,   705,     0,   309,   310,
     311,   312,  1266,  1267,     0,  1268,     0,   316,   706,   707,
     317,   708,   318,   319,   320,   321,   322,   323,     0,     0,
     709,   325,   710,     0,   326,   327,   328,     0,     0,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,  1269,   711,  1270,   344,   345,   346,   347,   348,
     349,   350,     0,   352,     0,   353,   354,   712,   355,     0,
       0,   357,  1271,   359,   360,   361,     0,   362,     0,     0,
     363,   364,   365,     0,     0,     0,   713,   714,   715,     0,
     368,   369,   370,   371,   372,   373,     0,   374,     0,   376,
       0,   378,   379,   380,     0,   381,   382,   383,   384,   385,
     386,   387,  1272,   389,   390,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     716,   404,   405,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,     0,   420,
    1766,   422,   423,   717,   424,  1274,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,     0,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
    1275,  1276,     0,     0,   448,     0,   450,     0,     0,   452,
     453,   454,   455,   456,   457,     0,     0,   458,   459,   460,
     461,     0,     0,   462,   463,   464,   465,     0,  1277,     0,
     468,   718,   469,   470,   471,     0,     0,   472,     0,     0,
     473,   474,   475,   476,   477,  1257,     0,     0,     0,     0,
       0,     0,     0,   486,   487,   488,   191,   192,   193,   194,
     195,   196,   197,   198,     0,   200,   201,   202,     0,     0,
       0,     0,     0,     0,     0,   203,   204,     0,   205,   697,
     206,   207,   208,     0,  1258,   698,  1259,  1260,     0,   213,
     214,   215,   216,   217,     0,     0,   218,   219,  1261,  1262,
     222,     0,   223,   224,   225,   226,     0,     0,     0,   228,
     229,   230,   231,   699,   232,   233,     0,   234,   235,   236,
     237,   238,   239,     0,   240,   241,   242,   700,   243,   244,
       0,     0,     0,   701,     0,     0,     0,   245,   246,   247,
     248,   249,   250,  1263,  1264,   253,     0,   254,     0,   255,
     256,   257,   258,   259,     0,   260,   261,   262,     0,     0,
     263,   264,   966,   266,   267,     0,   268,   269,   270,     0,
     271,   272,     0,   273,   274,   275,   276,     0,   278,   279,
       0,     0,   281,     0,   282,  1265,   284,     0,   285,     0,
     286,   702,     0,   703,   287,   288,   289,     0,   290,     0,
       0,   292,     0,   293,   294,   295,   296,   297,   704,   298,
     299,   300,     0,   301,   302,   303,   304,   305,   306,     0,
     307,   705,     0,   309,   310,   311,   312,  1266,  1267,     0,
    1268,     0,   316,   706,   707,   317,   708,   318,   319,   320,
     321,   322,   323,     0,     0,   709,   325,   710,     0,   326,
     327,   328,     0,     0,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,  1269,   711,  1270,
     344,   345,   346,   347,   348,   349,   350,     0,   352,     0,
     353,   354,   712,   355,     0,     0,   357,  1271,   359,   360,
     361,     0,   362,     0,     0,   363,   364,   365,     0,     0,
       0,   713,   714,   715,     0,   368,   369,   370,   371,   372,
     373,     0,   374,     0,   376,     0,   378,   379,   380,     0,
     381,   382,   383,   384,   385,   386,   387,  1272,   389,   390,
     391,     0,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,     0,   402,   403,   716,   404,   405,     0,   407,
     408,   409,   410,   411,   412,   413,   414,     0,   415,   416,
     417,   418,   419,     0,   420,     0,   422,   423,   717,   424,
    1274,     0,   426,   427,   428,   429,   430,   431,   432,   433,
     434,   435,     0,   437,     0,   438,   439,     0,   440,   441,
     442,   443,   444,   445,     0,  1275,  1276,     0,     0,   448,
       0,   450,     0,     0,   452,   453,   454,   455,   456,   457,
       0,     0,   458,   459,   460,   461,     0,     0,   462,   463,
     464,   465,     0,  1277,     0,   468,   718,   469,   470,   471,
       0,     0,   472,     0,     0,   473,   474,   475,   476,   477,
    1257,     0,     0,     0,     0,     0,     0,     0,   486,   487,
     488,   191,   192,   193,   194,   195,   196,   197,   198,     0,
     200,   201,   202,     0,     0,     0,     0,     0,     0,     0,
     203,   204,     0,   205,   697,   206,   207,   208,     0,     0,
     698,     0,     0,     0,   213,   214,   215,   216,   217,     0,
       0,   218,   219,     0,     0,   222,     0,   223,   224,   225,
     226,     0,     0,     0,   228,   229,   230,   231,   699,   232,
     233,     0,   234,   235,   236,   237,   238,   239,     0,   240,
     241,   242,   700,   243,   244,     0,     0,     0,   701,     0,
       0,     0,   245,   246,   247,   248,   249,   250,     0,     0,
     253,     0,   254,     0,   255,   256,   257,   258,   259,     0,
     260,   261,   262,     0,     0,   263,   264,   265,   266,   267,
       0,   268,   269,   270,     0,   271,   272,     0,   273,   274,
     275,   276,     0,   278,   279,     0,     0,   281,     0,   282,
       0,   284,     0,   285,     0,   286,   702,     0,   703,   287,
     288,   289,     0,   290,     0,     0,   292,     0,   293,   294,
     295,   296,   297,   704,   298,   299,   300,     0,   301,   302,
     303,   304,   305,   306,     0,   307,   705,     0,   309,   310,
     311,   312,     0,     0,     0,     0,     0,   316,   706,   707,
     317,   708,   318,   319,   320,   321,   322,   323,     0,     0,
     709,   325,   710,     0,   326,   327,   328,     0,     0,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,     0,   711,     0,   344,   345,   346,   347,   348,
     349,   350,     0,   352,     0,   353,   354,   712,   355,     0,
       0,   357,     0,   359,   360,   361,     0,   362,     0,     0,
     363,   364,   365,     0,     0,     0,   713,   714,   715,     0,
     368,   369,   370,   371,   372,   373,     0,   374,     0,   376,
       0,   378,   379,   380,     0,   381,   382,   383,   384,   385,
     386,   387,     0,   389,   390,   391,     0,   392,   393,   394,
     395,   396,   397,   398,   399,   400,   401,     0,   402,   403,
     716,   404,   405,     0,   407,   408,   409,   410,   411,   412,
     413,   414,     0,   415,   416,   417,   418,   419,     0,   420,
       0,   422,   423,   717,   424,     0,     0,   426,   427,   428,
     429,   430,   431,   432,   433,   434,   435,     0,   437,     0,
     438,   439,     0,   440,   441,   442,   443,   444,   445,     0,
       0,     0,     0,     0,   448,     0,   450,     0,     0,   452,
     453,   454,   455,   456,   457,     0,     0,   458,   459,   460,
     461,     0,     0,   462,   463,   464,   465,     0,     0,     0,
     468,   718,   469,   470,   471,     0,     0,   472,     0,     0,
     473,   474,   475,   476,   477,     0,     0,     0,     0,     0,
       0,     0,     0,   486,   487,   488
};

static const yytype_int16 yycheck[] =
{
       0,     0,     0,     0,     0,   175,   513,   852,    17,    49,
     165,    11,   693,   646,   158,   859,   171,    26,    22,    35,
     888,    21,   605,   606,    28,    43,   695,   610,   911,  1165,
     720,  1375,  1127,  1149,   938,  1413,   925,   725,    22,    12,
    1273,   823,   993,   540,    28,   769,  1513,   554,   506,    49,
     964,   965,  2314,   753,  1771,  1772,   736,  1202,   653,  1808,
    1155,  1068,   552,   763,  1066,    21,   556,  2071,    23,   983,
       7,  1336,  1208,  1209,  1319,  2529,   566,    14,  1450,   800,
      35,   172,  1092,  1305,    42,  1971,   177,    45,  1149,  2045,
     548,   166,  1066,   160,   169,   186,  2207,  2381,   879,  2383,
    1669,  1305,    18,  1483,   804,   802,  1305,  1114,  1305,   809,
     185,  1305,  2768,  1305,  2209,  1117,   816,   160,  1976,  1977,
    2444,  2749,  2483,   844,   145,   825,  1371,  1982,   573,     0,
    2974,  1196,     0,     0,     0,  1066,     0,  1155,  1675,  1117,
    2947,    39,  1680,  1117,  3148,  2920,     5,  2984,   690,     5,
      57,   726,   649,  2463,  2464,  2465,  2466,  2467,  2468,  2483,
     160,     0,     5,  1543,     5,     0,  2663,   690,     0,  1918,
       9,    31,  2952,    77,   128,  2205,  2206,   954,   955,    25,
       5,    43,   104,    22,    22,  2999,  1117,  3001,   763,     0,
      16,    29,     0,     5,    99,     0,     5,   150,   731,    26,
      27,     9,   979,     0,     0,     5,     9,    97,   888,  1888,
     150,    18,   123,    13,    22,   798,    57,     5,     5,     5,
      72,     5,    66,   181,     5,    13,    13,    18,   925,  1010,
       5,     5,    57,     5,   104,    18,     4,  3414,  3415,     5,
      35,     9,    11,   153,    11,  1994,  3154,  1996,   150,    81,
      70,   229,   247,  3507,   151,    35,    50,   150,   163,  3298,
      50,   113,   252,    41,     9,    22,   145,    36,    72,  3514,
     264,   153,    29,   109,  3468,   158,     5,   784,   133,   133,
       3,     4,     5,     4,    81,   247,     9,   104,     9,   111,
     109,   106,   106,   109,   193,     5,   141,   229,  1300,   293,
       9,   355,  1232,    11,   310,   121,   156,   133,    63,   113,
     152,   150,   297,   218,   121,   150,   221,    81,   141,     5,
     104,  1011,   149,   155,   151,  1276,  1300,  1815,    36,  1053,
     121,   170,   108,    20,   237,   170,   355,   322,   121,   150,
     375,   347,   150,   513,   264,   150,  1036,   502,   308,  1263,
    1264,   264,    39,    22,   150,    11,   324,  1271,   155,   170,
      29,   206,   170,     4,   183,   170,   150,   237,     9,  1300,
     860,  1859,  1052,   293,   170,   429,  1056,  1057,   875,   282,
     293,   104,  3157,   206,   554,   284,   392,   393,   166,   544,
     425,   155,   170,  1238,   298,    11,   551,  1327,  1242,   359,
     378,   866,  3596,   173,   249,   373,   396,   317,   313,   179,
     429,   253,   877,   265,   190,  1112,   295,   187,   104,   425,
     511,   304,   237,     8,   515,   242,   916,   205,   242,   319,
     425,   425,    50,   508,   525,   317,   346,   927,  2111,  2112,
     310,    22,  1449,  2116,  2805,   890,   170,    59,   523,   939,
     296,    50,  2762,   355,  1134,  3709,    30,   264,   274,  3498,
    1140,   265,   308,   425,   346,   188,  3470,   196,   300,   324,
     324,   425,  1254,   264,   260,   407,   429,   388,  1175,     5,
     306,  2805,  2155,  2156,  1261,  1262,   209,  3664,   497,   429,
     412,   329,  1192,  1270,  1194,   250,   315,   349,   324,  3274,
    1507,   406,   293,   300,  1184,   299,  1230,  1187,  1188,   299,
     293,   355,  2049,   359,  1235,   322,  1518,  3331,   425,   131,
     425,  3301,  1405,   335,   336,   429,  2556,   383,   425,  2278,
     104,   540,   541,  1766,   574,   147,   429,   373,  3783,  1236,
      50,  3316,   383,  1550,  1518,   349,   366,   342,   326,   693,
    3047,  1251,  1049,   375,   373,   576,  1253,   384,   121,  1239,
     392,   257,   342,   425,   423,   425,   425,  1109,   427,   425,
    3574,   355,   329,   573,   574,   191,   534,   416,   417,   429,
     496,   585,   425,   587,   425,   589,  1109,  1518,  2305,   428,
    2307,   595,  2902,   428,   426,   392,   428,  1087,  1295,   572,
     425,   585,  1290,   587,  1749,   589,  1181,  2144,   416,   417,
     619,   595,   596,   597,   784,  1148,   425,   428,   574,   774,
     428,   424,  2733,   428,   392,   425,   781,   393,   412,   426,
     639,   428,   428,  2728,  3409,   429,   645,   425,   425,   648,
     649,   650,  3417,   427,   425,   411,   189,  1344,   416,   417,
     425,   425,   421,   425,   421,  1771,  3564,  2543,   616,   425,
     329,  2547,   599,   738,   739,   277,  3670,  1448,   253,  1450,
    1177,   416,   417,   104,  2423,  2424,   831,  3484,  3515,  1460,
     425,   299,  1463,   393,   684,   684,   684,   684,   684,   270,
    1471,  1472,  2230,   416,   417,   416,   417,     5,  1475,  1476,
     299,   411,  3494,  1484,  1485,   429,  1971,   416,   417,   667,
     418,   419,   420,   421,  1495,   425,   242,   673,     5,   229,
    1722,   796,   251,  3727,   306,   495,    22,  2444,   251,    59,
     500,  2111,  2112,   429,   297,    59,  2116,   812,   813,  2418,
     150,  1324,  2421,  2422,  1722,   152,  2425,   250,  1722,   647,
      74,  2218,   736,   651,   829,    23,  2435,   369,   384,   322,
    1778,    97,   418,   419,   420,   421,  2483,   348,   104,   350,
     151,   116,    68,   118,   104,  2155,  2156,   152,   142,    75,
    1102,   856,   857,   130,  1417,  1418,    99,   163,    11,   299,
     799,  1722,    34,   279,   139,  3639,  1798,  3801,    72,   109,
     416,   417,   418,   419,   420,   421,   150,   131,   193,   105,
    2527,   429,   322,   684,  1504,   154,   684,   684,   684,  1516,
     684,   107,    72,   147,  1798,   287,   109,   412,   413,   414,
     429,   416,   417,   418,   419,   420,   421,  3629,   412,   113,
     187,   611,   218,   425,    11,   144,   253,  1963,  1355,   423,
     163,   425,   426,   427,   152,   429,   626,   104,   257,  1349,
    1834,   106,  3316,   113,   228,    43,   875,  1798,  1358,    36,
     209,    32,   802,   183,  1339,   189,   646,   257,   174,   888,
    1370,   167,   180,  1348,   315,   266,   429,  1345,  2743,  1954,
     890,  1356,  1357,   663,   423,  3418,   134,   242,   427,   284,
     183,   237,   247,  1834,   888,   218,  3562,   237,   221,  1374,
     257,    74,   242,   922,   345,   685,   184,    95,   834,   919,
     919,  1411,   425,    51,  1414,  3757,  1416,   169,    97,  1419,
     337,    59,   177,   308,   242,  3710,  1381,   313,  2203,   425,
     108,   104,  3570,  3571,    11,   355,   327,   277,   948,   380,
     423,   112,  3475,   277,   427,   242,   893,  3749,   895,   289,
     897,   392,   899,   425,   901,   902,   903,   967,   191,    36,
    1010,   908,  2645,   272,  1481,  2648,  2649,  2650,  2651,  2652,
    2653,  2654,  2655,  2656,  2657,   116,   295,   118,   363,  3821,
     237,   265,   237,  3277,   425,   925,  1910,   997,   334,   304,
     313,   337,   412,  1012,   182,   315,  3117,  1177,   139,   348,
    1010,   350,     5,  1022,    18,   265,   361,   427,  3129,     5,
      24,   368,   190,  1032,   191,   370,  3121,   426,  1095,  1096,
     429,  1098,  2705,  2706,   218,   345,  3131,    22,   264,   369,
    1049,   337,  3565,  1052,   429,   369,   426,  1056,  1057,   429,
    3573,   229,  1095,  1096,    22,  1098,   826,   827,   828,  1080,
     229,  1159,   308,   373,   345,  1847,  3427,   293,  1052,   374,
     380,     5,  1056,  1057,   237,   349,   306,   315,  3034,   362,
     151,   209,   392,   392,     8,  1782,   283,    11,  2805,   425,
     373,   263,   306,   406,    73,  1095,  1096,  3725,  1098,   349,
     116,   132,   118,  3427,  2990,  1203,   237,   345,   179,  2995,
     307,   242,  2998,   359,    98,   425,   247,   121,   104,   333,
     429,    96,  1052,   194,   191,   192,   357,  1218,  2986,   313,
     425,   116,   203,   311,  2136,  1210,  1211,  1212,  1213,  2141,
     171,  1821,   380,   373,  1989,   915,   125,  2292,   116,  1829,
    1134,  1831,     8,  1997,   392,    11,  1140,  1939,  1940,  1941,
    1942,  1483,  2136,   154,   308,  1240,  1241,  2141,   938,  2848,
     104,  1246,  2741,   240,   145,  2854,  2855,  2856,  2857,  2858,
    2859,  1336,  1112,  1338,   155,  1355,  1170,   425,  2304,   173,
     229,  1200,  1347,   416,   417,   418,   419,   420,   421,   170,
    1184,  1898,  1667,  1187,  1188,  2136,     3,   116,     5,   118,
    2141,  2589,     0,  1304,   255,   359,   255,   264,   209,  1149,
     199,   200,  2232,   264,  2231,   264,    66,   310,  1319,   428,
     361,   247,   303,   212,    74,  1310,  1311,  1312,  1313,   370,
    2913,    76,   217,  2304,   219,  1175,   293,  2619,    96,   416,
     417,   418,   419,   420,   421,  1239,  3710,   107,  1413,  3008,
     264,  3010,  1983,  2485,   347,  2645,  1724,   191,  2648,  2649,
    2650,  2651,  2652,  2653,  2654,  2655,  2656,  2657,  2543,  1303,
    1371,  2485,  2547,   118,   357,   264,  2485,  1777,  2485,   293,
    1980,  2485,  1062,  2485,   284,   429,  1320,  1306,  3393,  3394,
    2081,  1376,    99,   191,   264,   426,  1236,   412,   429,   392,
     393,  1481,   276,   276,   170,   141,     5,   167,   109,   145,
       9,   394,   427,  1253,  3608,  2705,  2706,   175,   237,   253,
     130,   302,  2577,   293,   324,   191,  1336,   297,   247,   378,
     279,   141,   425,  1273,   385,   145,  3350,   170,  2129,   416,
     417,   418,   419,   420,   421,  1813,  3618,   348,  2038,   350,
     344,   345,   322,   251,  2061,  1295,   163,    34,   347,   217,
     349,   219,   393,    40,   392,   316,    97,  2158,   141,  2515,
     206,  1381,   145,   373,   251,  1425,   246,   187,   284,   256,
     411,  1161,   183,   357,   357,   386,  2310,   253,   294,  2282,
    3404,    74,  3406,    11,   345,   107,   206,  2381,  2382,  2383,
     315,   429,  2193,     8,  1344,   104,    11,   426,  3091,  3092,
     429,   218,   318,   249,   221,  1425,  1382,  1443,    36,  2640,
     394,   394,   392,  2900,  1434,  1434,  1434,  1434,  1434,  2441,
     345,    36,  3328,   206,  1214,   386,    41,   238,   239,   249,
    2381,  2382,  2383,  2664,  1391,    37,  1393,   257,  1395,  1468,
    1397,   392,  1399,  3558,  1234,   167,  1403,  2441,   196,  1966,
     293,  1429,   392,    22,   297,   380,    58,  1461,  1462,    28,
    2482,   154,   264,   316,   312,  1469,   249,  1442,   310,  1473,
    1474,   355,   416,   417,   418,   419,   420,   421,   429,   322,
     173,   293,   315,   347,  1488,   297,  1490,  2772,  2482,   429,
    2441,   293,   345,  2010,   264,   297,   313,   423,   425,   425,
     425,   427,  1522,  1988,   315,   347,  1510,   348,  1512,   350,
     322,   312,   345,  2913,  3213,  3214,   209,  2002,  2003,  2219,
     322,  2006,   426,   293,  2034,   429,    97,  2012,   392,   393,
    2557,  2482,    85,   386,   345,  1564,   412,   413,   414,   264,
     416,   417,   418,   419,   420,   421,   393,   380,   368,   392,
     392,   393,   322,   393,   150,   170,   755,   426,   757,   392,
     429,   425,   373,   256,   411,   764,  1516,   424,   293,   380,
    1360,   411,   429,  2600,   170,   359,   191,   192,   425,  1369,
     392,   392,     5,   425,   145,   425,   173,    10,  2073,   406,
    1380,  2494,   425,   295,  2302,  2248,    19,   322,   151,    78,
     145,  2216,  3089,   423,   165,   424,   426,   427,  1719,   165,
     429,   251,  1723,    36,   425,    97,   256,   587,   588,   589,
     165,   196,   592,   593,   594,   240,   179,  1417,  1418,   392,
     393,  2348,   602,  2350,  1745,  2791,  2792,   348,   253,   350,
     420,   194,  1753,    56,    57,   425,    81,   427,  2175,   426,
     203,     8,   429,    47,    11,   348,  2678,   350,  2685,   306,
     307,   426,  3355,  1683,   429,  1776,   359,   312,   103,  1693,
     420,    28,   425,   226,   109,   425,   369,   427,  2843,  2128,
     426,  2130,  2131,   429,  2678,  1796,  3379,  3380,  2612,  1693,
    3427,  3091,  3092,  1729,     9,  1731,  2667,  2668,   425,   134,
    3724,  1677,  2419,  1814,   251,  2990,  1817,   423,     8,   425,
    2995,    11,  3481,  2998,  2867,  2868,   426,   429,  2871,   429,
    2873,    47,   426,   426,  1835,   429,   429,  2678,    28,   425,
    1759,  1842,  1827,    37,   426,   426,   426,   429,   429,   429,
    1851,   426,   408,   426,   429,  3444,   429,  1858,   183,   426,
     303,   193,   429,   426,    85,  1545,   429,   306,   307,   426,
    2270,  2271,   429,  2273,  1554,   426,   392,   393,   429,  2111,
    2112,   427,  3509,   426,  2116,   426,   429,   426,   429,  1874,
     429,   251,  2804,  2500,  2806,   254,  1881,  1882,  1883,  1884,
    1885,  1886,   426,   254,  2703,   429,  1971,  2514,  2283,   409,
     410,   416,   417,   418,   419,   420,   421,   408,   426,     0,
    2804,   429,  2806,  2155,  2156,   426,  1766,  1821,   429,   355,
     151,  1771,  1772,   426,   254,  1829,   429,  1831,  2453,  2454,
    2455,  2967,  1782,  3086,   191,  2829,  2951,  2322,    37,  2324,
     426,  3534,   251,   429,   426,  2562,   426,   429,   179,   429,
    2784,  1880,   193,  2804,     8,  2806,   348,    11,   350,  1888,
    2370,  1956,   426,   194,   426,   429,   426,   429,   408,   429,
    2773,  2774,   203,  2674,    28,   348,   426,   350,  2829,   429,
     315,  2484,    36,   425,   418,   427,  1676,    41,  1678,   426,
      81,   191,   429,   322,   426,   226,   253,   429,  1993,   426,
    1995,    43,   429,  1907,   426,   392,   393,   429,  2625,  1938,
     345,  1971,   426,  3400,   426,   429,   426,   429,   149,   429,
     251,   891,   426,   109,   894,   429,   896,  2644,   898,   429,
     900,  1960,  1925,   426,   904,  1955,  1955,  1966,   373,   130,
       8,  2249,  2250,    11,    86,   380,   426,   425,  1898,   429,
     141,  1971,  2669,   253,   145,  3355,    47,   392,   426,   150,
      28,   429,   426,  2473,   155,  2475,   425,   158,   110,   160,
     426,   426,   303,   429,   429,   425,  2864,   427,   130,  3379,
    3380,  2010,   426,   251,   428,  2175,  2703,   129,   427,   141,
     425,  2735,   426,   145,   395,   429,   187,   183,   426,   426,
     426,   429,   429,   429,   146,  1795,   427,   426,   426,  2526,
     429,   429,   166,  1963,   426,   206,   170,   429,   426,   161,
     426,   429,   425,   429,  2725,  2726,     8,   426,  2203,    11,
     429,   929,   930,   426,  2038,   187,   429,   191,   192,   426,
     425,   145,   429,  3328,   375,   204,    28,   426,  2212,   251,
     429,   205,  2242,   239,   206,   412,   413,   414,   249,   416,
     417,   418,   419,   420,   421,   375,   257,   426,  3466,   425,
     429,   426,  2780,   426,   429,   428,  2561,  2587,     8,   246,
    2565,    11,  2567,   237,  2569,  2570,   240,   312,   426,   426,
      18,   429,   429,  2578,   196,   425,    24,   249,  2158,   253,
     242,  2611,   256,   426,  1498,   257,   429,  1501,   250,   300,
      59,  2061,   412,   413,   414,   392,   416,   417,   418,   419,
     420,   421,    31,   191,    18,  3410,   395,   425,  2613,   315,
      24,    37,  1922,     8,  3534,    63,    11,    37,  2158,   687,
     282,   689,  2548,   364,  2550,   264,   145,    71,  2259,   280,
     135,   375,  2172,   425,   345,   135,   135,   395,   135,   345,
    2198,  2199,   135,   429,  2864,   135,   135,   135,    49,    63,
     251,  2191,   326,   135,  2976,   135,   135,   368,   251,  3315,
     135,   135,   345,  2203,   425,   253,   114,   373,  3097,    31,
    2219,   204,   145,   121,   380,   146,   124,   145,   389,    80,
     391,   392,   425,  3225,     5,     5,   392,   425,   425,   191,
     425,   425,   273,  2217,  2931,  2219,   368,   425,   425,   425,
     114,  3585,  3507,  3587,     5,     5,     5,   121,   425,   425,
     124,  3225,   423,  2344,     5,   426,   427,   428,   425,   425,
    2351,   425,   425,   425,   425,   425,   425,   175,   425,   425,
     425,   425,   425,   425,  2444,   425,   137,   425,   412,   413,
     414,   191,   416,   417,   418,   419,   420,   421,   425,   261,
     424,   253,    31,   429,  3225,  3076,   430,    87,   204,    31,
     145,   175,   249,  3277,   145,   355,   355,   168,   427,   355,
     355,   355,   314,  2483,   251,   355,   355,   242,   355,   374,
      66,   229,  2413,  2645,   251,   175,  2648,  2649,  2650,  2651,
    2652,  2653,  2654,  2655,  2656,  2657,   191,   355,   355,   425,
     429,   264,   375,   253,  3024,   375,  3277,   264,    98,   355,
     355,  3234,   355,    47,    47,   229,   264,   355,  2367,  3227,
     425,   355,   255,   355,   412,   413,   414,   355,   416,   417,
     418,   419,   420,   421,  2304,  2305,   251,  2307,  2387,   355,
     355,   355,   355,  2705,  2706,   293,   310,   251,  2543,   297,
     264,   191,  2547,   392,   425,    31,   383,  3492,   253,   425,
    3097,   425,    49,   264,    30,    20,   104,   375,   386,  2418,
     212,    31,  2421,  2422,   322,   385,  2425,   145,  2348,   293,
    2350,   425,    31,   297,   196,   389,  2435,  2197,   311,   135,
     375,  2440,   293,    80,  2589,  2444,   297,  2927,  2928,   135,
     301,   246,   355,   375,  3709,   135,   307,   135,   322,   300,
     412,   413,   414,   314,   416,   417,   418,   419,   420,   421,
    2444,   322,   380,   241,  3154,  3134,   150,  2451,  2452,   330,
    3359,   425,  2456,  3170,  2483,   353,    31,   338,  2248,   388,
     223,   223,   408,  3180,    11,   429,  2577,   322,  2497,  2419,
     137,   353,  2476,   150,    49,   425,   355,   357,   164,  2483,
     164,  2592,   412,   413,   414,   425,   416,   417,   418,   419,
     420,   421,   426,   429,  2444,   412,  2525,  2526,  2518,  2518,
     187,   168,  3222,  2614,  3640,    80,   387,   429,   252,  3019,
    3020,  3021,   247,   429,   426,   355,  2536,  2536,   355,   310,
      73,  3006,   310,  2543,   425,   375,   195,  2547,  3013,  3014,
     195,   242,   425,  2483,   251,   242,   242,   258,   413,   414,
     355,   416,   417,   418,   419,   420,   421,   250,   355,   355,
    2500,   429,  3455,   293,   293,   293,   355,   284,   319,   191,
      31,   191,   137,   191,  2514,   191,   375,   375,   191,   250,
      30,  2913,   425,   412,   423,   423,   145,  2527,  2598,  2598,
     355,   355,   355,   355,   425,    19,   412,   147,   247,  3390,
     425,   319,  3748,   168,    31,   162,   251,  2772,   251,   162,
     145,   429,   425,    31,   135,   145,   251,   251,   425,   170,
    3137,   170,  2562,   170,  3608,  2805,  3333,   319,   395,    19,
     156,   196,   220,    47,   429,   429,  3535,   251,   150,   426,
     297,   426,   299,   426,   301,    26,    27,   426,   150,    73,
     307,   426,  3359,   426,   426,   429,   355,   314,    82,    83,
      84,   408,   389,  2713,   408,   322,   425,  3608,   426,   426,
    2689,   426,   426,   330,   260,    13,   426,  2778,   426,  3578,
     426,   338,  3275,  3582,  3583,  2625,    18,  2715,  2716,  2717,
    2718,   426,    24,   425,    13,   426,  3171,  3172,  3198,  3199,
      81,  3201,   126,  2713,  2644,   206,   251,   251,   254,   378,
     425,   425,   425,  2732,   355,  2495,  3594,   181,   242,   135,
     135,   206,   103,   355,  3579,  2505,  3580,   268,   109,  2669,
     387,    63,   297,   372,   268,  2836,   301,  2838,   215,   215,
    2520,   215,   307,   355,   355,   355,   170,   355,  3539,   314,
     355,   175,   355,   134,   355,   191,   191,   322,   191,  3091,
    3092,   191,   191,  2703,     3,   330,    73,   423,   191,   191,
     221,   313,   426,   338,   426,    82,    83,    84,   206,   412,
     255,   364,   114,    97,   295,   392,  2805,   425,   250,   121,
     214,  2571,   124,   251,  2574,   426,   159,   355,   194,   426,
    2819,   429,   183,  2822,  2818,  2824,   230,   231,   232,   233,
     234,  2805,   236,   259,   194,   247,   425,   310,   310,   126,
     375,  3321,   387,   425,  2818,  2990,   391,   392,  3535,  2848,
    2995,  3331,  2612,  2998,    59,  2854,  2855,  2856,  2857,  2858,
    2859,   310,   375,   175,   268,  2864,   254,   429,  3002,    74,
     429,   133,   133,   423,  3497,   127,   150,    11,   145,   426,
     426,  3336,   426,  3338,  3339,  2805,  3557,  3658,   175,   385,
    2864,  3578,    57,   150,  3349,  3582,  3583,   425,   158,   104,
     304,   106,  2876,  2877,   252,  2904,  2905,  2906,  2907,   412,
      48,   145,   181,  2887,  3411,   426,   425,   229,   426,   426,
       8,   426,   355,    11,   364,   364,   355,   214,   355,   426,
    2904,   355,   426,   426,  3431,   145,  3771,   341,   426,   343,
      28,   191,   191,   230,   231,   232,   233,   234,    36,   236,
     424,   426,   264,    41,   315,   424,   195,   425,    96,   425,
    2720,  2721,    31,   367,   392,  2964,   429,   145,   426,   429,
     374,    69,   177,   377,   395,   176,   347,  3137,   392,   429,
      23,   268,    25,   355,   345,   297,    29,   194,   425,   425,
      33,    34,    35,   425,    37,   319,    39,    40,   155,    42,
    2990,    44,    45,   426,   150,  2995,   426,   150,  2998,   426,
     322,  2931,   373,   390,   425,    18,   390,    47,   160,   380,
     426,    24,   355,   384,     8,   150,   426,    11,   429,   426,
     392,   392,   237,   364,   172,   135,   242,   242,   242,   412,
    3520,   191,   429,  3355,   429,   111,   242,  2967,   106,   177,
    3024,   152,    36,   150,   341,   424,   375,    41,   375,   122,
      63,   388,    97,   392,   425,   150,   425,  3379,  3380,   425,
     178,   425,   277,   254,   150,   425,   425,  3532,   166,   217,
     367,   219,   170,   379,   289,   331,   426,   374,  3153,  3154,
     377,   229,   426,   391,   267,  3176,  3669,   251,   426,   289,
     426,   392,   375,   191,   192,   425,  3187,   145,  3563,  3589,
     425,   114,    31,   242,   216,   425,   173,   205,   121,   134,
     255,   124,   165,   166,   167,   263,   169,   307,   171,   172,
     173,   307,   175,  3132,   177,  3200,   179,    59,   181,   254,
    3146,  2901,   185,   186,   187,    59,    47,  3141,     0,   237,
     257,   145,   240,   425,   347,   251,   117,   140,   281,  2919,
     298,   254,   254,   379,   369,   253,  3086,  3141,   256,  3666,
     429,    31,   175,  3167,   150,   389,  2936,  3097,   287,   392,
     122,   429,   166,  3328,   251,    31,   170,   251,   425,   392,
     426,   426,   425,  3167,   332,   306,   109,   425,   373,    17,
     306,    28,   134,   281,  3178,  3179,   684,   191,   192,  3183,
    3184,  1221,  1924,   425,  3213,  3214,  2219,  1804,  1057,  2315,
    2804,   205,  3534,  2440,  3447,  3225,   229,  3594,  3227,    81,
    2955,  3492,  3231,  3232,  3268,  2277,  3235,  3236,   326,  3496,
    3729,  2027,  3410,  3770,  3696,  3695,  3738,  2957,  1321,  1749,
    3170,  3411,  3516,  2829,  2382,  1307,   240,  3251,  1912,  3773,
    3180,   264,  2496,  3834,  3826,  3410,  3242,  3427,  3241,   253,
    2482,  3431,  3745,  2446,  3433,  3677,  1298,  3251,   130,  3436,
      28,  3027,  3561,  2965,   917,  3430,  1772,  2967,  3287,   141,
     293,  3281,  3281,   145,   297,  3640,   541,  3754,   150,  3828,
    3482,  1678,  1677,   155,   662,  1382,   158,  2948,   160,  2599,
    3765,  2228,   677,  1086,  2239,  3314,  1105,  2251,  1713,   322,
    1104,  3466,  2245,  1670,   412,   413,   414,  1712,   416,   417,
     418,   419,   420,   421,  1696,   187,  2203,  1971,  3328,  2549,
     534,   429,   326,  1107,   667,  2229,  3329,  3412,  3108,  3109,
    3110,  3111,  2945,  1897,   206,  2688,  3537,  2680,  3718,  3722,
    3719,  2242,  3507,  2172,  2083,    31,     8,  2050,  2170,    11,
      -1,  1546,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    49,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,   249,    -1,    41,
      -1,    -1,    -1,    -1,    -1,   257,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3333,    80,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3427,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,    -1,  3359,
      -1,  3506,    -1,    -1,    -1,  3444,    -1,    -1,   300,  3448,
      -1,    -1,   495,  3427,    -1,    -1,    -1,   500,    -1,   502,
      -1,    -1,    -1,   506,    -1,   508,    -1,    -1,   511,    -1,
     513,   137,   515,   516,    -1,    -1,    -1,    -1,    -1,    -1,
     523,    -1,   525,    -1,    -1,    -1,    -1,   129,    -1,    -1,
      -1,   534,    -1,   345,    -1,    -1,    -1,   540,    -1,  3564,
      -1,   544,   168,    -1,    -1,   548,  3666,  3427,   551,    -1,
      -1,   554,    -1,    -1,    -1,     8,   368,    -1,    11,    -1,
      -1,  3586,    -1,  3588,   166,    -1,   569,    -1,   170,    -1,
     196,   574,    -1,    -1,    -1,    28,    -1,   389,    -1,   391,
     392,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,   191,
     192,    -1,    -1,    -1,    -1,    -1,    -1,  3702,  3318,    -1,
      -1,    -1,    -1,   205,  3709,    -1,    -1,    -1,   611,    -1,
      -1,   423,    -1,   616,   426,   427,   428,    -1,    -1,    -1,
      -1,    -1,    -1,   626,   627,    -1,  3731,    -1,    -1,  3509,
      -1,    -1,    -1,    -1,    -1,  3594,    -1,    -1,   240,    -1,
      -1,   644,    -1,   646,   647,    -1,   649,    -1,   651,    -1,
      -1,   253,    -1,    -1,    -1,  3535,    -1,    -1,    -1,    -1,
     663,    -1,    -1,    -1,   667,    -1,    -1,   670,    -1,    -1,
      -1,   297,   675,    -1,  3699,   301,    -1,    -1,    -1,    -1,
      -1,   307,   685,    -1,    -1,    -1,    -1,    -1,   314,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   322,    -1,  3578,    -1,
      -1,    -1,  3582,  3583,   330,    -1,    -1,    -1,    -1,    -1,
    3735,    -1,   338,   166,    -1,    -1,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,   326,  3830,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   738,   739,    -1,   191,   192,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3469,
      -1,    -1,   205,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,   387,    -1,    -1,    -1,   391,    -1,    -1,    -1,    -1,
      -1,   774,    -1,    -1,    -1,    -1,    -1,  3497,   781,    -1,
      -1,   784,    -1,    -1,   237,    36,    -1,   240,    -1,    -1,
      41,    -1,    -1,   796,    -1,  3785,    -1,    -1,    -1,    -1,
     253,    -1,    -1,   256,  3754,  3754,  3754,  3754,  3754,   812,
     813,    -1,    -1,    -1,   416,   417,   418,   419,   420,   421,
      -1,    -1,  3781,   826,   827,   828,   829,    -1,   831,    -1,
      -1,    -1,    -1,    -1,    -1,  3785,  3785,  3785,  3785,  3785,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3781,    -1,    -1,
      -1,    -1,  3572,   856,   857,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,  3826,     8,    -1,
      -1,    11,   875,   326,    -1,  3834,   879,    -1,  3828,  3828,
    3828,  3828,  3828,    -1,    -1,   888,    -1,    -1,    28,    -1,
      -1,    31,  3826,    -1,    -1,    -1,    36,    -1,    21,    -1,
    3834,    41,    -1,    -1,    -1,    -1,    -1,   910,   911,    -1,
      -1,    -1,   915,    -1,   917,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      53,    -1,   935,    -1,    -1,   938,    -1,    -1,   941,    -1,
     191,   192,    -1,    66,    -1,    -1,    -1,    -1,    -1,   952,
       8,    74,    -1,    11,   205,    78,    -1,    -1,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,    -1,
      28,    -1,    -1,    -1,    -1,    98,   429,   980,    36,    -1,
      -1,    -1,    -1,    41,    -1,    -1,   237,    -1,    -1,   240,
      -1,    -1,    -1,    -1,    -1,    -1,   119,    -1,    -1,    -1,
      -1,    -1,   253,    -1,  1007,  1008,    -1,  1010,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1027,    -1,   166,    -1,    -1,   152,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1049,    -1,    -1,    -1,
     173,   191,   192,  1056,  1057,    -1,    -1,    -1,    -1,  1062,
      -1,    -1,  1065,    -1,    -1,   205,    -1,  1070,    -1,  1072,
      -1,    -1,    -1,    -1,   197,   326,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   145,    -1,    -1,
      -1,    -1,   150,    -1,  1097,    -1,    -1,   237,  1101,  1102,
     240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,
      -1,    -1,   170,   253,    -1,    -1,   256,    -1,  1121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     253,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,  1142,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,
      -1,    -1,  1155,    -1,    -1,    -1,     8,   280,  1161,    11,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,    -1,    -1,    -1,  1177,    -1,    28,    -1,    -1,   237,
      -1,   304,   240,    -1,    36,   308,   326,   310,    -1,    41,
      -1,    -1,    -1,   316,    -1,   253,    -1,    -1,   256,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1210,  1211,  1212,
    1213,  1214,    -1,    -1,    -1,  1218,    -1,  1220,    -1,    -1,
      -1,    -1,   345,    -1,   347,    -1,    -1,    -1,   351,  1232,
      -1,  1234,    -1,    -1,    -1,    -1,   359,  1240,  1241,    -1,
      -1,   364,    -1,  1246,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   386,    -1,    -1,    -1,    -1,   326,    -1,
      -1,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1304,    -1,    -1,    -1,    -1,    -1,  1310,  1311,  1312,
    1313,    -1,    -1,    -1,   166,    -1,  1319,    -1,   170,    -1,
      -1,    -1,    -1,    -1,  1327,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1336,    -1,  1338,    -1,    -1,    -1,   191,
     192,    -1,  1345,    -1,  1347,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1355,   205,   412,   413,   414,  1360,   416,   417,
     418,   419,   420,   421,    -1,    -1,  1369,    -1,  1371,    -1,
      -1,    -1,  1375,  1376,    -1,    -1,    -1,  1380,    -1,  1382,
      -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,   240,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   253,  1405,    -1,   256,    -1,    -1,    -1,    -1,    -1,
    1413,    -1,    -1,    -1,  1417,  1418,    -1,    -1,     8,    -1,
      -1,    11,  1425,    -1,    -1,    -1,  1429,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1442,
    1443,    -1,    -1,  1446,    -1,  1448,    36,  1450,    -1,    -1,
      -1,    41,    -1,    -1,  1457,    -1,    -1,  1460,    -1,    -1,
    1463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1471,  1472,
      -1,    -1,    -1,    -1,   326,    -1,  1479,    -1,  1481,  1482,
    1483,  1484,  1485,    -1,    -1,    -1,    -1,    -1,    -1,  1492,
    1493,    -1,  1495,    -1,  1497,    -1,    -1,  1500,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1517,    -1,    -1,    -1,  1521,    -1,
       8,    -1,  1525,    11,    -1,    -1,  1529,    -1,  1531,  1532,
    1533,  1534,  1535,  1536,  1537,  1538,  1539,    -1,  1541,   129,
      28,    -1,  1545,  1546,    -1,  1548,    -1,    -1,    36,    -1,
      -1,  1554,    -1,    41,    -1,    -1,    -1,    -1,    -1,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
      -1,    -1,    -1,    -1,   426,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    -1,
     240,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,    -1,
      -1,    18,    -1,   253,    -1,    -1,  1669,    24,    -1,    -1,
      -1,    -1,    -1,  1676,    -1,  1678,    -1,  1680,   166,    -1,
      -1,    -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,    -1,    63,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1719,   205,    -1,    -1,
    1723,  1724,    -1,    -1,    -1,    -1,  1729,    -1,  1731,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,     8,    96,
      -1,    11,  1745,  1746,    -1,    -1,    -1,    -1,    -1,   237,
    1753,    -1,   240,    -1,    -1,    -1,    -1,   114,    -1,    -1,
      -1,    -1,    -1,    -1,   121,   253,    36,   124,   256,    -1,
      -1,    41,    -1,  1776,    -1,  1778,    -1,    -1,    -1,    -1,
      -1,  1784,    -1,   166,    -1,    -1,  1789,   170,    -1,    -1,
      -1,    -1,  1795,  1796,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1807,  1808,    -1,    -1,   191,   192,
    1813,  1814,    -1,    -1,  1817,   172,    -1,    -1,   175,    -1,
      -1,    -1,   205,    -1,  1827,    -1,   416,   417,   418,   419,
     420,   421,  1835,    -1,    -1,    -1,    -1,    -1,   326,  1842,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1851,    -1,
      -1,    -1,    -1,    -1,   237,  1858,    -1,   240,     8,   129,
     217,    11,   219,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     253,  1874,   229,   256,    -1,    -1,    -1,    -1,  1881,  1882,
    1883,  1884,  1885,  1886,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    41,    -1,  1896,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,    -1,    -1,   263,   264,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1918,    -1,    -1,    -1,  1922,
      -1,   191,   192,  1926,   412,   413,   414,    -1,   416,   417,
     418,   419,   420,   421,    -1,   205,   293,    -1,   426,    -1,
     297,   298,    -1,   326,    -1,    -1,    -1,  1950,    -1,    -1,
      -1,    -1,    -1,  1956,  1957,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1966,    -1,   322,    -1,    -1,  1971,  1972,
     240,    -1,    -1,  1976,  1977,   332,     8,    -1,  1981,    11,
      -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,    -1,    -1,
    1993,  1994,  1995,  1996,    -1,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,  2010,    -1,    41,
      -1,    -1,  2015,    -1,    -1,    -1,   166,    -1,    -1,    -1,
     170,    -1,    -1,    -1,  2027,    -1,    -1,    -1,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,    -1,
    2043,   191,   192,   426,    -1,    -1,    -1,  2050,    31,    -1,
      -1,    -1,    -1,    -1,    -1,   205,   326,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    49,    -1,  2071,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2081,  2082,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,    80,    -1,    -1,
      -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,  2111,  2112,
      -1,    -1,    -1,  2116,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2128,  2129,  2130,  2131,    -1,
      -1,    -1,    -1,    -1,   166,    -1,    -1,  2140,   170,    -1,
    2143,    -1,  2145,  2146,    -1,    -1,   416,   417,   418,   419,
     420,   421,  2155,  2156,   137,  2158,    -1,    -1,    -1,   191,
     192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2171,    -1,
    2173,    -1,  2175,   205,  2177,    -1,   326,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   168,    -1,    -1,    -1,    -1,
    2193,    -1,    -1,    -1,  2197,     8,    -1,    -1,    11,    -1,
    2203,    -1,  2205,  2206,  2207,   237,    -1,    -1,   240,    -1,
      -1,    -1,    -1,   196,    -1,    28,  2219,    -1,    -1,  2222,
      -1,   253,    -1,    36,   256,  2228,    -1,  2230,    41,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2239,    -1,    -1,    -1,
      -1,  2244,    -1,    -1,    -1,  2248,    -1,    -1,  2251,    -1,
      -1,    -1,    -1,    -1,     8,    -1,  2259,    11,    -1,    -1,
      -1,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,    -1,  2276,    -1,  2278,    -1,    -1,    -1,  2282,
      -1,    -1,    36,    -1,    -1,    -1,     7,    41,    -1,    -1,
      -1,    -1,    13,    14,   326,    -1,    -1,    -1,    -1,    20,
      -1,    22,    -1,    -1,    -1,    -1,    -1,    28,    -1,    30,
      -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,   301,    -1,
      -1,    -1,    -1,    -1,   307,    -1,    -1,    48,    -1,    -1,
      -1,   314,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   322,
      -1,  2344,    -1,    -1,    -1,    -1,    -1,   330,  2351,    -1,
      -1,    -1,    -1,   166,    -1,   338,    -1,   170,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   129,    -1,    -1,   191,   192,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
      -1,    -1,   205,    -1,   426,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   387,    -1,    -1,    -1,   391,    -1,
    2413,    -1,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,
    2423,  2424,    -1,    -1,   237,    -1,    -1,   240,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,
     253,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,    -1,
      21,   205,    -1,    -1,    -1,    -1,    -1,   178,    -1,   180,
      -1,   182,    33,   184,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    53,    -1,    -1,    -1,   240,    -1,    -1,    -1,
      -1,  2494,  2495,    -1,    -1,    -1,    -1,    28,    -1,   253,
      -1,    -1,  2505,    74,    -1,    36,    -1,    78,    -1,    -1,
      41,    -1,    -1,   326,    -1,    -1,    -1,  2520,    -1,    -1,
      -1,    -1,    -1,  2526,    -1,    -1,    -1,    98,    -1,    -1,
      -1,    -1,    -1,   104,  2537,    -1,    -1,  2540,    -1,    -1,
    2543,    -1,    -1,    -1,  2547,    -1,    -1,    -1,   119,    -1,
    2553,    -1,    -1,  2556,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2571,    -1,
      -1,  2574,   326,    -1,  2577,    -1,   147,    -1,  2581,    -1,
      -1,    -1,    -1,   154,    -1,    -1,  2589,   158,    -1,  2592,
      -1,    -1,    -1,    -1,    -1,    -1,  2599,    -1,    -1,   412,
     413,   414,   173,   416,   417,   418,   419,   420,   421,  2612,
      -1,  2614,    -1,   426,    -1,    -1,    -1,    -1,    -1,  2622,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2631,    -1,
      -1,    -1,    -1,    -1,  2637,   166,  2639,    -1,   209,   170,
      -1,    -1,  2645,    -1,    -1,  2648,  2649,  2650,  2651,  2652,
    2653,  2654,  2655,  2656,  2657,    -1,    -1,    -1,  2661,  2662,
     191,   192,   416,   417,   418,   419,   420,   421,    -1,    -1,
      -1,  2674,    -1,    -1,   205,    -1,    -1,  2680,    -1,    -1,
      -1,    -1,   253,    -1,    -1,   256,    -1,  2690,    -1,    -1,
    2693,    -1,  2695,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2704,  2705,  2706,    -1,    -1,   237,  2710,    -1,   240,
    2713,    -1,    -1,    -1,    -1,    -1,    -1,  2720,  2721,    -1,
    2723,    -1,   253,    -1,    -1,   256,  2729,    -1,  2731,    -1,
    2733,    -1,    -1,   304,    -1,    -1,    -1,    -1,  2741,   310,
      -1,    -1,    -1,    -1,    -1,   316,    -1,    -1,   319,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2772,
    2773,  2774,    -1,    -1,   345,  2778,   347,   348,    -1,   350,
     351,    -1,   503,    -1,    -1,    -1,    -1,    -1,   359,    -1,
      -1,    -1,    -1,   364,  2797,   326,   517,   518,   369,    -1,
      -1,   522,    -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,
     531,    -1,    -1,    -1,    -1,   386,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   545,    -1,    -1,    -1,    -1,    -1,
      -1,     8,    -1,  2836,    11,  2838,   557,    -1,    -1,   560,
      -1,   562,    -1,   564,    -1,    -1,     8,    -1,    -1,    11,
      -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,  2864,    -1,    -1,    41,    -1,    28,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,   599,    41,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,    -1,    -1,    -1,    -1,   426,    -1,    -1,  2901,    -1,
      -1,   622,    -1,   624,    -1,    -1,    -1,    -1,    -1,    -1,
    2913,    -1,    -1,    -1,    -1,    -1,  2919,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2936,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2945,    -1,    -1,    -1,    -1,    -1,  2951,    -1,
      -1,    -1,  2955,    -1,  2957,    -1,   677,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2968,  2969,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2986,    -1,    -1,    -1,  2990,    -1,   166,
      -1,    -1,  2995,   170,    -1,  2998,  2999,    -1,  3001,    -1,
      -1,    -1,    -1,    -1,   166,  3008,    -1,  3010,   170,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3027,    -1,    -1,    -1,   205,   191,
     192,     8,    -1,    -1,    11,    -1,    -1,  3040,    -1,    -1,
      -1,    -1,    -1,   205,   765,    -1,    -1,    -1,    -1,    -1,
      -1,    28,    -1,    -1,    -1,    -1,   777,    -1,    -1,    36,
     237,    -1,    -1,   240,    41,   786,    -1,    -1,    -1,    -1,
      -1,   792,    -1,  3076,    -1,   237,   253,    -1,   240,   256,
    3083,  3084,   803,    -1,    -1,    -1,    -1,    -1,  3091,  3092,
      -1,   253,    -1,  3096,   256,    -1,    -1,    -1,    -1,  3102,
    3103,    -1,    -1,  3106,    -1,  3108,  3109,  3110,  3111,    -1,
      -1,   832,     8,    -1,  3117,    11,    -1,    -1,    -1,    -1,
    3123,    -1,    -1,    -1,    -1,    -1,  3129,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3137,    -1,    -1,    -1,    -1,    -1,
      36,    -1,    -1,  3146,    -1,    41,  3149,    -1,    -1,   326,
    3153,  3154,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,  3168,    -1,    -1,    -1,    -1,
      -1,    -1,   893,  3176,   895,    -1,   897,    -1,   899,    -1,
     901,   902,   903,    -1,  3187,    -1,    -1,   908,    -1,   166,
      -1,    -1,    -1,   170,    -1,    -1,    -1,  3200,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3227,    -1,    -1,    -1,   205,    -1,
      -1,  3234,    -1,   129,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,    -1,    -1,    -1,    -1,   426,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
     237,    -1,   424,   240,  3267,    -1,    -1,    -1,    -1,    -1,
     166,    -1,    -1,    -1,   170,    -1,   253,    -1,    -1,   256,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,
      -1,    -1,    -1,    -1,    -1,  3318,    -1,    -1,    -1,    -1,
      -1,  3324,    -1,    -1,    -1,  3328,    -1,    -1,  3331,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   240,    -1,    -1,  3350,    -1,   326,
      -1,    -1,  3355,    28,   165,    -1,    -1,   253,    -1,    -1,
     171,    36,    -1,    -1,    -1,  1086,    41,    -1,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,  3379,  3380,    -1,    -1,
    3383,    -1,    -1,    -1,    -1,    -1,    -1,  3390,  3391,    -1,
      -1,    28,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    36,
      -1,  3404,    -1,  3406,    41,    -1,    -1,  3410,  3411,  3412,
      -1,  1132,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3430,  3431,    -1,
     326,    -1,    -1,    -1,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,    -1,    -1,    -1,    -1,   426,
      -1,    -1,  3455,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3466,    -1,    -1,  3469,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,  3481,    -1,
    3483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3492,
      -1,   166,    -1,    -1,  3497,   170,    -1,    36,    -1,    -1,
      -1,    -1,    41,  3506,  3507,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
     416,   417,   418,   419,   420,   421,    -1,    -1,    -1,   166,
     205,  3534,    -1,   170,  3537,    -1,  3539,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3552,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,
      -1,  3564,   237,    -1,    -1,   240,    -1,    -1,   205,  3572,
      -1,    -1,  3575,    -1,    -1,  1296,    -1,    -1,   253,    -1,
      -1,   256,  3585,  3586,  3587,  3588,    -1,  1308,    -1,    -1,
     129,  3594,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     237,    -1,    -1,   240,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3615,    -1,    -1,    -1,   253,    -1,    -1,   256,
      -1,    -1,    -1,    -1,    -1,  1346,    -1,   166,    -1,  1350,
      -1,   170,    -1,    -1,    -1,    -1,    -1,    -1,  1359,    -1,
    1361,    -1,  1363,    -1,    -1,    -1,    -1,  1368,    -1,    -1,
      -1,   326,   191,   192,    -1,  3658,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3666,    -1,    -1,   205,    -1,    -1,    -1,
    1391,    -1,  1393,    -1,  1395,    -1,  1397,     8,  1399,    -1,
      11,    -1,  1403,    -1,    -1,    -1,    -1,    -1,    -1,   326,
      -1,   502,    -1,    -1,    -1,    -1,  3699,    28,    -1,  3702,
      -1,   240,    -1,    -1,    -1,    36,  3709,    -1,    -1,    -1,
      41,    -1,    -1,    -1,   253,  3718,    -1,    -1,  3721,  3722,
      -1,  3724,    -1,    -1,    -1,    -1,    -1,    -1,  3731,    -1,
      -1,    -1,  3735,   544,    -1,    -1,    -1,   412,   413,   414,
     551,   416,   417,   418,   419,   420,   421,    -1,    -1,    -1,
      -1,   426,    -1,    -1,  3757,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3767,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   412,   413,   414,  3781,   416,
     417,   418,   419,   420,   421,    -1,    -1,   326,    -1,   426,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,  3821,    -1,
      -1,    -1,    -1,  3826,    -1,    36,    -1,  3830,    -1,    -1,
      41,  3834,    -1,   644,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     191,   192,    -1,    -1,   675,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,   416,   417,   418,
     419,   420,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   237,    -1,    -1,   240,
      -1,    -1,    -1,    -1,    -1,     8,    -1,    -1,    11,    -1,
      -1,    -1,   253,    -1,    -1,   256,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    36,    -1,    -1,     8,    -1,    41,    11,
      -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,    -1,   170,
      -1,    -1,    -1,   774,    -1,    -1,    28,    -1,    -1,    -1,
     781,    -1,    -1,    -1,    36,    -1,    -1,    -1,    -1,    41,
     191,   192,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   802,    -1,    -1,   205,   326,    -1,    -1,    -1,  1720,
      -1,    -1,    -1,   644,  1725,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1735,    -1,    -1,    -1,    -1,   112,
     831,  1742,    -1,    -1,    -1,    -1,   237,  1748,    -1,   240,
      -1,    -1,    -1,  1754,   675,    -1,    -1,    -1,  1759,    -1,
      -1,    -1,   253,    -1,    -1,   256,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1785,  1786,  1787,  1788,   879,    -1,
      -1,  1792,  1793,   166,    -1,    -1,  1797,   170,    -1,  1800,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,    -1,    -1,    -1,    -1,   426,    -1,  1818,   191,   192,
      -1,    -1,    -1,    -1,   166,    -1,    -1,  1828,   170,  1830,
      -1,    -1,   205,    -1,   925,   326,    -1,    -1,  1839,  1840,
    1841,    -1,  1843,    -1,    -1,    -1,    -1,    -1,    -1,   191,
     192,  1852,  1853,    -1,    -1,    -1,    -1,    -1,    -1,  1860,
    1861,   952,    -1,   205,   237,    -1,    -1,   240,    -1,    -1,
      -1,     8,    -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,
     253,    -1,    -1,   256,    -1,    -1,    -1,    -1,    -1,   980,
      -1,    28,    -1,    -1,    -1,   237,    -1,    -1,   240,    36,
      -1,    -1,    -1,    -1,    41,    -1,    -1,    -1,    -1,    -1,
      -1,   253,    -1,    -1,   256,    -1,  1007,  1008,    -1,  1010,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,    -1,   274,    -1,    -1,   426,  1027,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    31,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,  1065,  1066,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   326,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   339,    -1,    -1,
      -1,    -1,   375,    -1,    -1,    -1,  1097,   144,    -1,    -1,
    1101,  1102,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1112,    -1,    -1,    -1,    -1,  1117,    -1,    -1,   166,
      -1,   952,    -1,   170,    -1,    -1,    -1,    -1,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,    -1,
      -1,    -1,    -1,    -1,   191,   192,    -1,    -1,  1149,   980,
      -1,    -1,    -1,    -1,    -1,    -1,  2067,    -1,   205,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
      -1,    -1,    -1,    -1,  1175,    -1,  1007,  1008,    -1,  1010,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
     237,   170,    -1,   240,    -1,    -1,  1027,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,   256,
      -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   272,   205,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1065,  1236,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1253,    -1,    -1,    -1,    -1,    -1,   237,    -1,
      -1,   240,    -1,    -1,    -1,    -1,  1097,    -1,    -1,    -1,
    1101,  1102,  1273,    -1,   253,    -1,    -1,   256,    -1,   326,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1295,    -1,    -1,    -1,    -1,  1300,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,  1336,    -1,  1338,    -1,    -1,
      -1,    -1,    -1,  1344,    -1,    -1,  1347,   326,    28,  2260,
    2261,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,    -1,
      -1,    41,    -1,    -1,    -1,   412,   413,   414,    -1,   416,
     417,   418,   419,   420,   421,    -1,    -1,    -1,    -1,    -1,
    2291,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1413,    -1,  2325,  2326,  2327,  2328,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   802,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,    -1,    -1,    -1,    -1,  1448,    -1,  1450,
      -1,    -1,    -1,    -1,    -1,    -1,  1457,    -1,    -1,  1460,
      -1,    -1,  1463,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1471,  1472,    -1,    -1,    -1,    -1,    -1,    -1,  1479,    -1,
      -1,  1482,  1483,  1484,  1485,    -1,   166,    -1,    -1,    -1,
     170,  1492,  1493,    -1,  1495,    -1,  1497,    -1,  2409,  1500,
      -1,    -1,    -1,  2414,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   191,   192,    -1,    -1,  1516,  1517,  1518,    -1,    -1,
    1521,    -1,    -1,    -1,  1525,   205,    -1,    -1,  1529,    -1,
    1531,  1532,  1533,  1534,  1535,  1536,  1537,  1538,  1539,    -1,
    1541,    -1,    -1,    -1,    -1,  1546,    -1,  1548,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   925,    -1,   237,    -1,    -1,
     240,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   253,    -1,    -1,   256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   269,
    2501,  2502,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,
      -1,    -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    28,
      -1,    -1,    31,    -1,    -1,    -1,  1457,    36,    -1,    -1,
       8,    -1,    41,    11,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,  1479,    -1,
      28,  1482,  2563,    -1,  1485,    -1,    -1,    -1,    36,    -1,
      -1,  1492,  1493,    41,    -1,  2576,  1497,    -1,    -1,  1500,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1680,
      -1,    -1,    -1,    -1,    -1,    -1,  1517,    -1,    -1,    -1,
    1521,    -1,    -1,    -1,  1525,    -1,    -1,    -1,  1529,    -1,
    1531,  1532,  1533,  1534,  1535,  1536,  1537,  1538,  1539,    -1,
    1541,    -1,    -1,    -1,    -1,  1546,    -1,  1548,    -1,    -1,
      -1,  1722,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,  1112,    -1,    -1,  1746,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   166,    -1,    -1,
      -1,   170,    -1,    -1,    -1,  1766,    -1,    -1,    -1,    -1,
    1771,  1772,   150,    -1,    -1,    -1,    -1,    -1,    -1,  1149,
      -1,  1782,   191,   192,    -1,    -1,    -1,    -1,   166,   802,
      -1,    -1,   170,    -1,    -1,    -1,   205,  1798,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1175,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   191,   192,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   205,   237,    -1,
      -1,   240,    -1,  1834,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   253,    -1,    -1,   256,    -1,  1680,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   237,
      -1,    -1,   240,    -1,    -1,    -1,  1236,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   253,    -1,    -1,   256,    -1,
      -1,    -1,    -1,  1253,  2795,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1896,    -1,  1898,    -1,    -1,
      -1,    -1,    -1,  1273,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   925,    -1,    -1,  1746,    -1,   326,    -1,    -1,
      -1,  2832,    -1,    -1,    -1,  1295,  2837,    -1,  2839,  2840,
    2841,  2842,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1963,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1971,    -1,    -1,    -1,  1344,    -1,    -1,    -1,    -1,    -1,
    1981,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    21,    -1,  2908,  2909,  2910,
      -1,  2912,    -1,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,    -1,  2015,    -1,    -1,     8,    -1,    -1,
      11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   412,   413,   414,    28,   416,   417,
     418,   419,   420,   421,    -1,    36,    -1,    -1,    -1,  2050,
      41,    -1,    78,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2061,    -1,    -1,    -1,    -1,  1896,    -1,    -1,    -1,    -1,
      -1,    -1,    98,  2984,    -1,    -1,    -1,    -1,   104,    -1,
    2081,  2082,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3003,   119,    -1,    -1,    -1,   802,    -1,  1112,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2111,  2112,    -1,    -1,    -1,  2116,    -1,    -1,    -1,    -1,
      -1,   147,    -1,    -1,    -1,    -1,   152,  2128,  2129,  2130,
    2131,    -1,   158,    -1,    -1,  2136,  1149,    -1,    -1,  2140,
    2141,    -1,  2143,    -1,  2145,    -1,  1516,   173,    -1,    -1,
    1981,    -1,    -1,    -1,  2155,  2156,    -1,  2158,    -1,    -1,
      -1,    -1,  1175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2171,   197,  2173,    -1,    -1,   166,  2177,    -1,  1548,   170,
      -1,    -1,    -1,    -1,  2015,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2193,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     191,   192,  2203,    -1,  2205,  2206,  2207,   802,    -1,    -1,
      -1,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,  2050,
     925,  2222,    -1,  1236,    -1,    -1,    -1,   253,    -1,  2230,
      -1,    -1,    -1,    -1,    -1,   802,    -1,    -1,  2239,    -1,
    1253,    -1,    -1,  2244,    -1,    -1,   237,    -1,    -1,   240,
    2251,  2082,    -1,    -1,   280,    -1,    -1,    -1,    -1,    -1,
    1273,    -1,   253,    -1,    -1,   256,  3177,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2276,    -1,  3188,   304,    -1,
      -1,    -1,  1295,    -1,   310,    -1,    -1,    -1,    -1,    -1,
     316,    -1,    -1,   319,    -1,    -1,    -1,  2128,    -1,  2130,
    2131,    -1,    -1,  2304,  2305,    -1,  2307,    -1,    -1,  2140,
      -1,    -1,  2143,    -1,  2145,    -1,    -1,    -1,    -1,   345,
      -1,   347,    -1,    -1,    -1,   351,    -1,    -1,    -1,    -1,
     925,  1344,    -1,   359,    -1,   326,    -1,    -1,   364,    -1,
    2171,    -1,  2173,    -1,    -1,    -1,  2177,  2348,   374,  2350,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   925,    -1,
     386,   352,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3283,    -1,  2205,  2206,  2207,    -1,    -1,    -1,
    2381,  2382,  2383,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2222,    -1,    -1,  3305,    -1,  1766,    -1,    -1,  2230,
      -1,  1771,  1772,    -1,    -1,    -1,    -1,  1112,  2239,    -1,
      -1,    -1,  1782,  2244,    -1,    -1,    -1,    -1,  2419,    -1,
    2251,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,  3342,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2441,    -1,    -1,  2444,  1149,  2276,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1175,    -1,    -1,    -1,    -1,    -1,    -1,   802,    -1,    -1,
      -1,  2482,  2483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2500,
      -1,    -1,    -1,  1516,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2514,    -1,    -1,    -1,  1112,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2527,    -1,  1898,    -1,
      -1,  1236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2543,    -1,    -1,  1112,  2547,    -1,  1253,    -1,
      -1,    -1,    -1,    -1,  1149,  2556,    -1,    -1,    -1,    -1,
      -1,  2562,    -1,    -1,    -1,    -1,    -1,    -1,  1273,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1175,    -1,  1149,    -1,    -1,    -1,    -1,    -1,  2589,    -1,
    1295,    -1,    -1,  1963,    -1,    -1,    -1,    -1,    -1,    -1,
     925,    -1,    -1,    -1,  3515,    -1,    -1,    -1,  1175,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2622,    -1,    -1,  2625,    -1,    -1,    -1,    -1,    -1,
    2631,    -1,    -1,    -1,    -1,    -1,  2637,    -1,  2639,  1344,
      -1,  1236,    -1,  2644,  2645,    -1,    -1,  2648,  2649,  2650,
    2651,  2652,  2653,  2654,  2655,  2656,  2657,    -1,  1253,    -1,
    2661,  2662,    -1,    -1,    -1,    -1,    -1,    -1,  2669,  1236,
      -1,    -1,    -1,  2674,    -1,    -1,    -1,  2678,  1273,  2680,
      -1,    -1,    -1,    -1,    -1,    -1,  1253,    -1,    -1,  2690,
      -1,  2061,  2693,    -1,  2695,    -1,    -1,    -1,    -1,    -1,
    1295,    -1,  2703,  2704,  2705,  2706,  1273,    -1,    -1,  2710,
      -1,    -1,  2713,     8,    -1,    -1,    11,    -1,    -1,    -1,
      -1,    -1,  2723,    -1,    -1,  2556,    -1,    -1,  1295,    -1,
    2731,    -1,  2733,    28,    -1,    -1,    31,    -1,    -1,    -1,
      -1,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,  1344,
      -1,    -1,    -1,  1766,    -1,    -1,    -1,    -1,  1771,  1772,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1782,
      -1,  2772,    -1,    -1,    -1,    -1,    -1,  1344,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3697,  1112,    -1,    -1,
      -1,  2622,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2631,    -1,    -1,  2804,  2805,  2806,  2637,    -1,  2639,    -1,
      -1,  1516,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,     8,  1149,    -1,    11,    -1,  2829,    -1,
    2661,  2662,    -1,    -1,    -1,  2205,  2206,  2207,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    31,    -1,    -1,  2680,
    1175,    36,    -1,    -1,    -1,    -1,    41,    -1,    -1,  2690,
      -1,    -1,  2693,    -1,  2695,    -1,    -1,    -1,    -1,    -1,
      -1,   166,    -1,  2704,    -1,   170,    -1,    -1,    -1,  2710,
      -1,    -1,  2713,    -1,    -1,  1898,    -1,    -1,    -1,    -1,
      -1,    -1,  2723,    -1,    -1,    -1,   191,   192,    -1,    -1,
    2731,    -1,  2733,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     205,  1236,  2913,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1516,    -1,    -1,    -1,    -1,    -1,    -1,  1253,    -1,
    2931,    -1,    -1,    -1,  2304,  2305,    -1,  2307,    -1,    -1,
      -1,    -1,   237,    -1,    -1,   240,    -1,    -1,  1273,  1516,
    1963,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   253,    -1,
      -1,   256,    -1,    -1,    -1,    -1,  2967,  2968,  2969,    -1,
    1295,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2348,    -1,
    2350,   166,    -1,    -1,    -1,   170,    -1,    -1,    -1,  2990,
      -1,    -1,    -1,    -1,  2995,    -1,    -1,  2998,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   191,   192,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1344,
     205,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   326,    -1,    -1,    -1,    -1,    -1,    -1,   802,  3040,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2061,  2419,
      -1,    -1,   237,    -1,    -1,   240,    -1,    -1,    -1,    -1,
      -1,  1766,    -1,    -1,    -1,    -1,  1771,  1772,   253,    -1,
      -1,   256,    -1,    -1,  2444,  3076,    -1,  1782,    -1,    -1,
      -1,    -1,  3083,  3084,    -1,  3086,    -1,    -1,    -1,    -1,
    3091,  3092,    -1,    -1,    -1,  3096,  3097,    -1,    -1,    -1,
      -1,  3102,  3103,    -1,    -1,  3106,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  2483,    -1,    -1,  3117,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,    -1,  3129,    -1,
    2500,    -1,    -1,    -1,    -1,    -1,    -1,  2968,  2969,    -1,
      -1,   326,    -1,    -1,  2514,    -1,    -1,    -1,  3149,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2527,    -1,    -1,
      -1,   925,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3170,
      -1,  1766,    -1,    -1,    -1,    -1,  1771,  1772,    -1,  3180,
      -1,    -1,    -1,    -1,    -1,    -1,  2556,  1782,    -1,    -1,
      -1,  1516,  2562,  1898,    -1,    -1,    -1,    -1,    -1,  1766,
      -1,    -1,    -1,    -1,  1771,  1772,    -1,    -1,    -1,  3040,
      -1,    -1,    -1,    -1,    -1,  1782,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3225,    -1,    -1,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3083,  3084,    -1,  2625,    -1,    -1,  1963,    -1,
      -1,    -1,    -1,    -1,    -1,  3096,  3267,    -1,    21,    -1,
      -1,  3102,  3103,    -1,  2644,  3106,  3277,    -1,    -1,    -1,
      33,    -1,    -1,    -1,    -1,    -1,  3117,    -1,    -1,    -1,
      -1,  2304,  2305,    -1,  2307,    -1,    -1,    -1,  3129,  2669,
      53,    -1,    -1,  1898,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3315,    -1,    -1,    -1,  3149,    -1,
      -1,    -1,    -1,  3324,    -1,    78,    -1,  3328,    -1,    -1,
      -1,  1898,  3333,  2703,    -1,  2348,    -1,  2350,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    98,    -1,    -1,  1112,    -1,
      -1,    -1,    -1,    -1,  3355,    -1,  2061,    -1,  3359,    -1,
      -1,    -1,    -1,  2733,    -1,    -1,   119,    -1,  1963,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3379,  3380,
      -1,    -1,  3383,    -1,    -1,  1149,    -1,    -1,    -1,  3390,
    3391,    -1,    -1,    -1,   147,    -1,  1963,    -1,    -1,   152,
      -1,    -1,    -1,    -1,    -1,   158,  2419,    -1,    -1,  3410,
      -1,  1175,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     173,    -1,    -1,    -1,    -1,    -1,  3427,    -1,    -1,  3430,
      -1,  2444,    -1,    -1,    -1,  2805,  3267,    -1,    -1,    -1,
      -1,  1766,    -1,    -1,    -1,    -1,  1771,  1772,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1782,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3466,  2061,    -1,    -1,    -1,
    2483,    -1,  1236,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2500,    -1,  1253,
      -1,    -1,    -1,  3324,  2061,    -1,    -1,    -1,    -1,    -1,
     253,  2514,    -1,    -1,    -1,    -1,  3507,    -1,  3509,  1273,
     263,    -1,    -1,    -1,  2527,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   280,    -1,    -1,
      -1,  1295,    -1,  3534,  3535,    -1,  3537,    -1,  3539,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2562,
      -1,   304,  3383,    -1,    -1,   308,    -1,   310,    -1,    -1,
    3391,  2931,    -1,   316,    -1,    -1,   319,    -1,    -1,    -1,
      -1,    -1,    -1,  1898,  3575,    -1,    -1,  3578,    -1,    -1,
    1344,  3582,  3583,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   345,    -1,   347,    -1,    -1,  2967,   351,  2304,
    2305,    -1,  2307,    -1,    -1,    -1,   359,  3608,    -1,    -1,
      -1,   364,  2625,    -1,  3615,    -1,    -1,    -1,    -1,    -1,
      -1,   374,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  2644,    -1,   386,    -1,    -1,    -1,    -1,  1963,  3640,
      -1,    -1,    -1,  2348,    -1,  2350,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2669,  3658,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2703,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3702,    -1,    -1,    -1,    -1,  3537,    -1,  3709,  2304,
    2305,    -1,  2307,    -1,  2419,    -1,  3086,    -1,    -1,    -1,
    3721,  3722,    -1,    -1,    -1,    -1,    -1,  3097,    -1,    -1,
    3731,    -1,    -1,    -1,    -1,    -1,  2061,  2304,  2305,  2444,
    2307,    -1,    -1,    -1,  3575,    -1,    -1,  3117,    -1,    -1,
      -1,    -1,  1516,  2348,    -1,  2350,  3757,    -1,    -1,  3129,
      -1,    -1,    -1,    -1,    -1,    -1,  3767,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2483,    -1,
      -1,  2348,    -1,  2350,  3615,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2805,    -1,    -1,  2500,    -1,    -1,    -1,    -1,
    3170,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2514,
    3180,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3821,    -1,  2527,    -1,  2419,    -1,    -1,    -1,    -1,  3830,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     8,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2444,
      -1,    -1,  2419,    -1,    -1,    -1,    -1,  2562,    28,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,     8,
      -1,    41,    11,    -1,    -1,    -1,    -1,  2444,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2483,    28,
    3721,  3722,    -1,    -1,    -1,    -1,    -1,    36,    -1,    -1,
      -1,    -1,    41,    -1,    -1,  2500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2483,    -1,  2931,  2514,
    2625,    -1,    -1,    -1,    -1,    -1,  3757,    -1,    -1,    -1,
      -1,    -1,  2527,  2500,    -1,    -1,  3767,    -1,    -1,  2644,
      -1,    -1,    -1,    -1,    -1,  3315,    -1,  2514,    -1,    -1,
      -1,    -1,    -1,    -1,  2967,    -1,    -1,    -1,  1023,    -1,
    2527,    -1,    -1,  3333,  2669,    -1,    -1,  2562,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2304,
    2305,    -1,  2307,    -1,    -1,    -1,    -1,    -1,    -1,  3359,
    3821,    -1,    -1,    -1,    -1,  2562,   166,    -1,  2703,    -1,
     170,    -1,  1766,    -1,    -1,    -1,    -1,  1771,  1772,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1082,  1782,    -1,
      -1,   191,   192,  2348,    -1,  2350,    -1,   166,    -1,    -1,
    2625,   170,    -1,    -1,    -1,   205,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2644,
      -1,    -1,   191,   192,    -1,    -1,    -1,  3427,  2625,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   205,   237,    -1,    -1,
     240,    -1,    -1,  3086,  2669,    -1,    -1,  2644,    -1,    -1,
      -1,    -1,    -1,   253,  3097,    -1,   256,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2419,    -1,    -1,    -1,   237,    -1,
    2805,   240,  2669,    -1,    -1,    -1,    -1,    -1,  2703,    -1,
      -1,    -1,    -1,    -1,   253,    -1,    -1,    -1,    -1,  2444,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1898,    -1,  2703,    -1,    -1,  3509,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   326,  3170,  2483,    -1,
      -1,    -1,    -1,    -1,    -1,  3535,    -1,  3180,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2500,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   326,    -1,  2514,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1963,
      -1,    -1,  2527,    -1,    -1,    -1,    -1,    -1,  3578,    -1,
    2805,    -1,  3582,  3583,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2931,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2562,  2805,    -1,
      -1,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3640,    -1,    -1,   412,   413,   414,    -1,   416,   417,   418,
     419,   420,   421,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2061,    -1,    -1,
    2625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1378,    -1,    -1,    -1,    -1,    -1,  2644,
    3333,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2931,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2669,    -1,  3359,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2931,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,  2703,    -1,
      -1,  3086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1455,    -1,  3097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  1478,  3427,    -1,    -1,    -1,  1483,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  1502,  1503,    -1,
    1505,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3180,    -1,    -1,    -1,  1544,
    2805,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3086,    -1,    -1,    -1,    -1,  3509,    -1,    -1,    -1,
      -1,    -1,  3097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1579,    -1,    -1,    -1,    -1,  3086,
      -1,    -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2304,  2305,    -1,  2307,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3578,    -1,    -1,    -1,  3582,
    3583,    -1,    -1,    -1,    -1,  3170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2348,  3180,  2350,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3170,    -1,    -1,  2931,    -1,    -1,    -1,
      -1,    -1,    -1,  3180,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1689,    -1,    -1,    -1,  3333,    -1,
      -1,    -1,    -1,    -1,  1699,    -1,    -1,  1702,    -1,    -1,
      -1,    -1,  2967,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3359,  2419,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2444,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2483,
      -1,    -1,  3427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2500,    -1,  3333,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2514,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3086,    -1,  2527,  3359,    -1,  3333,    -1,    -1,    -1,
      -1,    -1,  3097,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,  2562,    -1,
      -1,    -1,    -1,    -1,  3509,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    3535,    -1,  3427,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3170,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3180,    -1,    -1,    -1,    -1,
    3427,  2625,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    14,    -1,  3578,    -1,    -1,    -1,  3582,  3583,    -1,
    2644,    24,    -1,    26,    27,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    40,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2669,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3509,    -1,    -1,    60,    -1,    62,
      63,    -1,    -1,    -1,    67,    -1,    69,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    79,    -1,    81,  2703,
    3535,    -1,  3509,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,
     103,    -1,    -1,    -1,    -1,    -1,   109,    -1,  3535,    -1,
      -1,    -1,   115,    -1,   117,    -1,    -1,    -1,   121,    -1,
      -1,    -1,    -1,  3578,   127,    -1,    -1,  3582,  3583,    -1,
      -1,   134,    -1,   136,    -1,    -1,    -1,    -1,   141,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3333,    -1,
      -1,  3578,   155,    -1,    -1,  3582,  3583,    -1,    -1,    -1,
    2085,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3359,    -1,    -1,    -1,    -1,    -1,
     183,  2805,  2107,    -1,  2109,    -1,  2111,  2112,  2113,    -1,
      -1,  2116,    -1,    -1,    -1,  2120,    -1,    -1,    -1,    -1,
      -1,    -1,  2127,    -1,   207,   208,    -1,  2132,    -1,    -1,
     213,    -1,  2137,    -1,    -1,    -1,    -1,  2142,    -1,   222,
      -1,    -1,    -1,    -1,    -1,    -1,  2151,    -1,    -1,    -1,
    2155,  2156,  2157,    -1,    -1,    -1,   239,    -1,    -1,    -1,
      -1,    -1,  3427,    -1,  2169,    -1,    -1,    -1,    -1,    -1,
      -1,  2176,    -1,  2178,  2179,  2180,  2181,  2182,  2183,  2184,
    2185,  2186,  2187,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   275,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   286,    -1,    -1,  2211,   290,    -1,   292,
      -1,    -1,    -1,    -1,   297,    -1,    -1,    -1,    -1,   302,
      -1,    -1,   305,    -1,    -1,    -1,   309,  2931,    -1,    -1,
      -1,    -1,   315,    -1,    -1,    -1,    -1,    -1,    -1,   322,
      -1,    -1,   325,    -1,  3509,    -1,    -1,    -1,    -1,   332,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   345,  2967,    -1,    -1,    -1,    -1,    -1,    -1,
    3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   362,
      -1,  2286,    -1,    -1,    -1,    -1,    -1,    -1,   371,    -1,
     373,    -1,    -1,   376,    -1,    -1,    -1,   380,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   392,
      -1,    -1,    -1,  3578,    -1,    -1,    -1,  3582,  3583,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3086,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3097,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  2447,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3170,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3180,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2559,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  2580,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2621,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3333,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  2642,  2643,    -1,
    2645,    -1,    -1,  2648,  2649,  2650,  2651,  2652,  2653,  2654,
    2655,  2656,  2657,  2658,    -1,  3359,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  2681,    -1,    -1,  2684,
      -1,  2686,    -1,    -1,    -1,    -1,  2691,  2692,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    2705,  2706,  2707,    -1,  2709,    -1,    -1,  2712,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3427,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2739,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2753,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  2769,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3509,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3535,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3578,    -1,    -1,    -1,  3582,  3583,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  2913,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3041,    -1,    -1,  3044,
    3045,  3046,    -1,    -1,  3049,    -1,    -1,    -1,    -1,  3054,
    3055,  3056,  3057,  3058,  3059,  3060,  3061,  3062,  3063,  3064,
    3065,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  3090,  3091,  3092,  3093,    -1,
    3095,    -1,    -1,    -1,  3099,  3100,  3101,    -1,    -1,  3104,
      -1,    -1,  3107,    -1,    -1,    -1,    -1,    -1,    -1,  3114,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  3126,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3269,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3312,  3313,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  3351,    -1,    -1,    -1,
    3355,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3367,    -1,  3369,    -1,    -1,    -1,    -1,  3374,
    3375,  3376,    -1,    -1,  3379,  3380,  3381,  3382,    -1,  3384,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,  3408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,  3472,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  3519,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  3533,  3534,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  3547,  3548,  3549,    -1,  3551,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,  3648,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,  3672,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,  3701,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,  3760,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,  3800,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,   375,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   423,    -1,    -1,    -1,   427,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,   116,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,    -1,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,   382,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,
     417,   418,    -1,    -1,    -1,    -1,    -1,    -1,   425,   426,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,    -1,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,    -1,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,   417,     3,    -1,    -1,    -1,    -1,
      -1,    -1,   425,   426,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   426,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    -1,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    -1,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
      -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,    -1,   203,   204,
     205,    -1,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
      -1,   236,    -1,   238,   239,   240,   241,    -1,    -1,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,    -1,   263,   264,
     265,   266,   267,   268,    -1,   270,    -1,   272,    -1,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,    -1,   307,   308,   309,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,    -1,   341,    -1,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
      -1,    -1,   357,    -1,   359,    -1,    -1,   362,   363,   364,
     365,   366,   367,    -1,    -1,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,    -1,   381,   382,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   406,   407,   408,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,   426,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,    -1,   203,   204,   205,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,    -1,    -1,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,    -1,
     270,    -1,   272,    -1,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,    -1,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,     3,     4,
       5,     6,     7,     8,     9,    10,   406,   407,   408,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,   426,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,   150,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
      -1,   356,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   416,   417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     425,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,    -1,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   416,   417,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   425,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,    -1,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,    -1,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,    -1,
      -1,    -1,    -1,    -1,   423,   424,   425,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,    -1,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     416,   417,   418,    -1,    -1,    -1,    -1,    -1,    -1,   425,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,    -1,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,    -1,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,    -1,   369,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,   417,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   416,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,   129,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,   150,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,   166,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,   205,    -1,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,   326,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,    -1,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,
     417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,   205,    -1,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   416,   417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   425,     3,     4,     5,     6,     7,     8,     9,    10,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,    33,    34,    -1,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      71,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,   149,    -1,
     151,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,   166,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,   179,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
      -1,   202,   203,   204,   205,    -1,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,   260,
     261,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,    -1,    -1,   357,   358,   359,   360,
     361,   362,   363,   364,   365,   366,   367,    -1,   369,   370,
     371,   372,   373,   374,    -1,   376,   377,   378,   379,   380,
     381,    -1,   383,   384,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   416,   417,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   425,     3,     4,     5,     6,     7,
       8,     9,    10,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,     3,     4,
       5,     6,     7,     8,     9,    10,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,
      -1,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    -1,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    71,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,   149,    -1,   151,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,   166,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,   179,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,    -1,   202,   203,   204,
     205,    -1,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
      -1,    -1,   357,   358,   359,   360,   361,   362,   363,   364,
     365,   366,   367,    -1,   369,   370,   371,   372,   373,   374,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,   384,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   416,   417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     425,     3,     4,     5,     6,     7,     8,     9,    10,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,    -1,   369,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   416,   417,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   425,     3,     4,     5,     6,     7,     8,
       9,    10,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    64,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,   157,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,   180,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,   202,   203,   204,   205,    -1,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,
     259,   260,   261,   262,   263,   264,   265,   266,   267,   268,
      -1,   270,   271,   272,   273,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,   306,   307,   308,
     309,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,   340,   341,    -1,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,    -1,    -1,   357,   358,
     359,   360,   361,   362,   363,   364,   365,   366,   367,    -1,
     369,   370,   371,   372,   373,   374,    -1,   376,   377,   378,
     379,   380,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,   398,
     399,   400,   401,   402,   403,   404,   405,   406,   407,   408,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,   417,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   425,     3,     4,     5,
       6,     7,     8,     9,    10,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
      -1,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,    -1,   369,   370,   371,   372,   373,   374,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     416,   417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,
       3,     4,     5,     6,     7,     8,     9,    10,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,   202,
     203,   204,   205,    -1,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,   259,   260,   261,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,    -1,    -1,   357,   358,   359,   360,   361,   362,
     363,   364,   365,   366,   367,    -1,    -1,   370,   371,   372,
     373,   374,    -1,   376,   377,   378,   379,   380,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   416,   417,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   425,     3,     4,     5,     6,     7,     8,     9,
      10,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      30,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,    -1,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   416,   417,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,     3,     4,     5,     6,
       7,     8,     9,    10,    -1,    -1,    -1,    14,    15,    16,
      17,    18,    19,    20,    21,    -1,    23,    24,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,    33,    34,    -1,    36,
      37,    38,    39,    40,    -1,    42,    43,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    -1,    60,    61,    62,    63,    64,    -1,    -1,
      67,    68,    69,    70,    71,    72,    73,    -1,    75,    76,
      77,    78,    79,    80,    -1,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,    -1,   105,    -1,
     107,   108,   109,   110,   111,    -1,   113,   114,   115,    -1,
      -1,   118,   119,   120,   121,   122,    -1,   124,   125,   126,
      -1,   128,    -1,    -1,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,    -1,   142,   143,   144,    -1,   146,
      -1,   148,   149,    -1,   151,   152,   153,   154,    -1,   156,
     157,    -1,   159,    -1,   161,   162,   163,   164,   165,    -1,
     167,   168,   169,    -1,   171,   172,   173,   174,   175,   176,
      -1,   178,   179,   180,   181,   182,   183,   184,   185,   186,
      -1,   188,    -1,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,    -1,   202,   203,   204,    -1,    -1,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,   222,   223,   224,   225,   226,
     227,   228,   229,   230,   231,   232,   233,   234,   235,   236,
      -1,   238,   239,   240,   241,   242,   243,   244,   245,   246,
     247,   248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,
      -1,   258,   259,   260,   261,   262,   263,   264,   265,   266,
     267,   268,    -1,   270,   271,   272,   273,   274,   275,   276,
      -1,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,    -1,   290,   291,   292,   293,   294,   295,   296,
     297,   298,   299,    -1,   301,   302,   303,   304,   305,   306,
     307,   308,   309,   310,   311,   312,   313,   314,    -1,   316,
     317,   318,   319,   320,   321,   322,   323,   324,   325,    -1,
     327,   328,    -1,   330,   331,   332,   333,   334,   335,   336,
     337,   338,   339,   340,   341,    -1,   343,   344,    -1,   346,
     347,   348,   349,   350,   351,    -1,   353,   354,    -1,    -1,
     357,   358,   359,   360,   361,   362,   363,   364,   365,   366,
     367,    -1,   369,   370,   371,   372,   373,   374,    -1,   376,
     377,   378,   379,   380,   381,    -1,   383,   384,   385,   386,
     387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   416,
     417,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,     3,
       4,     5,     6,     7,     8,     9,    10,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,    -1,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,   202,   203,
     204,    -1,    -1,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,    -1,
      -1,     3,   416,   417,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   425,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    53,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,    -1,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
     252,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   425,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    53,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,    -1,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,   252,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    53,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,   202,   203,   204,   205,    -1,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,   240,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,   374,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,     3,
       4,     5,    -1,    -1,    -1,     9,    -1,    -1,    -1,   425,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,   251,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,    -1,
      -1,     3,   416,   417,   418,    -1,    -1,    -1,    -1,    -1,
      -1,   425,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    26,    27,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,   345,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
     392,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
      -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   425,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,   345,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,   392,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,    -1,
      -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   425,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,    -1,    -1,    -1,    -1,    -1,    -1,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,    -1,    -1,    -1,    -1,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   425,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,    -1,    -1,    -1,    -1,
      -1,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   425,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
      -1,    -1,    -1,     3,     4,     5,    -1,    -1,     8,     9,
      -1,    -1,    -1,   425,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,    -1,   136,   137,    -1,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,    -1,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,    -1,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,   237,   238,   239,
     240,   241,   242,    -1,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,    -1,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,   269,
     270,    -1,   272,    -1,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,   342,   343,   344,   345,   346,   347,   348,   349,
     350,   351,   352,   353,   354,   355,   356,   357,    -1,   359,
      -1,   361,   362,   363,   364,   365,   366,   367,   368,   369,
     370,   371,   372,   373,   374,   375,   376,   377,   378,   379,
      -1,   381,   382,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   395,   396,   397,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,
      -1,    -1,   412,   413,   414,    -1,   416,   417,   418,   419,
     420,   421,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,
      -1,    -1,    -1,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
      -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,
      -1,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,    -1,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,    -1,    -1,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,    -1,    -1,
      -1,   412,   413,   414,    -1,   416,   417,   418,   419,   420,
     421,     3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,    -1,    -1,    -1,
     412,   413,   414,    -1,   416,   417,   418,   419,   420,   421,
       3,    -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,
      -1,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    -1,    38,    39,    40,    41,    42,
      -1,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    64,    -1,    -1,    67,    68,    69,    70,    -1,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,   135,   136,   137,   138,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,
     153,   154,    -1,   156,   157,    -1,   159,    -1,   161,   162,
     163,   164,   165,    -1,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,    -1,   180,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,
     193,    -1,   195,   196,   197,   198,   199,   200,    -1,   202,
      -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,    -1,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,    -1,   238,   239,    -1,   241,    -1,
     243,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,
     263,   264,   265,   266,   267,   268,    -1,   270,   271,   272,
     273,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
      -1,   304,   305,   306,   307,   308,   309,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,    -1,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,   340,   341,    -1,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,    -1,    -1,   357,   358,   359,   360,    -1,   362,
     363,   364,   365,   366,   367,    -1,    -1,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,   380,   381,    -1,
     383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,   398,   399,   400,   401,   402,
     403,   404,   405,   406,   407,   408,    -1,    -1,    -1,   412,
     413,   414,    -1,   416,   417,   418,   419,   420,   421,     3,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,    -1,    -1,    -1,   412,   413,
     414,    -1,   416,   417,   418,   419,   420,   421,     3,    -1,
      -1,    -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,    -1,   202,    -1,   204,
      -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,    -1,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,    -1,    -1,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,    -1,    -1,    -1,   412,   413,   414,
      -1,   416,   417,   418,   419,   420,   421,     3,    -1,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,    -1,    -1,     3,   412,   413,   414,    -1,
     416,   417,   418,   419,   420,   421,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     418,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   418,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   418,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    -1,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    -1,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,    -1,   136,   137,    -1,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
      -1,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,    -1,   203,   204,   205,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,    -1,   236,    -1,   238,   239,
     240,   241,    -1,    -1,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,    -1,   259,
     260,   261,    -1,   263,   264,   265,   266,   267,   268,    -1,
     270,    -1,   272,    -1,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,    -1,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
      -1,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,    -1,   359,
      -1,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
      -1,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,    -1,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,   418,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,    -1,   203,
     204,   205,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,    -1,   236,    -1,   238,   239,   240,   241,    -1,    -1,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,    -1,   270,    -1,   272,    -1,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,    -1,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,    -1,   381,    -1,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,    -1,     3,     4,     5,    -1,    -1,
      -1,     9,   406,   407,   408,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,   418,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,   251,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,     4,     5,    -1,    -1,    -1,     9,   416,   417,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,     4,     5,
      -1,    -1,    -1,     9,   416,   417,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,   251,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,   361,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,     9,
     416,   417,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
     150,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,   416,   417,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,   289,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   303,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,   315,   316,   317,   318,   319,   320,   321,   322,   323,
     324,   325,   326,   327,   328,   329,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   342,   343,
     344,   345,   346,   347,   348,   349,   350,   351,   352,   353,
     354,   355,   356,   357,   358,   359,   360,   361,   362,   363,
     364,   365,   366,   367,   368,   369,   370,   371,   372,   373,
     374,   375,   376,   377,   378,   379,   380,   381,   382,   383,
     384,   385,   386,   387,   388,   389,   390,   391,   392,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   264,   265,   266,   267,
     268,   269,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   300,   301,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,   327,
     328,   329,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,   342,   343,   344,   345,   346,   347,
     348,   349,   350,   351,   352,   353,   354,   355,   356,   357,
     358,   359,   360,   361,   362,   363,   364,   365,   366,   367,
     368,   369,   370,   371,   372,   373,   374,   375,   376,   377,
     378,   379,   380,   381,   382,   383,   384,   385,   386,   387,
     388,   389,   390,   391,   392,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    71,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    85,    86,    87,    -1,    -1,    -1,    91,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,   149,    -1,   151,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,   166,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,   179,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,    -1,
     202,   203,   204,   205,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,   240,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,   259,   260,   261,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,   303,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,   326,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,   384,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,   202,   203,   204,   205,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,   240,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    71,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    85,    86,    87,    -1,    -1,
      -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,   149,
      -1,   151,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,   166,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,   179,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,    -1,   202,   203,   204,   205,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
     240,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,   326,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,   384,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    -1,    66,    67,    68,    69,    70,    -1,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,   147,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,   277,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,   369,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,   147,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,   205,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,   277,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,   369,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,   155,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,   289,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,   315,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,   155,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,   147,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,   369,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
       4,     5,     6,     7,    -1,     9,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,   289,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,   315,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,   251,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,   361,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,   147,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,   345,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    26,    27,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,     5,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,   374,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      26,    27,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,   374,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
     374,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,   252,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,     5,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,   345,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    31,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    31,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,   158,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,   375,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    31,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,    -1,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    -1,    38,    39,    40,    41,    42,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    64,    -1,
      -1,    67,    68,    69,    70,    -1,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    -1,
      86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,   135,
     136,   137,   138,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,    -1,
     156,   157,    -1,   159,    -1,   161,   162,   163,   164,   165,
      -1,   167,   168,   169,    -1,   171,   172,   173,   174,   175,
     176,    -1,   178,    -1,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,   195,
     196,   197,   198,   199,   200,    -1,   202,    -1,   204,    -1,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
      -1,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,    -1,   238,   239,    -1,   241,    -1,   243,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,   265,
     266,   267,   268,    -1,   270,   271,   272,   273,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,    -1,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
      -1,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,   358,   359,   360,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,   380,   381,    -1,   383,    -1,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,   398,   399,   400,   401,   402,   403,   404,   405,
     406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,    19,
      20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,
      40,    41,    42,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    -1,    -1,    54,    55,    56,    57,    58,    -1,
      60,    61,    62,    63,    64,    -1,    -1,    67,    68,    69,
      70,    -1,    72,    73,    -1,    75,    76,    77,    78,    79,
      80,    -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,
     100,   101,   102,   103,    -1,   105,    -1,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,    -1,    -1,   118,   119,
     120,   121,   122,    -1,   124,   125,   126,    -1,   128,   129,
      -1,   131,   132,   133,   134,   135,   136,   137,   138,    -1,
     140,    -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,
      -1,    -1,   152,   153,   154,    -1,   156,   157,    -1,   159,
      -1,   161,   162,   163,   164,   165,    -1,   167,   168,   169,
      -1,   171,   172,   173,   174,   175,   176,    -1,   178,    -1,
     180,   181,   182,   183,   184,   185,   186,    -1,   188,    -1,
     190,    -1,    -1,   193,    -1,   195,   196,   197,   198,   199,
     200,    -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,
      -1,    -1,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,    -1,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,    -1,   238,   239,
      -1,   241,    -1,   243,   244,   245,   246,   247,   248,    -1,
     250,    -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,
      -1,    -1,   262,   263,   264,   265,   266,   267,   268,    -1,
     270,   271,   272,   273,   274,   275,   276,    -1,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,    -1,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
      -1,   301,   302,    -1,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,    -1,   316,   317,   318,   319,
     320,    -1,   322,   323,   324,   325,    -1,   327,   328,    -1,
     330,   331,   332,   333,   334,   335,   336,   337,   338,   339,
     340,   341,    -1,   343,   344,    -1,   346,   347,   348,   349,
     350,   351,    -1,   353,   354,    -1,    -1,   357,   358,   359,
     360,    -1,   362,   363,   364,   365,   366,   367,    -1,    -1,
     370,   371,   372,   373,    -1,    -1,   376,   377,   378,   379,
     380,   381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,
     390,    -1,    -1,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,   267,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    -1,
      38,    39,    40,    41,    42,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    64,    -1,    -1,    67,
      68,    69,    70,    -1,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    -1,    86,    87,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,   135,   136,   137,
     138,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,    -1,    -1,    -1,   152,   153,   154,    -1,   156,   157,
      -1,   159,    -1,   161,   162,   163,   164,   165,    -1,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,    -1,   180,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,    -1,    -1,   193,    -1,   195,   196,   197,
     198,   199,   200,    -1,   202,    -1,   204,    -1,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,    -1,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,    -1,
     238,   239,    -1,   241,    -1,   243,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
     258,    -1,    -1,    -1,   262,   263,   264,   265,   266,   267,
     268,    -1,   270,   271,   272,   273,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,    -1,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,    -1,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,   340,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
     358,   359,   360,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,   380,   381,    -1,   383,    -1,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
     398,   399,   400,   401,   402,   403,   404,   405,   406,   407,
     408,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    33,    34,    -1,    36,    -1,    38,    39,    40,    41,
      42,    -1,    44,    45,    -1,    47,    48,    49,    50,    51,
      -1,    -1,    54,    55,    56,    57,    58,    -1,    60,    61,
      62,    63,    64,    -1,    -1,    67,    68,    69,    70,    -1,
      72,    73,    -1,    75,    76,    77,    78,    79,    80,    -1,
      82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    95,    96,    97,    98,    99,   100,   101,
     102,   103,    -1,   105,    -1,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,    -1,    -1,   118,   119,   120,   121,
     122,    -1,   124,   125,   126,    -1,   128,   129,    -1,   131,
     132,   133,   134,   135,   136,   137,   138,    -1,   140,    -1,
     142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,    -1,
     152,   153,   154,    -1,   156,   157,    -1,   159,    -1,   161,
     162,   163,   164,   165,    -1,   167,   168,   169,    -1,   171,
     172,   173,   174,   175,   176,    -1,   178,    -1,   180,   181,
     182,   183,   184,   185,   186,    -1,   188,    -1,   190,    -1,
      -1,   193,    -1,   195,   196,   197,   198,   199,   200,    -1,
     202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,    -1,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,    -1,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,    -1,   238,   239,    -1,   241,
      -1,   243,   244,   245,   246,   247,   248,    -1,   250,    -1,
      -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,    -1,
     262,   263,   264,   265,   266,   267,   268,    -1,   270,   271,
     272,   273,   274,   275,   276,    -1,   278,   279,   280,   281,
     282,   283,   284,   285,   286,   287,   288,    -1,   290,   291,
     292,   293,   294,   295,   296,   297,   298,   299,    -1,   301,
     302,    -1,   304,   305,   306,   307,   308,   309,   310,   311,
     312,   313,   314,    -1,   316,   317,   318,   319,   320,    -1,
     322,   323,   324,   325,    -1,   327,   328,    -1,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
      -1,   343,   344,    -1,   346,   347,   348,   349,   350,   351,
      -1,   353,   354,    -1,    -1,   357,   358,   359,   360,    -1,
     362,   363,   364,   365,   366,   367,    -1,    -1,   370,   371,
     372,   373,    -1,    -1,   376,   377,   378,   379,   380,   381,
      -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,    -1,
      -1,   393,   394,   395,   396,   397,   398,   399,   400,   401,
     402,   403,   404,   405,   406,   407,   408,     3,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,    -1,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      -1,    47,    48,    49,    50,    51,    -1,    -1,    54,    55,
      56,    57,    58,    -1,    60,    61,    62,    63,    -1,    -1,
      -1,    67,    68,    69,    70,    71,    72,    73,    -1,    75,
      76,    77,    78,    79,    80,    -1,    82,    83,    84,    85,
      86,    87,    -1,    -1,    -1,    91,    -1,    -1,    -1,    95,
      96,    97,    98,    99,   100,   101,   102,   103,    -1,   105,
      -1,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
      -1,    -1,   118,   119,   120,   121,   122,    -1,   124,   125,
     126,    -1,   128,   129,    -1,   131,   132,   133,   134,    -1,
     136,   137,    -1,    -1,   140,    -1,   142,   143,   144,    -1,
     146,    -1,   148,   149,    -1,   151,   152,   153,   154,    -1,
     156,    -1,    -1,   159,    -1,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,    -1,   178,   179,   180,   181,   182,   183,   184,   185,
     186,    -1,   188,    -1,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,    -1,    -1,   203,   204,   205,
      -1,   207,   208,   209,    -1,    -1,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,    -1,
     236,    -1,   238,   239,   240,   241,    -1,    -1,   244,   245,
     246,   247,   248,    -1,   250,    -1,    -1,   253,   254,   255,
      -1,    -1,   258,   259,   260,   261,    -1,   263,   264,   265,
     266,   267,   268,    -1,   270,    -1,   272,    -1,   274,   275,
     276,    -1,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,    -1,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,    -1,   301,   302,   303,   304,   305,
      -1,   307,   308,   309,   310,   311,   312,   313,   314,    -1,
     316,   317,   318,   319,   320,    -1,   322,   323,   324,   325,
     326,   327,   328,    -1,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,    -1,   341,    -1,   343,   344,    -1,
     346,   347,   348,   349,   350,   351,    -1,   353,   354,    -1,
      -1,   357,    -1,   359,    -1,    -1,   362,   363,   364,   365,
     366,   367,    -1,    -1,   370,   371,   372,   373,    -1,    -1,
     376,   377,   378,   379,    -1,   381,   382,   383,   384,   385,
     386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,   395,
     396,   397,     3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     406,   407,   408,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    33,    34,    -1,    36,    -1,    38,    39,    40,
      41,    42,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    -1,    -1,    54,    55,    56,    57,    58,    -1,    60,
      61,    62,    63,    64,    -1,    -1,    67,    68,    69,    70,
      -1,    72,    73,    -1,    75,    76,    77,    78,    79,    80,
      -1,    82,    83,    84,    -1,    86,    87,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    95,    96,    97,    98,    99,   100,
     101,   102,   103,    -1,   105,    -1,   107,   108,   109,   110,
     111,    -1,   113,   114,   115,    -1,    -1,   118,   119,   120,
     121,   122,    -1,   124,   125,   126,    -1,   128,   129,    -1,
     131,   132,   133,   134,   135,   136,   137,   138,    -1,   140,
      -1,   142,   143,   144,    -1,   146,    -1,   148,    -1,    -1,
      -1,   152,   153,   154,    -1,   156,   157,    -1,   159,    -1,
     161,   162,   163,   164,   165,    -1,   167,   168,   169,    -1,
     171,   172,   173,   174,   175,   176,    -1,   178,    -1,   180,
     181,   182,   183,   184,   185,   186,    -1,   188,    -1,   190,
      -1,    -1,   193,    -1,   195,   196,   197,   198,   199,   200,
      -1,   202,    -1,   204,    -1,    -1,   207,   208,   209,    -1,
      -1,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,    -1,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,    -1,   238,   239,    -1,
     241,    -1,   243,   244,   245,   246,   247,   248,    -1,   250,
      -1,    -1,   253,   254,   255,    -1,    -1,   258,    -1,    -1,
      -1,   262,   263,   264,   265,   266,   267,   268,    -1,   270,
     271,   272,   273,   274,   275,   276,    -1,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,    -1,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,    -1,
     301,   302,    -1,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,    -1,   316,   317,   318,   319,   320,
      -1,   322,   323,   324,   325,    -1,   327,   328,    -1,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,    -1,   343,   344,    -1,   346,   347,   348,   349,   350,
     351,    -1,   353,   354,    -1,    -1,   357,   358,   359,   360,
      -1,   362,   363,   364,   365,   366,   367,    -1,    -1,   370,
     371,   372,   373,    -1,    -1,   376,   377,   378,   379,   380,
     381,    -1,   383,    -1,   385,   386,   387,    -1,    -1,   390,
      -1,    -1,   393,   394,   395,   396,   397,   398,   399,   400,
     401,   402,   403,   404,   405,   406,   407,   408,     3,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,    34,
      -1,    36,    -1,    38,    39,    40,    41,    42,    -1,    44,
      45,    -1,    47,    48,    49,    50,    51,    -1,    -1,    54,
      55,    56,    57,    58,    -1,    60,    61,    62,    63,    64,
      -1,    -1,    67,    68,    69,    70,    -1,    72,    73,    -1,
      75,    76,    77,    78,    79,    80,    -1,    82,    83,    84,
      -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      95,    96,    97,    98,    99,   100,   101,   102,   103,    -1,
     105,    -1,   107,   108,   109,   110,   111,    -1,   113,   114,
     115,    -1,    -1,   118,   119,   120,   121,   122,    -1,   124,
     125,   126,    -1,   128,   129,    -1,   131,   132,   133,   134,
     135,   136,   137,   138,    -1,   140,    -1,   142,   143,   144,
      -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,   154,
      -1,   156,   157,    -1,   159,    -1,   161,   162,   163,   164,
     165,    -1,   167,   168,   169,    -1,   171,   172,   173,   174,
     175,   176,    -1,   178,    -1,   180,   181,   182,   183,   184,
     185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,    -1,
     195,   196,   197,   198,   199,   200,    -1,   202,    -1,   204,
      -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,    -1,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,    -1,   238,   239,    -1,   241,    -1,   243,   244,
     245,   246,   247,   248,    -1,   250,    -1,    -1,   253,   254,
     255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,   264,
     265,   266,   267,   268,    -1,   270,   271,   272,   273,   274,
     275,   276,    -1,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,    -1,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    -1,   301,   302,    -1,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
      -1,   316,   317,   318,   319,   320,    -1,   322,   323,   324,
     325,    -1,   327,   328,    -1,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,    -1,   343,   344,
      -1,   346,   347,   348,   349,   350,   351,    -1,   353,   354,
      -1,    -1,   357,   358,   359,   360,    -1,   362,   363,   364,
     365,   366,   367,    -1,    -1,   370,   371,   372,   373,    -1,
      -1,   376,   377,   378,   379,   380,   381,    -1,   383,    -1,
     385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,   394,
     395,   396,   397,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,    -1,   203,   204,   205,    -1,   207,   208,
     209,    -1,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,    -1,   236,    -1,   238,
     239,   240,   241,   242,    -1,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,    -1,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
      -1,   270,    -1,   272,    -1,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,    -1,   343,   344,   345,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,    -1,    -1,   357,    -1,
     359,    -1,    -1,   362,   363,   364,   365,   366,   367,    -1,
      -1,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,    -1,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    37,    38,    39,    40,    -1,    42,    43,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      -1,    -1,    -1,    67,    68,    69,    70,    71,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,   149,    -1,   151,   152,   153,
     154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,   163,
     164,   165,   166,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,   179,    -1,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,    -1,    -1,   203,
     204,   205,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,   240,   241,    -1,    -1,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,    -1,   259,   260,   261,    -1,   263,
     264,   265,   266,   267,   268,    -1,   270,    -1,   272,    -1,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,   283,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,   303,
     304,   305,    -1,   307,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,   326,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,    -1,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,    -1,   359,    -1,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,    -1,   381,    -1,   383,
     384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,     3,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   406,   407,   408,    14,    15,    16,    17,    18,
      19,    20,    21,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,    38,
      39,    40,    -1,    42,    43,    44,    45,    -1,    47,    48,
      49,    50,    51,    -1,    -1,    54,    55,    56,    57,    58,
      -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,    68,
      69,    70,    71,    72,    73,    -1,    75,    76,    77,    78,
      79,    80,    -1,    82,    83,    84,    85,    86,    87,    -1,
      -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,    98,
      99,   100,   101,   102,   103,    -1,   105,    -1,   107,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,    -1,   118,
     119,   120,   121,   122,    -1,   124,   125,   126,    -1,   128,
     129,    -1,   131,   132,   133,   134,    -1,   136,   137,    -1,
      -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,   148,
     149,    -1,   151,   152,   153,   154,    -1,   156,    -1,    -1,
     159,    -1,   161,   162,   163,   164,   165,   166,   167,   168,
     169,    -1,   171,   172,   173,   174,   175,   176,    -1,   178,
     179,    -1,   181,   182,   183,   184,   185,   186,    -1,   188,
      -1,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,    -1,    -1,   203,   204,   205,    -1,   207,   208,
     209,    -1,    -1,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,    -1,   238,
     239,   240,   241,    -1,    -1,   244,   245,   246,   247,   248,
      -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,    -1,
     259,   260,   261,    -1,   263,   264,   265,   266,   267,   268,
      -1,   270,    -1,   272,    -1,   274,   275,   276,    -1,   278,
     279,   280,   281,   282,   283,   284,   285,   286,   287,   288,
      -1,   290,   291,   292,   293,   294,   295,   296,   297,   298,
     299,    -1,   301,   302,   303,   304,   305,    -1,   307,   308,
     309,   310,   311,   312,   313,   314,    -1,   316,   317,   318,
     319,   320,    -1,   322,   323,   324,   325,   326,   327,   328,
      -1,   330,   331,   332,   333,   334,   335,   336,   337,   338,
     339,    -1,   341,    -1,   343,   344,    -1,   346,   347,   348,
     349,   350,   351,    -1,   353,   354,    -1,    -1,   357,    -1,
     359,    -1,    -1,   362,   363,   364,   365,   366,   367,    -1,
      -1,   370,   371,   372,   373,    -1,    -1,   376,   377,   378,
     379,    -1,   381,    -1,   383,   384,   385,   386,   387,    -1,
      -1,   390,    -1,    -1,   393,   394,   395,   396,   397,     3,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,   408,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    33,
      34,    -1,    36,    -1,    38,    39,    40,    41,    42,    -1,
      44,    45,    -1,    47,    48,    49,    50,    51,    -1,    -1,
      54,    55,    56,    57,    58,    -1,    60,    61,    62,    63,
      64,    -1,    -1,    67,    68,    69,    70,    -1,    72,    73,
      -1,    75,    76,    77,    78,    79,    80,    -1,    82,    83,
      84,    -1,    86,    87,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    95,    96,    97,    98,    99,   100,   101,   102,   103,
      -1,   105,    -1,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,    -1,    -1,   118,   119,   120,   121,   122,    -1,
     124,   125,   126,    -1,   128,   129,    -1,   131,   132,   133,
     134,   135,   136,   137,   138,    -1,   140,    -1,   142,   143,
     144,    -1,   146,    -1,   148,    -1,    -1,    -1,   152,   153,
     154,    -1,   156,   157,    -1,   159,    -1,   161,   162,   163,
     164,   165,    -1,   167,   168,   169,    -1,   171,   172,   173,
     174,   175,   176,    -1,   178,    -1,   180,   181,   182,   183,
     184,   185,   186,    -1,   188,    -1,   190,    -1,    -1,   193,
      -1,   195,   196,   197,   198,   199,   200,    -1,   202,    -1,
     204,    -1,    -1,   207,   208,   209,    -1,    -1,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,    -1,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,    -1,   238,   239,    -1,   241,    -1,   243,
     244,   245,   246,   247,   248,    -1,   250,    -1,    -1,   253,
     254,   255,    -1,    -1,   258,    -1,    -1,    -1,   262,   263,
     264,   265,   266,    -1,   268,    -1,   270,   271,   272,   273,
     274,   275,   276,    -1,   278,   279,   280,   281,   282,    -1,
     284,   285,   286,   287,   288,    -1,   290,   291,   292,   293,
     294,   295,   296,   297,   298,   299,    -1,   301,   302,    -1,
     304,   305,   306,    -1,   308,   309,   310,   311,   312,   313,
     314,    -1,   316,   317,   318,   319,   320,    -1,   322,   323,
     324,   325,    -1,   327,   328,    -1,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,    -1,   343,
     344,    -1,   346,   347,   348,   349,   350,   351,    -1,   353,
     354,    -1,    -1,   357,   358,   359,   360,    -1,   362,   363,
     364,   365,   366,   367,    -1,    -1,   370,   371,   372,   373,
      -1,    -1,   376,   377,   378,   379,   380,   381,    -1,   383,
      -1,   385,   386,   387,    -1,    -1,   390,    -1,    -1,   393,
     394,   395,   396,   397,   398,   399,   400,   401,   402,   403,
     404,   405,   406,   407,   408,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,    -1,   203,   204,   205,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,    -1,    -1,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
      -1,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,    -1,   270,    -1,   272,    -1,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,   323,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
      -1,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,    -1,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,
     408,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    42,
      43,    44,    45,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    56,    57,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,   101,   102,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
     143,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,   185,   186,    -1,   188,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,    -1,
     203,   204,   205,    -1,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,    -1,
      -1,   244,   245,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,    -1,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,    -1,   270,    -1,   272,
      -1,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,   285,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,    -1,   322,
     323,   324,   325,   326,   327,   328,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,    -1,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,    -1,
     353,   354,    -1,    -1,   357,    -1,   359,    -1,    -1,   362,
     363,   364,   365,   366,   367,    -1,    -1,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,    -1,   381,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,     3,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   406,   407,   408,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    25,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    33,    34,    -1,    36,    37,
      38,    39,    40,    -1,    42,    43,    44,    45,    -1,    47,
      48,    49,    50,    51,    -1,    -1,    54,    55,    56,    57,
      58,    -1,    60,    61,    62,    63,    -1,    -1,    -1,    67,
      68,    69,    70,    71,    72,    73,    -1,    75,    76,    77,
      78,    79,    80,    -1,    82,    83,    84,    85,    86,    87,
      -1,    -1,    -1,    91,    -1,    -1,    -1,    95,    96,    97,
      98,    99,   100,   101,   102,   103,    -1,   105,    -1,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,    -1,    -1,
     118,   119,   120,   121,   122,    -1,   124,   125,   126,    -1,
     128,   129,    -1,   131,   132,   133,   134,    -1,   136,   137,
      -1,    -1,   140,    -1,   142,   143,   144,    -1,   146,    -1,
     148,   149,    -1,   151,   152,   153,   154,    -1,   156,    -1,
      -1,   159,    -1,   161,   162,   163,   164,   165,   166,   167,
     168,   169,    -1,   171,   172,   173,   174,   175,   176,    -1,
     178,   179,    -1,   181,   182,   183,   184,   185,   186,    -1,
     188,    -1,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,    -1,    -1,   203,   204,   205,    -1,   207,
     208,   209,    -1,    -1,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,    -1,   236,    -1,
     238,   239,   240,   241,    -1,    -1,   244,   245,   246,   247,
     248,    -1,   250,    -1,    -1,   253,   254,   255,    -1,    -1,
      -1,   259,   260,   261,    -1,   263,   264,   265,   266,   267,
     268,    -1,   270,    -1,   272,    -1,   274,   275,   276,    -1,
     278,   279,   280,   281,   282,   283,   284,   285,   286,   287,
     288,    -1,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,    -1,   301,   302,   303,   304,   305,    -1,   307,
     308,   309,   310,   311,   312,   313,   314,    -1,   316,   317,
     318,   319,   320,    -1,   322,    -1,   324,   325,   326,   327,
     328,    -1,   330,   331,   332,   333,   334,   335,   336,   337,
     338,   339,    -1,   341,    -1,   343,   344,    -1,   346,   347,
     348,   349,   350,   351,    -1,   353,   354,    -1,    -1,   357,
      -1,   359,    -1,    -1,   362,   363,   364,   365,   366,   367,
      -1,    -1,   370,   371,   372,   373,    -1,    -1,   376,   377,
     378,   379,    -1,   381,    -1,   383,   384,   385,   386,   387,
      -1,    -1,   390,    -1,    -1,   393,   394,   395,   396,   397,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   406,   407,
     408,    14,    15,    16,    17,    18,    19,    20,    21,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      33,    34,    -1,    36,    37,    38,    39,    40,    -1,    -1,
      43,    -1,    -1,    -1,    47,    48,    49,    50,    51,    -1,
      -1,    54,    55,    -1,    -1,    58,    -1,    60,    61,    62,
      63,    -1,    -1,    -1,    67,    68,    69,    70,    71,    72,
      73,    -1,    75,    76,    77,    78,    79,    80,    -1,    82,
      83,    84,    85,    86,    87,    -1,    -1,    -1,    91,    -1,
      -1,    -1,    95,    96,    97,    98,    99,   100,    -1,    -1,
     103,    -1,   105,    -1,   107,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,    -1,   118,   119,   120,   121,   122,
      -1,   124,   125,   126,    -1,   128,   129,    -1,   131,   132,
     133,   134,    -1,   136,   137,    -1,    -1,   140,    -1,   142,
      -1,   144,    -1,   146,    -1,   148,   149,    -1,   151,   152,
     153,   154,    -1,   156,    -1,    -1,   159,    -1,   161,   162,
     163,   164,   165,   166,   167,   168,   169,    -1,   171,   172,
     173,   174,   175,   176,    -1,   178,   179,    -1,   181,   182,
     183,   184,    -1,    -1,    -1,    -1,    -1,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,    -1,    -1,
     203,   204,   205,    -1,   207,   208,   209,    -1,    -1,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,    -1,   226,    -1,   228,   229,   230,   231,   232,
     233,   234,    -1,   236,    -1,   238,   239,   240,   241,    -1,
      -1,   244,    -1,   246,   247,   248,    -1,   250,    -1,    -1,
     253,   254,   255,    -1,    -1,    -1,   259,   260,   261,    -1,
     263,   264,   265,   266,   267,   268,    -1,   270,    -1,   272,
      -1,   274,   275,   276,    -1,   278,   279,   280,   281,   282,
     283,   284,    -1,   286,   287,   288,    -1,   290,   291,   292,
     293,   294,   295,   296,   297,   298,   299,    -1,   301,   302,
     303,   304,   305,    -1,   307,   308,   309,   310,   311,   312,
     313,   314,    -1,   316,   317,   318,   319,   320,    -1,   322,
      -1,   324,   325,   326,   327,    -1,    -1,   330,   331,   332,
     333,   334,   335,   336,   337,   338,   339,    -1,   341,    -1,
     343,   344,    -1,   346,   347,   348,   349,   350,   351,    -1,
      -1,    -1,    -1,    -1,   357,    -1,   359,    -1,    -1,   362,
     363,   364,   365,   366,   367,    -1,    -1,   370,   371,   372,
     373,    -1,    -1,   376,   377,   378,   379,    -1,    -1,    -1,
     383,   384,   385,   386,   387,    -1,    -1,   390,    -1,    -1,
     393,   394,   395,   396,   397,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   406,   407,   408
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    14,    24,    26,    27,    40,    60,    62,    63,    67,
      69,    79,    81,   100,   103,   109,   115,   117,   121,   127,
     134,   136,   141,   155,   183,   207,   208,   213,   222,   239,
     275,   286,   290,   292,   297,   302,   305,   309,   315,   322,
     325,   332,   345,   362,   371,   373,   376,   380,   392,   425,
     432,   433,   434,   435,   441,   442,   444,   445,   446,   447,
     448,   449,   450,   452,   453,   457,   467,   469,   470,   473,
     474,   475,   485,   486,   501,   536,   542,   543,   550,   556,
     558,   560,   561,   562,   563,   572,   576,   577,   578,   580,
     581,   582,   596,   597,   598,   599,   610,   616,   617,   620,
     621,   622,   623,   624,   629,   631,   634,   638,   639,   649,
     650,   653,   658,   668,   687,   690,   691,   692,   695,   698,
     700,   702,   705,   708,   709,   710,   717,   718,   720,   721,
     722,   727,   729,   730,   734,   735,   738,   739,   740,   742,
     743,   744,   745,   747,   750,   751,   756,   762,   765,   767,
     768,   773,   775,   779,   786,   790,   791,   792,   793,   794,
     795,   824,   357,   394,   723,    21,    78,    98,   104,   119,
     147,   152,   158,   173,   197,   253,   280,   304,   310,   316,
     319,   345,   347,   351,   359,   364,   374,   386,   557,   723,
       3,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    33,    34,    36,    38,    39,    40,    41,
      42,    44,    45,    47,    48,    49,    50,    51,    54,    55,
      56,    57,    58,    60,    61,    62,    63,    64,    67,    68,
      69,    70,    72,    73,    75,    76,    77,    78,    79,    80,
      82,    83,    84,    86,    87,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   105,   107,   108,   109,   110,   111,
     113,   114,   115,   118,   119,   120,   121,   122,   124,   125,
     126,   128,   129,   131,   132,   133,   134,   135,   136,   137,
     138,   140,   142,   143,   144,   146,   148,   152,   153,   154,
     156,   157,   159,   161,   162,   163,   164,   165,   167,   168,
     169,   171,   172,   173,   174,   175,   176,   178,   180,   181,
     182,   183,   184,   185,   186,   188,   190,   193,   195,   196,
     197,   198,   199,   200,   202,   204,   207,   208,   209,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   238,   239,   241,   243,   244,   245,   246,
     247,   248,   250,   253,   254,   255,   258,   262,   263,   264,
     265,   266,   267,   268,   270,   271,   272,   273,   274,   275,
     276,   278,   279,   280,   281,   282,   283,   284,   285,   286,
     287,   288,   290,   291,   292,   293,   294,   295,   296,   297,
     298,   299,   301,   302,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   316,   317,   318,   319,   320,
     322,   323,   324,   325,   327,   328,   330,   331,   332,   333,
     334,   335,   336,   337,   338,   339,   340,   341,   343,   344,
     346,   347,   348,   349,   350,   351,   353,   354,   357,   358,
     359,   360,   362,   363,   364,   365,   366,   367,   370,   371,
     372,   373,   376,   377,   378,   379,   380,   381,   383,   385,
     386,   387,   390,   393,   394,   395,   396,   397,   398,   399,
     400,   401,   402,   403,   404,   405,   406,   407,   408,   787,
     927,   939,   942,   943,   384,   752,   251,   276,   723,    43,
     492,   791,    21,    33,    53,    74,    98,   104,   119,   147,
     154,   158,   209,   253,   256,   304,   310,   319,   347,   348,
     350,   351,   359,   364,   369,   374,   502,   613,   659,   669,
      22,   275,   927,   787,   150,    22,   270,   348,   350,     5,
     196,   696,   697,   936,    21,    33,    53,    78,    98,   119,
     147,   152,   158,   173,   253,   263,   304,   308,   310,   316,
     319,   345,   347,   351,   359,   364,   374,   386,   557,   625,
     723,   927,    81,   384,   425,   536,   751,   757,   765,   768,
     773,   779,   786,   790,     9,    15,    22,    38,   142,   148,
     150,   170,   198,   228,   278,   291,   416,   417,   635,   636,
     787,   935,   938,    22,    81,   289,   315,   640,   641,   642,
     939,   189,   939,   932,   936,   345,   800,   635,   939,   357,
     927,   263,    98,   173,   344,   345,   703,   309,   939,    22,
     320,   353,   357,   459,   939,    19,   155,   640,   641,   276,
     723,   939,    22,   116,   802,    54,    75,   209,   224,   304,
     310,   320,   353,   357,   397,   458,   459,    22,   320,   353,
     357,   459,   357,   252,   833,   925,   939,   800,   418,   939,
     833,   835,   151,   425,   753,   425,   921,   288,   796,   797,
     927,   791,   792,     0,   428,   752,   130,   187,   257,   368,
     803,   804,   791,   793,   794,   429,     3,    37,    43,    71,
      85,    91,   149,   151,   166,   179,   191,   192,   194,   203,
     205,   226,   240,   259,   260,   261,   303,   326,   384,   933,
     939,   940,   942,   944,   627,   939,   928,   939,   279,   627,
      97,   648,   933,   937,   939,   925,   246,     8,    61,   140,
     412,   413,   414,   416,   417,   418,   419,   420,   421,   694,
     888,   889,   939,   937,   927,   925,   927,   833,   927,   312,
     927,   627,   215,   937,   925,   196,   193,   284,   724,   725,
     726,   925,   931,   939,    21,    53,    66,    74,    78,    98,
     119,   152,   173,   197,   253,   304,   308,   310,   316,   345,
     347,   351,   359,   364,   386,   557,   632,   936,   925,   355,
     933,   927,   425,   359,   928,   627,    97,   348,   350,   937,
     348,   350,    61,   140,   694,   295,   937,   454,   939,   927,
     927,   312,   927,   627,   215,   937,   316,   345,   386,    78,
     173,   152,   308,   363,   551,    22,   927,   788,   835,   466,
     936,   939,   697,   165,   933,   927,   165,   701,   165,   928,
      97,   165,   933,   165,   926,   927,    61,   140,   165,   694,
      47,   165,   926,   165,   927,   165,   927,   165,   927,   312,
     165,   927,   165,   215,   926,   196,   165,   626,   627,   425,
     766,   502,   757,   380,   384,   751,   758,   759,   760,   939,
     752,   938,   636,   637,    22,   637,   938,   637,    22,   637,
     938,   637,   637,   637,   938,   935,   935,   787,   637,   279,
     425,   425,   520,   520,   520,   251,   355,   429,   520,   925,
     833,   834,   429,   719,   936,   425,   763,    47,   927,   927,
     925,   939,    37,   408,   193,   427,   254,   254,   251,   150,
     936,   355,   251,     4,     6,     7,     8,    10,    30,    42,
      44,    45,    52,    53,    56,    57,    64,    88,    89,    90,
      91,    92,    93,    94,   101,   102,   120,   135,   138,   139,
     143,   157,   185,   186,   188,   202,   210,   211,   225,   227,
     237,   242,   243,   245,   253,   262,   271,   285,   306,   321,
     328,   340,   353,   354,   358,   360,   361,   369,   374,   381,
     399,   400,   401,   402,   403,   404,   405,   416,   417,   418,
     425,   791,   844,   847,   850,   851,   852,   854,   855,   856,
     857,   860,   861,   865,   867,   868,   886,   890,   909,   914,
     922,   923,   933,   934,   935,   936,   939,   936,    22,   471,
     924,   925,   320,   458,   104,   465,   936,   466,   936,    37,
      58,   458,   408,   725,   254,   150,   355,   412,    37,   408,
     193,   726,   425,   925,   418,   423,   427,   915,   916,   834,
      31,   939,   322,   149,   151,   384,   748,   749,   751,   149,
     754,   104,   865,   919,   920,   796,   429,   425,   755,   426,
     426,   434,   925,    22,   116,   801,   801,    47,   801,   141,
     145,   206,   249,   807,   809,   810,   819,   821,   822,   803,
     804,   921,   425,   604,   916,   264,   293,   427,   628,   264,
     293,   322,   392,   436,   467,   468,   654,    18,   121,   264,
     322,   478,   395,    49,    80,   137,   168,   264,   293,   301,
     307,   314,   322,   330,   338,   387,   468,   681,   688,   425,
     670,    18,   121,   293,   451,    18,    24,    63,   114,   121,
     124,   175,   229,   264,   293,   297,   322,   476,   477,     4,
     417,   548,   938,   627,   627,   425,   693,   427,   170,   293,
     436,   443,   264,   293,    48,    96,   172,   217,   219,   229,
     263,   293,   298,   322,   332,   476,   545,   546,   255,   264,
     385,   566,   574,   293,   322,   476,   264,   293,   297,   322,
      72,   113,   265,   349,   251,   264,   293,   322,   145,   293,
     322,   436,   468,   293,   322,   476,   927,   204,   252,   396,
     429,   724,   375,   746,   251,   933,   425,   927,   933,   246,
      61,   140,   694,   927,   312,   927,   196,   627,   520,   335,
     336,   488,   936,   425,   604,   605,    59,     3,    42,    44,
      45,    56,    57,   101,   102,   143,   185,   186,   188,   225,
     227,   245,   285,   323,   328,   353,   354,   381,   841,   843,
     845,   847,   849,   851,   852,   853,   855,   856,   860,   861,
     940,   942,   927,   436,    31,   741,   395,   436,   627,   627,
     425,   600,   502,   436,    37,   455,   364,   573,   264,   559,
      72,   113,   265,   349,    20,    39,   583,    31,   600,   145,
     436,   925,   537,   925,   925,   627,    71,   660,   933,   927,
     557,    43,    95,   182,   229,   311,   375,   774,   135,   604,
      50,   299,   479,   135,   425,   135,   395,   135,   670,   135,
     429,   165,   627,   165,   627,   135,   693,   926,   135,   135,
     251,   135,   479,   135,    72,   113,   265,   349,   135,   251,
     135,   145,   165,   165,   466,   135,   429,   479,   865,   893,
     345,   426,   429,   139,   251,   361,   463,   466,   548,   761,
     757,   637,   787,   637,   787,   637,   787,   637,   787,   637,
     787,   787,   787,   637,   787,   425,   521,   522,   939,   521,
      22,    98,   147,   152,   196,   197,   310,   316,   345,   347,
     643,   924,   926,   642,   104,   425,   769,   790,   170,   429,
     776,   936,   841,   896,    31,   926,   146,   704,   704,   704,
     204,   939,   145,   145,   643,   926,   309,   939,   425,   917,
     423,   791,   897,   383,   858,   865,   913,   425,   858,   858,
     425,   425,   425,   425,   846,   846,   273,   791,   425,   425,
     848,   425,   425,   425,   425,    56,    57,   858,   865,   425,
     846,   425,   425,   425,   425,   425,   393,   411,   425,   862,
     425,   862,   425,   425,   791,   425,   425,   425,   425,   425,
     425,   425,   865,   865,   791,   865,   893,   916,   936,    57,
     425,   859,   425,   936,     3,     8,    11,    28,    31,    36,
      41,   166,   170,   191,   192,   205,   237,   240,   253,   256,
     326,   412,   413,   414,   416,   417,   418,   419,   420,   421,
     888,   890,   892,   261,   865,   189,   429,   798,   425,   936,
     916,   107,   167,   472,   429,    58,   104,   466,    31,     3,
     104,   209,   464,   548,   861,   936,    76,   118,   874,    87,
     104,   460,   461,   463,   548,   104,   460,   204,   925,   865,
       3,    22,    26,    27,    28,    29,    30,    31,    32,    35,
      46,    52,    53,    59,    65,    66,    74,    81,    88,    89,
      90,    92,    93,    94,   104,   106,   112,   116,   117,   123,
     127,   130,   139,   141,   145,   147,   150,   155,   158,   160,
     170,   177,   187,   189,   201,   206,   210,   211,   237,   242,
     249,   251,   252,   256,   257,   269,   277,   289,   300,   315,
     321,   329,   342,   345,   352,   355,   356,   361,   368,   369,
     374,   375,   382,   388,   389,   391,   392,   418,   930,   941,
     942,   943,   944,   945,   915,    77,   298,   630,   939,   425,
     780,   781,   782,   783,   784,   939,   426,   429,   752,   426,
     429,   797,   926,    31,   755,   793,   793,   805,   806,   865,
     793,   142,   228,   816,   284,   324,   373,    22,   811,   865,
     812,   814,   865,   867,   819,   820,   810,   809,   807,   808,
     145,   822,   807,   819,   418,   896,   264,   293,   322,   355,
     355,   930,   427,   355,   355,   347,   458,   736,   145,   155,
     170,   302,   655,   656,    59,    74,   131,   147,   277,   369,
     518,   519,    74,   104,   237,   355,   104,   237,   310,   927,
     251,   548,   314,   355,   355,   242,   548,   108,   190,   310,
     299,   681,   689,   170,   180,   258,   323,   382,   426,   671,
     674,   675,   676,   678,   841,   940,   355,   374,    66,   131,
     509,   518,   939,    66,   706,   251,   308,   359,    74,   706,
      25,   296,   308,   359,   925,   175,   355,   355,   425,   481,
     347,   392,   393,   481,   429,     4,   264,   375,   375,   235,
     841,   264,   694,    98,   355,   438,   468,   355,   355,   548,
      47,   547,   548,   548,    96,   217,   219,    47,   355,   436,
     310,   436,   229,   546,   425,   355,   242,   936,   566,   355,
     706,   310,   355,   355,   481,   481,   627,   627,   627,   627,
     925,   355,   355,   310,    94,   374,   579,   937,   355,   438,
     355,   310,   264,   293,   284,   294,   318,   462,   724,   931,
     939,   925,   604,   841,   251,   670,   548,   627,   627,   693,
     191,   251,    72,   113,   265,   349,   251,   627,   191,   392,
     493,   436,     3,   606,   607,   600,   425,   843,    31,    30,
     842,    99,   163,   218,   221,   313,   406,   425,   863,   864,
     628,   846,    20,   731,   841,   927,   437,   613,   375,   601,
     602,   941,   386,   437,   937,    81,   155,   456,   501,   542,
     582,   638,   658,   727,   936,   574,   575,   927,   212,   627,
     627,   627,   627,   109,   183,   362,   373,   584,   585,   128,
     425,   579,   437,   544,   545,    31,   247,   425,   538,   520,
     145,   661,   931,   425,   672,    31,   196,   392,   393,   789,
     311,   425,   791,   826,   827,   828,   833,   836,   868,   933,
     939,   389,   838,   933,   479,   841,   928,   165,   927,   933,
     479,   926,   927,   135,   375,   135,   375,   694,   479,   479,
     926,   927,   925,   927,   927,   927,   925,   926,   579,   135,
     135,   479,   626,   627,   426,   429,   925,   757,   759,   787,
     787,   787,   787,   787,   787,   521,   426,   429,   426,   153,
     317,   346,   926,    97,   319,   647,   648,   926,   246,   926,
     924,   924,   926,   355,   392,   651,   380,   770,   771,   939,
     300,   772,    16,   133,   306,   324,   777,   833,   241,   778,
     426,   429,   764,   768,   773,   779,   790,   355,   641,   640,
     641,   150,   156,   652,   939,   893,   915,   424,   893,   897,
     898,   425,   388,   910,   911,   865,   893,   935,   935,   893,
       3,    99,   163,   218,   221,   313,   406,   899,   900,   936,
     935,   893,   893,   935,   935,   858,   858,   865,   694,   865,
     901,   416,   417,   866,   867,   886,   890,   903,   426,   893,
     865,   893,   904,   353,   408,   935,   935,   865,    46,   150,
     201,   356,   865,   893,   907,   893,   223,   865,   872,   873,
     874,   223,   865,   874,   426,   429,   322,   935,   935,   863,
     841,   865,   941,   353,    35,   342,   918,   865,   425,   791,
     908,   116,   118,   139,   237,   242,   247,   361,   370,   865,
      41,   166,   170,   205,   326,   425,   865,   355,   865,   865,
     865,   865,   865,   865,   865,   865,   865,   865,    22,    29,
     329,   887,   306,   425,   886,   154,   209,   345,   348,   350,
     799,   925,   923,   150,   825,    22,   116,   382,   418,   426,
     676,   865,   894,   895,   940,   925,   357,   425,   936,   429,
     426,   424,   430,   164,   164,   479,   784,   785,   429,   825,
     412,   917,   925,   749,   750,   925,   919,   426,   791,   429,
      32,   112,   375,   666,   425,   813,   938,   252,   247,   823,
     823,   429,   306,   307,   815,   820,   808,   426,   426,   355,
     355,   310,   937,   927,   930,   937,   928,   927,    73,   737,
     304,   374,   640,   310,   155,   640,   425,   927,   375,   662,
     195,   195,   425,   927,   242,   937,   865,   242,   927,   229,
     264,   378,   554,   566,   242,   108,   190,   937,   927,   251,
     927,   258,   940,   426,   429,   676,   678,   675,   678,   940,
     628,   937,   926,   509,   841,   939,   927,   927,    22,   374,
     927,   165,   927,   165,   939,   308,   359,   308,   359,   927,
      22,   374,   927,   925,   937,   927,   483,   484,   941,   927,
     250,    63,   250,   477,   355,   929,   939,   929,   429,   426,
     429,   355,   928,   937,    73,    82,    83,    84,   126,   175,
     214,   230,   231,   232,   233,   234,   236,   268,   341,   367,
     374,   377,   439,   937,   927,   548,   627,   927,   548,   927,
     548,    18,   121,   322,   567,   568,   569,   570,   941,   937,
     927,   927,   927,   937,   927,    18,    24,   121,   264,   293,
     264,   293,   600,   293,   293,   293,   937,   927,   927,   319,
     937,   927,   927,   355,   355,    70,   366,   284,   191,    31,
     627,   191,   191,   375,   375,   191,   242,   633,   936,   627,
     627,   627,   627,   627,   627,   191,   633,   250,   150,   355,
     487,   425,   489,   490,   412,   426,   429,   865,    30,   842,
     841,   423,   423,   355,   355,   355,   425,   355,   935,   846,
     584,    73,   125,   199,   200,   212,   264,   347,   349,   732,
     511,   554,   555,    19,   170,   304,   343,   439,   440,   145,
     929,   426,   429,   412,   925,   455,   256,   502,   147,   936,
     600,   600,   600,   600,   247,   251,   256,   425,   839,   840,
     939,   319,   134,   790,   627,   205,   503,   505,   507,   509,
     515,   518,   539,   540,   939,   392,   393,   532,    31,   936,
     251,   426,   673,   674,   679,    31,   196,   301,   391,   680,
     681,   682,   251,   466,   162,   162,   145,   791,   827,   828,
      31,   829,   939,   429,    85,   151,   179,   194,   203,   226,
     303,   830,   829,    31,   829,   939,   425,   916,    87,   865,
     772,   604,    31,   135,   479,   670,   627,   929,   627,   929,
     693,   251,   479,   479,   251,   479,   319,   145,   466,   479,
     865,   425,   426,   522,   170,   170,   170,   395,   926,   429,
     548,   549,   158,   644,   645,   937,    19,   652,   426,   429,
     917,   922,   133,   324,   133,   324,   306,   373,   220,   841,
     927,   150,   251,   644,    47,   479,   426,   424,   424,   429,
     893,   865,   123,   911,   912,    31,   426,   426,   426,   426,
     426,   150,   426,   426,   426,   426,   426,   429,   426,   269,
     902,   426,   866,   866,    11,   170,   191,   253,   412,   413,
     414,   416,   417,   418,   419,   420,   421,   890,   866,   426,
     426,   145,   150,   905,   906,   426,   408,   426,   426,    31,
     907,   893,   907,   907,   150,   426,   426,   941,    31,   426,
     429,   865,   941,   429,   865,   917,   865,   939,   426,   426,
     408,   866,   866,   129,   893,   150,   116,   118,   139,   242,
     247,   361,   370,   425,   129,   342,   918,   865,   908,   865,
     355,   694,   865,   425,   791,   348,   350,   348,   350,   925,
     800,   800,   826,   389,   837,   894,   894,   895,   426,   260,
     879,    13,   426,   429,   804,   725,   935,   863,   461,   865,
     426,   429,   781,   838,   919,   755,   806,   253,   888,   891,
     409,   410,   667,   865,   815,   924,   778,   778,   812,   937,
     927,   927,   206,   926,   926,   251,   926,   254,   251,   865,
     519,   929,   425,   425,   425,   521,   479,   378,   355,   552,
     927,   566,   181,   242,   628,   674,   678,   678,   420,   511,
     121,   297,   322,   478,   707,   135,   479,   135,   479,   927,
     927,   927,   927,   426,   429,   412,   427,   937,   264,   293,
      18,   121,   264,   293,   841,   235,   841,   937,   206,   268,
     242,   936,   268,   926,   372,   569,   570,   569,   426,   429,
     571,   936,   355,   215,   215,   215,   355,   355,   355,   355,
     355,   355,   355,   927,   937,   927,   633,   841,   191,   633,
     633,   929,   929,   633,   191,   191,   191,   191,   191,   191,
     633,   488,   496,   497,   941,    43,    86,   110,   129,   146,
     161,   242,   250,   282,   491,   253,   416,   417,   548,   603,
     678,   891,   936,   945,     3,   607,   426,   423,   426,   935,
     424,   935,   163,   218,   864,   218,   864,   864,   935,   221,
     426,   251,   206,   412,   733,   733,   733,   733,   733,   733,
     733,    59,    74,   104,   106,   177,   237,   242,   277,   289,
     369,   512,   513,   514,   255,   564,   926,   158,   304,   926,
     935,   364,   602,   603,   520,   295,   345,    97,   521,   925,
     585,   608,   609,   936,   426,   429,   841,   927,   927,   392,
     541,   425,   504,   925,   426,   429,   426,   429,   250,   481,
     250,   251,   533,   790,   355,   925,   426,   429,   104,   412,
     683,   936,   466,   345,   677,   678,   392,   682,   684,   109,
     183,   315,   373,   715,   159,   790,   426,   939,   425,   827,
     194,   259,   831,   827,   831,   194,   830,   831,   194,   425,
     939,   425,   894,   247,   479,   841,   927,   479,   375,   479,
     375,   479,   479,   925,   925,   927,   579,   479,   939,   310,
     310,   310,   926,   648,   429,   937,   392,   429,   646,   254,
     790,   771,   133,   133,   926,   643,   479,   937,   897,   426,
     352,   865,   127,   841,   865,   865,   865,   905,   841,   866,
     116,   118,   237,   247,   866,   866,   866,   866,   866,   866,
     866,   866,   866,   866,   865,   865,   906,   905,   862,   862,
     841,   426,   426,   426,   893,   426,   429,   941,   873,   274,
     339,   875,   426,   429,   385,   869,    31,   426,   859,   936,
     865,    28,    28,   865,   426,   865,   150,   425,   896,   865,
     866,   866,   129,   129,   865,   426,   129,   865,   800,   800,
     800,   800,   925,   925,   865,   158,   817,   429,   803,   804,
     803,   426,   879,   425,   880,   939,   865,   879,   936,   382,
     895,   426,   426,   424,   412,   784,   772,   425,   667,   426,
     252,   733,   153,   317,   346,   657,   145,   657,   426,   425,
     524,   525,   664,   868,   939,   521,   521,   426,   937,   628,
     181,   420,   364,   237,   481,    97,   237,   334,   337,   481,
     364,   927,   939,   484,   603,   941,   355,   355,   152,   253,
     337,   611,   612,   152,   253,   618,   619,   355,   355,   426,
     426,   426,   938,   936,   936,   936,   568,   927,   145,   145,
     295,   145,   165,   937,   927,   937,   927,   927,   927,   927,
     566,   426,   633,   191,   191,   633,   633,   633,   633,   633,
     633,   375,   494,   495,   426,   429,   418,   425,   463,   498,
     548,   741,   741,   237,   282,   741,   741,   106,   177,   237,
     593,   594,   595,   935,   392,   393,   424,   424,   426,   863,
     925,   733,   104,   935,   936,   104,   936,   104,   936,   104,
     936,   104,   927,   104,   927,   104,   927,   425,   927,   866,
     107,   167,   106,   242,   195,   925,   684,   425,   926,   926,
     841,    31,   925,   395,   145,   586,   426,   429,   840,   564,
     766,    97,   229,   506,   508,   510,   518,   939,   532,   516,
     176,   531,   507,   540,    69,   347,   534,   392,   728,   936,
     662,   679,   865,   865,   429,   425,   680,   600,   355,   552,
     829,   425,   926,   827,   251,   375,   832,   827,   194,   827,
     839,   425,   839,   939,   426,   927,   426,   479,   929,   929,
     479,   479,   319,   926,   926,   926,   548,   155,   645,   652,
     150,   865,   426,   426,   906,   150,   116,   118,   247,   425,
     426,   398,   871,   893,   390,   390,   426,   865,   229,   865,
     429,   870,   843,   863,   866,   866,   865,   896,   426,    28,
      28,   865,   865,   129,   865,   426,   925,   925,   925,   925,
      47,   160,   818,   426,   426,   879,   881,   939,   895,   879,
     936,   921,   694,   938,   355,   640,   150,   593,   865,   426,
     429,   392,   375,   627,   665,   665,   426,   426,   684,   364,
     242,   242,   938,   939,   841,   479,   479,   412,   937,   927,
     935,   935,   841,   429,   935,   935,   429,   937,   927,   926,
     926,   627,   926,   135,   191,   633,   633,   436,   111,   497,
     463,   499,   500,   936,   936,   242,   418,   521,   936,   936,
     107,   167,   106,   595,   594,   424,   152,   180,   152,   150,
     592,   938,   865,   237,   513,   684,   520,   375,   535,   565,
     569,   375,   790,   425,   927,   122,   587,   388,   589,   936,
      97,   426,   429,   392,   533,   132,   171,   425,   532,   109,
     121,   274,   927,    51,    59,   209,   150,   425,   936,   676,
     685,   686,   940,   684,   925,   178,   553,   926,   426,   865,
     425,   827,   832,   426,   839,   426,   479,   479,   479,   927,
     254,   479,   644,   866,   150,   425,   896,   425,   426,   429,
     426,   426,   379,   331,   426,   426,   426,   866,   866,   865,
     893,   865,   391,   876,   879,   879,   267,   882,   426,   863,
     426,   644,   251,   644,   426,   684,   525,   253,   694,   627,
     666,   666,   289,   684,   535,   375,   480,   603,   425,   933,
     694,   612,   425,   425,   619,   392,   295,   392,   392,   145,
     633,   489,   936,   426,   429,   521,   648,    31,   699,   699,
     925,   593,   426,   535,   216,   523,   173,   426,   429,   929,
     728,   564,   306,   333,   588,   425,   134,   508,   255,   534,
      22,    68,    75,   105,   174,   337,   517,   517,   924,   533,
     307,   307,    59,   254,    59,   627,   663,   664,   678,   426,
     429,   837,   552,   555,   426,   926,   426,   479,   866,   896,
     426,   872,   893,   229,   407,   877,   878,   939,    47,   803,
     879,   646,   657,   479,   665,   535,   425,   667,   667,   925,
     535,   593,   865,   896,   670,   287,   615,   693,   896,   896,
     626,   627,   626,   627,   926,   500,   699,    34,   169,   145,
     151,   266,   327,   251,   527,   528,   529,   347,   569,   140,
     614,   865,   281,   511,   426,   534,   254,   254,   426,   429,
     680,   685,   117,   426,   426,   426,   426,   379,   429,    31,
     893,   283,   307,   883,   150,   666,   389,   526,   694,   520,
     593,   426,   615,   426,   426,   392,   122,   109,   373,   251,
     529,   251,   528,   927,   627,    31,   426,   933,   392,   482,
     664,   684,    23,   184,   716,   878,   880,    41,    87,   365,
     865,   884,   885,   884,   426,   644,   667,   425,   593,   426,
     523,   933,   627,   306,    50,   229,   299,   322,   530,   530,
     611,   425,   481,   534,   238,   425,   711,   713,   718,   768,
     773,   779,   790,   885,   306,   144,   272,   144,   272,   479,
     865,   527,   670,   589,    17,   104,   242,     4,     6,     7,
     590,   591,   935,   936,   939,   837,   712,   713,   714,   791,
     792,    28,   426,   593,   134,   426,   429,   426,   428,   885,
     281,   591,   714,   933,   425,   590,   426
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (&yylloc, yyscanner, YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc, yyscanner)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location, yyscanner); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
  YYUSE (yyscanner);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, core_yyscan_t yyscanner)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp, yyscanner);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, core_yyscan_t yyscanner)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule, yyscanner)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
    core_yyscan_t yyscanner;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       , yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule, yyscanner); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, core_yyscan_t yyscanner)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp, yyscanner)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
    core_yyscan_t yyscanner;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (yyscanner);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (core_yyscan_t yyscanner);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */





/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (core_yyscan_t yyscanner)
#else
int
yyparse (yyscanner)
    core_yyscan_t yyscanner;
#endif
#endif
{
/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

    /* Number of syntax errors so far.  */
    int yynerrs;

    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 624 "gram.y"
    {
				pg_yyget_extra(yyscanner)->parsetree = (yyvsp[(1) - (1)].list);
			;}
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 631 "gram.y"
    {
					if ((yyvsp[(3) - (3)].node) != NULL)
						(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
					else
						(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 638 "gram.y"
    {
					if ((yyvsp[(1) - (1)].node) != NULL)
						(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
					else
						(yyval.list) = NIL;
				;}
    break;

  case 107:

/* Line 1455 of yacc.c  */
#line 750 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 108:

/* Line 1455 of yacc.c  */
#line 761 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_ROLE;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 109:

/* Line 1455 of yacc.c  */
#line 771 "gram.y"
    {;}
    break;

  case 110:

/* Line 1455 of yacc.c  */
#line 772 "gram.y"
    {;}
    break;

  case 111:

/* Line 1455 of yacc.c  */
#line 781 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 112:

/* Line 1455 of yacc.c  */
#line 782 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 113:

/* Line 1455 of yacc.c  */
#line 786 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 114:

/* Line 1455 of yacc.c  */
#line 787 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 115:

/* Line 1455 of yacc.c  */
#line 792 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password",
									 (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 116:

/* Line 1455 of yacc.c  */
#line 797 "gram.y"
    {
					(yyval.defelt) = makeDefElem("password", NULL);
				;}
    break;

  case 117:

/* Line 1455 of yacc.c  */
#line 801 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 118:

/* Line 1455 of yacc.c  */
#line 806 "gram.y"
    {
					(yyval.defelt) = makeDefElem("unencryptedPassword",
									 (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 119:

/* Line 1455 of yacc.c  */
#line 811 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 120:

/* Line 1455 of yacc.c  */
#line 815 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 121:

/* Line 1455 of yacc.c  */
#line 819 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(TRUE));
				;}
    break;

  case 122:

/* Line 1455 of yacc.c  */
#line 823 "gram.y"
    {
					(yyval.defelt) = makeDefElem("inherit", (Node *)makeInteger(FALSE));
				;}
    break;

  case 123:

/* Line 1455 of yacc.c  */
#line 827 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(TRUE));
				;}
    break;

  case 124:

/* Line 1455 of yacc.c  */
#line 831 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createdb", (Node *)makeInteger(FALSE));
				;}
    break;

  case 125:

/* Line 1455 of yacc.c  */
#line 835 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(TRUE));
				;}
    break;

  case 126:

/* Line 1455 of yacc.c  */
#line 839 "gram.y"
    {
					(yyval.defelt) = makeDefElem("createrole", (Node *)makeInteger(FALSE));
				;}
    break;

  case 127:

/* Line 1455 of yacc.c  */
#line 843 "gram.y"
    {
					/* For backwards compatibility, synonym for SUPERUSER */
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(TRUE));
				;}
    break;

  case 128:

/* Line 1455 of yacc.c  */
#line 848 "gram.y"
    {
					(yyval.defelt) = makeDefElem("superuser", (Node *)makeInteger(FALSE));
				;}
    break;

  case 129:

/* Line 1455 of yacc.c  */
#line 852 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(TRUE));
				;}
    break;

  case 130:

/* Line 1455 of yacc.c  */
#line 856 "gram.y"
    {
					(yyval.defelt) = makeDefElem("canlogin", (Node *)makeInteger(FALSE));
				;}
    break;

  case 131:

/* Line 1455 of yacc.c  */
#line 860 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 132:

/* Line 1455 of yacc.c  */
#line 864 "gram.y"
    {
					(yyval.defelt) = makeDefElem("validUntil", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 133:

/* Line 1455 of yacc.c  */
#line 869 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 134:

/* Line 1455 of yacc.c  */
#line 875 "gram.y"
    { (yyval.defelt) = (yyvsp[(1) - (1)].defelt); ;}
    break;

  case 135:

/* Line 1455 of yacc.c  */
#line 878 "gram.y"
    {
					(yyval.defelt) = makeDefElem("sysid", (Node *)makeInteger((yyvsp[(2) - (2)].ival)));
				;}
    break;

  case 136:

/* Line 1455 of yacc.c  */
#line 882 "gram.y"
    {
					(yyval.defelt) = makeDefElem("adminmembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 137:

/* Line 1455 of yacc.c  */
#line 886 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rolemembers", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 138:

/* Line 1455 of yacc.c  */
#line 890 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 139:

/* Line 1455 of yacc.c  */
#line 894 "gram.y"
    {
					(yyval.defelt) = makeDefElem("addroleto", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 140:

/* Line 1455 of yacc.c  */
#line 908 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_USER;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 141:

/* Line 1455 of yacc.c  */
#line 926 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 142:

/* Line 1455 of yacc.c  */
#line 936 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 143:

/* Line 1455 of yacc.c  */
#line 937 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 144:

/* Line 1455 of yacc.c  */
#line 942 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->database = (yyvsp[(4) - (5)].str);
					n->setstmt = (yyvsp[(5) - (5)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 145:

/* Line 1455 of yacc.c  */
#line 960 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (5)].str);
					n->action = +1;	/* add, if there are members */
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 146:

/* Line 1455 of yacc.c  */
#line 972 "gram.y"
    {
					AlterRoleSetStmt *n = makeNode(AlterRoleSetStmt);
					n->role = (yyvsp[(3) - (4)].str);
					n->database = NULL;
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 147:

/* Line 1455 of yacc.c  */
#line 993 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 148:

/* Line 1455 of yacc.c  */
#line 1000 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 149:

/* Line 1455 of yacc.c  */
#line 1019 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 150:

/* Line 1455 of yacc.c  */
#line 1026 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->roles = (yyvsp[(5) - (5)].list);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 151:

/* Line 1455 of yacc.c  */
#line 1043 "gram.y"
    {
					CreateRoleStmt *n = makeNode(CreateRoleStmt);
					n->stmt_type = ROLESTMT_GROUP;
					n->role = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 152:

/* Line 1455 of yacc.c  */
#line 1061 "gram.y"
    {
					AlterRoleStmt *n = makeNode(AlterRoleStmt);
					n->role = (yyvsp[(3) - (6)].str);
					n->action = (yyvsp[(4) - (6)].ival);
					n->options = list_make1(makeDefElem("rolemembers",
														(Node *)(yyvsp[(6) - (6)].list)));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 153:

/* Line 1455 of yacc.c  */
#line 1071 "gram.y"
    { (yyval.ival) = +1; ;}
    break;

  case 154:

/* Line 1455 of yacc.c  */
#line 1072 "gram.y"
    { (yyval.ival) = -1; ;}
    break;

  case 155:

/* Line 1455 of yacc.c  */
#line 1085 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = FALSE;
					n->roles = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 156:

/* Line 1455 of yacc.c  */
#line 1092 "gram.y"
    {
					DropRoleStmt *n = makeNode(DropRoleStmt);
					n->missing_ok = TRUE;
					n->roles = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 157:

/* Line 1455 of yacc.c  */
#line 1109 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* One can omit the schema name or the authorization id. */
					if ((yyvsp[(3) - (6)].str) != NULL)
						n->schemaname = (yyvsp[(3) - (6)].str);
					else
						n->schemaname = (yyvsp[(5) - (6)].str);
					n->authid = (yyvsp[(5) - (6)].str);
					n->schemaElts = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 158:

/* Line 1455 of yacc.c  */
#line 1121 "gram.y"
    {
					CreateSchemaStmt *n = makeNode(CreateSchemaStmt);
					/* ...but not both */
					n->schemaname = (yyvsp[(3) - (4)].str);
					n->authid = NULL;
					n->schemaElts = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 159:

/* Line 1455 of yacc.c  */
#line 1132 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 160:

/* Line 1455 of yacc.c  */
#line 1133 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 161:

/* Line 1455 of yacc.c  */
#line 1137 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 162:

/* Line 1455 of yacc.c  */
#line 1138 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 169:

/* Line 1455 of yacc.c  */
#line 1166 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(2) - (2)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 170:

/* Line 1455 of yacc.c  */
#line 1172 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 171:

/* Line 1455 of yacc.c  */
#line 1178 "gram.y"
    {
					VariableSetStmt *n = (yyvsp[(3) - (3)].vsetstmt);
					n->is_local = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 172:

/* Line 1455 of yacc.c  */
#line 1187 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 173:

/* Line 1455 of yacc.c  */
#line 1195 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = (yyvsp[(1) - (3)].str);
					n->args = (yyvsp[(3) - (3)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 174:

/* Line 1455 of yacc.c  */
#line 1203 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 175:

/* Line 1455 of yacc.c  */
#line 1210 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 176:

/* Line 1455 of yacc.c  */
#line 1217 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_CURRENT;
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 177:

/* Line 1455 of yacc.c  */
#line 1225 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "timezone";
					if ((yyvsp[(3) - (3)].node) != NULL)
						n->args = list_make1((yyvsp[(3) - (3)].node));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 178:

/* Line 1455 of yacc.c  */
#line 1236 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "TRANSACTION";
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 179:

/* Line 1455 of yacc.c  */
#line 1244 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_MULTI;
					n->name = "SESSION CHARACTERISTICS";
					n->args = (yyvsp[(5) - (5)].list);
					(yyval.vsetstmt) = n;
				;}
    break;

  case 180:

/* Line 1455 of yacc.c  */
#line 1252 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("current database cannot be changed"),
							 parser_errposition((yylsp[(2) - (2)]))));
					(yyval.vsetstmt) = NULL; /*not reached*/
				;}
    break;

  case 181:

/* Line 1455 of yacc.c  */
#line 1260 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "search_path";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 182:

/* Line 1455 of yacc.c  */
#line 1268 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "client_encoding";
					if ((yyvsp[(2) - (2)].str) != NULL)
						n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					else
						n->kind = VAR_SET_DEFAULT;
					(yyval.vsetstmt) = n;
				;}
    break;

  case 183:

/* Line 1455 of yacc.c  */
#line 1279 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "role";
					n->args = list_make1(makeStringConst((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 184:

/* Line 1455 of yacc.c  */
#line 1287 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "session_authorization";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 185:

/* Line 1455 of yacc.c  */
#line 1295 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_DEFAULT;
					n->name = "session_authorization";
					(yyval.vsetstmt) = n;
				;}
    break;

  case 186:

/* Line 1455 of yacc.c  */
#line 1302 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_SET_VALUE;
					n->name = "xmloption";
					n->args = list_make1(makeStringConst((yyvsp[(3) - (3)].ival) == XMLOPTION_DOCUMENT ? "DOCUMENT" : "CONTENT", (yylsp[(3) - (3)])));
					(yyval.vsetstmt) = n;
				;}
    break;

  case 187:

/* Line 1455 of yacc.c  */
#line 1311 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 188:

/* Line 1455 of yacc.c  */
#line 1313 "gram.y"
    {
					(yyval.str) = palloc(strlen((yyvsp[(1) - (3)].str)) + strlen((yyvsp[(3) - (3)].str)) + 2);
					sprintf((yyval.str), "%s.%s", (yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str));
				;}
    break;

  case 189:

/* Line 1455 of yacc.c  */
#line 1319 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 190:

/* Line 1455 of yacc.c  */
#line 1320 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 191:

/* Line 1455 of yacc.c  */
#line 1324 "gram.y"
    { (yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)])); ;}
    break;

  case 192:

/* Line 1455 of yacc.c  */
#line 1326 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 193:

/* Line 1455 of yacc.c  */
#line 1329 "gram.y"
    { (yyval.str) = "read uncommitted"; ;}
    break;

  case 194:

/* Line 1455 of yacc.c  */
#line 1330 "gram.y"
    { (yyval.str) = "read committed"; ;}
    break;

  case 195:

/* Line 1455 of yacc.c  */
#line 1331 "gram.y"
    { (yyval.str) = "repeatable read"; ;}
    break;

  case 196:

/* Line 1455 of yacc.c  */
#line 1332 "gram.y"
    { (yyval.str) = "serializable"; ;}
    break;

  case 197:

/* Line 1455 of yacc.c  */
#line 1336 "gram.y"
    { (yyval.str) = "true"; ;}
    break;

  case 198:

/* Line 1455 of yacc.c  */
#line 1337 "gram.y"
    { (yyval.str) = "false"; ;}
    break;

  case 199:

/* Line 1455 of yacc.c  */
#line 1338 "gram.y"
    { (yyval.str) = "on"; ;}
    break;

  case 200:

/* Line 1455 of yacc.c  */
#line 1344 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 201:

/* Line 1455 of yacc.c  */
#line 1357 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 202:

/* Line 1455 of yacc.c  */
#line 1361 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 203:

/* Line 1455 of yacc.c  */
#line 1365 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					if ((yyvsp[(3) - (3)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(3) - (3)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(3) - (3)]))));
					}
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 204:

/* Line 1455 of yacc.c  */
#line 1380 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						A_Const *n = (A_Const *) linitial((yyvsp[(6) - (6)].list));
						if ((n->val.val.ival & ~(INTERVAL_MASK(HOUR) | INTERVAL_MASK(MINUTE))) != 0)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("time zone interval must be HOUR or HOUR TO MINUTE"),
									 parser_errposition((yylsp[(6) - (6)]))));
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 205:

/* Line 1455 of yacc.c  */
#line 1402 "gram.y"
    { (yyval.node) = makeAConst((yyvsp[(1) - (1)].value), (yylsp[(1) - (1)])); ;}
    break;

  case 206:

/* Line 1455 of yacc.c  */
#line 1403 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 207:

/* Line 1455 of yacc.c  */
#line 1404 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 208:

/* Line 1455 of yacc.c  */
#line 1408 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 209:

/* Line 1455 of yacc.c  */
#line 1409 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 210:

/* Line 1455 of yacc.c  */
#line 1410 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 211:

/* Line 1455 of yacc.c  */
#line 1414 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 212:

/* Line 1455 of yacc.c  */
#line 1415 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 213:

/* Line 1455 of yacc.c  */
#line 1420 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 214:

/* Line 1455 of yacc.c  */
#line 1427 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 215:

/* Line 1455 of yacc.c  */
#line 1434 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 216:

/* Line 1455 of yacc.c  */
#line 1441 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET;
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 217:

/* Line 1455 of yacc.c  */
#line 1448 "gram.y"
    {
					VariableSetStmt *n = makeNode(VariableSetStmt);
					n->kind = VAR_RESET_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 218:

/* Line 1455 of yacc.c  */
#line 1457 "gram.y"
    { (yyval.vsetstmt) = (yyvsp[(2) - (2)].vsetstmt); ;}
    break;

  case 219:

/* Line 1455 of yacc.c  */
#line 1458 "gram.y"
    { (yyval.vsetstmt) = (VariableSetStmt *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 220:

/* Line 1455 of yacc.c  */
#line 1464 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 221:

/* Line 1455 of yacc.c  */
#line 1470 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "timezone";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 222:

/* Line 1455 of yacc.c  */
#line 1476 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "transaction_isolation";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 223:

/* Line 1455 of yacc.c  */
#line 1482 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "session_authorization";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 224:

/* Line 1455 of yacc.c  */
#line 1488 "gram.y"
    {
					VariableShowStmt *n = makeNode(VariableShowStmt);
					n->name = "all";
					(yyval.node) = (Node *) n;
				;}
    break;

  case 225:

/* Line 1455 of yacc.c  */
#line 1498 "gram.y"
    {
					ConstraintsSetStmt *n = makeNode(ConstraintsSetStmt);
					n->constraints = (yyvsp[(3) - (4)].list);
					n->deferred    = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 226:

/* Line 1455 of yacc.c  */
#line 1507 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 227:

/* Line 1455 of yacc.c  */
#line 1508 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 228:

/* Line 1455 of yacc.c  */
#line 1512 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 229:

/* Line 1455 of yacc.c  */
#line 1513 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 230:

/* Line 1455 of yacc.c  */
#line 1522 "gram.y"
    {
					CheckPointStmt *n = makeNode(CheckPointStmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 231:

/* Line 1455 of yacc.c  */
#line 1537 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_ALL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 232:

/* Line 1455 of yacc.c  */
#line 1543 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 233:

/* Line 1455 of yacc.c  */
#line 1549 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_TEMP;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 234:

/* Line 1455 of yacc.c  */
#line 1555 "gram.y"
    {
					DiscardStmt *n = makeNode(DiscardStmt);
					n->target = DISCARD_PLANS;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 235:

/* Line 1455 of yacc.c  */
#line 1573 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_TABLE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 236:

/* Line 1455 of yacc.c  */
#line 1581 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_INDEX;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 237:

/* Line 1455 of yacc.c  */
#line 1589 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_SEQUENCE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 238:

/* Line 1455 of yacc.c  */
#line 1597 "gram.y"
    {
					AlterTableStmt *n = makeNode(AlterTableStmt);
					n->relation = (yyvsp[(3) - (4)].range);
					n->cmds = (yyvsp[(4) - (4)].list);
					n->relkind = OBJECT_VIEW;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 239:

/* Line 1455 of yacc.c  */
#line 1607 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 240:

/* Line 1455 of yacc.c  */
#line 1608 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 241:

/* Line 1455 of yacc.c  */
#line 1614 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 242:

/* Line 1455 of yacc.c  */
#line 1622 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddColumn;
					n->def = (yyvsp[(3) - (3)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 243:

/* Line 1455 of yacc.c  */
#line 1630 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ColumnDefault;
					n->name = (yyvsp[(3) - (4)].str);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 244:

/* Line 1455 of yacc.c  */
#line 1639 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 245:

/* Line 1455 of yacc.c  */
#line 1647 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetNotNull;
					n->name = (yyvsp[(3) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 246:

/* Line 1455 of yacc.c  */
#line 1655 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStatistics;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeInteger((yyvsp[(6) - (6)].ival));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 247:

/* Line 1455 of yacc.c  */
#line 1664 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 248:

/* Line 1455 of yacc.c  */
#line 1673 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetOptions;
					n->name = (yyvsp[(3) - (5)].str);
					n->def = (Node *) (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 249:

/* Line 1455 of yacc.c  */
#line 1682 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetStorage;
					n->name = (yyvsp[(3) - (6)].str);
					n->def = (Node *) makeString((yyvsp[(6) - (6)].str));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 250:

/* Line 1455 of yacc.c  */
#line 1691 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 251:

/* Line 1455 of yacc.c  */
#line 1701 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropColumn;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 252:

/* Line 1455 of yacc.c  */
#line 1714 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AlterColumnType;
					n->name = (yyvsp[(3) - (7)].str);
					n->def = (Node *) (yyvsp[(6) - (7)].typnam);
					n->transform = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 253:

/* Line 1455 of yacc.c  */
#line 1724 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddConstraint;
					n->def = (yyvsp[(2) - (2)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 254:

/* Line 1455 of yacc.c  */
#line 1732 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(5) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 255:

/* Line 1455 of yacc.c  */
#line 1742 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropConstraint;
					n->name = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 256:

/* Line 1455 of yacc.c  */
#line 1752 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 257:

/* Line 1455 of yacc.c  */
#line 1759 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropOids;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 258:

/* Line 1455 of yacc.c  */
#line 1766 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ClusterOn;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 259:

/* Line 1455 of yacc.c  */
#line 1774 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropCluster;
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 260:

/* Line 1455 of yacc.c  */
#line 1782 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 261:

/* Line 1455 of yacc.c  */
#line 1790 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 262:

/* Line 1455 of yacc.c  */
#line 1798 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaTrig;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 263:

/* Line 1455 of yacc.c  */
#line 1806 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 264:

/* Line 1455 of yacc.c  */
#line 1813 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 265:

/* Line 1455 of yacc.c  */
#line 1820 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrig;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 266:

/* Line 1455 of yacc.c  */
#line 1828 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigAll;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 267:

/* Line 1455 of yacc.c  */
#line 1835 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableTrigUser;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 268:

/* Line 1455 of yacc.c  */
#line 1842 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 269:

/* Line 1455 of yacc.c  */
#line 1850 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableAlwaysRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 270:

/* Line 1455 of yacc.c  */
#line 1858 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_EnableReplicaRule;
					n->name = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 271:

/* Line 1455 of yacc.c  */
#line 1866 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DisableRule;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 272:

/* Line 1455 of yacc.c  */
#line 1874 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_AddInherit;
					n->def = (Node *) (yyvsp[(2) - (2)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 273:

/* Line 1455 of yacc.c  */
#line 1882 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_DropInherit;
					n->def = (Node *) (yyvsp[(3) - (3)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 274:

/* Line 1455 of yacc.c  */
#line 1890 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ChangeOwner;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 275:

/* Line 1455 of yacc.c  */
#line 1898 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetTableSpace;
					n->name = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 276:

/* Line 1455 of yacc.c  */
#line 1906 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_SetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 277:

/* Line 1455 of yacc.c  */
#line 1914 "gram.y"
    {
					AlterTableCmd *n = makeNode(AlterTableCmd);
					n->subtype = AT_ResetRelOptions;
					n->def = (Node *)(yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 278:

/* Line 1455 of yacc.c  */
#line 1923 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (3)].node); ;}
    break;

  case 279:

/* Line 1455 of yacc.c  */
#line 1924 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 280:

/* Line 1455 of yacc.c  */
#line 1928 "gram.y"
    { (yyval.dbehavior) = DROP_CASCADE; ;}
    break;

  case 281:

/* Line 1455 of yacc.c  */
#line 1929 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; ;}
    break;

  case 282:

/* Line 1455 of yacc.c  */
#line 1930 "gram.y"
    { (yyval.dbehavior) = DROP_RESTRICT; /* default */ ;}
    break;

  case 283:

/* Line 1455 of yacc.c  */
#line 1934 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 284:

/* Line 1455 of yacc.c  */
#line 1935 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 285:

/* Line 1455 of yacc.c  */
#line 1939 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 286:

/* Line 1455 of yacc.c  */
#line 1942 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 287:

/* Line 1455 of yacc.c  */
#line 1943 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 288:

/* Line 1455 of yacc.c  */
#line 1947 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 289:

/* Line 1455 of yacc.c  */
#line 1948 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 290:

/* Line 1455 of yacc.c  */
#line 1954 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 291:

/* Line 1455 of yacc.c  */
#line 1958 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 292:

/* Line 1455 of yacc.c  */
#line 1962 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (5)].str), (yyvsp[(3) - (5)].str), (Node *) (yyvsp[(5) - (5)].node),
											 DEFELEM_UNSPEC);
				;}
    break;

  case 293:

/* Line 1455 of yacc.c  */
#line 1967 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended((yyvsp[(1) - (3)].str), (yyvsp[(3) - (3)].str), NULL, DEFELEM_UNSPEC);
				;}
    break;

  case 294:

/* Line 1455 of yacc.c  */
#line 1982 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 295:

/* Line 1455 of yacc.c  */
#line 1988 "gram.y"
    {
					ClosePortalStmt *n = makeNode(ClosePortalStmt);
					n->portalname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 296:

/* Line 1455 of yacc.c  */
#line 2016 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = (yyvsp[(3) - (10)].range);
					n->query = NULL;
					n->attlist = (yyvsp[(4) - (10)].list);
					n->is_from = (yyvsp[(6) - (10)].boolean);
					n->filename = (yyvsp[(7) - (10)].str);

					n->options = NIL;
					/* Concatenate user-supplied flags */
					if ((yyvsp[(2) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(2) - (10)].defelt));
					if ((yyvsp[(5) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(5) - (10)].defelt));
					if ((yyvsp[(8) - (10)].defelt))
						n->options = lappend(n->options, (yyvsp[(8) - (10)].defelt));
					if ((yyvsp[(10) - (10)].list))
						n->options = list_concat(n->options, (yyvsp[(10) - (10)].list));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 297:

/* Line 1455 of yacc.c  */
#line 2037 "gram.y"
    {
					CopyStmt *n = makeNode(CopyStmt);
					n->relation = NULL;
					n->query = (yyvsp[(2) - (6)].node);
					n->attlist = NIL;
					n->is_from = false;
					n->filename = (yyvsp[(4) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 298:

/* Line 1455 of yacc.c  */
#line 2050 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 299:

/* Line 1455 of yacc.c  */
#line 2051 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 300:

/* Line 1455 of yacc.c  */
#line 2060 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 301:

/* Line 1455 of yacc.c  */
#line 2061 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 302:

/* Line 1455 of yacc.c  */
#line 2062 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 303:

/* Line 1455 of yacc.c  */
#line 2065 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 304:

/* Line 1455 of yacc.c  */
#line 2066 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 305:

/* Line 1455 of yacc.c  */
#line 2071 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 306:

/* Line 1455 of yacc.c  */
#line 2072 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 307:

/* Line 1455 of yacc.c  */
#line 2077 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 308:

/* Line 1455 of yacc.c  */
#line 2081 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 309:

/* Line 1455 of yacc.c  */
#line 2085 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 310:

/* Line 1455 of yacc.c  */
#line 2089 "gram.y"
    {
					(yyval.defelt) = makeDefElem("null", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 311:

/* Line 1455 of yacc.c  */
#line 2093 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("csv"));
				;}
    break;

  case 312:

/* Line 1455 of yacc.c  */
#line 2097 "gram.y"
    {
					(yyval.defelt) = makeDefElem("header", (Node *)makeInteger(TRUE));
				;}
    break;

  case 313:

/* Line 1455 of yacc.c  */
#line 2101 "gram.y"
    {
					(yyval.defelt) = makeDefElem("quote", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 314:

/* Line 1455 of yacc.c  */
#line 2105 "gram.y"
    {
					(yyval.defelt) = makeDefElem("escape", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 315:

/* Line 1455 of yacc.c  */
#line 2109 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 316:

/* Line 1455 of yacc.c  */
#line 2113 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_quote", (Node *)makeNode(A_Star));
				;}
    break;

  case 317:

/* Line 1455 of yacc.c  */
#line 2117 "gram.y"
    {
					(yyval.defelt) = makeDefElem("force_not_null", (Node *)(yyvsp[(4) - (4)].list));
				;}
    break;

  case 318:

/* Line 1455 of yacc.c  */
#line 2126 "gram.y"
    {
					(yyval.defelt) = makeDefElem("format", (Node *)makeString("binary"));
				;}
    break;

  case 319:

/* Line 1455 of yacc.c  */
#line 2129 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 320:

/* Line 1455 of yacc.c  */
#line 2134 "gram.y"
    {
					(yyval.defelt) = makeDefElem("oids", (Node *)makeInteger(TRUE));
				;}
    break;

  case 321:

/* Line 1455 of yacc.c  */
#line 2137 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 322:

/* Line 1455 of yacc.c  */
#line 2142 "gram.y"
    {
					(yyval.defelt) = makeDefElem("delimiter", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 323:

/* Line 1455 of yacc.c  */
#line 2145 "gram.y"
    { (yyval.defelt) = NULL; ;}
    break;

  case 324:

/* Line 1455 of yacc.c  */
#line 2149 "gram.y"
    {;}
    break;

  case 325:

/* Line 1455 of yacc.c  */
#line 2150 "gram.y"
    {;}
    break;

  case 326:

/* Line 1455 of yacc.c  */
#line 2156 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 327:

/* Line 1455 of yacc.c  */
#line 2160 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 328:

/* Line 1455 of yacc.c  */
#line 2167 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 329:

/* Line 1455 of yacc.c  */
#line 2173 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 330:

/* Line 1455 of yacc.c  */
#line 2174 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 331:

/* Line 1455 of yacc.c  */
#line 2175 "gram.y"
    { (yyval.node) = (Node *) makeNode(A_Star); ;}
    break;

  case 332:

/* Line 1455 of yacc.c  */
#line 2176 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(2) - (3)].list); ;}
    break;

  case 333:

/* Line 1455 of yacc.c  */
#line 2177 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 334:

/* Line 1455 of yacc.c  */
#line 2182 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 335:

/* Line 1455 of yacc.c  */
#line 2186 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 336:

/* Line 1455 of yacc.c  */
#line 2193 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 337:

/* Line 1455 of yacc.c  */
#line 2206 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (11)].range)->istemp = (yyvsp[(2) - (11)].boolean);
					n->relation = (yyvsp[(4) - (11)].range);
					n->tableElts = (yyvsp[(6) - (11)].list);
					n->inhRelations = (yyvsp[(8) - (11)].list);
					n->constraints = NIL;
					n->options = (yyvsp[(9) - (11)].list);
					n->oncommit = (yyvsp[(10) - (11)].oncommit);
					n->tablespacename = (yyvsp[(11) - (11)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 338:

/* Line 1455 of yacc.c  */
#line 2220 "gram.y"
    {
					CreateStmt *n = makeNode(CreateStmt);
					(yyvsp[(4) - (10)].range)->istemp = (yyvsp[(2) - (10)].boolean);
					n->relation = (yyvsp[(4) - (10)].range);
					n->tableElts = (yyvsp[(7) - (10)].list);
					n->ofTypename = makeTypeNameFromNameList((yyvsp[(6) - (10)].list));
					n->ofTypename->location = (yylsp[(6) - (10)]);
					n->constraints = NIL;
					n->options = (yyvsp[(8) - (10)].list);
					n->oncommit = (yyvsp[(9) - (10)].oncommit);
					n->tablespacename = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 339:

/* Line 1455 of yacc.c  */
#line 2242 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 340:

/* Line 1455 of yacc.c  */
#line 2243 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 341:

/* Line 1455 of yacc.c  */
#line 2244 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 342:

/* Line 1455 of yacc.c  */
#line 2245 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 343:

/* Line 1455 of yacc.c  */
#line 2246 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 344:

/* Line 1455 of yacc.c  */
#line 2247 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 345:

/* Line 1455 of yacc.c  */
#line 2248 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 346:

/* Line 1455 of yacc.c  */
#line 2252 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 347:

/* Line 1455 of yacc.c  */
#line 2253 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 348:

/* Line 1455 of yacc.c  */
#line 2257 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 349:

/* Line 1455 of yacc.c  */
#line 2258 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 350:

/* Line 1455 of yacc.c  */
#line 2263 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 351:

/* Line 1455 of yacc.c  */
#line 2267 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 352:

/* Line 1455 of yacc.c  */
#line 2274 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 353:

/* Line 1455 of yacc.c  */
#line 2278 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 354:

/* Line 1455 of yacc.c  */
#line 2284 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 355:

/* Line 1455 of yacc.c  */
#line 2285 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 356:

/* Line 1455 of yacc.c  */
#line 2286 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 357:

/* Line 1455 of yacc.c  */
#line 2290 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 358:

/* Line 1455 of yacc.c  */
#line 2291 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 359:

/* Line 1455 of yacc.c  */
#line 2295 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (3)].str);
					n->typeName = (yyvsp[(2) - (3)].typnam);
					n->constraints = (yyvsp[(3) - (3)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 360:

/* Line 1455 of yacc.c  */
#line 2306 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (4)].str);
					n->constraints = (yyvsp[(4) - (4)].list);
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 361:

/* Line 1455 of yacc.c  */
#line 2316 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 362:

/* Line 1455 of yacc.c  */
#line 2317 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 363:

/* Line 1455 of yacc.c  */
#line 2322 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 364:

/* Line 1455 of yacc.c  */
#line 2329 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 365:

/* Line 1455 of yacc.c  */
#line 2330 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 366:

/* Line 1455 of yacc.c  */
#line 2350 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NOTNULL;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 367:

/* Line 1455 of yacc.c  */
#line 2357 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 368:

/* Line 1455 of yacc.c  */
#line 2364 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (3)]);
					n->keys = NULL;
					n->options = (yyvsp[(2) - (3)].list);
					n->indexspace = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 369:

/* Line 1455 of yacc.c  */
#line 2374 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (4)]);
					n->keys = NULL;
					n->options = (yyvsp[(3) - (4)].list);
					n->indexspace = (yyvsp[(4) - (4)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 370:

/* Line 1455 of yacc.c  */
#line 2384 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (4)]);
					n->raw_expr = (yyvsp[(3) - (4)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 371:

/* Line 1455 of yacc.c  */
#line 2393 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_DEFAULT;
					n->location = (yylsp[(1) - (2)]);
					n->raw_expr = (yyvsp[(2) - (2)].node);
					n->cooked_expr = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 372:

/* Line 1455 of yacc.c  */
#line 2402 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (5)]);
					n->pktable			= (yyvsp[(2) - (5)].range);
					n->fk_attrs			= NIL;
					n->pk_attrs			= (yyvsp[(3) - (5)].list);
					n->fk_matchtype		= (yyvsp[(4) - (5)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(5) - (5)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(5) - (5)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 373:

/* Line 1455 of yacc.c  */
#line 2431 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRABLE;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 374:

/* Line 1455 of yacc.c  */
#line 2438 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_NOT_DEFERRABLE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 375:

/* Line 1455 of yacc.c  */
#line 2445 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_DEFERRED;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 376:

/* Line 1455 of yacc.c  */
#line 2452 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_ATTR_IMMEDIATE;
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 377:

/* Line 1455 of yacc.c  */
#line 2471 "gram.y"
    {
					InhRelation *n = makeNode(InhRelation);
					n->relation = (yyvsp[(2) - (3)].range);
					n->options = (yyvsp[(3) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 378:

/* Line 1455 of yacc.c  */
#line 2480 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 379:

/* Line 1455 of yacc.c  */
#line 2481 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) & ~(yyvsp[(3) - (3)].ival); ;}
    break;

  case 380:

/* Line 1455 of yacc.c  */
#line 2482 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 381:

/* Line 1455 of yacc.c  */
#line 2486 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_DEFAULTS; ;}
    break;

  case 382:

/* Line 1455 of yacc.c  */
#line 2487 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_CONSTRAINTS; ;}
    break;

  case 383:

/* Line 1455 of yacc.c  */
#line 2488 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_INDEXES; ;}
    break;

  case 384:

/* Line 1455 of yacc.c  */
#line 2489 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_STORAGE; ;}
    break;

  case 385:

/* Line 1455 of yacc.c  */
#line 2490 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_COMMENTS; ;}
    break;

  case 386:

/* Line 1455 of yacc.c  */
#line 2491 "gram.y"
    { (yyval.ival) = CREATE_TABLE_LIKE_ALL; ;}
    break;

  case 387:

/* Line 1455 of yacc.c  */
#line 2501 "gram.y"
    {
					Constraint *n = (Constraint *) (yyvsp[(3) - (3)].node);
					Assert(IsA(n, Constraint));
					n->conname = (yyvsp[(2) - (3)].str);
					n->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 388:

/* Line 1455 of yacc.c  */
#line 2508 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 389:

/* Line 1455 of yacc.c  */
#line 2513 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_CHECK;
					n->location = (yylsp[(1) - (5)]);
					n->raw_expr = (yyvsp[(3) - (5)].node);
					n->cooked_expr = NULL;
					if ((yyvsp[(5) - (5)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("CHECK constraints cannot be deferred"),
								 parser_errposition((yylsp[(5) - (5)]))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 390:

/* Line 1455 of yacc.c  */
#line 2528 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_UNIQUE;
					n->location = (yylsp[(1) - (7)]);
					n->keys = (yyvsp[(3) - (7)].list);
					n->options = (yyvsp[(5) - (7)].list);
					n->indexspace = (yyvsp[(6) - (7)].str);
					n->deferrable = ((yyvsp[(7) - (7)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(7) - (7)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 391:

/* Line 1455 of yacc.c  */
#line 2541 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_PRIMARY;
					n->location = (yylsp[(1) - (8)]);
					n->keys = (yyvsp[(4) - (8)].list);
					n->options = (yyvsp[(6) - (8)].list);
					n->indexspace = (yyvsp[(7) - (8)].str);
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 392:

/* Line 1455 of yacc.c  */
#line 2555 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_EXCLUSION;
					n->location = (yylsp[(1) - (9)]);
					n->access_method	= (yyvsp[(2) - (9)].str);
					n->exclusions		= (yyvsp[(4) - (9)].list);
					n->options			= (yyvsp[(6) - (9)].list);
					n->indexspace		= (yyvsp[(7) - (9)].str);
					n->where_clause		= (yyvsp[(8) - (9)].node);
					n->deferrable		= ((yyvsp[(9) - (9)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(9) - (9)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 393:

/* Line 1455 of yacc.c  */
#line 2570 "gram.y"
    {
					Constraint *n = makeNode(Constraint);
					n->contype = CONSTR_FOREIGN;
					n->location = (yylsp[(1) - (11)]);
					n->pktable			= (yyvsp[(7) - (11)].range);
					n->fk_attrs			= (yyvsp[(4) - (11)].list);
					n->pk_attrs			= (yyvsp[(8) - (11)].list);
					n->fk_matchtype		= (yyvsp[(9) - (11)].ival);
					n->fk_upd_action	= (char) ((yyvsp[(10) - (11)].ival) >> 8);
					n->fk_del_action	= (char) ((yyvsp[(10) - (11)].ival) & 0xFF);
					n->skip_validation  = FALSE;
					n->deferrable		= ((yyvsp[(11) - (11)].ival) & 1) != 0;
					n->initdeferred		= ((yyvsp[(11) - (11)].ival) & 2) != 0;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 394:

/* Line 1455 of yacc.c  */
#line 2588 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 395:

/* Line 1455 of yacc.c  */
#line 2589 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 396:

/* Line 1455 of yacc.c  */
#line 2593 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 397:

/* Line 1455 of yacc.c  */
#line 2594 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 398:

/* Line 1455 of yacc.c  */
#line 2598 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str));
				;}
    break;

  case 399:

/* Line 1455 of yacc.c  */
#line 2604 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_FULL;
			;}
    break;

  case 400:

/* Line 1455 of yacc.c  */
#line 2608 "gram.y"
    {
				ereport(ERROR,
						(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
						 errmsg("MATCH PARTIAL not yet implemented"),
						 parser_errposition((yylsp[(1) - (2)]))));
				(yyval.ival) = FKCONSTR_MATCH_PARTIAL;
			;}
    break;

  case 401:

/* Line 1455 of yacc.c  */
#line 2616 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 402:

/* Line 1455 of yacc.c  */
#line 2620 "gram.y"
    {
				(yyval.ival) = FKCONSTR_MATCH_UNSPECIFIED;
			;}
    break;

  case 403:

/* Line 1455 of yacc.c  */
#line 2626 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 404:

/* Line 1455 of yacc.c  */
#line 2628 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 405:

/* Line 1455 of yacc.c  */
#line 2632 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (3)].ielem), (yyvsp[(3) - (3)].list));
			;}
    break;

  case 406:

/* Line 1455 of yacc.c  */
#line 2637 "gram.y"
    {
				(yyval.list) = list_make2((yyvsp[(1) - (6)].ielem), (yyvsp[(5) - (6)].list));
			;}
    break;

  case 407:

/* Line 1455 of yacc.c  */
#line 2643 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 408:

/* Line 1455 of yacc.c  */
#line 2644 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 409:

/* Line 1455 of yacc.c  */
#line 2655 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (1)].ival) << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 410:

/* Line 1455 of yacc.c  */
#line 2657 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | ((yyvsp[(1) - (1)].ival) & 0xFF); ;}
    break;

  case 411:

/* Line 1455 of yacc.c  */
#line 2659 "gram.y"
    { (yyval.ival) = ((yyvsp[(1) - (2)].ival) << 8) | ((yyvsp[(2) - (2)].ival) & 0xFF); ;}
    break;

  case 412:

/* Line 1455 of yacc.c  */
#line 2661 "gram.y"
    { (yyval.ival) = ((yyvsp[(2) - (2)].ival) << 8) | ((yyvsp[(1) - (2)].ival) & 0xFF); ;}
    break;

  case 413:

/* Line 1455 of yacc.c  */
#line 2663 "gram.y"
    { (yyval.ival) = (FKCONSTR_ACTION_NOACTION << 8) | (FKCONSTR_ACTION_NOACTION & 0xFF); ;}
    break;

  case 414:

/* Line 1455 of yacc.c  */
#line 2666 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 415:

/* Line 1455 of yacc.c  */
#line 2669 "gram.y"
    { (yyval.ival) = (yyvsp[(3) - (3)].ival); ;}
    break;

  case 416:

/* Line 1455 of yacc.c  */
#line 2673 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_NOACTION; ;}
    break;

  case 417:

/* Line 1455 of yacc.c  */
#line 2674 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_RESTRICT; ;}
    break;

  case 418:

/* Line 1455 of yacc.c  */
#line 2675 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_CASCADE; ;}
    break;

  case 419:

/* Line 1455 of yacc.c  */
#line 2676 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETNULL; ;}
    break;

  case 420:

/* Line 1455 of yacc.c  */
#line 2677 "gram.y"
    { (yyval.ival) = FKCONSTR_ACTION_SETDEFAULT; ;}
    break;

  case 421:

/* Line 1455 of yacc.c  */
#line 2680 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 422:

/* Line 1455 of yacc.c  */
#line 2681 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 423:

/* Line 1455 of yacc.c  */
#line 2686 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 424:

/* Line 1455 of yacc.c  */
#line 2687 "gram.y"
    { (yyval.list) = list_make1(defWithOids(true)); ;}
    break;

  case 425:

/* Line 1455 of yacc.c  */
#line 2688 "gram.y"
    { (yyval.list) = list_make1(defWithOids(false)); ;}
    break;

  case 426:

/* Line 1455 of yacc.c  */
#line 2689 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 427:

/* Line 1455 of yacc.c  */
#line 2692 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DROP; ;}
    break;

  case 428:

/* Line 1455 of yacc.c  */
#line 2693 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_DELETE_ROWS; ;}
    break;

  case 429:

/* Line 1455 of yacc.c  */
#line 2694 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_PRESERVE_ROWS; ;}
    break;

  case 430:

/* Line 1455 of yacc.c  */
#line 2695 "gram.y"
    { (yyval.oncommit) = ONCOMMIT_NOOP; ;}
    break;

  case 431:

/* Line 1455 of yacc.c  */
#line 2698 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 432:

/* Line 1455 of yacc.c  */
#line 2699 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 433:

/* Line 1455 of yacc.c  */
#line 2702 "gram.y"
    { (yyval.str) = (yyvsp[(4) - (4)].str); ;}
    break;

  case 434:

/* Line 1455 of yacc.c  */
#line 2703 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 435:

/* Line 1455 of yacc.c  */
#line 2714 "gram.y"
    {
					/*
					 * When the SelectStmt is a set-operation tree, we must
					 * stuff the INTO information into the leftmost component
					 * Select, because that's where analyze.c will expect
					 * to find it.	Similarly, the output column names must
					 * be attached to that Select's target list.
					 */
					SelectStmt *n = findLeftmostSelect((SelectStmt *) (yyvsp[(6) - (7)].node));
					if (n->intoClause != NULL)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("CREATE TABLE AS cannot specify INTO"),
								 parser_errposition(exprLocation((Node *) n->intoClause))));
					(yyvsp[(4) - (7)].into)->rel->istemp = (yyvsp[(2) - (7)].boolean);
					n->intoClause = (yyvsp[(4) - (7)].into);
					/* Implement WITH NO DATA by forcing top-level LIMIT 0 */
					if (!(yyvsp[(7) - (7)].boolean))
						((SelectStmt *) (yyvsp[(6) - (7)].node))->limitCount = makeIntConst(0, -1);
					(yyval.node) = (yyvsp[(6) - (7)].node);
				;}
    break;

  case 436:

/* Line 1455 of yacc.c  */
#line 2739 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(1) - (5)].range);
					(yyval.into)->colNames = (yyvsp[(2) - (5)].list);
					(yyval.into)->options = (yyvsp[(3) - (5)].list);
					(yyval.into)->onCommit = (yyvsp[(4) - (5)].oncommit);
					(yyval.into)->tableSpaceName = (yyvsp[(5) - (5)].str);
				;}
    break;

  case 437:

/* Line 1455 of yacc.c  */
#line 2750 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 438:

/* Line 1455 of yacc.c  */
#line 2751 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 439:

/* Line 1455 of yacc.c  */
#line 2755 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 440:

/* Line 1455 of yacc.c  */
#line 2756 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 441:

/* Line 1455 of yacc.c  */
#line 2761 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (1)].str);
					n->typeName = NULL;
					n->inhcount = 0;
					n->is_local = true;
					n->is_not_null = false;
					n->raw_default = NULL;
					n->cooked_default = NULL;
					n->constraints = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 442:

/* Line 1455 of yacc.c  */
#line 2776 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 443:

/* Line 1455 of yacc.c  */
#line 2777 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 444:

/* Line 1455 of yacc.c  */
#line 2778 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 445:

/* Line 1455 of yacc.c  */
#line 2792 "gram.y"
    {
					CreateSeqStmt *n = makeNode(CreateSeqStmt);
					(yyvsp[(4) - (5)].range)->istemp = (yyvsp[(2) - (5)].boolean);
					n->sequence = (yyvsp[(4) - (5)].range);
					n->options = (yyvsp[(5) - (5)].list);
					n->ownerId = InvalidOid;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 446:

/* Line 1455 of yacc.c  */
#line 2804 "gram.y"
    {
					AlterSeqStmt *n = makeNode(AlterSeqStmt);
					n->sequence = (yyvsp[(3) - (4)].range);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 447:

/* Line 1455 of yacc.c  */
#line 2812 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 448:

/* Line 1455 of yacc.c  */
#line 2813 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 449:

/* Line 1455 of yacc.c  */
#line 2816 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 450:

/* Line 1455 of yacc.c  */
#line 2817 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 451:

/* Line 1455 of yacc.c  */
#line 2821 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cache", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 452:

/* Line 1455 of yacc.c  */
#line 2825 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(TRUE));
				;}
    break;

  case 453:

/* Line 1455 of yacc.c  */
#line 2829 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cycle", (Node *)makeInteger(FALSE));
				;}
    break;

  case 454:

/* Line 1455 of yacc.c  */
#line 2833 "gram.y"
    {
					(yyval.defelt) = makeDefElem("increment", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 455:

/* Line 1455 of yacc.c  */
#line 2837 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 456:

/* Line 1455 of yacc.c  */
#line 2841 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 457:

/* Line 1455 of yacc.c  */
#line 2845 "gram.y"
    {
					(yyval.defelt) = makeDefElem("maxvalue", NULL);
				;}
    break;

  case 458:

/* Line 1455 of yacc.c  */
#line 2849 "gram.y"
    {
					(yyval.defelt) = makeDefElem("minvalue", NULL);
				;}
    break;

  case 459:

/* Line 1455 of yacc.c  */
#line 2853 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owned_by", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 460:

/* Line 1455 of yacc.c  */
#line 2857 "gram.y"
    {
					(yyval.defelt) = makeDefElem("start", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 461:

/* Line 1455 of yacc.c  */
#line 2861 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", NULL);
				;}
    break;

  case 462:

/* Line 1455 of yacc.c  */
#line 2865 "gram.y"
    {
					(yyval.defelt) = makeDefElem("restart", (Node *)(yyvsp[(3) - (3)].value));
				;}
    break;

  case 463:

/* Line 1455 of yacc.c  */
#line 2870 "gram.y"
    {;}
    break;

  case 464:

/* Line 1455 of yacc.c  */
#line 2871 "gram.y"
    {;}
    break;

  case 465:

/* Line 1455 of yacc.c  */
#line 2875 "gram.y"
    { (yyval.value) = makeFloat((yyvsp[(1) - (1)].str)); ;}
    break;

  case 466:

/* Line 1455 of yacc.c  */
#line 2877 "gram.y"
    {
					(yyval.value) = makeFloat((yyvsp[(2) - (2)].str));
					doNegateFloat((yyval.value));
				;}
    break;

  case 467:

/* Line 1455 of yacc.c  */
#line 2881 "gram.y"
    { (yyval.value) = makeInteger((yyvsp[(1) - (1)].ival)); ;}
    break;

  case 468:

/* Line 1455 of yacc.c  */
#line 2884 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 469:

/* Line 1455 of yacc.c  */
#line 2885 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 470:

/* Line 1455 of yacc.c  */
#line 2898 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (6)].boolean);
				n->plname = (yyvsp[(6) - (6)].str);
				/* parameters are all to be supplied by system */
				n->plhandler = NIL;
				n->plinline = NIL;
				n->plvalidator = NIL;
				n->pltrusted = false;
				(yyval.node) = (Node *)n;
			;}
    break;

  case 471:

/* Line 1455 of yacc.c  */
#line 2911 "gram.y"
    {
				CreatePLangStmt *n = makeNode(CreatePLangStmt);
				n->replace = (yyvsp[(2) - (10)].boolean);
				n->plname = (yyvsp[(6) - (10)].str);
				n->plhandler = (yyvsp[(8) - (10)].list);
				n->plinline = (yyvsp[(9) - (10)].list);
				n->plvalidator = (yyvsp[(10) - (10)].list);
				n->pltrusted = (yyvsp[(3) - (10)].boolean);
				(yyval.node) = (Node *)n;
			;}
    break;

  case 472:

/* Line 1455 of yacc.c  */
#line 2924 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 473:

/* Line 1455 of yacc.c  */
#line 2925 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 474:

/* Line 1455 of yacc.c  */
#line 2933 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 475:

/* Line 1455 of yacc.c  */
#line 2934 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 476:

/* Line 1455 of yacc.c  */
#line 2938 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 477:

/* Line 1455 of yacc.c  */
#line 2939 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 478:

/* Line 1455 of yacc.c  */
#line 2943 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 479:

/* Line 1455 of yacc.c  */
#line 2944 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 480:

/* Line 1455 of yacc.c  */
#line 2948 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 481:

/* Line 1455 of yacc.c  */
#line 2949 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 482:

/* Line 1455 of yacc.c  */
#line 2954 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(4) - (5)].str);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 483:

/* Line 1455 of yacc.c  */
#line 2962 "gram.y"
    {
					DropPLangStmt *n = makeNode(DropPLangStmt);
					n->plname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 484:

/* Line 1455 of yacc.c  */
#line 2972 "gram.y"
    {;}
    break;

  case 485:

/* Line 1455 of yacc.c  */
#line 2973 "gram.y"
    {;}
    break;

  case 486:

/* Line 1455 of yacc.c  */
#line 2984 "gram.y"
    {
					CreateTableSpaceStmt *n = makeNode(CreateTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (6)].str);
					n->owner = (yyvsp[(4) - (6)].str);
					n->location = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 487:

/* Line 1455 of yacc.c  */
#line 2993 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 488:

/* Line 1455 of yacc.c  */
#line 2994 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 489:

/* Line 1455 of yacc.c  */
#line 3008 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(3) - (3)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 490:

/* Line 1455 of yacc.c  */
#line 3015 "gram.y"
    {
					DropTableSpaceStmt *n = makeNode(DropTableSpaceStmt);
					n->tablespacename = (yyvsp[(5) - (5)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 491:

/* Line 1455 of yacc.c  */
#line 3031 "gram.y"
    {
					CreateFdwStmt *n = makeNode(CreateFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 492:

/* Line 1455 of yacc.c  */
#line 3048 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 493:

/* Line 1455 of yacc.c  */
#line 3056 "gram.y"
    {
					DropFdwStmt *n = makeNode(DropFdwStmt);
					n->fdwname = (yyvsp[(7) - (8)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 494:

/* Line 1455 of yacc.c  */
#line 3073 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (7)].str);
					n->validator = (yyvsp[(6) - (7)].list);
					n->change_validator = true;
					n->options = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 495:

/* Line 1455 of yacc.c  */
#line 3082 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->validator = (yyvsp[(6) - (6)].list);
					n->change_validator = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 496:

/* Line 1455 of yacc.c  */
#line 3090 "gram.y"
    {
					AlterFdwStmt *n = makeNode(AlterFdwStmt);
					n->fdwname = (yyvsp[(5) - (6)].str);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 497:

/* Line 1455 of yacc.c  */
#line 3100 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 498:

/* Line 1455 of yacc.c  */
#line 3101 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 499:

/* Line 1455 of yacc.c  */
#line 3106 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 500:

/* Line 1455 of yacc.c  */
#line 3110 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 501:

/* Line 1455 of yacc.c  */
#line 3117 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 502:

/* Line 1455 of yacc.c  */
#line 3122 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 503:

/* Line 1455 of yacc.c  */
#line 3126 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 504:

/* Line 1455 of yacc.c  */
#line 3133 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 505:

/* Line 1455 of yacc.c  */
#line 3137 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_SET;
				;}
    break;

  case 506:

/* Line 1455 of yacc.c  */
#line 3142 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(2) - (2)].defelt);
					(yyval.defelt)->defaction = DEFELEM_ADD;
				;}
    break;

  case 507:

/* Line 1455 of yacc.c  */
#line 3147 "gram.y"
    {
					(yyval.defelt) = makeDefElemExtended(NULL, (yyvsp[(2) - (2)].str), NULL, DEFELEM_DROP);
				;}
    break;

  case 508:

/* Line 1455 of yacc.c  */
#line 3154 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 509:

/* Line 1455 of yacc.c  */
#line 3160 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 510:

/* Line 1455 of yacc.c  */
#line 3165 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 511:

/* Line 1455 of yacc.c  */
#line 3177 "gram.y"
    {
					CreateForeignServerStmt *n = makeNode(CreateForeignServerStmt);
					n->servername = (yyvsp[(3) - (10)].str);
					n->servertype = (yyvsp[(4) - (10)].str);
					n->version = (yyvsp[(5) - (10)].str);
					n->fdwname = (yyvsp[(9) - (10)].str);
					n->options = (yyvsp[(10) - (10)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 512:

/* Line 1455 of yacc.c  */
#line 3189 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 513:

/* Line 1455 of yacc.c  */
#line 3190 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 514:

/* Line 1455 of yacc.c  */
#line 3195 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 515:

/* Line 1455 of yacc.c  */
#line 3196 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 516:

/* Line 1455 of yacc.c  */
#line 3200 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 517:

/* Line 1455 of yacc.c  */
#line 3201 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 518:

/* Line 1455 of yacc.c  */
#line 3212 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->missing_ok = false;
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 519:

/* Line 1455 of yacc.c  */
#line 3220 "gram.y"
    {
					DropForeignServerStmt *n = makeNode(DropForeignServerStmt);
					n->servername = (yyvsp[(5) - (6)].str);
					n->missing_ok = true;
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 520:

/* Line 1455 of yacc.c  */
#line 3237 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (5)].str);
					n->version = (yyvsp[(4) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 521:

/* Line 1455 of yacc.c  */
#line 3246 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->version = (yyvsp[(4) - (4)].str);
					n->has_version = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 522:

/* Line 1455 of yacc.c  */
#line 3254 "gram.y"
    {
					AlterForeignServerStmt *n = makeNode(AlterForeignServerStmt);
					n->servername = (yyvsp[(3) - (4)].str);
					n->options = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 523:

/* Line 1455 of yacc.c  */
#line 3270 "gram.y"
    {
					CreateUserMappingStmt *n = makeNode(CreateUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 524:

/* Line 1455 of yacc.c  */
#line 3281 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 525:

/* Line 1455 of yacc.c  */
#line 3282 "gram.y"
    { (yyval.str) = "current_user"; ;}
    break;

  case 526:

/* Line 1455 of yacc.c  */
#line 3283 "gram.y"
    { (yyval.str) = (strcmp((yyvsp[(1) - (1)].str), "public") == 0) ? NULL : (yyvsp[(1) - (1)].str); ;}
    break;

  case 527:

/* Line 1455 of yacc.c  */
#line 3294 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(5) - (7)].str);
					n->servername = (yyvsp[(7) - (7)].str);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 528:

/* Line 1455 of yacc.c  */
#line 3302 "gram.y"
    {
					DropUserMappingStmt *n = makeNode(DropUserMappingStmt);
					n->username = (yyvsp[(7) - (9)].str);
					n->servername = (yyvsp[(9) - (9)].str);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 529:

/* Line 1455 of yacc.c  */
#line 3319 "gram.y"
    {
					AlterUserMappingStmt *n = makeNode(AlterUserMappingStmt);
					n->username = (yyvsp[(5) - (8)].str);
					n->servername = (yyvsp[(7) - (8)].str);
					n->options = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 530:

/* Line 1455 of yacc.c  */
#line 3340 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (15)].str);
					n->relation = (yyvsp[(7) - (15)].range);
					n->funcname = (yyvsp[(12) - (15)].list);
					n->args = (yyvsp[(14) - (15)].list);
					n->before = (yyvsp[(4) - (15)].boolean);
					n->row = (yyvsp[(8) - (15)].boolean);
					n->events = intVal(linitial((yyvsp[(5) - (15)].list)));
					n->columns = (List *) lsecond((yyvsp[(5) - (15)].list));
					n->whenClause = (yyvsp[(9) - (15)].node);
					n->isconstraint  = FALSE;
					n->deferrable	 = FALSE;
					n->initdeferred  = FALSE;
					n->constrrel = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 531:

/* Line 1455 of yacc.c  */
#line 3361 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(4) - (20)].str);
					n->relation = (yyvsp[(8) - (20)].range);
					n->funcname = (yyvsp[(17) - (20)].list);
					n->args = (yyvsp[(19) - (20)].list);
					n->before = FALSE;
					n->row = TRUE;
					n->events = intVal(linitial((yyvsp[(6) - (20)].list)));
					n->columns = (List *) lsecond((yyvsp[(6) - (20)].list));
					n->whenClause = (yyvsp[(14) - (20)].node);
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(10) - (20)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(10) - (20)].ival) & 2) != 0;
					n->constrrel = (yyvsp[(9) - (20)].range);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 532:

/* Line 1455 of yacc.c  */
#line 3381 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 533:

/* Line 1455 of yacc.c  */
#line 3382 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 534:

/* Line 1455 of yacc.c  */
#line 3387 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 535:

/* Line 1455 of yacc.c  */
#line 3389 "gram.y"
    {
					int		events1 = intVal(linitial((yyvsp[(1) - (3)].list)));
					int		events2 = intVal(linitial((yyvsp[(3) - (3)].list)));
					List   *columns1 = (List *) lsecond((yyvsp[(1) - (3)].list));
					List   *columns2 = (List *) lsecond((yyvsp[(3) - (3)].list));

					if (events1 & events2)
						parser_yyerror("duplicate trigger events specified");
					/*
					 * concat'ing the columns lists loses information about
					 * which columns went with which event, but so long as
					 * only UPDATE carries columns and we disallow multiple
					 * UPDATE items, it doesn't matter.  Command execution
					 * should just ignore the columns for non-UPDATE events.
					 */
					(yyval.list) = list_make2(makeInteger(events1 | events2),
									list_concat(columns1, columns2));
				;}
    break;

  case 536:

/* Line 1455 of yacc.c  */
#line 3411 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_INSERT), NIL); ;}
    break;

  case 537:

/* Line 1455 of yacc.c  */
#line 3413 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_DELETE), NIL); ;}
    break;

  case 538:

/* Line 1455 of yacc.c  */
#line 3415 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), NIL); ;}
    break;

  case 539:

/* Line 1455 of yacc.c  */
#line 3417 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_UPDATE), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 540:

/* Line 1455 of yacc.c  */
#line 3419 "gram.y"
    { (yyval.list) = list_make2(makeInteger(TRIGGER_TYPE_TRUNCATE), NIL); ;}
    break;

  case 541:

/* Line 1455 of yacc.c  */
#line 3424 "gram.y"
    {
					(yyval.boolean) = (yyvsp[(3) - (3)].boolean);
				;}
    break;

  case 542:

/* Line 1455 of yacc.c  */
#line 3428 "gram.y"
    {
					/*
					 * If ROW/STATEMENT not specified, default to
					 * STATEMENT, per SQL
					 */
					(yyval.boolean) = FALSE;
				;}
    break;

  case 543:

/* Line 1455 of yacc.c  */
#line 3438 "gram.y"
    {;}
    break;

  case 544:

/* Line 1455 of yacc.c  */
#line 3439 "gram.y"
    {;}
    break;

  case 545:

/* Line 1455 of yacc.c  */
#line 3443 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 546:

/* Line 1455 of yacc.c  */
#line 3444 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 547:

/* Line 1455 of yacc.c  */
#line 3448 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (4)].node); ;}
    break;

  case 548:

/* Line 1455 of yacc.c  */
#line 3449 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 549:

/* Line 1455 of yacc.c  */
#line 3453 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].value)); ;}
    break;

  case 550:

/* Line 1455 of yacc.c  */
#line 3454 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].value)); ;}
    break;

  case 551:

/* Line 1455 of yacc.c  */
#line 3455 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 552:

/* Line 1455 of yacc.c  */
#line 3460 "gram.y"
    {
					char buf[64];
					snprintf(buf, sizeof(buf), "%d", (yyvsp[(1) - (1)].ival));
					(yyval.value) = makeString(pstrdup(buf));
				;}
    break;

  case 553:

/* Line 1455 of yacc.c  */
#line 3465 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 554:

/* Line 1455 of yacc.c  */
#line 3466 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 555:

/* Line 1455 of yacc.c  */
#line 3467 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 556:

/* Line 1455 of yacc.c  */
#line 3468 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 557:

/* Line 1455 of yacc.c  */
#line 3469 "gram.y"
    { (yyval.value) = makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 558:

/* Line 1455 of yacc.c  */
#line 3473 "gram.y"
    { (yyval.range) = (yyvsp[(2) - (2)].range); ;}
    break;

  case 559:

/* Line 1455 of yacc.c  */
#line 3474 "gram.y"
    { (yyval.range) = NULL; ;}
    break;

  case 560:

/* Line 1455 of yacc.c  */
#line 3479 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 561:

/* Line 1455 of yacc.c  */
#line 3481 "gram.y"
    {
					if ((yyvsp[(1) - (2)].ival) == 0 && (yyvsp[(2) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 562:

/* Line 1455 of yacc.c  */
#line 3490 "gram.y"
    {
					if ((yyvsp[(1) - (1)].ival) != 0)
						(yyval.ival) = 3;
					else
						(yyval.ival) = 0;
				;}
    break;

  case 563:

/* Line 1455 of yacc.c  */
#line 3497 "gram.y"
    {
					if ((yyvsp[(2) - (2)].ival) == 0 && (yyvsp[(1) - (2)].ival) != 0)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("constraint declared INITIALLY DEFERRED must be DEFERRABLE"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.ival) = (yyvsp[(1) - (2)].ival) | (yyvsp[(2) - (2)].ival);
				;}
    break;

  case 564:

/* Line 1455 of yacc.c  */
#line 3506 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 565:

/* Line 1455 of yacc.c  */
#line 3510 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 566:

/* Line 1455 of yacc.c  */
#line 3511 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 567:

/* Line 1455 of yacc.c  */
#line 3515 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 568:

/* Line 1455 of yacc.c  */
#line 3516 "gram.y"
    { (yyval.ival) = 2; ;}
    break;

  case 569:

/* Line 1455 of yacc.c  */
#line 3522 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 570:

/* Line 1455 of yacc.c  */
#line 3532 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_TRIGGER;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 571:

/* Line 1455 of yacc.c  */
#line 3555 "gram.y"
    {
					CreateTrigStmt *n = makeNode(CreateTrigStmt);
					n->trigname = (yyvsp[(3) - (8)].str);
					n->args = list_make1((yyvsp[(6) - (8)].node));
					n->isconstraint  = TRUE;
					n->deferrable = ((yyvsp[(8) - (8)].ival) & 1) != 0;
					n->initdeferred = ((yyvsp[(8) - (8)].ival) & 2) != 0;

					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("CREATE ASSERTION is not yet implemented")));

					(yyval.node) = (Node *)n;
				;}
    break;

  case 572:

/* Line 1455 of yacc.c  */
#line 3573 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = NULL;
					n->property = (yyvsp[(3) - (4)].str);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					n->removeType = OBJECT_TRIGGER; /* XXX */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("DROP ASSERTION is not yet implemented")));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 573:

/* Line 1455 of yacc.c  */
#line 3596 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->definition = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 574:

/* Line 1455 of yacc.c  */
#line 3606 "gram.y"
    {
					/* old-style (pre-8.2) syntax for CREATE AGGREGATE */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_AGGREGATE;
					n->oldstyle = true;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 575:

/* Line 1455 of yacc.c  */
#line 3617 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_OPERATOR;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 576:

/* Line 1455 of yacc.c  */
#line 3627 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->definition = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 577:

/* Line 1455 of yacc.c  */
#line 3637 "gram.y"
    {
					/* Shell type (identified by lack of definition) */
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TYPE;
					n->oldstyle = false;
					n->defnames = (yyvsp[(3) - (3)].list);
					n->args = NIL;
					n->definition = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 578:

/* Line 1455 of yacc.c  */
#line 3648 "gram.y"
    {
					CompositeTypeStmt *n = makeNode(CompositeTypeStmt);
					RangeVar *r = makeNode(RangeVar);

					/* can't use qualified_name, sigh */
					switch (list_length((yyvsp[(3) - (7)].list)))
					{
						case 1:
							r->catalogname = NULL;
							r->schemaname = NULL;
							r->relname = strVal(linitial((yyvsp[(3) - (7)].list)));
							break;
						case 2:
							r->catalogname = NULL;
							r->schemaname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							break;
						case 3:
							r->catalogname = strVal(linitial((yyvsp[(3) - (7)].list)));
							r->schemaname = strVal(lsecond((yyvsp[(3) - (7)].list)));
							r->relname = strVal(lthird((yyvsp[(3) - (7)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString((yyvsp[(3) - (7)].list))),
											parser_errposition((yylsp[(3) - (7)]))));
							break;
					}
					r->location = (yylsp[(3) - (7)]);
					n->typevar = r;
					n->coldeflist = (yyvsp[(6) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 579:

/* Line 1455 of yacc.c  */
#line 3684 "gram.y"
    {
					CreateEnumStmt *n = makeNode(CreateEnumStmt);
					n->typeName = (yyvsp[(3) - (8)].list);
					n->vals = (yyvsp[(7) - (8)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 580:

/* Line 1455 of yacc.c  */
#line 3691 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSPARSER;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 581:

/* Line 1455 of yacc.c  */
#line 3700 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSDICTIONARY;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 582:

/* Line 1455 of yacc.c  */
#line 3709 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSTEMPLATE;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 583:

/* Line 1455 of yacc.c  */
#line 3718 "gram.y"
    {
					DefineStmt *n = makeNode(DefineStmt);
					n->kind = OBJECT_TSCONFIGURATION;
					n->args = NIL;
					n->defnames = (yyvsp[(5) - (6)].list);
					n->definition = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 584:

/* Line 1455 of yacc.c  */
#line 3728 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 585:

/* Line 1455 of yacc.c  */
#line 3731 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 586:

/* Line 1455 of yacc.c  */
#line 3732 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 587:

/* Line 1455 of yacc.c  */
#line 3736 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *) (yyvsp[(3) - (3)].node));
				;}
    break;

  case 588:

/* Line 1455 of yacc.c  */
#line 3740 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (1)].str), NULL);
				;}
    break;

  case 589:

/* Line 1455 of yacc.c  */
#line 3746 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].typnam); ;}
    break;

  case 590:

/* Line 1455 of yacc.c  */
#line 3747 "gram.y"
    { (yyval.node) = (Node *)makeString(pstrdup((yyvsp[(1) - (1)].keyword))); ;}
    break;

  case 591:

/* Line 1455 of yacc.c  */
#line 3748 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].list); ;}
    break;

  case 592:

/* Line 1455 of yacc.c  */
#line 3749 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(1) - (1)].value); ;}
    break;

  case 593:

/* Line 1455 of yacc.c  */
#line 3750 "gram.y"
    { (yyval.node) = (Node *)makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 594:

/* Line 1455 of yacc.c  */
#line 3753 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 595:

/* Line 1455 of yacc.c  */
#line 3754 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 596:

/* Line 1455 of yacc.c  */
#line 3757 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 597:

/* Line 1455 of yacc.c  */
#line 3760 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 598:

/* Line 1455 of yacc.c  */
#line 3761 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 599:

/* Line 1455 of yacc.c  */
#line 3770 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (3)].str), (Node *)(yyvsp[(3) - (3)].node));
				;}
    break;

  case 600:

/* Line 1455 of yacc.c  */
#line 3776 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 601:

/* Line 1455 of yacc.c  */
#line 3777 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 602:

/* Line 1455 of yacc.c  */
#line 3781 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 603:

/* Line 1455 of yacc.c  */
#line 3783 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 604:

/* Line 1455 of yacc.c  */
#line 3801 "gram.y"
    {
					CreateOpClassStmt *n = makeNode(CreateOpClassStmt);
					n->opclassname = (yyvsp[(4) - (13)].list);
					n->isDefault = (yyvsp[(5) - (13)].boolean);
					n->datatype = (yyvsp[(8) - (13)].typnam);
					n->amname = (yyvsp[(10) - (13)].str);
					n->opfamilyname = (yyvsp[(11) - (13)].list);
					n->items = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 605:

/* Line 1455 of yacc.c  */
#line 3814 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 606:

/* Line 1455 of yacc.c  */
#line 3815 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 607:

/* Line 1455 of yacc.c  */
#line 3820 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = NIL;
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 608:

/* Line 1455 of yacc.c  */
#line 3829 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->number = (yyvsp[(2) - (5)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 609:

/* Line 1455 of yacc.c  */
#line 3838 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(3) - (4)].list);
					n->args = extractArgTypes((yyvsp[(4) - (4)].list));
					n->number = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 610:

/* Line 1455 of yacc.c  */
#line 3847 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->name = (yyvsp[(6) - (7)].list);
					n->args = extractArgTypes((yyvsp[(7) - (7)].list));
					n->number = (yyvsp[(2) - (7)].ival);
					n->class_args = (yyvsp[(4) - (7)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 611:

/* Line 1455 of yacc.c  */
#line 3857 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_STORAGETYPE;
					n->storedtype = (yyvsp[(2) - (2)].typnam);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 612:

/* Line 1455 of yacc.c  */
#line 3865 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 613:

/* Line 1455 of yacc.c  */
#line 3866 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 614:

/* Line 1455 of yacc.c  */
#line 3869 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 615:

/* Line 1455 of yacc.c  */
#line 3870 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 616:

/* Line 1455 of yacc.c  */
#line 3874 "gram.y"
    {
					/*
					 * RECHECK no longer does anything in opclass definitions,
					 * but we still accept it to ease porting of old database
					 * dumps.
					 */
					ereport(NOTICE,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("RECHECK is no longer required"),
							 errhint("Update your data type."),
							 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.boolean) = TRUE;
				;}
    break;

  case 617:

/* Line 1455 of yacc.c  */
#line 3887 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 618:

/* Line 1455 of yacc.c  */
#line 3893 "gram.y"
    {
					CreateOpFamilyStmt *n = makeNode(CreateOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (6)].list);
					n->amname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 619:

/* Line 1455 of yacc.c  */
#line 3903 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = false;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 620:

/* Line 1455 of yacc.c  */
#line 3912 "gram.y"
    {
					AlterOpFamilyStmt *n = makeNode(AlterOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (8)].list);
					n->amname = (yyvsp[(6) - (8)].str);
					n->isDrop = true;
					n->items = (yyvsp[(8) - (8)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 621:

/* Line 1455 of yacc.c  */
#line 3923 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 622:

/* Line 1455 of yacc.c  */
#line 3924 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 623:

/* Line 1455 of yacc.c  */
#line 3929 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_OPERATOR;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 624:

/* Line 1455 of yacc.c  */
#line 3937 "gram.y"
    {
					CreateOpClassItem *n = makeNode(CreateOpClassItem);
					n->itemtype = OPCLASS_ITEM_FUNCTION;
					n->number = (yyvsp[(2) - (5)].ival);
					n->args = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 625:

/* Line 1455 of yacc.c  */
#line 3949 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 626:

/* Line 1455 of yacc.c  */
#line 3958 "gram.y"
    {
					RemoveOpClassStmt *n = makeNode(RemoveOpClassStmt);
					n->opclassname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 627:

/* Line 1455 of yacc.c  */
#line 3970 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(4) - (7)].list);
					n->amname = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 628:

/* Line 1455 of yacc.c  */
#line 3979 "gram.y"
    {
					RemoveOpFamilyStmt *n = makeNode(RemoveOpFamilyStmt);
					n->opfamilyname = (yyvsp[(6) - (9)].list);
					n->amname = (yyvsp[(8) - (9)].str);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 629:

/* Line 1455 of yacc.c  */
#line 4000 "gram.y"
    {
					DropOwnedStmt *n = makeNode(DropOwnedStmt);
					n->roles = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 630:

/* Line 1455 of yacc.c  */
#line 4010 "gram.y"
    {
					ReassignOwnedStmt *n = makeNode(ReassignOwnedStmt);
					n->roles = (yyvsp[(4) - (6)].list);
					n->newrole = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 631:

/* Line 1455 of yacc.c  */
#line 4028 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (6)].objtype);
					n->missing_ok = TRUE;
					n->objects = (yyvsp[(5) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 632:

/* Line 1455 of yacc.c  */
#line 4037 "gram.y"
    {
					DropStmt *n = makeNode(DropStmt);
					n->removeType = (yyvsp[(2) - (4)].objtype);
					n->missing_ok = FALSE;
					n->objects = (yyvsp[(3) - (4)].list);
					n->behavior = (yyvsp[(4) - (4)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 633:

/* Line 1455 of yacc.c  */
#line 4048 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 634:

/* Line 1455 of yacc.c  */
#line 4049 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 635:

/* Line 1455 of yacc.c  */
#line 4050 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 636:

/* Line 1455 of yacc.c  */
#line 4051 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 637:

/* Line 1455 of yacc.c  */
#line 4052 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 638:

/* Line 1455 of yacc.c  */
#line 4053 "gram.y"
    { (yyval.objtype) = OBJECT_DOMAIN; ;}
    break;

  case 639:

/* Line 1455 of yacc.c  */
#line 4054 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 640:

/* Line 1455 of yacc.c  */
#line 4055 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 641:

/* Line 1455 of yacc.c  */
#line 4056 "gram.y"
    { (yyval.objtype) = OBJECT_TSPARSER; ;}
    break;

  case 642:

/* Line 1455 of yacc.c  */
#line 4057 "gram.y"
    { (yyval.objtype) = OBJECT_TSDICTIONARY; ;}
    break;

  case 643:

/* Line 1455 of yacc.c  */
#line 4058 "gram.y"
    { (yyval.objtype) = OBJECT_TSTEMPLATE; ;}
    break;

  case 644:

/* Line 1455 of yacc.c  */
#line 4059 "gram.y"
    { (yyval.objtype) = OBJECT_TSCONFIGURATION; ;}
    break;

  case 645:

/* Line 1455 of yacc.c  */
#line 4063 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].list)); ;}
    break;

  case 646:

/* Line 1455 of yacc.c  */
#line 4064 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 647:

/* Line 1455 of yacc.c  */
#line 4067 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 648:

/* Line 1455 of yacc.c  */
#line 4068 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)); ;}
    break;

  case 649:

/* Line 1455 of yacc.c  */
#line 4072 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(2) - (2)].str))); ;}
    break;

  case 650:

/* Line 1455 of yacc.c  */
#line 4074 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 651:

/* Line 1455 of yacc.c  */
#line 4087 "gram.y"
    {
					TruncateStmt *n = makeNode(TruncateStmt);
					n->relations = (yyvsp[(3) - (5)].list);
					n->restart_seqs = (yyvsp[(4) - (5)].boolean);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 652:

/* Line 1455 of yacc.c  */
#line 4097 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 653:

/* Line 1455 of yacc.c  */
#line 4098 "gram.y"
    { (yyval.boolean) = true; ;}
    break;

  case 654:

/* Line 1455 of yacc.c  */
#line 4099 "gram.y"
    { (yyval.boolean) = false; ;}
    break;

  case 655:

/* Line 1455 of yacc.c  */
#line 4125 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = (yyvsp[(3) - (6)].objtype);
					n->objname = (yyvsp[(4) - (6)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 656:

/* Line 1455 of yacc.c  */
#line 4134 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_AGGREGATE;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 657:

/* Line 1455 of yacc.c  */
#line 4143 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_FUNCTION;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = extractArgTypes((yyvsp[(5) - (7)].list));
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 658:

/* Line 1455 of yacc.c  */
#line 4152 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPERATOR;
					n->objname = (yyvsp[(4) - (7)].list);
					n->objargs = (yyvsp[(5) - (7)].list);
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 659:

/* Line 1455 of yacc.c  */
#line 4161 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CONSTRAINT;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 660:

/* Line 1455 of yacc.c  */
#line 4170 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 661:

/* Line 1455 of yacc.c  */
#line 4179 "gram.y"
    {
					/* Obsolete syntax supported for awhile for compatibility */
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_RULE;
					n->objname = list_make1(makeString((yyvsp[(4) - (6)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 662:

/* Line 1455 of yacc.c  */
#line 4189 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TRIGGER;
					n->objname = lappend((yyvsp[(6) - (8)].list), makeString((yyvsp[(4) - (8)].str)));
					n->objargs = NIL;
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 663:

/* Line 1455 of yacc.c  */
#line 4198 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPCLASS;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 664:

/* Line 1455 of yacc.c  */
#line 4207 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_OPFAMILY;
					n->objname = (yyvsp[(5) - (9)].list);
					n->objargs = list_make1(makeString((yyvsp[(7) - (9)].str)));
					n->comment = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 665:

/* Line 1455 of yacc.c  */
#line 4216 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LARGEOBJECT;
					n->objname = list_make1((yyvsp[(5) - (7)].value));
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 666:

/* Line 1455 of yacc.c  */
#line 4225 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_CAST;
					n->objname = list_make1((yyvsp[(5) - (10)].typnam));
					n->objargs = list_make1((yyvsp[(7) - (10)].typnam));
					n->comment = (yyvsp[(10) - (10)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 667:

/* Line 1455 of yacc.c  */
#line 4234 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_LANGUAGE;
					n->objname = (yyvsp[(5) - (7)].list);
					n->objargs = NIL;
					n->comment = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 668:

/* Line 1455 of yacc.c  */
#line 4243 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSPARSER;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 669:

/* Line 1455 of yacc.c  */
#line 4251 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSDICTIONARY;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 670:

/* Line 1455 of yacc.c  */
#line 4259 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSTEMPLATE;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 671:

/* Line 1455 of yacc.c  */
#line 4267 "gram.y"
    {
					CommentStmt *n = makeNode(CommentStmt);
					n->objtype = OBJECT_TSCONFIGURATION;
					n->objname = (yyvsp[(6) - (8)].list);
					n->comment = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 672:

/* Line 1455 of yacc.c  */
#line 4277 "gram.y"
    { (yyval.objtype) = OBJECT_COLUMN; ;}
    break;

  case 673:

/* Line 1455 of yacc.c  */
#line 4278 "gram.y"
    { (yyval.objtype) = OBJECT_DATABASE; ;}
    break;

  case 674:

/* Line 1455 of yacc.c  */
#line 4279 "gram.y"
    { (yyval.objtype) = OBJECT_SCHEMA; ;}
    break;

  case 675:

/* Line 1455 of yacc.c  */
#line 4280 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 676:

/* Line 1455 of yacc.c  */
#line 4281 "gram.y"
    { (yyval.objtype) = OBJECT_SEQUENCE; ;}
    break;

  case 677:

/* Line 1455 of yacc.c  */
#line 4282 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 678:

/* Line 1455 of yacc.c  */
#line 4283 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 679:

/* Line 1455 of yacc.c  */
#line 4284 "gram.y"
    { (yyval.objtype) = OBJECT_TYPE; ;}
    break;

  case 680:

/* Line 1455 of yacc.c  */
#line 4285 "gram.y"
    { (yyval.objtype) = OBJECT_VIEW; ;}
    break;

  case 681:

/* Line 1455 of yacc.c  */
#line 4286 "gram.y"
    { (yyval.objtype) = OBJECT_CONVERSION; ;}
    break;

  case 682:

/* Line 1455 of yacc.c  */
#line 4287 "gram.y"
    { (yyval.objtype) = OBJECT_TABLESPACE; ;}
    break;

  case 683:

/* Line 1455 of yacc.c  */
#line 4288 "gram.y"
    { (yyval.objtype) = OBJECT_ROLE; ;}
    break;

  case 684:

/* Line 1455 of yacc.c  */
#line 4292 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 685:

/* Line 1455 of yacc.c  */
#line 4293 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 686:

/* Line 1455 of yacc.c  */
#line 4304 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 687:

/* Line 1455 of yacc.c  */
#line 4310 "gram.y"
    {
					FetchStmt *n = (FetchStmt *) (yyvsp[(2) - (2)].node);
					n->ismove = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 688:

/* Line 1455 of yacc.c  */
#line 4318 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(1) - (1)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 689:

/* Line 1455 of yacc.c  */
#line 4326 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(2) - (2)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 690:

/* Line 1455 of yacc.c  */
#line 4334 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 691:

/* Line 1455 of yacc.c  */
#line 4342 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 692:

/* Line 1455 of yacc.c  */
#line 4350 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 693:

/* Line 1455 of yacc.c  */
#line 4358 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 694:

/* Line 1455 of yacc.c  */
#line 4366 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_ABSOLUTE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 695:

/* Line 1455 of yacc.c  */
#line 4374 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_RELATIVE;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 696:

/* Line 1455 of yacc.c  */
#line 4382 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(1) - (3)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 697:

/* Line 1455 of yacc.c  */
#line 4390 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 698:

/* Line 1455 of yacc.c  */
#line 4398 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 699:

/* Line 1455 of yacc.c  */
#line 4406 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 700:

/* Line 1455 of yacc.c  */
#line 4414 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_FORWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 701:

/* Line 1455 of yacc.c  */
#line 4422 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(3) - (3)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = 1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 702:

/* Line 1455 of yacc.c  */
#line 4430 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = (yyvsp[(2) - (4)].ival);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 703:

/* Line 1455 of yacc.c  */
#line 4438 "gram.y"
    {
					FetchStmt *n = makeNode(FetchStmt);
					n->portalname = (yyvsp[(4) - (4)].str);
					n->direction = FETCH_BACKWARD;
					n->howMany = FETCH_ALL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 704:

/* Line 1455 of yacc.c  */
#line 4447 "gram.y"
    {;}
    break;

  case 705:

/* Line 1455 of yacc.c  */
#line 4448 "gram.y"
    {;}
    break;

  case 706:

/* Line 1455 of yacc.c  */
#line 4451 "gram.y"
    {;}
    break;

  case 707:

/* Line 1455 of yacc.c  */
#line 4452 "gram.y"
    {;}
    break;

  case 708:

/* Line 1455 of yacc.c  */
#line 4464 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 709:

/* Line 1455 of yacc.c  */
#line 4480 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ((yyvsp[(4) - (7)].privtarget))->targtype;
					n->objtype = ((yyvsp[(4) - (7)].privtarget))->objtype;
					n->objects = ((yyvsp[(4) - (7)].privtarget))->objs;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 710:

/* Line 1455 of yacc.c  */
#line 4494 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ((yyvsp[(7) - (10)].privtarget))->targtype;
					n->objtype = ((yyvsp[(7) - (10)].privtarget))->objtype;
					n->objects = ((yyvsp[(7) - (10)].privtarget))->objs;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 711:

/* Line 1455 of yacc.c  */
#line 4519 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 712:

/* Line 1455 of yacc.c  */
#line 4521 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 713:

/* Line 1455 of yacc.c  */
#line 4523 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 714:

/* Line 1455 of yacc.c  */
#line 4525 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(3) - (4)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 715:

/* Line 1455 of yacc.c  */
#line 4532 "gram.y"
    {
					AccessPriv *n = makeNode(AccessPriv);
					n->priv_name = NULL;
					n->cols = (yyvsp[(4) - (5)].list);
					(yyval.list) = list_make1(n);
				;}
    break;

  case 716:

/* Line 1455 of yacc.c  */
#line 4540 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].accesspriv)); ;}
    break;

  case 717:

/* Line 1455 of yacc.c  */
#line 4541 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].accesspriv)); ;}
    break;

  case 718:

/* Line 1455 of yacc.c  */
#line 4545 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 719:

/* Line 1455 of yacc.c  */
#line 4552 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 720:

/* Line 1455 of yacc.c  */
#line 4559 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = pstrdup((yyvsp[(1) - (2)].keyword));
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 721:

/* Line 1455 of yacc.c  */
#line 4566 "gram.y"
    {
				AccessPriv *n = makeNode(AccessPriv);
				n->priv_name = (yyvsp[(1) - (2)].str);
				n->cols = (yyvsp[(2) - (2)].list);
				(yyval.accesspriv) = n;
			;}
    break;

  case 722:

/* Line 1455 of yacc.c  */
#line 4580 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(1) - (1)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 723:

/* Line 1455 of yacc.c  */
#line 4588 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 724:

/* Line 1455 of yacc.c  */
#line 4596 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 725:

/* Line 1455 of yacc.c  */
#line 4604 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FDW;
					n->objs = (yyvsp[(4) - (4)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 726:

/* Line 1455 of yacc.c  */
#line 4612 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FOREIGN_SERVER;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 727:

/* Line 1455 of yacc.c  */
#line 4620 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 728:

/* Line 1455 of yacc.c  */
#line 4628 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_DATABASE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 729:

/* Line 1455 of yacc.c  */
#line 4636 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LANGUAGE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 730:

/* Line 1455 of yacc.c  */
#line 4644 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_LARGEOBJECT;
					n->objs = (yyvsp[(3) - (3)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 731:

/* Line 1455 of yacc.c  */
#line 4652 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_NAMESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 732:

/* Line 1455 of yacc.c  */
#line 4660 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_OBJECT;
					n->objtype = ACL_OBJECT_TABLESPACE;
					n->objs = (yyvsp[(2) - (2)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 733:

/* Line 1455 of yacc.c  */
#line 4668 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_RELATION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 734:

/* Line 1455 of yacc.c  */
#line 4676 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_SEQUENCE;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 735:

/* Line 1455 of yacc.c  */
#line 4684 "gram.y"
    {
					PrivTarget *n = (PrivTarget *) palloc(sizeof(PrivTarget));
					n->targtype = ACL_TARGET_ALL_IN_SCHEMA;
					n->objtype = ACL_OBJECT_FUNCTION;
					n->objs = (yyvsp[(5) - (5)].list);
					(yyval.privtarget) = n;
				;}
    break;

  case 736:

/* Line 1455 of yacc.c  */
#line 4695 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 737:

/* Line 1455 of yacc.c  */
#line 4696 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 738:

/* Line 1455 of yacc.c  */
#line 4700 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* This hack lets us avoid reserving PUBLIC as a keyword*/
					if (strcmp((yyvsp[(1) - (1)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(1) - (1)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 739:

/* Line 1455 of yacc.c  */
#line 4710 "gram.y"
    {
					PrivGrantee *n = makeNode(PrivGrantee);
					/* Treat GROUP PUBLIC as a synonym for PUBLIC */
					if (strcmp((yyvsp[(2) - (2)].str), "public") == 0)
						n->rolname = NULL;
					else
						n->rolname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 740:

/* Line 1455 of yacc.c  */
#line 4723 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 741:

/* Line 1455 of yacc.c  */
#line 4724 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 742:

/* Line 1455 of yacc.c  */
#line 4728 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].funwithargs)); ;}
    break;

  case 743:

/* Line 1455 of yacc.c  */
#line 4730 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].funwithargs)); ;}
    break;

  case 744:

/* Line 1455 of yacc.c  */
#line 4735 "gram.y"
    {
					FuncWithArgs *n = makeNode(FuncWithArgs);
					n->funcname = (yyvsp[(1) - (2)].list);
					n->funcargs = extractArgTypes((yyvsp[(2) - (2)].list));
					(yyval.funwithargs) = n;
				;}
    break;

  case 745:

/* Line 1455 of yacc.c  */
#line 4751 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = true;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->admin_opt = (yyvsp[(5) - (6)].boolean);
					n->grantor = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 746:

/* Line 1455 of yacc.c  */
#line 4764 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = false;
					n->granted_roles = (yyvsp[(2) - (6)].list);
					n->grantee_roles = (yyvsp[(4) - (6)].list);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 747:

/* Line 1455 of yacc.c  */
#line 4774 "gram.y"
    {
					GrantRoleStmt *n = makeNode(GrantRoleStmt);
					n->is_grant = false;
					n->admin_opt = true;
					n->granted_roles = (yyvsp[(5) - (9)].list);
					n->grantee_roles = (yyvsp[(7) - (9)].list);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 748:

/* Line 1455 of yacc.c  */
#line 4785 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 749:

/* Line 1455 of yacc.c  */
#line 4786 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 750:

/* Line 1455 of yacc.c  */
#line 4789 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 751:

/* Line 1455 of yacc.c  */
#line 4790 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 752:

/* Line 1455 of yacc.c  */
#line 4801 "gram.y"
    {
					AlterDefaultPrivilegesStmt *n = makeNode(AlterDefaultPrivilegesStmt);
					n->options = (yyvsp[(4) - (5)].list);
					n->action = (GrantStmt *) (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 753:

/* Line 1455 of yacc.c  */
#line 4810 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 754:

/* Line 1455 of yacc.c  */
#line 4811 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 755:

/* Line 1455 of yacc.c  */
#line 4816 "gram.y"
    {
					(yyval.defelt) = makeDefElem("schemas", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 756:

/* Line 1455 of yacc.c  */
#line 4820 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 757:

/* Line 1455 of yacc.c  */
#line 4824 "gram.y"
    {
					(yyval.defelt) = makeDefElem("roles", (Node *)(yyvsp[(3) - (3)].list));
				;}
    break;

  case 758:

/* Line 1455 of yacc.c  */
#line 4836 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = true;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->grant_option = (yyvsp[(7) - (7)].boolean);
					(yyval.node) = (Node*)n;
				;}
    break;

  case 759:

/* Line 1455 of yacc.c  */
#line 4849 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = false;
					n->privileges = (yyvsp[(2) - (7)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(4) - (7)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 760:

/* Line 1455 of yacc.c  */
#line 4863 "gram.y"
    {
					GrantStmt *n = makeNode(GrantStmt);
					n->is_grant = false;
					n->grant_option = true;
					n->privileges = (yyvsp[(5) - (10)].list);
					n->targtype = ACL_TARGET_DEFAULTS;
					n->objtype = (yyvsp[(7) - (10)].ival);
					n->objects = NIL;
					n->grantees = (yyvsp[(9) - (10)].list);
					n->behavior = (yyvsp[(10) - (10)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 761:

/* Line 1455 of yacc.c  */
#line 4878 "gram.y"
    { (yyval.ival) = ACL_OBJECT_RELATION; ;}
    break;

  case 762:

/* Line 1455 of yacc.c  */
#line 4879 "gram.y"
    { (yyval.ival) = ACL_OBJECT_FUNCTION; ;}
    break;

  case 763:

/* Line 1455 of yacc.c  */
#line 4880 "gram.y"
    { (yyval.ival) = ACL_OBJECT_SEQUENCE; ;}
    break;

  case 764:

/* Line 1455 of yacc.c  */
#line 4895 "gram.y"
    {
					IndexStmt *n = makeNode(IndexStmt);
					n->unique = (yyvsp[(2) - (14)].boolean);
					n->concurrent = (yyvsp[(4) - (14)].boolean);
					n->idxname = (yyvsp[(5) - (14)].str);
					n->relation = (yyvsp[(7) - (14)].range);
					n->accessMethod = (yyvsp[(8) - (14)].str);
					n->indexParams = (yyvsp[(10) - (14)].list);
					n->options = (yyvsp[(12) - (14)].list);
					n->tableSpace = (yyvsp[(13) - (14)].str);
					n->whereClause = (yyvsp[(14) - (14)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 765:

/* Line 1455 of yacc.c  */
#line 4911 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 766:

/* Line 1455 of yacc.c  */
#line 4912 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 767:

/* Line 1455 of yacc.c  */
#line 4916 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 768:

/* Line 1455 of yacc.c  */
#line 4917 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 769:

/* Line 1455 of yacc.c  */
#line 4921 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 770:

/* Line 1455 of yacc.c  */
#line 4922 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 771:

/* Line 1455 of yacc.c  */
#line 4926 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 772:

/* Line 1455 of yacc.c  */
#line 4927 "gram.y"
    { (yyval.str) = DEFAULT_INDEX_TYPE; ;}
    break;

  case 773:

/* Line 1455 of yacc.c  */
#line 4930 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].ielem)); ;}
    break;

  case 774:

/* Line 1455 of yacc.c  */
#line 4931 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].ielem)); ;}
    break;

  case 775:

/* Line 1455 of yacc.c  */
#line 4940 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = (yyvsp[(1) - (4)].str);
					(yyval.ielem)->expr = NULL;
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 776:

/* Line 1455 of yacc.c  */
#line 4950 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(1) - (4)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(2) - (4)].list);
					(yyval.ielem)->ordering = (yyvsp[(3) - (4)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(4) - (4)].ival);
				;}
    break;

  case 777:

/* Line 1455 of yacc.c  */
#line 4960 "gram.y"
    {
					(yyval.ielem) = makeNode(IndexElem);
					(yyval.ielem)->name = NULL;
					(yyval.ielem)->expr = (yyvsp[(2) - (6)].node);
					(yyval.ielem)->indexcolname = NULL;
					(yyval.ielem)->opclass = (yyvsp[(4) - (6)].list);
					(yyval.ielem)->ordering = (yyvsp[(5) - (6)].ival);
					(yyval.ielem)->nulls_ordering = (yyvsp[(6) - (6)].ival);
				;}
    break;

  case 778:

/* Line 1455 of yacc.c  */
#line 4971 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 779:

/* Line 1455 of yacc.c  */
#line 4972 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 780:

/* Line 1455 of yacc.c  */
#line 4973 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 781:

/* Line 1455 of yacc.c  */
#line 4976 "gram.y"
    { (yyval.ival) = SORTBY_ASC; ;}
    break;

  case 782:

/* Line 1455 of yacc.c  */
#line 4977 "gram.y"
    { (yyval.ival) = SORTBY_DESC; ;}
    break;

  case 783:

/* Line 1455 of yacc.c  */
#line 4978 "gram.y"
    { (yyval.ival) = SORTBY_DEFAULT; ;}
    break;

  case 784:

/* Line 1455 of yacc.c  */
#line 4981 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_FIRST; ;}
    break;

  case 785:

/* Line 1455 of yacc.c  */
#line 4982 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_LAST; ;}
    break;

  case 786:

/* Line 1455 of yacc.c  */
#line 4983 "gram.y"
    { (yyval.ival) = SORTBY_NULLS_DEFAULT; ;}
    break;

  case 787:

/* Line 1455 of yacc.c  */
#line 5001 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (9)].boolean);
					n->funcname = (yyvsp[(4) - (9)].list);
					n->parameters = (yyvsp[(5) - (9)].list);
					n->returnType = (yyvsp[(7) - (9)].typnam);
					n->options = (yyvsp[(8) - (9)].list);
					n->withClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 788:

/* Line 1455 of yacc.c  */
#line 5013 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (12)].boolean);
					n->funcname = (yyvsp[(4) - (12)].list);
					n->parameters = mergeTableFuncParameters((yyvsp[(5) - (12)].list), (yyvsp[(9) - (12)].list));
					n->returnType = TableFuncTypeName((yyvsp[(9) - (12)].list));
					n->returnType->location = (yylsp[(7) - (12)]);
					n->options = (yyvsp[(11) - (12)].list);
					n->withClause = (yyvsp[(12) - (12)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 789:

/* Line 1455 of yacc.c  */
#line 5026 "gram.y"
    {
					CreateFunctionStmt *n = makeNode(CreateFunctionStmt);
					n->replace = (yyvsp[(2) - (7)].boolean);
					n->funcname = (yyvsp[(4) - (7)].list);
					n->parameters = (yyvsp[(5) - (7)].list);
					n->returnType = NULL;
					n->options = (yyvsp[(6) - (7)].list);
					n->withClause = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 790:

/* Line 1455 of yacc.c  */
#line 5039 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 791:

/* Line 1455 of yacc.c  */
#line 5040 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 792:

/* Line 1455 of yacc.c  */
#line 5043 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 793:

/* Line 1455 of yacc.c  */
#line 5044 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 794:

/* Line 1455 of yacc.c  */
#line 5048 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 795:

/* Line 1455 of yacc.c  */
#line 5049 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 796:

/* Line 1455 of yacc.c  */
#line 5057 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 797:

/* Line 1455 of yacc.c  */
#line 5058 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 798:

/* Line 1455 of yacc.c  */
#line 5062 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param)); ;}
    break;

  case 799:

/* Line 1455 of yacc.c  */
#line 5064 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param)); ;}
    break;

  case 800:

/* Line 1455 of yacc.c  */
#line 5079 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(2) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(1) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 801:

/* Line 1455 of yacc.c  */
#line 5088 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (3)].str);
					n->argType = (yyvsp[(3) - (3)].typnam);
					n->mode = (yyvsp[(2) - (3)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 802:

/* Line 1455 of yacc.c  */
#line 5097 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 803:

/* Line 1455 of yacc.c  */
#line 5106 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = (yyvsp[(1) - (2)].fun_param_mode);
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 804:

/* Line 1455 of yacc.c  */
#line 5115 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = NULL;
					n->argType = (yyvsp[(1) - (1)].typnam);
					n->mode = FUNC_PARAM_IN;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 805:

/* Line 1455 of yacc.c  */
#line 5126 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_IN; ;}
    break;

  case 806:

/* Line 1455 of yacc.c  */
#line 5127 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_OUT; ;}
    break;

  case 807:

/* Line 1455 of yacc.c  */
#line 5128 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 808:

/* Line 1455 of yacc.c  */
#line 5129 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_INOUT; ;}
    break;

  case 809:

/* Line 1455 of yacc.c  */
#line 5130 "gram.y"
    { (yyval.fun_param_mode) = FUNC_PARAM_VARIADIC; ;}
    break;

  case 811:

/* Line 1455 of yacc.c  */
#line 5141 "gram.y"
    {
					/* We can catch over-specified results here if we want to,
					 * but for now better to silently swallow typmod, etc.
					 * - thomas 2000-03-22
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 812:

/* Line 1455 of yacc.c  */
#line 5155 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 813:

/* Line 1455 of yacc.c  */
#line 5157 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (4)].str)), (yyvsp[(2) - (4)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->location = (yylsp[(1) - (4)]);
				;}
    break;

  case 814:

/* Line 1455 of yacc.c  */
#line 5163 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(2) - (5)].str)), (yyvsp[(3) - (5)].list)));
					(yyval.typnam)->pct_type = true;
					(yyval.typnam)->setof = TRUE;
					(yyval.typnam)->location = (yylsp[(2) - (5)]);
				;}
    break;

  case 815:

/* Line 1455 of yacc.c  */
#line 5173 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (1)].fun_param);
			    ;}
    break;

  case 816:

/* Line 1455 of yacc.c  */
#line 5177 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 817:

/* Line 1455 of yacc.c  */
#line 5182 "gram.y"
    {
				    (yyval.fun_param) = (yyvsp[(1) - (3)].fun_param);
				    (yyval.fun_param)->defexpr = (yyvsp[(3) - (3)].node);
			    ;}
    break;

  case 818:

/* Line 1455 of yacc.c  */
#line 5191 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 819:

/* Line 1455 of yacc.c  */
#line 5192 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 820:

/* Line 1455 of yacc.c  */
#line 5200 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(FALSE));
				;}
    break;

  case 821:

/* Line 1455 of yacc.c  */
#line 5204 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 822:

/* Line 1455 of yacc.c  */
#line 5208 "gram.y"
    {
					(yyval.defelt) = makeDefElem("strict", (Node *)makeInteger(TRUE));
				;}
    break;

  case 823:

/* Line 1455 of yacc.c  */
#line 5212 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("immutable"));
				;}
    break;

  case 824:

/* Line 1455 of yacc.c  */
#line 5216 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("stable"));
				;}
    break;

  case 825:

/* Line 1455 of yacc.c  */
#line 5220 "gram.y"
    {
					(yyval.defelt) = makeDefElem("volatility", (Node *)makeString("volatile"));
				;}
    break;

  case 826:

/* Line 1455 of yacc.c  */
#line 5224 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 827:

/* Line 1455 of yacc.c  */
#line 5228 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 828:

/* Line 1455 of yacc.c  */
#line 5232 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(TRUE));
				;}
    break;

  case 829:

/* Line 1455 of yacc.c  */
#line 5236 "gram.y"
    {
					(yyval.defelt) = makeDefElem("security", (Node *)makeInteger(FALSE));
				;}
    break;

  case 830:

/* Line 1455 of yacc.c  */
#line 5240 "gram.y"
    {
					(yyval.defelt) = makeDefElem("cost", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 831:

/* Line 1455 of yacc.c  */
#line 5244 "gram.y"
    {
					(yyval.defelt) = makeDefElem("rows", (Node *)(yyvsp[(2) - (2)].value));
				;}
    break;

  case 832:

/* Line 1455 of yacc.c  */
#line 5248 "gram.y"
    {
					/* we abuse the normal content of a DefElem here */
					(yyval.defelt) = makeDefElem("set", (Node *)(yyvsp[(1) - (1)].vsetstmt));
				;}
    break;

  case 833:

/* Line 1455 of yacc.c  */
#line 5256 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)(yyvsp[(2) - (2)].list));
				;}
    break;

  case 834:

/* Line 1455 of yacc.c  */
#line 5260 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 835:

/* Line 1455 of yacc.c  */
#line 5264 "gram.y"
    {
					(yyval.defelt) = makeDefElem("window", (Node *)makeInteger(TRUE));
				;}
    break;

  case 836:

/* Line 1455 of yacc.c  */
#line 5268 "gram.y"
    {
					(yyval.defelt) = (yyvsp[(1) - (1)].defelt);
				;}
    break;

  case 837:

/* Line 1455 of yacc.c  */
#line 5273 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 838:

/* Line 1455 of yacc.c  */
#line 5275 "gram.y"
    {
					(yyval.list) = list_make2(makeString((yyvsp[(1) - (3)].str)), makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 839:

/* Line 1455 of yacc.c  */
#line 5281 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 840:

/* Line 1455 of yacc.c  */
#line 5282 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 841:

/* Line 1455 of yacc.c  */
#line 5286 "gram.y"
    {
					FunctionParameter *n = makeNode(FunctionParameter);
					n->name = (yyvsp[(1) - (2)].str);
					n->argType = (yyvsp[(2) - (2)].typnam);
					n->mode = FUNC_PARAM_TABLE;
					n->defexpr = NULL;
					(yyval.fun_param) = n;
				;}
    break;

  case 842:

/* Line 1455 of yacc.c  */
#line 5298 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].fun_param));
				;}
    break;

  case 843:

/* Line 1455 of yacc.c  */
#line 5302 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].fun_param));
				;}
    break;

  case 844:

/* Line 1455 of yacc.c  */
#line 5317 "gram.y"
    {
					AlterFunctionStmt *n = makeNode(AlterFunctionStmt);
					n->func = (yyvsp[(3) - (5)].funwithargs);
					n->actions = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 845:

/* Line 1455 of yacc.c  */
#line 5327 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 846:

/* Line 1455 of yacc.c  */
#line 5328 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 849:

/* Line 1455 of yacc.c  */
#line 5350 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = extractArgTypes((yyvsp[(4) - (5)].list));
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 850:

/* Line 1455 of yacc.c  */
#line 5360 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_FUNCTION;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = extractArgTypes((yyvsp[(6) - (7)].list));
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 851:

/* Line 1455 of yacc.c  */
#line 5373 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 852:

/* Line 1455 of yacc.c  */
#line 5383 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_AGGREGATE;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 853:

/* Line 1455 of yacc.c  */
#line 5396 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(3) - (5)].list);
					n->args = (yyvsp[(4) - (5)].list);
					n->behavior = (yyvsp[(5) - (5)].dbehavior);
					n->missing_ok = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 854:

/* Line 1455 of yacc.c  */
#line 5406 "gram.y"
    {
					RemoveFuncStmt *n = makeNode(RemoveFuncStmt);
					n->kind = OBJECT_OPERATOR;
					n->name = (yyvsp[(5) - (7)].list);
					n->args = (yyvsp[(6) - (7)].list);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					n->missing_ok = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 855:

/* Line 1455 of yacc.c  */
#line 5419 "gram.y"
    {
				   ereport(ERROR,
						   (errcode(ERRCODE_SYNTAX_ERROR),
							errmsg("missing argument"),
							errhint("Use NONE to denote the missing argument of a unary operator."),
							parser_errposition((yylsp[(3) - (3)]))));
				;}
    break;

  case 856:

/* Line 1455 of yacc.c  */
#line 5427 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 857:

/* Line 1455 of yacc.c  */
#line 5429 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(4) - (5)].typnam)); ;}
    break;

  case 858:

/* Line 1455 of yacc.c  */
#line 5431 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (5)].typnam), NULL); ;}
    break;

  case 859:

/* Line 1455 of yacc.c  */
#line 5436 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 860:

/* Line 1455 of yacc.c  */
#line 5438 "gram.y"
    { (yyval.list) = lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(3) - (3)].list)); ;}
    break;

  case 861:

/* Line 1455 of yacc.c  */
#line 5451 "gram.y"
    {
					DoStmt *n = makeNode(DoStmt);
					n->args = (yyvsp[(2) - (2)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 862:

/* Line 1455 of yacc.c  */
#line 5459 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 863:

/* Line 1455 of yacc.c  */
#line 5460 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 864:

/* Line 1455 of yacc.c  */
#line 5465 "gram.y"
    {
					(yyval.defelt) = makeDefElem("as", (Node *)makeString((yyvsp[(1) - (1)].str)));
				;}
    break;

  case 865:

/* Line 1455 of yacc.c  */
#line 5469 "gram.y"
    {
					(yyval.defelt) = makeDefElem("language", (Node *)makeString((yyvsp[(2) - (2)].str)));
				;}
    break;

  case 866:

/* Line 1455 of yacc.c  */
#line 5482 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (11)].typnam);
					n->targettype = (yyvsp[(6) - (11)].typnam);
					n->func = (yyvsp[(10) - (11)].funwithargs);
					n->context = (CoercionContext) (yyvsp[(11) - (11)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 867:

/* Line 1455 of yacc.c  */
#line 5493 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 868:

/* Line 1455 of yacc.c  */
#line 5504 "gram.y"
    {
					CreateCastStmt *n = makeNode(CreateCastStmt);
					n->sourcetype = (yyvsp[(4) - (10)].typnam);
					n->targettype = (yyvsp[(6) - (10)].typnam);
					n->func = NULL;
					n->context = (CoercionContext) (yyvsp[(10) - (10)].ival);
					n->inout = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 869:

/* Line 1455 of yacc.c  */
#line 5515 "gram.y"
    { (yyval.ival) = COERCION_IMPLICIT; ;}
    break;

  case 870:

/* Line 1455 of yacc.c  */
#line 5516 "gram.y"
    { (yyval.ival) = COERCION_ASSIGNMENT; ;}
    break;

  case 871:

/* Line 1455 of yacc.c  */
#line 5517 "gram.y"
    { (yyval.ival) = COERCION_EXPLICIT; ;}
    break;

  case 872:

/* Line 1455 of yacc.c  */
#line 5522 "gram.y"
    {
					DropCastStmt *n = makeNode(DropCastStmt);
					n->sourcetype = (yyvsp[(5) - (9)].typnam);
					n->targettype = (yyvsp[(7) - (9)].typnam);
					n->behavior = (yyvsp[(9) - (9)].dbehavior);
					n->missing_ok = (yyvsp[(3) - (9)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 873:

/* Line 1455 of yacc.c  */
#line 5532 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 874:

/* Line 1455 of yacc.c  */
#line 5533 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 875:

/* Line 1455 of yacc.c  */
#line 5548 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = (yyvsp[(2) - (4)].objtype);
					n->relation = (yyvsp[(3) - (4)].range);
					n->name = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 876:

/* Line 1455 of yacc.c  */
#line 5556 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = false;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 877:

/* Line 1455 of yacc.c  */
#line 5566 "gram.y"
    {
					ReindexStmt *n = makeNode(ReindexStmt);
					n->kind = OBJECT_DATABASE;
					n->name = (yyvsp[(3) - (4)].str);
					n->relation = NULL;
					n->do_system = true;
					n->do_user = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 878:

/* Line 1455 of yacc.c  */
#line 5578 "gram.y"
    { (yyval.objtype) = OBJECT_INDEX; ;}
    break;

  case 879:

/* Line 1455 of yacc.c  */
#line 5579 "gram.y"
    { (yyval.objtype) = OBJECT_TABLE; ;}
    break;

  case 880:

/* Line 1455 of yacc.c  */
#line 5582 "gram.y"
    {  (yyval.boolean) = TRUE; ;}
    break;

  case 881:

/* Line 1455 of yacc.c  */
#line 5583 "gram.y"
    {  (yyval.boolean) = FALSE; ;}
    break;

  case 882:

/* Line 1455 of yacc.c  */
#line 5594 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 883:

/* Line 1455 of yacc.c  */
#line 5603 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 884:

/* Line 1455 of yacc.c  */
#line 5611 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_DATABASE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 885:

/* Line 1455 of yacc.c  */
#line 5619 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 886:

/* Line 1455 of yacc.c  */
#line 5628 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 887:

/* Line 1455 of yacc.c  */
#line 5636 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_LANGUAGE;
					n->subname = (yyvsp[(4) - (7)].str);
					n->newname = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 888:

/* Line 1455 of yacc.c  */
#line 5644 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 889:

/* Line 1455 of yacc.c  */
#line 5653 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->subname = (yyvsp[(6) - (9)].str);
					n->newname = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 890:

/* Line 1455 of yacc.c  */
#line 5662 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SCHEMA;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 891:

/* Line 1455 of yacc.c  */
#line 5670 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 892:

/* Line 1455 of yacc.c  */
#line 5679 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 893:

/* Line 1455 of yacc.c  */
#line 5688 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 894:

/* Line 1455 of yacc.c  */
#line 5697 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_INDEX;
					n->relation = (yyvsp[(3) - (6)].range);
					n->subname = NULL;
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 895:

/* Line 1455 of yacc.c  */
#line 5706 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_COLUMN;
					n->relation = (yyvsp[(3) - (8)].range);
					n->subname = (yyvsp[(6) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 896:

/* Line 1455 of yacc.c  */
#line 5715 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TRIGGER;
					n->relation = (yyvsp[(5) - (8)].range);
					n->subname = (yyvsp[(3) - (8)].str);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 897:

/* Line 1455 of yacc.c  */
#line 5724 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 898:

/* Line 1455 of yacc.c  */
#line 5732 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_ROLE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 899:

/* Line 1455 of yacc.c  */
#line 5740 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TABLESPACE;
					n->subname = (yyvsp[(3) - (6)].str);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 900:

/* Line 1455 of yacc.c  */
#line 5748 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 901:

/* Line 1455 of yacc.c  */
#line 5757 "gram.y"
    {
					AlterTableSpaceOptionsStmt *n =
						makeNode(AlterTableSpaceOptionsStmt);
					n->tablespacename = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					n->isReset = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 902:

/* Line 1455 of yacc.c  */
#line 5766 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSPARSER;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 903:

/* Line 1455 of yacc.c  */
#line 5774 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 904:

/* Line 1455 of yacc.c  */
#line 5782 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSTEMPLATE;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 905:

/* Line 1455 of yacc.c  */
#line 5790 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newname = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 906:

/* Line 1455 of yacc.c  */
#line 5798 "gram.y"
    {
					RenameStmt *n = makeNode(RenameStmt);
					n->renameType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newname = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 907:

/* Line 1455 of yacc.c  */
#line 5807 "gram.y"
    { (yyval.ival) = COLUMN; ;}
    break;

  case 908:

/* Line 1455 of yacc.c  */
#line 5808 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 909:

/* Line 1455 of yacc.c  */
#line 5811 "gram.y"
    { (yyval.ival) = 1; ;}
    break;

  case 910:

/* Line 1455 of yacc.c  */
#line 5812 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 911:

/* Line 1455 of yacc.c  */
#line 5823 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newschema = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 912:

/* Line 1455 of yacc.c  */
#line 5832 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 913:

/* Line 1455 of yacc.c  */
#line 5840 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 914:

/* Line 1455 of yacc.c  */
#line 5849 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TABLE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 915:

/* Line 1455 of yacc.c  */
#line 5857 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_SEQUENCE;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 916:

/* Line 1455 of yacc.c  */
#line 5865 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_VIEW;
					n->relation = (yyvsp[(3) - (6)].range);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 917:

/* Line 1455 of yacc.c  */
#line 5873 "gram.y"
    {
					AlterObjectSchemaStmt *n = makeNode(AlterObjectSchemaStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newschema = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 918:

/* Line 1455 of yacc.c  */
#line 5889 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_AGGREGATE;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 919:

/* Line 1455 of yacc.c  */
#line 5898 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_CONVERSION;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 920:

/* Line 1455 of yacc.c  */
#line 5906 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DATABASE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 921:

/* Line 1455 of yacc.c  */
#line 5914 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_DOMAIN;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 922:

/* Line 1455 of yacc.c  */
#line 5922 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FUNCTION;
					n->object = (yyvsp[(3) - (6)].funwithargs)->funcname;
					n->objarg = (yyvsp[(3) - (6)].funwithargs)->funcargs;
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 923:

/* Line 1455 of yacc.c  */
#line 5931 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LANGUAGE;
					n->object = list_make1(makeString((yyvsp[(4) - (7)].str)));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 924:

/* Line 1455 of yacc.c  */
#line 5939 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_LARGEOBJECT;
					n->object = list_make1((yyvsp[(4) - (7)].value));
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 925:

/* Line 1455 of yacc.c  */
#line 5947 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPERATOR;
					n->object = (yyvsp[(3) - (7)].list);
					n->objarg = (yyvsp[(4) - (7)].list);
					n->newowner = (yyvsp[(7) - (7)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 926:

/* Line 1455 of yacc.c  */
#line 5956 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPCLASS;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 927:

/* Line 1455 of yacc.c  */
#line 5965 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_OPFAMILY;
					n->object = (yyvsp[(4) - (9)].list);
					n->addname = (yyvsp[(6) - (9)].str);
					n->newowner = (yyvsp[(9) - (9)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 928:

/* Line 1455 of yacc.c  */
#line 5974 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_SCHEMA;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 929:

/* Line 1455 of yacc.c  */
#line 5982 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TYPE;
					n->object = (yyvsp[(3) - (6)].list);
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 930:

/* Line 1455 of yacc.c  */
#line 5990 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TABLESPACE;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 931:

/* Line 1455 of yacc.c  */
#line 5998 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSDICTIONARY;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 932:

/* Line 1455 of yacc.c  */
#line 6006 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_TSCONFIGURATION;
					n->object = (yyvsp[(5) - (8)].list);
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 933:

/* Line 1455 of yacc.c  */
#line 6014 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FDW;
					n->object = list_make1(makeString((yyvsp[(5) - (8)].str)));
					n->newowner = (yyvsp[(8) - (8)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 934:

/* Line 1455 of yacc.c  */
#line 6022 "gram.y"
    {
					AlterOwnerStmt *n = makeNode(AlterOwnerStmt);
					n->objectType = OBJECT_FOREIGN_SERVER;
					n->object = list_make1(makeString((yyvsp[(3) - (6)].str)));
					n->newowner = (yyvsp[(6) - (6)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 935:

/* Line 1455 of yacc.c  */
#line 6041 "gram.y"
    {
					RuleStmt *n = makeNode(RuleStmt);
					n->replace = (yyvsp[(2) - (13)].boolean);
					n->relation = (yyvsp[(9) - (13)].range);
					n->rulename = (yyvsp[(4) - (13)].str);
					n->whereClause = (yyvsp[(10) - (13)].node);
					n->event = (yyvsp[(7) - (13)].ival);
					n->instead = (yyvsp[(12) - (13)].boolean);
					n->actions = (yyvsp[(13) - (13)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 936:

/* Line 1455 of yacc.c  */
#line 6055 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 937:

/* Line 1455 of yacc.c  */
#line 6056 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 938:

/* Line 1455 of yacc.c  */
#line 6057 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 939:

/* Line 1455 of yacc.c  */
#line 6063 "gram.y"
    { if ((yyvsp[(3) - (3)].node) != NULL)
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				  else
					(yyval.list) = (yyvsp[(1) - (3)].list);
				;}
    break;

  case 940:

/* Line 1455 of yacc.c  */
#line 6069 "gram.y"
    { if ((yyvsp[(1) - (1)].node) != NULL)
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				  else
					(yyval.list) = NIL;
				;}
    break;

  case 946:

/* Line 1455 of yacc.c  */
#line 6085 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 947:

/* Line 1455 of yacc.c  */
#line 6086 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 948:

/* Line 1455 of yacc.c  */
#line 6089 "gram.y"
    { (yyval.ival) = CMD_SELECT; ;}
    break;

  case 949:

/* Line 1455 of yacc.c  */
#line 6090 "gram.y"
    { (yyval.ival) = CMD_UPDATE; ;}
    break;

  case 950:

/* Line 1455 of yacc.c  */
#line 6091 "gram.y"
    { (yyval.ival) = CMD_DELETE; ;}
    break;

  case 951:

/* Line 1455 of yacc.c  */
#line 6092 "gram.y"
    { (yyval.ival) = CMD_INSERT; ;}
    break;

  case 952:

/* Line 1455 of yacc.c  */
#line 6096 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 953:

/* Line 1455 of yacc.c  */
#line 6097 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 954:

/* Line 1455 of yacc.c  */
#line 6098 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 955:

/* Line 1455 of yacc.c  */
#line 6104 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(5) - (6)].range);
					n->property = (yyvsp[(3) - (6)].str);
					n->behavior = (yyvsp[(6) - (6)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 956:

/* Line 1455 of yacc.c  */
#line 6114 "gram.y"
    {
					DropPropertyStmt *n = makeNode(DropPropertyStmt);
					n->relation = (yyvsp[(7) - (8)].range);
					n->property = (yyvsp[(5) - (8)].str);
					n->behavior = (yyvsp[(8) - (8)].dbehavior);
					n->removeType = OBJECT_RULE;
					n->missing_ok = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 957:

/* Line 1455 of yacc.c  */
#line 6135 "gram.y"
    {
					NotifyStmt *n = makeNode(NotifyStmt);
					n->conditionname = (yyvsp[(2) - (3)].str);
					n->payload = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 958:

/* Line 1455 of yacc.c  */
#line 6144 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 959:

/* Line 1455 of yacc.c  */
#line 6145 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 960:

/* Line 1455 of yacc.c  */
#line 6149 "gram.y"
    {
					ListenStmt *n = makeNode(ListenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 961:

/* Line 1455 of yacc.c  */
#line 6158 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 962:

/* Line 1455 of yacc.c  */
#line 6164 "gram.y"
    {
					UnlistenStmt *n = makeNode(UnlistenStmt);
					n->conditionname = NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 963:

/* Line 1455 of yacc.c  */
#line 6183 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 964:

/* Line 1455 of yacc.c  */
#line 6190 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_BEGIN;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 965:

/* Line 1455 of yacc.c  */
#line 6197 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_START;
					n->options = (yyvsp[(3) - (3)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 966:

/* Line 1455 of yacc.c  */
#line 6204 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 967:

/* Line 1455 of yacc.c  */
#line 6211 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 968:

/* Line 1455 of yacc.c  */
#line 6218 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK;
					n->options = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 969:

/* Line 1455 of yacc.c  */
#line 6225 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_SAVEPOINT;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 970:

/* Line 1455 of yacc.c  */
#line 6233 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(3) - (3)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 971:

/* Line 1455 of yacc.c  */
#line 6241 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_RELEASE;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(2) - (2)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 972:

/* Line 1455 of yacc.c  */
#line 6249 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(5) - (5)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 973:

/* Line 1455 of yacc.c  */
#line 6257 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_TO;
					n->options = list_make1(makeDefElem("savepoint_name",
														(Node *)makeString((yyvsp[(4) - (4)].str))));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 974:

/* Line 1455 of yacc.c  */
#line 6265 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_PREPARE;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 975:

/* Line 1455 of yacc.c  */
#line 6272 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_COMMIT_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 976:

/* Line 1455 of yacc.c  */
#line 6279 "gram.y"
    {
					TransactionStmt *n = makeNode(TransactionStmt);
					n->kind = TRANS_STMT_ROLLBACK_PREPARED;
					n->gid = (yyvsp[(3) - (3)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 977:

/* Line 1455 of yacc.c  */
#line 6287 "gram.y"
    {;}
    break;

  case 978:

/* Line 1455 of yacc.c  */
#line 6288 "gram.y"
    {;}
    break;

  case 979:

/* Line 1455 of yacc.c  */
#line 6289 "gram.y"
    {;}
    break;

  case 980:

/* Line 1455 of yacc.c  */
#line 6294 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_isolation",
									   makeStringConst((yyvsp[(3) - (3)].str), (yylsp[(3) - (3)]))); ;}
    break;

  case 981:

/* Line 1455 of yacc.c  */
#line 6297 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(TRUE, (yylsp[(1) - (2)]))); ;}
    break;

  case 982:

/* Line 1455 of yacc.c  */
#line 6300 "gram.y"
    { (yyval.defelt) = makeDefElem("transaction_read_only",
									   makeIntConst(FALSE, (yylsp[(1) - (2)]))); ;}
    break;

  case 983:

/* Line 1455 of yacc.c  */
#line 6307 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].defelt)); ;}
    break;

  case 984:

/* Line 1455 of yacc.c  */
#line 6309 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt)); ;}
    break;

  case 985:

/* Line 1455 of yacc.c  */
#line 6311 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 987:

/* Line 1455 of yacc.c  */
#line 6317 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 988:

/* Line 1455 of yacc.c  */
#line 6331 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(4) - (8)].range);
					n->view->istemp = (yyvsp[(2) - (8)].boolean);
					n->aliases = (yyvsp[(5) - (8)].list);
					n->query = (yyvsp[(7) - (8)].node);
					n->replace = false;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 989:

/* Line 1455 of yacc.c  */
#line 6342 "gram.y"
    {
					ViewStmt *n = makeNode(ViewStmt);
					n->view = (yyvsp[(6) - (10)].range);
					n->view->istemp = (yyvsp[(4) - (10)].boolean);
					n->aliases = (yyvsp[(7) - (10)].list);
					n->query = (yyvsp[(9) - (10)].node);
					n->replace = true;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 990:

/* Line 1455 of yacc.c  */
#line 6355 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 991:

/* Line 1455 of yacc.c  */
#line 6361 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 992:

/* Line 1455 of yacc.c  */
#line 6367 "gram.y"
    {
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("WITH CHECK OPTION is not implemented")));
				;}
    break;

  case 993:

/* Line 1455 of yacc.c  */
#line 6372 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 994:

/* Line 1455 of yacc.c  */
#line 6383 "gram.y"
    {
					LoadStmt *n = makeNode(LoadStmt);
					n->filename = (yyvsp[(2) - (2)].str);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 995:

/* Line 1455 of yacc.c  */
#line 6399 "gram.y"
    {
					CreatedbStmt *n = makeNode(CreatedbStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 996:

/* Line 1455 of yacc.c  */
#line 6408 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 997:

/* Line 1455 of yacc.c  */
#line 6409 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 998:

/* Line 1455 of yacc.c  */
#line 6414 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 999:

/* Line 1455 of yacc.c  */
#line 6418 "gram.y"
    {
					(yyval.defelt) = makeDefElem("tablespace", NULL);
				;}
    break;

  case 1000:

/* Line 1455 of yacc.c  */
#line 6422 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1001:

/* Line 1455 of yacc.c  */
#line 6426 "gram.y"
    {
					(yyval.defelt) = makeDefElem("location", NULL);
				;}
    break;

  case 1002:

/* Line 1455 of yacc.c  */
#line 6430 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1003:

/* Line 1455 of yacc.c  */
#line 6434 "gram.y"
    {
					(yyval.defelt) = makeDefElem("template", NULL);
				;}
    break;

  case 1004:

/* Line 1455 of yacc.c  */
#line 6438 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1005:

/* Line 1455 of yacc.c  */
#line 6442 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", (Node *)makeInteger((yyvsp[(3) - (3)].ival)));
				;}
    break;

  case 1006:

/* Line 1455 of yacc.c  */
#line 6446 "gram.y"
    {
					(yyval.defelt) = makeDefElem("encoding", NULL);
				;}
    break;

  case 1007:

/* Line 1455 of yacc.c  */
#line 6450 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1008:

/* Line 1455 of yacc.c  */
#line 6454 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_collate", NULL);
				;}
    break;

  case 1009:

/* Line 1455 of yacc.c  */
#line 6458 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1010:

/* Line 1455 of yacc.c  */
#line 6462 "gram.y"
    {
					(yyval.defelt) = makeDefElem("lc_ctype", NULL);
				;}
    break;

  case 1011:

/* Line 1455 of yacc.c  */
#line 6466 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1012:

/* Line 1455 of yacc.c  */
#line 6470 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", (Node *)makeString((yyvsp[(3) - (3)].str)));
				;}
    break;

  case 1013:

/* Line 1455 of yacc.c  */
#line 6474 "gram.y"
    {
					(yyval.defelt) = makeDefElem("owner", NULL);
				;}
    break;

  case 1014:

/* Line 1455 of yacc.c  */
#line 6483 "gram.y"
    {;}
    break;

  case 1015:

/* Line 1455 of yacc.c  */
#line 6484 "gram.y"
    {;}
    break;

  case 1016:

/* Line 1455 of yacc.c  */
#line 6496 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (5)].str);
					n->options = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1017:

/* Line 1455 of yacc.c  */
#line 6503 "gram.y"
    {
					AlterDatabaseStmt *n = makeNode(AlterDatabaseStmt);
					n->dbname = (yyvsp[(3) - (6)].str);
					n->options = list_make1(makeDefElem("tablespace",
													(Node *)makeString((yyvsp[(6) - (6)].str))));
					(yyval.node) = (Node *)n;
				 ;}
    break;

  case 1018:

/* Line 1455 of yacc.c  */
#line 6514 "gram.y"
    {
					AlterDatabaseSetStmt *n = makeNode(AlterDatabaseSetStmt);
					n->dbname = (yyvsp[(3) - (4)].str);
					n->setstmt = (yyvsp[(4) - (4)].vsetstmt);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1019:

/* Line 1455 of yacc.c  */
#line 6524 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].defelt)); ;}
    break;

  case 1020:

/* Line 1455 of yacc.c  */
#line 6525 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1021:

/* Line 1455 of yacc.c  */
#line 6530 "gram.y"
    {
					(yyval.defelt) = makeDefElem("connectionlimit", (Node *)makeInteger((yyvsp[(4) - (4)].ival)));
				;}
    break;

  case 1022:

/* Line 1455 of yacc.c  */
#line 6544 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(3) - (3)].str);
					n->missing_ok = FALSE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1023:

/* Line 1455 of yacc.c  */
#line 6551 "gram.y"
    {
					DropdbStmt *n = makeNode(DropdbStmt);
					n->dbname = (yyvsp[(5) - (5)].str);
					n->missing_ok = TRUE;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1024:

/* Line 1455 of yacc.c  */
#line 6568 "gram.y"
    {
					CreateDomainStmt *n = makeNode(CreateDomainStmt);
					n->domainname = (yyvsp[(3) - (6)].list);
					n->typeName = (yyvsp[(5) - (6)].typnam);
					n->constraints = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1025:

/* Line 1455 of yacc.c  */
#line 6580 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'T';
					n->typeName = (yyvsp[(3) - (4)].list);
					n->def = (yyvsp[(4) - (4)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1026:

/* Line 1455 of yacc.c  */
#line 6589 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'N';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1027:

/* Line 1455 of yacc.c  */
#line 6597 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'O';
					n->typeName = (yyvsp[(3) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1028:

/* Line 1455 of yacc.c  */
#line 6605 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'C';
					n->typeName = (yyvsp[(3) - (5)].list);
					n->def = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1029:

/* Line 1455 of yacc.c  */
#line 6614 "gram.y"
    {
					AlterDomainStmt *n = makeNode(AlterDomainStmt);
					n->subtype = 'X';
					n->typeName = (yyvsp[(3) - (7)].list);
					n->name = (yyvsp[(6) - (7)].str);
					n->behavior = (yyvsp[(7) - (7)].dbehavior);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1030:

/* Line 1455 of yacc.c  */
#line 6624 "gram.y"
    {;}
    break;

  case 1031:

/* Line 1455 of yacc.c  */
#line 6625 "gram.y"
    {;}
    break;

  case 1032:

/* Line 1455 of yacc.c  */
#line 6637 "gram.y"
    {
					AlterTSDictionaryStmt *n = makeNode(AlterTSDictionaryStmt);
					n->dictname = (yyvsp[(5) - (6)].list);
					n->options = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1033:

/* Line 1455 of yacc.c  */
#line 6647 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = false;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1034:

/* Line 1455 of yacc.c  */
#line 6657 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(9) - (11)].list);
					n->dicts = (yyvsp[(11) - (11)].list);
					n->override = true;
					n->replace = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1035:

/* Line 1455 of yacc.c  */
#line 6667 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = NIL;
					n->dicts = list_make2((yyvsp[(9) - (11)].list),(yyvsp[(11) - (11)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1036:

/* Line 1455 of yacc.c  */
#line 6677 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (13)].list);
					n->tokentype = (yyvsp[(9) - (13)].list);
					n->dicts = list_make2((yyvsp[(11) - (13)].list),(yyvsp[(13) - (13)].list));
					n->override = false;
					n->replace = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1037:

/* Line 1455 of yacc.c  */
#line 6687 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (9)].list);
					n->tokentype = (yyvsp[(9) - (9)].list);
					n->missing_ok = false;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1038:

/* Line 1455 of yacc.c  */
#line 6695 "gram.y"
    {
					AlterTSConfigurationStmt *n = makeNode(AlterTSConfigurationStmt);
					n->cfgname = (yyvsp[(5) - (11)].list);
					n->tokentype = (yyvsp[(11) - (11)].list);
					n->missing_ok = true;
					(yyval.node) = (Node*)n;
				;}
    break;

  case 1039:

/* Line 1455 of yacc.c  */
#line 6717 "gram.y"
    {
			  CreateConversionStmt *n = makeNode(CreateConversionStmt);
			  n->conversion_name = (yyvsp[(4) - (10)].list);
			  n->for_encoding_name = (yyvsp[(6) - (10)].str);
			  n->to_encoding_name = (yyvsp[(8) - (10)].str);
			  n->func_name = (yyvsp[(10) - (10)].list);
			  n->def = (yyvsp[(2) - (10)].boolean);
			  (yyval.node) = (Node *)n;
			;}
    break;

  case 1040:

/* Line 1455 of yacc.c  */
#line 6739 "gram.y"
    {
			       ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(3) - (4)].range);
				   n->indexname = (yyvsp[(4) - (4)].str);
				   n->verbose = (yyvsp[(2) - (4)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1041:

/* Line 1455 of yacc.c  */
#line 6747 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = NULL;
				   n->indexname = NULL;
				   n->verbose = (yyvsp[(2) - (2)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1042:

/* Line 1455 of yacc.c  */
#line 6756 "gram.y"
    {
				   ClusterStmt *n = makeNode(ClusterStmt);
				   n->relation = (yyvsp[(5) - (5)].range);
				   n->indexname = (yyvsp[(3) - (5)].str);
				   n->verbose = (yyvsp[(2) - (5)].boolean);
				   (yyval.node) = (Node*)n;
				;}
    break;

  case 1043:

/* Line 1455 of yacc.c  */
#line 6766 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].str); ;}
    break;

  case 1044:

/* Line 1455 of yacc.c  */
#line 6767 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1045:

/* Line 1455 of yacc.c  */
#line 6780 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (4)].boolean) ? 0 : -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1046:

/* Line 1455 of yacc.c  */
#line 6794 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->relation = (yyvsp[(5) - (5)].range);
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1047:

/* Line 1455 of yacc.c  */
#line 6808 "gram.y"
    {
					VacuumStmt *n = (VacuumStmt *) (yyvsp[(5) - (5)].node);
					n->options |= VACOPT_VACUUM;
					if ((yyvsp[(2) - (5)].boolean))
						n->options |= VACOPT_FULL;
					if ((yyvsp[(4) - (5)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					n->freeze_table_age = (yyvsp[(3) - (5)].boolean) ? 0 : -1;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1048:

/* Line 1455 of yacc.c  */
#line 6820 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (4)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1049:

/* Line 1455 of yacc.c  */
#line 6832 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_VACUUM | (yyvsp[(3) - (6)].ival);
					if (n->options & VACOPT_FREEZE)
						n->freeze_min_age = n->freeze_table_age = 0;
					else
						n->freeze_min_age = n->freeze_table_age = -1;
					n->relation = (yyvsp[(5) - (6)].range);
					n->va_cols = (yyvsp[(6) - (6)].list);
					if (n->va_cols != NIL)	/* implies analyze */
						n->options |= VACOPT_ANALYZE;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1050:

/* Line 1455 of yacc.c  */
#line 6848 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1051:

/* Line 1455 of yacc.c  */
#line 6849 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | (yyvsp[(3) - (3)].ival); ;}
    break;

  case 1052:

/* Line 1455 of yacc.c  */
#line 6853 "gram.y"
    { (yyval.ival) = VACOPT_ANALYZE; ;}
    break;

  case 1053:

/* Line 1455 of yacc.c  */
#line 6854 "gram.y"
    { (yyval.ival) = VACOPT_VERBOSE; ;}
    break;

  case 1054:

/* Line 1455 of yacc.c  */
#line 6855 "gram.y"
    { (yyval.ival) = VACOPT_FREEZE; ;}
    break;

  case 1055:

/* Line 1455 of yacc.c  */
#line 6856 "gram.y"
    { (yyval.ival) = VACOPT_FULL; ;}
    break;

  case 1056:

/* Line 1455 of yacc.c  */
#line 6861 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (2)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = NULL;
					n->va_cols = NIL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1057:

/* Line 1455 of yacc.c  */
#line 6873 "gram.y"
    {
					VacuumStmt *n = makeNode(VacuumStmt);
					n->options = VACOPT_ANALYZE;
					if ((yyvsp[(2) - (4)].boolean))
						n->options |= VACOPT_VERBOSE;
					n->freeze_min_age = -1;
					n->freeze_table_age = -1;
					n->relation = (yyvsp[(3) - (4)].range);
					n->va_cols = (yyvsp[(4) - (4)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1058:

/* Line 1455 of yacc.c  */
#line 6887 "gram.y"
    {;}
    break;

  case 1059:

/* Line 1455 of yacc.c  */
#line 6888 "gram.y"
    {;}
    break;

  case 1060:

/* Line 1455 of yacc.c  */
#line 6892 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1061:

/* Line 1455 of yacc.c  */
#line 6893 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1062:

/* Line 1455 of yacc.c  */
#line 6896 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1063:

/* Line 1455 of yacc.c  */
#line 6897 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1064:

/* Line 1455 of yacc.c  */
#line 6900 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1065:

/* Line 1455 of yacc.c  */
#line 6901 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1066:

/* Line 1455 of yacc.c  */
#line 6905 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1067:

/* Line 1455 of yacc.c  */
#line 6906 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1068:

/* Line 1455 of yacc.c  */
#line 6920 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(2) - (2)].node);
					n->options = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1069:

/* Line 1455 of yacc.c  */
#line 6927 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(4) - (4)].node);
					n->options = list_make1(makeDefElem("analyze", NULL));
					if ((yyvsp[(3) - (4)].boolean))
						n->options = lappend(n->options,
											 makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1070:

/* Line 1455 of yacc.c  */
#line 6937 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(3) - (3)].node);
					n->options = list_make1(makeDefElem("verbose", NULL));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1071:

/* Line 1455 of yacc.c  */
#line 6944 "gram.y"
    {
					ExplainStmt *n = makeNode(ExplainStmt);
					n->query = (yyvsp[(5) - (5)].node);
					n->options = (yyvsp[(3) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1079:

/* Line 1455 of yacc.c  */
#line 6964 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].defelt));
				;}
    break;

  case 1080:

/* Line 1455 of yacc.c  */
#line 6968 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].defelt));
				;}
    break;

  case 1081:

/* Line 1455 of yacc.c  */
#line 6975 "gram.y"
    {
					(yyval.defelt) = makeDefElem((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1082:

/* Line 1455 of yacc.c  */
#line 6981 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1083:

/* Line 1455 of yacc.c  */
#line 6982 "gram.y"
    { (yyval.str) = "analyze"; ;}
    break;

  case 1084:

/* Line 1455 of yacc.c  */
#line 6983 "gram.y"
    { (yyval.str) = "verbose"; ;}
    break;

  case 1085:

/* Line 1455 of yacc.c  */
#line 6987 "gram.y"
    { (yyval.node) = (Node *) makeString((yyvsp[(1) - (1)].str)); ;}
    break;

  case 1086:

/* Line 1455 of yacc.c  */
#line 6988 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].value); ;}
    break;

  case 1087:

/* Line 1455 of yacc.c  */
#line 6989 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1088:

/* Line 1455 of yacc.c  */
#line 7000 "gram.y"
    {
					PrepareStmt *n = makeNode(PrepareStmt);
					n->name = (yyvsp[(2) - (5)].str);
					n->argtypes = (yyvsp[(3) - (5)].list);
					n->query = (yyvsp[(5) - (5)].node);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1089:

/* Line 1455 of yacc.c  */
#line 7009 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1090:

/* Line 1455 of yacc.c  */
#line 7010 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1095:

/* Line 1455 of yacc.c  */
#line 7028 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(2) - (3)].str);
					n->params = (yyvsp[(3) - (3)].list);
					n->into = NULL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1096:

/* Line 1455 of yacc.c  */
#line 7037 "gram.y"
    {
					ExecuteStmt *n = makeNode(ExecuteStmt);
					n->name = (yyvsp[(7) - (8)].str);
					n->params = (yyvsp[(8) - (8)].list);
					(yyvsp[(4) - (8)].into)->rel->istemp = (yyvsp[(2) - (8)].boolean);
					n->into = (yyvsp[(4) - (8)].into);
					if ((yyvsp[(4) - (8)].into)->colNames)
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("column name list not allowed in CREATE TABLE / AS EXECUTE")));
					/* ... because it's not implemented, but it could be */
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1097:

/* Line 1455 of yacc.c  */
#line 7052 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1098:

/* Line 1455 of yacc.c  */
#line 7053 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1099:

/* Line 1455 of yacc.c  */
#line 7064 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(2) - (2)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1100:

/* Line 1455 of yacc.c  */
#line 7070 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = (yyvsp[(3) - (3)].str);
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1101:

/* Line 1455 of yacc.c  */
#line 7076 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1102:

/* Line 1455 of yacc.c  */
#line 7082 "gram.y"
    {
						DeallocateStmt *n = makeNode(DeallocateStmt);
						n->name = NULL;
						(yyval.node) = (Node *) n;
					;}
    break;

  case 1103:

/* Line 1455 of yacc.c  */
#line 7098 "gram.y"
    {
					(yyvsp[(4) - (5)].istmt)->relation = (yyvsp[(3) - (5)].range);
					(yyvsp[(4) - (5)].istmt)->returningList = (yyvsp[(5) - (5)].list);
					(yyval.node) = (Node *) (yyvsp[(4) - (5)].istmt);
				;}
    break;

  case 1104:

/* Line 1455 of yacc.c  */
#line 7107 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1105:

/* Line 1455 of yacc.c  */
#line 7113 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = (yyvsp[(2) - (4)].list);
					(yyval.istmt)->selectStmt = (yyvsp[(4) - (4)].node);
				;}
    break;

  case 1106:

/* Line 1455 of yacc.c  */
#line 7119 "gram.y"
    {
					(yyval.istmt) = makeNode(InsertStmt);
					(yyval.istmt)->cols = NIL;
					(yyval.istmt)->selectStmt = NULL;
				;}
    break;

  case 1107:

/* Line 1455 of yacc.c  */
#line 7128 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1108:

/* Line 1455 of yacc.c  */
#line 7130 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1109:

/* Line 1455 of yacc.c  */
#line 7135 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1110:

/* Line 1455 of yacc.c  */
#line 7145 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1111:

/* Line 1455 of yacc.c  */
#line 7146 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1112:

/* Line 1455 of yacc.c  */
#line 7159 "gram.y"
    {
					DeleteStmt *n = makeNode(DeleteStmt);
					n->relation = (yyvsp[(3) - (6)].range);
					n->usingClause = (yyvsp[(4) - (6)].list);
					n->whereClause = (yyvsp[(5) - (6)].node);
					n->returningList = (yyvsp[(6) - (6)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1113:

/* Line 1455 of yacc.c  */
#line 7170 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1114:

/* Line 1455 of yacc.c  */
#line 7171 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1115:

/* Line 1455 of yacc.c  */
#line 7183 "gram.y"
    {
					LockStmt *n = makeNode(LockStmt);

					n->relations = (yyvsp[(3) - (5)].list);
					n->mode = (yyvsp[(4) - (5)].ival);
					n->nowait = (yyvsp[(5) - (5)].boolean);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1116:

/* Line 1455 of yacc.c  */
#line 7193 "gram.y"
    { (yyval.ival) = (yyvsp[(2) - (3)].ival); ;}
    break;

  case 1117:

/* Line 1455 of yacc.c  */
#line 7194 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1118:

/* Line 1455 of yacc.c  */
#line 7197 "gram.y"
    { (yyval.ival) = AccessShareLock; ;}
    break;

  case 1119:

/* Line 1455 of yacc.c  */
#line 7198 "gram.y"
    { (yyval.ival) = RowShareLock; ;}
    break;

  case 1120:

/* Line 1455 of yacc.c  */
#line 7199 "gram.y"
    { (yyval.ival) = RowExclusiveLock; ;}
    break;

  case 1121:

/* Line 1455 of yacc.c  */
#line 7200 "gram.y"
    { (yyval.ival) = ShareUpdateExclusiveLock; ;}
    break;

  case 1122:

/* Line 1455 of yacc.c  */
#line 7201 "gram.y"
    { (yyval.ival) = ShareLock; ;}
    break;

  case 1123:

/* Line 1455 of yacc.c  */
#line 7202 "gram.y"
    { (yyval.ival) = ShareRowExclusiveLock; ;}
    break;

  case 1124:

/* Line 1455 of yacc.c  */
#line 7203 "gram.y"
    { (yyval.ival) = ExclusiveLock; ;}
    break;

  case 1125:

/* Line 1455 of yacc.c  */
#line 7204 "gram.y"
    { (yyval.ival) = AccessExclusiveLock; ;}
    break;

  case 1126:

/* Line 1455 of yacc.c  */
#line 7207 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1127:

/* Line 1455 of yacc.c  */
#line 7208 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1128:

/* Line 1455 of yacc.c  */
#line 7224 "gram.y"
    {
					UpdateStmt *n = makeNode(UpdateStmt);
					n->relation = (yyvsp[(2) - (7)].range);
					n->targetList = (yyvsp[(4) - (7)].list);
					n->fromClause = (yyvsp[(5) - (7)].list);
					n->whereClause = (yyvsp[(6) - (7)].node);
					n->returningList = (yyvsp[(7) - (7)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1129:

/* Line 1455 of yacc.c  */
#line 7236 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1130:

/* Line 1455 of yacc.c  */
#line 7237 "gram.y"
    { (yyval.list) = list_concat((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].list)); ;}
    break;

  case 1131:

/* Line 1455 of yacc.c  */
#line 7241 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1132:

/* Line 1455 of yacc.c  */
#line 7242 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1133:

/* Line 1455 of yacc.c  */
#line 7247 "gram.y"
    {
					(yyval.target) = (yyvsp[(1) - (3)].target);
					(yyval.target)->val = (Node *) (yyvsp[(3) - (3)].node);
				;}
    break;

  case 1134:

/* Line 1455 of yacc.c  */
#line 7255 "gram.y"
    {
					ListCell *col_cell;
					ListCell *val_cell;

					/*
					 * Break the ctext_row apart, merge individual expressions
					 * into the destination ResTargets.  XXX this approach
					 * cannot work for general row expressions as sources.
					 */
					if (list_length((yyvsp[(2) - (5)].list)) != list_length((yyvsp[(5) - (5)].list)))
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("number of columns does not match number of values"),
								 parser_errposition((yylsp[(1) - (5)]))));
					forboth(col_cell, (yyvsp[(2) - (5)].list), val_cell, (yyvsp[(5) - (5)].list))
					{
						ResTarget *res_col = (ResTarget *) lfirst(col_cell);
						Node *res_val = (Node *) lfirst(val_cell);

						res_col->val = res_val;
					}

					(yyval.list) = (yyvsp[(2) - (5)].list);
				;}
    break;

  case 1135:

/* Line 1455 of yacc.c  */
#line 7283 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(1) - (2)].str);
					(yyval.target)->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.target)->val = NULL;	/* upper production sets this */
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1136:

/* Line 1455 of yacc.c  */
#line 7293 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1137:

/* Line 1455 of yacc.c  */
#line 7294 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list),(yyvsp[(3) - (3)].target)); ;}
    break;

  case 1138:

/* Line 1455 of yacc.c  */
#line 7305 "gram.y"
    {
					DeclareCursorStmt *n = makeNode(DeclareCursorStmt);
					n->portalname = (yyvsp[(2) - (7)].str);
					/* currently we always set FAST_PLAN option */
					n->options = (yyvsp[(3) - (7)].ival) | (yyvsp[(5) - (7)].ival) | CURSOR_OPT_FAST_PLAN;
					n->query = (yyvsp[(7) - (7)].node);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1139:

/* Line 1455 of yacc.c  */
#line 7315 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1140:

/* Line 1455 of yacc.c  */
#line 7318 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1141:

/* Line 1455 of yacc.c  */
#line 7319 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (3)].ival) | CURSOR_OPT_NO_SCROLL; ;}
    break;

  case 1142:

/* Line 1455 of yacc.c  */
#line 7320 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_SCROLL; ;}
    break;

  case 1143:

/* Line 1455 of yacc.c  */
#line 7321 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_BINARY; ;}
    break;

  case 1144:

/* Line 1455 of yacc.c  */
#line 7322 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (2)].ival) | CURSOR_OPT_INSENSITIVE; ;}
    break;

  case 1145:

/* Line 1455 of yacc.c  */
#line 7325 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1146:

/* Line 1455 of yacc.c  */
#line 7326 "gram.y"
    { (yyval.ival) = CURSOR_OPT_HOLD; ;}
    break;

  case 1147:

/* Line 1455 of yacc.c  */
#line 7327 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1150:

/* Line 1455 of yacc.c  */
#line 7380 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1151:

/* Line 1455 of yacc.c  */
#line 7381 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1152:

/* Line 1455 of yacc.c  */
#line 7395 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1153:

/* Line 1455 of yacc.c  */
#line 7397 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].list), NIL,
										NULL, NULL, NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (2)].node);
				;}
    break;

  case 1154:

/* Line 1455 of yacc.c  */
#line 7404 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(3) - (4)].list),
										list_nth((yyvsp[(4) - (4)].list), 0), list_nth((yyvsp[(4) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1155:

/* Line 1455 of yacc.c  */
#line 7412 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].list), (yyvsp[(4) - (4)].list),
										list_nth((yyvsp[(3) - (4)].list), 0), list_nth((yyvsp[(3) - (4)].list), 1),
										NULL,
										yyscanner);
					(yyval.node) = (yyvsp[(1) - (4)].node);
				;}
    break;

  case 1156:

/* Line 1455 of yacc.c  */
#line 7420 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (2)].node), NULL, NIL,
										NULL, NULL,
										(yyvsp[(1) - (2)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (2)].node);
				;}
    break;

  case 1157:

/* Line 1455 of yacc.c  */
#line 7428 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].list), NIL,
										NULL, NULL,
										(yyvsp[(1) - (3)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (3)].node);
				;}
    break;

  case 1158:

/* Line 1455 of yacc.c  */
#line 7436 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(4) - (5)].list),
										list_nth((yyvsp[(5) - (5)].list), 0), list_nth((yyvsp[(5) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1159:

/* Line 1455 of yacc.c  */
#line 7444 "gram.y"
    {
					insertSelectOptions((SelectStmt *) (yyvsp[(2) - (5)].node), (yyvsp[(3) - (5)].list), (yyvsp[(5) - (5)].list),
										list_nth((yyvsp[(4) - (5)].list), 0), list_nth((yyvsp[(4) - (5)].list), 1),
										(yyvsp[(1) - (5)].with),
										yyscanner);
					(yyval.node) = (yyvsp[(2) - (5)].node);
				;}
    break;

  case 1160:

/* Line 1455 of yacc.c  */
#line 7454 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1161:

/* Line 1455 of yacc.c  */
#line 7455 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1162:

/* Line 1455 of yacc.c  */
#line 7485 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->distinctClause = (yyvsp[(2) - (9)].list);
					n->targetList = (yyvsp[(3) - (9)].list);
					n->intoClause = (yyvsp[(4) - (9)].into);
					n->fromClause = (yyvsp[(5) - (9)].list);
					n->whereClause = (yyvsp[(6) - (9)].node);
					n->groupClause = (yyvsp[(7) - (9)].list);
					n->havingClause = (yyvsp[(8) - (9)].node);
					n->windowClause = (yyvsp[(9) - (9)].list);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1163:

/* Line 1455 of yacc.c  */
#line 7497 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1164:

/* Line 1455 of yacc.c  */
#line 7499 "gram.y"
    {
					/* same as SELECT * FROM relation_expr */
					ColumnRef *cr = makeNode(ColumnRef);
					ResTarget *rt = makeNode(ResTarget);
					SelectStmt *n = makeNode(SelectStmt);

					cr->fields = list_make1(makeNode(A_Star));
					cr->location = -1;

					rt->name = NULL;
					rt->indirection = NIL;
					rt->val = (Node *)cr;
					rt->location = -1;

					n->targetList = list_make1(rt);
					n->fromClause = list_make1((yyvsp[(2) - (2)].range));
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1165:

/* Line 1455 of yacc.c  */
#line 7518 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_UNION, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1166:

/* Line 1455 of yacc.c  */
#line 7522 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_INTERSECT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1167:

/* Line 1455 of yacc.c  */
#line 7526 "gram.y"
    {
					(yyval.node) = makeSetOp(SETOP_EXCEPT, (yyvsp[(3) - (4)].boolean), (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1168:

/* Line 1455 of yacc.c  */
#line 7541 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(2) - (2)].list);
				(yyval.with)->recursive = false;
				(yyval.with)->location = (yylsp[(1) - (2)]);
			;}
    break;

  case 1169:

/* Line 1455 of yacc.c  */
#line 7548 "gram.y"
    {
				(yyval.with) = makeNode(WithClause);
				(yyval.with)->ctes = (yyvsp[(3) - (3)].list);
				(yyval.with)->recursive = true;
				(yyval.with)->location = (yylsp[(1) - (3)]);
			;}
    break;

  case 1170:

/* Line 1455 of yacc.c  */
#line 7557 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1171:

/* Line 1455 of yacc.c  */
#line 7558 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1172:

/* Line 1455 of yacc.c  */
#line 7562 "gram.y"
    {
				CommonTableExpr *n = makeNode(CommonTableExpr);
				n->ctename = (yyvsp[(1) - (4)].str);
				n->aliascolnames = (yyvsp[(2) - (4)].list);
				n->ctequery = (yyvsp[(4) - (4)].node);
				n->location = (yylsp[(1) - (4)]);
				(yyval.node) = (Node *) n;
			;}
    break;

  case 1173:

/* Line 1455 of yacc.c  */
#line 7574 "gram.y"
    {
					(yyval.into) = makeNode(IntoClause);
					(yyval.into)->rel = (yyvsp[(2) - (2)].range);
					(yyval.into)->colNames = NIL;
					(yyval.into)->options = NIL;
					(yyval.into)->onCommit = ONCOMMIT_NOOP;
					(yyval.into)->tableSpaceName = NULL;
				;}
    break;

  case 1174:

/* Line 1455 of yacc.c  */
#line 7583 "gram.y"
    { (yyval.into) = NULL; ;}
    break;

  case 1175:

/* Line 1455 of yacc.c  */
#line 7592 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1176:

/* Line 1455 of yacc.c  */
#line 7597 "gram.y"
    {
					(yyval.range) = (yyvsp[(3) - (3)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1177:

/* Line 1455 of yacc.c  */
#line 7602 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1178:

/* Line 1455 of yacc.c  */
#line 7607 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1179:

/* Line 1455 of yacc.c  */
#line 7612 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1180:

/* Line 1455 of yacc.c  */
#line 7617 "gram.y"
    {
					(yyval.range) = (yyvsp[(4) - (4)].range);
					(yyval.range)->istemp = true;
				;}
    break;

  case 1181:

/* Line 1455 of yacc.c  */
#line 7622 "gram.y"
    {
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1182:

/* Line 1455 of yacc.c  */
#line 7627 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->istemp = false;
				;}
    break;

  case 1183:

/* Line 1455 of yacc.c  */
#line 7633 "gram.y"
    {;}
    break;

  case 1184:

/* Line 1455 of yacc.c  */
#line 7634 "gram.y"
    {;}
    break;

  case 1185:

/* Line 1455 of yacc.c  */
#line 7637 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1186:

/* Line 1455 of yacc.c  */
#line 7638 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1187:

/* Line 1455 of yacc.c  */
#line 7639 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1188:

/* Line 1455 of yacc.c  */
#line 7646 "gram.y"
    { (yyval.list) = list_make1(NIL); ;}
    break;

  case 1189:

/* Line 1455 of yacc.c  */
#line 7647 "gram.y"
    { (yyval.list) = (yyvsp[(4) - (5)].list); ;}
    break;

  case 1190:

/* Line 1455 of yacc.c  */
#line 7648 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1191:

/* Line 1455 of yacc.c  */
#line 7649 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1192:

/* Line 1455 of yacc.c  */
#line 7653 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list);;}
    break;

  case 1193:

/* Line 1455 of yacc.c  */
#line 7654 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1194:

/* Line 1455 of yacc.c  */
#line 7658 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1195:

/* Line 1455 of yacc.c  */
#line 7662 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].sortby)); ;}
    break;

  case 1196:

/* Line 1455 of yacc.c  */
#line 7663 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].sortby)); ;}
    break;

  case 1197:

/* Line 1455 of yacc.c  */
#line 7667 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (4)].node);
					(yyval.sortby)->sortby_dir = SORTBY_USING;
					(yyval.sortby)->sortby_nulls = (yyvsp[(4) - (4)].ival);
					(yyval.sortby)->useOp = (yyvsp[(3) - (4)].list);
					(yyval.sortby)->location = (yylsp[(3) - (4)]);
				;}
    break;

  case 1198:

/* Line 1455 of yacc.c  */
#line 7676 "gram.y"
    {
					(yyval.sortby) = makeNode(SortBy);
					(yyval.sortby)->node = (yyvsp[(1) - (3)].node);
					(yyval.sortby)->sortby_dir = (yyvsp[(2) - (3)].ival);
					(yyval.sortby)->sortby_nulls = (yyvsp[(3) - (3)].ival);
					(yyval.sortby)->useOp = NIL;
					(yyval.sortby)->location = -1;		/* no operator */
				;}
    break;

  case 1199:

/* Line 1455 of yacc.c  */
#line 7688 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(2) - (2)].node), (yyvsp[(1) - (2)].node)); ;}
    break;

  case 1200:

/* Line 1455 of yacc.c  */
#line 7689 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1201:

/* Line 1455 of yacc.c  */
#line 7690 "gram.y"
    { (yyval.list) = list_make2(NULL, (yyvsp[(1) - (1)].node)); ;}
    break;

  case 1202:

/* Line 1455 of yacc.c  */
#line 7691 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(1) - (1)].node), NULL); ;}
    break;

  case 1203:

/* Line 1455 of yacc.c  */
#line 7695 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1204:

/* Line 1455 of yacc.c  */
#line 7696 "gram.y"
    { (yyval.list) = list_make2(NULL,NULL); ;}
    break;

  case 1205:

/* Line 1455 of yacc.c  */
#line 7701 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1206:

/* Line 1455 of yacc.c  */
#line 7703 "gram.y"
    {
					/* Disabled because it was too confusing, bjm 2002-02-18 */
					ereport(ERROR,
							(errcode(ERRCODE_SYNTAX_ERROR),
							 errmsg("LIMIT #,# syntax is not supported"),
							 errhint("Use separate LIMIT and OFFSET clauses."),
							 parser_errposition((yylsp[(1) - (4)]))));
				;}
    break;

  case 1207:

/* Line 1455 of yacc.c  */
#line 7713 "gram.y"
    { (yyval.node) = (yyvsp[(3) - (5)].node); ;}
    break;

  case 1208:

/* Line 1455 of yacc.c  */
#line 7718 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1209:

/* Line 1455 of yacc.c  */
#line 7721 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1210:

/* Line 1455 of yacc.c  */
#line 7725 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1211:

/* Line 1455 of yacc.c  */
#line 7727 "gram.y"
    {
					/* LIMIT ALL is represented as a NULL constant */
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1212:

/* Line 1455 of yacc.c  */
#line 7734 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1213:

/* Line 1455 of yacc.c  */
#line 7744 "gram.y"
    { (yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)])); ;}
    break;

  case 1214:

/* Line 1455 of yacc.c  */
#line 7745 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (3)].node); ;}
    break;

  case 1215:

/* Line 1455 of yacc.c  */
#line 7746 "gram.y"
    { (yyval.node) = makeIntConst(1, -1); ;}
    break;

  case 1216:

/* Line 1455 of yacc.c  */
#line 7754 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1217:

/* Line 1455 of yacc.c  */
#line 7758 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1218:

/* Line 1455 of yacc.c  */
#line 7759 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1219:

/* Line 1455 of yacc.c  */
#line 7762 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1220:

/* Line 1455 of yacc.c  */
#line 7763 "gram.y"
    { (yyval.ival) = 0; ;}
    break;

  case 1221:

/* Line 1455 of yacc.c  */
#line 7768 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1222:

/* Line 1455 of yacc.c  */
#line 7769 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1223:

/* Line 1455 of yacc.c  */
#line 7773 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1224:

/* Line 1455 of yacc.c  */
#line 7774 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1225:

/* Line 1455 of yacc.c  */
#line 7778 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1226:

/* Line 1455 of yacc.c  */
#line 7779 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1227:

/* Line 1455 of yacc.c  */
#line 7783 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1228:

/* Line 1455 of yacc.c  */
#line 7784 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1229:

/* Line 1455 of yacc.c  */
#line 7788 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1230:

/* Line 1455 of yacc.c  */
#line 7789 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1231:

/* Line 1455 of yacc.c  */
#line 7794 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = TRUE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1232:

/* Line 1455 of yacc.c  */
#line 7802 "gram.y"
    {
					LockingClause *n = makeNode(LockingClause);
					n->lockedRels = (yyvsp[(3) - (4)].list);
					n->forUpdate = FALSE;
					n->noWait = (yyvsp[(4) - (4)].boolean);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1233:

/* Line 1455 of yacc.c  */
#line 7812 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1234:

/* Line 1455 of yacc.c  */
#line 7813 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1235:

/* Line 1455 of yacc.c  */
#line 7819 "gram.y"
    {
					SelectStmt *n = makeNode(SelectStmt);
					n->valuesLists = list_make1((yyvsp[(2) - (2)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1236:

/* Line 1455 of yacc.c  */
#line 7825 "gram.y"
    {
					SelectStmt *n = (SelectStmt *) (yyvsp[(1) - (3)].node);
					n->valuesLists = lappend(n->valuesLists, (yyvsp[(3) - (3)].list));
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1237:

/* Line 1455 of yacc.c  */
#line 7842 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1238:

/* Line 1455 of yacc.c  */
#line 7843 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1239:

/* Line 1455 of yacc.c  */
#line 7847 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1240:

/* Line 1455 of yacc.c  */
#line 7848 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1241:

/* Line 1455 of yacc.c  */
#line 7859 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1242:

/* Line 1455 of yacc.c  */
#line 7863 "gram.y"
    {
					(yyvsp[(1) - (2)].range)->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1243:

/* Line 1455 of yacc.c  */
#line 7868 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (1)].node);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1244:

/* Line 1455 of yacc.c  */
#line 7875 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					n->coldeflist = NIL;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1245:

/* Line 1455 of yacc.c  */
#line 7883 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1246:

/* Line 1455 of yacc.c  */
#line 7890 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (6)].node);
					a->aliasname = (yyvsp[(3) - (6)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(5) - (6)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1247:

/* Line 1455 of yacc.c  */
#line 7900 "gram.y"
    {
					RangeFunction *n = makeNode(RangeFunction);
					Alias *a = makeNode(Alias);
					n->funccallnode = (yyvsp[(1) - (5)].node);
					a->aliasname = (yyvsp[(2) - (5)].str);
					n->alias = a;
					n->coldeflist = (yyvsp[(4) - (5)].list);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1248:

/* Line 1455 of yacc.c  */
#line 7910 "gram.y"
    {
					/*
					 * The SQL spec does not permit a subselect
					 * (<derived_table>) without an alias clause,
					 * so we don't either.  This avoids the problem
					 * of needing to invent a unique refname for it.
					 * That could be surmounted if there's sufficient
					 * popular demand, but for now let's just implement
					 * the spec and see if anyone complains.
					 * However, it does seem like a good idea to emit
					 * an error message that's better than "syntax error".
					 */
					if (IsA((yyvsp[(1) - (1)].node), SelectStmt) &&
						((SelectStmt *) (yyvsp[(1) - (1)].node))->valuesLists)
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("VALUES in FROM must have an alias"),
								 errhint("For example, FROM (VALUES ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					else
						ereport(ERROR,
								(errcode(ERRCODE_SYNTAX_ERROR),
								 errmsg("subquery in FROM must have an alias"),
								 errhint("For example, FROM (SELECT ...) [AS] foo."),
								 parser_errposition((yylsp[(1) - (1)]))));
					(yyval.node) = NULL;
				;}
    break;

  case 1249:

/* Line 1455 of yacc.c  */
#line 7938 "gram.y"
    {
					RangeSubselect *n = makeNode(RangeSubselect);
					n->subquery = (yyvsp[(1) - (2)].node);
					n->alias = (yyvsp[(2) - (2)].alias);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1250:

/* Line 1455 of yacc.c  */
#line 7945 "gram.y"
    {
					(yyval.node) = (Node *) (yyvsp[(1) - (1)].jexpr);
				;}
    break;

  case 1251:

/* Line 1455 of yacc.c  */
#line 7949 "gram.y"
    {
					(yyvsp[(2) - (4)].jexpr)->alias = (yyvsp[(4) - (4)].alias);
					(yyval.node) = (Node *) (yyvsp[(2) - (4)].jexpr);
				;}
    break;

  case 1252:

/* Line 1455 of yacc.c  */
#line 7975 "gram.y"
    {
					(yyval.jexpr) = (yyvsp[(2) - (3)].jexpr);
				;}
    break;

  case 1253:

/* Line 1455 of yacc.c  */
#line 7979 "gram.y"
    {
					/* CROSS JOIN is same as unqualified inner join */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL;
					n->quals = NULL;
					(yyval.jexpr) = n;
				;}
    break;

  case 1254:

/* Line 1455 of yacc.c  */
#line 7991 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(2) - (5)].jtype);
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(4) - (5)].node);
					if ((yyvsp[(5) - (5)].node) != NULL && IsA((yyvsp[(5) - (5)].node), List))
						n->usingClause = (List *) (yyvsp[(5) - (5)].node); /* USING clause */
					else
						n->quals = (yyvsp[(5) - (5)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1255:

/* Line 1455 of yacc.c  */
#line 8004 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = FALSE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(3) - (4)].node);
					if ((yyvsp[(4) - (4)].node) != NULL && IsA((yyvsp[(4) - (4)].node), List))
						n->usingClause = (List *) (yyvsp[(4) - (4)].node); /* USING clause */
					else
						n->quals = (yyvsp[(4) - (4)].node); /* ON clause */
					(yyval.jexpr) = n;
				;}
    break;

  case 1256:

/* Line 1455 of yacc.c  */
#line 8018 "gram.y"
    {
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = (yyvsp[(3) - (5)].jtype);
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (5)].node);
					n->rarg = (yyvsp[(5) - (5)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1257:

/* Line 1455 of yacc.c  */
#line 8029 "gram.y"
    {
					/* letting join_type reduce to empty doesn't work */
					JoinExpr *n = makeNode(JoinExpr);
					n->jointype = JOIN_INNER;
					n->isNatural = TRUE;
					n->larg = (yyvsp[(1) - (4)].node);
					n->rarg = (yyvsp[(4) - (4)].node);
					n->usingClause = NIL; /* figure out which columns later... */
					n->quals = NULL; /* fill later */
					(yyval.jexpr) = n;
				;}
    break;

  case 1258:

/* Line 1455 of yacc.c  */
#line 8044 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (5)].str);
					(yyval.alias)->colnames = (yyvsp[(4) - (5)].list);
				;}
    break;

  case 1259:

/* Line 1455 of yacc.c  */
#line 8050 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(2) - (2)].str);
				;}
    break;

  case 1260:

/* Line 1455 of yacc.c  */
#line 8055 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (4)].str);
					(yyval.alias)->colnames = (yyvsp[(3) - (4)].list);
				;}
    break;

  case 1261:

/* Line 1455 of yacc.c  */
#line 8061 "gram.y"
    {
					(yyval.alias) = makeNode(Alias);
					(yyval.alias)->aliasname = (yyvsp[(1) - (1)].str);
				;}
    break;

  case 1262:

/* Line 1455 of yacc.c  */
#line 8067 "gram.y"
    { (yyval.jtype) = JOIN_FULL; ;}
    break;

  case 1263:

/* Line 1455 of yacc.c  */
#line 8068 "gram.y"
    { (yyval.jtype) = JOIN_LEFT; ;}
    break;

  case 1264:

/* Line 1455 of yacc.c  */
#line 8069 "gram.y"
    { (yyval.jtype) = JOIN_RIGHT; ;}
    break;

  case 1265:

/* Line 1455 of yacc.c  */
#line 8070 "gram.y"
    { (yyval.jtype) = JOIN_INNER; ;}
    break;

  case 1266:

/* Line 1455 of yacc.c  */
#line 8074 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1267:

/* Line 1455 of yacc.c  */
#line 8075 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1268:

/* Line 1455 of yacc.c  */
#line 8087 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(3) - (4)].list); ;}
    break;

  case 1269:

/* Line 1455 of yacc.c  */
#line 8088 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1270:

/* Line 1455 of yacc.c  */
#line 8094 "gram.y"
    {
					/* default inheritance */
					(yyval.range) = (yyvsp[(1) - (1)].range);
					(yyval.range)->inhOpt = INH_DEFAULT;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1271:

/* Line 1455 of yacc.c  */
#line 8101 "gram.y"
    {
					/* inheritance query */
					(yyval.range) = (yyvsp[(1) - (2)].range);
					(yyval.range)->inhOpt = INH_YES;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1272:

/* Line 1455 of yacc.c  */
#line 8108 "gram.y"
    {
					/* no inheritance */
					(yyval.range) = (yyvsp[(2) - (2)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1273:

/* Line 1455 of yacc.c  */
#line 8115 "gram.y"
    {
					/* no inheritance, SQL99-style syntax */
					(yyval.range) = (yyvsp[(3) - (4)].range);
					(yyval.range)->inhOpt = INH_NO;
					(yyval.range)->alias = NULL;
				;}
    break;

  case 1274:

/* Line 1455 of yacc.c  */
#line 8125 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1275:

/* Line 1455 of yacc.c  */
#line 8126 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1276:

/* Line 1455 of yacc.c  */
#line 8140 "gram.y"
    {
					(yyval.range) = (yyvsp[(1) - (1)].range);
				;}
    break;

  case 1277:

/* Line 1455 of yacc.c  */
#line 8144 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(2) - (2)].str);
					(yyvsp[(1) - (2)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (2)].range);
				;}
    break;

  case 1278:

/* Line 1455 of yacc.c  */
#line 8151 "gram.y"
    {
					Alias *alias = makeNode(Alias);
					alias->aliasname = (yyvsp[(3) - (3)].str);
					(yyvsp[(1) - (3)].range)->alias = alias;
					(yyval.range) = (yyvsp[(1) - (3)].range);
				;}
    break;

  case 1279:

/* Line 1455 of yacc.c  */
#line 8160 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1280:

/* Line 1455 of yacc.c  */
#line 8165 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1281:

/* Line 1455 of yacc.c  */
#line 8166 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1282:

/* Line 1455 of yacc.c  */
#line 8171 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1283:

/* Line 1455 of yacc.c  */
#line 8173 "gram.y"
    {
					CurrentOfExpr *n = makeNode(CurrentOfExpr);
					/* cvarno is filled in by parse analysis */
					n->cursor_name = (yyvsp[(4) - (4)].str);
					n->cursor_param = 0;
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1284:

/* Line 1455 of yacc.c  */
#line 8180 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1285:

/* Line 1455 of yacc.c  */
#line 8186 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1286:

/* Line 1455 of yacc.c  */
#line 8190 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1287:

/* Line 1455 of yacc.c  */
#line 8196 "gram.y"
    {
					ColumnDef *n = makeNode(ColumnDef);
					n->colname = (yyvsp[(1) - (2)].str);
					n->typeName = (yyvsp[(2) - (2)].typnam);
					n->constraints = NIL;
					n->is_local = true;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1288:

/* Line 1455 of yacc.c  */
#line 8217 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1289:

/* Line 1455 of yacc.c  */
#line 8222 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1290:

/* Line 1455 of yacc.c  */
#line 8229 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(4) - (5)].ival)));
				;}
    break;

  case 1291:

/* Line 1455 of yacc.c  */
#line 8234 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (6)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger((yyvsp[(5) - (6)].ival)));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1292:

/* Line 1455 of yacc.c  */
#line 8240 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
				;}
    break;

  case 1293:

/* Line 1455 of yacc.c  */
#line 8245 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (3)].typnam);
					(yyval.typnam)->arrayBounds = list_make1(makeInteger(-1));
					(yyval.typnam)->setof = TRUE;
				;}
    break;

  case 1294:

/* Line 1455 of yacc.c  */
#line 8254 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeInteger(-1)); ;}
    break;

  case 1295:

/* Line 1455 of yacc.c  */
#line 8256 "gram.y"
    {  (yyval.list) = lappend((yyvsp[(1) - (4)].list), makeInteger((yyvsp[(3) - (4)].ival))); ;}
    break;

  case 1296:

/* Line 1455 of yacc.c  */
#line 8258 "gram.y"
    {  (yyval.list) = NIL; ;}
    break;

  case 1297:

/* Line 1455 of yacc.c  */
#line 8262 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1298:

/* Line 1455 of yacc.c  */
#line 8263 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1299:

/* Line 1455 of yacc.c  */
#line 8264 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1300:

/* Line 1455 of yacc.c  */
#line 8265 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1301:

/* Line 1455 of yacc.c  */
#line 8266 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1302:

/* Line 1455 of yacc.c  */
#line 8268 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (2)].typnam);
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
				;}
    break;

  case 1303:

/* Line 1455 of yacc.c  */
#line 8273 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (5)].typnam);
					if ((yyvsp[(5) - (5)].list) != NIL)
					{
						if (list_length((yyvsp[(5) - (5)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (5)]))));
						(yyval.typnam)->typmods = lappend((yyvsp[(5) - (5)].list), makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					}
					else
						(yyval.typnam)->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												 makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
				;}
    break;

  case 1304:

/* Line 1455 of yacc.c  */
#line 8302 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1305:

/* Line 1455 of yacc.c  */
#line 8303 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1306:

/* Line 1455 of yacc.c  */
#line 8304 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1307:

/* Line 1455 of yacc.c  */
#line 8305 "gram.y"
    { (yyval.typnam) = (yyvsp[(1) - (1)].typnam); ;}
    break;

  case 1308:

/* Line 1455 of yacc.c  */
#line 8317 "gram.y"
    {
					(yyval.typnam) = makeTypeName((yyvsp[(1) - (2)].str));
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1309:

/* Line 1455 of yacc.c  */
#line 8323 "gram.y"
    {
					(yyval.typnam) = makeTypeNameFromNameList(lcons(makeString((yyvsp[(1) - (3)].str)), (yyvsp[(2) - (3)].list)));
					(yyval.typnam)->typmods = (yyvsp[(3) - (3)].list);
					(yyval.typnam)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1310:

/* Line 1455 of yacc.c  */
#line 8330 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1311:

/* Line 1455 of yacc.c  */
#line 8331 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1312:

/* Line 1455 of yacc.c  */
#line 8338 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1313:

/* Line 1455 of yacc.c  */
#line 8343 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1314:

/* Line 1455 of yacc.c  */
#line 8348 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int2");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1315:

/* Line 1455 of yacc.c  */
#line 8353 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("int8");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1316:

/* Line 1455 of yacc.c  */
#line 8358 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float4");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1317:

/* Line 1455 of yacc.c  */
#line 8363 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(2) - (2)].typnam);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1318:

/* Line 1455 of yacc.c  */
#line 8368 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1319:

/* Line 1455 of yacc.c  */
#line 8373 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1320:

/* Line 1455 of yacc.c  */
#line 8379 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1321:

/* Line 1455 of yacc.c  */
#line 8385 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("numeric");
					(yyval.typnam)->typmods = (yyvsp[(2) - (2)].list);
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1322:

/* Line 1455 of yacc.c  */
#line 8391 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("bool");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1323:

/* Line 1455 of yacc.c  */
#line 8398 "gram.y"
    {
					/*
					 * Check FLOAT() precision limits assuming IEEE floating
					 * types - thomas 1997-09-18
					 */
					if ((yyvsp[(2) - (3)].ival) < 1)
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be at least 1 bit"),
								 parser_errposition((yylsp[(2) - (3)]))));
					else if ((yyvsp[(2) - (3)].ival) <= 24)
						(yyval.typnam) = SystemTypeName("float4");
					else if ((yyvsp[(2) - (3)].ival) <= 53)
						(yyval.typnam) = SystemTypeName("float8");
					else
						ereport(ERROR,
								(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
								 errmsg("precision for type float must be less than 54 bits"),
								 parser_errposition((yylsp[(2) - (3)]))));
				;}
    break;

  case 1324:

/* Line 1455 of yacc.c  */
#line 8419 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("float8");
				;}
    break;

  case 1325:

/* Line 1455 of yacc.c  */
#line 8429 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1326:

/* Line 1455 of yacc.c  */
#line 8433 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1327:

/* Line 1455 of yacc.c  */
#line 8441 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1328:

/* Line 1455 of yacc.c  */
#line 8445 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1329:

/* Line 1455 of yacc.c  */
#line 8453 "gram.y"
    {
					char *typname;

					typname = (yyvsp[(2) - (5)].boolean) ? "varbit" : "bit";
					(yyval.typnam) = SystemTypeName(typname);
					(yyval.typnam)->typmods = (yyvsp[(4) - (5)].list);
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1330:

/* Line 1455 of yacc.c  */
#line 8465 "gram.y"
    {
					/* bit defaults to bit(1), varbit to no limit */
					if ((yyvsp[(2) - (2)].boolean))
					{
						(yyval.typnam) = SystemTypeName("varbit");
					}
					else
					{
						(yyval.typnam) = SystemTypeName("bit");
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));
					}
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1331:

/* Line 1455 of yacc.c  */
#line 8486 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1332:

/* Line 1455 of yacc.c  */
#line 8490 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1333:

/* Line 1455 of yacc.c  */
#line 8496 "gram.y"
    {
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
				;}
    break;

  case 1334:

/* Line 1455 of yacc.c  */
#line 8500 "gram.y"
    {
					/* Length was not specified so allow to be unrestricted.
					 * This handles problems with fixed-length (bpchar) strings
					 * which in column definitions must default to a length
					 * of one, but should not be constrained if the length
					 * was not specified.
					 */
					(yyval.typnam) = (yyvsp[(1) - (1)].typnam);
					(yyval.typnam)->typmods = NIL;
				;}
    break;

  case 1335:

/* Line 1455 of yacc.c  */
#line 8513 "gram.y"
    {
					if (((yyvsp[(5) - (5)].str) != NULL) && (strcmp((yyvsp[(5) - (5)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (5)].str)) + 1 + strlen((yyvsp[(5) - (5)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (5)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(5) - (5)].str));
						(yyvsp[(1) - (5)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (5)].str));
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1336:

/* Line 1455 of yacc.c  */
#line 8532 "gram.y"
    {
					if (((yyvsp[(2) - (2)].str) != NULL) && (strcmp((yyvsp[(2) - (2)].str), "sql_text") != 0))
					{
						char *type;

						type = palloc(strlen((yyvsp[(1) - (2)].str)) + 1 + strlen((yyvsp[(2) - (2)].str)) + 1);
						strcpy(type, (yyvsp[(1) - (2)].str));
						strcat(type, "_");
						strcat(type, (yyvsp[(2) - (2)].str));
						(yyvsp[(1) - (2)].str) = type;
					}

					(yyval.typnam) = SystemTypeName((yyvsp[(1) - (2)].str));

					/* char defaults to char(1), varchar to no limit */
					if (strcmp((yyvsp[(1) - (2)].str), "bpchar") == 0)
						(yyval.typnam)->typmods = list_make1(makeIntConst(1, -1));

					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1337:

/* Line 1455 of yacc.c  */
#line 8555 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1338:

/* Line 1455 of yacc.c  */
#line 8557 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1339:

/* Line 1455 of yacc.c  */
#line 8559 "gram.y"
    { (yyval.str) = "varchar"; ;}
    break;

  case 1340:

/* Line 1455 of yacc.c  */
#line 8561 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1341:

/* Line 1455 of yacc.c  */
#line 8563 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1342:

/* Line 1455 of yacc.c  */
#line 8565 "gram.y"
    { (yyval.str) = (yyvsp[(2) - (2)].boolean) ? "varchar": "bpchar"; ;}
    break;

  case 1343:

/* Line 1455 of yacc.c  */
#line 8569 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1344:

/* Line 1455 of yacc.c  */
#line 8570 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1345:

/* Line 1455 of yacc.c  */
#line 8574 "gram.y"
    { (yyval.str) = (yyvsp[(3) - (3)].str); ;}
    break;

  case 1346:

/* Line 1455 of yacc.c  */
#line 8575 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1347:

/* Line 1455 of yacc.c  */
#line 8583 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1348:

/* Line 1455 of yacc.c  */
#line 8592 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timestamptz");
					else
						(yyval.typnam) = SystemTypeName("timestamp");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1349:

/* Line 1455 of yacc.c  */
#line 8600 "gram.y"
    {
					if ((yyvsp[(5) - (5)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->typmods = list_make1(makeIntConst((yyvsp[(3) - (5)].ival), (yylsp[(3) - (5)])));
					(yyval.typnam)->location = (yylsp[(1) - (5)]);
				;}
    break;

  case 1350:

/* Line 1455 of yacc.c  */
#line 8609 "gram.y"
    {
					if ((yyvsp[(2) - (2)].boolean))
						(yyval.typnam) = SystemTypeName("timetz");
					else
						(yyval.typnam) = SystemTypeName("time");
					(yyval.typnam)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1351:

/* Line 1455 of yacc.c  */
#line 8620 "gram.y"
    {
					(yyval.typnam) = SystemTypeName("interval");
					(yyval.typnam)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1352:

/* Line 1455 of yacc.c  */
#line 8627 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1353:

/* Line 1455 of yacc.c  */
#line 8628 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1354:

/* Line 1455 of yacc.c  */
#line 8629 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1355:

/* Line 1455 of yacc.c  */
#line 8634 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1356:

/* Line 1455 of yacc.c  */
#line 8636 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MONTH), (yylsp[(1) - (1)]))); ;}
    break;

  case 1357:

/* Line 1455 of yacc.c  */
#line 8638 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY), (yylsp[(1) - (1)]))); ;}
    break;

  case 1358:

/* Line 1455 of yacc.c  */
#line 8640 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR), (yylsp[(1) - (1)]))); ;}
    break;

  case 1359:

/* Line 1455 of yacc.c  */
#line 8642 "gram.y"
    { (yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(MINUTE), (yylsp[(1) - (1)]))); ;}
    break;

  case 1360:

/* Line 1455 of yacc.c  */
#line 8644 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1361:

/* Line 1455 of yacc.c  */
#line 8646 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(YEAR) |
												 INTERVAL_MASK(MONTH), (yylsp[(1) - (3)])));
				;}
    break;

  case 1362:

/* Line 1455 of yacc.c  */
#line 8651 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR), (yylsp[(1) - (3)])));
				;}
    break;

  case 1363:

/* Line 1455 of yacc.c  */
#line 8656 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(DAY) |
												 INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1364:

/* Line 1455 of yacc.c  */
#line 8662 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(DAY) |
												INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1365:

/* Line 1455 of yacc.c  */
#line 8670 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(HOUR) |
												 INTERVAL_MASK(MINUTE), (yylsp[(1) - (3)])));
				;}
    break;

  case 1366:

/* Line 1455 of yacc.c  */
#line 8675 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(HOUR) |
												INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1367:

/* Line 1455 of yacc.c  */
#line 8682 "gram.y"
    {
					(yyval.list) = (yyvsp[(3) - (3)].list);
					linitial((yyval.list)) = makeIntConst(INTERVAL_MASK(MINUTE) |
												INTERVAL_MASK(SECOND), (yylsp[(1) - (3)]));
				;}
    break;

  case 1368:

/* Line 1455 of yacc.c  */
#line 8688 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1369:

/* Line 1455 of yacc.c  */
#line 8693 "gram.y"
    {
					(yyval.list) = list_make1(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (1)])));
				;}
    break;

  case 1370:

/* Line 1455 of yacc.c  */
#line 8697 "gram.y"
    {
					(yyval.list) = list_make2(makeIntConst(INTERVAL_MASK(SECOND), (yylsp[(1) - (4)])),
									makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
				;}
    break;

  case 1371:

/* Line 1455 of yacc.c  */
#line 8726 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1372:

/* Line 1455 of yacc.c  */
#line 8728 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1373:

/* Line 1455 of yacc.c  */
#line 8730 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("timezone");
					n->args = list_make2((yyvsp[(5) - (5)].node), (yyvsp[(1) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1374:

/* Line 1455 of yacc.c  */
#line 8752 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1375:

/* Line 1455 of yacc.c  */
#line 8754 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1376:

/* Line 1455 of yacc.c  */
#line 8756 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1377:

/* Line 1455 of yacc.c  */
#line 8758 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1378:

/* Line 1455 of yacc.c  */
#line 8760 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1379:

/* Line 1455 of yacc.c  */
#line 8762 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1380:

/* Line 1455 of yacc.c  */
#line 8764 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1381:

/* Line 1455 of yacc.c  */
#line 8766 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1382:

/* Line 1455 of yacc.c  */
#line 8768 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1383:

/* Line 1455 of yacc.c  */
#line 8770 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1384:

/* Line 1455 of yacc.c  */
#line 8772 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1385:

/* Line 1455 of yacc.c  */
#line 8775 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1386:

/* Line 1455 of yacc.c  */
#line 8777 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1387:

/* Line 1455 of yacc.c  */
#line 8779 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1388:

/* Line 1455 of yacc.c  */
#line 8782 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1389:

/* Line 1455 of yacc.c  */
#line 8784 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL, (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1390:

/* Line 1455 of yacc.c  */
#line 8786 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1391:

/* Line 1455 of yacc.c  */
#line 8789 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1392:

/* Line 1455 of yacc.c  */
#line 8791 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1393:

/* Line 1455 of yacc.c  */
#line 8804 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1394:

/* Line 1455 of yacc.c  */
#line 8806 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1395:

/* Line 1455 of yacc.c  */
#line 8819 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1396:

/* Line 1455 of yacc.c  */
#line 8821 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(3) - (5)].node), (yyvsp[(5) - (5)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~~*", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1397:

/* Line 1455 of yacc.c  */
#line 8834 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)])); ;}
    break;

  case 1398:

/* Line 1455 of yacc.c  */
#line 8836 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("like_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~~*", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1399:

/* Line 1455 of yacc.c  */
#line 8850 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (4)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (4)].node), (Node *) n, (yylsp[(2) - (4)]));
				;}
    break;

  case 1400:

/* Line 1455 of yacc.c  */
#line 8863 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(4) - (6)].node), (yyvsp[(6) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (6)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "~", (yyvsp[(1) - (6)].node), (Node *) n, (yylsp[(2) - (6)]));
				;}
    break;

  case 1401:

/* Line 1455 of yacc.c  */
#line 8876 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (5)].node), makeNullAConst(-1));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (5)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (5)].node), (Node *) n, (yylsp[(2) - (5)]));
				;}
    break;

  case 1402:

/* Line 1455 of yacc.c  */
#line 8889 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("similar_escape");
					n->args = list_make2((yyvsp[(5) - (7)].node), (yyvsp[(7) - (7)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(2) - (7)]);
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "!~", (yyvsp[(1) - (7)].node), (Node *) n, (yylsp[(2) - (7)]));
				;}
    break;

  case 1403:

/* Line 1455 of yacc.c  */
#line 8912 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (3)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1404:

/* Line 1455 of yacc.c  */
#line 8919 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1405:

/* Line 1455 of yacc.c  */
#line 8926 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (4)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1406:

/* Line 1455 of yacc.c  */
#line 8933 "gram.y"
    {
					NullTest *n = makeNode(NullTest);
					n->arg = (Expr *) (yyvsp[(1) - (2)].node);
					n->nulltesttype = IS_NOT_NULL;
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1407:

/* Line 1455 of yacc.c  */
#line 8940 "gram.y"
    {
					(yyval.node) = (Node *)makeOverlaps((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].list), (yylsp[(2) - (3)]), yyscanner);
				;}
    break;

  case 1408:

/* Line 1455 of yacc.c  */
#line 8944 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1409:

/* Line 1455 of yacc.c  */
#line 8951 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_TRUE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1410:

/* Line 1455 of yacc.c  */
#line 8958 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1411:

/* Line 1455 of yacc.c  */
#line 8965 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_FALSE;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1412:

/* Line 1455 of yacc.c  */
#line 8972 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (3)].node);
					b->booltesttype = IS_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1413:

/* Line 1455 of yacc.c  */
#line 8979 "gram.y"
    {
					BooleanTest *b = makeNode(BooleanTest);
					b->arg = (Expr *) (yyvsp[(1) - (4)].node);
					b->booltesttype = IS_NOT_UNKNOWN;
					(yyval.node) = (Node *)b;
				;}
    break;

  case 1414:

/* Line 1455 of yacc.c  */
#line 8986 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1415:

/* Line 1455 of yacc.c  */
#line 8990 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
									(Node *) makeSimpleA_Expr(AEXPR_DISTINCT,
															  "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));

				;}
    break;

  case 1416:

/* Line 1455 of yacc.c  */
#line 8998 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1417:

/* Line 1455 of yacc.c  */
#line 9002 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1418:

/* Line 1455 of yacc.c  */
#line 9012 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1419:

/* Line 1455 of yacc.c  */
#line 9019 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						(Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1420:

/* Line 1455 of yacc.c  */
#line 9026 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_OR, NIL,
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
						(Node *) makeA_Expr(AEXPR_AND, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<=", (yyvsp[(1) - (6)].node), (yyvsp[(4) - (6)].node), (yylsp[(2) - (6)])),
											(yylsp[(2) - (6)])),
											 (yylsp[(2) - (6)]));
				;}
    break;

  case 1421:

/* Line 1455 of yacc.c  */
#line 9039 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_AND, NIL,
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
						(Node *) makeA_Expr(AEXPR_OR, NIL,
						    (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (7)].node), (yyvsp[(7) - (7)].node), (yylsp[(2) - (7)])),
						    (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (7)].node), (yyvsp[(5) - (7)].node), (yylsp[(2) - (7)])),
											(yylsp[(2) - (7)])),
											 (yylsp[(2) - (7)]));
				;}
    break;

  case 1422:

/* Line 1455 of yacc.c  */
#line 9052 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(3) - (3)].node), SubLink))
					{
						/* generate foo = ANY (subquery) */
						SubLink *n = (SubLink *) (yyvsp[(3) - (3)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (3)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(2) - (3)]);
						(yyval.node) = (Node *)n;
					}
					else
					{
						/* generate scalar IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)]));
					}
				;}
    break;

  case 1423:

/* Line 1455 of yacc.c  */
#line 9071 "gram.y"
    {
					/* in_expr returns a SubLink or a list of a_exprs */
					if (IsA((yyvsp[(4) - (4)].node), SubLink))
					{
						/* generate NOT (foo = ANY (subquery)) */
						/* Make an = ANY node */
						SubLink *n = (SubLink *) (yyvsp[(4) - (4)].node);
						n->subLinkType = ANY_SUBLINK;
						n->testexpr = (yyvsp[(1) - (4)].node);
						n->operName = list_make1(makeString("="));
						n->location = (yylsp[(3) - (4)]);
						/* Stick a NOT on top */
						(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL, (Node *) n, (yylsp[(2) - (4)]));
					}
					else
					{
						/* generate scalar NOT IN expression */
						(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_IN, "<>", (yyvsp[(1) - (4)].node), (yyvsp[(4) - (4)].node), (yylsp[(2) - (4)]));
					}
				;}
    break;

  case 1424:

/* Line 1455 of yacc.c  */
#line 9092 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = (yyvsp[(3) - (4)].ival);
					n->testexpr = (yyvsp[(1) - (4)].node);
					n->operName = (yyvsp[(2) - (4)].list);
					n->subselect = (yyvsp[(4) - (4)].node);
					n->location = (yylsp[(2) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1425:

/* Line 1455 of yacc.c  */
#line 9102 "gram.y"
    {
					if ((yyvsp[(3) - (6)].ival) == ANY_SUBLINK)
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ANY, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
					else
						(yyval.node) = (Node *) makeA_Expr(AEXPR_OP_ALL, (yyvsp[(2) - (6)].list), (yyvsp[(1) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(2) - (6)]));
				;}
    break;

  case 1426:

/* Line 1455 of yacc.c  */
#line 9109 "gram.y"
    {
					/* Not sure how to get rid of the parentheses
					 * but there are lots of shift/reduce errors without them.
					 *
					 * Should be able to implement this by plopping the entire
					 * select into a node, then transforming the target expressions
					 * from whatever they are into count(*), and testing the
					 * entire result equal to one.
					 * But, will probably implement a separate node in the executor.
					 */
					ereport(ERROR,
							(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
							 errmsg("UNIQUE predicate is not yet implemented"),
							 parser_errposition((yylsp[(1) - (2)]))));
				;}
    break;

  case 1427:

/* Line 1455 of yacc.c  */
#line 9125 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1428:

/* Line 1455 of yacc.c  */
#line 9130 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1429:

/* Line 1455 of yacc.c  */
#line 9148 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1430:

/* Line 1455 of yacc.c  */
#line 9150 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].typnam), (yylsp[(2) - (3)])); ;}
    break;

  case 1431:

/* Line 1455 of yacc.c  */
#line 9152 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1432:

/* Line 1455 of yacc.c  */
#line 9154 "gram.y"
    { (yyval.node) = doNegate((yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1433:

/* Line 1455 of yacc.c  */
#line 9156 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "+", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1434:

/* Line 1455 of yacc.c  */
#line 9158 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "-", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1435:

/* Line 1455 of yacc.c  */
#line 9160 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "*", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1436:

/* Line 1455 of yacc.c  */
#line 9162 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "/", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1437:

/* Line 1455 of yacc.c  */
#line 9164 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "%", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1438:

/* Line 1455 of yacc.c  */
#line 9166 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "^", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1439:

/* Line 1455 of yacc.c  */
#line 9168 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "<", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1440:

/* Line 1455 of yacc.c  */
#line 9170 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, ">", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1441:

/* Line 1455 of yacc.c  */
#line 9172 "gram.y"
    { (yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OP, "=", (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1442:

/* Line 1455 of yacc.c  */
#line 9174 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (3)].list), (yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yylsp[(2) - (3)])); ;}
    break;

  case 1443:

/* Line 1455 of yacc.c  */
#line 9176 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(1) - (2)].list), NULL, (yyvsp[(2) - (2)].node), (yylsp[(1) - (2)])); ;}
    break;

  case 1444:

/* Line 1455 of yacc.c  */
#line 9178 "gram.y"
    { (yyval.node) = (Node *) makeA_Expr(AEXPR_OP, (yyvsp[(2) - (2)].list), (yyvsp[(1) - (2)].node), NULL, (yylsp[(2) - (2)])); ;}
    break;

  case 1445:

/* Line 1455 of yacc.c  */
#line 9180 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (5)].node), (yyvsp[(5) - (5)].node), (yylsp[(2) - (5)]));
				;}
    break;

  case 1446:

/* Line 1455 of yacc.c  */
#line 9184 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL,
						NULL, (Node *) makeSimpleA_Expr(AEXPR_DISTINCT, "=", (yyvsp[(1) - (6)].node), (yyvsp[(6) - (6)].node), (yylsp[(2) - (6)])), (yylsp[(2) - (6)]));
				;}
    break;

  case 1447:

/* Line 1455 of yacc.c  */
#line 9189 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "=", (yyvsp[(1) - (6)].node), (Node *) (yyvsp[(5) - (6)].list), (yylsp[(2) - (6)]));
				;}
    break;

  case 1448:

/* Line 1455 of yacc.c  */
#line 9193 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_OF, "<>", (yyvsp[(1) - (7)].node), (Node *) (yyvsp[(6) - (7)].list), (yylsp[(2) - (7)]));
				;}
    break;

  case 1449:

/* Line 1455 of yacc.c  */
#line 9197 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_DOCUMENT, NULL, NIL,
									 list_make1((yyvsp[(1) - (3)].node)), (yylsp[(2) - (3)]));
				;}
    break;

  case 1450:

/* Line 1455 of yacc.c  */
#line 9202 "gram.y"
    {
					(yyval.node) = (Node *) makeA_Expr(AEXPR_NOT, NIL, NULL,
											 makeXmlExpr(IS_DOCUMENT, NULL, NIL,
														 list_make1((yyvsp[(1) - (4)].node)), (yylsp[(2) - (4)])),
											 (yylsp[(2) - (4)]));
				;}
    break;

  case 1451:

/* Line 1455 of yacc.c  */
#line 9218 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1452:

/* Line 1455 of yacc.c  */
#line 9219 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1453:

/* Line 1455 of yacc.c  */
#line 9221 "gram.y"
    {
					ParamRef *p = makeNode(ParamRef);
					p->number = (yyvsp[(1) - (2)].ival);
					p->location = (yylsp[(1) - (2)]);
					if ((yyvsp[(2) - (2)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (Node *) p;
						n->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
						(yyval.node) = (Node *) n;
					}
					else
						(yyval.node) = (Node *) p;
				;}
    break;

  case 1454:

/* Line 1455 of yacc.c  */
#line 9236 "gram.y"
    {
					if ((yyvsp[(4) - (4)].list))
					{
						A_Indirection *n = makeNode(A_Indirection);
						n->arg = (yyvsp[(2) - (4)].node);
						n->indirection = check_indirection((yyvsp[(4) - (4)].list), yyscanner);
						(yyval.node) = (Node *)n;
					}
					else
						(yyval.node) = (yyvsp[(2) - (4)].node);
				;}
    break;

  case 1455:

/* Line 1455 of yacc.c  */
#line 9248 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1456:

/* Line 1455 of yacc.c  */
#line 9250 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1457:

/* Line 1455 of yacc.c  */
#line 9252 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (1)].node);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1458:

/* Line 1455 of yacc.c  */
#line 9262 "gram.y"
    {
					/*
					 * Because the select_with_parens nonterminal is designed
					 * to "eat" as many levels of parens as possible, the
					 * '(' a_expr ')' opt_indirection production above will
					 * fail to match a sub-SELECT with indirection decoration;
					 * the sub-SELECT won't be regarded as an a_expr as long
					 * as there are parens around it.  To support applying
					 * subscripting or field selection to a sub-SELECT result,
					 * we need this redundant-looking production.
					 */
					SubLink *n = makeNode(SubLink);
					A_Indirection *a = makeNode(A_Indirection);
					n->subLinkType = EXPR_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(1) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					a->arg = (Node *)n;
					a->indirection = check_indirection((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.node) = (Node *)a;
				;}
    break;

  case 1459:

/* Line 1455 of yacc.c  */
#line 9285 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = EXISTS_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1460:

/* Line 1455 of yacc.c  */
#line 9295 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subLinkType = ARRAY_SUBLINK;
					n->testexpr = NULL;
					n->operName = NIL;
					n->subselect = (yyvsp[(2) - (2)].node);
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1461:

/* Line 1455 of yacc.c  */
#line 9305 "gram.y"
    {
					A_ArrayExpr *n = (A_ArrayExpr *) (yyvsp[(2) - (2)].node);
					Assert(IsA(n, A_ArrayExpr));
					/* point outermost A_ArrayExpr to the ARRAY keyword */
					n->location = (yylsp[(1) - (2)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1462:

/* Line 1455 of yacc.c  */
#line 9313 "gram.y"
    {
					RowExpr *r = makeNode(RowExpr);
					r->args = (yyvsp[(1) - (1)].list);
					r->row_typeid = InvalidOid;	/* not analyzed yet */
					r->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)r;
				;}
    break;

  case 1463:

/* Line 1455 of yacc.c  */
#line 9331 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (4)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(4) - (4)].windef);
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1464:

/* Line 1455 of yacc.c  */
#line 9344 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = (yyvsp[(3) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1465:

/* Line 1455 of yacc.c  */
#line 9357 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = list_make1((yyvsp[(4) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1466:

/* Line 1455 of yacc.c  */
#line 9370 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (8)].list);
					n->args = lappend((yyvsp[(3) - (8)].list), (yyvsp[(6) - (8)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = TRUE;
					n->over = (yyvsp[(8) - (8)].windef);
					n->location = (yylsp[(1) - (8)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1467:

/* Line 1455 of yacc.c  */
#line 9383 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (6)].list);
					n->args = (yyvsp[(3) - (6)].list);
					n->agg_order = (yyvsp[(4) - (6)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(6) - (6)].windef);
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1468:

/* Line 1455 of yacc.c  */
#line 9396 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					/* Ideally we'd mark the FuncCall node to indicate
					 * "must be an aggregate", but there's no provision
					 * for that in FuncCall at the moment.
					 */
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1469:

/* Line 1455 of yacc.c  */
#line 9413 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (7)].list);
					n->args = (yyvsp[(4) - (7)].list);
					n->agg_order = (yyvsp[(5) - (7)].list);
					n->agg_star = FALSE;
					n->agg_distinct = TRUE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(7) - (7)].windef);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1470:

/* Line 1455 of yacc.c  */
#line 9426 "gram.y"
    {
					/*
					 * We consider AGGREGATE(*) to invoke a parameterless
					 * aggregate.  This does the right thing for COUNT(*),
					 * and there are no other aggregates in SQL92 that accept
					 * '*' as parameter.
					 *
					 * The FuncCall node is also marked agg_star = true,
					 * so that later processing can detect what the argument
					 * really was.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = (yyvsp[(1) - (5)].list);
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = TRUE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = (yyvsp[(5) - (5)].windef);
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1471:

/* Line 1455 of yacc.c  */
#line 9449 "gram.y"
    {
					/*
					 * Translate as "'now'::text::date".
					 *
					 * We cannot use "'now'::date" because coerce_type() will
					 * immediately reduce that to a constant representing
					 * today's date.  We need to delay the conversion until
					 * runtime, else the wrong things will happen when
					 * CURRENT_DATE is used in a column default value or rule.
					 *
					 * This could be simplified if we had a way to generate
					 * an expression tree representing runtime application
					 * of type-input conversion functions.  (As of PG 7.3
					 * that is actually possible, but not clear that we want
					 * to rely on it.)
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("date"), -1);
				;}
    break;

  case 1472:

/* Line 1455 of yacc.c  */
#line 9470 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timetz"), -1);
				;}
    break;

  case 1473:

/* Line 1455 of yacc.c  */
#line 9480 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timetz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timetz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1474:

/* Line 1455 of yacc.c  */
#line 9493 "gram.y"
    {
					/*
					 * Translate as "now()", since we have a function that
					 * does exactly what is needed.
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("now");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1475:

/* Line 1455 of yacc.c  */
#line 9510 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamptz(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamptz");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1476:

/* Line 1455 of yacc.c  */
#line 9523 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast((Node *)n, SystemTypeName("time"), -1);
				;}
    break;

  case 1477:

/* Line 1455 of yacc.c  */
#line 9533 "gram.y"
    {
					/*
					 * Translate as "'now'::text::time(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("time");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast((Node *)n, d, -1);
				;}
    break;

  case 1478:

/* Line 1455 of yacc.c  */
#line 9546 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					n = makeStringConstCast("now", (yylsp[(1) - (1)]), SystemTypeName("text"));
					(yyval.node) = makeTypeCast(n, SystemTypeName("timestamp"), -1);
				;}
    break;

  case 1479:

/* Line 1455 of yacc.c  */
#line 9556 "gram.y"
    {
					/*
					 * Translate as "'now'::text::timestamp(n)".
					 * See comments for CURRENT_DATE.
					 */
					Node *n;
					TypeName *d;
					n = makeStringConstCast("now", (yylsp[(1) - (4)]), SystemTypeName("text"));
					d = SystemTypeName("timestamp");
					d->typmods = list_make1(makeIntConst((yyvsp[(3) - (4)].ival), (yylsp[(3) - (4)])));
					(yyval.node) = makeTypeCast(n, d, -1);
				;}
    break;

  case 1480:

/* Line 1455 of yacc.c  */
#line 9569 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1481:

/* Line 1455 of yacc.c  */
#line 9582 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1482:

/* Line 1455 of yacc.c  */
#line 9595 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("session_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1483:

/* Line 1455 of yacc.c  */
#line 9608 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_user");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1484:

/* Line 1455 of yacc.c  */
#line 9621 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_database");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1485:

/* Line 1455 of yacc.c  */
#line 9634 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("current_schema");
					n->args = NIL;
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1486:

/* Line 1455 of yacc.c  */
#line 9647 "gram.y"
    { (yyval.node) = makeTypeCast((yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].typnam), (yylsp[(1) - (6)])); ;}
    break;

  case 1487:

/* Line 1455 of yacc.c  */
#line 9649 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("date_part");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1488:

/* Line 1455 of yacc.c  */
#line 9662 "gram.y"
    {
					/* overlay(A PLACING B FROM C FOR D) is converted to
					 * overlay(A, B, C, D)
					 * overlay(A PLACING B FROM C) is converted to
					 * overlay(A, B, C)
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("overlay");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1489:

/* Line 1455 of yacc.c  */
#line 9680 "gram.y"
    {
					/* position(A in B) is converted to position(B, A) */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("position");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1490:

/* Line 1455 of yacc.c  */
#line 9694 "gram.y"
    {
					/* substring(A from B for C) is converted to
					 * substring(A, B, C) - thomas 2000-11-28
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("substring");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1491:

/* Line 1455 of yacc.c  */
#line 9710 "gram.y"
    {
					/* TREAT(expr AS target) converts expr of a particular type to target,
					 * which is defined to be a subtype of the original expression.
					 * In SQL99, this is intended for use with structured UDTs,
					 * but let's make this a generally useful form allowing stronger
					 * coercions than are handled by implicit casting.
					 */
					FuncCall *n = makeNode(FuncCall);
					/* Convert SystemTypeName() to SystemFuncName() even though
					 * at the moment they result in the same thing.
					 */
					n->funcname = SystemFuncName(((Value *)llast((yyvsp[(5) - (6)].typnam)->names))->val.str);
					n->args = list_make1((yyvsp[(3) - (6)].node));
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (6)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1492:

/* Line 1455 of yacc.c  */
#line 9732 "gram.y"
    {
					/* various trim expressions are defined in SQL92
					 * - thomas 1997-07-19
					 */
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1493:

/* Line 1455 of yacc.c  */
#line 9748 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("ltrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1494:

/* Line 1455 of yacc.c  */
#line 9761 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("rtrim");
					n->args = (yyvsp[(4) - (5)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1495:

/* Line 1455 of yacc.c  */
#line 9774 "gram.y"
    {
					FuncCall *n = makeNode(FuncCall);
					n->funcname = SystemFuncName("btrim");
					n->args = (yyvsp[(3) - (4)].list);
					n->agg_order = NIL;
					n->agg_star = FALSE;
					n->agg_distinct = FALSE;
					n->func_variadic = FALSE;
					n->over = NULL;
					n->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1496:

/* Line 1455 of yacc.c  */
#line 9787 "gram.y"
    {
					(yyval.node) = (Node *) makeSimpleA_Expr(AEXPR_NULLIF, "=", (yyvsp[(3) - (6)].node), (yyvsp[(5) - (6)].node), (yylsp[(1) - (6)]));
				;}
    break;

  case 1497:

/* Line 1455 of yacc.c  */
#line 9791 "gram.y"
    {
					CoalesceExpr *c = makeNode(CoalesceExpr);
					c->args = (yyvsp[(3) - (4)].list);
					c->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1498:

/* Line 1455 of yacc.c  */
#line 9798 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_GREATEST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1499:

/* Line 1455 of yacc.c  */
#line 9806 "gram.y"
    {
					MinMaxExpr *v = makeNode(MinMaxExpr);
					v->args = (yyvsp[(3) - (4)].list);
					v->op = IS_LEAST;
					v->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)v;
				;}
    break;

  case 1500:

/* Line 1455 of yacc.c  */
#line 9814 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLCONCAT, NULL, NIL, (yyvsp[(3) - (4)].list), (yylsp[(1) - (4)]));
				;}
    break;

  case 1501:

/* Line 1455 of yacc.c  */
#line 9818 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (5)].str), NIL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1502:

/* Line 1455 of yacc.c  */
#line 9822 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), (yyvsp[(6) - (7)].list), NIL, (yylsp[(1) - (7)]));
				;}
    break;

  case 1503:

/* Line 1455 of yacc.c  */
#line 9826 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (7)].str), NIL, (yyvsp[(6) - (7)].list), (yylsp[(1) - (7)]));
				;}
    break;

  case 1504:

/* Line 1455 of yacc.c  */
#line 9830 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLELEMENT, (yyvsp[(4) - (9)].str), (yyvsp[(6) - (9)].list), (yyvsp[(8) - (9)].list), (yylsp[(1) - (9)]));
				;}
    break;

  case 1505:

/* Line 1455 of yacc.c  */
#line 9834 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLFOREST, NULL, (yyvsp[(3) - (4)].list), NIL, (yylsp[(1) - (4)]));
				;}
    break;

  case 1506:

/* Line 1455 of yacc.c  */
#line 9838 "gram.y"
    {
					XmlExpr *x = (XmlExpr *)
						makeXmlExpr(IS_XMLPARSE, NULL, NIL,
									list_make2((yyvsp[(4) - (6)].node), makeBoolAConst((yyvsp[(5) - (6)].boolean), -1)),
									(yylsp[(1) - (6)]));
					x->xmloption = (yyvsp[(3) - (6)].ival);
					(yyval.node) = (Node *)x;
				;}
    break;

  case 1507:

/* Line 1455 of yacc.c  */
#line 9847 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (5)].str), NULL, NIL, (yylsp[(1) - (5)]));
				;}
    break;

  case 1508:

/* Line 1455 of yacc.c  */
#line 9851 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLPI, (yyvsp[(4) - (7)].str), NULL, list_make1((yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1509:

/* Line 1455 of yacc.c  */
#line 9855 "gram.y"
    {
					(yyval.node) = makeXmlExpr(IS_XMLROOT, NULL, NIL,
									 list_make3((yyvsp[(3) - (7)].node), (yyvsp[(5) - (7)].node), (yyvsp[(6) - (7)].node)), (yylsp[(1) - (7)]));
				;}
    break;

  case 1510:

/* Line 1455 of yacc.c  */
#line 9860 "gram.y"
    {
					XmlSerialize *n = makeNode(XmlSerialize);
					n->xmloption = (yyvsp[(3) - (7)].ival);
					n->expr = (yyvsp[(4) - (7)].node);
					n->typeName = (yyvsp[(6) - (7)].typnam);
					n->location = (yylsp[(1) - (7)]);
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1511:

/* Line 1455 of yacc.c  */
#line 9874 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1512:

/* Line 1455 of yacc.c  */
#line 9876 "gram.y"
    { (yyval.node) = makeNullAConst(-1); ;}
    break;

  case 1513:

/* Line 1455 of yacc.c  */
#line 9880 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_YES, -1); ;}
    break;

  case 1514:

/* Line 1455 of yacc.c  */
#line 9882 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO, -1); ;}
    break;

  case 1515:

/* Line 1455 of yacc.c  */
#line 9884 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_NO_VALUE, -1); ;}
    break;

  case 1516:

/* Line 1455 of yacc.c  */
#line 9886 "gram.y"
    { (yyval.node) = makeIntConst(XML_STANDALONE_OMITTED, -1); ;}
    break;

  case 1517:

/* Line 1455 of yacc.c  */
#line 9889 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1518:

/* Line 1455 of yacc.c  */
#line 9892 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1519:

/* Line 1455 of yacc.c  */
#line 9893 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1520:

/* Line 1455 of yacc.c  */
#line 9897 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1521:

/* Line 1455 of yacc.c  */
#line 9905 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *) (yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1522:

/* Line 1455 of yacc.c  */
#line 9914 "gram.y"
    { (yyval.ival) = XMLOPTION_DOCUMENT; ;}
    break;

  case 1523:

/* Line 1455 of yacc.c  */
#line 9915 "gram.y"
    { (yyval.ival) = XMLOPTION_CONTENT; ;}
    break;

  case 1524:

/* Line 1455 of yacc.c  */
#line 9918 "gram.y"
    { (yyval.boolean) = TRUE; ;}
    break;

  case 1525:

/* Line 1455 of yacc.c  */
#line 9919 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1526:

/* Line 1455 of yacc.c  */
#line 9920 "gram.y"
    { (yyval.boolean) = FALSE; ;}
    break;

  case 1527:

/* Line 1455 of yacc.c  */
#line 9927 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1528:

/* Line 1455 of yacc.c  */
#line 9928 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1529:

/* Line 1455 of yacc.c  */
#line 9932 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].windef)); ;}
    break;

  case 1530:

/* Line 1455 of yacc.c  */
#line 9934 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].windef)); ;}
    break;

  case 1531:

/* Line 1455 of yacc.c  */
#line 9939 "gram.y"
    {
					WindowDef *n = (yyvsp[(3) - (3)].windef);
					n->name = (yyvsp[(1) - (3)].str);
					(yyval.windef) = n;
				;}
    break;

  case 1532:

/* Line 1455 of yacc.c  */
#line 9947 "gram.y"
    { (yyval.windef) = (yyvsp[(2) - (2)].windef); ;}
    break;

  case 1533:

/* Line 1455 of yacc.c  */
#line 9949 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = (yyvsp[(2) - (2)].str);
					n->refname = NULL;
					n->partitionClause = NIL;
					n->orderClause = NIL;
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					n->location = (yylsp[(2) - (2)]);
					(yyval.windef) = n;
				;}
    break;

  case 1534:

/* Line 1455 of yacc.c  */
#line 9962 "gram.y"
    { (yyval.windef) = NULL; ;}
    break;

  case 1535:

/* Line 1455 of yacc.c  */
#line 9967 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->name = NULL;
					n->refname = (yyvsp[(2) - (6)].str);
					n->partitionClause = (yyvsp[(3) - (6)].list);
					n->orderClause = (yyvsp[(4) - (6)].list);
					/* copy relevant fields of opt_frame_clause */
					n->frameOptions = (yyvsp[(5) - (6)].windef)->frameOptions;
					n->startOffset = (yyvsp[(5) - (6)].windef)->startOffset;
					n->endOffset = (yyvsp[(5) - (6)].windef)->endOffset;
					n->location = (yylsp[(1) - (6)]);
					(yyval.windef) = n;
				;}
    break;

  case 1536:

/* Line 1455 of yacc.c  */
#line 9992 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1537:

/* Line 1455 of yacc.c  */
#line 9993 "gram.y"
    { (yyval.str) = NULL; ;}
    break;

  case 1538:

/* Line 1455 of yacc.c  */
#line 9996 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (3)].list); ;}
    break;

  case 1539:

/* Line 1455 of yacc.c  */
#line 9997 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1540:

/* Line 1455 of yacc.c  */
#line 10009 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_RANGE;
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_PRECEDING |
										   FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE PRECEDING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					if (n->frameOptions & (FRAMEOPTION_START_VALUE_FOLLOWING |
										   FRAMEOPTION_END_VALUE_FOLLOWING))
						ereport(ERROR,
								(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
								 errmsg("RANGE FOLLOWING is only supported with UNBOUNDED"),
								 parser_errposition((yylsp[(1) - (2)]))));
					(yyval.windef) = n;
				;}
    break;

  case 1541:

/* Line 1455 of yacc.c  */
#line 10027 "gram.y"
    {
					WindowDef *n = (yyvsp[(2) - (2)].windef);
					n->frameOptions |= FRAMEOPTION_NONDEFAULT | FRAMEOPTION_ROWS;
					(yyval.windef) = n;
				;}
    break;

  case 1542:

/* Line 1455 of yacc.c  */
#line 10033 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_DEFAULTS;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1543:

/* Line 1455 of yacc.c  */
#line 10043 "gram.y"
    {
					WindowDef *n = (yyvsp[(1) - (1)].windef);
					/* reject invalid cases */
					if (n->frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(1) - (1)]))));
					if (n->frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot end with current row"),
								 parser_errposition((yylsp[(1) - (1)]))));
					n->frameOptions |= FRAMEOPTION_END_CURRENT_ROW;
					(yyval.windef) = n;
				;}
    break;

  case 1544:

/* Line 1455 of yacc.c  */
#line 10060 "gram.y"
    {
					WindowDef *n1 = (yyvsp[(2) - (4)].windef);
					WindowDef *n2 = (yyvsp[(4) - (4)].windef);
					/* form merged options */
					int		frameOptions = n1->frameOptions;
					/* shift converts START_ options to END_ options */
					frameOptions |= n2->frameOptions << 1;
					frameOptions |= FRAMEOPTION_BETWEEN;
					/* reject invalid cases */
					if (frameOptions & FRAMEOPTION_START_UNBOUNDED_FOLLOWING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame start cannot be UNBOUNDED FOLLOWING"),
								 parser_errposition((yylsp[(2) - (4)]))));
					if (frameOptions & FRAMEOPTION_END_UNBOUNDED_PRECEDING)
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame end cannot be UNBOUNDED PRECEDING"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_CURRENT_ROW) &&
						(frameOptions & FRAMEOPTION_END_VALUE_PRECEDING))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from current row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					if ((frameOptions & FRAMEOPTION_START_VALUE_FOLLOWING) &&
						(frameOptions & (FRAMEOPTION_END_VALUE_PRECEDING |
										 FRAMEOPTION_END_CURRENT_ROW)))
						ereport(ERROR,
								(errcode(ERRCODE_WINDOWING_ERROR),
								 errmsg("frame starting from following row cannot have preceding rows"),
								 parser_errposition((yylsp[(4) - (4)]))));
					n1->frameOptions = frameOptions;
					n1->endOffset = n2->startOffset;
					(yyval.windef) = n1;
				;}
    break;

  case 1545:

/* Line 1455 of yacc.c  */
#line 10105 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_PRECEDING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1546:

/* Line 1455 of yacc.c  */
#line 10113 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_UNBOUNDED_FOLLOWING;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1547:

/* Line 1455 of yacc.c  */
#line 10121 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_CURRENT_ROW;
					n->startOffset = NULL;
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1548:

/* Line 1455 of yacc.c  */
#line 10129 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_PRECEDING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1549:

/* Line 1455 of yacc.c  */
#line 10137 "gram.y"
    {
					WindowDef *n = makeNode(WindowDef);
					n->frameOptions = FRAMEOPTION_START_VALUE_FOLLOWING;
					n->startOffset = (yyvsp[(1) - (2)].node);
					n->endOffset = NULL;
					(yyval.windef) = n;
				;}
    break;

  case 1550:

/* Line 1455 of yacc.c  */
#line 10157 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1551:

/* Line 1455 of yacc.c  */
#line 10158 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1552:

/* Line 1455 of yacc.c  */
#line 10159 "gram.y"
    { (yyval.list) = lappend((yyvsp[(2) - (5)].list), (yyvsp[(4) - (5)].node)); ;}
    break;

  case 1553:

/* Line 1455 of yacc.c  */
#line 10162 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1554:

/* Line 1455 of yacc.c  */
#line 10163 "gram.y"
    { (yyval.ival) = ANY_SUBLINK; ;}
    break;

  case 1555:

/* Line 1455 of yacc.c  */
#line 10164 "gram.y"
    { (yyval.ival) = ALL_SUBLINK; ;}
    break;

  case 1556:

/* Line 1455 of yacc.c  */
#line 10167 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1557:

/* Line 1455 of yacc.c  */
#line 10168 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1558:

/* Line 1455 of yacc.c  */
#line 10171 "gram.y"
    { (yyval.str) = "+"; ;}
    break;

  case 1559:

/* Line 1455 of yacc.c  */
#line 10172 "gram.y"
    { (yyval.str) = "-"; ;}
    break;

  case 1560:

/* Line 1455 of yacc.c  */
#line 10173 "gram.y"
    { (yyval.str) = "*"; ;}
    break;

  case 1561:

/* Line 1455 of yacc.c  */
#line 10174 "gram.y"
    { (yyval.str) = "/"; ;}
    break;

  case 1562:

/* Line 1455 of yacc.c  */
#line 10175 "gram.y"
    { (yyval.str) = "%"; ;}
    break;

  case 1563:

/* Line 1455 of yacc.c  */
#line 10176 "gram.y"
    { (yyval.str) = "^"; ;}
    break;

  case 1564:

/* Line 1455 of yacc.c  */
#line 10177 "gram.y"
    { (yyval.str) = "<"; ;}
    break;

  case 1565:

/* Line 1455 of yacc.c  */
#line 10178 "gram.y"
    { (yyval.str) = ">"; ;}
    break;

  case 1566:

/* Line 1455 of yacc.c  */
#line 10179 "gram.y"
    { (yyval.str) = "="; ;}
    break;

  case 1567:

/* Line 1455 of yacc.c  */
#line 10183 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1568:

/* Line 1455 of yacc.c  */
#line 10185 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1569:

/* Line 1455 of yacc.c  */
#line 10190 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1570:

/* Line 1455 of yacc.c  */
#line 10192 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1571:

/* Line 1455 of yacc.c  */
#line 10197 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1572:

/* Line 1455 of yacc.c  */
#line 10199 "gram.y"
    { (yyval.list) = (yyvsp[(3) - (4)].list); ;}
    break;

  case 1573:

/* Line 1455 of yacc.c  */
#line 10201 "gram.y"
    { (yyval.list) = list_make1(makeString("~~")); ;}
    break;

  case 1574:

/* Line 1455 of yacc.c  */
#line 10203 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~")); ;}
    break;

  case 1575:

/* Line 1455 of yacc.c  */
#line 10205 "gram.y"
    { (yyval.list) = list_make1(makeString("~~*")); ;}
    break;

  case 1576:

/* Line 1455 of yacc.c  */
#line 10207 "gram.y"
    { (yyval.list) = list_make1(makeString("!~~*")); ;}
    break;

  case 1577:

/* Line 1455 of yacc.c  */
#line 10219 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1578:

/* Line 1455 of yacc.c  */
#line 10223 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1579:

/* Line 1455 of yacc.c  */
#line 10230 "gram.y"
    {
					(yyval.list) = list_make1((yyvsp[(1) - (1)].node));
				;}
    break;

  case 1580:

/* Line 1455 of yacc.c  */
#line 10234 "gram.y"
    {
					(yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1581:

/* Line 1455 of yacc.c  */
#line 10240 "gram.y"
    {
					(yyval.node) = (yyvsp[(1) - (1)].node);
				;}
    break;

  case 1582:

/* Line 1455 of yacc.c  */
#line 10244 "gram.y"
    {
					NamedArgExpr *na = makeNode(NamedArgExpr);
					na->name = (yyvsp[(1) - (3)].str);
					na->arg = (Expr *) (yyvsp[(3) - (3)].node);
					na->argnumber = -1;		/* until determined */
					na->location = (yylsp[(1) - (3)]);
					(yyval.node) = (Node *) na;
				;}
    break;

  case 1583:

/* Line 1455 of yacc.c  */
#line 10254 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].typnam)); ;}
    break;

  case 1584:

/* Line 1455 of yacc.c  */
#line 10255 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].typnam)); ;}
    break;

  case 1585:

/* Line 1455 of yacc.c  */
#line 10259 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1586:

/* Line 1455 of yacc.c  */
#line 10263 "gram.y"
    {
					(yyval.node) = makeAArrayExpr((yyvsp[(2) - (3)].list), (yylsp[(1) - (3)]));
				;}
    break;

  case 1587:

/* Line 1455 of yacc.c  */
#line 10267 "gram.y"
    {
					(yyval.node) = makeAArrayExpr(NIL, (yylsp[(1) - (2)]));
				;}
    break;

  case 1588:

/* Line 1455 of yacc.c  */
#line 10272 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1589:

/* Line 1455 of yacc.c  */
#line 10273 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1590:

/* Line 1455 of yacc.c  */
#line 10279 "gram.y"
    {
					(yyval.list) = list_make2(makeStringConst((yyvsp[(1) - (3)].str), (yylsp[(1) - (3)])), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1591:

/* Line 1455 of yacc.c  */
#line 10282 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1592:

/* Line 1455 of yacc.c  */
#line 10289 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1593:

/* Line 1455 of yacc.c  */
#line 10290 "gram.y"
    { (yyval.str) = "year"; ;}
    break;

  case 1594:

/* Line 1455 of yacc.c  */
#line 10291 "gram.y"
    { (yyval.str) = "month"; ;}
    break;

  case 1595:

/* Line 1455 of yacc.c  */
#line 10292 "gram.y"
    { (yyval.str) = "day"; ;}
    break;

  case 1596:

/* Line 1455 of yacc.c  */
#line 10293 "gram.y"
    { (yyval.str) = "hour"; ;}
    break;

  case 1597:

/* Line 1455 of yacc.c  */
#line 10294 "gram.y"
    { (yyval.str) = "minute"; ;}
    break;

  case 1598:

/* Line 1455 of yacc.c  */
#line 10295 "gram.y"
    { (yyval.str) = "second"; ;}
    break;

  case 1599:

/* Line 1455 of yacc.c  */
#line 10296 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1600:

/* Line 1455 of yacc.c  */
#line 10307 "gram.y"
    {
					(yyval.list) = list_make4((yyvsp[(1) - (4)].node), (yyvsp[(2) - (4)].node), (yyvsp[(3) - (4)].node), (yyvsp[(4) - (4)].node));
				;}
    break;

  case 1601:

/* Line 1455 of yacc.c  */
#line 10311 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1602:

/* Line 1455 of yacc.c  */
#line 10318 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1603:

/* Line 1455 of yacc.c  */
#line 10324 "gram.y"
    { (yyval.list) = list_make2((yyvsp[(3) - (3)].node), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1604:

/* Line 1455 of yacc.c  */
#line 10325 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1605:

/* Line 1455 of yacc.c  */
#line 10342 "gram.y"
    {
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(2) - (3)].node), (yyvsp[(3) - (3)].node));
				;}
    break;

  case 1606:

/* Line 1455 of yacc.c  */
#line 10346 "gram.y"
    {
					/* not legal per SQL99, but might as well allow it */
					(yyval.list) = list_make3((yyvsp[(1) - (3)].node), (yyvsp[(3) - (3)].node), (yyvsp[(2) - (3)].node));
				;}
    break;

  case 1607:

/* Line 1455 of yacc.c  */
#line 10351 "gram.y"
    {
					(yyval.list) = list_make2((yyvsp[(1) - (2)].node), (yyvsp[(2) - (2)].node));
				;}
    break;

  case 1608:

/* Line 1455 of yacc.c  */
#line 10355 "gram.y"
    {
					/*
					 * Since there are no cases where this syntax allows
					 * a textual FOR value, we forcibly cast the argument
					 * to int4.  The possible matches in pg_proc are
					 * substring(text,int4) and substring(text,text),
					 * and we don't want the parser to choose the latter,
					 * which it is likely to do if the second argument
					 * is unknown or doesn't have an implicit cast to int4.
					 */
					(yyval.list) = list_make3((yyvsp[(1) - (2)].node), makeIntConst(1, -1),
									makeTypeCast((yyvsp[(2) - (2)].node),
												 SystemTypeName("int4"), -1));
				;}
    break;

  case 1609:

/* Line 1455 of yacc.c  */
#line 10370 "gram.y"
    {
					(yyval.list) = (yyvsp[(1) - (1)].list);
				;}
    break;

  case 1610:

/* Line 1455 of yacc.c  */
#line 10374 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1611:

/* Line 1455 of yacc.c  */
#line 10378 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1612:

/* Line 1455 of yacc.c  */
#line 10381 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1613:

/* Line 1455 of yacc.c  */
#line 10384 "gram.y"
    { (yyval.list) = lappend((yyvsp[(3) - (3)].list), (yyvsp[(1) - (3)].node)); ;}
    break;

  case 1614:

/* Line 1455 of yacc.c  */
#line 10385 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (2)].list); ;}
    break;

  case 1615:

/* Line 1455 of yacc.c  */
#line 10386 "gram.y"
    { (yyval.list) = (yyvsp[(1) - (1)].list); ;}
    break;

  case 1616:

/* Line 1455 of yacc.c  */
#line 10390 "gram.y"
    {
					SubLink *n = makeNode(SubLink);
					n->subselect = (yyvsp[(1) - (1)].node);
					/* other fields will be filled later */
					(yyval.node) = (Node *)n;
				;}
    break;

  case 1617:

/* Line 1455 of yacc.c  */
#line 10396 "gram.y"
    { (yyval.node) = (Node *)(yyvsp[(2) - (3)].list); ;}
    break;

  case 1618:

/* Line 1455 of yacc.c  */
#line 10407 "gram.y"
    {
					CaseExpr *c = makeNode(CaseExpr);
					c->casetype = InvalidOid; /* not analyzed yet */
					c->arg = (Expr *) (yyvsp[(2) - (5)].node);
					c->args = (yyvsp[(3) - (5)].list);
					c->defresult = (Expr *) (yyvsp[(4) - (5)].node);
					c->location = (yylsp[(1) - (5)]);
					(yyval.node) = (Node *)c;
				;}
    break;

  case 1619:

/* Line 1455 of yacc.c  */
#line 10420 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1620:

/* Line 1455 of yacc.c  */
#line 10421 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1621:

/* Line 1455 of yacc.c  */
#line 10426 "gram.y"
    {
					CaseWhen *w = makeNode(CaseWhen);
					w->expr = (Expr *) (yyvsp[(2) - (4)].node);
					w->result = (Expr *) (yyvsp[(4) - (4)].node);
					w->location = (yylsp[(1) - (4)]);
					(yyval.node) = (Node *)w;
				;}
    break;

  case 1622:

/* Line 1455 of yacc.c  */
#line 10436 "gram.y"
    { (yyval.node) = (yyvsp[(2) - (2)].node); ;}
    break;

  case 1623:

/* Line 1455 of yacc.c  */
#line 10437 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1624:

/* Line 1455 of yacc.c  */
#line 10440 "gram.y"
    { (yyval.node) = (yyvsp[(1) - (1)].node); ;}
    break;

  case 1625:

/* Line 1455 of yacc.c  */
#line 10441 "gram.y"
    { (yyval.node) = NULL; ;}
    break;

  case 1626:

/* Line 1455 of yacc.c  */
#line 10445 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (1)].str), NIL, (yylsp[(1) - (1)]), yyscanner);
				;}
    break;

  case 1627:

/* Line 1455 of yacc.c  */
#line 10449 "gram.y"
    {
					(yyval.node) = makeColumnRef((yyvsp[(1) - (2)].str), (yyvsp[(2) - (2)].list), (yylsp[(1) - (2)]), yyscanner);
				;}
    break;

  case 1628:

/* Line 1455 of yacc.c  */
#line 10456 "gram.y"
    {
					(yyval.node) = (Node *) makeString((yyvsp[(2) - (2)].str));
				;}
    break;

  case 1629:

/* Line 1455 of yacc.c  */
#line 10460 "gram.y"
    {
					(yyval.node) = (Node *) makeNode(A_Star);
				;}
    break;

  case 1630:

/* Line 1455 of yacc.c  */
#line 10464 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = NULL;
					ai->uidx = (yyvsp[(2) - (3)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1631:

/* Line 1455 of yacc.c  */
#line 10471 "gram.y"
    {
					A_Indices *ai = makeNode(A_Indices);
					ai->lidx = (yyvsp[(2) - (5)].node);
					ai->uidx = (yyvsp[(4) - (5)].node);
					(yyval.node) = (Node *) ai;
				;}
    break;

  case 1632:

/* Line 1455 of yacc.c  */
#line 10480 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1633:

/* Line 1455 of yacc.c  */
#line 10481 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1634:

/* Line 1455 of yacc.c  */
#line 10485 "gram.y"
    { (yyval.list) = NIL; ;}
    break;

  case 1635:

/* Line 1455 of yacc.c  */
#line 10486 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (2)].list), (yyvsp[(2) - (2)].node)); ;}
    break;

  case 1638:

/* Line 1455 of yacc.c  */
#line 10501 "gram.y"
    { (yyval.node) = (Node *) (yyvsp[(1) - (1)].node); ;}
    break;

  case 1639:

/* Line 1455 of yacc.c  */
#line 10503 "gram.y"
    {
					SetToDefault *n = makeNode(SetToDefault);
					n->location = (yylsp[(1) - (1)]);
					(yyval.node) = (Node *) n;
				;}
    break;

  case 1640:

/* Line 1455 of yacc.c  */
#line 10511 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].node)); ;}
    break;

  case 1641:

/* Line 1455 of yacc.c  */
#line 10512 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].node)); ;}
    break;

  case 1642:

/* Line 1455 of yacc.c  */
#line 10520 "gram.y"
    { (yyval.list) = (yyvsp[(2) - (3)].list); ;}
    break;

  case 1643:

/* Line 1455 of yacc.c  */
#line 10531 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].target)); ;}
    break;

  case 1644:

/* Line 1455 of yacc.c  */
#line 10532 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].target)); ;}
    break;

  case 1645:

/* Line 1455 of yacc.c  */
#line 10536 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(3) - (3)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (3)].node);
					(yyval.target)->location = (yylsp[(1) - (3)]);
				;}
    break;

  case 1646:

/* Line 1455 of yacc.c  */
#line 10552 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = (yyvsp[(2) - (2)].str);
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (2)].node);
					(yyval.target)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1647:

/* Line 1455 of yacc.c  */
#line 10560 "gram.y"
    {
					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)(yyvsp[(1) - (1)].node);
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1648:

/* Line 1455 of yacc.c  */
#line 10568 "gram.y"
    {
					ColumnRef *n = makeNode(ColumnRef);
					n->fields = list_make1(makeNode(A_Star));
					n->location = (yylsp[(1) - (1)]);

					(yyval.target) = makeNode(ResTarget);
					(yyval.target)->name = NULL;
					(yyval.target)->indirection = NIL;
					(yyval.target)->val = (Node *)n;
					(yyval.target)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1649:

/* Line 1455 of yacc.c  */
#line 10589 "gram.y"
    { (yyval.list) = list_make1((yyvsp[(1) - (1)].range)); ;}
    break;

  case 1650:

/* Line 1455 of yacc.c  */
#line 10590 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), (yyvsp[(3) - (3)].range)); ;}
    break;

  case 1651:

/* Line 1455 of yacc.c  */
#line 10602 "gram.y"
    {
					(yyval.range) = makeNode(RangeVar);
					(yyval.range)->catalogname = NULL;
					(yyval.range)->schemaname = NULL;
					(yyval.range)->relname = (yyvsp[(1) - (1)].str);
					(yyval.range)->location = (yylsp[(1) - (1)]);
				;}
    break;

  case 1652:

/* Line 1455 of yacc.c  */
#line 10610 "gram.y"
    {
					check_qualified_name((yyvsp[(2) - (2)].list), yyscanner);
					(yyval.range) = makeNode(RangeVar);
					switch (list_length((yyvsp[(2) - (2)].list)))
					{
						case 1:
							(yyval.range)->catalogname = NULL;
							(yyval.range)->schemaname = (yyvsp[(1) - (2)].str);
							(yyval.range)->relname = strVal(linitial((yyvsp[(2) - (2)].list)));
							break;
						case 2:
							(yyval.range)->catalogname = (yyvsp[(1) - (2)].str);
							(yyval.range)->schemaname = strVal(linitial((yyvsp[(2) - (2)].list)));
							(yyval.range)->relname = strVal(lsecond((yyvsp[(2) - (2)].list)));
							break;
						default:
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("improper qualified name (too many dotted names): %s",
											NameListToString(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)))),
									 parser_errposition((yylsp[(1) - (2)]))));
							break;
					}
					(yyval.range)->location = (yylsp[(1) - (2)]);
				;}
    break;

  case 1653:

/* Line 1455 of yacc.c  */
#line 10638 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1654:

/* Line 1455 of yacc.c  */
#line 10640 "gram.y"
    { (yyval.list) = lappend((yyvsp[(1) - (3)].list), makeString((yyvsp[(3) - (3)].str))); ;}
    break;

  case 1655:

/* Line 1455 of yacc.c  */
#line 10644 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1656:

/* Line 1455 of yacc.c  */
#line 10647 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1657:

/* Line 1455 of yacc.c  */
#line 10650 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1658:

/* Line 1455 of yacc.c  */
#line 10652 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1659:

/* Line 1455 of yacc.c  */
#line 10654 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1660:

/* Line 1455 of yacc.c  */
#line 10656 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1661:

/* Line 1455 of yacc.c  */
#line 10667 "gram.y"
    { (yyval.list) = list_make1(makeString((yyvsp[(1) - (1)].str))); ;}
    break;

  case 1662:

/* Line 1455 of yacc.c  */
#line 10669 "gram.y"
    {
						(yyval.list) = check_func_name(lcons(makeString((yyvsp[(1) - (2)].str)), (yyvsp[(2) - (2)].list)),
											 yyscanner);
					;}
    break;

  case 1663:

/* Line 1455 of yacc.c  */
#line 10680 "gram.y"
    {
					(yyval.node) = makeIntConst((yyvsp[(1) - (1)].ival), (yylsp[(1) - (1)]));
				;}
    break;

  case 1664:

/* Line 1455 of yacc.c  */
#line 10684 "gram.y"
    {
					(yyval.node) = makeFloatConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1665:

/* Line 1455 of yacc.c  */
#line 10688 "gram.y"
    {
					(yyval.node) = makeStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1666:

/* Line 1455 of yacc.c  */
#line 10692 "gram.y"
    {
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1667:

/* Line 1455 of yacc.c  */
#line 10696 "gram.y"
    {
					/* This is a bit constant per SQL99:
					 * Without Feature F511, "BIT data type",
					 * a <general literal> shall not be a
					 * <bit string literal> or a <hex string literal>.
					 */
					(yyval.node) = makeBitStringConst((yyvsp[(1) - (1)].str), (yylsp[(1) - (1)]));
				;}
    break;

  case 1668:

/* Line 1455 of yacc.c  */
#line 10705 "gram.y"
    {
					/* generic type 'literal' syntax */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (2)].list));
					t->location = (yylsp[(1) - (2)]);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), t);
				;}
    break;

  case 1669:

/* Line 1455 of yacc.c  */
#line 10712 "gram.y"
    {
					/* generic syntax with a type modifier */
					TypeName *t = makeTypeNameFromNameList((yyvsp[(1) - (5)].list));
					ListCell *lc;

					/*
					 * We must use func_arg_list in the production to avoid
					 * reduce/reduce conflicts, but we don't actually wish
					 * to allow NamedArgExpr in this context.
					 */
					foreach(lc, (yyvsp[(3) - (5)].list))
					{
						NamedArgExpr *arg = (NamedArgExpr *) lfirst(lc);

						if (IsA(arg, NamedArgExpr))
							ereport(ERROR,
								    (errcode(ERRCODE_SYNTAX_ERROR),
								     errmsg("type modifier cannot have parameter name"),
								     parser_errposition(arg->location)));
					}
					t->typmods = (yyvsp[(3) - (5)].list);
					t->location = (yylsp[(1) - (5)]);
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (5)].str), (yylsp[(5) - (5)]), t);
				;}
    break;

  case 1670:

/* Line 1455 of yacc.c  */
#line 10737 "gram.y"
    {
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (2)].str), (yylsp[(2) - (2)]), (yyvsp[(1) - (2)].typnam));
				;}
    break;

  case 1671:

/* Line 1455 of yacc.c  */
#line 10741 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (3)].typnam);
					t->typmods = (yyvsp[(3) - (3)].list);
					(yyval.node) = makeStringConstCast((yyvsp[(2) - (3)].str), (yylsp[(2) - (3)]), t);
				;}
    break;

  case 1672:

/* Line 1455 of yacc.c  */
#line 10747 "gram.y"
    {
					TypeName *t = (yyvsp[(1) - (6)].typnam);
					if ((yyvsp[(6) - (6)].list) != NIL)
					{
						if (list_length((yyvsp[(6) - (6)].list)) != 1)
							ereport(ERROR,
									(errcode(ERRCODE_SYNTAX_ERROR),
									 errmsg("interval precision specified twice"),
									 parser_errposition((yylsp[(1) - (6)]))));
						t->typmods = lappend((yyvsp[(6) - (6)].list), makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					}
					else
						t->typmods = list_make2(makeIntConst(INTERVAL_FULL_RANGE, -1),
												makeIntConst((yyvsp[(3) - (6)].ival), (yylsp[(3) - (6)])));
					(yyval.node) = makeStringConstCast((yyvsp[(5) - (6)].str), (yylsp[(5) - (6)]), t);
				;}
    break;

  case 1673:

/* Line 1455 of yacc.c  */
#line 10764 "gram.y"
    {
					(yyval.node) = makeBoolAConst(TRUE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1674:

/* Line 1455 of yacc.c  */
#line 10768 "gram.y"
    {
					(yyval.node) = makeBoolAConst(FALSE, (yylsp[(1) - (1)]));
				;}
    break;

  case 1675:

/* Line 1455 of yacc.c  */
#line 10772 "gram.y"
    {
					(yyval.node) = makeNullAConst((yylsp[(1) - (1)]));
				;}
    break;

  case 1676:

/* Line 1455 of yacc.c  */
#line 10777 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1677:

/* Line 1455 of yacc.c  */
#line 10778 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1678:

/* Line 1455 of yacc.c  */
#line 10779 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1679:

/* Line 1455 of yacc.c  */
#line 10781 "gram.y"
    { (yyval.ival) = (yyvsp[(1) - (1)].ival); ;}
    break;

  case 1680:

/* Line 1455 of yacc.c  */
#line 10782 "gram.y"
    { (yyval.ival) = + (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1681:

/* Line 1455 of yacc.c  */
#line 10783 "gram.y"
    { (yyval.ival) = - (yyvsp[(2) - (2)].ival); ;}
    break;

  case 1682:

/* Line 1455 of yacc.c  */
#line 10799 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1683:

/* Line 1455 of yacc.c  */
#line 10800 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1684:

/* Line 1455 of yacc.c  */
#line 10801 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1685:

/* Line 1455 of yacc.c  */
#line 10806 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1686:

/* Line 1455 of yacc.c  */
#line 10807 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1687:

/* Line 1455 of yacc.c  */
#line 10808 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1688:

/* Line 1455 of yacc.c  */
#line 10814 "gram.y"
    { (yyval.str) = (yyvsp[(1) - (1)].str); ;}
    break;

  case 1689:

/* Line 1455 of yacc.c  */
#line 10815 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1690:

/* Line 1455 of yacc.c  */
#line 10816 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1691:

/* Line 1455 of yacc.c  */
#line 10817 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;

  case 1692:

/* Line 1455 of yacc.c  */
#line 10818 "gram.y"
    { (yyval.str) = pstrdup((yyvsp[(1) - (1)].keyword)); ;}
    break;



/* Line 1455 of yacc.c  */
#line 33587 "gram.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, yyscanner, YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (&yylloc, yyscanner, yymsg);
	  }
	else
	  {
	    yyerror (&yylloc, yyscanner, YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc, yyscanner);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc, yyscanner);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 11270 "gram.y"


/*
 * The signature of this function is required by bison.  However, we
 * ignore the passed yylloc and instead use the last token position
 * available from the scanner.
 */
static void
base_yyerror(YYLTYPE *yylloc, core_yyscan_t yyscanner, const char *msg)
{
	parser_yyerror(msg);
}

static Node *
makeColumnRef(char *colname, List *indirection,
			  int location, core_yyscan_t yyscanner)
{
	/*
	 * Generate a ColumnRef node, with an A_Indirection node added if there
	 * is any subscripting in the specified indirection list.  However,
	 * any field selection at the start of the indirection list must be
	 * transposed into the "fields" part of the ColumnRef node.
	 */
	ColumnRef  *c = makeNode(ColumnRef);
	int		nfields = 0;
	ListCell *l;

	c->location = location;
	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Indices))
		{
			A_Indirection *i = makeNode(A_Indirection);

			if (nfields == 0)
			{
				/* easy case - all indirection goes to A_Indirection */
				c->fields = list_make1(makeString(colname));
				i->indirection = check_indirection(indirection, yyscanner);
			}
			else
			{
				/* got to split the list in two */
				i->indirection = check_indirection(list_copy_tail(indirection,
																  nfields),
												   yyscanner);
				indirection = list_truncate(indirection, nfields);
				c->fields = lcons(makeString(colname), indirection);
			}
			i->arg = (Node *) c;
			return (Node *) i;
		}
		else if (IsA(lfirst(l), A_Star))
		{
			/* We only allow '*' at the end of a ColumnRef */
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
		nfields++;
	}
	/* No subscripting, so all indirection gets added to field list */
	c->fields = lcons(makeString(colname), indirection);
	return (Node *) c;
}

static Node *
makeTypeCast(Node *arg, TypeName *typename, int location)
{
	TypeCast *n = makeNode(TypeCast);
	n->arg = arg;
	n->typeName = typename;
	n->location = location;
	return (Node *) n;
}

static Node *
makeStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeStringConstCast(char *str, int location, TypeName *typename)
{
	Node *s = makeStringConst(str, location);

	return makeTypeCast(s, typename, -1);
}

static Node *
makeIntConst(int val, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Integer;
	n->val.val.ival = val;
	n->location = location;

	return (Node *)n;
}

static Node *
makeFloatConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Float;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeBitStringConst(char *str, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_BitString;
	n->val.val.str = str;
	n->location = location;

	return (Node *)n;
}

static Node *
makeNullAConst(int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_Null;
	n->location = location;

	return (Node *)n;
}

static Node *
makeAConst(Value *v, int location)
{
	Node *n;

	switch (v->type)
	{
		case T_Float:
			n = makeFloatConst(v->val.str, location);
			break;

		case T_Integer:
			n = makeIntConst(v->val.ival, location);
			break;

		case T_String:
		default:
			n = makeStringConst(v->val.str, location);
			break;
	}

	return n;
}

/* makeBoolAConst()
 * Create an A_Const string node and put it inside a boolean cast.
 */
static Node *
makeBoolAConst(bool state, int location)
{
	A_Const *n = makeNode(A_Const);

	n->val.type = T_String;
	n->val.val.str = (state ? "t" : "f");
	n->location = location;

	return makeTypeCast((Node *)n, SystemTypeName("bool"), -1);
}

/* makeOverlaps()
 * Create and populate a FuncCall node to support the OVERLAPS operator.
 */
static FuncCall *
makeOverlaps(List *largs, List *rargs, int location, core_yyscan_t yyscanner)
{
	FuncCall *n = makeNode(FuncCall);

	n->funcname = SystemFuncName("overlaps");
	if (list_length(largs) == 1)
		largs = lappend(largs, largs);
	else if (list_length(largs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on left side of OVERLAPS expression"),
				 parser_errposition(location)));
	if (list_length(rargs) == 1)
		rargs = lappend(rargs, rargs);
	else if (list_length(rargs) != 2)
		ereport(ERROR,
				(errcode(ERRCODE_SYNTAX_ERROR),
				 errmsg("wrong number of parameters on right side of OVERLAPS expression"),
				 parser_errposition(location)));
	n->args = list_concat(largs, rargs);
	n->agg_order = NIL;
	n->agg_star = FALSE;
	n->agg_distinct = FALSE;
	n->func_variadic = FALSE;
	n->over = NULL;
	n->location = location;
	return n;
}

/* check_qualified_name --- check the result of qualified_name production
 *
 * It's easiest to let the grammar production for qualified_name allow
 * subscripts and '*', which we then must reject here.
 */
static void
check_qualified_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
}

/* check_func_name --- check the result of func_name production
 *
 * It's easiest to let the grammar production for func_name allow subscripts
 * and '*', which we then must reject here.
 */
static List *
check_func_name(List *names, core_yyscan_t yyscanner)
{
	ListCell   *i;

	foreach(i, names)
	{
		if (!IsA(lfirst(i), String))
			parser_yyerror("syntax error");
	}
	return names;
}

/* check_indirection --- check the result of indirection production
 *
 * We only allow '*' at the end of the list, but it's hard to enforce that
 * in the grammar, so do it here.
 */
static List *
check_indirection(List *indirection, core_yyscan_t yyscanner)
{
	ListCell *l;

	foreach(l, indirection)
	{
		if (IsA(lfirst(l), A_Star))
		{
			if (lnext(l) != NULL)
				parser_yyerror("improper use of \"*\"");
		}
	}
	return indirection;
}

/* extractArgTypes()
 * Given a list of FunctionParameter nodes, extract a list of just the
 * argument types (TypeNames) for input parameters only.  This is what
 * is needed to look up an existing function, which is what is wanted by
 * the productions that use this call.
 */
static List *
extractArgTypes(List *parameters)
{
	List	   *result = NIL;
	ListCell   *i;

	foreach(i, parameters)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(i);

		if (p->mode != FUNC_PARAM_OUT && p->mode != FUNC_PARAM_TABLE)
			result = lappend(result, p->argType);
	}
	return result;
}

/* findLeftmostSelect()
 * Find the leftmost component SelectStmt in a set-operation parsetree.
 */
static SelectStmt *
findLeftmostSelect(SelectStmt *node)
{
	while (node && node->op != SETOP_NONE)
		node = node->larg;
	Assert(node && IsA(node, SelectStmt) && node->larg == NULL);
	return node;
}

/* insertSelectOptions()
 * Insert ORDER BY, etc into an already-constructed SelectStmt.
 *
 * This routine is just to avoid duplicating code in SelectStmt productions.
 */
static void
insertSelectOptions(SelectStmt *stmt,
					List *sortClause, List *lockingClause,
					Node *limitOffset, Node *limitCount,
					WithClause *withClause,
					core_yyscan_t yyscanner)
{
	Assert(IsA(stmt, SelectStmt));

	/*
	 * Tests here are to reject constructs like
	 *	(SELECT foo ORDER BY bar) ORDER BY baz
	 */
	if (sortClause)
	{
		if (stmt->sortClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple ORDER BY clauses not allowed"),
					 parser_errposition(exprLocation((Node *) sortClause))));
		stmt->sortClause = sortClause;
	}
	/* We can handle multiple locking clauses, though */
	stmt->lockingClause = list_concat(stmt->lockingClause, lockingClause);
	if (limitOffset)
	{
		if (stmt->limitOffset)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple OFFSET clauses not allowed"),
					 parser_errposition(exprLocation(limitOffset))));
		stmt->limitOffset = limitOffset;
	}
	if (limitCount)
	{
		if (stmt->limitCount)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple LIMIT clauses not allowed"),
					 parser_errposition(exprLocation(limitCount))));
		stmt->limitCount = limitCount;
	}
	if (withClause)
	{
		if (stmt->withClause)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("multiple WITH clauses not allowed"),
					 parser_errposition(exprLocation((Node *) withClause))));
		stmt->withClause = withClause;
	}
}

static Node *
makeSetOp(SetOperation op, bool all, Node *larg, Node *rarg)
{
	SelectStmt *n = makeNode(SelectStmt);

	n->op = op;
	n->all = all;
	n->larg = (SelectStmt *) larg;
	n->rarg = (SelectStmt *) rarg;
	return (Node *) n;
}

/* SystemFuncName()
 * Build a properly-qualified reference to a built-in function.
 */
List *
SystemFuncName(char *name)
{
	return list_make2(makeString("pg_catalog"), makeString(name));
}

/* SystemTypeName()
 * Build a properly-qualified reference to a built-in type.
 *
 * typmod is defaulted, but may be changed afterwards by caller.
 * Likewise for the location.
 */
TypeName *
SystemTypeName(char *name)
{
	return makeTypeNameFromNameList(list_make2(makeString("pg_catalog"),
											   makeString(name)));
}

/* doNegate()
 * Handle negation of a numeric constant.
 *
 * Formerly, we did this here because the optimizer couldn't cope with
 * indexquals that looked like "var = -4" --- it wants "var = const"
 * and a unary minus operator applied to a constant didn't qualify.
 * As of Postgres 7.0, that problem doesn't exist anymore because there
 * is a constant-subexpression simplifier in the optimizer.  However,
 * there's still a good reason for doing this here, which is that we can
 * postpone committing to a particular internal representation for simple
 * negative constants.	It's better to leave "-123.456" in string form
 * until we know what the desired type is.
 */
static Node *
doNegate(Node *n, int location)
{
	if (IsA(n, A_Const))
	{
		A_Const *con = (A_Const *)n;

		/* report the constant's location as that of the '-' sign */
		con->location = location;

		if (con->val.type == T_Integer)
		{
			con->val.val.ival = -con->val.val.ival;
			return n;
		}
		if (con->val.type == T_Float)
		{
			doNegateFloat(&con->val);
			return n;
		}
	}

	return (Node *) makeSimpleA_Expr(AEXPR_OP, "-", NULL, n, location);
}

static void
doNegateFloat(Value *v)
{
	char   *oldval = v->val.str;

	Assert(IsA(v, Float));
	if (*oldval == '+')
		oldval++;
	if (*oldval == '-')
		v->val.str = oldval+1;	/* just strip the '-' */
	else
	{
		char   *newval = (char *) palloc(strlen(oldval) + 2);

		*newval = '-';
		strcpy(newval+1, oldval);
		v->val.str = newval;
	}
}

static Node *
makeAArrayExpr(List *elements, int location)
{
	A_ArrayExpr *n = makeNode(A_ArrayExpr);

	n->elements = elements;
	n->location = location;
	return (Node *) n;
}

static Node *
makeXmlExpr(XmlExprOp op, char *name, List *named_args, List *args,
			int location)
{
	XmlExpr    *x = makeNode(XmlExpr);

	x->op = op;
	x->name = name;
	/*
	 * named_args is a list of ResTarget; it'll be split apart into separate
	 * expression and name lists in transformXmlExpr().
	 */
	x->named_args = named_args;
	x->arg_names = NIL;
	x->args = args;
	/* xmloption, if relevant, must be filled in by caller */
	/* type and typmod will be filled in during parse analysis */
	x->type = InvalidOid;			/* marks the node as not analyzed */
	x->location = location;
	return (Node *) x;
}

/* parser_init()
 * Initialize to parse one query string
 */
void
parser_init(base_yy_extra_type *yyext)
{
	yyext->parsetree = NIL;		/* in case grammar forgets to set it */
}

/*
 * Merge the input and output parameters of a table function.
 */
static List *
mergeTableFuncParameters(List *func_args, List *columns)
{
	ListCell   *lc;

	/* Explicit OUT and INOUT parameters shouldn't be used in this syntax */
	foreach(lc, func_args)
	{
		FunctionParameter *p = (FunctionParameter *) lfirst(lc);

		if (p->mode != FUNC_PARAM_IN && p->mode != FUNC_PARAM_VARIADIC)
			ereport(ERROR,
					(errcode(ERRCODE_SYNTAX_ERROR),
					 errmsg("OUT and INOUT arguments aren't allowed in TABLE functions")));
	}

	return list_concat(func_args, columns);
}

/*
 * Determine return type of a TABLE function.  A single result column
 * returns setof that column's type; otherwise return setof record.
 */
static TypeName *
TableFuncTypeName(List *columns)
{
	TypeName *result;

	if (list_length(columns) == 1)
	{
		FunctionParameter *p = (FunctionParameter *) linitial(columns);

		result = (TypeName *) copyObject(p->argType);
	}
	else
		result = SystemTypeName("record");

	result->setof = true;

	return result;
}

/*
 * Must undefine this stuff before including scan.c, since it has different
 * definitions for these macros.
 */
#undef yyerror
#undef yylval
#undef yylloc

#include "scan.c"

